﻿/* Copyright (C) Microsoft Corporation. All rights reserved. */
(function() {
    "use strict";
    WinJS.Namespace.define("MS.Entertainment.Instrumentation", {PerfTrack: WinJS.Class.define(null, {}, {
            triggerLog: [], StartPoints: {
                    AppLaunch: "AppLaunch", PlayCommand: "PlayCommand", CollectionGalleryRequest: "CollectionGalleryRequest", SearchGalleryRequest: "SearchGalleryRequest", PopoverRequest: "PopoverRequest", MarketplaceGalleryRequest: "MarketplaceGalleryRequest", WebBlendRequest: "WebBlendRequest", ExplorePageRequest: "ExplorePageRequest", RadioPageRequest: "RadioPageRequest", TVDetailsRequest: "TVDetailsRequest", MovieDetailsRequest: "MovieDetailsRequest", AlbumDetailsRequest: "AlbumDetailsRequest", ArtistDetailsRequest: "ArtistDetailsRequest", PlaylistDetailsRequest: "PlaylistDetailsRequest", DevicesPageRequest: "DevicesPageRequest", NowPlayingPageRequest: "NowPlayingPageRequest", MoviesStorePageRequest: "MoviesStorePageRequest", TvStorePageRequest: "TvStorePageRequest", VideoCollectionPageRequest: "VideoCollectionPageRequest"
                }, logTrigger: function logTrigger(scenarioName) {
                    var text = scenarioName;
                    for (var i = 1; i < arguments.length; i++)
                        text += "\t" + arguments[i];
                    MS.Entertainment.Instrumentation.PerfTrack.triggerLog.push(text)
                }, getLogger: (function _perfTrack_getLoggerClosure() {
                    var logger = null;
                    return function _perfTrack_getLoggerWorker() {
                            if (!logger)
                                logger = new Microsoft.PerfTrack.PerfTrackLogger(Microsoft.PerfTrack.PerfTrackLogger.windowsDataUploadEnabled);
                            return logger
                        }
                })(), _truncateString: function _perfTrack_truncateString(s) {
                    var result = s;
                    if (result && typeof(result) === "string" && result.length > 120)
                        result = result.substr(0, 120) + "[...]";
                    return result
                }, _getState: (function _perfTrack_getStateClosure() {
                    var startedScenarios = {};
                    var fireOnceScenarios = {};
                    var disabledScenarios = {};
                    var disabledScenariosByDefault = {};
                    var startTimes = {};
                    var applicationStartTime = null;
                    disabledScenariosByDefault[1318] = true;
                    disabledScenariosByDefault[1319] = true;
                    disabledScenariosByDefault[1320] = true;
                    disabledScenariosByDefault[1321] = true;
                    disabledScenariosByDefault[1322] = true;
                    disabledScenariosByDefault[1582] = true;
                    disabledScenariosByDefault[1583] = true;
                    var actions = {
                            isStarted: function _perfTrack_getState_isStarted(scenarioId, matchKey) {
                                var result = true;
                                var result = startedScenarios.hasOwnProperty(scenarioId);
                                if (result && (matchKey !== undefined))
                                    result = startedScenarios[scenarioId].hasOwnProperty(matchKey);
                                return result
                            }, onBegin: function _perfTrack_getState_onBegin(scenarioId, matchKey) {
                                    if (!startedScenarios[scenarioId])
                                        startedScenarios[scenarioId] = {};
                                    if (matchKey !== undefined)
                                        startedScenarios[scenarioId][matchKey] = true
                                }, onEnd: function _perfTrack_getState_onEnd(scenarioId, matchKey) {
                                    if (matchKey !== undefined) {
                                        if (startedScenarios[scenarioId])
                                            delete startedScenarios[scenarioId][matchKey]
                                    }
                                    else
                                        delete startedScenarios[scenarioId]
                                }, isFiredOnce: function _perfTrack_getState_isFiredOnce(scenarioId, matchKey) {
                                    var result = true;
                                    var result = fireOnceScenarios.hasOwnProperty(scenarioId);
                                    if (result && (matchKey !== undefined))
                                        result = fireOnceScenarios[scenarioId].hasOwnProperty(matchKey);
                                    return result
                                }, onFiredOnce: function _perfTrack_getState_onFiredOnce(scenarioId, matchKey) {
                                    if (matchKey !== undefined) {
                                        if (!fireOnceScenarios[scenarioId])
                                            fireOnceScenarios[scenarioId] = {};
                                        fireOnceScenarios[scenarioId][matchKey] = true
                                    }
                                    else
                                        fireOnceScenarios[scenarioId] = true
                                }, isDisabled: function _perfTrack_getState_isDisabled(scenarioId, matchKey) {
                                    var result = null;
                                    if (matchKey !== undefined) {
                                        if (disabledScenarios[scenarioId])
                                            result = disabledScenarios[scenarioId][matchKey]
                                    }
                                    else
                                        result = disabledScenarios[scenarioId];
                                    if (result === null || result === undefined)
                                        result = (disabledScenariosByDefault[scenarioId] || false);
                                    return result
                                }, disableScenario: function _perfTrack_getState_disableScenario(scenarioId, matchKey) {
                                    if (matchKey !== undefined) {
                                        if (!disabledScenarios[scenarioId])
                                            disabledScenarios[scenarioId] = {};
                                        disabledScenarios[scenarioId][matchKey] = true
                                    }
                                    else
                                        disabledScenarios[scenarioId] = true
                                }, enableScenario: function _perfTrack_getState_enableScenario(scenarioId, matchKey) {
                                    if (matchKey !== undefined) {
                                        if (!disabledScenarios[scenarioId])
                                            disabledScenarios[scenarioId] = {};
                                        disabledScenarios[scenarioId][matchKey] = false
                                    }
                                    else
                                        disabledScenarios[scenarioId] = false
                                }, cleanupDynamicEnabledDisabledFlag: function _perfTrack_getState_cleanupDynamicEnabledDisabledFlag(scenarioId, matchKey) {
                                    if (matchKey !== undefined) {
                                        if (disabledScenarios[scenarioId])
                                            delete disabledScenarios[scenarioId][matchKey]
                                    }
                                    else
                                        delete disabledScenarios[scenarioId]
                                }, setStartTime: function _perfTrack_getState_setStartTime(startPoint, matchKey) {
                                    if (startPoint)
                                        if (matchKey !== undefined) {
                                            if (!startTimes[startPoint])
                                                startTimes[startPoint] = {};
                                            startTimes[startPoint][matchKey] = new Date
                                        }
                                        else
                                            startTimes[startPoint] = new Date
                                }, deleteStartTime: function _perfTrack_getState_deleteStartTime(startPoint, matchKey) {
                                    if (startPoint)
                                        if (matchKey !== undefined) {
                                            if (startTimes[startPoint])
                                                delete startTimes[startPoint][matchKey]
                                        }
                                        else
                                            delete startTimes[startPoint]
                                }, getStartTime: function _perfTrack_getState_getStartTime(startPoint, matchKey) {
                                    var result = null;
                                    if (startPoint) {
                                        if (matchKey !== undefined) {
                                            if (startTimes[startPoint])
                                                result = startTimes[startPoint][matchKey]
                                        }
                                        else
                                            result = startTimes[startPoint];
                                        if (!result)
                                            if (startPoint === "AppLaunch")
                                                if (applicationStartTime)
                                                    result = applicationStartTime;
                                                else if (PerfTrack && PerfTrack.LaunchInformation && PerfTrack.LaunchInformation.getStartTime) {
                                                    applicationStartTime = PerfTrack.LaunchInformation.getStartTime();
                                                    result = applicationStartTime
                                                }
                                    }
                                    return result
                                }, resetStartPoints: function _perfTrack_resetStartPoints() {
                                    startTimes = {}
                                }
                        };
                    return function _perfTrack_getStateWorker() {
                            return actions
                        }
                })(), setStartTime: function _perfTrack_setStartTime(startPoint, matchKey) {
                    var state = MS.Entertainment.Instrumentation.PerfTrack._getState();
                    state.setStartTime(startPoint, matchKey)
                }, getStartTime: function _perfTrack_getStartTime(startPoint, matchKey) {
                    var state = MS.Entertainment.Instrumentation.PerfTrack._getState();
                    return state.getStartTime(startPoint, matchKey)
                }, getShellEventProvider: (function _perfTrack_getShellEventProviderClosure() {
                    var eventProvider = null;
                    return function _perfTrack_getShellEventProviderWorker() {
                            if (!eventProvider)
                                eventProvider = new Microsoft.Entertainment.Instrumentation.Providers.Shell;
                            return eventProvider
                        }
                })(), enableScenarioAppLaunch: function _perfTrack_enableScenarioAppLaunch() {
                    MS.Entertainment.Instrumentation.PerfTrack._getState().enableScenario(1317)
                }, disableScenarioAppLaunch: function _perfTrack_disableScenarioAppLaunch() {
                    MS.Entertainment.Instrumentation.PerfTrack._getState().disableScenario(1317)
                }, triggerScenarioAppLaunch: function _perfTrack_triggerScenarioAppLaunch(DurationMsec) {
                    var PT = MS.Entertainment.Instrumentation.PerfTrack;
                    var state = PT._getState();
                    if (!state.isDisabled(1317) && !state.isFiredOnce(1317)) {
                        var stopTime = new Date;
                        var startTime = state.getStartTime("AppLaunch");
                        if (startTime) {
                            var duration = ((stopTime >= startTime) ? (stopTime - startTime) : 0);
                            var DurationMsec = duration;
                            PT.getShellEventProvider().tracePerfTrack_Trigger_AppLaunchCompleted(DurationMsec);
                            if (PT.getLogger().writeLaunchStopEvent)
                                PT.getLogger().writeLaunchStopEvent(Microsoft.PerfTrack.PerfTrackTimePoint.responsive, MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.uiState).activationKind);
                            PT.getLogger().writeTriggerEvent(1317, "XBLW-AppLaunch", duration);
                            PT.logTrigger("XBLW-AppLaunch", DurationMsec);
                            state.deleteStartTime("AppLaunch")
                        }
                        state.onFiredOnce(1317);
                        PT.disableAllStartupScenarios()
                    }
                }, enableScenarioAppLaunchToCollection: function _perfTrack_enableScenarioAppLaunchToCollection() {
                    MS.Entertainment.Instrumentation.PerfTrack._getState().enableScenario(1318)
                }, disableScenarioAppLaunchToCollection: function _perfTrack_disableScenarioAppLaunchToCollection() {
                    MS.Entertainment.Instrumentation.PerfTrack._getState().disableScenario(1318)
                }, triggerScenarioAppLaunchToCollection: function _perfTrack_triggerScenarioAppLaunchToCollection(DurationMsec) {
                    var PT = MS.Entertainment.Instrumentation.PerfTrack;
                    var state = PT._getState();
                    if (!state.isDisabled(1318) && !state.isFiredOnce(1318)) {
                        var stopTime = new Date;
                        var startTime = state.getStartTime("AppLaunch");
                        if (startTime) {
                            var duration = ((stopTime >= startTime) ? (stopTime - startTime) : 0);
                            var DurationMsec = duration;
                            PT.getShellEventProvider().tracePerfTrack_Trigger_AppLaunchToCollectionCompleted(DurationMsec);
                            if (PT.getLogger().writeLaunchStopEvent)
                                PT.getLogger().writeLaunchStopEvent(Microsoft.PerfTrack.PerfTrackTimePoint.visibleComplete, MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.uiState).activationKind);
                            PT.getLogger().writeTriggerEvent(1318, "XBLW-AppLaunchToCollection", duration);
                            PT.logTrigger("XBLW-AppLaunchToCollection", DurationMsec);
                            state.deleteStartTime("AppLaunch")
                        }
                        state.onFiredOnce(1318);
                        PT.disableAllStartupScenarios()
                    }
                }, enableScenarioAppLaunchPlayNonProtectedContent: function _perfTrack_enableScenarioAppLaunchPlayNonProtectedContent() {
                    MS.Entertainment.Instrumentation.PerfTrack._getState().enableScenario(1319)
                }, disableScenarioAppLaunchPlayNonProtectedContent: function _perfTrack_disableScenarioAppLaunchPlayNonProtectedContent() {
                    MS.Entertainment.Instrumentation.PerfTrack._getState().disableScenario(1319)
                }, triggerScenarioAppLaunchPlayNonProtectedContent: function _perfTrack_triggerScenarioAppLaunchPlayNonProtectedContent(DurationMsec) {
                    var PT = MS.Entertainment.Instrumentation.PerfTrack;
                    var state = PT._getState();
                    if (!state.isDisabled(1319) && !state.isFiredOnce(1319)) {
                        var stopTime = new Date;
                        var startTime = state.getStartTime("AppLaunch");
                        if (startTime) {
                            var duration = ((stopTime >= startTime) ? (stopTime - startTime) : 0);
                            var DurationMsec = duration;
                            PT.getShellEventProvider().tracePerfTrack_Trigger_AppLaunchPlayNonProtectedContent(DurationMsec);
                            if (PT.getLogger().writeLaunchStopEvent)
                                PT.getLogger().writeLaunchStopEvent(Microsoft.PerfTrack.PerfTrackTimePoint.responsive, MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.uiState).activationKind);
                            PT.getLogger().writeTriggerEvent(1319, "XBLW-AppLaunchPlayNonProtectedContent", duration);
                            PT.logTrigger("XBLW-AppLaunchPlayNonProtectedContent", DurationMsec);
                            state.deleteStartTime("AppLaunch")
                        }
                        state.onFiredOnce(1319);
                        PT.disableAllStartupScenarios()
                    }
                }, enableScenarioAppLaunchPlayProtectedContent: function _perfTrack_enableScenarioAppLaunchPlayProtectedContent() {
                    MS.Entertainment.Instrumentation.PerfTrack._getState().enableScenario(1320)
                }, disableScenarioAppLaunchPlayProtectedContent: function _perfTrack_disableScenarioAppLaunchPlayProtectedContent() {
                    MS.Entertainment.Instrumentation.PerfTrack._getState().disableScenario(1320)
                }, triggerScenarioAppLaunchPlayProtectedContent: function _perfTrack_triggerScenarioAppLaunchPlayProtectedContent(DurationMsec) {
                    var PT = MS.Entertainment.Instrumentation.PerfTrack;
                    var state = PT._getState();
                    if (!state.isDisabled(1320) && !state.isFiredOnce(1320)) {
                        var stopTime = new Date;
                        var startTime = state.getStartTime("AppLaunch");
                        if (startTime) {
                            var duration = ((stopTime >= startTime) ? (stopTime - startTime) : 0);
                            var DurationMsec = duration;
                            PT.getShellEventProvider().tracePerfTrack_Trigger_AppLaunchPlayProtectedContent(DurationMsec);
                            if (PT.getLogger().writeLaunchStopEvent)
                                PT.getLogger().writeLaunchStopEvent(Microsoft.PerfTrack.PerfTrackTimePoint.responsive, MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.uiState).activationKind);
                            PT.getLogger().writeTriggerEvent(1320, "XBLW-AppLaunchPlayProtectedContent", duration);
                            PT.logTrigger("XBLW-AppLaunchPlayProtectedContent", DurationMsec);
                            state.deleteStartTime("AppLaunch")
                        }
                        state.onFiredOnce(1320);
                        PT.disableAllStartupScenarios()
                    }
                }, enableScenarioPlayProtectedInApp: function _perfTrack_enableScenarioPlayProtectedInApp() {
                    MS.Entertainment.Instrumentation.PerfTrack._getState().enableScenario(1321)
                }, disableScenarioPlayProtectedInApp: function _perfTrack_disableScenarioPlayProtectedInApp() {
                    MS.Entertainment.Instrumentation.PerfTrack._getState().disableScenario(1321)
                }, triggerScenarioPlayProtectedInApp: function _perfTrack_triggerScenarioPlayProtectedInApp(DurationMsec) {
                    var PT = MS.Entertainment.Instrumentation.PerfTrack;
                    var state = PT._getState();
                    if (!state.isDisabled(1321)) {
                        var stopTime = new Date;
                        var startTime = state.getStartTime("PlayCommand");
                        if (startTime) {
                            if (stopTime >= startTime) {
                                var duration = ((stopTime >= startTime) ? (stopTime - startTime) : 0);
                                var DurationMsec = duration;
                                PT.getShellEventProvider().tracePerfTrack_Trigger_PlayProtectedInAppPlaybackStarted(DurationMsec);
                                PT.getLogger().writeTriggerEvent(1321, "XBLW-PlayProtectedInApp", duration);
                                PT.logTrigger("XBLW-PlayProtectedInApp", DurationMsec)
                            }
                            state.deleteStartTime("PlayCommand")
                        }
                    }
                }, enableScenarioPlayNonProtectedInApp: function _perfTrack_enableScenarioPlayNonProtectedInApp() {
                    MS.Entertainment.Instrumentation.PerfTrack._getState().enableScenario(1322)
                }, disableScenarioPlayNonProtectedInApp: function _perfTrack_disableScenarioPlayNonProtectedInApp() {
                    MS.Entertainment.Instrumentation.PerfTrack._getState().disableScenario(1322)
                }, triggerScenarioPlayNonProtectedInApp: function _perfTrack_triggerScenarioPlayNonProtectedInApp(DurationMsec) {
                    var PT = MS.Entertainment.Instrumentation.PerfTrack;
                    var state = PT._getState();
                    if (!state.isDisabled(1322)) {
                        var stopTime = new Date;
                        var startTime = state.getStartTime("PlayCommand");
                        if (startTime) {
                            if (stopTime >= startTime) {
                                var duration = ((stopTime >= startTime) ? (stopTime - startTime) : 0);
                                var DurationMsec = duration;
                                PT.getShellEventProvider().tracePerfTrack_Trigger_PlayNonProtectedInAppPlaybackStarted(DurationMsec);
                                PT.getLogger().writeTriggerEvent(1322, "XBLW-PlayNonProtectedInApp", duration);
                                PT.logTrigger("XBLW-PlayNonProtectedInApp", DurationMsec)
                            }
                            state.deleteStartTime("PlayCommand")
                        }
                    }
                }, enableScenarioCollectionGalleryRequestToLoad: function _perfTrack_enableScenarioCollectionGalleryRequestToLoad() {
                    MS.Entertainment.Instrumentation.PerfTrack._getState().enableScenario(1325)
                }, disableScenarioCollectionGalleryRequestToLoad: function _perfTrack_disableScenarioCollectionGalleryRequestToLoad() {
                    MS.Entertainment.Instrumentation.PerfTrack._getState().disableScenario(1325)
                }, triggerScenarioCollectionGalleryRequestToLoad: function _perfTrack_triggerScenarioCollectionGalleryRequestToLoad(DurationMsec) {
                    var PT = MS.Entertainment.Instrumentation.PerfTrack;
                    var state = PT._getState();
                    if (!state.isDisabled(1325)) {
                        var stopTime = new Date;
                        var startTime = state.getStartTime("CollectionGalleryRequest");
                        if (startTime) {
                            if (stopTime >= startTime) {
                                var duration = ((stopTime >= startTime) ? (stopTime - startTime) : 0);
                                var DurationMsec = duration;
                                PT.getShellEventProvider().tracePerfTrack_Trigger_CollectionGalleryRequestToLoad(DurationMsec);
                                PT.getLogger().writeTriggerEvent(1325, "XBLW-CollectionGalleryRequestToLoad", duration);
                                PT.logTrigger("XBLW-CollectionGalleryRequestToLoad", DurationMsec)
                            }
                            state.deleteStartTime("CollectionGalleryRequest")
                        }
                    }
                }, enableScenarioSearchGalleryRequestToLoad: function _perfTrack_enableScenarioSearchGalleryRequestToLoad() {
                    MS.Entertainment.Instrumentation.PerfTrack._getState().enableScenario(1326)
                }, disableScenarioSearchGalleryRequestToLoad: function _perfTrack_disableScenarioSearchGalleryRequestToLoad() {
                    MS.Entertainment.Instrumentation.PerfTrack._getState().disableScenario(1326)
                }, triggerScenarioSearchGalleryRequestToLoad: function _perfTrack_triggerScenarioSearchGalleryRequestToLoad(DurationMsec) {
                    var PT = MS.Entertainment.Instrumentation.PerfTrack;
                    var state = PT._getState();
                    if (!state.isDisabled(1326)) {
                        var stopTime = new Date;
                        var startTime = state.getStartTime("SearchGalleryRequest");
                        if (startTime) {
                            if (stopTime >= startTime) {
                                var duration = ((stopTime >= startTime) ? (stopTime - startTime) : 0);
                                var DurationMsec = duration;
                                PT.getShellEventProvider().tracePerfTrack_Trigger_SearchGalleryRequestToLoad(DurationMsec);
                                PT.getLogger().writeTriggerEvent(1326, "XBLW-SearchGalleryRequestToLoad", duration);
                                PT.logTrigger("XBLW-SearchGalleryRequestToLoad", DurationMsec)
                            }
                            state.deleteStartTime("SearchGalleryRequest")
                        }
                    }
                }, enableScenarioPopoverRequestToLoad: function _perfTrack_enableScenarioPopoverRequestToLoad() {
                    MS.Entertainment.Instrumentation.PerfTrack._getState().enableScenario(1327)
                }, disableScenarioPopoverRequestToLoad: function _perfTrack_disableScenarioPopoverRequestToLoad() {
                    MS.Entertainment.Instrumentation.PerfTrack._getState().disableScenario(1327)
                }, triggerScenarioPopoverRequestToLoad: function _perfTrack_triggerScenarioPopoverRequestToLoad(name, DurationMsec) {
                    var PT = MS.Entertainment.Instrumentation.PerfTrack;
                    var state = PT._getState();
                    if (!state.isDisabled(1327)) {
                        var stopTime = new Date;
                        var startTime = state.getStartTime("PopoverRequest");
                        if (startTime) {
                            if (stopTime >= startTime) {
                                var duration = ((stopTime >= startTime) ? (stopTime - startTime) : 0);
                                var DurationMsec = duration;
                                PT.getShellEventProvider().tracePerfTrack_Trigger_PopoverRequestToLoad(name, DurationMsec);
                                PT.getLogger().writeTriggerEventWithMetadata(1327, "XBLW-PopoverRequestToLoad", duration, 0, 0, 0, 0, 0, PT._truncateString(name), "");
                                PT.logTrigger("XBLW-PopoverRequestToLoad", name, DurationMsec)
                            }
                            state.deleteStartTime("PopoverRequest")
                        }
                    }
                }, enableScenarioMarketplaceGalleryRequestToLoad: function _perfTrack_enableScenarioMarketplaceGalleryRequestToLoad() {
                    MS.Entertainment.Instrumentation.PerfTrack._getState().enableScenario(1333)
                }, disableScenarioMarketplaceGalleryRequestToLoad: function _perfTrack_disableScenarioMarketplaceGalleryRequestToLoad() {
                    MS.Entertainment.Instrumentation.PerfTrack._getState().disableScenario(1333)
                }, triggerScenarioMarketplaceGalleryRequestToLoad: function _perfTrack_triggerScenarioMarketplaceGalleryRequestToLoad(DurationMsec) {
                    var PT = MS.Entertainment.Instrumentation.PerfTrack;
                    var state = PT._getState();
                    if (!state.isDisabled(1333)) {
                        var stopTime = new Date;
                        var startTime = state.getStartTime("MarketplaceGalleryRequest");
                        if (startTime) {
                            if (stopTime >= startTime) {
                                var duration = ((stopTime >= startTime) ? (stopTime - startTime) : 0);
                                var DurationMsec = duration;
                                PT.getShellEventProvider().tracePerfTrack_Trigger_MarketplaceGalleryRequestToLoad(DurationMsec);
                                PT.getLogger().writeTriggerEvent(1333, "XBLW-MarketplaceGalleryRequestToLoad", duration);
                                PT.logTrigger("XBLW-MarketplaceGalleryRequestToLoad", DurationMsec)
                            }
                            state.deleteStartTime("MarketplaceGalleryRequest")
                        }
                    }
                }, enableScenarioWebBlendRequestToLoad: function _perfTrack_enableScenarioWebBlendRequestToLoad() {
                    MS.Entertainment.Instrumentation.PerfTrack._getState().enableScenario(1339)
                }, disableScenarioWebBlendRequestToLoad: function _perfTrack_disableScenarioWebBlendRequestToLoad() {
                    MS.Entertainment.Instrumentation.PerfTrack._getState().disableScenario(1339)
                }, triggerScenarioWebBlendRequestToLoad: function _perfTrack_triggerScenarioWebBlendRequestToLoad(url, DurationMsec) {
                    var PT = MS.Entertainment.Instrumentation.PerfTrack;
                    var state = PT._getState();
                    if (!state.isDisabled(1339)) {
                        var stopTime = new Date;
                        var startTime = state.getStartTime("WebBlendRequest");
                        if (startTime) {
                            if (stopTime >= startTime) {
                                var duration = ((stopTime >= startTime) ? (stopTime - startTime) : 0);
                                var DurationMsec = duration;
                                PT.getShellEventProvider().tracePerfTrack_Trigger_WebBlendRequestToLoad(url, DurationMsec);
                                PT.getLogger().writeTriggerEventWithMetadata(1339, "XBLW-WebBlendRequestToLoad", duration, 0, 0, 0, 0, 0, PT._truncateString(url), "");
                                PT.logTrigger("XBLW-WebBlendRequestToLoad", url, DurationMsec)
                            }
                            state.deleteStartTime("WebBlendRequest")
                        }
                    }
                }, enableScenarioExplorePageRequestToLoad: function _perfTrack_enableScenarioExplorePageRequestToLoad() {
                    MS.Entertainment.Instrumentation.PerfTrack._getState().enableScenario(1580)
                }, disableScenarioExplorePageRequestToLoad: function _perfTrack_disableScenarioExplorePageRequestToLoad() {
                    MS.Entertainment.Instrumentation.PerfTrack._getState().disableScenario(1580)
                }, triggerScenarioExplorePageRequestToLoad: function _perfTrack_triggerScenarioExplorePageRequestToLoad(DurationMsec) {
                    var PT = MS.Entertainment.Instrumentation.PerfTrack;
                    var state = PT._getState();
                    if (!state.isDisabled(1580)) {
                        var stopTime = new Date;
                        var startTime = state.getStartTime("ExplorePageRequest");
                        if (startTime) {
                            if (stopTime >= startTime) {
                                var duration = ((stopTime >= startTime) ? (stopTime - startTime) : 0);
                                var DurationMsec = duration;
                                PT.getShellEventProvider().tracePerfTrack_Trigger_ExplorePageRequestToLoad(DurationMsec);
                                PT.getLogger().writeTriggerEvent(1580, "XBLW-ExplorePageRequestToLoad", duration);
                                PT.logTrigger("XBLW-ExplorePageRequestToLoad", DurationMsec)
                            }
                            state.deleteStartTime("ExplorePageRequest")
                        }
                    }
                }, enableScenarioRadioPageRequestToLoad: function _perfTrack_enableScenarioRadioPageRequestToLoad() {
                    MS.Entertainment.Instrumentation.PerfTrack._getState().enableScenario(1581)
                }, disableScenarioRadioPageRequestToLoad: function _perfTrack_disableScenarioRadioPageRequestToLoad() {
                    MS.Entertainment.Instrumentation.PerfTrack._getState().disableScenario(1581)
                }, triggerScenarioRadioPageRequestToLoad: function _perfTrack_triggerScenarioRadioPageRequestToLoad(DurationMsec) {
                    var PT = MS.Entertainment.Instrumentation.PerfTrack;
                    var state = PT._getState();
                    if (!state.isDisabled(1581)) {
                        var stopTime = new Date;
                        var startTime = state.getStartTime("RadioPageRequest");
                        if (startTime) {
                            if (stopTime >= startTime) {
                                var duration = ((stopTime >= startTime) ? (stopTime - startTime) : 0);
                                var DurationMsec = duration;
                                PT.getShellEventProvider().tracePerfTrack_Trigger_RadioPageRequestToLoad(DurationMsec);
                                PT.getLogger().writeTriggerEvent(1581, "XBLW-RadioPageRequestToLoad", duration);
                                PT.logTrigger("XBLW-RadioPageRequestToLoad", DurationMsec)
                            }
                            state.deleteStartTime("RadioPageRequest")
                        }
                    }
                }, enableScenarioDevicesPageRequestToLoad: function _perfTrack_enableScenarioDevicesPageRequestToLoad() {
                    MS.Entertainment.Instrumentation.PerfTrack._getState().enableScenario(1674)
                }, disableScenarioDevicesPageRequestToLoad: function _perfTrack_disableScenarioDevicesPageRequestToLoad() {
                    MS.Entertainment.Instrumentation.PerfTrack._getState().disableScenario(1674)
                }, triggerScenarioDevicesPageRequestToLoad: function _perfTrack_triggerScenarioDevicesPageRequestToLoad(DurationMsec) {
                    var PT = MS.Entertainment.Instrumentation.PerfTrack;
                    var state = PT._getState();
                    if (!state.isDisabled(1674)) {
                        var stopTime = new Date;
                        var startTime = state.getStartTime("DevicesPageRequest");
                        if (startTime) {
                            if (stopTime >= startTime) {
                                var duration = ((stopTime >= startTime) ? (stopTime - startTime) : 0);
                                var DurationMsec = duration;
                                PT.getShellEventProvider().tracePerfTrack_Trigger_DevicesPageRequestToLoad(DurationMsec);
                                PT.getLogger().writeTriggerEvent(1674, "XBLW-DevicesPageRequestToLoad", duration);
                                PT.logTrigger("XBLW-DevicesPageRequestToLoad", DurationMsec)
                            }
                            state.deleteStartTime("DevicesPageRequest")
                        }
                    }
                }, enableScenarioNowPlayingPageRequestToLoad: function _perfTrack_enableScenarioNowPlayingPageRequestToLoad() {
                    MS.Entertainment.Instrumentation.PerfTrack._getState().enableScenario(1683)
                }, disableScenarioNowPlayingPageRequestToLoad: function _perfTrack_disableScenarioNowPlayingPageRequestToLoad() {
                    MS.Entertainment.Instrumentation.PerfTrack._getState().disableScenario(1683)
                }, triggerScenarioNowPlayingPageRequestToLoad: function _perfTrack_triggerScenarioNowPlayingPageRequestToLoad(DurationMsec) {
                    var PT = MS.Entertainment.Instrumentation.PerfTrack;
                    var state = PT._getState();
                    if (!state.isDisabled(1683)) {
                        var stopTime = new Date;
                        var startTime = state.getStartTime("NowPlayingPageRequest");
                        if (startTime) {
                            if (stopTime >= startTime) {
                                var duration = ((stopTime >= startTime) ? (stopTime - startTime) : 0);
                                var DurationMsec = duration;
                                PT.getShellEventProvider().tracePerfTrack_Trigger_NowPlayingPageRequestToLoad(DurationMsec);
                                PT.getLogger().writeTriggerEvent(1683, "XBLW-NowPlayingPageRequestToLoad", duration);
                                PT.logTrigger("XBLW-NowPlayingPageRequestToLoad", DurationMsec)
                            }
                            state.deleteStartTime("NowPlayingPageRequest")
                        }
                    }
                }, enableScenarioMoviesStorePageRequestToLoad: function _perfTrack_enableScenarioMoviesStorePageRequestToLoad() {
                    MS.Entertainment.Instrumentation.PerfTrack._getState().enableScenario(1701)
                }, disableScenarioMoviesStorePageRequestToLoad: function _perfTrack_disableScenarioMoviesStorePageRequestToLoad() {
                    MS.Entertainment.Instrumentation.PerfTrack._getState().disableScenario(1701)
                }, triggerScenarioMoviesStorePageRequestToLoad: function _perfTrack_triggerScenarioMoviesStorePageRequestToLoad(DurationMsec) {
                    var PT = MS.Entertainment.Instrumentation.PerfTrack;
                    var state = PT._getState();
                    if (!state.isDisabled(1701)) {
                        var stopTime = new Date;
                        var startTime = state.getStartTime("MoviesStorePageRequest");
                        if (startTime) {
                            if (stopTime >= startTime) {
                                var duration = ((stopTime >= startTime) ? (stopTime - startTime) : 0);
                                var DurationMsec = duration;
                                PT.getShellEventProvider().tracePerfTrack_Trigger_MoviesStorePageRequestToLoad(DurationMsec);
                                PT.getLogger().writeTriggerEvent(1701, "XBLW-MoviesStorePageRequestToLoad", duration);
                                PT.logTrigger("XBLW-MoviesStorePageRequestToLoad", DurationMsec)
                            }
                            state.deleteStartTime("MoviesStorePageRequest")
                        }
                    }
                }, enableScenarioTvStorePageRequestToLoad: function _perfTrack_enableScenarioTvStorePageRequestToLoad() {
                    MS.Entertainment.Instrumentation.PerfTrack._getState().enableScenario(1702)
                }, disableScenarioTvStorePageRequestToLoad: function _perfTrack_disableScenarioTvStorePageRequestToLoad() {
                    MS.Entertainment.Instrumentation.PerfTrack._getState().disableScenario(1702)
                }, triggerScenarioTvStorePageRequestToLoad: function _perfTrack_triggerScenarioTvStorePageRequestToLoad(DurationMsec) {
                    var PT = MS.Entertainment.Instrumentation.PerfTrack;
                    var state = PT._getState();
                    if (!state.isDisabled(1702)) {
                        var stopTime = new Date;
                        var startTime = state.getStartTime("TvStorePageRequest");
                        if (startTime) {
                            if (stopTime >= startTime) {
                                var duration = ((stopTime >= startTime) ? (stopTime - startTime) : 0);
                                var DurationMsec = duration;
                                PT.getShellEventProvider().tracePerfTrack_Trigger_TvStorePageRequestToLoad(DurationMsec);
                                PT.getLogger().writeTriggerEvent(1702, "XBLW-TvStorePageRequestToLoad", duration);
                                PT.logTrigger("XBLW-TvStorePageRequestToLoad", DurationMsec)
                            }
                            state.deleteStartTime("TvStorePageRequest")
                        }
                    }
                }, enableScenarioVideoCollectionPageRequestToLoad: function _perfTrack_enableScenarioVideoCollectionPageRequestToLoad() {
                    MS.Entertainment.Instrumentation.PerfTrack._getState().enableScenario(1703)
                }, disableScenarioVideoCollectionPageRequestToLoad: function _perfTrack_disableScenarioVideoCollectionPageRequestToLoad() {
                    MS.Entertainment.Instrumentation.PerfTrack._getState().disableScenario(1703)
                }, triggerScenarioVideoCollectionPageRequestToLoad: function _perfTrack_triggerScenarioVideoCollectionPageRequestToLoad(DurationMsec) {
                    var PT = MS.Entertainment.Instrumentation.PerfTrack;
                    var state = PT._getState();
                    if (!state.isDisabled(1703)) {
                        var stopTime = new Date;
                        var startTime = state.getStartTime("VideoCollectionPageRequest");
                        if (startTime) {
                            if (stopTime >= startTime) {
                                var duration = ((stopTime >= startTime) ? (stopTime - startTime) : 0);
                                var DurationMsec = duration;
                                PT.getShellEventProvider().tracePerfTrack_Trigger_VideoCollectionPageRequestToLoad(DurationMsec);
                                PT.getLogger().writeTriggerEvent(1703, "XBLW-VideoCollectionPageRequestToLoad", duration);
                                PT.logTrigger("XBLW-VideoCollectionPageRequestToLoad", DurationMsec)
                            }
                            state.deleteStartTime("VideoCollectionPageRequest")
                        }
                    }
                }, enableScenarioAppLaunchToExplore: function _perfTrack_enableScenarioAppLaunchToExplore() {
                    MS.Entertainment.Instrumentation.PerfTrack._getState().enableScenario(1582)
                }, disableScenarioAppLaunchToExplore: function _perfTrack_disableScenarioAppLaunchToExplore() {
                    MS.Entertainment.Instrumentation.PerfTrack._getState().disableScenario(1582)
                }, triggerScenarioAppLaunchToExplore: function _perfTrack_triggerScenarioAppLaunchToExplore(DurationMsec) {
                    var PT = MS.Entertainment.Instrumentation.PerfTrack;
                    var state = PT._getState();
                    if (!state.isDisabled(1582) && !state.isFiredOnce(1582)) {
                        var stopTime = new Date;
                        var startTime = state.getStartTime("AppLaunch");
                        if (startTime) {
                            var duration = ((stopTime >= startTime) ? (stopTime - startTime) : 0);
                            var DurationMsec = duration;
                            PT.getShellEventProvider().tracePerfTrack_Trigger_AppLaunchToExploreComplete(DurationMsec);
                            if (PT.getLogger().writeLaunchStopEvent)
                                PT.getLogger().writeLaunchStopEvent(Microsoft.PerfTrack.PerfTrackTimePoint.visibleComplete, MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.uiState).activationKind);
                            PT.getLogger().writeTriggerEvent(1582, "XBLW-AppLaunchToExplore", duration);
                            PT.logTrigger("XBLW-AppLaunchToExplore", DurationMsec);
                            state.deleteStartTime("AppLaunch")
                        }
                        state.onFiredOnce(1582);
                        PT.disableAllStartupScenarios()
                    }
                }, enableScenarioAppLaunchToRadio: function _perfTrack_enableScenarioAppLaunchToRadio() {
                    MS.Entertainment.Instrumentation.PerfTrack._getState().enableScenario(1583)
                }, disableScenarioAppLaunchToRadio: function _perfTrack_disableScenarioAppLaunchToRadio() {
                    MS.Entertainment.Instrumentation.PerfTrack._getState().disableScenario(1583)
                }, triggerScenarioAppLaunchToRadio: function _perfTrack_triggerScenarioAppLaunchToRadio(DurationMsec) {
                    var PT = MS.Entertainment.Instrumentation.PerfTrack;
                    var state = PT._getState();
                    if (!state.isDisabled(1583) && !state.isFiredOnce(1583)) {
                        var stopTime = new Date;
                        var startTime = state.getStartTime("AppLaunch");
                        if (startTime) {
                            var duration = ((stopTime >= startTime) ? (stopTime - startTime) : 0);
                            var DurationMsec = duration;
                            PT.getShellEventProvider().tracePerfTrack_Trigger_AppLaunchToRadioComplete(DurationMsec);
                            if (PT.getLogger().writeLaunchStopEvent)
                                PT.getLogger().writeLaunchStopEvent(Microsoft.PerfTrack.PerfTrackTimePoint.visibleComplete, MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.uiState).activationKind);
                            PT.getLogger().writeTriggerEvent(1583, "XBLW-AppLaunchToRadio", duration);
                            PT.logTrigger("XBLW-AppLaunchToRadio", DurationMsec);
                            state.deleteStartTime("AppLaunch")
                        }
                        state.onFiredOnce(1583);
                        PT.disableAllStartupScenarios()
                    }
                }, enableScenarioTVDetailsRequest: function _perfTrack_enableScenarioTVDetailsRequest() {
                    MS.Entertainment.Instrumentation.PerfTrack._getState().enableScenario(1584)
                }, disableScenarioTVDetailsRequest: function _perfTrack_disableScenarioTVDetailsRequest() {
                    MS.Entertainment.Instrumentation.PerfTrack._getState().disableScenario(1584)
                }, triggerScenarioTVDetailsRequest: function _perfTrack_triggerScenarioTVDetailsRequest(DurationMsec) {
                    var PT = MS.Entertainment.Instrumentation.PerfTrack;
                    var state = PT._getState();
                    if (!state.isDisabled(1584)) {
                        var stopTime = new Date;
                        var startTime = state.getStartTime("TVDetailsRequest");
                        if (startTime) {
                            if (stopTime >= startTime) {
                                var duration = ((stopTime >= startTime) ? (stopTime - startTime) : 0);
                                var DurationMsec = duration;
                                PT.getShellEventProvider().tracePerfTrack_Trigger_TVDetailsRequestToLoad(DurationMsec);
                                PT.getLogger().writeTriggerEvent(1584, "XBLW-TVDetailsRequestToLoad", duration);
                                PT.logTrigger("XBLW-TVDetailsRequestToLoad", DurationMsec)
                            }
                            state.deleteStartTime("TVDetailsRequest")
                        }
                    }
                }, enableScenarioMovieDetailsRequest: function _perfTrack_enableScenarioMovieDetailsRequest() {
                    MS.Entertainment.Instrumentation.PerfTrack._getState().enableScenario(1585)
                }, disableScenarioMovieDetailsRequest: function _perfTrack_disableScenarioMovieDetailsRequest() {
                    MS.Entertainment.Instrumentation.PerfTrack._getState().disableScenario(1585)
                }, triggerScenarioMovieDetailsRequest: function _perfTrack_triggerScenarioMovieDetailsRequest(DurationMsec) {
                    var PT = MS.Entertainment.Instrumentation.PerfTrack;
                    var state = PT._getState();
                    if (!state.isDisabled(1585)) {
                        var stopTime = new Date;
                        var startTime = state.getStartTime("MovieDetailsRequest");
                        if (startTime) {
                            if (stopTime >= startTime) {
                                var duration = ((stopTime >= startTime) ? (stopTime - startTime) : 0);
                                var DurationMsec = duration;
                                PT.getShellEventProvider().tracePerfTrack_Trigger_MovieDetailsRequestToLoad(DurationMsec);
                                PT.getLogger().writeTriggerEvent(1585, "XBLW-MovieDetailsRequestToLoad", duration);
                                PT.logTrigger("XBLW-MovieDetailsRequestToLoad", DurationMsec)
                            }
                            state.deleteStartTime("MovieDetailsRequest")
                        }
                    }
                }, enableScenarioAlbumDetailsRequest: function _perfTrack_enableScenarioAlbumDetailsRequest() {
                    MS.Entertainment.Instrumentation.PerfTrack._getState().enableScenario(1586)
                }, disableScenarioAlbumDetailsRequest: function _perfTrack_disableScenarioAlbumDetailsRequest() {
                    MS.Entertainment.Instrumentation.PerfTrack._getState().disableScenario(1586)
                }, triggerScenarioAlbumDetailsRequest: function _perfTrack_triggerScenarioAlbumDetailsRequest(DurationMsec) {
                    var PT = MS.Entertainment.Instrumentation.PerfTrack;
                    var state = PT._getState();
                    if (!state.isDisabled(1586)) {
                        var stopTime = new Date;
                        var startTime = state.getStartTime("AlbumDetailsRequest");
                        if (startTime) {
                            if (stopTime >= startTime) {
                                var duration = ((stopTime >= startTime) ? (stopTime - startTime) : 0);
                                var DurationMsec = duration;
                                PT.getShellEventProvider().tracePerfTrack_Trigger_AlbumDetailsRequestToLoad(DurationMsec);
                                PT.getLogger().writeTriggerEvent(1586, "XBLW-AlbumDetailsRequestToLoad", duration);
                                PT.logTrigger("XBLW-AlbumDetailsRequestToLoad", DurationMsec)
                            }
                            state.deleteStartTime("AlbumDetailsRequest")
                        }
                    }
                }, enableScenarioArtistDetailsRequest: function _perfTrack_enableScenarioArtistDetailsRequest() {
                    MS.Entertainment.Instrumentation.PerfTrack._getState().enableScenario(1587)
                }, disableScenarioArtistDetailsRequest: function _perfTrack_disableScenarioArtistDetailsRequest() {
                    MS.Entertainment.Instrumentation.PerfTrack._getState().disableScenario(1587)
                }, triggerScenarioArtistDetailsRequest: function _perfTrack_triggerScenarioArtistDetailsRequest(DurationMsec) {
                    var PT = MS.Entertainment.Instrumentation.PerfTrack;
                    var state = PT._getState();
                    if (!state.isDisabled(1587)) {
                        var stopTime = new Date;
                        var startTime = state.getStartTime("ArtistDetailsRequest");
                        if (startTime) {
                            if (stopTime >= startTime) {
                                var duration = ((stopTime >= startTime) ? (stopTime - startTime) : 0);
                                var DurationMsec = duration;
                                PT.getShellEventProvider().tracePerfTrack_Trigger_ArtistDetailsRequestToLoad(DurationMsec);
                                PT.getLogger().writeTriggerEvent(1587, "XBLW-ArtistDetailsRequestToLoad", duration);
                                PT.logTrigger("XBLW-ArtistDetailsRequestToLoad", DurationMsec)
                            }
                            state.deleteStartTime("ArtistDetailsRequest")
                        }
                    }
                }, enableScenarioPlaylistDetailsRequest: function _perfTrack_enableScenarioPlaylistDetailsRequest() {
                    MS.Entertainment.Instrumentation.PerfTrack._getState().enableScenario(1588)
                }, disableScenarioPlaylistDetailsRequest: function _perfTrack_disableScenarioPlaylistDetailsRequest() {
                    MS.Entertainment.Instrumentation.PerfTrack._getState().disableScenario(1588)
                }, triggerScenarioPlaylistDetailsRequest: function _perfTrack_triggerScenarioPlaylistDetailsRequest(DurationMsec) {
                    var PT = MS.Entertainment.Instrumentation.PerfTrack;
                    var state = PT._getState();
                    if (!state.isDisabled(1588)) {
                        var stopTime = new Date;
                        var startTime = state.getStartTime("PlaylistDetailsRequest");
                        if (startTime) {
                            if (stopTime >= startTime) {
                                var duration = ((stopTime >= startTime) ? (stopTime - startTime) : 0);
                                var DurationMsec = duration;
                                PT.getShellEventProvider().tracePerfTrack_Trigger_PlaylistDetailsRequestToLoad(DurationMsec);
                                PT.getLogger().writeTriggerEvent(1588, "XBLW-PlaylistDetailsRequestToLoad", duration);
                                PT.logTrigger("XBLW-PlaylistDetailsRequestToLoad", DurationMsec)
                            }
                            state.deleteStartTime("PlaylistDetailsRequest")
                        }
                    }
                }, disableAllStartupScenarios: function _perfTrack_disableAllStartupScenarios() {
                    var PT = MS.Entertainment.Instrumentation.PerfTrack;
                    PT.disableScenarioAppLaunch();
                    PT.disableScenarioAppLaunchToCollection();
                    PT.disableScenarioAppLaunchPlayNonProtectedContent();
                    PT.disableScenarioAppLaunchPlayProtectedContent();
                    PT.disableScenarioAppLaunchToExplore();
                    PT.disableScenarioAppLaunchToRadio()
                }, onSuspending: function _perfTrack_onSuspending() {
                    MS.Entertainment.Instrumentation.PerfTrack._getState().resetStartPoints();
                    MS.Entertainment.Instrumentation.PerfTrack.disableAllStartupScenarios()
                }, onResuming: function _perfTrack_onResuming() {
                    MS.Entertainment.Instrumentation.PerfTrack._getState().resetStartPoints()
                }
        })})
})()
