﻿/* Copyright (C) Microsoft Corporation. All rights reserved. */
scriptValidator();
MS.Entertainment.UI.Debug.defineAssert("MS.Entertainment.Platform.Playback");
(function() {
    "use strict";
    var MSEPlatform = WinJS.Namespace.define("MS.Entertainment.Platform", null);
    WinJS.Namespace.defineWithParent(MSEPlatform, "Playback", {PlaybackControl: MS.Entertainment.UI.Framework.defineUserControl("/Components/Playback/Controls/PlaybackControl.html#playbackControlTemplate", function PlaybackControl_constructor(element, options) {
            MSEPlatform.Playback.Etw.traceString("PlaybackControl::Constructor: ")
        }, {
            initialize: function PlaybackControl_initialize() {
                MS.Entertainment.Platform.Playback.Etw.traceString("PlaybackControl::initialize");
                this._iPlayback = new MS.Entertainment.Platform.Playback.PlaybackController.createInstance;
                this._player = MS.Entertainment.Platform.Playback.XPlayer.createInstance(this._playerContainer);
                if (this._iPlayback === null || this._player === null)
                    throw"PlaybackControl_initialize: Error! failed to create XPlayer";
                this._iPlayback.setPlayer(this._player);
                this.controlInitialized = true;
                MSEPlatform.Playback.Etw.traceControlInitialized();
                this.dispatchEvent("onControlInitialized", {sender: this})
            }, dispose: function PlaybackControl_dispose() {
                    this.release()
                }, release: function release() {
                    if (this._iPlayback) {
                        this._iPlayback.dispose();
                        this._iPlayback = null;
                        this._player.dispose();
                        this._player = null
                    }
                }, getPlaybackInterface: function PlaybackControl_getPlaybackInterface() {
                    if (this._iPlayback === null)
                        throw"PlaybackControl_getPlaybackInterface: Error! iPlayback is null";
                    return this._iPlayback
                }, getClosedCaptionsContainer: function PlaybackControl_getClosedCaptionsContainer() {
                    return this._closedCaptionsContainer
                }, isVideoAdSupported: {get: function() {
                        var iPlayback;
                        try {
                            iPlayback = this.getPlaybackInterface()
                        }
                        catch(e) {
                            return false
                        }
                        if (iPlayback._currentMedia)
                            return iPlayback._currentMedia.videoAdSupported;
                        else
                            return false
                    }}, _iPlayback: null, _player: null, _playerContainer: null, _closedCaptionsContainer: null
        }, {controlInitialized: false})})
})()
