﻿/* Copyright (C) Microsoft Corporation. All rights reserved. */
scriptValidator();
(function() {
    "use strict";
    var MSEPlatform = WinJS.Namespace.define("MS.Entertainment.Platform", null);
    (function() {
        function _hresult(hex) {
            return hex >= 0x80000000 ? hex - 0x100000000 : hex
        }
        var errorGroups = {
                Error: {
                    NS_E_EXPLICIT_CONTENT_SIGNIN_REQUIRED: 0xC00D1354, NS_E_EXPLICIT_CONTENT_PLAY_BLOCKED: 0xC00D1355, NS_E_EXPLICIT_CONTENT_DOWNLOAD_BLOCKED: 0xC00D1393, NS_E_WMP_ACCESS_DENIED: 0xC00D11D2, NS_E_WMP_NETWORK_ERROR: 0xC00D11C0, NS_E_SIGNIN_NOT_SUPPORTED_REGION: 0xC00D1388, NS_E_DRM_NEEDS_INDIVIDUALIZATION: 0xC00D2728, NS_E_WMPIM_USEROFFLINE: 0xC00D1126, NS_E_WMP_DRM_LICENSE_NOTACQUIRED: 0xc00d1204, NS_E_COMPRESSED_DIGITAL_AUDIO_PROTECTION_LEVEL_UNSUPPORTED: 0xC00D2098, NS_E_UNCOMPRESSED_DIGITAL_AUDIO_PROTECTION_LEVEL_UNSUPPORTED: 0xC00D2099, NS_E_DRM_DRIVER_AUTH_FAILURE: 0xC00D274D, NS_E_DRM_UNABLE_TO_INITIALIZE: 0xC00D271D, NS_E_WMP_AUDIO_HW_PROBLEM: 0xC00D11BA, NS_E_WMP_BAD_DRIVER: 0xC00D11D1, NS_E_WMP_MULTIPLE_ERROR_IN_PLAYLIST: 0xC00D11DF, NS_E_WMPCORE_BUSY: 0xC00D10B7, NS_E_WMP_DRM_GENERIC_LICENSE_FAILURE: 0xC00D11DA, NS_E_DRM_INVALID_LICENSE: 0xC00D2718, ZEST_E_SIGNIN_REQUIRED: 0xC101A24B, ZEST_E_MW_CONCURRENT_STREAM: 0xC101A9CA, ZEST_E_ASSET_ITEM_NOT_PURCHASED: 0xC101A7D1, ZEST_E_ASSET_LICENSE_RIGHT_NOT_OWNED: 0xC101A7D4, ZEST_E_MULTITUNER_CONCURRENTSTREAMING_DETECTED: 0xC101A7D8, ZEST_E_MEDIAINSTANCE_STREAMING_OCCUPIED: 0xC101A7E1, ZEST_E_MW_CONTENT_REVOKED_ON_LABEL_TAKEDOWN: 0xC101A9D6, ZEST_E_DEVICE_ACTIVATION_LIMIT_EXCEEDED: 0xC101A411, ZUNE_E_PASSPORT_TICKET_SIGNIN_REQUIRED: 0xC1010036, ZUNE_E_NO_SUBSCRIPTION_DOWNLOAD_RIGHTS: 0xC1010029, ZUNE_E_DOWNLOAD_LIBRARY_DISK_FULL: 0xC1010039, ZUNE_E_DOWNLOAD_SYSTEM_DISK_FULL: 0xC1010038, E_MDS_UNAUTHENTICATED_TRACK_LIMIT: 0xC101AB55, E_MDS_AUTHENTICATED_TRACK_LIMIT: 0xC101AB56, E_MDS_INDIVIDUAL_TRACK_LIMIT: 0xC101AB59, E_MDS_CANNOT_PLAY: 0xC101AB57, E_MDS_ROAMING_LIMIT: 0xC101AB58, E_ENHANCED_STORAGE: 0x8004b896, E_ABORT: 0x80004004, E_FILE_NOT_FOUND: 0x80070002, ERROR_GRAPHICS_ONLY_CONSOLE_SESSION_SUPPORTED: 0xC0262500, X8_E_PLAYBACK_MEDIA_ERR_ABORTED: 0xC101008D, X8_E_PLAYBACK_MEDIA_ERR_NETWORK: 0xC101008E, X8_E_PLAYBACK_MEDIA_ERR_DECODE: 0xC101008F, X8_E_PLAYBACK_MEDIA_ERR_SRC_NOT_SUPPORTED: 0xC1010090, X8_E_PLAYBACK_MEDIA_GENERIC: 0xC1010091, X8_E_PLAYBACK_MEDIA_CANT_PLAYTO: 0xC1010092, X8_E_PLAYBACK_MEDIA_CANT_PLAYTO_PREMIUM: 0xC1010093, X8_E_PLAYBACK_FREESTREAMING_NO_RIGHTS: 0xC1010094, X8_E_PLAYBACK_PLAYTO_ERR_DECODE: 0xC1010095, X8_E_PLAYBACK_LOGON_TO_PLAY_EXPLICIT_CONTENT: 0xC1010096, X8_E_PLAYBACK_LOGON_TO_PLAY_EXPLICIT_CONTENT_PRE_ASSET_LOCATION: 0xC1010097, X8_E_PLAYBACK_EXPLICIT_CONTENT_PLAY_BLOCKED_PRE_ASSET_LOCATION: 0xC1010098, X8_E_PLAYBACK_PROTECTED_MEDIA_NOT_IDENTIFIED: 0xC1010099, X8_E_PLAYBACK_HIGH_SECURITY_LEVEL_CONTENT_NOT_ALLOWED: 0xC101009A, X8_E_PLAYBACK_PLAYLIST_FILE_CORRUPT: 0xC101009C, X8_E_PLAYBACK_REMOTE_DESKTOP_NOT_SUPPORTED: 0xC101009D, X8_E_PLAYBACK_MEDIA_ERR_NOT_LOCAL: 0xC101009E, X8_E_PLAYBACK_HDMI_OUTPUT_LOST: 0xC101009F, X8_E_PLAYBACK_PLAYLIST_PATH_NOT_SUPPORTED: 0xC10100A0, X8_E_PLAYBACK_PLAYTO_UNEXPECTED_ERR: 0xC10100A1, X8_E_PLAYBACK_NO_ASSET_LOCATION: 0xC101010A, X8_E_PREVIEW_ONLY_DONOT_PLAY_IN_PLAYLIST: 0xC101010D, X8_E_PLAYBACK_STOPPED_DATA_LIMIT_EXCEEDED: 0xC10101C2, X8_E_PLAYBACK_STOPPED_DATA_LIMIT_APPROACHING: 0xC10101C3, X8_E_PLAYBACK_STOPPED_SWITCHED_TO_METERED_NETWORK: 0xC10101C4, X8_E_UNSUPPORTED_FORMAT: 0xC1010103, MF_E_DRM_UNSUPPORTED: 0xC00D3700, MF_E_AUDIO_PLAYBACK_DEVICE_INVALIDATED: 0XC00D4E86, MF_E_UNSUPPORTED_CONTENT_PROTECTION_SYSTEM: 0xC00D7186, MF_E_INVALIDMEDIATYPE: 0xC00D36B4, MF_E_CANNOT_CREATE_SINK: 0xC00D36FA, MF_E_DEBUGGING_NOT_ALLOWED: 0xC00D715D, MF_E_HIGH_SECURITY_LEVEL_CONTENT_NOT_ALLOWED: 0xC00D7178, MF_E_UNSUPPORTED_BYTESTREAM: 0xC00D36C4, MF_E_UNSUPPORTED_RATE: 0xC00D36D0, MF_E_TOPO_CODEC_NOT_FOUND: 0xC00D5212, INET_E_CONNECTION_TIMEOUT: 0x800C000b, INET_E_DOWNLOAD_FAILURE: 0x800C0008, INET_E_RESOURCE_NOT_FOUND: 0x800C0005, SL_E_LICENSE_FILE_NOT_INSTALLED: 0xC004F011
                }, MediaTagError: {
                        MEDIA_ENGINE_ERR_NOERROR: 0, MEDIA_ERR_ABORTED: 1, MEDIA_ERR_NETWORK: 2, MEDIA_ERR_DECODE: 3, MEDIA_ERR_SRC_NOT_SUPPORTED: 4
                    }
            };
        var errorCodeNameLookupTable = {};
        function _adjustCodeUINT32(code)
        {
            return code < 0 ? (code += 0x100000000) : (code & 0xFFFFFFFF)
        }
        var codeToString = {
                Error: function(code, codeName) {
                    return (codeName + "(0x" + _adjustCodeUINT32(code).toString(16) + ")")
                }, MediaTagError: function(code, codeName) {
                        return (codeName + "(" + code + ")")
                    }, unknownError: function(code) {
                        return "(0x" + _adjustCodeUINT32(code).toString(16) + ")".toString()
                    }
            };
        for (var groupName in errorGroups) {
            var errorGroup = errorGroups[groupName];
            for (var codeName in errorGroup) {
                var code = _hresult(errorGroup[codeName]);
                if (codeToString[groupName])
                    errorCodeNameLookupTable[code] = codeToString[groupName](_hresult(code), codeName)
            }
        }
        {};
        function _hydrateErrorTable(errorGroups) {
            var _hydratedTable = {};
            for (var groupName in errorGroups) {
                var errorGroup = errorGroups[groupName];
                Object.defineProperty(_hydratedTable, groupName, {
                    value: {}, writable: false, enumerable: true, configurable: false
                });
                for (var codeName in errorGroup) {
                    var code = _hresult(errorGroup[codeName]);
                    Object.defineProperty(_hydratedTable[groupName], codeName, {
                        value: {
                            code: _hresult(errorGroup[codeName]), name: codeName
                        }, writable: false, enumerable: true, configurable: false
                    })
                }
            }
            {};
            return _hydratedTable
        }
        function _errorToString(code) {
            var codeName = errorCodeNameLookupTable[code];
            return codeName || codeToString.unknownError(code)
        }
        function _mediaErrorToString(error) {
            return ("error.code = " + _errorToString(error.code) + ", error.msExtendedCode = " + _errorToString(error.msExtendedCode))
        }
        function _codeOf(errorName) {
            for (var groupName in errorGroups) {
                var errorGroup = errorGroups[groupName];
                var code = errorGroup[errorName];
                if (code === +code)
                    return _hresult(code)
            }
            {};
            throw new Error("Invalid Error name: " + errorName);
        }
        WinJS.Namespace.defineWithParent(MSEPlatform, "Playback", _hydrateErrorTable(errorGroups));
        WinJS.Namespace.defineWithParent(MSEPlatform, "Playback", {
            errorToString: _errorToString, mediaErrorToString: _mediaErrorToString, codeOfError: _codeOf
        })
    })();
    WinJS.Namespace.define("MS.Entertainment.Platform.Playback", {
        makePlaybackError: function makePlaybackError(error, context) {
            if (error instanceof Error)
                MSEPlatform.Playback.Etw.traceString("+PlaybackError::makePlaybackError InnerError: " + MSEPlatform.Playback.errorToString(error.code));
            else
                MSEPlatform.Playback.Etw.traceString("+PlaybackError::makePlaybackError InnerError" + ", " + MSEPlatform.Playback.mediaErrorToString(error) + ", context = " + context);
            var playbackError = {};
            var errorCode = 0;
            if (!error) {
                errorCode = MS.Entertainment.Platform.Playback.Error.X8_E_PLAYBACK_MEDIA_GENERIC.code;
                MS.Entertainment.Utilities.Telemetry.logPlaybackErrorConvertedToGeneric(0, 0, "makePlaybackError, error is NULL - " + context)
            }
            else if (typeof(error) === "object")
                if (error.code)
                    errorCode = MS.Entertainment.Platform.Playback._mapMediaElementErrorCodes(error.code, error.msExtendedCode);
                else if (error.number)
                    errorCode = MS.Entertainment.Platform.Playback._mapMediaElementErrorCodes(error.number);
                else if (error.msExtendedCode)
                    errorCode = error.msExtendedCode;
                else
                    try {
                        var s = error.toString();
                        if (s && s !== String.empty) {
                            errorCode = MS.Entertainment.Platform.Playback.Error.X8_E_PLAYBACK_MEDIA_GENERIC.code;
                            MS.Entertainment.Utilities.Telemetry.logPlaybackErrorConvertedToGeneric(0, 0, "makePlaybackError, string object = " + s + " - " + context)
                        }
                    }
                    catch(ex) {}
            else if (typeof(error) === "string") {
                errorCode = MS.Entertainment.Platform.Playback.Error.X8_E_PLAYBACK_MEDIA_GENERIC.code;
                MS.Entertainment.Utilities.Telemetry.logPlaybackErrorConvertedToGeneric(0, 0, "makePlaybackError, string literal = " + error + " - " + context)
            }
            else if (isNaN(error)) {
                errorCode = MS.Entertainment.Platform.Playback.Error.X8_E_PLAYBACK_MEDIA_GENERIC.code;
                MS.Entertainment.Utilities.Telemetry.logPlaybackErrorConvertedToGeneric(0, 0, "makePlaybackError, error isNaN - " + context)
            }
            else
                errorCode = error;
            playbackError.innerError = error;
            playbackError.isCritical = (error && error.isCritical);
            playbackError.code = errorCode;
            playbackError.msExtendedCode = errorCode;
            playbackError.context = context;
            if (error && error.name)
                playbackError[error.name] = errorCode;
            MSEPlatform.Playback.Etw.traceString("-PlaybackError::makePlaybackError OuterError" + ", code = " + MSEPlatform.Playback.errorToString(errorCode));
            return playbackError
        }, firePlaybackError: function firePlaybackError(callback, error, context, mediaItem) {
                if (callback) {
                    var eventObject = {
                            type: "error", target: {error: {
                                        code: 0, innerError: null, isCritical: false, msExtendedCode: 0, mediaItem: null, context: context
                                    }}
                        };
                    eventObject.target.error = MS.Entertainment.Platform.Playback.makePlaybackError(error, context);
                    if (mediaItem !== undefined)
                        eventObject.target.error.mediaItem = mediaItem;
                    MSEPlatform.Playback.Etw.traceString("PlaybackErrors::firePlaybackError" + ", code = " + MSEPlatform.Playback.errorToString(eventObject.target.error.code) + ", msExtendedCode = " + MSEPlatform.Playback.errorToString(eventObject.target.error.msExtendedCode) + ", context = " + context);
                    callback(eventObject)
                }
                MS.Entertainment.Instrumentation.PerfTrack.disableAllStartupScenarios();
                MS.Entertainment.Instrumentation.PerfTrack.disableScenarioPlayProtectedInApp();
                MS.Entertainment.Instrumentation.PerfTrack.disableScenarioPlayNonProtectedInApp()
            }, makeParentallyBlockedError: function makeParentallyBlockedError() {
                return MS.Entertainment.Utilities.isVideoApp ? MS.Entertainment.Platform.Playback.Error.X8_E_PLAYBACK_EXPLICIT_CONTENT_PLAY_BLOCKED_PRE_ASSET_LOCATION : MS.Entertainment.Platform.Playback.Error.NS_E_EXPLICIT_CONTENT_PLAY_BLOCKED
            }, _mapMediaElementErrorCodes: function _mapMediaElementErrorCodes(code, msExtendedCode) {
                if (code < MSEPlatform.Playback.MediaTagError.MEDIA_ERR_ABORTED.code || code > MSEPlatform.Playback.MediaTagError.MEDIA_ERR_SRC_NOT_SUPPORTED.code)
                    return code;
                var errorCode;
                switch (code) {
                    case MSEPlatform.Playback.MediaTagError.MEDIA_ERR_ABORTED.code:
                        if (msExtendedCode)
                            errorCode = msExtendedCode;
                        else
                            errorCode = MSEPlatform.Playback.Error.X8_E_PLAYBACK_MEDIA_ERR_ABORTED.code;
                        break;
                    case MSEPlatform.Playback.MediaTagError.MEDIA_ERR_NETWORK.code:
                        if (msExtendedCode)
                            errorCode = msExtendedCode;
                        else
                            errorCode = MSEPlatform.Playback.Error.X8_E_PLAYBACK_MEDIA_ERR_NETWORK.code;
                        break;
                    case MSEPlatform.Playback.MediaTagError.MEDIA_ERR_DECODE.code:
                        if (msExtendedCode)
                            errorCode = msExtendedCode;
                        else
                            errorCode = MSEPlatform.Playback.Error.X8_E_PLAYBACK_MEDIA_ERR_DECODE.code;
                        break;
                    case MSEPlatform.Playback.MediaTagError.MEDIA_ERR_SRC_NOT_SUPPORTED.code:
                        if (msExtendedCode)
                            if (msExtendedCode === MSEPlatform.Playback.Error.MF_E_UNSUPPORTED_CONTENT_PROTECTION_SYSTEM.code)
                                errorCode = MSEPlatform.Playback.Error.NS_E_WMP_DRM_LICENSE_NOTACQUIRED.code;
                            else
                                errorCode = msExtendedCode;
                        else
                            errorCode = MSEPlatform.Playback.Error.X8_E_PLAYBACK_MEDIA_ERR_SRC_NOT_SUPPORTED.code;
                        break;
                    default:
                        errorCode = MSEPlatform.Playback.Error.X8_E_PLAYBACK_MEDIA_GENERIC.code;
                        MS.Entertainment.Utilities.Telemetry.logPlaybackErrorConvertedToGeneric(code, msExtendedCode, "_mapMediaElementErrorCodes");
                        break
                }
                return errorCode
            }
    })
})()
