﻿/* Copyright (C) Microsoft Corporation. All rights reserved. */
scriptValidator();
MS.Entertainment.UI.Debug.defineAssert("MS.Entertainment.Platform.Playback");
(function() {
    "use strict";
    var MSEPlatform = WinJS.Namespace.define("MS.Entertainment.Platform", null);
    WinJS.Namespace.defineWithParent(MSEPlatform, "Playback", {MediaInstance: MS.Entertainment.UI.Framework.define(function MediaInstance_constructor(mediaObject) {
            this._initialize(mediaObject)
        }, {
            source: String.empty, acquisitionData: null, alternateSource: null, mediaType: -1, protectionState: MS.Entertainment.Platform.Playback.ProtectionState.unknown, startPosition: 0, cookie: 1, isLocal: false, playlogEnabled: true, trackingId: String.empty, isAudioAd: false, isPreview: false, inCollection: false, fromCollection: false, serviceId: null, duration: null, videoAdSupported: false, videoEncoding: Microsoft.Entertainment.Marketplace.VideoEncoding.unknown, alternateVideoEncoding: null, _bookmark: 0, _played: false, _playcount: 0, _mediaItem: null, _provider: null, _errorDescriptor: null, _initializedPromise: null, _mediaStore: null, _bookmarkWatcher: null, _initialize: function MediaInstance_initialize(mediaObject) {
                    var that = this;
                    var playFromBookmark = true;
                    if (mediaObject) {
                        var configurationManager = new Microsoft.Entertainment.Configuration.ConfigurationManager;
                        var isSubscription = configurationManager.service.lastSignedInUserSubscription;
                        if (mediaObject.hasOwnProperty("source")) {
                            var source = mediaObject["source"];
                            var manifestHint = /_51.ism\/manifest/i;
                            if (source && source.toString().match(manifestHint) && !MS.Entertainment.Utilities.isVideoApp2) {
                                this["alternateSource"] = source;
                                this["source"] = source.toString().replace(manifestHint, "_ST.ism/manifest")
                            }
                            else
                                this["source"] = source
                        }
                        if (mediaObject.hasOwnProperty("mediaType"))
                            this["mediaType"] = mediaObject["mediaType"];
                        if (mediaObject.hasOwnProperty("startPosition") && mediaObject["startPosition"]) {
                            this["startPosition"] = mediaObject["startPosition"];
                            playFromBookmark = false
                        }
                        if (mediaObject.hasOwnProperty("cookie"))
                            this["cookie"] = mediaObject["cookie"];
                        this["isPreview"] = false;
                        if (mediaObject.hasOwnProperty("mediaItem")) {
                            this["_mediaItem"] = mediaObject["mediaItem"];
                            if (this._mediaItem && this._mediaItem.acquisitionData)
                                this["acquisitionData"] = this._mediaItem.acquisitionData;
                            if (this._mediaItem && this._mediaItem.data) {
                                if (this._mediaItem.data.libraryId)
                                    this["libraryId"] = this._mediaItem.data.libraryId;
                                if (this._mediaItem.data.playPreviewOnly) {
                                    this["playlogEnabled"] = false;
                                    this["isPreview"] = true
                                }
                                if (this._mediaItem.data.playlistId && this._mediaItem.data.playlistId >= 0) {
                                    this["containerLibraryId"] = this._mediaItem.data.playlistId;
                                    this["containerMediaType"] = Microsoft.Entertainment.Queries.ObjectType.playlist
                                }
                                else if (this._mediaItem.data.albumId) {
                                    this["containerLibraryId"] = this._mediaItem.data.albumId;
                                    this["containerMediaType"] = Microsoft.Entertainment.Queries.ObjectType.album
                                }
                                if (this._mediaItem.data.inCollection)
                                    this["inCollection"] = this._mediaItem.data.inCollection;
                                if (this._mediaItem.data.duration)
                                    this["duration"] = this._mediaItem.data.duration;
                                if (this._mediaItem.data.serviceId)
                                    this["serviceId"] = this._mediaItem.data.serviceId;
                                if (this._mediaItem.data.fromCollection)
                                    this["fromCollection"] = this._mediaItem.data.fromCollection
                            }
                        }
                        if (mediaObject.hasOwnProperty("mediaInstanceId"))
                            this["mediaInstanceId"] = mediaObject["mediaInstanceId"];
                        if (mediaObject.hasOwnProperty("nativeLicenseRight"))
                            this["nativeLicenseRight"] = mediaObject["nativeLicenseRight"];
                        var featureEnablement = new Microsoft.Entertainment.FeatureEnablement.FeatureEnablement;
                        var freeVideoWithAds = featureEnablement.isEnabled(Microsoft.Entertainment.FeatureEnablement.FeatureItem.videoFreeWithAds);
                        if (mediaObject.hasOwnProperty("offerId")) {
                            this["offerId"] = mediaObject["offerId"];
                            var offerId = mediaObject["offerId"];
                            if (freeVideoWithAds && offerId && configurationManager.video.offerIdsVideoFreeWithAds) {
                                MS.Entertainment.Platform.Playback.assert(offerId.length > 3, "OfferId is invalid.");
                                offerId = offerId.substr(1, offerId.length - 2).toLowerCase();
                                var freeOfferWithAds = configurationManager.video.offerIdsVideoFreeWithAds.split(',');
                                for (var count = 0; count < freeOfferWithAds.length; count++)
                                    if (offerId === freeOfferWithAds[count].toLowerCase()) {
                                        this.videoAdSupported = true;
                                        break
                                    }
                            }
                        }
                        if (freeVideoWithAds && configurationManager.video.playVideoFreeWithAds)
                            this.videoAdSupported = true;
                        if (mediaObject.hasOwnProperty("libraryId"))
                            this["libraryId"] = mediaObject["libraryId"];
                        if (mediaObject.hasOwnProperty("isLocal"))
                            this["isLocal"] = mediaObject["isLocal"];
                        if (mediaObject.hasOwnProperty("error"))
                            this["_errorDescriptor"] = mediaObject["error"];
                        if (mediaObject.hasOwnProperty("trackingId") && !!mediaObject.trackingId)
                            this["trackingId"] = mediaObject["trackingId"];
                        if (mediaObject.hasOwnProperty("isAudioAd"))
                            this["isAudioAd"] = mediaObject["isAudioAd"];
                        if (mediaObject.hasOwnProperty("protectionState"))
                            this["protectionState"] = mediaObject["protectionState"];
                        if (mediaObject.hasOwnProperty("videoEncoding")) {
                            this["videoEncoding"] = mediaObject["videoEncoding"];
                            this["alternateVideoEncoding"] = null
                        }
                        else if (this.isVideo() && this.isPreview) {
                            this["videoEncoding"] = Microsoft.Entertainment.Marketplace.VideoEncoding.h264;
                            this["alternateVideoEncoding"] = Microsoft.Entertainment.Marketplace.VideoEncoding.vc1
                        }
                        if (this.isLocal && this.isMusicTrack() && !isSubscription) {
                            var protectionState = this["protectionState"];
                            if (protectionState === MS.Entertainment.Platform.Playback.ProtectionState.drmProtected) {
                                this["_errorDescriptor"] = {msExtendedCode: MS.Entertainment.Platform.Playback.Error.X8_E_PLAYBACK_FREESTREAMING_NO_RIGHTS.code};
                                MSEPlatform.Playback.Etw.traceString("MediaInstance_constructor : Free-streaming user trying to play protected content, setting error to 0xC1010094")
                            }
                            else if (protectionState === MS.Entertainment.Platform.Playback.ProtectionState.unknown) {
                                this["protectionState"] = MS.Entertainment.Platform.Playback.ProtectionState.unprotected;
                                MSEPlatform.Playback.Etw.traceString("MediaInstance_constructor : unknown protection state. We set to unprotected state")
                            }
                        }
                    }
                    this._initializedPromise = this._loadBookmarkAndPlayDataAsync(playFromBookmark);
                    this._maxPositionValueHolder = 0;
                    if (MS.Entertainment.ServiceLocator.isServiceRegistered(MS.Entertainment.Services.contentRestrictionService)) {
                        var contentRestrictionService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.contentRestrictionService);
                        this._ratedContentDescriptionPromise = contentRestrictionService.createRatedContentDescriptionFromMediaItemAsync(this._mediaItem && this._mediaItem.data, MS.Entertainment.Utilities.isMusicApp2)
                    }
                }, maxPosition: {
                    get: function MediaInstance__position_get() {
                        return this._maxPositionValueHolder
                    }, set: function MediaInstance__position_set(value) {
                            if (value > this._maxPositionValueHolder && !this._remoteTrackingMode)
                                this._maxPositionValueHolder = value
                        }
                }, _loadBookmarkAndPlayDataAsync: function MediaInstance_loadBookmarkAndPlayDataAsync(playFromBookmark) {
                    var provider = this._getProvider();
                    if (this.playlogEnabled && provider && this.libraryId && this.libraryId > 0) {
                        var getBookmarkAsync = provider.getBookmarkAsync(this.libraryId).then(function success(result) {
                                this._bookmark = result.value;
                                if (playFromBookmark)
                                    this.startPosition = this._bookmark;
                                return WinJS.Promise.wrap()
                            }.bind(this), function error() {
                                this._bookmark = 0;
                                MSEPlatform.Playback.Etw.traceString("MediaInstance_loadBookmarkAndPlayDataAsync : Failed to load bookmark");
                                return WinJS.Promise.wrap()
                            }.bind(this));
                        var getPlaycountAsync = provider.getPlaycountAsync(this.libraryId).then(function success(result) {
                                this._playcount = result.value;
                                return WinJS.Promise.wrap()
                            }.bind(this), function error() {
                                this._playcount = 0;
                                MSEPlatform.Playback.Etw.traceString("MediaInstance_loadBookmarkAndPlayDataAsync : Failed to load play count");
                                return WinJS.Promise.wrap()
                            }.bind(this));
                        var getPlayedStatusAsync = provider.getPlayedStatusAsync(this.libraryId).then(function success(result) {
                                this._played = result.value;
                                return WinJS.Promise.wrap()
                            }.bind(this), function error() {
                                this._played = 0;
                                MSEPlatform.Playback.Etw.traceString("MediaInstance_loadBookmarkAndPlayDataAsync : Failed to load played status");
                                return WinJS.Promise.wrap()
                            }.bind(this));
                        return WinJS.Promise.join([getBookmarkAsync, getPlaycountAsync, getPlayedStatusAsync]).then(function() {
                                return WinJS.Promise.wrap(this)
                            }.bind(this))
                    }
                    else
                        return WinJS.Promise.wrap(this)
                }, isEqual: function MediaInstance_isEqual(mediaInstance) {
                    var isSame = false;
                    if (mediaInstance && this.source === mediaInstance.source && this.mediaType === mediaInstance.mediaType && this.protectionState === mediaInstance.protectionState && this.startPosition === mediaInstance.startPosition && this.cookie === mediaInstance.cookie)
                        isSame = true;
                    return isSame
                }, toString: function MediaInstance_toString() {
                    var mediaString = this.source + " : " + this.mediaType + " : " + this.protectionState + " : " + this.startPosition + " : " + this.cookie;
                    return mediaString
                }, _getProvider: function _getProvider() {
                    if (!this._mediaStore)
                        this._mediaStore = new Microsoft.Entertainment.Platform.MediaStore;
                    if (this.mediaType === Microsoft.Entertainment.Queries.ObjectType.video)
                        return this._mediaStore.videoProvider;
                    else if (this.mediaType === Microsoft.Entertainment.Queries.ObjectType.track)
                        return this._mediaStore.trackProvider;
                    else
                        return null
                }, _getContainerProvider: function _getContainerProvider() {
                    if (!this._mediaStore)
                        this._mediaStore = new Microsoft.Entertainment.Platform.MediaStore;
                    switch (this.containerMediaType) {
                        case Microsoft.Entertainment.Queries.ObjectType.album:
                            return this._mediaStore.albumProvider;
                        case Microsoft.Entertainment.Queries.ObjectType.playlist:
                            return this._mediaStore.playlistProvider;
                        default:
                            return null
                    }
                }, _getBookmarkWatcher: function _getBookmarkWatcher() {
                    if (!this._bookmarkWatcher)
                        if (MS.Entertainment.ServiceLocator.isServiceRegistered(MS.Entertainment.Services.bookmarkOperationsWatcher))
                            this._bookmarkWatcher = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.bookmarkOperationsWatcher);
                    return this._bookmarkWatcher
                }, _getMediaItemProp: function MediaInstance_getMediaItemProp(name, defaultValue, validityCheckFunction) {
                    if (!name || typeof(name) !== "string" || name === String.empty)
                        throw new Error("Invalid property name.");
                    if (!validityCheckFunction || typeof(validityCheckFunction) !== "function")
                        throw new Error("Invalid validity check function.");
                    var result = this[name];
                    if (validityCheckFunction(result))
                        return result;
                    if (this._mediaItem) {
                        var result = this._mediaItem[name];
                        if (validityCheckFunction(result))
                            return result;
                        if (this._mediaItem.data) {
                            var result = this._mediaItem.data[name];
                            if (validityCheckFunction(result))
                                return result
                        }
                    }
                    return defaultValue
                }, isMovie: function MediaInstance_isMovie() {
                    var isType = false;
                    if (this._mediaItem)
                        isType = (this.mediaType === Microsoft.Entertainment.Queries.ObjectType.video && this._mediaItem.videoType === Microsoft.Entertainment.Queries.VideoType.movie);
                    return isType
                }, isTVEpisode: function MediaInstance_isTVEpisode() {
                    var isType = false;
                    if (this._mediaItem)
                        isType = (this.mediaType === Microsoft.Entertainment.Queries.ObjectType.video && this._mediaItem.videoType === Microsoft.Entertainment.Queries.VideoType.tvEpisode);
                    return isType
                }, isVideo: function MediaInstance_isVideo() {
                    return (this.mediaType === Microsoft.Entertainment.Queries.ObjectType.video)
                }, isMusicVideo: function MediaInstance_isMusicVideo() {
                    var isType = false;
                    if (this._mediaItem)
                        isType = (this.mediaType === Microsoft.Entertainment.Queries.ObjectType.video && this._mediaItem.videoType === Microsoft.Entertainment.Queries.VideoType.musicVideo);
                    return isType
                }, isMusicTrack: function MediaInstance_isMusicTrack() {
                    return (this.mediaType === Microsoft.Entertainment.Queries.ObjectType.track)
                }, isMusicAlbum: function MediaInstance_isMusicAlbum() {
                    return (this.mediaType === Microsoft.Entertainment.Queries.ObjectType.album)
                }, isGame: function MediaInstance_isGame() {
                    return (this.mediaType === Microsoft.Entertainment.Queries.ObjectType.game)
                }, isArtist: function MediaInstance_isArtist() {
                    var isType = false;
                    if (this._mediaItem)
                        isType = (this.mediaType === Microsoft.Entertainment.Queries.ObjectType.person && this._mediaItem.personType === Microsoft.Entertainment.Queries.PersonType.artist);
                    return isType
                }, isGenre: function MediaInstance_isGenre() {
                    return (this.mediaType === Microsoft.Entertainment.Queries.ObjectType.genre)
                }, isPlaylist: function MediaInstance_isPlaylist() {
                    return (this.mediaType === Microsoft.Entertainment.Queries.ObjectType.playlist)
                }, bookmark: {
                    set: function MediaInstance_setBookmark(newValue) {
                        this._bookmark = newValue;
                        if (this.libraryId && this.libraryId > 0) {
                            var provider = this._getProvider();
                            if (provider) {
                                var setBookmarkAsync = provider.setBookmarkAsync(this.libraryId, newValue).then(function success() {
                                        MSEPlatform.Playback.Etw.tracePlaylogBookmarkSave(newValue)
                                    }, function error() {
                                        MSEPlatform.Playback.Etw.traceString("MediaInstance_setBookmarkAsync : Failed to save bookmark")
                                    });
                                var bookmarkWatcher = this._getBookmarkWatcher();
                                if (bookmarkWatcher)
                                    bookmarkWatcher.registerOperation(setBookmarkAsync)
                            }
                        }
                    }, get: function MediaInstance_getBookmark() {
                            return this._bookmark
                        }
                }, played: {
                    set: function MediaInstance_setPlayed(newValue) {
                        this._played = newValue;
                        if (this.libraryId && this.libraryId > 0) {
                            var provider = this._getProvider();
                            var containerProvider = this._getContainerProvider();
                            var bookmarkWatcher = this._getBookmarkWatcher();
                            if (provider) {
                                var setPlayedStatusAsync = provider.setPlayedStatusAsync(this.libraryId, newValue).then(function success() {
                                        MSEPlatform.Playback.Etw.tracePlaylogPlayedSave(newValue)
                                    }, function error() {
                                        MSEPlatform.Playback.Etw.traceString("MediaInstance_setPlayedStatusAsync : Failed to save played status")
                                    });
                                if (bookmarkWatcher)
                                    bookmarkWatcher.registerOperation(setPlayedStatusAsync)
                            }
                            if (containerProvider) {
                                var setPlayedStatusAsync = containerProvider.setPlayedStatusAsync(this.containerLibraryId, newValue).then(function success() {
                                        MSEPlatform.Playback.Etw.tracePlaylogPlayedSave(newValue)
                                    }, function error() {
                                        MSEPlatform.Playback.Etw.traceString("MediaInstance_setPlayedStatusAsync : Failed to save played status on container")
                                    });
                                if (bookmarkWatcher)
                                    bookmarkWatcher.registerOperation(setPlayedStatusAsync)
                            }
                        }
                    }, get: function MediaInstance_getPlayed() {
                            return this._played
                        }
                }, playcount: {
                    set: function MediaInstance_setPlaycount(newValue) {
                        this._playcount = newValue;
                        if (this.libraryId && this.libraryId > 0) {
                            var provider = this._getProvider();
                            if (provider)
                                provider.setPlaycountAsync(this.libraryId, newValue).then(function success() {
                                    MSEPlatform.Playback.Etw.tracePlaylogPlayCountSave(newValue)
                                }, function error() {
                                    MSEPlatform.Playback.Etw.traceString("MediaInstance_setPlaycountAsync : Failed to save play count")
                                })
                        }
                    }, get: function MediaInstance_getPlaycount() {
                            return this._playcount
                        }
                }, serviceIdSafe: {get: function MediaInstance_getServiceId() {
                        return this._getMediaItemProp("serviceId", MS.Entertainment.Utilities.EMPTY_GUID, function(value) {
                                return !MS.Entertainment.Utilities.isEmptyGuid(value)
                            })
                    }}, mediaTypeSafe: {get: function MediaInstance_getMediaTypeSafe() {
                        return this._getMediaItemProp("mediaType", -1, function(value) {
                                return value !== -1
                            })
                    }}, shouldLogToDrmDownloadHistory: {get: function MediaInstance_shouldLogToDownloadHistory() {
                        if (this.nativeLicenseRight !== undefined && this.nativeLicenseRight !== null && this.nativeLicenseRight !== Microsoft.Entertainment.Marketplace.MarketplaceMediaRights.unknownMediaRight)
                            return this.nativeLicenseRight !== Microsoft.Entertainment.Marketplace.MarketplaceMediaRights.subscriptionDownload;
                        return this.mediaTypeSafe !== Microsoft.Entertainment.Queries.ObjectType.track
                    }}, fillDownloadSubscriptionInfoAsync: function fillDownloadSubscriptionInfoAsync() {
                    if ((!this.mediaInstanceId || MS.Entertainment.Utilities.isEmptyGuid(this.mediaInstanceId)) && this._mediaItem && this.mediaTypeSafe === Microsoft.Entertainment.Queries.ObjectType.track)
                        return MS.Entertainment.Platform.PurchaseHelpers.queryMediaDetailForCacheItemAsync(this._mediaItem, this.mediaTypeSafe).then(function queryMediaDetailForCacheItemAsync_complete(detail) {
                                if (detail.result && detail.result.item && detail.result.item.rights) {
                                    var right = MS.Entertainment.Platform.PurchaseHelpers.getPreferredRight(detail.result.item.rights, [Microsoft.Entertainment.Marketplace.MarketplaceMediaRights.subscriptionDownload]);
                                    if (right) {
                                        this.mediaInstanceId = right.mediaInstanceId;
                                        this.offerId = right.offerId;
                                        this.nativeLicenseRight = Microsoft.Entertainment.Marketplace.MarketplaceMediaRights.subscriptionDownload
                                    }
                                }
                            }.bind(this));
                    return WinJS.Promise.wrap()
                }
        }, {createInstanceAsync: function MediaInstance_CreateInstanceAsync(itemData) {
                var mediaInstance = new MSEPlatform.Playback.MediaInstance(itemData);
                return mediaInstance._initializedPromise
            }})})
})()
