﻿/* Copyright (C) Microsoft Corporation. All rights reserved. */
scriptValidator();
(function() {
    "use strict";
    WinJS.Namespace.define("MS.Entertainment.ViewModels.SmartAppbarActions", {
        defaultActions: {
            _defaultActions: null, get: function() {
                    if (!MS.Entertainment.ViewModels.SmartAppbarActions._defaultActions)
                        MS.Entertainment.ViewModels.SmartAppbarActions._defaultActions = [MS.Entertainment.UI.AppBarActions.openFile];
                    return MS.Entertainment.ViewModels.SmartAppbarActions._defaultActions
                }
        }, setDefaultGalleryEventHandlers: function setDefaultGalleryEventHandlers(clearSelectionCallback, removeCompleteCallback) {
                var eventHandlers = {};
                if (clearSelectionCallback) {
                    eventHandlers[MS.Entertainment.UI.AppBarActions.addToNowPlaying] = clearSelectionCallback;
                    eventHandlers[MS.Entertainment.UI.AppBarActions.addToPlaylist] = clearSelectionCallback;
                    eventHandlers[MS.Entertainment.UI.AppBarActions.artistDetails] = clearSelectionCallback;
                    eventHandlers[MS.Entertainment.UI.AppBarActions.clearSelection] = clearSelectionCallback;
                    eventHandlers[MS.Entertainment.UI.AppBarActions.exploreAlbum] = clearSelectionCallback;
                    eventHandlers[MS.Entertainment.UI.AppBarActions.playSelection] = clearSelectionCallback;
                    eventHandlers[MS.Entertainment.UI.AppBarActions.deleteMedia] = clearSelectionCallback;
                    eventHandlers[MS.Entertainment.UI.AppBarActions.deleteSeries] = clearSelectionCallback;
                    eventHandlers[MS.Entertainment.UI.AppBarActions.downloadFromMarketplace] = clearSelectionCallback;
                    eventHandlers[MS.Entertainment.UI.AppBarActions.downloadSeason] = clearSelectionCallback;
                    eventHandlers[MS.Entertainment.UI.AppBarActions.subscriptionDownload] = clearSelectionCallback;
                    eventHandlers[MS.Entertainment.UI.AppBarActions.tryDownloadAgain] = clearSelectionCallback;
                    eventHandlers[MS.Entertainment.UI.AppBarActions.renamePlaylist] = clearSelectionCallback
                }
                if (removeCompleteCallback) {
                    eventHandlers[MS.Entertainment.UI.AppBarActions.deleteMedia] = removeCompleteCallback;
                    eventHandlers[MS.Entertainment.UI.AppBarActions.deleteSeries] = removeCompleteCallback;
                    eventHandlers[MS.Entertainment.UI.AppBarActions.deletePlaylist] = removeCompleteCallback
                }
                return eventHandlers
            }, _appBarActions: null, getAppbarActions: function getAppbarActions() {
                if (MS.Entertainment.ViewModels.SmartAppbarActions._appBarActions)
                    return MS.Entertainment.ViewModels.SmartAppbarActions._appBarActions;
                MS.Entertainment.ViewModels.SmartAppbarActions._appBarActions = [MS.Entertainment.UI.Components.Shell.OpenFileAction.getOpenFileAction(), this.createNavigateBackAppbarAction(), this.createPlayAndShowNowPlayingAppbarAction(), this.createPlayDisabledAppbarAction(), this.createResumeAppbarAction(), this.createRestartAppbarAction(), this.createPlayTrailerAppbarAction(), this.createSeriesDetailsAppbarAction(), this.createSeasonDetailsAppbarAction(), this.createPlayOnXboxAppbarAction(), this.createGetOnXboxAction(), this.createPinToStartScreenAction(), this.createUnpinFromStartScreenAction(), this.createBuyEpisodeAppbarAction(), this.createBuySeasonAppbarAction(), this.createBuyCurrentSeasonAppbarAction(), this.createBuyVideoAppbarAction(), this.createRentVideoAppbarAction(), this.createDownloadFromMarketplaceAppbarAction(), this.createDownloadSeasonAppbarAction(), this.createTryDownloadAgainAppbarAction(), this.createShowDownloadManagerAppbarAction(), this.createRemoveAppbarAction(), this.createMovieDetailsAppbarAction(), this.createDeleteMediaAppbarAction(), this.createDeleteSeriesAppbarAction(), ];
                return MS.Entertainment.ViewModels.SmartAppbarActions._appBarActions
            }
    })
})()
