﻿/* Copyright (C) Microsoft Corporation. All rights reserved. */
(function() {
    "use strict";
    scriptValidator("/Framework/corefx.js", "/Framework/debug.js", "/Framework/utilities.js");
    MS.Entertainment.UI.Debug.defineAssert("MS.Entertainment.ViewModels.Video");
    var config = new Microsoft.Entertainment.Configuration.ConfigurationManager;
    MS.Entertainment.ViewModels.Video.assert(MS.Entertainment.appMode !== undefined, "File was loaded in startup path, this make slow down perf since we are creating a config object");
    if (MS.Entertainment.Utilities.isVideoApp1)
        WinJS.Namespace.define("MS.Entertainment.ViewModels.Video", {metaCriticTemplate: "/Components/Immersive/Video/TVImmersiveTemplates.html#metaCriticTemplate"});
    else
        WinJS.Namespace.define("MS.Entertainment.ViewModels.Video", {metaCriticTemplate: "/Components/Video2/TvDetailsPage.html#metaCriticTemplate"});
    WinJS.Namespace.define("MS.Entertainment.UI.Controls", {MetaCriticControl: MS.Entertainment.UI.Framework.defineUserControl(MS.Entertainment.ViewModels.Video.metaCriticTemplate, function MetaCriticControl(element) {
            this.clickHandlerWithContext = WinJS.Utilities.markSupportedForProcessing(this._onClick.bind(this))
        }, {
            controlName: "MetaCriticControl", allowAnimations: false, voicePhrase: "metacritic", clickHandlerWithContext: null, _metaCriticScoreDomElement: null, _mediaItemBindings: null, initialize: function initialize() {
                    this._mediaItemBindings = WinJS.Binding.bind(this, {mediaItem: this._onMediaItemChanded.bind(this)})
                }, unload: function unload() {
                    if (this._mediaItemBindings) {
                        this._mediaItemBindings.cancel();
                        this._mediaItemBindings = null
                    }
                    MS.Entertainment.UI.Framework.UserControl.prototype.unload.call(this)
                }, _onMediaItemChanded: function _onMediaItemChanded() {
                    var featureEnablement = new Microsoft.Entertainment.FeatureEnablement.FeatureEnablement;
                    this.visible = (featureEnablement.isEnabled(Microsoft.Entertainment.FeatureEnablement.FeatureItem.metaCritic) && this.mediaItem && this.mediaItem.criticReview && this.mediaItem.criticReview.reviewScore >= 0);
                    if (this.visible) {
                        this._updateColor = this._updateColor.bind(this);
                        this._onClick = this._onClick.bind(this);
                        this._updateColor()
                    }
                    this._setControlFocusability()
                }, _setControlFocusability: function _setControlFocusability() {
                    if (!this._metaCriticControl)
                        return;
                    if (this.visible && MS.Entertainment.Utilities.isApp1) {
                        WinJS.Utilities.addClass(this._metaCriticControl, "win-focusable");
                        WinJS.Utilities.addClass(this._metaCriticControl, "acc-keyboardFocusTarget")
                    }
                }, _onKeyDown: function _onKeyDown(event) {
                    if (event.keyCode === WinJS.Utilities.Key.enter || event.keyCode === WinJS.Utilities.Key.space || event.keyCode === WinJS.Utilities.Key.invokeButton)
                        this._onClick()
                }, _onClick: function onClick() {
                    if (this.mediaItem && this.mediaItem.criticReview && this.mediaItem.criticReview.url && MS.Entertainment.Utilities.verifyUrl(this.mediaItem.criticReview.url))
                        Windows.System.Launcher.launchUriAsync(new Windows.Foundation.Uri(this.mediaItem.criticReview.url))
                }, _updateColor: function updateColor() {
                    if (this.mediaItem && this.mediaItem.criticReview && this.mediaItem.criticReview.reviewScore >= 0 && this._metaCriticScoreDomElement) {
                        WinJS.Utilities.removeClass(this._metaCriticScoreDomElement, "metaCritic-red");
                        WinJS.Utilities.removeClass(this._metaCriticScoreDomElement, "metaCritic-yellow");
                        WinJS.Utilities.removeClass(this._metaCriticScoreDomElement, "metaCritic-green");
                        if (this.mediaItem.criticReview.reviewScore < 40)
                            WinJS.Utilities.addClass(this._metaCriticScoreDomElement, "metaCritic-red");
                        else if (this.mediaItem.criticReview.reviewScore < 61)
                            WinJS.Utilities.addClass(this._metaCriticScoreDomElement, "metaCritic-yellow");
                        else if (this.mediaItem.criticReview.reviewScore <= 100)
                            WinJS.Utilities.addClass(this._metaCriticScoreDomElement, "metaCritic-green")
                    }
                }
        }, {
            visible: false, mediaItem: null
        })})
})()
