﻿/* Copyright (C) Microsoft Corporation. All rights reserved. */
scriptValidator("/Framework/corefx.js");
(function() {
    "use strict";
    MS.Entertainment.UI.Debug.defineAssert("MS.Entertainment.Pages");
    WinJS.Namespace.define("MS.Entertainment.Pages", {ContentNotificationList: MS.Entertainment.UI.Framework.defineUserControl("Components/Shell/ContentNotificationList.html#contentNotificationListTemplate", null, null, {source: null})});
    WinJS.Namespace.define("MS.Entertainment.Pages", {ContentNotificationTileItem: MS.Entertainment.UI.Framework.defineUserControl(null, function contentNotificationTileItemConstructor(element, options){}, {
            _bindings: null, _hasDelayedInitialized: false, _contentNotifications: null, _alternateText: String.empty, _alternateIcon: String.empty, _useAlternateTextStyle: null, _mediaItem: null, _pendingContentNotifications: null, defaultTextStyle: String.empty, alternateTextStyle: String.empty, hideIfEmpty: false, hideSiblingsIfNotEmpty: false, controlName: "contentNotificationTileItem", _delayInitialized: function _delayInitialized() {
                    if (!this._unloaded) {
                        this._hasDelayedInitialized = true;
                        this._findNotificationForDisplay = this._findNotificationForDisplay.bind(this);
                        this._displayedShortNotificationUpdated = this._displayedShortNotificationUpdated.bind(this);
                        this._displayedLongNotificationUpdated = this._displayedLongNotificationUpdated.bind(this);
                        this._displayedIconNotificationUpdated = this._displayedIconNotificationUpdated.bind(this);
                        this._commitContentNotifications();
                        this._commitAlternateIcon();
                        this._commitAlternateText()
                    }
                }, unload: function unload() {
                    this.contentNotifications = null;
                    this.displayedNotification = null;
                    MS.Entertainment.UI.Framework.UserControl.prototype.unload.call(this)
                }, mediaItem: {
                    get: function get_mediaItem() {
                        return this._mediaItem
                    }, set: function set_mediaItem(value) {
                            this._mediaItem = value;
                            if (MS.Entertainment.UI.FileTransferService)
                                MS.Entertainment.UI.FileTransferService.pulseAsync(this._mediaItem)
                        }
                }, _isEmpty: function _isEmpty() {
                    var i,
                        item;
                    var notifications = this.contentNotifications;
                    var empty = true;
                    if (!notifications)
                        return true;
                    for (i = 0; i < notifications.length; i++) {
                        item = WinJS.Binding.unwrap(notifications).item(i);
                        if (this.checkItem(item)) {
                            if (item !== this._displayedNotification)
                                this.displayedNotification = item;
                            empty = false;
                            break
                        }
                    }
                    return empty
                }, _findNotificationForDisplay: function _findNotificationForDisplay() {
                    if (this._unloaded)
                        return;
                    var empty = this._isEmpty();
                    if (empty)
                        this.displayedNotification = null;
                    if (empty && this.hideIfEmpty)
                        WinJS.Utilities.addClass(this.domElement, "removeFromDisplay");
                    else
                        WinJS.Utilities.removeClass(this.domElement, "removeFromDisplay");
                    var siblings = null;
                    if (this.domElement.parentElement && this.hideSiblingsIfNotEmpty)
                        siblings = this.domElement.parentElement.children;
                    if (siblings) {
                        var currentSibling;
                        for (var i = 0; i < siblings.length; i++) {
                            currentSibling = siblings[i];
                            if (currentSibling !== this.domElement)
                                if (!empty)
                                    WinJS.Utilities.addClass(currentSibling, "removeFromDisplaySecondary");
                                else
                                    WinJS.Utilities.removeClass(currentSibling, "removeFromDisplaySecondary")
                        }
                    }
                }, checkItem: function checkItem(item) {
                    return true
                }, contentNotifications: {
                    get: function get_contentNotifications() {
                        return this._pendingContentNotifications || this._contentNotifications
                    }, set: function set_contentNotifications(value) {
                            if (value !== this._pendingContentNotifications) {
                                this._pendingContentNotifications = value;
                                this._commitContentNotifications()
                            }
                        }
                }, alternateText: {
                    get: function get_alternateText() {
                        return this._alternateText
                    }, set: function set_alternateText(value) {
                            if (value !== this._alternateText) {
                                this._alternateText = value;
                                this._commitAlternateText()
                            }
                        }
                }, alternateIcon: {
                    get: function get_alternateIcon() {
                        return this._alternateIcon
                    }, set: function set_alternateIcon(value) {
                            if (value !== this._alternateIcon) {
                                this._alternateIcon = value;
                                this._commitAlternateIcon()
                            }
                        }
                }, useAlternateTextStyle: {
                    set: function setUseAlternateTextStyle(value) {
                        if (this._useAlternateTextStyle === value)
                            return;
                        if (value) {
                            if (this.defaultTextStyle)
                                WinJS.Utilities.removeClass(this.domElement, this.defaultTextStyle);
                            if (this.alternateTextStyle)
                                WinJS.Utilities.addClass(this.domElement, this.alternateTextStyle)
                        }
                        else {
                            if (this.alternateTextStyle)
                                WinJS.Utilities.removeClass(this.domElement, this.alternateTextStyle);
                            if (this.defaultTextStyle)
                                WinJS.Utilities.addClass(this.domElement, this.defaultTextStyle)
                        }
                        this._useAlternateTextStyle = value
                    }, get: function getUseAlternateTextStyle() {
                            return this._useAlternateTextStyle
                        }
                }, displayedDefaultShortNotificationUpdated: function displayedDefaultShortNotificationUpdated() {
                    this.useAlternateTextStyle = !!this.alternateText;
                    this._displayedShortNotificationUpdated(this.alternateText || String.empty)
                }, displayedDefaultLongNotificationUpdated: function displayedDefaultLongNotificationUpdated() {
                    this.useAlternateTextStyle = !!this.alternateText;
                    this._displayedLongNotificationUpdated(this.alternateText || String.empty)
                }, displayedDefaultIconNotificationUpdated: function displayedDefaultIconNotificationUpdated() {
                    this._displayedIconNotificationUpdated(this.alternateIcon || String.empty)
                }, displayedNotification: {
                    get: function get_displayedNotification() {
                        return this._displayedNotification
                    }, set: function set_displayedNotification(value) {
                            if (value !== this._displayedNotification) {
                                this._displayedNotification = value;
                                this._commitDisplayedNotification()
                            }
                        }, enumerable: false
                }, _commitDisplayedNotification: function _commitDisplayNotification() {
                    if (this._hasDelayedInitialized) {
                        if (this._bindings) {
                            this._bindings.cancel();
                            this._bindings = null
                        }
                        this.useAlternateTextStyle = !this._displayedNotification;
                        if (this._displayedNotification)
                            this._bindings = WinJS.Binding.bind(this, {_displayedNotification: {
                                    shortText: this._displayedShortNotificationUpdated, longText: this._displayedLongNotificationUpdated, icon: this._displayedIconNotificationUpdated
                                }});
                        else {
                            this.displayedDefaultShortNotificationUpdated();
                            this.displayedDefaultLongNotificationUpdated();
                            this.displayedDefaultIconNotificationUpdated()
                        }
                    }
                }, _commitAlternateIcon: function _commitAlternateIcon() {
                    if (this._hasDelayedInitialized && !this.displayedNotification)
                        this.displayedDefaultIconNotificationUpdated()
                }, _commitAlternateText: function _commitAlternateText() {
                    if (!this.displayedNotification) {
                        this.displayedDefaultShortNotificationUpdated();
                        this.displayedDefaultLongNotificationUpdated()
                    }
                }, _commitContentNotifications: function _commitContentNotifications() {
                    if (this._hasDelayedInitialized && this._pendingContentNotifications !== this._contentNotifications) {
                        if (this._contentNotifications)
                            this._contentNotifications.removeChangeListener(this._findNotificationForDisplay);
                        this._contentNotifications = this._pendingContentNotifications;
                        if (this._contentNotifications) {
                            this._contentNotifications.addChangeListener(this._findNotificationForDisplay);
                            this._findNotificationForDisplay()
                        }
                    }
                }, _displayedNotification: null, _displayedShortNotificationUpdated: function _displayedShortNotificationUpdated(newValue){}, _displayedLongNotificationUpdated: function _displayedLongNotificationUpdated(newValue){}, _displayedIconNotificationUpdated: function _displayedIconNotificationUpdated(newValue){}
        }, {})});
    WinJS.Namespace.define("MS.Entertainment.Pages", {ContentNotificationShortTextTileItem: MS.Entertainment.UI.Framework.deriveUserControl("MS.Entertainment.Pages.ContentNotificationTileItem", null, function contentNotificationShortTextTileItem(){}, {
            controlName: "contentNotificationShortTextTileItem", checkItem: function checkItem(item) {
                    return item.shortText
                }, _displayedShortNotificationUpdated: function _displayedShortNotificationUpdated(newValue) {
                    if (!this._unloaded)
                        this.domElement.textContent = newValue
                }
        })});
    WinJS.Namespace.define("MS.Entertainment.Pages", {ContentNotificationShortTextTileItemWithRentalExpiration: MS.Entertainment.UI.Framework.deriveUserControl("MS.Entertainment.Pages.ContentNotificationShortTextTileItem", null, function contentNotificationShortTextTileItemWithRentalExpiration(){}, {
            controlName: "contentNotificationShortTextTileItemWithRentalExpiration", _expirationTickTimer: null, _expirationString: null, _mediaItem: null, _playbackSessionBindings: null, _uiStateEventHandler: null, _ingestingPurchaseHistoryChangedHandler: null, unload: function unload() {
                    if (this._expirationTickTimer) {
                        window.clearTimeout(this._expirationTickTimer);
                        this._expirationTickTimer = null
                    }
                    if (this._playbackSessionBindings) {
                        this._playbackSessionBindings.cancel();
                        this._playbackSessionBindings = null
                    }
                    if (this._ingestingPurchaseHistoryChangedHandler) {
                        var purchaseHistoryService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.purchaseHistory);
                        if (purchaseHistoryService && this._ingestingPurchaseHistoryChangedHandler) {
                            purchaseHistoryService.unbind("isGroveling", this._ingestingPurchaseHistoryChangedHandler);
                            this._ingestingPurchaseHistoryChangedHandler = null
                        }
                    }
                    MS.Entertainment.Pages.ContentNotificationShortTextTileItem.prototype.unload.call(this)
                }, mediaItem: {
                    get: function get_mediaItem() {
                        return this._mediaItem
                    }, set: function set_mediaItem(value) {
                            this._mediaItem = value;
                            if (MS.Entertainment.Utilities.isVideoApp && this._mediaItem && this._mediaItem.mediaType === Microsoft.Entertainment.Queries.ObjectType.video && this._mediaItem.videoType === Microsoft.Entertainment.Queries.VideoType.movie && this.mediaItem.inCollection) {
                                this._bindIngestingPurchaseHistoryChangedHandler();
                                this.getExpirationDate()
                            }
                            if (MS.Entertainment.UI.FileTransferService)
                                MS.Entertainment.UI.FileTransferService.pulseAsync(this._mediaItem)
                        }
                }, getExpirationDate: function getExpirationDate() {
                    if (this._uiStateEventHandler) {
                        this._uiStateEventHandler.cancel();
                        this._uiStateEventHandler = null
                    }
                    if (MS.Entertainment.ServiceLocator.isServiceRegistered(MS.Entertainment.Services.sessionManager))
                        MS.Entertainment.ViewModels.SmartBuyStateEngine.queryMediaStateAsync(this.mediaItem).then(function checkMediaExpiration(stateInfo) {
                            if (stateInfo && stateInfo.marketplace && stateInfo.marketplace.rentalExpirations && stateInfo.marketplace.rentalExpirations.length > 0 && (stateInfo.marketplace.rentalExpirations.overall.latestDate || stateInfo.marketplace.rentalExpirations.overall.isExpired)) {
                                if (!this._playbackSessionBindings) {
                                    var completePromise = function completePromise(newValue) {
                                            if (newValue === MS.Entertainment.Platform.Playback.TransportState.playing)
                                                this.getExpirationDate()
                                        }.bind(this);
                                    var sessionMgr = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.sessionManager);
                                    this._playbackSessionBindings = WinJS.Binding.bind(sessionMgr.primarySession, {
                                        currentTransportState: completePromise.bind(this), playerState: completePromise.bind(this)
                                    })
                                }
                                if (this._expirationTickTimer) {
                                    window.clearTimeout(this._expirationTickTimer);
                                    this._expirationTickTimer = null
                                }
                                MS.Entertainment.UI.RentalExpirationService.getExpirationString(this.mediaItem, stateInfo.marketplace.rentalExpirations.overall.latestDate, this.updateExpirationString.bind(this))
                            }
                        }.bind(this));
                    else
                        this._uiStateEventHandler = MS.Entertainment.Utilities.addEventHandlers(MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.uiState), {stageThreeActivatedChanged: function stageThreeActivatedChanged(e) {
                                if (e.detail.newValue && !this._unloaded) {
                                    this._bindIngestingPurchaseHistoryChangedHandler();
                                    this.getExpirationDate()
                                }
                            }.bind(this)})
                }, _bindIngestingPurchaseHistoryChangedHandler: function _bindIngestingPurchaseHistoryChangedHandler() {
                    if (!this._ingestingPurchaseHistoryChangedHandler && MS.Entertainment.ServiceLocator.isServiceRegistered(MS.Entertainment.Services.purchaseHistory)) {
                        var purchaseHistoryService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.purchaseHistory);
                        if (purchaseHistoryService && purchaseHistoryService.isUsingXdlcForIngestion()) {
                            this._ingestingPurchaseHistoryChangedHandler = this._ingestingPurchaseHistoryChanged.bind(this);
                            purchaseHistoryService.bind("isGroveling", this._ingestingPurchaseHistoryChangedHandler)
                        }
                    }
                }, _ingestingPurchaseHistoryChanged: function _ingestingPurchaseHistoryChanged(isIngesting) {
                    var purchaseHistoryService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.purchaseHistory);
                    if (purchaseHistoryService && purchaseHistoryService.hasGrovelEverCompleted)
                        this.getExpirationDate()
                }, _isEmpty: function _isEmpty() {
                    var empty = !this.expirationString;
                    if (empty)
                        empty = MS.Entertainment.Pages.ContentNotificationTileItem.prototype._isEmpty.call(this);
                    return empty
                }, updateExpirationString: function updateExpirationString(spanInMilliseconds, expirationTickTimer) {
                    this._expirationTickTimer = expirationTickTimer;
                    if (spanInMilliseconds < MS.Entertainment.Formatters.milliSecondsFromTimeSpan(4))
                        this.expirationString = MS.Entertainment.Formatters.formatRentalExpirationFromSpanInt(spanInMilliseconds);
                    else
                        this.expirationString = String.empty;
                    this._findNotificationForDisplay()
                }, expirationString: {
                    get: function get_expirationString() {
                        return this._expirationString
                    }, set: function set_expirationString(value) {
                            this._expirationString = value;
                            if (!this.displayedNotification) {
                                this.displayedDefaultShortNotificationUpdated();
                                this.displayedDefaultLongNotificationUpdated()
                            }
                        }
                }, displayedDefaultShortNotificationUpdated: function displayedDefaultShortNotificationUpdated() {
                    this.useAlternateTextStyle = !this.expirationString;
                    this._displayedShortNotificationUpdated(this.expirationString || this.alternateText || String.empty)
                }, displayedDefaultLongNotificationUpdated: function displayedDefaultLongNotificationUpdated() {
                    this.useAlternateTextStyle = !this.expirationString;
                    this._displayedLongNotificationUpdated(this.expirationString || this.alternateText || String.empty)
                }, _displayedShortNotificationUpdated: function _displayedShortNotificationUpdated(newValue) {
                    if (!this._unloaded)
                        this.domElement.textContent = newValue
                }
        })});
    WinJS.Namespace.define("MS.Entertainment.Pages", {ContentNotificationIconTileItem: MS.Entertainment.UI.Framework.deriveUserControl("MS.Entertainment.Pages.ContentNotificationTileItem", null, function contentNotificationIconTileItem(){}, {
            _mediaItem: null, controlName: "contentNotificationIconTileItem", checkItem: function checkItem(item) {
                    return item.icon
                }, _delayInitialized: function delayInitialized() {
                    MS.Entertainment.Pages.ContentNotificationTileItem.prototype._delayInitialized.call(this);
                    this._commitMediaItem()
                }, mediaItem: {
                    get: function get_mediaItem() {
                        return this._mediaItem
                    }, set: function set_mediaItem(value) {
                            if (value !== this._mediaItem) {
                                this._mediaItem = value;
                                this._commitMediaItem()
                            }
                        }
                }, _commitMediaItem: function _commitMediaItem() {
                    if (!this._unloaded && this._hasDelayedInitialized) {
                        if (this._mediaItem)
                            this.contentNotifications = this._mediaItem.contentNotifications;
                        MS.Entertainment.UI.FileTransferService.pulseAsync(this._mediaItem)
                    }
                }, _displayedIconNotificationUpdated: function _displayedIconNotificationUpdated(newValue) {
                    MS.Entertainment.Pages.assert(!newValue || (newValue.length === 1), "Expected single icon character.");
                    if (!this._unloaded)
                        this.domElement.textContent = newValue
                }
        })})
})()
