﻿/* Copyright (C) Microsoft Corporation. All rights reserved. */
(function() {
    "use strict";
    scriptValidator();
    MS.Entertainment.UI.Debug.defineAssert("MS.Entertainment.Platform.PurchaseHelpers");
    WinJS.Namespace.define("MS.Entertainment.Platform.PurchaseHelpers", {
        CONSOLE_TARGET: "XBox", PC_TARGET: "X8", METRO_TARGET: "Windows", PURCHASE_TYPE_RENT: "Rent", PURCHASE_TYPE_BUY: "Buy", AVATAR_TYPE: "AvatarItem", PDLC_TYPE: "PDLCItem", GAME_ADDON_TYPE: "GameAddon", GAME_DEMO_TYPE: "GameDemo", GAME_VIDEO_TYPE: "GameVideo", GAMER_PICTURE_TYPE: "GamerPic", GAME_THEME_TYPE: "Theme", METRO_GAME_CONSUMABLE: "MetroGameConsumable", METRO_GAME_CONTENT: "MetroGameContent", METRO_GAME_ID: 62, METRO_AVATAR_ITEM_ID: 47, METRO_GAME_CONTENT_ID: 63, METRO_GAME_CONSUMABLE_ID: 64, XBOX_GAME_CONTENT: "Xbox360GameContent", XBOX_GAME: "Xbox360Game", XBOX_GAME_TRIAL: "XboxGameTrial", XBOX_GAME_DEMO: "Xbox360GameDemo", XBOX_THEME: "XboxTheme", XBOX_GAMER_TILE: "XboxGamerTile", XBOX_GAME_VIDEO: "XboxGameVideo", XBOX_GAME_TRAILER: "XboxGameTrailer", XBOX_GAME_CONTENT_ID: 18, XBOX_GAME_ID: 1, XBOX_ARCADE_ID: 23, XBOX_INDIE_ID: 37, XBOX_GAME_TRIAL_ID: 5, XBOX_GAME_DEMO_ID: 19, XBOX_THEME_ID: 20, XBOX_GAMER_TILE_ID: 22, XBOX_GAME_VIDEO_ID: 30, GAME_TYPE: "Game", MOVIE_TYPE: "Movie", TV_EPISODE_TYPE: "TVEpisode", TV_SEASON_TYPE: "TVSeason", ALBUM_TYPE: "Album", TRACK_TYPE: "Track", WATCH_ON_CONSOLE_TARGET: "360", WATCH_ON_PC_TARGET: "X8", DELIVERY_FORMAT_STREAMING: "Streaming", ERROR_CONTENT_ALREADY_OWNED: "CONTENT_ALREADY_OWNED", ERROR_SIGN_IN_FAILED: "SIGN_IN_FAILED", SUCCESS: "SUCCESS", FAILURE: "FAILURE", ERROR_BLOCK_PURCHASE: "BLOCK_PURCHASE", ERROR_NO_PURCHASE_FLOW_PROVIDER: "NO_PURCHASE_FLOW_PROVIDER", ERROR_NO_PURCHASE_FLOW_EXP: "NO_PURCHASE_FLOW_EXP", LicenseRightMap: {
                _scriptLicenseRights: null, _delayLoadScriptLicenseRights: function _delayLoadScriptLicenseRights() {
                        if (!MS.Entertainment.Platform.PurchaseHelpers.LicenseRightMap._scriptLicenseRights)
                            MS.Entertainment.Platform.PurchaseHelpers.LicenseRightMap._scriptLicenseRights = [MS.Entertainment.ViewModels.SmartBuyStateHandlers.MarketplaceRight.Preview, MS.Entertainment.ViewModels.SmartBuyStateHandlers.MarketplaceRight.Stream, MS.Entertainment.ViewModels.SmartBuyStateHandlers.MarketplaceRight.Subscription, MS.Entertainment.ViewModels.SmartBuyStateHandlers.MarketplaceRight.Purchase, MS.Entertainment.ViewModels.SmartBuyStateHandlers.MarketplaceRight.AlbumPurchase, MS.Entertainment.ViewModels.SmartBuyStateHandlers.MarketplaceRight.SubscriptionFree, MS.Entertainment.ViewModels.SmartBuyStateHandlers.MarketplaceRight.TransferToPortableDevice, MS.Entertainment.ViewModels.SmartBuyStateHandlers.MarketplaceRight.Rent, MS.Entertainment.ViewModels.SmartBuyStateHandlers.MarketplaceRight.PurchaseStream, MS.Entertainment.ViewModels.SmartBuyStateHandlers.MarketplaceRight.RentStream, MS.Entertainment.ViewModels.SmartBuyStateHandlers.MarketplaceRight.PreviewStream, MS.Entertainment.ViewModels.SmartBuyStateHandlers.MarketplaceRight.Trial, MS.Entertainment.ViewModels.SmartBuyStateHandlers.MarketplaceRight.SeasonPurchase, MS.Entertainment.ViewModels.SmartBuyStateHandlers.MarketplaceRight.SeasonPurchaseStream, MS.Entertainment.ViewModels.SmartBuyStateHandlers.MarketplaceRight.FreeStream, MS.Entertainment.ViewModels.SmartBuyStateHandlers.MarketplaceRight.Download, ]
                    }, toNative: function toNative(licenseRight) {
                        if (typeof(licenseRight) === "number")
                            return licenseRight;
                        if (typeof(licenseRight) !== "string")
                            return Microsoft.Entertainment.Marketplace.MarketplaceMediaRights.unknownMediaRight;
                        MS.Entertainment.Platform.PurchaseHelpers.LicenseRightMap._delayLoadScriptLicenseRights();
                        return MS.Entertainment.Platform.PurchaseHelpers.LicenseRightMap._scriptLicenseRights.indexOf(licenseRight)
                    }, toScript: function toScript(licenseRight) {
                        if (typeof(licenseRight) === "string")
                            return licenseRight;
                        MS.Entertainment.Platform.PurchaseHelpers.LicenseRightMap._delayLoadScriptLicenseRights();
                        if (typeof(licenseRight) !== "number" || licenseRight < 0 || licenseRight >= MS.Entertainment.Platform.PurchaseHelpers.LicenseRightMap._scriptLicenseRights.length)
                            return null;
                        return MS.Entertainment.Platform.PurchaseHelpers.LicenseRightMap._scriptLicenseRights[licenseRight]
                    }, ModernLicenseRight: {
                        Invalid: 0, AlbumPurchase: 100, Download: 200, FreeStream: 300, FreeStreamLimitExceeded: 301, Preview: 400, PreviewStream: 500, Purchase: 600, PurchaseStream: 700, Rent: 800, RentStream: 900, Root: 1000, SeasonPurchase: 1100, SeasonPurchaseStream: 1200, Stream: 1300, Subscription: 1400, SubscriptionFree: 1500, TakeDown: 1600, TransferToPortableDevice: 1700, Trial: 1800
                    }, fromModernToNative: function fromModernToNative(licenseRight) {
                        var LicenseRightMap = MS.Entertainment.Platform.PurchaseHelpers.LicenseRightMap;
                        var MarketplaceRight = MS.Entertainment.ViewModels.SmartBuyStateHandlers.MarketplaceRight;
                        switch (licenseRight) {
                            case LicenseRightMap.ModernLicenseRight.AlbumPurchase:
                                return LicenseRightMap.toNative(MarketplaceRight.AlbumPurchase);
                            case LicenseRightMap.ModernLicenseRight.Download:
                                return LicenseRightMap.toNative(MarketplaceRight.Download);
                            case LicenseRightMap.ModernLicenseRight.FreeStream:
                                return LicenseRightMap.toNative(MarketplaceRight.FreeStream);
                            case LicenseRightMap.ModernLicenseRight.Preview:
                                return LicenseRightMap.toNative(MarketplaceRight.Preview);
                            case LicenseRightMap.ModernLicenseRight.PreviewStream:
                                return LicenseRightMap.toNative(MarketplaceRight.PreviewStream);
                            case LicenseRightMap.ModernLicenseRight.Purchase:
                                return LicenseRightMap.toNative(MarketplaceRight.Purchase);
                            case LicenseRightMap.ModernLicenseRight.PurchaseStream:
                                return LicenseRightMap.toNative(MarketplaceRight.PurchaseStream);
                            case LicenseRightMap.ModernLicenseRight.Rent:
                                return LicenseRightMap.toNative(MarketplaceRight.Rent);
                            case LicenseRightMap.ModernLicenseRight.RentStream:
                                return LicenseRightMap.toNative(MarketplaceRight.RentStream);
                            case LicenseRightMap.ModernLicenseRight.SeasonPurchase:
                                return LicenseRightMap.toNative(MarketplaceRight.SeasonPurchase);
                            case LicenseRightMap.ModernLicenseRight.SeasonPurchaseStream:
                                return LicenseRightMap.toNative(MarketplaceRight.SeasonPurchaseStream);
                            case LicenseRightMap.ModernLicenseRight.Stream:
                                return LicenseRightMap.toNative(MarketplaceRight.Stream);
                            case LicenseRightMap.ModernLicenseRight.Subscription:
                                return LicenseRightMap.toNative(MarketplaceRight.Subscription);
                            case LicenseRightMap.ModernLicenseRight.SubscriptionFree:
                                return LicenseRightMap.toNative(MarketplaceRight.SubscriptionFree);
                            case LicenseRightMap.ModernLicenseRight.TransferToPortableDevice:
                                return LicenseRightMap.toNative(MarketplaceRight.TransferToPortableDevice);
                            case LicenseRightMap.ModernLicenseRight.Trial:
                                return LicenseRightMap.toNative(MarketplaceRight.Trial);
                            case LicenseRightMap.ModernLicenseRight.Invalid:
                            case LicenseRightMap.ModernLicenseRight.FreeStreamLimitExceeded:
                            case LicenseRightMap.ModernLicenseRight.Root:
                            case LicenseRightMap.ModernLicenseRight.TakeDown:
                            default:
                                throw new Error("Unsupported license right.");
                        }
                    }
            }, Error: {
                NS_E_EXPLICIT_CONTENT_DOWNLOAD_BLOCKED: (0xC00D1393 - 0xFFFFFFFF - 1), NS_E_ERROR_CANCELLED_HR_FROM_WIN32: (0x800704c7 - 0xFFFFFFFF - 1)
            }, displayPurchaseBlockingDialog: function displayPurchaseBlockingDialog(mediaItem) {
                if (!MS.Entertainment.Utilities.isVideoApp)
                    return WinJS.Promise.wrap(false);
                if (MS.Entertainment.ServiceLocator.isServiceRegistered(MS.Entertainment.Services.purchaseHistory)) {
                    var purchaseHistoryService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.purchaseHistory);
                    if (purchaseHistoryService.inPurchaseFlow)
                        return WinJS.Promise.wrap(true)
                }
                MS.Entertainment.assert(mediaItem, "PurchaseHelpers: Invalid mediaItem passed into displayPurchaseBlockingDialog");
                if (MS.Entertainment.Utilities.isVideoApp2 && !MS.Entertainment.isAppModeOverride && !MS.Entertainment.Utilities.supportsProtectedContent) {
                    var msgBox = new Windows.UI.Popups.MessageDialog(String.load(String.id.IDS_VIDEO2_PURCHASE_WARNING_BODY), String.load(String.id.IDS_VIDEO2_PURCHASE_WARNING_TITLE));
                    msgBox.commands.append(new Windows.UI.Popups.UICommand(String.load(String.id.IDS_CANCEL_BUTTON), null, String.id.IDS_CANCEL_BUTTON));
                    msgBox.defaultCommandIndex = 0;
                    msgBox.cancelCommandIndex = 0;
                    return msgBox.showAsync().then(function onDialogDismissed(result) {
                            return WinJS.Promise.wrap(true)
                        })
                }
                var configurationManager = new Microsoft.Entertainment.Configuration.ConfigurationManager;
                var purchaseHistoryService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.purchaseHistory);
                var signIn = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signIn);
                var signedInSignal = new MS.Entertainment.UI.Framework.Signal;
                var signedInBindings;
                var signInPromise;
                if (!configurationManager.service.blockVideoPurchasesDuringGrovel)
                    return WinJS.Promise.wrap(false);
                if (signIn.isSigningIn) {
                    signedInBindings = WinJS.Binding.bind(signIn, {isSignedIn: function onSignedIn() {
                            if (!signedInBindings)
                                return;
                            signedInBindings.cancel();
                            signedInBindings = null;
                            signedInSignal.complete()
                        }});
                    signInPromise = signedInSignal.promise
                }
                else
                    signInPromise = signIn.signIn();
                return signInPromise.then(function onSignInComplete(value) {
                        var successfulSignIn = signIn.isSignedIn && !signIn.isSigningOut;
                        var showRegionMismatchDialog = false;
                        var navigationService = MS.Entertainment.Utilities.isVideoApp2 && MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.navigation);
                        if (MS.Entertainment.Utilities.isVideoApp2)
                            showRegionMismatchDialog = successfulSignIn && !MS.Entertainment.Utilities.appRegionMatchesMachineRegion();
                        if (showRegionMismatchDialog)
                            return MS.Entertainment.UI.Shell.showMessageBox(String.load(String.id.IDS_VIDEO2_REGION_WARNING_TITLE), String.load(String.id.IDS_VIDEO2_REGION_WARNING_BODY), {dismissOnNavigateDelay: 30000}).then(function onDialogDismissed() {
                                    return {regionBlocked: true}
                                });
                        else if (navigationService && navigationService.checkUserLocation(MS.Entertainment.UI.Monikers.root))
                            return WinJS.Promise.wrap({navigatedAway: true});
                        else if (successfulSignIn)
                            return this._getDatabaseAndServiceRights(mediaItem).then(function onComplete(completed) {
                                    if (!completed)
                                        return WinJS.Promise.wrapError(new Error("Invalid result returned from promise chain"));
                                    var servicePurchaseRights = 0;
                                    var serviceRentalRights = 0;
                                    var aggregatedResults = {
                                            isFullyOwnedInDb: false, isFullyOwnedInCloud: false
                                        };
                                    var completedPromiseDbRights = completed.databaseRights;
                                    aggregatedResults.isFullyOwnedInDb = completedPromiseDbRights.canPurchaseDownload || completedPromiseDbRights.canPurchaseStream || completedPromiseDbRights.canRentDownload || completedPromiseDbRights.canRentStream;
                                    aggregatedResults.isFullyOwnedInCloud = completed.servicePurchaseRights || (configurationManager.service.blockVideoRentalsDuringGrovel && completed.serviceRentalRights);
                                    return aggregatedResults
                                });
                        else
                            return WinJS.Promise.wrapError(new Error("User did not sign in during purchase attempt"))
                    }.bind(this)).then(function onServiceEntitlementsCheck(contentRights) {
                        contentRights = contentRights || {};
                        if (contentRights.regionBlocked || contentRights.navigatedAway)
                            return true;
                        var blockPurchaseDialog = false;
                        if (contentRights.isFullyOwnedInDb)
                            blockPurchaseDialog = true;
                        else if (contentRights.isFullyOwnedInCloud) {
                            var purchaseHistoryServiceIsGroveling = !!purchaseHistoryService.isGroveling;
                            MS.Entertainment.Utilities.Telemetry.logTelemetryEventWithParameterArray(MS.Entertainment.Utilities.Telemetry.TelemetryEvents.VideoPrePurchaseBlocked, [{
                                    parameterName: MS.Entertainment.Utilities.Telemetry.TelemetryParameterNames.PurchaseHistoryServiceIsGroveling, parameterValue: purchaseHistoryServiceIsGroveling
                                }]);
                            MS.Entertainment.UI.Shell.showMessageBox(String.load(String.id.IDS_DIALOG_PURCHASE_DURING_GROVEL_TITLE), String.load(String.id.IDS_DIALOG_PURCHASE_DURING_GROVEL_CAPTION));
                            if (!purchaseHistoryServiceIsGroveling)
                                purchaseHistoryService.grovel();
                            blockPurchaseDialog = true
                        }
                        return blockPurchaseDialog
                    }).then(null, function onError(error) {
                        var purchaseRightsQueryError = error && error.servicePurchaseRights;
                        var rentalRightsQueryError = error && error.serviceRentalRights;
                        if (!WinJS.Promise.isCanceledError(error) && error !== MS.Entertainment.Platform.PurchaseHelpers.Error.NS_E_ERROR_CANCELLED_HR_FROM_WIN32)
                            MS.Entertainment.fail("displayPurchaseBlockingDialog failed with error: " + ((error && error.message) || error));
                        if (purchaseRightsQueryError && !WinJS.Promise.isCanceledError(purchaseRightsQueryError))
                            MS.Entertainment.fail("Inventory call for purchased items failed with error code: " + purchaseRightsQueryError.number + " and message: " + purchaseRightsQueryError.message);
                        if (rentalRightsQueryError && !WinJS.Promise.isCanceledError(rentalRightsQueryError))
                            MS.Entertainment.fail("Inventory call for rental items failed with error code: " + rentalRightsQueryError.number + " and message: " + rentalRightsQueryError.message);
                        return (!signIn.isSignedIn || signIn.isSigningOut || (configurationManager.service.blockPurchaseOnServiceFailure && (purchaseRightsQueryError || rentalRightsQueryError)))
                    })
            }, freePurchaseFlow: function freePurchaseFlow(mediaItem, offerId, currencyCode, purchaseType, startPlayback, signedOffer, offer) {
                MS.Entertainment.Utilities.assert(mediaItem, "freePurchaseFlow requires a mediaItem");
                var mediaIsTVSeason = MS.Entertainment.Platform.PlaybackHelpers.isTVSeason(mediaItem);
                var productGuid = mediaIsTVSeason ? mediaItem.edsId || mediaItem.canonicalId : mediaItem.serviceId || mediaItem.zuneId;
                var commonTelemetryParams = [{
                            parameterName: MS.Entertainment.Utilities.Telemetry.TelemetryParameterNames.CorrelationID, parameterValue: MS.Entertainment.Utilities.Telemetry.getCorrelationId(productGuid)
                        }, {
                            parameterName: MS.Entertainment.Utilities.Telemetry.TelemetryParameterNames.ProductGuid, parameterValue: productGuid || String.empty
                        }, {
                            parameterName: MS.Entertainment.Utilities.Telemetry.TelemetryParameterNames.MediaType, parameterValue: mediaItem.mediaType || String.empty
                        }, {
                            parameterName: MS.Entertainment.Utilities.Telemetry.TelemetryParameterNames.SignedOfferGuid, parameterValue: offerId || String.empty
                        }, {
                            parameterName: MS.Entertainment.Utilities.Telemetry.TelemetryParameterNames.DeliveryFormat, parameterValue: MS.Entertainment.Platform.PurchaseHelpers.DELIVERY_FORMAT_STREAMING
                        }, {
                            parameterName: MS.Entertainment.Utilities.Telemetry.TelemetryParameterNames.DistributionRight, parameterValue: purchaseType || String.empty
                        }, {
                            parameterName: MS.Entertainment.Utilities.Telemetry.TelemetryParameterNames.DisplayPrice, parameterValue: WinJS.Utilities.getMember("price", offer) || String.empty
                        }, {
                            parameterName: MS.Entertainment.Utilities.Telemetry.TelemetryParameterNames.PageURI, parameterValue: MS.Entertainment.Utilities.getCurrentUserLocation()
                        }];
                var signIn = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signIn);
                var signInPromise = signIn.signIn();
                return signInPromise.then(function signInComplete(value) {
                        if (value === MS.Entertainment.Utilities.SignIn.SignInResult.success)
                            return MS.Entertainment.Platform.PurchaseHelpers.getItemPurchaseAndRentStateAsync(mediaItem, true).then(function onGetItemPurchaseAndRentState(state) {
                                    var ownItem = (state.canPurchaseDownload || state.canPurchaseStream);
                                    if (ownItem) {
                                        var telemetryParameterArray = commonTelemetryParams.concat([{
                                                    parameterName: MS.Entertainment.Utilities.Telemetry.TelemetryParameterNames.ErrorId, parameterValue: MS.Entertainment.Platform.PurchaseHelpers.ERROR_CONTENT_ALREADY_OWNED
                                                }]);
                                        MS.Entertainment.Utilities.Telemetry.logTelemetryEventWithParameterArray(MS.Entertainment.Utilities.Telemetry.TelemetryEvents.UIFailure, telemetryParameterArray);
                                        MS.Entertainment.Platform.PlaybackHelpers.playMedia(mediaItem, false, 0);
                                        return WinJS.Promise.wrapError("Content Already Owned")
                                    }
                                    var signedInUser = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signedInUser);
                                    if (signedInUser.isParentallyControlled)
                                        return WinJS.Promise.wrapError("Parental Controlled User");
                                    if (MS.Entertainment.Utilities.isVideoApp2) {
                                        var currentUser = signIn.getAppCurrentUser();
                                        return Windows.Xbox.ApplicationModel.Store.Product.checkPrivilegeAsync(currentUser, 193, false, String.empty).then(function success(result) {
                                                if (result === Windows.Xbox.ApplicationModel.Store.PrivilegeCheckResult.restricted)
                                                    return WinJS.Promise.wrapError("Free Content Blocked User");
                                                return WinJS.Promise.wrap()
                                            }, function error() {
                                                return WinJS.Promise.wrapError("Unexpected Error")
                                            })
                                    }
                                    return WinJS.Promise.wrap()
                                });
                        var telemetryParameterArray = commonTelemetryParams.concat([{
                                    parameterName: MS.Entertainment.Utilities.Telemetry.TelemetryParameterNames.ErrorId, parameterValue: MS.Entertainment.Platform.PurchaseHelpers.ERROR_SIGN_IN_FAILED
                                }]);
                        MS.Entertainment.Utilities.Telemetry.logTelemetryEventWithParameterArray(MS.Entertainment.Utilities.Telemetry.TelemetryEvents.UIFailure, telemetryParameterArray);
                        return WinJS.Promise.wrapError("Sign in Failed")
                    }, function signInError(error) {
                        var telemetryParameterArray = commonTelemetryParams.concat([{
                                    parameterName: MS.Entertainment.Utilities.Telemetry.TelemetryParameterNames.ErrorId, parameterValue: MS.Entertainment.Platform.PurchaseHelpers.ERROR_SIGN_IN_FAILED
                                }]);
                        MS.Entertainment.Utilities.Telemetry.logTelemetryEventWithParameterArray(MS.Entertainment.Utilities.Telemetry.TelemetryEvents.UIFailure, telemetryParameterArray);
                        return WinJS.Promise.wrapError("Sign in Failed")
                    }).then(function signIn_complete() {
                        MS.Entertainment.Utilities.Telemetry.logTelemetryEventWithParameterArray(MS.Entertainment.Utilities.Telemetry.TelemetryEvents.PurchaseReviewStart, commonTelemetryParams);
                        return Microsoft.Entertainment.Fulfillment.Video.Entitlements.purchaseOfferAsync(signedOffer)
                    }).then(function purchaseOfferAsync_complete() {
                        var telemetryParameterArray = commonTelemetryParams.concat([{
                                    parameterName: MS.Entertainment.Utilities.Telemetry.TelemetryParameterNames.Result, parameterValue: MS.Entertainment.Platform.PurchaseHelpers.SUCCESS
                                }]);
                        MS.Entertainment.Utilities.Telemetry.logTelemetryEventWithParameterArray(MS.Entertainment.Utilities.Telemetry.TelemetryEvents.PurchaseResponse, telemetryParameterArray);
                        MS.Entertainment.Platform.PurchaseHelpers.downloadClosedCaptionFiles(mediaItem);
                        return MS.Entertainment.Platform.PurchaseHelpers.addMedia(mediaItem, [offerId], true)
                    }).then(function addMediaComplete() {
                        if (startPlayback)
                            if (mediaItem.mediaType === Microsoft.Entertainment.Queries.ObjectType.tvSeason) {
                                if (mediaItem.episodes && mediaItem.episodes.count > 0)
                                    mediaItem.episodes.itemsFromIndex(0, 0, mediaItem.episodes.count).done(function gotLatestEpisode(latestEpisodes) {
                                        if (latestEpisodes && latestEpisodes.items && latestEpisodes.items.length > 0) {
                                            var firstEpisode = null;
                                            var i = 0;
                                            for (i = 0; i < latestEpisodes.items.length; i++) {
                                                var episode = latestEpisodes.items[i].data;
                                                if (episode.episodeNumber !== 0) {
                                                    firstEpisode = episode;
                                                    break
                                                }
                                            }
                                            if (!firstEpisode)
                                                firstEpisode = latestEpisodes.items[0].data;
                                            if (episode)
                                                MS.Entertainment.Platform.PlaybackHelpers.playMedia(episode, false, 0)
                                        }
                                    })
                            }
                            else {
                                var tunerConfigSignal = new MS.Entertainment.UI.Framework.Signal;
                                if (MS.Entertainment.Utilities.isVideoApp2) {
                                    var configuration = new Microsoft.Entertainment.Configuration.ConfigurationManager;
                                    var minDate = new Date(Date.now() - 24 * 60 * 60 * 1000);
                                    if (configuration.service.configLastDownload < minDate) {
                                        var tunerConfigDownloaded = function tunerConfigDownloaded() {
                                                tunerConfigSignal.complete();
                                                MS.Entertainment.FeatureEnablement._featureEnablement.removeEventListener("featureschangedevent", tunerConfigDownloaded, false)
                                            };
                                        MS.Entertainment.FeatureEnablement._featureEnablement.addEventListener("featureschangedevent", tunerConfigDownloaded, false);
                                        (new Microsoft.Entertainment.FeatureEnablement.FeatureEnablement).checkForNewFeatures()
                                    }
                                    else
                                        tunerConfigSignal.complete()
                                }
                                else
                                    tunerConfigSignal.complete();
                                tunerConfigSignal.promise.done(function playTheMedia() {
                                    MS.Entertainment.Platform.PlaybackHelpers.playMedia(mediaItem, false, 0)
                                })
                            }
                    }, function purchaseFreeOfferError(error) {
                        if (error !== "Sign in Failed" && error !== "Content Already Owned") {
                            var target = MS.Entertainment.Utilities.isApp1 ? MS.Entertainment.Platform.PurchaseHelpers.PC_TARGET : MS.Entertainment.Platform.PurchaseHelpers.CONSOLE_TARGET;
                            MS.Entertainment.Platform.PurchaseHelpers.launchPurchaseFlow(mediaItem, target, purchaseType, null, offerId, null, null, signedOffer)
                        }
                    })
            }, launchPurchaseFlow: function launchPurchaseFlow(mediaItem, target, purchaseType, eventHandlers, offerId, returnUri, gamerTag, signedOffer, offer) {
                if (!offerId || !signedOffer) {
                    MS.Entertainment.fail("PurchaseHelpers: No offerId or signedOffer defined");
                    return
                }
                var mediaIsTVSeason = MS.Entertainment.Platform.PlaybackHelpers.isTVSeason(mediaItem);
                var productGuid = mediaIsTVSeason ? mediaItem.edsId || mediaItem.canonicalId : mediaItem.serviceId || mediaItem.zuneId;
                var commonTelemetryParams = [{
                            parameterName: MS.Entertainment.Utilities.Telemetry.TelemetryParameterNames.CorrelationID, parameterValue: MS.Entertainment.Utilities.Telemetry.getCorrelationId(productGuid)
                        }, {
                            parameterName: MS.Entertainment.Utilities.Telemetry.TelemetryParameterNames.ProductGuid, parameterValue: productGuid || String.empty
                        }, {
                            parameterName: MS.Entertainment.Utilities.Telemetry.TelemetryParameterNames.MediaType, parameterValue: mediaItem.mediaType || String.empty
                        }, {
                            parameterName: MS.Entertainment.Utilities.Telemetry.TelemetryParameterNames.SignedOfferGuid, parameterValue: offerId || String.empty
                        }, {
                            parameterName: MS.Entertainment.Utilities.Telemetry.TelemetryParameterNames.DistributionRight, parameterValue: purchaseType || String.empty
                        }, {
                            parameterName: MS.Entertainment.Utilities.Telemetry.TelemetryParameterNames.PageURI, parameterValue: MS.Entertainment.Utilities.getCurrentUserLocation()
                        }, {
                            parameterName: MS.Entertainment.Utilities.Telemetry.TelemetryParameterNames.DisplayPrice, parameterValue: WinJS.Utilities.getMember("price", offer) || String.empty
                        }];
                if (!MS.Entertainment.UI.NetworkStatusService.isOnline())
                {
                    var error = MS.Entertainment.Platform.Playback.Error.NS_E_WMPIM_USEROFFLINE;
                    MS.Entertainment.UI.Shell.showError(String.load(String.id.IDS_FAILED_PANEL_HEADER), error.code);
                    var telemetryParameterArray = commonTelemetryParams.concat([{
                                parameterName: MS.Entertainment.Utilities.Telemetry.TelemetryParameterNames.ErrorCode, parameterValue: error.code
                            }, {
                                parameterName: MS.Entertainment.Utilities.Telemetry.TelemetryParameterNames.ErrorId, parameterValue: error.name
                            }]);
                    MS.Entertainment.Utilities.Telemetry.logTelemetryEventWithParameterArray(MS.Entertainment.Utilities.Telemetry.TelemetryEvents.UIFailure, telemetryParameterArray);
                    return
                }
                var serviceId = mediaItem.hasZuneId ? mediaItem.zuneId : mediaItem.serviceId;
                var unsnappingPromise;
                if (!target)
                    target = this.PC_TARGET;
                var indivPromise = MS.Entertainment.Utilities.isVideoApp ? MS.Entertainment.Utilities.DRM.individualizationAsync() : WinJS.Promise.as();
                WinJS.Promise.join({
                    blockPurchase: MS.Entertainment.Platform.PurchaseHelpers.displayPurchaseBlockingDialog(mediaItem), indivPromise: indivPromise
                }).done(function(args) {
                    if (args.blockPurchase) {
                        var telemetryParameterArray = commonTelemetryParams.concat([{
                                    parameterName: MS.Entertainment.Utilities.Telemetry.TelemetryParameterNames.ErrorId, parameterValue: MS.Entertainment.Platform.PurchaseHelpers.ERROR_BLOCK_PURCHASE
                                }]);
                        MS.Entertainment.Utilities.Telemetry.logTelemetryEventWithParameterArray(MS.Entertainment.Utilities.Telemetry.TelemetryEvents.UIFailure, telemetryParameterArray);
                        return
                    }
                    var flowProvider;
                    if (MS.Entertainment.ServiceLocator.isServiceRegistered(MS.Entertainment.Services.purchaseFlowProvider))
                        flowProvider = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.purchaseFlowProvider);
                    if (flowProvider) {
                        var purchaseFlow = flowProvider.getPurchaseFlow(mediaItem, serviceId, target, purchaseType, offerId, returnUri, gamerTag);
                        if (purchaseFlow && purchaseFlow.purchaseExp) {
                            if (eventHandlers) {
                                purchaseFlow.purchaseExp.onStartEvent = eventHandlers.onStartEvent;
                                purchaseFlow.purchaseExp.onMessageEvent = eventHandlers.onMessageEvent;
                                purchaseFlow.purchaseExp.onErrorEvent = eventHandlers.onErrorEvent;
                                purchaseFlow.purchaseExp.onFinishedEvent = eventHandlers.onFinishedEvent;
                                purchaseFlow.purchaseExp.onCancelEvent = eventHandlers.onCancelEvent;
                                purchaseFlow.purchaseExp.onPageLoadEvent = eventHandlers.onPageLoadEvent;
                                purchaseFlow.purchaseExp.onMediaAddedEvent = eventHandlers.onMediaAddedEvent
                            }
                            if (Windows.UI.ViewManagement.ApplicationView && Windows.UI.ViewManagement.ApplicationView.tryUnsnap())
                                unsnappingPromise = WinJS.Promise.timeout();
                            WinJS.Promise.as(unsnappingPromise).then(function applicationIsUnsnapped() {
                                MS.Entertainment.Utilities.Telemetry.logTelemetryEventWithParameterArray(MS.Entertainment.Utilities.Telemetry.TelemetryEvents.PurchaseReviewStart, commonTelemetryParams);
                                purchaseFlow.purchaseExp.mediaItem = mediaItem;
                                purchaseFlow.purchaseExp.offerIds = [offerId];
                                MS.Entertainment.UI.PurchaseHistoryService.enterPurchaseFlowActivity();
                                return MS.Entertainment.UI.Shell.showWebHostDialog(null, {
                                        desiredLeft: "0%", desiredTop: null, desiredHeight: (new Microsoft.Entertainment.Configuration.ConfigurationManager).service.modernWebBlendHeight, showBackButton: false, showCancelButton: false
                                    }, {
                                        sourceUrl: String.empty, authenticatedSourceUrl: purchaseFlow.purchaseUrl, webHostExperience: purchaseFlow.purchaseExp, taskId: purchaseFlow.taskId, isDialog: true, offer: signedOffer
                                    })
                            }).done(function showWebHostDialogComplete() {
                                var telemetryParameterArray = commonTelemetryParams.concat([{
                                            parameterName: MS.Entertainment.Utilities.Telemetry.TelemetryParameterNames.Result, parameterValue: MS.Entertainment.Platform.PurchaseHelpers.SUCCESS
                                        }]);
                                MS.Entertainment.Utilities.Telemetry.logTelemetryEventWithParameterArray(MS.Entertainment.Utilities.Telemetry.TelemetryEvents.PurchaseResponse, telemetryParameterArray);
                                if (offerId && mediaItem && MS.Entertainment.Utilities.isApp2 && !MS.Entertainment.isAppModeOverride)
                                    MS.Entertainment.Platform.PurchaseHelpers.addMedia(mediaItem, [offerId], true);
                                MS.Entertainment.UI.PurchaseHistoryService.leavePurchaseFlowActivity(false);
                                if (eventHandlers && eventHandlers.onShowWebHostDialogComplete)
                                    eventHandlers.onShowWebHostDialogComplete()
                            }, function showWebHostDialogError(error) {
                                var telemetryParameterArray = commonTelemetryParams.concat([{
                                            parameterName: MS.Entertainment.Utilities.Telemetry.TelemetryParameterNames.Result, parameterValue: MS.Entertainment.Platform.PurchaseHelpers.FAILURE
                                        }]);
                                if (error && error.name)
                                    telemetryParameterArray.push({
                                        parameterName: MS.Entertainment.Utilities.Telemetry.TelemetryParameterNames.ErrorId, parameterValue: error.name
                                    });
                                if (error && error.number)
                                    telemetryParameterArray.push({
                                        parameterName: MS.Entertainment.Utilities.Telemetry.TelemetryParameterNames.SystemErrorCode, parameterValue: error.number
                                    });
                                MS.Entertainment.Utilities.Telemetry.logTelemetryEventWithParameterArray(MS.Entertainment.Utilities.Telemetry.TelemetryEvents.PurchaseResponse, telemetryParameterArray);
                                var canceled = error && error.name === "Canceled";
                                MS.Entertainment.UI.PurchaseHistoryService.leavePurchaseFlowActivity(!canceled);
                                if (!canceled && eventHandlers && eventHandlers.onShowWebHostDialogError)
                                    eventHandlers.onShowWebHostDialogError()
                            })
                        }
                        else {
                            var telemetryParameterArray = commonTelemetryParams.concat([{
                                        parameterName: MS.Entertainment.Utilities.Telemetry.TelemetryParameterNames.ErrorId, parameterValue: MS.Entertainment.Platform.PurchaseHelpers.ERROR_NO_PURCHASE_FLOW_EXP
                                    }]);
                            MS.Entertainment.Utilities.Telemetry.logTelemetryEventWithParameterArray(MS.Entertainment.Utilities.Telemetry.TelemetryEvents.UIFailure, telemetryParameterArray)
                        }
                    }
                    else {
                        var telemetryParameterArray = commonTelemetryParams.concat([{
                                    parameterName: MS.Entertainment.Utilities.Telemetry.TelemetryParameterNames.ErrorId, parameterValue: MS.Entertainment.Platform.PurchaseHelpers.ERROR_NO_PURCHASE_FLOW_PROVIDER
                                }]);
                        MS.Entertainment.Utilities.Telemetry.logTelemetryEventWithParameterArray(MS.Entertainment.Utilities.Telemetry.TelemetryEvents.UIFailure, telemetryParameterArray)
                    }
                })
            }, getServiceIdAsync: function(fileItem) {
                var extraPropIds = [];
                extraPropIds.push("System.Media.UniqueFileIdentifier");
                return fileItem.properties.retrievePropertiesAsync(extraPropIds).then(function onRetrieveUniqueFileIdentifierSuccess(extraProps) {
                        var uniqueFileIdentifier = extraProps["System.Media.UniqueFileIdentifier"];
                        var serviceId = null;
                        if (uniqueFileIdentifier) {
                            var matched = uniqueFileIdentifier.match(/(X_id=\{[^;]*})/);
                            if (matched) {
                                serviceId = matched[0];
                                serviceId = serviceId.match(/{.+}/)[0];
                                serviceId = serviceId.substring(1, serviceId.length - 1)
                            }
                        }
                        return serviceId
                    }, function onRetrieveUniqueFileIdentifierError() {
                        return null
                    })
            }, queryMediaDetailForCacheItemAsync: function queryMediaDetailForCacheItemAsync(cacheItemWithData, mediaType) {
                if (!cacheItemWithData)
                    return WinJS.Promise.wrapError(new Error("Expected a valid item."));
                var getSmid;
                if (!cacheItemWithData.data.zuneId || MS.Entertainment.Utilities.isEmptyGuid(cacheItemWithData.data.zuneId))
                    if (!cacheItemWithData.data.fileItem)
                        return WinJS.Promise.wrapError(new Error("Expected a valid marketplace service id."));
                if (!mediaType) {
                    mediaType = cacheItemWithData.data.mediaType;
                    if (!mediaType)
                        return WinJS.Promise.wrapError(new Error("Expected a valid media type."))
                }
                var getSmid = WinJS.Promise.as(cacheItemWithData.data.zuneId);
                if (!cacheItemWithData.data.zuneId && cacheItemWithData.data.fileItem)
                    getSmid = this.getServiceIdAsync(cacheItemWithData.data.fileItem);
                return getSmid.then(function(smid) {
                        if (!cacheItemWithData.data.zuneId && !smid)
                            return WinJS.Promise.wrapError(new Error("Expected a valid marketplace service id."));
                        cacheItemWithData.data.zuneId = smid;
                        var detailProperty;
                        var query;
                        if (mediaType === Microsoft.Entertainment.Queries.ObjectType.track) {
                            detailProperty = "Music.SongDetails";
                            query = new MS.Entertainment.Data.Query.Music.SongDetails
                        }
                        else if (mediaType === Microsoft.Entertainment.Queries.ObjectType.video) {
                            detailProperty = "Video.EdsDetailMovie";
                            query = new MS.Entertainment.Data.Query.Video.EdsDetailMovie
                        }
                        else
                            return WinJS.Promise.wrapError(new Error("The media type is not supported."));
                        if (cacheItemWithData.data[detailProperty])
                            return WinJS.Promise.wrap(cacheItemWithData.data[detailProperty]);
                        query.id = smid;
                        query.idType = cacheItemWithData.data.serviceIdType;
                        query.impressionGuid = cacheItemWithData.data.impressionGuid;
                        query.relevancyTrackingContent = cacheItemWithData.data.relevancyTrackingContent;
                        return query.execute().then(function(detail) {
                                cacheItemWithData.data[detailProperty] = detail;
                                return WinJS.Promise.wrap(detail)
                            })
                    })
            }, getPreferredRight: function getPreferredRight(rights, licenseRightsOrderedByPreference) {
                if (!Array.isArray(rights) || !Array.isArray(licenseRightsOrderedByPreference))
                    return null;
                for (var i = 0; i < licenseRightsOrderedByPreference.length; i++) {
                    var nativeLicenseRight = MS.Entertainment.Platform.PurchaseHelpers.LicenseRightMap.toNative(licenseRightsOrderedByPreference[i]);
                    for (var j = 0; j < rights.length; j++)
                        if (nativeLicenseRight === MS.Entertainment.Platform.PurchaseHelpers.LicenseRightMap.toNative(rights[j].licenseRight))
                            return rights[j]
                }
                return null
            }, filterRights: function filterRights(sourceRights, filterLicenseRights) {
                var rights = [];
                if (!Array.isArray(sourceRights))
                    return rights;
                if (!Array.isArray(filterLicenseRights) || filterLicenseRights.length === 0)
                    return sourceRights;
                for (var i = 0; i < filterLicenseRights.length; i++)
                    for (var j = 0; j < sourceRights.length; j++)
                        if (MS.Entertainment.Platform.PurchaseHelpers.LicenseRightMap.toNative(filterLicenseRights[i]) === MS.Entertainment.Platform.PurchaseHelpers.LicenseRightMap.toNative(sourceRights[j].licenseRight)) {
                            rights.push(sourceRights[j]);
                            break
                        }
                return rights
            }, mapLicenseRightArrayToNative: function mapLicenseRightArrayToNative(licenseRights) {
                var nativeLicenseRights = [];
                if (!Array.isArray(licenseRights))
                    return nativeLicenseRights;
                for (var i = 0; i < licenseRights.length; i++)
                    nativeLicenseRights.push(MS.Entertainment.Platform.PurchaseHelpers.LicenseRightMap.toNative(licenseRights[i]));
                return nativeLicenseRights
            }, getAssetLocationsRequestInfo: function getAssetLocationsRequestInfo(serviceMediaId, rights, filterLicenseRights) {
                var requestInfo = {
                        serviceMediaIds: [], mediaInstanceIds: [], nativeLicenseRights: [], offerIds: []
                    };
                if (serviceMediaId && !MS.Entertainment.Utilities.isEmptyGuid(serviceMediaId)) {
                    var rights = MS.Entertainment.Platform.PurchaseHelpers.filterRights(rights, filterLicenseRights);
                    var mediaInstanceIds = [];
                    for (var i = 0; i < rights.length; i++) {
                        var mediaInstanceId = rights[i].mediaInstanceId;
                        var offerId = rights[i].offerId;
                        if (mediaInstanceId && !MS.Entertainment.Utilities.isEmptyGuid(mediaInstanceId)) {
                            requestInfo.serviceMediaIds.push(serviceMediaId);
                            requestInfo.mediaInstanceIds.push(mediaInstanceId);
                            requestInfo.nativeLicenseRights.push(MS.Entertainment.Platform.PurchaseHelpers.LicenseRightMap.toNative(rights[i].licenseRight));
                            requestInfo.offerIds.push((!offerId || MS.Entertainment.Utilities.isEmptyGuid(offerId)) ? null : offerId)
                        }
                    }
                }
                return requestInfo
            }, getAssetLocationsAsync: function getAssetLocationsAsync(serviceMediaId, rights, filterLicenseRights, autoActivateMachine, context, ticket) {
                var requestInfo = MS.Entertainment.Platform.PurchaseHelpers.getAssetLocationsRequestInfo(serviceMediaId, rights, filterLicenseRights);
                return MS.Entertainment.Platform.PurchaseHelpers.getAssetLocationsUsingRequestInfoAsync(requestInfo, autoActivateMachine, context, ticket)
            }, getAssetLocationsUsingRequestInfoAsync: function getAssetLocationsUsingRequestInfoAsync(requestInfo, autoActivateMachine, context, ticket, skipSubscriptionFiltering) {
                if (!requestInfo || !Array.isArray(requestInfo.mediaInstanceIds) || requestInfo.mediaInstanceIds.length === 0)
                    return WinJS.Promise.wrap([]);
                if (!Array.isArray(requestInfo.nativeLicenseRights) || requestInfo.mediaInstanceIds.length !== requestInfo.nativeLicenseRights.length)
                    return WinJS.Promise.wrapError(new Error("The input mediaInstanceIds and licenseRights must be arrays of equal length."));
                if (!Array.isArray(requestInfo.offerIds) || requestInfo.mediaInstanceIds.length !== requestInfo.offerIds.length)
                    return WinJS.Promise.wrapError(new Error("The input mediaInstanceIds and offerIds must be arrays of equal length."));
                var configurationManager = new Microsoft.Entertainment.Configuration.ConfigurationManager;
                if (!skipSubscriptionFiltering && (!ticket || !configurationManager.service.lastSignedInUserSubscription))
                    for (var i = 0; i < requestInfo.nativeLicenseRights.length; i++)
                        switch (requestInfo.nativeLicenseRights[i]) {
                            case Microsoft.Entertainment.Marketplace.MarketplaceMediaRights.subscriptionDownload:
                            case Microsoft.Entertainment.Marketplace.MarketplaceMediaRights.subscriptionStream:
                                requestInfo.serviceMediaIds.splice(i, 1);
                                requestInfo.mediaInstanceIds.splice(i, 1);
                                requestInfo.nativeLicenseRights.splice(i, 1);
                                requestInfo.offerIds.splice(i, 1);
                                i--;
                                break
                        }
                if (requestInfo.mediaInstanceIds.length === 0)
                    return WinJS.Promise.wrap([]);
                if (requestInfo.nativeLicenseRights.length === 1 && requestInfo.nativeLicenseRights[0] === Microsoft.Entertainment.Marketplace.MarketplaceMediaRights.freeStream && !MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signIn).isSignedIn)
                    ticket = null;
                requestInfo = {
                    serviceMediaIds: [requestInfo.serviceMediaIds[0]], mediaInstanceIds: [requestInfo.mediaInstanceIds[0]], nativeLicenseRights: [requestInfo.nativeLicenseRights[0]], offerIds: [requestInfo.offerIds[0]]
                };
                return Microsoft.Entertainment.Marketplace.Marketplace.getAssetLocationsAsync(ticket ? ticket : String.empty, requestInfo.serviceMediaIds, requestInfo.mediaInstanceIds, requestInfo.nativeLicenseRights, [], context ? [context] : [], !!autoActivateMachine).then(function getAssetLocationsAsync_complete(jsonAssetLocations) {
                        var assetLocations = JSON.parse(jsonAssetLocations).results;
                        assetLocations[0].offerId = requestInfo.offerIds[0];
                        return WinJS.Promise.wrap(assetLocations)
                    }.bind(this))
            }, useAddMediaForIngestion: function useAddMediaForIngestion() {
                var configManager = new Microsoft.Entertainment.Configuration.ConfigurationManager;
                return (!MS.Entertainment.Utilities.isVideoApp || !configManager.fulfillment.videoUsesXdlcInsteadOfZest || configManager.fulfillment.videoUsesAddMediaWhenXdlcEnabled)
            }, ensurePreownedMediaAddedAsync: function ensurePreownedMediaAddedAsync(media) {
                var addMediaResult = MS.Entertainment.Platform.PurchaseHelpers.createAddMediaResult();
                if (!media || !media.mediaType || (!MS.Entertainment.Utilities.isMusicApp && !MS.Entertainment.Utilities.isVideoApp))
                    return WinJS.Promise.wrap(addMediaResult);
                var promise = WinJS.Promise.wrap();
                var mediaList = [];
                var zuneIdList = [];
                var virtualMediaList = null;
                switch (media.mediaType) {
                    case Microsoft.Entertainment.Queries.ObjectType.video:
                    case Microsoft.Entertainment.Queries.ObjectType.track:
                        if (media.inCollection)
                            addMediaResult.addMedia(media);
                        else if (media.hasZuneId) {
                            mediaList.push(media);
                            zuneIdList.push(media.zuneId)
                        }
                        break;
                    case Microsoft.Entertainment.Queries.ObjectType.album:
                        virtualMediaList = media.tracks;
                        break;
                    case Microsoft.Entertainment.Queries.ObjectType.tvSeason:
                        virtualMediaList = media.episodes;
                        break;
                    case Microsoft.Entertainment.Queries.ObjectType.playlist:
                        virtualMediaList = media.tracks;
                        break;
                    default:
                        return WinJS.Promise.wrap(addMediaResult)
                }
                if (virtualMediaList)
                    promise = virtualMediaList.forEachAll(function itemsFromIndex_complete(args) {
                        var item = args.item.data;
                        if (item)
                            if (item.inCollection)
                                addMediaResult.addMedia(item);
                            else if (item.hasZuneId) {
                                mediaList.push(item);
                                zuneIdList.push(item.zuneId)
                            }
                    });
                return promise.then(function processMediaForAdding() {
                        if (!mediaList.length)
                            return WinJS.Promise.wrap(addMediaResult);
                        return Microsoft.Entertainment.Marketplace.Marketplace.getMediaEntitlementsAsync(zuneIdList).then(function getMediaEntitlementsAsync_complete(result) {
                                var entitlements = JSON.parse(result).result.entitlements;
                                var useAddMediaForIngestion = MS.Entertainment.Platform.PurchaseHelpers.useAddMediaForIngestion();
                                var promises = [];
                                for (var i = 0; i < mediaList.length; i++)
                                    if (!useAddMediaForIngestion) {
                                        var offerIds = [];
                                        if (entitlements[i].purchase.stream.isAvailable)
                                            offerIds.push(entitlements[i].purchase.stream.offerId);
                                        if (entitlements[i].purchase.download.isAvailable)
                                            offerIds.push(entitlements[i].purchase.download.offerId);
                                        if (entitlements[i].rent.stream.isAvailable)
                                            offerIds.push(entitlements[i].rent.stream.offerId);
                                        if (entitlements[i].rent.download.isAvailable)
                                            offerIds.push(entitlements[i].rent.download.offerId);
                                        if (offerIds.length > 0)
                                            promises.push(MS.Entertainment.Platform.PurchaseHelpers.addMedia(mediaList[i], offerIds).then(function addMedia_complete(addMediaResultInner) {
                                                addMediaResult.concat(addMediaResultInner);
                                                return WinJS.Promise.wrap(addMediaResultInner)
                                            }))
                                    }
                                    else if (entitlements[i].purchase.isAvailable || entitlements[i].rent.isAvailable)
                                        promises.push(MS.Entertainment.Platform.PurchaseHelpers.addMedia(mediaList[i]).then(function addMedia_complete(addMediaResultInner) {
                                            addMediaResult.concat(addMediaResultInner);
                                            return WinJS.Promise.wrap(addMediaResultInner)
                                        }));
                                return WinJS.Promise.join(promises).then(function addMedia_joinComplete() {
                                        return WinJS.Promise.wrap(addMediaResult)
                                    })
                            })
                    })
            }, addNonCollectionMediaToLibrary: function addNonCollectionMediaToLibrary(mediaItemsArray) {
                return MS.Entertainment.Platform.PurchaseHelpers._addNonCollectionMediaToLibrary(mediaItemsArray, false)
            }, tryAddNonCollectionMediaToLibrary: function tryAddNonCollectionMediaToLibrary(mediaItemsArray) {
                return MS.Entertainment.Platform.PurchaseHelpers._addNonCollectionMediaToLibrary(mediaItemsArray, true)
            }, _addNonCollectionMediaToLibrary: function _addNonCollectionMediaToLibrary(mediaItemsArray, ignoreErrors) {
                var serviceMediaIds = mediaItemsArray.map(function getServiceMediaId(mediaItem) {
                        return !MS.Entertainment.Utilities.isEmptyGuid(mediaItem.zuneId) ? mediaItem.zuneId : MS.Entertainment.Utilities.EMPTY_GUID
                    });
                var mediaTypes = mediaItemsArray.map(function getMediaType(mediaItem) {
                        return mediaItem.mediaType
                    });
                var mediaPropertySet = new Windows.Foundation.Collections.PropertySet;
                var propertySetPromises = mediaItemsArray.map(function populatePropertySets(mediaItem) {
                        return MS.Entertainment.Platform.PurchaseHelpers._populatePropertySetForMedia(mediaPropertySet, mediaItem)
                    });
                var marketplaceService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.marketplace);
                var addMedia = ignoreErrors ? marketplaceService.tryAddMedia : marketplaceService.addMedia;
                return WinJS.Promise.join(propertySetPromises).then(function propertySetPopulationComplete() {
                        return addMedia(serviceMediaIds, mediaTypes, [], [], mediaPropertySet, false)
                    }).then(function addMediaComplete(addMediaResult) {
                        var result = MS.Entertainment.Platform.PurchaseHelpers.parseJsonAddMediaResult(addMediaResult);
                        return WinJS.Promise.wrap(result)
                    })
            }, _populatePropertySetForArtist: function _populatePropertySetForArtist(artistPropertySet, artist) {
                var artistSimpleProperties = ["name", "hasSmartDJ", "hasSmartVJ", "imageResizeUri"];
                MS.Entertainment.Platform.PurchaseHelpers._addPropertiesToPropertySet(artistPropertySet, artist, artistSimpleProperties);
                if (artist.hasZuneId)
                    artistPropertySet["zuneId"] = artist.zuneId;
                if (artist.serviceIdType === MS.Entertainment.Data.Query.edsIdType.canonical)
                    artistPropertySet["bingId"] = artist.serviceId
            }, _populatePropertySetForAlbum: function _populatePropertySetForAlbum(propertySet, album) {
                MS.Entertainment.Platform.PurchaseHelpers.assert(album.hasZuneId, "Media passed into _populatePropertySetForAlbum does not have a valid zuneId");
                var albumPropertySet;
                var trackList = [];
                var albumSimpleProperties = ["imageResizeUri", "isExplicit", "name", "primaryGenreName", "releaseDate", "trackCount", "zuneId"];
                if (album.hasZuneId) {
                    albumPropertySet = MS.Entertainment.Platform.PurchaseHelpers._getOrCreatePropertySetWithKey(propertySet, album.zuneId);
                    MS.Entertainment.Platform.PurchaseHelpers._addPropertiesToPropertySet(albumPropertySet, album, albumSimpleProperties);
                    if (album.serviceIdType === MS.Entertainment.Data.Query.edsIdType.canonical)
                        albumPropertySet["bingId"] = album.serviceId;
                    if (album.rights)
                        MS.Entertainment.Platform.PurchaseHelpers._populateRightsForMedia(albumPropertySet, album);
                    if (album.artist) {
                        albumPropertySet["Artist"] = new Windows.Foundation.Collections.PropertySet;
                        MS.Entertainment.Platform.PurchaseHelpers._populatePropertySetForArtist(albumPropertySet["Artist"], album.artist)
                    }
                    if (album.tracks)
                        return album.tracks.forEachAll(function pushTrack(args) {
                                var track = args.item.data;
                                if (track) {
                                    trackList.push(track.zuneId);
                                    MS.Entertainment.Platform.PurchaseHelpers._populatePropertySetForTrack(propertySet, track)
                                }
                            }).then(function trackListPopulated() {
                                albumPropertySet["TrackList"] = trackList
                            }, function trackListError(e) {
                                albumPropertySet["TrackList"] = null
                            });
                    else
                        return WinJS.Promise.wrap()
                }
                return WinJS.Promise.wrap()
            }, _getOrCreatePropertySetWithKey: function _getOrCreatePropertySetWithKey(parentPropertySet, key) {
                if (!parentPropertySet.hasKey(key))
                    parentPropertySet[key] = new Windows.Foundation.Collections.PropertySet;
                return parentPropertySet[key]
            }, _addPropertiesToPropertySet: function _addPropertiesToPropertySet(propertySet, item, itemPropertiesList) {
                for (var itemProperty in itemPropertiesList)
                    propertySet[itemPropertiesList[itemProperty]] = item[itemPropertiesList[itemProperty]]
            }, _populateRightsForMedia: function _populateRightsForMedia(mediaPropertySet, media) {
                MS.Entertainment.Platform.PurchaseHelpers.assert(media.rights, "media did not have rights property");
                var rightsList = [];
                if (media.rights)
                    media.rights.forEach(function addRightToPropertySet(right) {
                        var rightPropertySet = new Windows.Foundation.Collections.PropertySet;
                        rightPropertySet["ProviderId"] = right.providerId;
                        rightPropertySet["LicenseRight"] = right.licenseRight;
                        rightPropertySet["Encoding"] = right.encoding;
                        rightPropertySet["MediaInstanceId"] = right.mediaInstanceId;
                        rightPropertySet["OfferId"] = right.offerId;
                        rightPropertySet["ClientTypes"] = right.clientTypes;
                        if (right.fulfillmentTicket)
                            rightPropertySet["FulfillmentTicket"] = right.fulfillmentTicket;
                        if (right.fulfillmentTicketExpirationDate)
                            rightPropertySet["FulfillmentTicketExpirationDate"] = right.fulfillmentTicketExpirationDate;
                        if (right.signedLicensePolicyTicket)
                            rightPropertySet["SignedLicensePolicyTicket"] = right.signedLicensePolicyTicket;
                        if (right.signedOffer)
                            rightPropertySet["SignedOffer"] = right.signedOffer;
                        rightsList.push(rightPropertySet)
                    });
                mediaPropertySet["Rights"] = rightsList
            }, _populatePropertySetForTrack: function _populatePropertySetForTrack(propertySet, track) {
                MS.Entertainment.Platform.PurchaseHelpers.assert(track.hasZuneId || track.fileItem, "Media passed into _populatePropertySetForMedia does not have a valid zuneId");
                var trackPropertySet;
                var trackSimpleProperties = ["durationSeconds", "genreName", "isExplicit", "imageResizeUri", "name", "releaseDate", "trackNumber", "zuneId"];
                if (track.hasZuneId) {
                    trackPropertySet = MS.Entertainment.Platform.PurchaseHelpers._getOrCreatePropertySetWithKey(propertySet, track.zuneId);
                    MS.Entertainment.Platform.PurchaseHelpers._addPropertiesToPropertySet(trackPropertySet, track, trackSimpleProperties);
                    if (track.artist) {
                        trackPropertySet["Artist"] = new Windows.Foundation.Collections.PropertySet;
                        MS.Entertainment.Platform.PurchaseHelpers._populatePropertySetForArtist(trackPropertySet["Artist"], track.artist)
                    }
                    if (track.rights)
                        MS.Entertainment.Platform.PurchaseHelpers._populateRightsForMedia(trackPropertySet, track);
                    if (track.serviceIdType === MS.Entertainment.Data.Query.edsIdType.canonical)
                        trackPropertySet["bingId"] = track.serviceId;
                    else if (track.serviceIdType === MS.Entertainment.Data.Query.edsIdType.amg)
                        trackPropertySet["amgId"] = track.serviceId;
                    if (track.album) {
                        if (track.album.artist) {
                            trackPropertySet["AlbumArtist"] = new Windows.Foundation.Collections.PropertySet;
                            MS.Entertainment.Platform.PurchaseHelpers._populatePropertySetForArtist(trackPropertySet["AlbumArtist"], track.album.artist)
                        }
                        trackPropertySet["albumZuneId"] = track.album.zuneId;
                        if (track.album.serviceIdType === MS.Entertainment.Data.Query.edsIdType.canonical)
                            trackPropertySet["albumBingId"] = track.album.serviceId;
                        trackPropertySet["albumName"] = track.album.name
                    }
                }
                return WinJS.Promise.wrap()
            }, _populatePropertySetForMedia: function _populatePropertySetForMedia(propertySet, media) {
                MS.Entertainment.Platform.PurchaseHelpers.assert(media.hasZuneId || media.fileItem, "Media passed into _populatePropertySetForMedia does not have a valid zuneId");
                var populatePromise;
                switch (media.mediaType) {
                    case Microsoft.Entertainment.Queries.ObjectType.album:
                        populatePromise = MS.Entertainment.Platform.PurchaseHelpers._populatePropertySetForAlbum(propertySet, media);
                        break;
                    case Microsoft.Entertainment.Queries.ObjectType.track:
                        populatePromise = MS.Entertainment.Platform.PurchaseHelpers._populatePropertySetForTrack(propertySet, media);
                        break;
                    default:
                        MS.Entertainment.Platform.PurchaseHelpers.assert(false, "Unknown mediaType passed to _populatePropertySetForMedia");
                        populatePromise = WinJS.Promise.wrap();
                        break
                }
                return populatePromise
            }, _getDatabaseAndServiceRights: function _getDatabaseAndServiceRights(mediaItem) {
                var i;
                var purchaseOfferIds = [];
                var rentalOfferIds = [];
                var defaultClientTypeFromApp = MS.Entertainment.Utilities.defaultClientTypeFromApp;
                var purchaseRights = MS.Entertainment.ViewModels.SmartBuyStateHandlers.getMatchingRights(mediaItem, defaultClientTypeFromApp, [MS.Entertainment.ViewModels.SmartBuyStateHandlers.MarketplaceRight.SeasonPurchase, MS.Entertainment.ViewModels.SmartBuyStateHandlers.MarketplaceRight.SeasonPurchaseStream, MS.Entertainment.ViewModels.SmartBuyStateHandlers.MarketplaceRight.Purchase, MS.Entertainment.ViewModels.SmartBuyStateHandlers.MarketplaceRight.PurchaseStream, ], false, false, false, null, true, true);
                var rentalRights = MS.Entertainment.ViewModels.SmartBuyStateHandlers.getMatchingRights(mediaItem, defaultClientTypeFromApp, [MS.Entertainment.ViewModels.SmartBuyStateHandlers.MarketplaceRight.Rent, MS.Entertainment.ViewModels.SmartBuyStateHandlers.MarketplaceRight.RentStream, ]);
                for (i = 0; i < purchaseRights.length; ++i) {
                    var currentRight = purchaseRights[i];
                    if (currentRight && purchaseOfferIds.indexOf(currentRight.offerId) === -1) {
                        MS.Entertainment.assert(currentRight.offerId, "PurchaseHelpers: Invalid offerId: " + currentRight.offerId);
                        purchaseOfferIds.push(currentRight.offerId)
                    }
                }
                for (i = 0; i < rentalRights.length; ++i) {
                    var currentRight = rentalRights[i];
                    if (currentRight && rentalOfferIds.indexOf(currentRight.offerId) === -1) {
                        MS.Entertainment.assert(currentRight.offerId, "PurchaseHelpers: Invalid offerId: " + currentRight.offerId);
                        rentalOfferIds.push(currentRight.offerId)
                    }
                }
                return WinJS.Promise.join({
                        databaseRights: MS.Entertainment.Platform.PurchaseHelpers.getItemPurchaseAndRentStateAsync(mediaItem, true), servicePurchaseRights: purchaseOfferIds.length && Microsoft.Entertainment.Fulfillment.Video.Entitlements.checkServiceAvailabilityAsync(purchaseOfferIds), serviceRentalRights: rentalOfferIds.length && Microsoft.Entertainment.Fulfillment.Video.Entitlements.checkServiceAvailabilityAsync(rentalOfferIds)
                    })
            }, addSubscriptionMedia: function addSubscriptionMedia(media) {
                MS.Entertainment.Platform.PurchaseHelpers.assert(media, "Invalid media item passed into addSubscriptionMedia");
                var serviceIds = [];
                var mediaTypes = [];
                var mediaItemsToHydrate = null;
                var getServiceIdsPromise = null;
                var populatePromise = null;
                var hasExplicitPrivilege = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signedInUser).hasExplicitPrivilege;
                if (MS.Entertainment.Data.List.isListOrArray(media))
                    getServiceIdsPromise = MS.Entertainment.Data.List.listToArray(media).then(function _addServiceIdsToArray(mediaItemsArray) {
                        var fileTransferNotifications = null;
                        if (MS.Entertainment.ServiceLocator.isServiceRegistered(MS.Entertainment.Services.fileTransferNotifications))
                            fileTransferNotifications = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.fileTransferNotifications);
                        var explicitContentBlocked = false;
                        var propertySetPromises = [];
                        var mediaPropertySet = new Windows.Foundation.Collections.PropertySet;
                        mediaItemsToHydrate = mediaItemsArray;
                        mediaItemsArray.forEach(function _getMediaData(mediaItem) {
                            var hydratePromise = WinJS.Promise.as();
                            if (MS.Entertainment.Platform.PlaybackHelpers.isMusicVideo(mediaItem)) {
                                mediaItem = mediaItem.track;
                                hydratePromise = mediaItem.hydrate()
                            }
                            propertySetPromises.push(hydratePromise.then(function _addMediaItem() {
                                MS.Entertainment.Platform.PurchaseHelpers.assert(mediaItem.hasZuneId, "Media passed into addSubscriptionMedia does not have a valid zuneId");
                                if (!hasExplicitPrivilege && mediaItem.isExplicit) {
                                    if (fileTransferNotifications)
                                        fileTransferNotifications.setItemError(mediaItem.zuneId, MS.Entertainment.Platform.PurchaseHelpers.Error.NS_E_EXPLICIT_CONTENT_DOWNLOAD_BLOCKED);
                                    explicitContentBlocked = true
                                }
                                else {
                                    serviceIds.push(mediaItem.zuneId);
                                    mediaTypes.push(mediaItem.mediaType)
                                }
                                if (mediaItem.hydrated)
                                    return MS.Entertainment.Platform.PurchaseHelpers._populatePropertySetForMedia(mediaPropertySet, mediaItem)
                            }))
                        });
                        if (!mediaTypes.length && explicitContentBlocked)
                            return WinJS.Promise.wrapError(MS.Entertainment.Platform.PurchaseHelpers.Error.NS_E_EXPLICIT_CONTENT_DOWNLOAD_BLOCKED);
                        return WinJS.Promise.join(propertySetPromises).then(function returnData() {
                                return {
                                        serviceIds: serviceIds, mediaTypes: mediaTypes, mediaPropertySet: (propertySetPromises.length === 0) ? null : mediaPropertySet
                                    }
                            })
                    });
                else {
                    MS.Entertainment.Platform.PurchaseHelpers.assert(media.hasZuneId, "Media passed into addSubscriptionMedia does not have a valid zuneId");
                    serviceIds.push(media.zuneId);
                    mediaTypes.push(media.mediaType);
                    mediaItemsToHydrate = [media];
                    var mediaPropertySet = new Windows.Foundation.Collections.PropertySet;
                    populatePromise = MS.Entertainment.Platform.PurchaseHelpers._populatePropertySetForMedia(mediaPropertySet, media);
                    getServiceIdsPromise = populatePromise.then(function returnData() {
                        return {
                                serviceIds: serviceIds, mediaTypes: mediaTypes, mediaPropertySet: mediaPropertySet
                            }
                    })
                }
                return getServiceIdsPromise.then(function addIds(data) {
                        if (data.serviceIds.length)
                            return Microsoft.Entertainment.Marketplace.Marketplace.addMedia(data.serviceIds, data.mediaTypes, [], [], data.mediaPropertySet, true);
                        else
                            return WinJS.Promise.wrapError()
                    }).then(function addSubscriptionMedia_complete(jsonAddMediaResult) {
                        var addMediaResult = MS.Entertainment.Platform.PurchaseHelpers.parseJsonAddMediaResult(jsonAddMediaResult);
                        return addMediaResult.hydrateLibraryInfoAsync(mediaItemsToHydrate).then(function hydrateLibraryIdsAsync_complete() {
                                return addMediaResult
                            })
                    })
            }, createAddMediaResult: function createAddMediaResult() {
                return {
                        mediaIdentifiers: [], dbMediaIds: [], dbMediaTypes: [], addMedia: function addMedia(media) {
                                this.concat({mediaIdentifiers: [{
                                            libraryId: media.libraryId, libraryType: media.mediaType, mediaId: media.zuneId
                                        }]})
                            }, concat: function concat(addMediaResult) {
                                var countAdded = 0;
                                if (addMediaResult && addMediaResult.mediaIdentifiers)
                                    for (var i = 0; i < addMediaResult.mediaIdentifiers.length; i++)
                                        if (!this.contains(addMediaResult.mediaIdentifiers[i].libraryId, addMediaResult.mediaIdentifiers[i].libraryType)) {
                                            var addMediaResultElement = addMediaResult.mediaIdentifiers[i];
                                            this.mediaIdentifiers.push({
                                                libraryId: addMediaResultElement.libraryId, libraryType: addMediaResultElement.libraryType, mediaId: addMediaResultElement.mediaId
                                            });
                                            this.dbMediaIds.push(addMediaResultElement.libraryId);
                                            this.dbMediaTypes.push(addMediaResultElement.libraryType);
                                            countAdded++
                                        }
                                return countAdded
                            }, contains: function contains(libraryId, libraryType) {
                                for (var i = 0; i < this.mediaIdentifiers.length; i++)
                                    if (this.mediaIdentifiers[i].libraryId === libraryId && this.mediaIdentifiers[i].libraryType === libraryType)
                                        return true;
                                return false
                            }, getLibraryIdFromServiceMediaId: function getLibraryIdFromServiceMediaId(mediaId) {
                                if (mediaId && typeof(mediaId) === "string") {
                                    mediaId = mediaId.toLowerCase();
                                    for (var i = 0; i < this.mediaIdentifiers.length; i++)
                                        if (this.mediaIdentifiers[i].mediaId.toLowerCase() === mediaId)
                                            return this.mediaIdentifiers[i].libraryId
                                }
                                return -1
                            }, _hydrateSingleLibraryInfoAsync: function _hydrateSingleLibraryInfoAsync(mediaItem) {
                                if (!mediaItem || !mediaItem.mediaType)
                                    return WinJS.Promise.as();
                                return MS.Entertainment.ViewModels.MediaItemModel.hydrateLibraryInfoAsync(mediaItem).then(function hydrateLibraryInfoAsyncComplete() {
                                        if (mediaItem.mediaType === Microsoft.Entertainment.Queries.ObjectType.album)
                                            return mediaItem.tracks;
                                        else if (mediaItem.mediaType === Microsoft.Entertainment.Queries.ObjectType.tvSeason)
                                            return mediaItem.episodes
                                    }).then(function populateVirtualList(virtualList) {
                                        if (virtualList)
                                            return virtualList.itemsFromIndex(0, 0, virtualList.count)
                                    }).then(function hydrateListItems(list) {
                                        if (list) {
                                            var hydratedListItems = list.items.map(function hydrateListItem(item) {
                                                    return MS.Entertainment.ViewModels.MediaItemModel.hydrateLibraryInfoAsync(item.data)
                                                });
                                            return WinJS.Promise.join(hydratedListItems)
                                        }
                                    })
                            }, hydrateLibraryInfoAsync: function hydrateLibraryInfoAsync(media) {
                                var hydratePromise;
                                if (!MS.Entertainment.Data.List.isListOrArray(media))
                                    hydratePromise = this._hydrateSingleLibraryInfoAsync(media);
                                else
                                    hydratePromise = MS.Entertainment.Data.List.listToArray(media).then(function _gotMediaArray(mediaItemsArray) {
                                        if (mediaItemsArray.length) {
                                            var hydrateLibraryInfoPromises = mediaItemsArray.map(this._hydrateSingleLibraryInfoAsync.bind(this));
                                            return WinJS.Promise.join(hydrateLibraryInfoPromises)
                                        }
                                    }.bind(this)).then(function _absorbResult(){});
                                return WinJS.Promise.as(hydratePromise)
                            }
                    }
            }, parseJsonAddMediaResult: function parseJsonAddMediaResult(jsonAddMediaResult) {
                var addMediaResult = MS.Entertainment.Platform.PurchaseHelpers.createAddMediaResult();
                addMediaResult.concat(JSON.parse(jsonAddMediaResult));
                return addMediaResult
            }, addMedia: function addMedia(media, filterToOfferIds, inPurchaseFlow) {
                var serviceId = null;
                if (media)
                    serviceId = media.zuneId;
                if (!serviceId || MS.Entertainment.Utilities.isEmptyGuid(serviceId))
                    return WinJS.Promise.wrapError(new Error("Cannot add non-marketplace content to the collection."));
                if (inPurchaseFlow)
                    MS.Entertainment.UI.PurchaseHistoryService.enterPurchaseFlowActivity();
                var useAddMediaForIngestion = MS.Entertainment.Platform.PurchaseHelpers.useAddMediaForIngestion();
                MS.Entertainment.Platform.PurchaseHelpers.assert(useAddMediaForIngestion || (filterToOfferIds && filterToOfferIds.length > 0), "Offer ids are required when not using the add media ingestion flow.");
                if (!useAddMediaForIngestion && filterToOfferIds && filterToOfferIds.length > 0) {
                    var addMediaResult = MS.Entertainment.Platform.PurchaseHelpers.createAddMediaResult();
                    return Microsoft.Entertainment.Fulfillment.Video.Entitlements.refreshAsync(filterToOfferIds, true, true, true, false).then(function refreshAsync_complete(refreshAsyncResult) {
                            return addMediaResult.hydrateLibraryInfoAsync(media)
                        }).then(function hydrateLibraryInfoAsync_complete() {
                            if (media.mediaType === Microsoft.Entertainment.Queries.ObjectType.album)
                                return media.tracks.itemsFromIndex(0, 0, media.tracks.count);
                            else if (media.mediaType === Microsoft.Entertainment.Queries.ObjectType.tvSeason)
                                return media.episodes.itemsFromIndex(0, 0, media.episodes.count);
                            else if (media.inCollection)
                                addMediaResult.addMedia(media)
                        }).then(function itemsFromIndex_complete(list) {
                            if (list && list.items)
                                list.items.map(function hydrateListItem(item) {
                                    if (item && item.data && item.data.inCollection)
                                        addMediaResult.addMedia(item.data)
                                });
                            if (inPurchaseFlow)
                                MS.Entertainment.UI.PurchaseHistoryService.leavePurchaseFlowActivity(false);
                            return addMediaResult
                        }, function itemsFromIndex_error(error) {
                            if (error && error.number && typeof error.number === "number")
                                error = error.number;
                            MS.Entertainment.UI.Shell.showError(String.load(String.id.IDS_PURCHASE_ERROR_CAPTION), error);
                            if (inPurchaseFlow)
                                MS.Entertainment.UI.PurchaseHistoryService.leavePurchaseFlowActivity(true)
                        })
                }
                return new WinJS.Promise(function addMedia_async(c, e, p) {
                        if (!filterToOfferIds)
                            filterToOfferIds = [];
                        var addMediaPromise;
                        try {
                            addMediaPromise = Microsoft.Entertainment.Marketplace.Marketplace.addMedia([serviceId], [media.mediaType], (typeof media.videoType === "number") ? [media.videoType] : [], filterToOfferIds, null, true)
                        }
                        catch(ex) {
                            addMediaPromise = WinJS.Promise.wrapError(ex)
                        }
                        addMediaPromise.then(function addMedia_complete(jsonAddMediaResult) {
                            var addMediaResult = MS.Entertainment.Platform.PurchaseHelpers.parseJsonAddMediaResult(jsonAddMediaResult);
                            return addMediaResult.hydrateLibraryInfoAsync(media).then(function hydrateLibraryIdsAsync_complete() {
                                    if (c)
                                        c(addMediaResult);
                                    if (inPurchaseFlow)
                                        MS.Entertainment.UI.PurchaseHistoryService.leavePurchaseFlowActivity(false)
                                })
                        }, function addMedia_error(error) {
                            if (error && error.number && typeof error.number === "number")
                                error = error.number;
                            MS.Entertainment.UI.Shell.showError(String.load(String.id.IDS_PURCHASE_ERROR_CAPTION), error);
                            if (inPurchaseFlow)
                                MS.Entertainment.UI.PurchaseHistoryService.leavePurchaseFlowActivity(true)
                        })
                    })
            }, getClosedCaptionVideos: function getClosedCaptionVideos(media) {
                var mediaWithClosedCaptions = [];
                var getClosedCaptionPromiseVideosPromise = null;
                if (media)
                    if (media.mediaType === Microsoft.Entertainment.Queries.ObjectType.video) {
                        if (media.hasZuneId && media.closedCaptionFiles && media.closedCaptionFiles.length > 0) {
                            mediaWithClosedCaptions.push(media);
                            getClosedCaptionPromiseVideosPromise = WinJS.Promise.wrap(mediaWithClosedCaptions)
                        }
                    }
                    else if (media.mediaType === Microsoft.Entertainment.Queries.ObjectType.tvSeason)
                        getClosedCaptionPromiseVideosPromise = media.episodes.forEachAll(function itemsFromIndex_complete(args) {
                            var episode = args.item.data;
                            if (episode && episode.hasZuneId && episode.closedCaptionFiles && episode.closedCaptionFiles.length > 0)
                                mediaWithClosedCaptions.push(episode)
                        }).then(function gotClosedCaptions() {
                            return WinJS.Promise.wrap(mediaWithClosedCaptions)
                        });
                return getClosedCaptionPromiseVideosPromise
            }, downloadClosedCaptionFiles: function downloadClosedCaptionFiles(media) {
                var getClosedCaptionPromiseVideosPromise = MS.Entertainment.Platform.PurchaseHelpers.getClosedCaptionVideos(media);
                if (getClosedCaptionPromiseVideosPromise)
                    getClosedCaptionPromiseVideosPromise.done(function onGetClosedCaptionPromiseVideosPromise(mediaWithClosedCaptions) {
                        mediaWithClosedCaptions.forEach(function forEachMedia(ccMedia) {
                            if (ccMedia)
                                Microsoft.Entertainment.Marketplace.Marketplace.getMediaEntitlementsAsync([ccMedia.zuneId]).done(function getMediaEntitlementsAsync_complete(result) {
                                    try {
                                        var entitlement = JSON.parse(result).result.entitlements[0];
                                        if (entitlement.best.download.isAvailable) {
                                            var bestDownloadServiceMediaInstanceId = entitlement.best.download.serviceMediaInstanceId || MS.Entertainment.Utilities.EMPTY_GUID;
                                            if (bestDownloadServiceMediaInstanceId !== MS.Entertainment.Utilities.EMPTY_GUID) {
                                                bestDownloadServiceMediaInstanceId = bestDownloadServiceMediaInstanceId.toLowerCase();
                                                for (var iClosedCaptionFile = 0; iClosedCaptionFile < ccMedia.closedCaptionFiles.length; iClosedCaptionFile++) {
                                                    var ccFile = ccMedia.closedCaptionFiles[iClosedCaptionFile];
                                                    if (ccFile && ccFile.mediaInstanceId && ccFile.mediaInstanceId.toLowerCase() === bestDownloadServiceMediaInstanceId) {
                                                        var ccServiceMediaId = entitlement.serviceMediaId;
                                                        var ccServiceMediaInstanceId = ccFile.mediaInstanceId;
                                                        var ccFileUri = ccFile.fileUri;
                                                        var ccLCID = ccFile.lcid;
                                                        var ccName = ccFile.name;
                                                        Microsoft.Entertainment.ClosedCaptionDownloader.downloadClosedCaptionFileAsync(ccFileUri, ccServiceMediaId, ccServiceMediaInstanceId, ccName, ccLCID)
                                                    }
                                                }
                                            }
                                        }
                                    }
                                    catch(ex) {}
                                }, function failed(info){}.bind(this))
                        })
                    }, function failed(info){}.bind(this))
            }, downloadMedia: function downloadMedia(media, dbMediaIds, dbMediaTypes, isBundleAlbum, inPurchaseFlow, contextMediaId, contextMediaType) {
                if (MS.Entertainment.Utilities.isApp2)
                    return WinJS.Promise.wrap([]);
                if (inPurchaseFlow)
                    MS.Entertainment.UI.PurchaseHistoryService.enterPurchaseFlowActivity();
                var preferStandardDef = false;
                var promptForStandardDef = WinJS.Promise.as();
                var downloadFile = true;
                if (MS.Entertainment.Utilities.isVideoApp) {
                    var storedDownloadPreference = MS.Entertainment.UI.Controls.ChooseDownloadQualityOverlay.storedDownloadPreference;
                    if (storedDownloadPreference)
                        preferStandardDef = (MS.Entertainment.UI.Controls.ChooseDownloadQualityOverlay.storedDownloadPreference === MS.Entertainment.Data.Augmenter.Marketplace.videoDefinition.sd);
                    else
                        promptForStandardDef = MS.Entertainment.UI.Controls.ChooseDownloadQualityOverlay.mediaHasHDandSD(media).then(function checkForHD(info) {
                            if (info.hasHD && info.hasSD)
                                return MS.Entertainment.UI.Controls.ChooseDownloadQualityOverlay.getDialogSizes(media).then(function showDialog(dataSource) {
                                        return MS.Entertainment.UI.Controls.ChooseDownloadQualityOverlay.show(dataSource).then(function onDialogDismissed(result) {
                                                if (result && result.userControlInstance) {
                                                    downloadFile = result.userControlInstance.downloadFile;
                                                    preferStandardDef = !result.userControlInstance.hdSelected
                                                }
                                                else
                                                    downloadFile = false;
                                                return
                                            })
                                    });
                            return
                        })
                }
                MS.Entertainment.Platform.PurchaseHelpers.downloadClosedCaptionFiles(media);
                return new WinJS.Promise(function(c, e, p) {
                        if (dbMediaIds && dbMediaTypes) {
                            var signInProvider = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signIn);
                            signInProvider.getPassportTicket(MS.Entertainment.Utilities.SignIn.TicketType.MBI_SSL, MS.Entertainment.Endpoint.load(MS.Entertainment.Endpoint.id.seid_Passport)).then(function getPassportTicketComplete(ticket) {
                                promptForStandardDef.done(function doDownload() {
                                    if (downloadFile)
                                        Microsoft.Entertainment.Marketplace.Marketplace.download(ticket, dbMediaIds, dbMediaTypes, contextMediaId || 0, contextMediaType || 0, preferStandardDef).then(function downloadComplete(result) {
                                            var firstErrorCode = 0;
                                            var successfulTaskIds = [];
                                            for (var i = 0; i < result.hresults.size; i++) {
                                                var errorCode = result.hresults[i];
                                                if (isBundleAlbum && errorCode !== 0 && dbMediaTypes[i] === Microsoft.Entertainment.Queries.ObjectType.video)
                                                    errorCode = 0;
                                                if (errorCode === 0) {
                                                    successfulTaskIds.push(result.taskIds[i]);
                                                    MS.Entertainment.Utilities.createMediaItemByLibraryInfo(dbMediaIds[i], dbMediaTypes[i]).then(function mediaItemHydrated(downloadedMedia) {
                                                        if (downloadedMedia)
                                                            MS.Entertainment.Utilities.Telemetry.logDownloadHappened(downloadedMedia)
                                                    })
                                                }
                                                else if (firstErrorCode === 0)
                                                    if (errorCode < 0)
                                                        firstErrorCode = errorCode
                                            }
                                            if (firstErrorCode !== 0)
                                                MS.Entertainment.UI.Shell.showError(String.load(String.id.IDS_DOWNLOAD_ERROR_CAPTION), firstErrorCode);
                                            if (c)
                                                c(successfulTaskIds);
                                            if (inPurchaseFlow)
                                                MS.Entertainment.UI.PurchaseHistoryService.leavePurchaseFlowActivity(false)
                                        }, function downloadError(error) {
                                            if (error && error.number && typeof error.number === "number")
                                                error = error.number;
                                            MS.Entertainment.UI.Shell.showError(String.load(String.id.IDS_DOWNLOAD_ERROR_CAPTION), error);
                                            if (inPurchaseFlow)
                                                MS.Entertainment.UI.PurchaseHistoryService.leavePurchaseFlowActivity(true)
                                        })
                                })
                            }, function getPassportTicketError(error) {
                                if (inPurchaseFlow)
                                    MS.Entertainment.UI.PurchaseHistoryService.leavePurchaseFlowActivity(true)
                            })
                        }
                    })
            }, itemSupportsPurchase: function itemSupportsPurchase(mediaItem) {
                if (mediaItem) {
                    var mediaType = mediaItem.mediaType;
                    if (mediaType === Microsoft.Entertainment.Queries.ObjectType.game || mediaType === Microsoft.Entertainment.Queries.ObjectType.video || mediaType === Microsoft.Entertainment.Queries.ObjectType.tvSeason || mediaType === Microsoft.Entertainment.Queries.ObjectType.album || mediaType === Microsoft.Entertainment.Queries.ObjectType.track)
                        return true
                }
                return false
            }, getItemPurchaseAndRentStateAsync: function getItemPurchaseAndRentStateAsync(mediaItem, force) {
                if (!force && mediaItem.canPurchaseStream !== undefined)
                    return WinJS.Promise.wrap({
                            canPurchaseStream: mediaItem.canPurchaseStream, canPurchaseDownload: mediaItem.canPurchaseDownload, canRentStream: mediaItem.canRentStream, canRentDownload: mediaItem.canRentDownload
                        });
                return Microsoft.Entertainment.Marketplace.Marketplace.getMediaEntitlementsAsync([mediaItem.zuneId]).then(function getMediaEntitlements_complete(result) {
                        result = JSON.parse(result).result.entitlements[0];
                        return WinJS.Promise.wrap({
                                canPurchaseStream: result.purchase.stream.isAvailable, canPurchaseDownload: result.purchase.download.isAvailable, canRentStream: result.rent.stream.isAvailable, canRentDownload: result.rent.download.isAvailable
                            })
                    })
            }, MarketplaceService: WinJS.Class.define(null, {
                addMedia: function addMedia(serviceMediaIds, mediaTypes, videoTypes, filterToOfferIds, mediaPropertyMap, addToCollection) {
                    return Microsoft.Entertainment.Marketplace.Marketplace.addMedia(serviceMediaIds, mediaTypes, videoTypes, filterToOfferIds, mediaPropertyMap, addToCollection)
                }, tryAddMedia: function tryAddMedia(serviceMediaIds, mediaTypes, videoTypes, filterToOfferIds, mediaPropertyMap, addToCollection) {
                        return Microsoft.Entertainment.Marketplace.Marketplace.tryAddMedia(serviceMediaIds, mediaTypes, videoTypes, filterToOfferIds, mediaPropertyMap, addToCollection)
                    }
            }, {createMarketplaceService: function createMarketplaceService() {
                    return new MS.Entertainment.Platform.PurchaseHelpers.MarketplaceService
                }})
    });
    MS.Entertainment.ServiceLocator.register(MS.Entertainment.Services.marketplace, MS.Entertainment.Platform.PurchaseHelpers.MarketplaceService.createMarketplaceService)
})()
