﻿/* Copyright (C) Microsoft Corporation. All rights reserved. */
scriptValidator("/Framework/debug.js", "/Framework/utilities.js");
MS.Entertainment.UI.Debug.defineAssert("MS.Entertainment.UI");
(function() {
    "use strict";
    WinJS.Namespace.define("MS.Entertainment.UI", {
        Notification: WinJS.Class.define(function notificationConstructor(options) {
            var property;
            for (property in options)
                this[property] = options[property]
        }, {
            notificationType: null, title: "", subTitle: "", subTitleCaret: false, moreDetails: "", icon: null, dismissIcon: MS.Entertainment.UI.Icon.close, secondaryActions: null, category: null, isPersistent: false, iconClassName: "", acknowledged: false, visible: true, attachedNotification: null, dismissOnSignOut: false, hideDefaultRing: false, automationId: null, _action: null, _actionObject: null, _actionParams: null, _dismissAction: null, _dismissActionObject: null, _dismissActionParams: null, action: {
                    get: function get_action() {
                        return this._action
                    }, set: function set_action(value) {
                            if (this._action !== value) {
                                this._action = value;
                                this._actionObject = null
                            }
                        }
                }, actionParams: {
                    get: function get_actionParams() {
                        return this._actionParams
                    }, set: function set_actionParams(value) {
                            this._actionParams = value;
                            if (this._actionObject)
                                this._actionObject.parameter = value
                        }
                }, actionObject: {get: function get_actionObject() {
                        if (!this._actionObject && this.action && typeof this.action === "string")
                            this._actionObject = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.actions).getAction(this.action);
                        if (this._actionObject)
                            this._actionObject.parameter = this.actionParams;
                        return this._actionObject
                    }}, dismissAction: {
                    get: function get_action() {
                        return this._dismissAction
                    }, set: function set_action(value) {
                            if (this._dismissAction !== value) {
                                this._dismissAction = value;
                                this._dismissActionObject = null
                            }
                        }
                }, dismissActionParams: {
                    get: function get_dismissActionParamss() {
                        return this._dismissActionParams
                    }, set: function set_dismissActionParams(value) {
                            this._dismissActionParams = value;
                            if (this._dismissActionObject)
                                this._dismissActionObject.parameter = value
                        }
                }, dismissActionObject: {get: function get_dismissActionObject() {
                        if (!this._dismissActionObject && this.dismissAction)
                            this._dismissActionObject = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.actions).getAction(this.dismissAction);
                        if (this._dismissActionObject)
                            this._dismissActionObject.parameter = this.dismissActionParams;
                        return this._dismissActionObject
                    }}, toJSON: function toJSON() {
                    var resultObject = {};
                    for (var key in this)
                        if (key && key[0] !== "_" && key !== "toJSON" && key !== "actionObject" && key !== "dismissActionObject")
                            resultObject[key] = this[key];
                    return resultObject
                }
        }, {Type: {
                Informational: "Informational", Critical: "Critical"
            }}), AppNotificationService: MS.Entertainment.defineObservable(function AppNotificationServiceConstructor() {
                MS.Entertainment.UI.AppNotificationService._instanceCount++;
                MS.Entertainment.Utilities.assert(MS.Entertainment.UI.AppNotificationService._instanceCount === 1, "Use MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.appNotification)");
                this.infoNotifications = new WinJS.Binding.List;
                this.criticalNotifications = new WinJS.Binding.List;
                this._dismissOnSignOutCategories = [];
                var waitPromise = WinJS.Promise.as();
                if (!MS.Entertainment.ServiceLocator.isServiceRegistered(MS.Entertainment.Services.signIn))
                    waitPromise = WinJS.Promise.timeout(4000);
                waitPromise.then(function() {
                    if (MS.Entertainment.ServiceLocator.isServiceRegistered(MS.Entertainment.Services.signIn))
                        MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signIn).bind("isSignedIn", this._onSignInChange.bind(this))
                }.bind(this))
            }, {
                _dismissOnSignOutCategories: null, infoNotifications: null, _infoNotificationContainer: null, criticalNotifications: null, _criticalNotificationContainer: null, _filterNotification: function _filterNotification(notification) {
                        return MS.Entertainment.Utilities.isApp2 && (notification.notificationType === MS.Entertainment.UI.Notification.Type.Informational)
                    }, send: function send(notification) {
                        if (!notification || this._filterNotification(notification))
                            return;
                        if (!notification.isPersistent)
                            MS.Entertainment.UI.assert(notification.notificationType === MS.Entertainment.UI.Notification.Type.Informational, "Non-persistent notifications must be informational only");
                        if (!notification.category) {
                            MS.Entertainment.UI.assert(!notification.isPersistent, "Expected a category on persistent notifications.");
                            MS.Entertainment.UI.assert(!notification.dismissOnSignOut, "Expected a category on dismiss-on-signout notifications.")
                        }
                        else if (notification.dismissOnSignOut && this._dismissOnSignOutCategories.indexOf(notification.category) < 0)
                            this._dismissOnSignOutCategories.push(notification.category);
                        notification = WinJS.Binding.as(notification);
                        (new Diagnostics.Tracing.Microsoft.Entertainment.Instrumentation.Providers.Shell).traceNotification_NotificationArrived(notification.title);
                        switch (notification.notificationType) {
                            case MS.Entertainment.UI.Notification.Type.Informational:
                                var existingIndex = this._indexOfNotification(this.infoNotifications, notification.category);
                                if (existingIndex >= 0)
                                    if (!notification.isPersistent) {
                                        WinJS.Binding.unwrap(this.infoNotifications).splice(existingIndex, 1);
                                        WinJS.Binding.unwrap(this.infoNotifications).push(notification)
                                    }
                                    else {
                                        WinJS.Binding.unwrap(this.infoNotifications).getAt(existingIndex).title = notification.title;
                                        WinJS.Binding.unwrap(this.infoNotifications).getAt(existingIndex).subTitle = notification.subTitle
                                    }
                                else
                                    WinJS.Binding.unwrap(this.infoNotifications).push(notification);
                                break;
                            case MS.Entertainment.UI.Notification.Type.Critical:
                                var existingIndex = this._indexOfNotification(this.criticalNotifications, notification.category);
                                if (existingIndex < 0)
                                    WinJS.Binding.unwrap(this.criticalNotifications).push(notification);
                                break
                        }
                    }, removeNotificationByCategory: function removeNotificationByCategory(category) {
                        var index = this._indexOfNotification(this.criticalNotifications, category);
                        if (index >= 0)
                            WinJS.Binding.unwrap(this.criticalNotifications).splice(index, 1);
                        index = this._indexOfNotification(this.infoNotifications, category);
                        if (index >= 0)
                            WinJS.Binding.unwrap(this.infoNotifications).splice(index, 1)
                    }, _indexOfNotification: function _indexOfNotification(queue, category) {
                        if (category)
                            for (var index = 0; index < queue.length; index++) {
                                var notification = WinJS.Binding.unwrap(queue).getItem(index).data;
                                if (notification.category === category)
                                    return index
                            }
                        return -1
                    }, _onSignInChange: function _onSignInChange(isSignedIn) {
                        if (!isSignedIn) {
                            for (var i = 0; i < this._dismissOnSignOutCategories.length; i++)
                                this.removeNotificationByCategory(this._dismissOnSignOutCategories[i]);
                            this._dismissOnSignOutCategories = []
                        }
                    }
            }, {
                factory: function factory() {
                    var appNotificationService = new MS.Entertainment.UI.AppNotificationService;
                    Object.defineProperty(appNotificationService, "infoNotificationContainer", {get: function() {
                            if (!this._infoNotificationContainer)
                                this._infoNotificationContainer = document.querySelector(".infoNotificationContainer");
                            return this._infoNotificationContainer
                        }});
                    Object.defineProperty(appNotificationService, "criticalNotificationContainer", {get: function() {
                            if (!this._criticalNotificationContainer)
                                this._criticalNotificationContainer = document.querySelector(".criticalNotificationContainer");
                            return this._criticalNotificationContainer
                        }});
                    return appNotificationService
                }, _instanceCount: 0
            })
    });
    MS.Entertainment.ServiceLocator.register(MS.Entertainment.Services.appNotification, MS.Entertainment.UI.AppNotificationService.factory);
    WinJS.Namespace.define("MS.Entertainment.UI.Controls", {InfoNotification: MS.Entertainment.UI.Framework.defineUserControl("/Components/Shell/appNotification.html#infoNotificationTemplate", function infoNotification(element, options){}, {
            _appNotificationService: null, _navigation: null, _timer: null, _notificationItemTemplate: null, _uiSettings: new Windows.UI.ViewManagement.UISettings, _initialized: false, _selfEventHandlers: null, _flipViewEventHandlers: null, _appNotificationServiceEventHandlers: null, _webUIApplicationEventHandlers: null, _navigationBindings: null, itemTemplate: "/Components/Shell/appNotification.html#infoNotificationItemTemplate", notificationDataSourcePropertyName: "infoNotifications", initialize: function initialize(){}, delayedInitialize: function delayedInitialize() {
                    return MS.Entertainment.UI.Framework.loadTemplate(this.itemTemplate).then(function(templateProvider) {
                            this._notificationItemTemplate = templateProvider.element;
                            this._appNotificationService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.appNotification);
                            this._onPropertyChange = this._onPropertyChange.bind(this);
                            this._onAppResume = this._onAppResume.bind(this);
                            if (MS.Entertainment.ServiceLocator.isServiceRegistered(MS.Entertainment.Services.navigation)) {
                                this._navigation = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.navigation);
                                this._navigationBindings = WinJS.Binding.bind(this._navigation, {currentPage: this._onPropertyChange})
                            }
                            this._selfEventHandlers = MS.Entertainment.Utilities.addEventHandlers(this.domElement, {keydown: this.onKeyDown.bind(this)});
                            this._webUIApplicationEventHandlers = MS.Entertainment.Utilities.addEventHandlers(Windows.UI.WebUI.WebUIApplication, {resuming: this._onAppResume});
                            this.notificationContainer.itemTemplate = this._notificationItemTemplate;
                            this._appNotificationServiceEventHandlers = MS.Entertainment.Utilities.addEventHandlers(this._appNotificationService[this.notificationDataSourcePropertyName], {
                                iteminserted: this._onPropertyChange, itemremoved: this._onPropertyChange
                            });
                            this._flipViewEventHandlers = MS.Entertainment.Utilities.addEventHandlers(this.notificationContainer, {
                                pageselected: this._onPageSelected.bind(this), pagecompleted: this._onPageCompleted.bind(this), datasourcecountchanged: this._onDataSourceChanged.bind(this)
                            });
                            this._initialized = true;
                            this._onDataSourceChanged()
                        }.bind(this))
                }, onKeyDown: function onKeyDown(event) {
                    if (event.keyCode === WinJS.Utilities.Key.enter || event.keyCode === WinJS.Utilities.Key.space)
                        this.onItemClick(event)
                }, _onTimerHandler: function _onTimerHandler() {
                    if (this._appNotificationService[this.notificationDataSourcePropertyName].length === 1) {
                        var item = WinJS.Binding.unwrap(this._appNotificationService.infoNotifications).getAt(0);
                        if (item.isPersistent) {
                            this._resetTimer();
                            return
                        }
                    }
                    var item = WinJS.Binding.unwrap(this._appNotificationService.infoNotifications).shift();
                    if (item) {
                        var isPersistent = item.isPersistent;
                        if (isPersistent)
                            this.pushNewItem(item)
                    }
                }, _resetTimer: function _restartTimer() {
                    window.clearTimeout(this._timer);
                    var notificationTimeoutMs = this._uiSettings.messageDuration * 1000;
                    this._timer = window.setTimeout(function() {
                        this._onTimerHandler()
                    }.bind(this), notificationTimeoutMs)
                }, _shouldHideNotifications: function _shouldHideNotifications() {
                    var notificationVisibility = ((this._appNotificationService[this.notificationDataSourcePropertyName].length > 0) && this._initialized);
                    if (this._navigation && this._navigation.currentPage)
                        notificationVisibility = notificationVisibility && this._navigation.currentPage.showNotifications;
                    return !notificationVisibility
                }, _onDataSourceChanged: function _onDataSourceChanged() {
                    this.hideNotifications = this._shouldHideNotifications();
                    if (!this.hideNotifications) {
                        this.notificationContainer.forceLayout();
                        if (this.notificationDataSourcePropertyName === "infoNotifications")
                            this._resetTimer()
                    }
                }, unload: function unload() {
                    if (this._appNotificationServiceEventHandlers) {
                        this._appNotificationServiceEventHandlers.cancel();
                        this._appNotificationServiceEventHandlers = null
                    }
                    if (this._flipViewEventHandlers) {
                        this._flipViewEventHandlers.cancel();
                        this._flipViewEventHandlers = null
                    }
                    if (this._selfEventHandlers) {
                        this._selfEventHandlers.cancel();
                        this._selfEventHandlers = null
                    }
                    if (this._webUIApplicationEventHandlers) {
                        this._webUIApplicationEventHandlers.cancel();
                        this._webUIApplicationEventHandlers = null
                    }
                    MS.Entertainment.UI.Framework.UserControl.prototype.unload.call(this)
                }, onItemClick: function onItemClick(event) {
                    if (WinJS.Utilities.hasClass(event.srcElement, "win-navbutton"))
                        return;
                    var currentItem = WinJS.Binding.unwrap(this._appNotificationService.infoNotifications).getItem(0);
                    if (currentItem && currentItem.data && currentItem.data.action) {
                        if (currentItem.data.action.execute)
                            currentItem.data.action.execute();
                        else if (typeof currentItem.data.action === "function")
                            currentItem.data.action();
                        return
                    }
                    if (event.target && event.target.performClick)
                        if (event.target.performClick.execute)
                            event.target.performClick.execute();
                        else
                            event.target.performClick()
                }, _onPropertyChange: function _onPropertyChange() {
                    if (this._appNotificationService[this.notificationDataSourcePropertyName]) {
                        var dataSource = WinJS.Binding.unwrap(this._appNotificationService[this.notificationDataSourcePropertyName]).dataSource;
                        if (dataSource !== this.notificationContainer.itemDataSource)
                            this.notificationContainer.itemDataSource = WinJS.Binding.unwrap(this._appNotificationService[this.notificationDataSourcePropertyName]).dataSource
                    }
                    this.hideNotifications = this._shouldHideNotifications();
                    if (!this.hideNotifications)
                        this.notificationContainer.forceLayout()
                }, _onAppResume: function _onAppResume() {
                    if (!this.hideNotifications) {
                        var notification = (this.notificationDataSourcePropertyName === "infoNotifications") ? document.querySelector(".appInfoNotification") : document.querySelector(".appCriticalNotification");
                        if (notification) {
                            notification.style.display = "none";
                            WinJS.Promise.timeout(100).then(function _delay() {
                                notification.style.display = String.empty
                            }.bind(this))
                        }
                    }
                }, _onPageSelected: function _onPageSelected() {
                    var that = this;
                    if (this.notificationContainer.currentPage !== 0) {
                        var item = WinJS.Binding.unwrap(this._appNotificationService.infoNotifications).shift();
                        var isPersistent = item.isPersistent;
                        if (isPersistent)
                            this.pushNewItem(item);
                        (new Diagnostics.Tracing.Microsoft.Entertainment.Instrumentation.Providers.Shell).traceNotification_PageSelected(item.title)
                    }
                    this._resetTimer()
                }, _onPageCompleted: function _onPageCompleted() {
                    if (this._buttonContainer) {
                        var items = this._buttonContainer.querySelectorAll("[aria-selected]");
                        for (var i = 0; i < items.length; i++)
                            if (items[i].getAttribute("aria-selected", "true")) {
                                var item = items[i].querySelector("[aria-hidden]");
                                if (item) {
                                    MS.Entertainment.Framework.AccUtils.createAndAddAriaLink(this._buttonContainer, item, "aria-labelledby");
                                    if (this._liveRegionContainer && this._buttonContainer) {
                                        this._buttonContainer.removeChild(this._liveRegionContainer);
                                        this._liveRegionContainer = document.createElement("div");
                                        WinJS.Utilities.addClass(this._liveRegionContainer, "removeFromDisplay");
                                        this._liveRegionContainer.setAttribute("role", "tooltip");
                                        this._liveRegionContainer.setAttribute("aria-live", "polite");
                                        this._buttonContainer.appendChild(this._liveRegionContainer);
                                        this._liveRegionContainer.setAttribute("aria-label", item.textContent)
                                    }
                                }
                                break
                            }
                    }
                }, pushNewItem: function pushNewItem(item) {
                    var property;
                    var newItem = new MS.Entertainment.UI.Notification;
                    for (property in newItem)
                        newItem[property] = item[property];
                    newItem = WinJS.Binding.as(newItem);
                    WinJS.Binding.unwrap(this._appNotificationService[this.notificationDataSourcePropertyName]).push(newItem)
                }
        }, {hideNotifications: true})});
    WinJS.Namespace.define("MS.Entertainment.UI.Controls", {CriticalNotification: MS.Entertainment.UI.Framework.deriveUserControl("MS.Entertainment.UI.Controls.InfoNotification", "/Components/Shell/appNotification.html#criticalNotificationTemplate", function criticalNotification(element, options){}, {
            itemTemplate: "/Components/Shell/appNotification.html#criticalNotificationItemTemplate", notificationDataSourcePropertyName: "criticalNotifications", _criticalSelfEventHandlers: null, initialize: function initialize() {
                    MS.Entertainment.UI.Controls.InfoNotification.prototype.initialize.call(this);
                    this._criticalSelfEventHandlers = MS.Entertainment.Utilities.addEventHandlers(this.domElement, {
                        keypress: this.onKeyPress.bind(this), click: this.onItemClick.bind(this)
                    })
                }, unload: function unload() {
                    MS.Entertainment.UI.Controls.InfoNotification.prototype.unload.call(this);
                    if (this._criticalSelfEventHandlers) {
                        this.this._criticalSelfEventHandlers.cancel();
                        this.this._criticalSelfEventHandlers = null
                    }
                }, onKeyPress: function onKeyPress(event) {
                    if (event.keyCode === WinJS.Utilities.Key.enter || event.keyCode === WinJS.Utilities.Key.space)
                        this.onItemClick(event)
                }, onItemClick: function onItemClick(event) {
                    if (WinJS.Utilities.hasClass(event.srcElement, "win-navbutton"))
                        return;
                    var currentItem = WinJS.Binding.unwrap(this._appNotificationService.criticalNotifications).getItem(0);
                    if (currentItem && currentItem.data.secondaryActions)
                        WinJS.Utilities.removeClass(this.domElement.querySelector(".criticalNotificationSecActions"), "removeFromDisplay");
                    else {
                        var item = WinJS.Binding.unwrap(this._appNotificationService.criticalNotifications).shift();
                        if (item && item.action) {
                            item.action();
                            (new Diagnostics.Tracing.Microsoft.Entertainment.Instrumentation.Providers.Shell).traceNotification_NotificationClicked(item.title)
                        }
                    }
                    if (WinJS.Utilities.hasClass(event.srcElement, "criticalNotificationSecAction")) {
                        if (event.target && event.target.performClick)
                            event.target.performClick();
                        WinJS.Binding.unwrap(this._appNotificationService.criticalNotifications).shift()
                    }
                }, _onPageSelected: function _onPageSelected() {
                    if (this.notificationContainer.currentPage !== 0) {
                        var item = WinJS.Binding.unwrap(this._appNotificationService.criticalNotifications).shift();
                        this.pushNewItem(item);
                        (new Diagnostics.Tracing.Microsoft.Entertainment.Instrumentation.Providers.Shell).traceNotification_PageSelected(item.title)
                    }
                }
        })})
})()
