﻿/* Copyright (C) Microsoft Corporation. All rights reserved. */
var MS;
(function(MS) {
    (function(Entertainment) {
        (function(Utilities) {
            var AcquisitionContext = (function() {
                    function AcquisitionContext(){}
                    AcquisitionContext.Collection = "Collection";
                    AcquisitionContext.ExplorerFile = "ExplorerFile";
                    AcquisitionContext.SmartDJ = "SmartDJ";
                    AcquisitionContext.Store = "Store";
                    AcquisitionContext.PlayTo = "PlayTo";
                    return AcquisitionContext
                })();
            Utilities.AcquisitionContext = AcquisitionContext;
            var AcquisitionContextType = (function() {
                    function AcquisitionContextType(){}
                    AcquisitionContextType.Album = "Album";
                    AcquisitionContextType.Artist = "MusicArtist";
                    AcquisitionContextType.Genre = "Genre";
                    AcquisitionContextType.PlayAll = "PlayAll";
                    AcquisitionContextType.Playlist = "MusicPlaylist";
                    AcquisitionContextType.Track = "Track";
                    AcquisitionContextType.MusicVideo = "MusicVideo";
                    AcquisitionContextType.Video = "Video";
                    AcquisitionContextType.TVSeries = "TVSeries";
                    return AcquisitionContextType
                })();
            Utilities.AcquisitionContextType = AcquisitionContextType;
            var AcquisitionData = (function() {
                    function AcquisitionData(acquisitionContext, acquisitionContextType, acquisitionContextID, acquisitionAdditionalContext) {
                        this.acquisitionContext = acquisitionContext;
                        this.acquisitionContextType = acquisitionContextType;
                        this.acquisitionContextID = acquisitionContextID;
                        this.acquisitionAdditionalContext = acquisitionAdditionalContext
                    }
                    return AcquisitionData
                })();
            Utilities.AcquisitionData = AcquisitionData;
            function getAcquisitionContextFromEnum(acquisitionContextEnum) {
                var acquisitionContext;
                switch (acquisitionContextEnum) {
                    case Microsoft.Entertainment.Platform.AcquisitionContext.collection:
                        acquisitionContext = MS.Entertainment.Utilities.AcquisitionContext.Collection;
                        break;
                    case Microsoft.Entertainment.Platform.AcquisitionContext.explorerFile:
                        acquisitionContext = MS.Entertainment.Utilities.AcquisitionContext.ExplorerFile;
                        break;
                    case Microsoft.Entertainment.Platform.AcquisitionContext.smartDJ:
                        acquisitionContext = MS.Entertainment.Utilities.AcquisitionContext.SmartDJ;
                        break;
                    case Microsoft.Entertainment.Platform.AcquisitionContext.store:
                        acquisitionContext = MS.Entertainment.Utilities.AcquisitionContext.Store;
                        break;
                    case Microsoft.Entertainment.Platform.AcquisitionContext.playTo:
                        acquisitionContext = MS.Entertainment.Utilities.AcquisitionContext.PlayTo;
                        break;
                    default:
                        MS.Entertainment.fail("Failed to map acquisitionContextEnum to valid AcquisitionContext.  enum: " + acquisitionContextEnum);
                        break
                }
                return acquisitionContext
            }
            Utilities.getAcquisitionContextFromEnum = getAcquisitionContextFromEnum;
            function getAcquisitionContextTypeFromEnum(acquisitionContextTypeEnum) {
                var acquisitionContextType;
                switch (acquisitionContextTypeEnum) {
                    case Microsoft.Entertainment.Platform.AcquisitionContextType.album:
                        acquisitionContextType = MS.Entertainment.Utilities.AcquisitionContextType.Album;
                        break;
                    case Microsoft.Entertainment.Platform.AcquisitionContextType.artist:
                        acquisitionContextType = MS.Entertainment.Utilities.AcquisitionContextType.Artist;
                        break;
                    case Microsoft.Entertainment.Platform.AcquisitionContextType.genre:
                        acquisitionContextType = MS.Entertainment.Utilities.AcquisitionContextType.Genre;
                        break;
                    case Microsoft.Entertainment.Platform.AcquisitionContextType.playAll:
                        acquisitionContextType = MS.Entertainment.Utilities.AcquisitionContextType.PlayAll;
                        break;
                    case Microsoft.Entertainment.Platform.AcquisitionContextType.playlist:
                        acquisitionContextType = MS.Entertainment.Utilities.AcquisitionContextType.Playlist;
                        break;
                    case Microsoft.Entertainment.Platform.AcquisitionContextType.track:
                        acquisitionContextType = MS.Entertainment.Utilities.AcquisitionContextType.Track;
                        break;
                    case Microsoft.Entertainment.Platform.AcquisitionContextType.musicVideo:
                        acquisitionContextType = MS.Entertainment.Utilities.AcquisitionContextType.MusicVideo;
                        break;
                    case Microsoft.Entertainment.Platform.AcquisitionContextType.video:
                        acquisitionContextType = MS.Entertainment.Utilities.AcquisitionContextType.Video;
                        break;
                    case Microsoft.Entertainment.Platform.AcquisitionContextType.tvSeries:
                        acquisitionContextType = MS.Entertainment.Utilities.AcquisitionContextType.TVSeries;
                        break;
                    default:
                        MS.Entertainment.fail("Failed to map acquisitionContextTypeEnum to valid AcquisitionContextType.  enum: " + acquisitionContextTypeEnum);
                        break
                }
                return acquisitionContextType
            }
            Utilities.getAcquisitionContextTypeFromEnum = getAcquisitionContextTypeFromEnum
        })(Entertainment.Utilities || (Entertainment.Utilities = {}));
        var Utilities = Entertainment.Utilities
    })(MS.Entertainment || (MS.Entertainment = {}));
    var Entertainment = MS.Entertainment
})(MS || (MS = {}))
