﻿/* Copyright (C) Microsoft Corporation. All rights reserved. */
(function() {
    "use strict";
    scriptValidator("/Framework/debug.js", "/Framework/serviceLocator.js");
    MS.Entertainment.UI.Debug.defineAssert("MS.Entertainment.UI.Components.Shell");
    WinJS.Namespace.define("MS.Entertainment.Framework", {InteractionNotifier: MS.Entertainment.UI.Framework.define(function InteractionNotifier() {
            this._listenerFunctions = [];
            var userInteractionHandler = this._notifyListeners.bind(this);
            var focusHandler = this._focusHandler.bind(this);
            var uiStateService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.uiState);
            document.body.addEventListener("keydown", userInteractionHandler, true);
            document.body.addEventListener("mousewheel", userInteractionHandler, true);
            document.body.addEventListener("MSPointerDown", userInteractionHandler, true);
            document.body.addEventListener("MSPointerMove", userInteractionHandler, true);
            document.body.addEventListener("focusin", focusHandler, true);
            document.body.addEventListener("pointerdown", userInteractionHandler, true);
            document.body.addEventListener("pointermove", userInteractionHandler, true);
            document.body.addEventListener("focusout", focusHandler, true);
            document.body.addEventListener("click", userInteractionHandler, true);
            this._bindings = WinJS.Binding.bind(uiStateService, {activeListening: userInteractionHandler})
        }, {
            _listenerFunctions: null, _bindings: null, _previouslyFocused: true, dispose: function dispose() {
                    if (this._bindings) {
                        this._bindings.cancel();
                        this._bindings = null
                    }
                }, _focusHandler: function _focusHandler() {
                    if (!this._previouslyFocused)
                        this._notifyListeners();
                    this._previouslyFocused = document.hasFocus()
                }, _notifyListeners: function _notifyListeners(event) {
                    for (var i = 0; i < this._listenerFunctions.length; i++)
                        try {
                            this._listenerFunctions[i]()
                        }
                        catch(exception) {
                            MS.Entertainment.UI.Components.Shell.assert(false, "Interaction listener failed " + this._listenerFunctions[i].toString() + "\r\nException: " + exception.toString())
                        }
                }, addInteractionListener: function addInteractionListener(listenerFunction) {
                    this._listenerFunctions.push(listenerFunction)
                }, removeInteractionListener: function removeInteractionListener(listenerFunction) {
                    var index = this._listenerFunctions.indexOf(listenerFunction);
                    if (index > -1)
                        this._listenerFunctions.splice(index, 1)
                }
        }, null)});
    MS.Entertainment.ServiceLocator.register(MS.Entertainment.Services.interactionNotifier, function InteractionNotifierFactory() {
        return new MS.Entertainment.Framework.InteractionNotifier
    })
})()
