﻿/* Copyright (C) Microsoft Corporation. All rights reserved. */
scriptValidator();
(function(MSE, undefined) {
    "use strict";
    var alias = MSE.Data.Property.alias;
    var augment = MSE.Data.Property.augment;
    var convert = MSE.Data.Property.convert;
    var convertNoDeflate = MSE.Data.Property.convertNoDeflate;
    var convertOriginal = MSE.Data.Property.convertOriginal;
    var convertOriginalNoDeflate = MSE.Data.Property.convertOriginalNoDeflate;
    var list = MSE.Data.Property.list;
    var listWithContext = MSE.Data.Property.listWithContext;
    var format = MSE.Data.Property.format;
    var collect = MSE.Data.Property.collect;
    var filter = MSE.Data.Property.filter;
    var filterArray = MSE.Data.Property.filterArray;
    var value = MSE.Data.Property.value;
    var uncachable = MSE.Data.Property.uncachable;
    var hydrated = MSE.Data.Property.hydrated;
    var hydratedRequired = MSE.Data.Property.hydratedRequired;
    var convertFeatureOptionsMusicOrVideo = {feature: [Microsoft.Entertainment.FeatureEnablement.FeatureItem.musicMarketplace, Microsoft.Entertainment.FeatureEnablement.FeatureItem.moviesMarketplace, Microsoft.Entertainment.FeatureEnablement.FeatureItem.tvMarketplace]};
    WinJS.Namespace.define("MS.Entertainment.Data", {
        ImageIdType: {
            undefinedImageIdType: Microsoft.Entertainment.ImageIdType.undefinedImageIdType, application: Microsoft.Entertainment.ImageIdType.application, editorialAlbum: Microsoft.Entertainment.ImageIdType.album, editorialArtist: Microsoft.Entertainment.ImageIdType.artist, editorialMovie: Microsoft.Entertainment.ImageIdType.movie, editorialSeason: Microsoft.Entertainment.ImageIdType.season, editorialSeries: Microsoft.Entertainment.ImageIdType.series, editorialTrack: Microsoft.Entertainment.ImageIdType.track, parentalRating: Microsoft.Entertainment.ImageIdType.parentalRating, image: Microsoft.Entertainment.ImageIdType.image
        }, ItemLocation: {
                unknown: "unknown", collection: "collection", marketplace: "marketplace"
            }, ItemIdType: {
                unknown: "unknown", library: "library", service: "service"
            }, convertFeatureOptionsMusicOrVideo: convertFeatureOptionsMusicOrVideo
    });
    WinJS.Namespace.defineWithParent(MSE, "Data.Filter.Marketplace", {filterUnsupportedFlexItems: function filterUnsupportedFlexItems(item) {
            return item && !(item.link.type === MSE.Data.Augmenter.Marketplace.EditorialType.Movie || item.link.type === MSE.Data.Augmenter.Marketplace.EditorialType.Series || item.link.type === MSE.Data.Augmenter.Marketplace.EditorialType.Album || item.link.type === MSE.Data.Augmenter.Marketplace.EditorialType.Artist || item.link.type === MSE.Data.Augmenter.Marketplace.EditorialType.MovieTrailer || item.link.type === MSE.Data.Augmenter.Marketplace.EditorialType.Season || item.link.type === MSE.Data.Augmenter.Marketplace.EditorialType.Episode || item.link.type === MSE.Data.Augmenter.Marketplace.EditorialType.Hub)
        }});
    var xboxCatalogIdPrefix = "66acd000-77fe-1000-9115-d802";
    var classicWindowsCatalogIdPrefix = "66acd000-77fe-1000-9115-d804";
    MS.Entertainment.UI.Debug.defineAssert("MS.Entertainment.Data.Factory.Common");
    WinJS.Namespace.defineWithParent(MSE, "Data.Factory.Common", {
        createMediaItemFromEditorialItem: function createMediaItemFromEditorialItem(editorialItem) {
            var augmentation = MS.Entertainment.Utilities.getEditorialItemAugmentation(editorialItem && editorialItem.link && editorialItem.link.type);
            return MSE.Data.augment(editorialItem, augmentation)
        }, createMediaItemFromPinnedItem: function createMediaItemFromEditorialItem(pinnedItem) {
                var augmentation = MS.Entertainment.Utilities.getPinnedItemAugmentation(pinnedItem && pinnedItem.Item && pinnedItem.Item.ContentType);
                return MSE.Data.augment(pinnedItem.Item, augmentation)
            }, createMediaItemFromRecentItem: function createMediaItemFromEditorialItem(recentItem) {
                var augmentation = MS.Entertainment.Utilities.getRecentItemAugmentation(recentItem && recentItem.Item && recentItem.Item.ContentType, recentItem && recentItem.Item && recentItem.Item.AcquisitionContext);
                return MSE.Data.augment(recentItem.Item, augmentation)
            }, combineTitleAndSubTitle: function combineTitleAndSubTitle(mediaItem) {
                var result = String.empty;
                if (mediaItem)
                    if (!mediaItem.mainTitle)
                        result = mediaItem.subTitle;
                    else if (!mediaItem.subTitle)
                        result = mediaItem.mainTitle;
                    else
                        result = String.load(String.id.IDS_TITLE_SUBTITLE).format(mediaItem.mainTitle, mediaItem.subTitle);
                return result
            }, hasSmartGlassActivities: function hasSmartGlassActivities(hasActivities) {
                return false
            }, zuneDeviceTypesValidate: function zuneDeviceTypesValidate(deviceTypes) {
                newDeviceTypes = [];
                if (Array.isArray(deviceTypes))
                    deviceTypes.forEach(function validate(deviceType) {
                        if (deviceType === MS.Entertainment.Data.Augmenter.Marketplace.zuneDeviceType._pc)
                            newDeviceTypes.push(MS.Entertainment.Data.Augmenter.Marketplace.zuneDeviceType.pc);
                        else
                            newDeviceTypes.push(deviceType)
                    });
                return newDeviceTypes
            }, movieWebDetailsUri: function movieWebDetailsUri(id) {
                if (id)
                    return MS.Entertainment.Utilities.UriFactory.create(MS.Entertainment.Endpoint.id.seid_PCMarketplace, ["redirect"], {
                            type: "movie", id: id, target: "web"
                        });
                else
                    return null
            }, tvSeriesWebDetailsUri: function tvSeriesWebDetailsUri(id) {
                if (id)
                    return MS.Entertainment.Utilities.UriFactory.create(MS.Entertainment.Endpoint.id.seid_PCMarketplace, ["redirect"], {
                            type: "tvseries", id: id, target: "web"
                        });
                else
                    return null
            }, tvSeasonWebDetailsUri: function tvSeasonWebDetailsUri(seasonId) {
                if (seasonId)
                    return MS.Entertainment.Utilities.UriFactory.create(MS.Entertainment.Endpoint.id.seid_PCMarketplace, ["redirect"], {
                            type: "tvseries", id: seasonId, target: "web"
                        });
                else
                    return null
            }, tvEpisodeWebDetailsUri: function tvEpisodeWebDetailsUri(id) {
                if (id)
                    return MS.Entertainment.Utilities.UriFactory.create(MS.Entertainment.Endpoint.id.seid_PCMarketplace, ["redirect"], {
                            type: "tvepisode", id: id, target: "web"
                        });
                else
                    return null
            }, videoWebDetailsUri: function videoWebDetailsUri(data) {
                var result = null;
                if (!data)
                    return result;
                switch (data.videoType) {
                    case Microsoft.Entertainment.Queries.VideoType.movie:
                        result = MSE.Data.Factory.Common.movieWebDetailsUri(data.serviceId);
                        break;
                    case Microsoft.Entertainment.Queries.VideoType.tvEpisode:
                        result = MSE.Data.Factory.Common.tvEpisodeWebDetailsUri(data.serviceId);
                        break;
                    case Microsoft.Entertainment.Queries.VideoType.musicVideo:
                    case Microsoft.Entertainment.Queries.VideoType.other:
                        break;
                    default:
                        MS.Entertainment.Data.Factory.Common.assert(false, "Unknown videoType in videoWebDetailsUri");
                        break
                }
                return result
            }, tvSeasonServiceId: function tvSeasonServiceId(season) {
                if (season)
                    return "{0}_s{1}".format(season.seriesId, season.seasonNumber);
                else
                    return null
            }, personWebDetailsUri: function personWebDetailsUri(data) {
                var result = null;
                if (!data)
                    return result;
                switch (data.personType) {
                    case Microsoft.Entertainment.Queries.PersonType.artist:
                    case Microsoft.Entertainment.Queries.PersonType.primaryArtist:
                        result = MSE.Data.Factory.Common.musicArtistWebDetailsUri(data.serviceId);
                        break;
                    case Microsoft.Entertainment.Queries.PersonType.actor:
                    case Microsoft.Entertainment.Queries.PersonType.composer:
                    case Microsoft.Entertainment.Queries.PersonType.conductor:
                    case Microsoft.Entertainment.Queries.PersonType.creator:
                    case Microsoft.Entertainment.Queries.PersonType.director:
                    case Microsoft.Entertainment.Queries.PersonType.influencer:
                    case Microsoft.Entertainment.Queries.PersonType.producer:
                    case Microsoft.Entertainment.Queries.PersonType.writer:
                        break;
                    default:
                        MS.Entertainment.Data.Factory.Common.assert(false, "Unknown personType in personWebDetailsUri");
                        break
                }
                return result
            }, webDetailsUri: function webDetailsUri(data) {
                var result = null;
                if (!data)
                    return result;
                try {
                    switch (data.mediaType) {
                        case Microsoft.Entertainment.Queries.ObjectType.video:
                            result = MSE.Data.Factory.Common.videoWebDetailsUri(data);
                            break;
                        case Microsoft.Entertainment.Queries.ObjectType.person:
                            result = MSE.Data.Factory.Common.personWebDetailsUri(data);
                            break;
                        case Microsoft.Entertainment.Queries.ObjectType.tvSeries:
                            result = MSE.Data.Factory.Common.tvSeriesWebDetailsUri(data.hasZuneId ? data.zuneId : data.serviceId);
                            break;
                        case Microsoft.Entertainment.Queries.ObjectType.tvSeason:
                            var seriesId;
                            if (data.seriesIdType === MS.Entertainment.Data.Query.edsIdType.zuneCatalog)
                                seriesId = data.seriesId;
                            else
                                seriesId = data.seriesServiceId;
                            result = MSE.Data.Factory.Common.tvSeasonWebDetailsUri(seriesId + "_s" + data.seasonNumber);
                            break;
                        case Microsoft.Entertainment.Queries.ObjectType.album:
                            result = MSE.Data.Factory.Common.musicAlbumWebDetailsUri(data.hasZuneId ? data.zuneId : data.serviceId);
                            break;
                        case Microsoft.Entertainment.Queries.ObjectType.track:
                            result = MSE.Data.Factory.Common.musicTrackWebDetailsUri(data.hasZuneId ? data.zuneId : data.serviceId);
                            break;
                        case Microsoft.Entertainment.Queries.ObjectType.bio:
                        case Microsoft.Entertainment.Queries.ObjectType.editorial:
                        case Microsoft.Entertainment.Queries.ObjectType.genre:
                        case Microsoft.Entertainment.Queries.ObjectType.playlist:
                        case Microsoft.Entertainment.Queries.ObjectType.review:
                            break;
                        default:
                            MS.Entertainment.Data.Factory.Common.assert(false, "Unknown mediaType in webDetailsUri");
                            break
                    }
                }
                catch(error) {
                    result = null
                }
                return result
            }, imageUri: function imageUri(data) {
                var result;
                var imageType = MS.Entertainment.Data.ImageIdType.undefinedImageIdType;
                var imageId;
                var imageChildId;
                if (!data || data.mediaType === null || data.mediaType === undefined)
                    return result;
                switch (data.mediaType) {
                    case Microsoft.Entertainment.Queries.ObjectType.game:
                        imageType = MS.Entertainment.Data.ImageIdType.xboxGame;
                        imageId = data.titleId;
                        break;
                    case Microsoft.Entertainment.Queries.ObjectType.video:
                        imageId = data.serviceId;
                        switch (data.videoType) {
                            case Microsoft.Entertainment.Queries.VideoType.movie:
                                imageType = MS.Entertainment.Data.ImageIdType.movie;
                                break;
                            case Microsoft.Entertainment.Queries.VideoType.tvEpisode:
                                imageType = MS.Entertainment.Data.ImageIdType.series;
                                break
                        }
                        {};
                        break;
                    case Microsoft.Entertainment.Queries.ObjectType.tvSeries:
                        imageType = MS.Entertainment.Data.ImageIdType.series;
                        imageId = data.serviceId;
                        break;
                    case Microsoft.Entertainment.Queries.ObjectType.tvSeason:
                        imageType = MS.Entertainment.Data.ImageIdType.season;
                        imageId = data.seriesId;
                        imageChildId = data.seasonNumber;
                        break;
                    case Microsoft.Entertainment.Queries.ObjectType.album:
                        imageType = MS.Entertainment.Data.ImageIdType.album;
                        imageId = data.serviceId;
                        break;
                    case Microsoft.Entertainment.Queries.ObjectType.track:
                        if (data.albumServiceId) {
                            imageType = MS.Entertainment.Data.ImageIdType.album;
                            imageId = data.albumServiceId
                        }
                        else if (data.artistServiceId) {
                            imageType = MS.Entertainment.Data.ImageIdType.artist;
                            imageId = data.artistServiceId
                        }
                        else {
                            imageType = MS.Entertainment.Data.ImageIdType.track;
                            imageId = data.serviceId
                        }
                        break;
                    case Microsoft.Entertainment.Queries.ObjectType.person:
                        switch (data.personType) {
                            case Microsoft.Entertainment.Queries.PersonType.artist:
                            case Microsoft.Entertainment.Queries.PersonType.primaryArtist:
                                if (data.imageId) {
                                    imageType = MS.Entertainment.Data.ImageIdType.image;
                                    imageId = data.imageId
                                }
                                else if (data.latestAlbumImageId) {
                                    imageType = MS.Entertainment.Data.ImageIdType.image;
                                    imageId = data.latestAlbumImageId
                                }
                                else {
                                    imageType = MS.Entertainment.Data.ImageIdType.artist;
                                    imageId = data.serviceId
                                }
                                break
                        }
                        break
                }
                if (imageId && imageType !== MS.Entertainment.Data.ImageIdType.undefinedImageIdType)
                    result = MS.Entertainment.UI.Shell.ImageLoader.makeCatalogImageUri(imageId, imageType, null, true, null, null, imageChildId);
                return result
            }
    });
    WinJS.Namespace.defineWithParent(MSE, "Data.Augmenter", {
        GamePlatform: {
            PC: "PC", Xbox: "Xbox", Phone: "Phone", Modern: "Modern", Web: "Web", Unknown: "Unknown"
        }, GameTitleType: {
                game: "Game", application: "App"
            }, GameSupportedPlatform: {
                Xbox360: "Xbox360", WebGames: "WebGames"
            }, ServiceTypes: {
                editorialItem: 1, wmis: 2, audioAd: 3
            }
    });
    WinJS.Namespace.defineWithParent(MSE, "Data.Augmenter.Marketplace", {zuneDeviceType: {
            all: "All", pc: "WindowsPC", xblWinClient: "XblWinClient", xbox360: "Xbox360", zuneDevice: "Zune3.0", zuneMobile: "ZuneMobile", _pc: "PC/Windows"
        }});
    WinJS.Namespace.defineWithParent(MSE, "Data.Factory.Library", {scaleGroupHintNumber: function scaleGroupHintNumber(number) {
            var result = 0;
            if (!isNaN(number))
                result = Math.log(number + 1);
            return result
        }});
    WinJS.Namespace.defineWithParent(MSE, "Data.Factory.Library", {
        mediaTypeToSubTypeMappings: (function() {
            var mapping;
            return {get: function mediaTypeToSubTypeMappings_get() {
                        if (mapping)
                            return mapping;
                        mapping = {};
                        mapping[Microsoft.Entertainment.Queries.ObjectType.album] = null;
                        mapping[Microsoft.Entertainment.Queries.ObjectType.game] = [Microsoft.Entertainment.Queries.GameType, Microsoft.Entertainment.Queries.GameTitleType];
                        mapping[Microsoft.Entertainment.Queries.ObjectType.person] = Microsoft.Entertainment.Queries.PersonType;
                        mapping[Microsoft.Entertainment.Queries.ObjectType.playlist] = Microsoft.Entertainment.Platform.PlaylistType;
                        mapping[Microsoft.Entertainment.Queries.ObjectType.smartDJ] = Microsoft.Entertainment.Queries.SmartDJObjectTypes;
                        mapping[Microsoft.Entertainment.Queries.ObjectType.track] = null;
                        mapping[Microsoft.Entertainment.Queries.ObjectType.tvSeason] = null;
                        mapping[Microsoft.Entertainment.Queries.ObjectType.tvSeries] = null;
                        mapping[Microsoft.Entertainment.Queries.ObjectType.video] = Microsoft.Entertainment.Queries.VideoType;
                        return mapping
                    }}
        })(), mediaTypeToSubTypeNameMappings: (function() {
                var mapping;
                return {get: function mediaTypeToSubTypeNameMappings_get() {
                            if (mapping)
                                return mapping;
                            mapping = {};
                            mapping[Microsoft.Entertainment.Queries.ObjectType.album] = null;
                            mapping[Microsoft.Entertainment.Queries.ObjectType.game] = ["gameType", "gameTitleType"];
                            mapping[Microsoft.Entertainment.Queries.ObjectType.person] = "personType";
                            mapping[Microsoft.Entertainment.Queries.ObjectType.playlist] = "playlistType";
                            mapping[Microsoft.Entertainment.Queries.ObjectType.smartDJ] = "smartDJType";
                            mapping[Microsoft.Entertainment.Queries.ObjectType.track] = null;
                            mapping[Microsoft.Entertainment.Queries.ObjectType.tvSeason] = null;
                            mapping[Microsoft.Entertainment.Queries.ObjectType.tvSeries] = null;
                            mapping[Microsoft.Entertainment.Queries.ObjectType.video] = "videoType";
                            return mapping
                        }}
            })(), mediaTypeToRatingTypeMappings: (function() {
                var mapping;
                return {get: function mediaTypeToRatingTypeMappings() {
                            if (mapping)
                                return mapping;
                            mapping = {};
                            if (Microsoft.Entertainment.Platform.RatingType) {
                                mapping[Microsoft.Entertainment.Queries.ObjectType.tvSeries] = Microsoft.Entertainment.Platform.RatingType.tvSeries;
                                mapping[Microsoft.Entertainment.Queries.ObjectType.video] = Microsoft.Entertainment.Platform.RatingType.movie
                            }
                            return mapping
                        }}
            })(), createGroupHintsListItemFactory: function createGroupHintsListItemFactory(augmentation) {
                var innerFactory = MSE.Data.Factory.createListItemAugmentationFactory(augmentation, null, MSE.Data.Factory.GroupHintWrapper);
                var groupHintsListItem = function groupHintsListItem(sourceItem, context) {
                        var result = innerFactory(sourceItem);
                        if (result && result.data && !isNaN(context))
                            result.data.largestTotalCount = context;
                        return result
                    };
                groupHintsListItem.listItemFactory = innerFactory.listItemFactory;
                return groupHintsListItem
            }
    });
    WinJS.Namespace.defineWithParent(MSE, "Data.Factory.Marketplace.Rights", {
        hasRight: function hasRight(rights, rightTypes) {
            var rightTypeIndex,
                rightIndex;
            var foundRight = false;
            if (rights && rightTypes)
                for (rightIndex in rights) {
                    for (rightTypeIndex in rightTypes)
                        if (rights[rightIndex] && rights[rightIndex].licenseRight === rightTypes[rightTypeIndex]) {
                            foundRight = true;
                            break
                        }
                    if (foundRight)
                        break
                }
            return foundRight
        }, hasPreviewRight: function hasPreviewRight(rights) {
                return MSE.Data.Factory.Marketplace.Rights.hasRight(rights, [MSE.Data.Augmenter.Marketplace.RightType.preview])
            }
    });
    WinJS.Namespace.defineWithParent(MSE, "Data.Augmenter", {MediaItem: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.Data.define(function MediaItem() {
                    this.base.apply(this, arguments);
                    MS.Entertainment.Utilities.addEventHandlers(this, {libraryIdChanged: function libraryIdChanged() {
                            this.dispatchChangeAndNotify("inCollection", this.inCollection, !this.inCollection)
                        }.bind(this)})
                }, {
                    serviceId: String.empty, serviceIdType: String.empty, zuneId: String.empty, canonicalId: String.empty, libraryId: hydrated(value(-1)), impressionGuid: hydrated(value(null)), localTracksCount: alias("LocalTracksCount", 0), offlineFilesCount: alias("OfflineFilesCount", 0), remoteTracksCount: alias("RemoteTracksCount", 0), remoteFilesCount: alias("RemoteFilesCount", 0), totalTracksCount: alias("TotalTracksCount"), mediaType: -1, name: hydratedRequired(value(String.empty)), title: hydratedRequired(convertNoDeflate("name", MSE.Data.Factory.self)), isPinnedToStartScreen: null, location: null, canPurchaseDownload: alias("CanPurchaseDownload", false), canPurchaseStream: alias("CanPurchaseStream", false), canRentStream: alias("CanRentStream", false), canRentDownload: alias("CanRentDownload", false), canSubscriptionDownload: alias("CanSubscriptionDownload", false), canPlayLocally: alias("CanPlayLocally", false), canPlayStream: alias("CanStream", false), canFreeStream: alias("CanFreeStream", false), canSubscriptionStream: alias("CanSubscriptionStream", false), primaryImageUri: hydrated(convertNoDeflate(String.empty, MSE.Data.Factory.Common.imageUri, String.empty)), webUri: convertNoDeflate(String.empty, MSE.Data.Factory.Common.webDetailsUri, String.empty), parent: null, acquisitionData: null, mediaTypeString: {get: function() {
                                return String.empty
                            }}, expectedMediaTypeString: {get: function() {
                                return String.empty
                            }}, isValid: {get: function() {
                                return this.hasServiceId || this.inCollection || this.hasCanonicalId || this.hasZuneId
                            }}, isValidType: {get: function() {
                                return true
                            }}, inCollection: uncachable(value(function get_inCollection() {
                            return MS.Entertainment.Utilities.isValidLibraryId(this.libraryId)
                        })), hasServiceId: {get: function() {
                                return !MS.Entertainment.Utilities.isEmptyGuid(this.serviceId)
                            }}, hasCanonicalId: {get: function() {
                                return !MS.Entertainment.Utilities.isEmptyGuid(this.canonicalId)
                            }}, hasZuneId: {get: function() {
                                return !MS.Entertainment.Utilities.isEmptyGuid(this.zuneId)
                            }}, isRemovable: {get: function() {
                                return (this.inCollection && (this.mediaType === Microsoft.Entertainment.Queries.ObjectType.album || this.mediaType === Microsoft.Entertainment.Queries.ObjectType.tvSeason || this.mediaType === Microsoft.Entertainment.Queries.ObjectType.tvSeries || this.mediaType === Microsoft.Entertainment.Queries.ObjectType.video || this.mediaType === Microsoft.Entertainment.Queries.ObjectType.playlist || (this.mediaType === Microsoft.Entertainment.Queries.ObjectType.track && !(this.playlistId >= 0))))
                            }}, canTransfer: {get: function get_canTransfer() {
                                switch (this.mediaType) {
                                    case Microsoft.Entertainment.Queries.ObjectType.person:
                                    case Microsoft.Entertainment.Queries.ObjectType.album:
                                        return this.remoteTracksCount < this.totalTracksCount;
                                    case Microsoft.Entertainment.Queries.ObjectType.track:
                                        return this.remoteFilesCount === 0 && this.localFilesCount > 0;
                                    default:
                                        return false
                                }
                            }}, hasRemoteContent: {get: function get_hasRemoteContent() {
                                switch (this.mediaType) {
                                    case Microsoft.Entertainment.Queries.ObjectType.person:
                                    case Microsoft.Entertainment.Queries.ObjectType.album:
                                        return this.remoteTracksCount > 0;
                                    case Microsoft.Entertainment.Queries.ObjectType.track:
                                        return this.remoteFilesCount > 0;
                                    default:
                                        return false
                                }
                            }}, hasLocalContent: {get: function get_hasLocalContent() {
                                switch (this.mediaType) {
                                    case Microsoft.Entertainment.Queries.ObjectType.person:
                                    case Microsoft.Entertainment.Queries.ObjectType.album:
                                        return this.localTracksCount > 0;
                                    case Microsoft.Entertainment.Queries.ObjectType.track:
                                        return (this.localTracksCount + this.offlineFilesCount) > 0;
                                    case Microsoft.Entertainment.Queries.ObjectType.video:
                                        return this.localTracksCount > 0;
                                    default:
                                        return true
                                }
                            }}, isEqual: function MediaItem_GenericComparer(mediaItem2) {
                            var isSame = false;
                            if (mediaItem2 && ((!MS.Entertainment.Utilities.isEmptyGuid(this.serviceId) && mediaItem2.serviceId === this.serviceId) || (!MS.Entertainment.Utilities.isEmptyGuid(this.canonicalId) && mediaItem2.canonicalId === this.canonicalId) || (!MS.Entertainment.Utilities.isEmptyGuid(this.zuneId) && mediaItem2.zuneId === this.zuneId) || (MS.Entertainment.Utilities.isValidLibraryId(this.libraryId) && mediaItem2.libraryId === this.libraryId) || (this.titleId && mediaItem2.titleId === this.titleId) || (this.filePath && mediaItem2.filePath === this.filePath) || (this.activationFilePath && mediaItem2.activationFilePath === this.activationFilePath) || (this.cloudSyncItemId && mediaItem2.cloudSyncItemId === this.cloudSyncItemId)))
                                isSame = true;
                            return isSame
                        }, isChildOf: function isChildOf(mediaItem2) {
                            var isChild = false;
                            if (mediaItem2 && this.parent)
                                if ((!MS.Entertainment.Utilities.isEmptyGuid(mediaItem2.zuneId) && mediaItem2.zuneId === this.parent.zuneId) || (!MS.Entertainment.Utilities.isEmptyGuid(mediaItem2.canonicalId) && mediaItem2.canonicalId === this.parent.canonicalId))
                                    isChild = true;
                                else
                                    isChild = this.parent.isChildOf(mediaItem2);
                            return isChild
                        }, sharesParentWith: function sharesParentWith(mediaItem2) {
                            var sharesParent = false;
                            if (mediaItem2 && mediaItem2.parent && this.parent) {
                                if ((!MS.Entertainment.Utilities.isEmptyGuid(mediaItem2.parent.zuneId) && mediaItem2.parent.zuneId === this.parent.zuneId) || (!MS.Entertainment.Utilities.isEmptyGuid(mediaItem2.parent.canonicalId) && mediaItem2.parent.canonicalId === this.parent.canonicalId))
                                    sharesParent = true;
                                else
                                    sharesParent = this.sharesParentWith(mediaItem2.parent);
                                if (!sharesParent)
                                    sharesParent = this.parent.sharesParentWith(mediaItem2)
                            }
                            return sharesParent
                        }, sharesDirectParentWith: function sharesDirectParentWith(mediaItem2) {
                            var sharesParent = false;
                            if (mediaItem2 && mediaItem2.parent && this.parent && this.parent.isEqual)
                                sharesParent = this.parent.isEqual(mediaItem2.parent);
                            return sharesParent
                        }, canDownload: {get: function get_canDownload() {
                                return this.canPurchaseDownload || this.canRentDownload || this.canSubscriptionDownload
                            }}, canPlay: {get: function get_canPlay() {
                                return this.canPlayLocally || this.canPlayStream
                            }}, canStream: {get: function get_canStream() {
                                return this.canPurchaseStream || this.canRentStream || this.canFreeStream || this.canSubscriptionStream
                            }}
                })
        })});
    WinJS.Namespace.defineWithParent(MSE, "Data.Augmenter.Common", {
        ErrorCode: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.Data.define(null, {
                    exactMatches: convert("Envelope.Body.LookupFullParamResponse.LookupFullParamResult.ExactResultsCount", MSE.Data.Factory.intNumber, 0), errorCodeUrl: alias("Envelope.Body.LookupFullParamResponse.LookupFullParamResult.ExactMatch.ErrorArticleUrl", "http://go.microsoft.com/fwlink/?LinkId=246305")
                })
        }), IntroPanelContent: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {
                        title: convertOriginal("Title", MSE.Data.Factory.normalizeTextDirection, String.empty), details: convert("BodyText.p", MSE.Data.Factory.arrayJoinWithNewLines, String.empty), subtitle: convertOriginal("Subtitle", MSE.Data.Factory.normalizeTextDirection, String.empty)
                    })
            })
    });
    WinJS.Namespace.defineWithParent(MSE, "Data.Augmenter.Library", {
        MediaItem: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.Data.derive(MSE.Data.Augmenter.MediaItem, null, {
                    libraryId: convert("ObjectId", MSE.Data.Factory.intNumber, -1), serviceId: convert("ServiceMediaId", MSE.Data.Factory.guid, String.empty, convertFeatureOptionsMusicOrVideo), serviceIdType: "ZuneCatalog", zuneId: convert("ServiceMediaId", MSE.Data.Factory.guid, String.empty, convertFeatureOptionsMusicOrVideo), imageUri: hydratedRequired(alias("ImageUrl", null)), imageResizeUri: hydratedRequired(alias("ImageUrl", null)), fromCollection: true, canonicalId: hydrated(convert("BingId", MSE.Data.Factory.guid, String.empty, convertFeatureOptionsMusicOrVideo)), collectionState: alias("CollectionState", null), canSubscriptionDownload: alias("CanSubscriptionDownload", false), inCollection: uncachable(value(function get_inCollection() {
                            return MS.Entertainment.Utilities.isValidLibraryId(this.libraryId) && this.collectionState !== Microsoft.Entertainment.Queries.ItemCollectionState.notInCollection && this.collectionState !== Microsoft.Entertainment.Queries.ItemCollectionState.notInCollectionValidRights && this.collectionState !== Microsoft.Entertainment.Queries.ItemCollectionState.notInCollectionTakenDown && this.collectionState !== Microsoft.Entertainment.Queries.ItemCollectionState.notInCollectionValidRights
                        }))
                })
        }), Genre: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.MediaItem, null, {
                        libraryId: convert("ObjectId", MSE.Data.Factory.intNumber, -1), value: convert("ObjectId", MSE.Data.Factory.intNumber, -1), name: alias("Name", String.empty), label: alias("Name", String.empty), mediaType: Microsoft.Entertainment.Queries.ObjectType.genre, type: "genre"
                    })
            }), LibraryResultSet: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {totalCount: alias("TotalCount", -1)})
            }), GroupItemHintBase: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {
                        _title: convert("Name", MSE.Data.Factory.stringOrUnknown), title: convertOriginalNoDeflate("_title", MSE.Data.Factory.normalizeTextDirection, String.empty), groupKey: convert([["GroupId", "SortName"]], MSE.Data.Factory.joinStrings, null), firstItemIndexSourceHint: alias("DBOffsetIndex", 0)
                    })
            })
    });
    WinJS.Namespace.defineWithParent(MSE, "Data.Augmenter.Library", {GroupItemHint: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.Data.derive(MSE.Data.Augmenter.Library.GroupItemHintBase, null, {
                    _title: convert("Name", MSE.Data.Factory.stringOrUnknown), title: convertOriginalNoDeflate("_title", MSE.Data.Factory.normalizeTextDirection, String.empty), groupKey: convert("GroupId", MSE.Data.Factory.string, null), description: convert("ItemsCount", MSE.Data.Factory.string, String.empty), totalCount: alias("ItemsCount", 0), largestTotalCount: 0, totalCountScaled: uncachable(convertNoDeflate("totalCount", MSE.Data.Factory.Library.scaleGroupHintNumber, 0)), largestTotalCountScaled: uncachable(convertNoDeflate("largestTotalCount", MSE.Data.Factory.Library.scaleGroupHintNumber, 0)), firstItemIndexSourceHint: alias("DBOffsetIndex", 0), subGroupHints: augment("SubGroups", MSE.Data.Augmenter.Library.GroupItemHintBase, null)
                })
        })});
    WinJS.Namespace.defineWithParent(MSE, "Data.Augmenter.Library", {
        MediaItemContainer: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.Data.derive(MSE.Data.Augmenter.Library.MediaItem, null, {knownChildServiceIds: null})
        }), GenresResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Library.LibraryResultSet, null, {
                        items: list("ResultSet", MSE.Data.Augmenter.Library.Genre, null), itemsArray: augment("ResultSet", MSE.Data.Augmenter.Library.Genre, null)
                    })
            }), GroupsAugmentation: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {
                        items: listWithContext("Groups", "LargestGroupItemsCount", MSE.Data.Factory.Library.createGroupHintsListItemFactory(MSE.Data.Augmenter.Library.GroupItemHint)), totalCount: alias("TotalCount")
                    })
            })
    });
    WinJS.Namespace.defineWithParent(MSE, "Data.Augmenter.Marketplace", {
        EditorialType: {
            Movie: "Movie", Series: "Series", Album: "Album", Artist: "Artist", MusicVideo: "MusicVideo", Track: "Track", Playlist: "Playlist", Game: "Game", MovieTrailer: "MovieTrailer", Hub: "Hub", FlexHub: "FlexHub", Season: "Season", Episode: "Episode"
        }, RightType: {
                albumPurchase: "AlbumPurchase", preview: "Preview", purchase: "Purchase", purchaseStream: "PurchaseStream", rent: "Rent", rentStream: "RentStream", stream: "Stream", freeStream: "FreeStream", subscription: "Subscription", subscriptionFree: "SubscriptionFree", seasonPurchase: "SeasonPurchase", seasonPurchaseStream: "SeasonPurchaseStream"
            }, IntroPanelResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {item: augment("ContentManifest.Content", MSE.Data.Augmenter.Common.IntroPanelContent)})
            })
    });
    WinJS.Namespace.defineWithParent(MSE, "Data.Augmenter.Marketplace", {
        MediaItem: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.Data.derive(MSE.Data.Augmenter.MediaItem, null, {
                    mediaType: null, serviceIdType: "ZuneCatalog", serviceId: convert("id", MSE.Data.Factory.guid, String.empty), zuneId: convert("id", MSE.Data.Factory.guid, String.empty), canonicalId: convert("id", MSE.Data.Factory.guid, String.empty), contentType: alias("type", String.empty), hasActivities: convert("HasActivities", MSE.Data.Factory.Common.hasSmartGlassActivities, false), collectionState: alias("CollectionState", null)
                })
        }), Right: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {
                        mediaInstanceId: convert("mediaInstanceId", MSE.Data.Factory.guid, String.empty), offerId: convert("offerId", MSE.Data.Factory.guid, String.empty), licenseRight: alias("licenseRight", String.empty), videoDefinition: alias("videoDefinition", String.empty), videoEncoding: alias("videoEncoding", String.empty), videoFileUrl: alias("videoFileUrl", String.empty), clientTypes: convert("clientTypes.clientType", MSE.Data.Factory.Common.zuneDeviceTypesValidate, MSE.Data.Factory.array), paymentInstruments: alias("paymentTypes.paymentType", MSE.Data.Factory.array)
                    })
            }), EditorialImage: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {id: alias("id", null)})
            }), EditorialItem: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {
                        id: alias("id", String.empty), libraryId: hydrated(value(-1)), serviceIdType: "ZuneCatalog", serviceId: convert("link.target", MSE.Data.Factory.guid, String.empty), zuneId: convert("link.target", MSE.Data.Factory.guid, String.empty), canonicalId: MS.Entertainment.Utilities.EMPTY_GUID, type: alias("link.type", String.empty), target: alias("link.target", String.empty), editorialTitle: convertOriginal("title", MSE.Data.Factory.normalizeTextDirection, String.empty), primaryText: convertOriginal("title", MSE.Data.Factory.normalizeTextDirection, String.empty), secondaryText: convertOriginal("text", MSE.Data.Factory.normalizeTextDirection, String.empty), title: String.empty, text: convertOriginal("text", MSE.Data.Factory.normalizeTextDirection, String.empty), imageId: convert("image.id", MSE.Data.Factory.guid, String.empty), backgroundImageId: alias("backgroundImage.id", String.empty), serviceType: MSE.Data.Augmenter.ServiceTypes.editorialItem, image: augment("image", MSE.Data.Augmenter.Marketplace.EditorialImage, null)
                    })
            }), EditorialHub: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {
                        mediaType: Microsoft.Entertainment.Queries.ObjectType.editorial, id: alias("id", String.empty), libraryId: hydrated(value(-1)), serviceIdType: "ZuneCatalog", serviceId: convert("link.target", MSE.Data.Factory.guid, String.empty), zuneId: convert("link.target", MSE.Data.Factory.guid, String.empty), canonicalId: MS.Entertainment.Utilities.EMPTY_GUID, type: alias("link.type", String.empty), target: alias("link.target", String.empty), editorialTitle: convertOriginal("title", MSE.Data.Factory.normalizeTextDirection, String.empty), primaryText: convertOriginal("title", MSE.Data.Factory.normalizeTextDirection, String.empty), secondaryText: convertOriginal("text", MSE.Data.Factory.normalizeTextDirection, String.empty), title: String.empty, text: convertOriginal("text", MSE.Data.Factory.normalizeTextDirection, String.empty), imageId: convert("image.id", MSE.Data.Factory.guid, String.empty), backgroundImageId: alias("backgroundImage.id", String.empty), serviceType: MSE.Data.Augmenter.ServiceTypes.editorialItem, isNotMedia: true
                    })
            }), GenreQueryOptions: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {
                        genreId: convert("id", MSE.Data.Factory.guid, String.empty), parentGenreId: convert("parentId", MSE.Data.Factory.guid, String.empty)
                    })
            }), ClosedCaption: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {
                        mediaInstanceId: convert("mediaInstanceId", MSE.Data.Factory.guid, String.empty), fileUri: alias("fileUri", String.empty), lcid: alias("lcid", String.empty), name: alias("name", String.empty)
                    })
            })
    });
    WinJS.Namespace.defineWithParent(MSE, "Data.Augmenter.Marketplace", {
        MediaItemContainer: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.Data.derive(MSE.Data.Augmenter.Library.MediaItem, null, {knownChildServiceIds: null})
        }), PrefixData: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.MediaItem, null, {
                        serviceId: convert("id", MSE.Data.Factory.guid, String.empty), zuneId: alias("id", String.empty), name: convertOriginal("title.$value", MSE.Data.Factory.normalizeTextDirection, String.empty), type: alias("type", String.empty), score: convert("score", MSE.Data.Factory.intNumber, 0)
                    })
            }), Genre: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.MediaItem, null, {
                        serviceId: convert("id", MSE.Data.Factory.guid, String.empty), name: alias("title", String.empty), mediaType: Microsoft.Entertainment.Queries.ObjectType.genre
                    })
            }), EditorialItemsEntry: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {
                        id: alias("id", String.empty), editorialItems: augment("editorialItems.editorialItem", MS.Entertainment.Data.Factory.Common.createMediaItemFromEditorialItem, null), catalogId: MS.Entertainment.Utilities.Telemetry.ContentCatalogId.EDS, sourceId: MS.Entertainment.Utilities.Telemetry.ContentSourceId.Compass
                    })
            }), GenrePivotValue: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {
                        queryOptions: augment(String.empty, MSE.Data.Augmenter.Marketplace.GenreQueryOptions, null), itemQueryOptions: augment(String.empty, MSE.Data.Augmenter.Marketplace.GenreQueryOptions, null), itemQuery: {get: function() {
                                    return MS.Entertainment.Data.Query.musicSubGenre
                                }}
                    })
            }), EditorialResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {
                        items: filter("feed.entry[0].editorialItems.editorialItem", MS.Entertainment.Data.Filter.Marketplace.filterUnsupportedFlexItems, MS.Entertainment.Data.Factory.Common.createMediaItemFromEditorialItem, null), itemsArray: filterArray("feed.entry[0].editorialItems.editorialItem", MS.Entertainment.Data.Filter.Marketplace.filterUnsupportedFlexItems, MS.Entertainment.Data.Factory.Common.createMediaItemFromEditorialItem), name: alias("feed.title.$value", MSE.Data.Factory.normalizeTextDirection, String.empty)
                    })
            })
    });
    WinJS.Namespace.defineWithParent(MSE, "Data.Augmenter.Marketplace", {RichGenre: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.Genre, null, {
                    name: alias(["title.$value", "title"], String.empty), serviceId: alias("id", String.empty), parentServiceId: alias("parentId", String.empty), isRoot: convert("isRoot", MSE.Data.Factory.boolFromString, true), label: alias(["title.$value", "title"], String.empty), value: augment(String.empty, MSE.Data.Augmenter.Marketplace.GenrePivotValue), items: null, selected: false, expanded: false, tabPanelId: null, childIds: null, ariaLevel: 1
                })
        })});
    WinJS.Namespace.defineWithParent(MSE, "Data.Augmenter.Marketplace", {SubRichGenre: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.RichGenre, null, {
                    items: undefined, expanded: undefined, ariaLevel: 2
                })
        })});
    WinJS.Namespace.defineWithParent(MSE, "Data.Augmenter.Marketplace", {
        GenericMediaResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.Data.define(null, {item: augment("entry", MSE.Data.Augmenter.Marketplace.MediaItem, null)})
        }), PrefixResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {items: list("feed.entry", MSE.Data.Augmenter.Marketplace.PrefixData, null)})
            }), GenresResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {items: list("feed.entry", MSE.Data.Augmenter.Marketplace.RichGenre, null)})
            }), SubGenresResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {items: list("entry.subGenres.genre", MSE.Data.Augmenter.Marketplace.SubRichGenre, null)})
            }), EntriesResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {
                        entries: list("feed.entry", MSE.Data.Augmenter.Marketplace.EditorialItemsEntry, null), entriesArray: augment("feed.entry", MSE.Data.Augmenter.Marketplace.EditorialItemsEntry, null), itemsArray: convertNoDeflate("entriesArray", MSE.Data.Factory.self, null)
                    })
            })
    });
    WinJS.Namespace.defineWithParent(MSE, "Data.Augmenter.Marketplace", {MediaSharePackage: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.Data.define(null, {
                    mediaId: alias("serviceId", String.empty), mediaType: alias("mediaType", 0), mediaTitle: alias("name", String.empty), title: alias("name", String.empty), description: alias("description", String.empty), text: alias("name", String.empty), uri: alias("webUri", String.empty), htmlUri: alias("webUri", String.empty), htmlImages: collect(["imageUri", "primaryImageUri"], null, String.empty), htmlLines: collect(["name", "description"], null, String.empty)
                })
        })})
})(MS.Entertainment)
