﻿/* Copyright (C) Microsoft Corporation. All rights reserved. */
scriptValidator();
(function(MSE, undefined) {
    "use strict";
    var alias = MSE.Data.Property.alias;
    var augment = MSE.Data.Property.augment;
    var augmentNoDeflate = MSE.Data.Property.augmentNoDeflate;
    var convert = MSE.Data.Property.convert;
    var convertNoDeflate = MSE.Data.Property.convertNoDeflate;
    var convertOriginal = MSE.Data.Property.convertOriginal;
    var convertOriginalNoDeflate = MSE.Data.Property.convertOriginalNoDeflate;
    var list = MSE.Data.Property.list;
    var format = MSE.Data.Property.format;
    var collect = MSE.Data.Property.collect;
    var filter = MSE.Data.Property.filter;
    var filterArray = MSE.Data.Property.filterArray;
    var filterNoDeflate = MSE.Data.Property.filterNoDeflate;
    var filterArrayNoDeflate = MSE.Data.Property.filterArrayNoDeflate;
    var search = MSE.Data.Property.search;
    var searchNoDeflate = MSE.Data.Property.searchNoDeflate;
    var sortArray = MSE.Data.Property.sortArray;
    var format = MSE.Data.Property.format;
    var value = MSE.Data.Property.value;
    var hydrated = MSE.Data.Property.hydrated;
    var hydratedRequired = MSE.Data.Property.hydratedRequired;
    var defaultVoiceConfidence = MSE.Data.Factory.defaultVoiceConfidence;
    var convertFeatureOptionsTv = {feature: Microsoft.Entertainment.FeatureEnablement.FeatureItem.tvMarketplace};
    var convertFeatureOptionsTvOrMovies = {feature: [Microsoft.Entertainment.FeatureEnablement.FeatureItem.tvMarketplace, Microsoft.Entertainment.FeatureEnablement.FeatureItem.moviesMarketplace]};
    var convertFeatureOptionsClosedCaptions = {feature: Microsoft.Entertainment.FeatureEnablement.FeatureItem.closedCaptionsEnabled};
    WinJS.Namespace.defineWithParent(MSE, "Data.Augmenter.Marketplace", {
        edsVideoRating: {
            notRated: "not rated", nr: "nr", unrated: "unrated"
        }, videoDefinition: {
                hd: "HD", sd: "SD"
            }
    });
    WinJS.Namespace.defineWithParent(MSE, "Data.Comparer.Marketplace", {
        edsCompareStudio: function edsCompareStudio(studio1, studio2) {
            var result;
            if (studio1 === studio2)
                result = 0;
            else if (!studio2)
                result = -1;
            else if (!studio1)
                result = 1;
            else if (studio1.Name > studio2.Name)
                result = -1;
            else if (studio1.Name < studio2.Name)
                result = 1;
            else
                result = 0;
            return result
        }, edsCompareSeason: function edsCompareSeason(season1, season2) {
                var result;
                if (season1 === season2 || (!season1 && !season2))
                    result = 0;
                else if (!season2)
                    result = -1;
                else if (!season1)
                    result = 1;
                else {
                    var seasonNum1 = season1.SeasonNumber;
                    var seasonNum2 = season2.SeasonNumber;
                    if (seasonNum1 > 99)
                        seasonNum1 = seasonNum1 / 100;
                    if (seasonNum2 > 99)
                        seasonNum2 = seasonNum2 / 100;
                    if (seasonNum1 > seasonNum2)
                        result = 1;
                    else if (seasonNum1 < seasonNum2)
                        result = -1;
                    else
                        result = 0
                }
                return result
            }, edsCompareImageByPurposeThenSize: function edsCompareImageByPurposeThenSize(image1, image2, rankings) {
                var selectBestPurposeRank = function selectBestPurposeRank(purposes, rankings) {
                        var bestPurpose = -1;
                        if (purposes && rankings)
                            for (var i = 0; i < purposes.length; i++) {
                                var rank = rankings[purposes[i]] || -1;
                                if (rank > bestPurpose)
                                    bestPurpose = rank
                            }
                        return bestPurpose
                    };
                var result;
                image1 = MS.Entertainment.Data.deflate(image1);
                image2 = MS.Entertainment.Data.deflate(image2);
                if (image1 === image2)
                    result = 0;
                else if (!image2)
                    result = -1;
                else if (!image1)
                    result = 1;
                else {
                    var biggestSize1 = (image1.Width > image1.Height) ? image1.Width : image1.Height;
                    var biggestSize2 = (image2.Width > image2.Height) ? image2.Width : image2.Height;
                    biggestSize1 = isNaN(biggestSize1) ? 0 : biggestSize1;
                    biggestSize2 = isNaN(biggestSize1) ? 0 : biggestSize2;
                    var purpose1 = selectBestPurposeRank(image1.Purposes, rankings);
                    var purpose2 = selectBestPurposeRank(image2.Purposes, rankings);
                    if (purpose1 > purpose2)
                        result = -1;
                    else if (purpose1 < purpose2)
                        result = 1;
                    else if (biggestSize1 > biggestSize2)
                        result = -1;
                    else if (biggestSize1 < biggestSize2)
                        result = 1;
                    else if (image1.Order < image2.Order)
                        result = -1;
                    else if (image1.Order > image2.Order)
                        result = 1;
                    else
                        result = 0
                }
                return result
            }, edsCompareImageByVideoPurpose: function edsCompareImageByVideoPurpose(image1, image2) {
                return MSE.Data.Comparer.Marketplace.edsCompareImageByPurposeThenSize(image1, image2, MS.Entertainment.Data.Augmenter.Marketplace.edsImagePurposeToRankMappings)
            }, edsCompareImagePurposeOnly: function edsCompareImagePurposeOnly(image1, image2) {
                var result;
                image1 = MS.Entertainment.Data.deflate(image1);
                image2 = MS.Entertainment.Data.deflate(image2);
                if (image1 === image2)
                    result = 0;
                else if (!image2)
                    result = -1;
                else if (!image1)
                    result = 1;
                else {
                    var image1rank = MS.Entertainment.Data.Augmenter.Marketplace.edsImagePurposeToRankMappings[image1.Purpose] || -1;
                    var image2rank = MS.Entertainment.Data.Augmenter.Marketplace.edsImagePurposeToRankMappings[image2.Purpose] || -1;
                    if (image1rank > image2rank)
                        result = -1;
                    else if (image1rank < image2rank)
                        result = 1;
                    else
                        result = 0
                }
                return result
            }
    });
    WinJS.Namespace.defineWithParent(MSE, "Data.Filter.Marketplace", {filterUnsupportedEditorialItems: function filterUnsupportedEditorialItems(item) {
            var editorialItem = item && item.editorialItem;
            var editorialType = WinJS.Utilities.getMember("actionType.mediaType", editorialItem);
            return !MS.Entertainment.Utilities.isSupportedVideoEditorialType(editorialItem, editorialType)
        }});
    WinJS.Namespace.defineWithParent(MSE, "Data.Filter.Marketplace", {filterUnsupportedRecommendationItems: function filterUnsupportedRecommendationItems(item) {
            var supported = true;
            if (item && MS.Entertainment.Utilities.checkRecommendationsItemForNotInterested(item))
                supported = false;
            return !supported
        }});
    WinJS.Namespace.defineWithParent(MSE, "Data.Factory.Marketplace", {
        EDSStudio: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.Data.define(null, {
                    images: augment("Images", MSE.Data.Augmenter.Marketplace.EDSImage, null), name: alias("Name", String.empty)
                })
        }), EDSCriticReview: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {
                        criticName: convert("Critic", MSE.Utilities.unEscapeHTML, String.empty), criticText: convert("CriticText", MSE.Utilities.unEscapeHTML, String.empty), date: convert("Date", MSE.Data.Factory.date, MSE.Data.Factory.dateNow), publication: convert("Publication", MSE.Utilities.unEscapeHTML, String.empty), publicationUrl: alias("PublicationUrl", String.empty), scoreDescription: alias("ScoreDescription", String.empty)
                    })
            })
    });
    WinJS.Namespace.defineWithParent(MSE, "Data.Factory.Marketplace", {EDSReviewSource: MSE.Data.define(null, {
            name: alias("Name", String.empty), reviewScore: convert("ReviewScore", MSE.Data.Factory.intNumber, -1), reviewScoreCount: convert("ReviewScoreCount", MSE.Data.Factory.intNumber, -1), url: alias("Url", String.empty), criticReviews: augment("CriticReviews", MSE.Data.Factory.Marketplace.EDSCriticReview, [])
        })});
    WinJS.Namespace.defineWithParent(MSE, "Data.Factory.Marketplace", {ProviderEDS: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.Data.define(null, {
                    titleId: alias("ID", String.empty), name: alias("Name", String.empty), imageUri: alias("Image.Url", String.empty), partnerApplicationLaunchInfoList: augment("PartnerApplicationLaunchInfos.PartnerApplicationLaunchInfo", MSE.Data.Augmenter.Marketplace.PartnerApplicationLaunchInfoEDS, null), providerContents: augment("ProviderContents.ProviderContent", MSE.Data.Augmenter.Marketplace.ProviderContent, null)
                })
        })});
    MS.Entertainment.UI.Debug.defineAssert("MS.Entertainment.Data.Factory.Marketplace");
    WinJS.Namespace.defineWithParent(MSE, "Data.Factory.Marketplace", {GenreEDS: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.MediaItem, null, {
                    name: alias("Name", String.empty), mediaType: Microsoft.Entertainment.Queries.ObjectType.genre
                })
        })});
    WinJS.Namespace.defineWithParent(MSE, "Data.Factory.Marketplace", {
        unknownString: function unknowString() {
            return String.load(String.id.IDS_UNKNOWN_VALUE)
        }, getEditorialItem: function getEditorialItem(item) {
                return item && item.editorialItem
            }, editorialTvSeasonGetSeriesId: function editorialTvSeasonSeriesIdFromTarget(target) {
                if (target) {
                    var delimiterPosition = target.indexOf(",");
                    if (delimiterPosition > 0)
                        return target.substring(0, delimiterPosition)
                }
                return String.empty
            }, editorialTvSeasonGetSeasonNumber: function editorialTvSeasonSeriesIdFromTarget(target) {
                if (target) {
                    var delimiterPosition = target.indexOf(",");
                    if (delimiterPosition > 0 && (delimiterPosition + 1) < target.length)
                        return parseInt(target.substring(delimiterPosition + 1))
                }
                return -1
            }, inMyVideosText: function(inCollection) {
                return inCollection ? String.load(String.id.IDS_SEARCH_INMYVIDEOS_LABEL) : String.empty
            }, edsClosedCaptionFiles: function edsClosedCaptions(providers) {
                var result = [];
                if (Array.isArray(providers))
                    providers.forEach(function providerItem(provider) {
                        if (provider && Array.isArray(provider.ProviderContents))
                            provider.ProviderContents.forEach(function augmentItem(content) {
                                if (content && content.VideoAttributes && Array.isArray(content.VideoAttributes.ClosedCaptionFiles))
                                    content.VideoAttributes.ClosedCaptionFiles.forEach(function augmentClosedCaptions(closedCaptions) {
                                        result.push(MSE.Data.augment({
                                            MediaInstanceID: content.MediaInstanceID, Lcid: closedCaptions.Lcid, Name: closedCaptions.Name, Url: closedCaptions.Url
                                        }, MSE.Data.Augmenter.Marketplace.EdsClosedCaption))
                                    })
                            })
                    });
                return result
            }, edsHasSubtitles: function edsHasSubtitles(providers) {
                var result = false;
                var defaultClosedCaptionLcid = -1;
                var closedCaptionFiles = MSE.Data.Factory.Marketplace.edsClosedCaptionFiles(providers);
                if (closedCaptionFiles && closedCaptionFiles.length > 1)
                    closedCaptionFiles.forEach(function filterToSubtitles(closedCaptions) {
                        if (defaultClosedCaptionLcid !== -1 && closedCaptions.lcid !== defaultClosedCaptionLcid)
                            result = true;
                        else
                            defaultClosedCaptionLcid = closedCaptions.lcid
                    });
                return result
            }, edsFormatSubtitles: function edsFormatSubtitles(providers) {
                var result = String.empty;
                var parts = [];
                var closedCaptionFiles = MSE.Data.Factory.Marketplace.edsClosedCaptionFiles(providers);
                if (closedCaptionFiles && closedCaptionFiles.length > 1)
                    closedCaptionFiles.forEach(function filterToSubtitles(closedCaptions) {
                        parts.push(closedCaptions.name)
                    });
                result = parts.unique().join(String.load(String.id.IDS_DETAILS_INFO_SEPERATOR));
                return result
            }, edsCrossMediaToVideoFactory: function edsCrossMediaToVideoFactory(item) {
                var mediaType = item.type || item.MediaItemType;
                if (mediaType in MS.Entertainment.Data.Query.edsMediaTypeIntegerToStringMappings)
                    mediaType = MS.Entertainment.Data.Query.edsMediaTypeIntegerToStringMappings[mediaType];
                var augmenter;
                if (mediaType === MS.Entertainment.Data.Query.edsMediaType.movie)
                    augmenter = MS.Entertainment.Data.Augmenter.Marketplace.Video.EdsMovie;
                else if (mediaType === MS.Entertainment.Data.Query.edsMediaType.tvSeries)
                    augmenter = MS.Entertainment.Data.Augmenter.Marketplace.Video.EdsTVSeries;
                if (augmenter)
                    item = MS.Entertainment.Data.augment(WinJS.Binding.unwrap(item), augmenter);
                return item
            }, edsProviders: function edsProviders(providers) {
                var result = [];
                var currentDate;
                if (Array.isArray(providers)) {
                    currentDate = new Date;
                    for (var p = 0; p < providers.length; p++) {
                        var provider = providers[p];
                        if (provider && Array.isArray(provider.ProviderContents)) {
                            var found = false;
                            for (var c = 0; c < provider.ProviderContents.length; c++) {
                                var content = provider.ProviderContents[c];
                                if (content && Array.isArray(content.OfferInstances))
                                    for (var o = 0; o < content.OfferInstances.length; o++) {
                                        var offer = content.OfferInstances[o];
                                        var endDate = MS.Entertainment.Data.Factory.date(offer.EndDate);
                                        if (!endDate || currentDate <= endDate) {
                                            found = true;
                                            break
                                        }
                                    }
                                if (found)
                                    break
                            }
                            if (found)
                                result.push(MSE.Data.augment(provider, MSE.Data.Augmenter.Marketplace.EdsProvider))
                        }
                    }
                }
                return result
            }, edsCompanionProviderNames: function edsCompanionProviderNames(providers) {
                var result = String.empty;
                if (MS.Entertainment.Utilities.isCompanionApp && Array.isArray(providers)) {
                    providers = providers.map(function(provider) {
                        return provider ? provider.name : String.empty
                    });
                    result = providers.join(String.load(String.id.IDS_DETAILS_INFO_SEPERATOR))
                }
                {};
                return result
            }, edsFilterNonZuneProvider: function edsFilterNonZuneProvider(provider) {
                var filter = true;
                if (provider && provider.ID === MS.Entertainment.Data.Augmenter.Marketplace.edsProviderId.zune)
                    filter = false;
                return filter
            }, edsFilterZuneProvider: function edsFilterZuneProvider(provider) {
                var filter = true;
                if (provider && provider.ID !== MS.Entertainment.Data.Augmenter.Marketplace.edsProviderId.zune)
                    filter = false;
                return filter
            }, edsRatingToStars: function(data) {
                if (!data)
                    data = 0;
                var averageRating = data * 5;
                return averageRating.toFixed(1)
            }, filterNonPreviewRight: function filterNonPreviewRight(right) {
                var filter = true;
                if (right && right.licenseRight === MS.Entertainment.Data.Augmenter.Marketplace.edsDistributionRight.preview)
                    filter = false;
                return filter
            }, filterNonHDRight: function filterNonHDRight(right) {
                var filter = true;
                if (right && MS.Entertainment.Utilities.rightSupportsTuner(right, MS.Entertainment.Utilities.defaultClientTypeFromApp) && right.licenseRight !== MS.Entertainment.Data.Augmenter.Marketplace.edsDistributionRight.preview && (right.videoDefinition === MS.Entertainment.Data.Augmenter.Marketplace.edsResolutionFormat.hd || right.videoDefinition === MS.Entertainment.Data.Augmenter.Marketplace.edsResolutionFormat.hd1080p))
                    filter = false;
                return filter
            }, filterNonSDRight: function filterNonSDRight(right) {
                var filter = true;
                if (right && MS.Entertainment.Utilities.rightSupportsTuner(right, MS.Entertainment.Utilities.defaultClientTypeFromApp) && right.licenseRight !== MS.Entertainment.Data.Augmenter.Marketplace.edsDistributionRight.preview && right.videoDefinition === MS.Entertainment.Data.Augmenter.Marketplace.edsResolutionFormat.sd)
                    filter = false;
                return filter
            }, filterNonRottenTomatoesReviews: function filterRottenTomatoesReviews(review) {
                var filter = true;
                if (review && review.name == MS.Entertainment.Data.Augmenter.Marketplace.edsCriticReviewSourceType.rottenTomatoes)
                    filter = false;
                return filter
            }, filterNonMetaCriticReviews: function filterNonMetaCriticReviews(review) {
                var filter = true;
                if (review && review.name == MS.Entertainment.Data.Augmenter.Marketplace.edsCriticReviewSourceType.metaCritic)
                    filter = false;
                return filter
            }, convertVideoEditorialItem: function convertVideoEditorialItem(editorialItemContainer) {
                var convertedItem = null;
                if (editorialItemContainer && editorialItemContainer.editorialItem)
                    convertedItem = MS.Entertainment.Utilities.convertEditorialItem(editorialItemContainer.editorialItem);
                return convertedItem
            }, convertVideoRecommendationItem: function convertVideoRecommendationItem(recommendedItem) {
                var convertedItem = null;
                if (recommendedItem) {
                    var setProperty = MS.Entertainment.Utilities.BindingAgnostic.setProperty;
                    setProperty(recommendedItem, "primaryText", recommendedItem.name);
                    if (recommendedItem.explanations && recommendedItem.explanations.length > 0 && recommendedItem.explanations[0] && recommendedItem.explanations[0].text) {
                        var explanationText = recommendedItem.explanations[0].text.match(/{(\d+)}/g) ? ("{0}" + recommendedItem.explanations[0].text).format(String.empty, recommendedItem.explanations[0].explanationItems[0].name) : recommendedItem.explanations[0].text;
                        setProperty(recommendedItem, "secondaryText", explanationText)
                    }
                    MS.Entertainment.UI.Shell.ImageLoader.getServiceImageUrl(recommendedItem, null, null, null, null, String.empty).then(function setPrimaryImageUrl(url) {
                        setProperty(recommendedItem, "imagePrimaryUrl", url)
                    });
                    setProperty(recommendedItem, "imageFallbackUrl", MS.Entertainment.UI.Shell.ImageLoader.getMediaItemDefaultImageUrl(recommendedItem))
                }
                return recommendedItem
            }, sanitizeVideoRating: function sanitizeVideoRating(rating) {
                var result = rating;
                var lowerCased = rating && rating.toLowerCase();
                if (!lowerCased || lowerCased === MSE.Data.Augmenter.Marketplace.edsVideoRating.nr || lowerCased === MSE.Data.Augmenter.Marketplace.edsVideoRating.notRated)
                    result = String.load(String.id.IDS_DETAILS_NOT_RATED_LABEL);
                return result
            }, setVideoRatingImage: function setVideoRatingImage(rating) {
                var ratingImage;
                var config = new Microsoft.Entertainment.Configuration.ConfigurationManager;
                var ratingValues = config.playback.videoRatingValues.split(",");
                MS.Entertainment.Data.Factory.Marketplace.assert((ratingValues.length === 5 || ratingValues === String.emtpy), "Exactly 5 rating values are expected for Poland");
                if (ratingValues.length === 5)
                    switch (rating) {
                        case ratingValues[0]:
                            ratingImage = "/images/VideoRatings/video_poland_ratings_no_restriction.png";
                            break;
                        case ratingValues[1]:
                            ratingImage = "/images/VideoRatings/video_poland_ratings_7.png";
                            break;
                        case ratingValues[2]:
                            ratingImage = "/images/VideoRatings/video_poland_ratings_12.png";
                            break;
                        case ratingValues[3]:
                            ratingImage = "/images/VideoRatings/video_poland_ratings_16.png";
                            break;
                        case ratingValues[4]:
                            ratingImage = "/images/VideoRatings/video_poland_ratings_18.png";
                            break;
                        default:
                            ratingImage = String.empty;
                            break
                    }
                return ratingImage
            }, sanitizeVideoRatingAndAddFilterMoniker: function sanitizeMovieRatingAndAddFilterMoniker(rating, mediaType) {
                var result = rating;
                var lowerCasedRating = rating && rating.toLowerCase();
                if (lowerCasedRating === MSE.Data.Augmenter.Marketplace.edsVideoRating.nr || lowerCasedRating === MSE.Data.Augmenter.Marketplace.edsVideoRating.notRated)
                    return MS.Entertainment.Shell.BaseContentRestrictionService.ratingTypes.microsoft3;
                else if (!lowerCasedRating)
                    return String.empty;
                mediaType = mediaType || "movie";
                if (MS.Entertainment.Utilities.PublicContentRatings) {
                    var globalizationManager = new Microsoft.Entertainment.Util.GlobalizationManager;
                    var regionCode = globalizationManager.getRegion();
                    var geographicRatings = MS.Entertainment.Utilities.PublicContentRatings.regions[regionCode];
                    result = geographicRatings && geographicRatings[mediaType] && geographicRatings[mediaType][result]
                }
                return result
            }, sanitizeMovieRatingAndAddFilterMoniker: function sanitizeMovieRatingAndAddFilterMoniker(rating) {
                return MS.Entertainment.Data.Factory.Marketplace.sanitizeVideoRatingAndAddFilterMoniker(rating, "movie")
            }, sanitizeTVRatingAndAddFilterMoniker: function sanitizeMovieRatingAndAddFilterMoniker(rating) {
                return MS.Entertainment.Data.Factory.Marketplace.sanitizeVideoRatingAndAddFilterMoniker(rating, "tv")
            }, toLocalizedRole: function toLocalizedRole(role) {
                var localizedString = role;
                switch (role) {
                    case MS.Entertainment.Data.Augmenter.Marketplace.edsContributorRole.director:
                        localizedString = String.load(String.id.IDS_VIDEO_CAST_DIRECTOR);
                        break;
                    case MS.Entertainment.Data.Augmenter.Marketplace.edsContributorRole.actor:
                        localizedString = String.load(String.id.IDS_VIDEO_CAST_ACTOR);
                        break;
                    case MS.Entertainment.Data.Augmenter.Marketplace.edsContributorRole.writer:
                        localizedString = String.load(String.id.IDS_VIDEO_CAST_WRITER);
                        break;
                    case MS.Entertainment.Data.Augmenter.Marketplace.edsContributorRole.creator:
                        localizedString = String.load(String.id.IDS_VIDEO_CAST_CREATOR);
                        break;
                    default:
                        MS.Entertainment.Data.Factory.Marketplace.fail("Unknown contributor role passed to toLocalizedRole");
                        break
                }
                return localizedString
            }, _edsCreateGenreQueryOptions: function _edsCreateGenreQueryOptions(selectedModifier, secondaryModifierKey) {
                var genre;
                var selectedSecondaryModifier;
                if (selectedModifier)
                    if (selectedModifier.isRoot)
                        genre = selectedModifier;
                    else {
                        selectedSecondaryModifier = selectedModifier;
                        genre = selectedModifier.parent
                    }
                var result = {};
                result[secondaryModifierKey] = selectedSecondaryModifier ? selectedSecondaryModifier.serviceId : null;
                if (genre && genre.serviceId)
                    result.genre = genre.serviceId;
                return result
            }, edsCreateMovieGenreQueryOptions: function edsCreateMovieGenreQueryOptions(selectedModifier) {
                return MSE.Data.Factory.Marketplace._edsCreateGenreQueryOptions(selectedModifier, "studio")
            }, edsCreateTvGenreQueryOptions: function edsCreateTvGenreQueryOptions(selectedModifier) {
                return MSE.Data.Factory.Marketplace._edsCreateGenreQueryOptions(selectedModifier, "network")
            }
    });
    WinJS.Namespace.defineWithParent(MSE, "Data.Factory.Library", {createFolderVideoItem: function createFolderVideoItem(sourceItem) {
            var augmentation;
            if (sourceItem && sourceItem.FilePath)
                augmentation = MSE.Data.Augmenter.Library.Video;
            else if (!(sourceItem instanceof MSE.Data.Augmenter.Library.Folder))
                augmentation = MSE.Data.Augmenter.Library.Folder;
            return MSE.Data.augment(sourceItem, augmentation)
        }});
    WinJS.Namespace.defineWithParent(MSE, "Data.Augmenter.Library", {contributor: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.Data.define(null, {
                    name: alias("Name", String.empty), role: alias("Role", String.empty), localizedRole: convert("Role", MSE.Data.Factory.Marketplace.toLocalizedRole, String.empty), character: alias("Characters[0]", String.empty), mediaType: Microsoft.Entertainment.Queries.ObjectType.person, voicePhrase: convert("Name", MSE.Data.Factory.normalizeStringForVoice, String.empty), voiceLongPhrase: convert("Name", MSE.Data.Factory.normalizeStringForVoiceLong, String.empty), voiceConfidence: value(defaultVoiceConfidence), imageUri: hydratedRequired(value(null)), biography: hydratedRequired(value(String.empty)), biographyLanguage: hydratedRequired(value(String.empty)), onHydrated: MS.Entertainment.Hydrator.contributor
                })
        })});
    WinJS.Namespace.defineWithParent(MSE, "Data.Augmenter.Library", {VideoBase: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.Data.derive(MSE.Data.Augmenter.Library.MediaItem, null, {
                    averageRating: hydrated(convert("AllTimeAverageRating", MSE.Data.Factory.Marketplace.edsRatingToStars, null)), averageRatingCount: hydrated(convert("AllTimeRatingCount", MSE.Data.Factory.intNumber, null)), canonicalId: hydrated(convert("canonicalId", MSE.Data.Factory.guid, MS.Entertainment.Utilities.EMPTY_GUID)), artistId: -1, duration: hydrated(value(String.empty), MSE.Data.Comparer.inverseDateComparer), dateAdded: null, filePath: null, genreId: -1, mediaType: Microsoft.Entertainment.Queries.ObjectType.video, releaseDate: hydrated(value(String.empty)), seasonNumber: -1, seriesTitle: null, seriesId: null, studio: null, studioName: null, subtitle: null, userStarRating: -1, imageUri: hydratedRequired(value(null)), providers: hydratedRequired(value(null)), providerNameList: hydratedRequired(value(String.empty)), wmContentId: null, videoType: Microsoft.Entertainment.Queries.VideoType.other, closedCaptionFiles: hydratedRequired(value(MSE.Data.Factory.array)), hasCaptions: hydratedRequired(value(false)), hasSubtitles: hydratedRequired(value(false)), formattedSubtitles: hydratedRequired(value(String.empty)), rightsHydrated: hydratedRequired(value(false)), rights: hydratedRequired(value(null)), images: hydratedRequired(value(null)), genre: hydratedRequired(value(null)), description: hydratedRequired(value(null)), backgroundImageUri: hydratedRequired(value(null)), xboxBackgroundImageUri: hydratedRequired(value(null)), xboxBackgroundImageResizeUri: hydratedRequired(value(null)), rating: hydratedRequired(value(MSE.Data.Factory.Marketplace.sanitizeVideoRating)), ratingImage: hydrated(convertNoDeflate("rating", MSE.Data.Factory.Marketplace.setVideoRatingImage, String.empty)), zestDeepLink: hydratedRequired(value(null)), has3rdPartyProvider: hydratedRequired(value(false)), previewRight: hydrated(searchNoDeflate("rights", MSE.Data.Factory.Marketplace.filterNonPreviewRight, null)), hdRight: hydrated(searchNoDeflate("rights", MSE.Data.Factory.Marketplace.filterNonHDRight, null)), sdRight: hydrated(searchNoDeflate("rights", MSE.Data.Factory.Marketplace.filterNonSDRight, null)), videoFileUrl: hydrated(convertNoDeflate("previewRight.videoFileUrl", MSE.Data.Factory.self, null)), videoPreviewUrl: hydrated(convertNoDeflate("previewRight.videoFileUrl", MSE.Data.Factory.self, null)), videoDefinition: hydrated(convertNoDeflate(["hdRight.videoFriendlyDefinition", "sdRight.videoFriendlyDefinition"], MSE.Data.Factory.self, MSE.Data.Factory.Marketplace.unknownString)), videoDefinitions: hydrated(convertNoDeflate([["sdRight.videoFriendlyDefinition", "hdRight.videoFriendlyDefinition"]], MSE.Data.Factory.arrayJoin, MSE.Data.Factory.Marketplace.unknownString)), libraryDefinitions: hydrated(value(String.empty)), hasSdLibraryDefinition: hydrated(value(false)), hasHdLibraryDefinition: hydrated(value(false)), seriesZuneId: null, seriesServiceId: null, seriesIdType: null, userRating: null, secondsFromEndForPostroll: hydratedRequired(value(-1)), hasSeriesId: {get: function() {
                                return (this.seriesId && this.seriesId !== MS.Entertainment.Utilities.EMPTY_GUID)
                            }}, isMovie: {get: function() {
                                return (this.videoType === Microsoft.Entertainment.Queries.VideoType.movie)
                            }}, onHydrated: MS.Entertainment.Hydrator.video
                })
        })});
    WinJS.Namespace.defineWithParent(MSE, "Data.Augmenter.Library", {Video: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.Data.derive(MSE.Data.Augmenter.Library.VideoBase, null, {
                    libraryId: convert("ObjectId", MSE.Data.Factory.intNumber, -1), serviceId: hydrated(convert("ServiceMediaId", MSE.Data.Factory.guid, String.empty, convertFeatureOptionsTvOrMovies)), name: hydrated(convertOriginal("Title", MSE.Data.Factory.normalizeTextDirection, String.empty)), sortName: convertOriginal("SortTitle", MSE.Data.Factory.normalizeTextDirection, String.empty), description: hydrated(convertOriginal("Description", MSE.Data.Factory.normalizeTextDirection, String.empty)), duration: hydrated(convert("Duration", MSE.Data.Factory.intNumber, String.empty), MSE.Data.Comparer.inverseDateComparer), contributors: hydratedRequired(value(null)), criticReview: hydratedRequired(value(null)), dateAdded: convert("DateAdded", MSE.Data.Factory.databaseDate, null), releaseDate: hydrated(convert("ReleaseDate", MSE.Data.Factory.databaseDate, String.empty)), videoType: convert("Category", MSE.Data.Factory.intNumber, -1), filePath: alias("FilePath", String.empty), localFilesCount: convert("LocalFilesCount", MSE.Data.Factory.intNumber, -1), remoteFilesCount: convert("RemoteFilesCount", MSE.Data.Factory.intNumber, -1), canPlayLocally: convert("CanPlayLocally", MSE.Data.Factory.bool, false), rating: hydrated(convert("ParentalRating", MSE.Data.Factory.Marketplace.sanitizeVideoRating, String.empty)), ratingImage: hydrated(convertNoDeflate("rating", MSE.Data.Factory.Marketplace.setVideoRatingImage, String.empty)), parentalRating: hydrated(alias("ParentalRatings[0].RatingId", String.empty)), voicePhrase: convert("Title", MSE.Data.Factory.normalizeStringForVoice, String.empty), voiceLongPhrase: convert("Title", MSE.Data.Factory.normalizeStringForVoiceLong, String.empty), voiceConfidence: value(defaultVoiceConfidence), artistId: convert("ArtistId", MSE.Data.Factory.intNumber, -1), artistName: convertOriginal("ArtistName", MSE.Data.Factory.normalizeTextDirection, String.empty), artistServiceId: convert("ArtistServiceMediaId", MSE.Data.Factory.guid, String.empty, convertFeatureOptionsTvOrMovies), genreId: convert("GenreId", MSE.Data.Factory.intNumber, -1), genreName: alias("GenreName", String.empty), network: hydrated(alias("Network", String.empty)), studio: convertOriginal("Studio", MSE.Data.Factory.normalizeTextDirection, String.empty), studioName: convertOriginal("Studio", MSE.Data.Factory.normalizeTextDirection, String.empty), subtitle: convertOriginal("Subtitle", MSE.Data.Factory.normalizeTextDirection, String.empty), userStarRating: convert("StarRating", MSE.Data.Factory.intNumber, -1), wmContentId: convert("WMContentId", MSE.Data.Factory.guid, String.empty), episodeNumber: convert("EpisodeNumber", MSE.Data.Factory.intNumber, -1), formattedEpisodeNumber: convert("EpisodeNumber", MSE.Data.Factory.formattedIntNumber, -1), seasonNumber: convert("TVSeasonNumber", MSE.Data.Factory.intNumber, -1), formattedSeasonNumber: convert("TVSeasonNumber", MSE.Data.Factory.formattedIntNumber, -1), seriesTitle: convertOriginal("TVSeriesTitle", MSE.Data.Factory.normalizeTextDirection, String.empty), seriesSortTitle: convertOriginal("TVSeriesSortTitle", MSE.Data.Factory.normalizeTextDirection, String.empty), seriesId: hydrated(convert("TVSeriesBingId", MSE.Data.Factory.guid, null, convertFeatureOptionsTv)), canonicalSeriesId: hydrated(convert("TVSeriesBingId", MSE.Data.Factory.guid, null)), seriesZuneId: hydrated(convert("TVSeriesServiceMediaId", MSE.Data.Factory.guid, null)), seriesServiceId: hydrated(convert("TVSeriesServiceMediaId", MSE.Data.Factory.guid, null)), seriesIdType: hydrated(value("Canonical")), seriesLibraryId: convert("TVSeriesId", MSE.Data.Factory.guid, null), seasonServiceId: convert("TVSeasonBingId", MSE.Data.Factory.guid, null), seasonLibraryId: convert("TVSeasonId", MSE.Data.Factory.guid, null), seasonImageUri: alias("TVSeasonImageUrl", String.empty), seriesImageUri: alias("TVSeriesImageUrl", String.empty)
                })
        })});
    WinJS.Namespace.defineWithParent(MSE, "Data.Augmenter.Library", {
        Movie: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.Data.derive(MSE.Data.Augmenter.Library.Video, null, {
                    videoType: convert("Category", MSE.Data.Factory.intNumber, Microsoft.Entertainment.Queries.VideoType.movie), studioName: convertOriginal("Studio", MSE.Data.Factory.normalizeTextDirection, String.empty), studioBackgroundImageUri: hydratedRequired(value(null)), studios: hydratedRequired(value(null)), edsMediaItemType: hydratedRequired(value(null), MSE.Data.Comparer.notFalsy), edsMediaItemTypeString: hydratedRequired(value(null), MSE.Data.Comparer.notFalsy), isPresale: hydratedRequired(value(false)), presaleFulfillmentDate: hydratedRequired(value(null)), isBundle: hydratedRequired(value(false)), isPartOfBundle: hydratedRequired(value(false)), allBundledItemsInCollection: hydratedRequired(value(false)), bundledItems: hydratedRequired(value(null)), onHydrated: MS.Entertainment.Hydrator.movie
                })
        }), TVSeries: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Library.Video, null, {
                        name: hydrated(convertOriginal("Title", MSE.Data.Factory.normalizeTextDirection, String.empty)), serviceId: convert("ServiceMediaId", MSE.Data.Factory.guid, String.empty, convertFeatureOptionsTv), episodeCount: hydratedRequired(value(-1)), downloadedEpisodesCount: convert("DownloadedEpisodesCount", MSE.Data.Factory.intNumber, 0), dateLastEpisodeAdded: convert("DateLastEpisodeAdded", MSE.Data.Factory.databaseDate, null), network: hydratedRequired(value(null)), providers: hydratedRequired(value(null)), hasActivities: hydratedRequired(value(false)), edsMediaGroup: hydratedRequired(value(null), MSE.Data.Comparer.notFalsy), edsMediaItemType: hydratedRequired(value(null), MSE.Data.Comparer.notFalsy), edsMediaItemTypeString: hydratedRequired(value(null), MSE.Data.Comparer.notFalsy), librarySeasons: hydratedRequired(value(null)), liveQuery: hydratedRequired(value(null)), description: hydratedRequired(value(null)), rights: hydratedRequired(value(null)), seasonCount: hydratedRequired(value(-1)), seasons: hydratedRequired(value(null)), genre: hydratedRequired(value(null)), rating: hydratedRequired(value(null)), mediaType: Microsoft.Entertainment.Queries.ObjectType.tvSeries, videoType: value(null), networkBackgroundImageUri: hydratedRequired(value(null)), onHydrated: MS.Entertainment.Hydrator.tvSeries
                    })
            }), TVSeason: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Library.MediaItem, null, {
                        name: hydrated(convertOriginal("Title", MSE.Data.Factory.normalizeTextDirection, String.empty)), sortName: convertOriginal("SortTitle", MSE.Data.Factory.normalizeTextDirection, String.empty), dateAdded: convert("DateAdded", MSE.Data.Factory.databaseDate, null), downloadedEpisodesCount: convert("DownloadedEpisodesCount", MSE.Data.Factory.intNumber, 0), seasonNumber: convert("Number", MSE.Data.Factory.intNumber, -1), serviceId: hydrated(convert("BingId", MSE.Data.Factory.guid, String.empty, convertFeatureOptionsTv)), serviceIdType: hydrated(value("Canonical")), seriesTitle: convertOriginal("TVSeriesTitle", MSE.Data.Factory.normalizeTextDirection, null), seriesSortTitle: convertOriginal("TVSeriesSortTitle", MSE.Data.Factory.normalizeTextDirection, null), seriesZuneId: hydrated(convert("TVSeriesServiceMediaId", MSE.Data.Factory.guid, null)), seriesServiceId: hydrated(convert("TVSeriesServiceMediaId", MSE.Data.Factory.guid, null)), seriesId: hydrated(convert("TVSeriesBingId", MSE.Data.Factory.guid, null, convertFeatureOptionsTv)), seriesIdType: hydrated(value("Canonical")), seriesLibraryId: convert("TVSeriesId", MSE.Data.Factory.guid, null), seriesImageUri: alias("TVSeriesImageUrl", String.empty), mediaType: Microsoft.Entertainment.Queries.ObjectType.tvSeason, seasonServiceId: convertNoDeflate(String.empty, MSE.Data.Factory.Common.tvSeasonServiceId, null), description: hydrated(convertOriginal("Description", MSE.Data.Factory.normalizeTextDirection, String.empty)), rights: hydratedRequired(value(null)), rightsHydrated: hydratedRequired(value(false)), episodes: hydratedRequired(value(null)), episodeCount: hydratedRequired(value(-1)), network: hydratedRequired(value(null)), providers: hydratedRequired(value(null)), episodesQueryFailed: hydratedRequired(value(false)), isComplete: hydratedRequired(value(false)), isLibrarySeason: true, knownChildServiceIds: null, hasSeriesId: {get: function() {
                                    return (this.seriesId && this.seriesId !== MS.Entertainment.Utilities.EMPTY_GUID)
                                }}, onHydrated: MS.Entertainment.Hydrator.tvSeason
                    })
            }), TVEpisode: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Library.Video, null, {
                        videoType: convert("Category", MSE.Data.Factory.intNumber, Microsoft.Entertainment.Queries.VideoType.tvEpisode), edsMediaItemType: hydratedRequired(value(null), MSE.Data.Comparer.notFalsy), edsMediaItemTypeString: hydratedRequired(value(null), MSE.Data.Comparer.notFalsy), onHydrated: MS.Entertainment.Hydrator.tvEpisode
                    })
            }), Studio: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.MediaItem, null, {
                        name: convertOriginal("Name", MSE.Data.Factory.normalizeTextDirection, String.empty), voicePhrase: convert("Name", MSE.Data.Factory.normalizeStringForVoice, String.empty), voiceConfidence: value(defaultVoiceConfidence)
                    })
            })
    });
    WinJS.Namespace.defineWithParent(MSE, "Data.Augmenter.Library", {MergedVideoTVSeasonResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.Data.define(null, {
                    movieItems: alias("source[0].itemsArray", null), tvSeriesItems: alias("source[1].itemsArray", null)
                })
        })});
    WinJS.Namespace.defineWithParent(MSE, "Data.Augmenter.Library", {Folder: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.Data.define(null, {
                    mediaType: Microsoft.Entertainment.Queries.ObjectType.folder, folderId: convert("ObjectId", MSE.Data.Factory.intNumber, -1), parentFolderId: convert("ParentFolderId", MSE.Data.Factory.intNumber, -1), name: alias("Title", String.empty), label: alias("Title", String.empty), path: alias("Path", String.empty), filePath: alias("ThumbnailFilePath", String.empty), isUnavailable: convert("IsUnavailable", MSE.Data.Factory.bool, false), type: Microsoft.Entertainment.Queries.ObjectType.folder, voicePhrase: convert("Title", MSE.Data.Factory.normalizeStringForVoice, String.empty), voiceConfidence: value(defaultVoiceConfidence)
                })
        })});
    WinJS.Namespace.defineWithParent(MSE, "Data.Augmenter.Library", {
        FoldersResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.Data.derive(MSE.Data.Augmenter.Library.LibraryResultSet, null, {items: augment("ResultSet", MSE.Data.Augmenter.Library.Folder, null)})
        }), FolderVideosResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Library.LibraryResultSet, null, {items: list("ResultSet", MSE.Data.Factory.Library.createFolderVideoItem, null)})
            }), VideosResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Library.LibraryResultSet, null, {
                        items: list("ResultSet", MSE.Data.Augmenter.Library.Video, null), firstItem: augment("ResultSet[0]", MSE.Data.Augmenter.Library.Video, null)
                    })
            }), MoviesResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Library.LibraryResultSet, null, {
                        items: list("ResultSet", MSE.Data.Augmenter.Library.Movie, null), itemsArray: augment("ResultSet", MSE.Data.Augmenter.Library.Movie, null)
                    })
            }), TVSeriesResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Library.LibraryResultSet, null, {
                        items: list("ResultSet", MSE.Data.Augmenter.Library.TVSeries, null), itemsArray: augment("ResultSet", MSE.Data.Augmenter.Library.TVSeries, null)
                    })
            }), TVSeasonsResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Library.LibraryResultSet, null, {items: list("ResultSet", MSE.Data.Augmenter.Library.TVSeason, null)})
            }), TVEpisodesResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Library.LibraryResultSet, null, {items: list("ResultSet", MSE.Data.Augmenter.Library.TVEpisode, null)})
            }), StudiosResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Library.LibraryResultSet, null, {items: list("ResultSet", MSE.Data.Augmenter.Library.Studio, null)})
            })
    });
    WinJS.Namespace.defineWithParent(MSE, "Data.Augmenter.Marketplace", {
        VideoBase: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.MediaItem, null, {
                    artistId: -1, averageRating: hydrated(convert("AllTimeAverageRating", MSE.Data.Factory.Marketplace.edsRatingToStars, null)), averageRatingCount: hydrated(convert("AllTimeRatingCount", MSE.Data.Factory.intNumber, null)), duration: hydrated(value(String.empty), MSE.Data.Comparer.inverseDateComparer), dateAdded: null, filePath: null, genreId: -1, mediaType: Microsoft.Entertainment.Queries.ObjectType.video, releaseDate: hydrated(value(String.empty)), seasonNumber: -1, seriesTitle: null, seriesId: null, seriesZuneId: null, seriesServiceId: null, seriesIdType: null, studio: null, subtitle: null, userStarRating: -1, imageUri: hydratedRequired(value(null)), providers: hydratedRequired(value(null)), providerNameList: hydratedRequired(value(String.empty)), wmContentId: null, videoType: Microsoft.Entertainment.Queries.VideoType.other, closedCaptionFiles: hydratedRequired(value(MSE.Data.Factory.array)), hasCaptions: hydratedRequired(value(false)), hasSubtitles: hydratedRequired(value(false)), formattedSubtitles: hydratedRequired(value(String.empty)), rightsHydrated: hydratedRequired(value(false)), images: hydratedRequired(value(null)), backgroundImageUri: hydratedRequired(value(null)), rating: hydratedRequired(value(MSE.Data.Factory.Marketplace.sanitizeVideoRating)), ratingImage: hydrated(convertNoDeflate("rating", MSE.Data.Factory.Marketplace.setVideoRatingImage, String.emtpy)), parentalRating: hydrated(alias("ParentalRatings[0].RatingId", String.empty)), zestDeepLink: hydratedRequired(value(null)), has3rdPartyProvider: hydratedRequired(value(false)), previewRight: hydrated(searchNoDeflate("rights", MSE.Data.Factory.Marketplace.filterNonPreviewRight, null)), hdRight: hydrated(searchNoDeflate("rights", MSE.Data.Factory.Marketplace.filterNonHDRight, null)), sdRight: hydrated(searchNoDeflate("rights", MSE.Data.Factory.Marketplace.filterNonSDRight, null)), videoFileUrl: hydrated(convertNoDeflate("previewRight.videoFileUrl", MSE.Data.Factory.self, null)), videoPreviewUrl: hydrated(convertNoDeflate("previewRight.videoFileUrl", MSE.Data.Factory.self, null)), videoDefinition: hydrated(convertNoDeflate(["hdRight.videoFriendlyDefinition", "sdRight.videoFriendlyDefinition"], MSE.Data.Factory.self, MSE.Data.Factory.Marketplace.unknownString)), videoDefinitions: hydrated(convertNoDeflate([["hdRight.videoFriendlyDefinition", "sdRight.videoFriendlyDefinition"]], MSE.Data.Factory.arrayJoin, MSE.Data.Factory.Marketplace.unknownString)), description: hydrated(value(String.empty)), network: String.empty, canonicalSeriesId: hydrated(value(null)), userRating: null, secondsFromEndForPostroll: hydratedRequired(value(-1)), hasSeriesId: {get: function() {
                                return (this.seriesId && this.seriesId !== MS.Entertainment.Utilities.EMPTY_GUID)
                            }}, isMovie: {get: function() {
                                return (this.videoType === Microsoft.Entertainment.Queries.VideoType.movie)
                            }}, onHydrated: MS.Entertainment.Hydrator.video
                })
        }), EDSVideoBase: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EDSMediaItem, null, {
                        artistId: -1, averageRating: hydrated(convert("AllTimeAverageRating", MSE.Data.Factory.Marketplace.edsRatingToStars, null)), averageRatingCount: hydrated(convert("AllTimeRatingCount", MSE.Data.Factory.intNumber, null)), duration: hydrated(value(String.empty), MSE.Data.Comparer.inverseDateComparer), dateAdded: null, filePath: null, genreId: -1, mediaType: Microsoft.Entertainment.Queries.ObjectType.video, releaseDate: hydrated(value(String.empty)), seasonNumber: -1, seriesTitle: null, seriesId: null, seriesZuneId: null, seriesServiceId: null, seriesIdType: null, studio: null, subtitle: null, userStarRating: -1, wmContentId: null, criticReview: null, videoType: Microsoft.Entertainment.Queries.VideoType.other, rights: hydrated(convert("Providers", MSE.Data.Factory.Marketplace.edsRightsCurrentClientProviders, null)), providers: hydrated(convert("Providers", MSE.Data.Factory.Marketplace.edsProviders)), providerNameList: hydrated(convert("Providers", MSE.Data.Factory.Marketplace.edsCompanionProviderNames, String.empty)), images: hydrated(sortArray("Images", MSE.Data.Comparer.Marketplace.edsCompareImageByVideoPurpose, MSE.Data.Augmenter.Marketplace.EDSImage, null)), closedCaptionFiles: hydratedRequired(value(MSE.Data.Factory.array)), hasCaptions: hydratedRequired(value(false)), hasSubtitles: hydratedRequired(value(false)), formattedSubtitles: hydratedRequired(value(String.empty)), rightsHydrated: hydratedRequired(value(false)), rating: hydratedRequired(value(MSE.Data.Factory.Marketplace.sanitizeVideoRating)), ratingImage: hydrated(convertNoDeflate("rating", MSE.Data.Factory.Marketplace.setVideoRatingImage, String.empty)), parentalRating: hydrated(alias("ParentalRatings[0].RatingId", String.empty)), zuneProvider: hydrated(search("Providers", MSE.Data.Factory.Marketplace.edsFilterNonZuneProvider, null)), thirdPartyProvider: hydrated(search("Providers", MSE.Data.Factory.Marketplace.edsFilterZuneProvider, null)), zestDeepLink: hydrated(convertNoDeflate("zuneProvider.PartnerApplicationLaunchInfoList[0].DeepLinkInfo", MSE.Data.Factory.self)), has3rdPartyProvider: hydrated(convertNoDeflate("thirdPartyProvider", MSE.Data.Factory.bool, false)), previewRight: hydrated(searchNoDeflate("rights", MSE.Data.Factory.Marketplace.filterNonPreviewRight, null)), hdRight: hydrated(searchNoDeflate("rights", MSE.Data.Factory.Marketplace.filterNonHDRight, null)), sdRight: hydrated(searchNoDeflate("rights", MSE.Data.Factory.Marketplace.filterNonSDRight, null)), videoFileUrl: hydrated(convertNoDeflate("previewRight.videoFileUrl", MSE.Data.Factory.self, null)), videoPreviewUrl: hydrated(convertNoDeflate("previewRight.videoFileUrl", MSE.Data.Factory.self, null)), videoDefinition: hydrated(convertNoDeflate(["hdRight.videoFriendlyDefinition", "sdRight.videoFriendlyDefinition"], MSE.Data.Factory.self, MSE.Data.Factory.Marketplace.unknownString)), videoDefinitions: hydrated(convertNoDeflate([["hdRight.videoFriendlyDefinition", "sdRight.videoFriendlyDefinition"]], MSE.Data.Factory.arrayJoin, MSE.Data.Factory.Marketplace.unknownString)), libraryDefinitions: hydrated(value(String.empty)), hasSdLibraryDefinition: hydrated(value(false)), hasHdLibraryDefinition: hydrated(value(false)), description: hydrated(value(String.empty)), network: hydrated(value(String.empty)), canonicalSeriesId: hydrated(value(null)), reviewSources: hydrated(augment("ReviewSources", MSE.Data.Factory.Marketplace.EDSReviewSource, null)), userRating: null, secondsFromEndForPostroll: hydratedRequired(value(-1)), hasSeriesId: {get: function() {
                                    return (this.seriesId && this.seriesId !== MS.Entertainment.Utilities.EMPTY_GUID)
                                }}, isMovie: {get: function() {
                                    return (this.videoType === Microsoft.Entertainment.Queries.VideoType.movie)
                                }}, onHydrated: MS.Entertainment.Hydrator.video
                    })
            })
    });
    WinJS.Namespace.defineWithParent(MSE, "Data.Augmenter.Marketplace", {
        Movie: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.VideoBase, null, {
                    serviceId: convert("id", MSE.Data.Factory.guid, String.empty), name: hydrated(convertOriginal("title.$value", MSE.Data.Factory.normalizeTextDirection, String.empty)), sortTitle: alias("sortTitle", String.empty), duration: hydrated(convert("duration", MSE.Data.Factory.timeSpan, String.empty), MSE.Data.Comparer.inverseDateComparer), releaseDate: hydrated(convert("releaseDate", MSE.Data.Factory.date, String.empty)), studioName: convertOriginal("studioInfo.name", MSE.Data.Factory.normalizeTextDirection, String.empty), genre: hydrated(augment("genres.genre", MSE.Data.Augmenter.Marketplace.Genre, null)), description: hydrated(alias("content.$value", String.empty)), rights: hydrated(augment("rights.right", MSE.Data.Augmenter.Marketplace.Right, MSE.Data.Factory.array)), closedCaptionFiles: hydrated(augment("closedCaptionFiles.closedCaptionFile", MSE.Data.Augmenter.Marketplace.ClosedCaption, MSE.Data.Factory.array)), hasCaptions: hydrated(convertNoDeflate("closedCaptionFiles.length", MSE.Data.Factory.bool, false, convertFeatureOptionsClosedCaptions)), rating: hydrated(convert("rating", MSE.Data.Factory.Marketplace.sanitizeVideoRating, String.empty)), parentalRating: hydrated(alias("ParentalRatings[0].RatingId", String.empty)), videoPreviewUrl: hydrated(value(String.empty)), videoType: Microsoft.Entertainment.Queries.VideoType.movie, voicePhrase: convert("title.$value", MSE.Data.Factory.normalizeStringForVoice, String.empty), voiceLongPhrase: convert("title.$value", MSE.Data.Factory.normalizeStringForVoiceLong, String.empty), voiceConfidence: value(defaultVoiceConfidence), secondsFromEndForPostroll: hydratedRequired(value(-1)), isPresale: hydratedRequired(value(false)), presaleFulfillmentDate: hydratedRequired(value(null)), isBundle: hydratedRequired(value(false)), isPartOfBundle: hydratedRequired(value(false)), allBundledItemsInCollection: hydratedRequired(value(false)), bundledItems: hydratedRequired(value(null)), onHydrated: MS.Entertainment.Hydrator.movie
                })
        }), TVEpisode: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.VideoBase, null, {
                        serviceId: convert("id", MSE.Data.Factory.guid, String.empty), name: hydrated(convertOriginal("title.$value", MSE.Data.Factory.normalizeTextDirection, String.empty)), sortTitle: alias("sortTitle", String.empty), releaseDate: hydrated(convert("releaseDate", MSE.Data.Factory.date, String.empty)), episodeNumber: convert("episodeNumber", MSE.Data.Factory.intNumber, -1), formattedEpisodeNumber: convert("episodeNumber", MSE.Data.Factory.formattedIntNumber, -1), seasonNumber: convert("seasonNumber", MSE.Data.Factory.intNumber, -1), formattedSeasonNumber: convert("seasonNumber", MSE.Data.Factory.formattedIntNumber, -1), studioName: hydrated(convertOriginal("network.title", MSE.Data.Factory.normalizeTextDirection, String.empty)), genre: hydrated(augment("categories.category", MSE.Data.Augmenter.Marketplace.Genre, null)), rights: hydrated(augment("rights.right", MSE.Data.Augmenter.Marketplace.Right, MSE.Data.Factory.array)), closedCaptionFiles: hydrated(augment("closedCaptionFiles.closedCaptionFile", MSE.Data.Augmenter.Marketplace.ClosedCaption, MSE.Data.Factory.array)), hasCaptions: hydrated(convertNoDeflate("closedCaptionFiles.length", MSE.Data.Factory.bool, false, convertFeatureOptionsClosedCaptions)), rating: hydrated(convert("rating", MSE.Data.Factory.Marketplace.sanitizeVideoRating, String.empty)), parentalRating: hydrated(alias("ParentalRatings[0].RatingId", String.empty)), description: hydrated(convertOriginal("content.$value", MSE.Data.Factory.normalizeTextDirection, String.empty)), videoType: Microsoft.Entertainment.Queries.VideoType.tvEpisode, seriesTitle: convertOriginal("series.title", MSE.Data.Factory.normalizeTextDirection, String.empty), seriesId: hydrated(convert("series.id", MSE.Data.Factory.guid, String.empty)), duration: hydrated(convert("length", MSE.Data.Factory.timeSpan, String.empty), MSE.Data.Comparer.inverseDateComparer), canonicalSeriesId: hydratedRequired(value(null)), voicePhrase: convert("title.$value", MSE.Data.Factory.normalizeStringForVoice, String.empty), voiceLongPhrase: convert("title.$value", MSE.Data.Factory.normalizeStringForVoiceLong, String.empty), voiceConfidence: value(defaultVoiceConfidence), secondsFromEndForPostroll: hydratedRequired(value(-1)), isChildOf: function MediaItem_TVEpisodeComparerIsChild(mediaItem2) {
                                var isChild = false;
                                if (mediaItem2 && ((mediaItem2.zuneId && this.zuneId === mediaItem2.zuneId) || (mediaItem2.canonicalId && this.canonicalId === mediaItem2.canonicalId) || (mediaItem2.seriesId && this.seriesId === mediaItem2.seriesId)))
                                    isChild = true;
                                return isChild
                            }, onHydrated: MS.Entertainment.Hydrator.tvEpisode
                    })
            }), Studio: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.MediaItem, null, {
                        serviceId: alias("id", String.empty), name: hydrated(convertOriginal("title.$value", MSE.Data.Factory.normalizeTextDirection, String.empty)), imageId: convert("image.id", MSE.Data.Factory.guid, String.empty), backgroundImageId: convert("backgroundImage.id", MSE.Data.Factory.guid, String.empty), voicePhrase: convert("title.$value", MSE.Data.Factory.normalizeStringForVoice, String.empty), voiceConfidence: value(defaultVoiceConfidence)
                    })
            }), MovieEDS: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EDSVideoBase, null, {
                        edsId: convert("ID", MSE.Data.Factory.guid, String.empty), name: hydrated(alias("Name", String.empty)), sortTitle: alias("Name", String.empty), duration: hydrated(convert("Duration", MSE.Data.Factory.timeSpan, String.empty), MSE.Data.Comparer.inverseDateComparer), releaseDate: hydrated(convert("ReleaseDate", MSE.Data.Factory.date, String.empty)), providers: hydrated(augment("Providers.Provider", MSE.Data.Factory.Marketplace.ProviderEDS, null)), genre: hydrated(augment("Genres.Genre", MSE.Data.Factory.Marketplace.GenreEDS, null)), description: hydrated(alias("Details.Description", String.empty)), rating: hydrated(convert("ParentalRating", MSE.Data.Factory.Marketplace.sanitizeVideoRating, String.empty)), parentalRating: hydrated(alias("ParentalRatings[0].RatingId", String.empty)), imageUri: hydrated(alias("Image.Url", String.empty)), videoPreviewUrl: hydrated(alias("PreviewUrl", String.empty)), videoType: Microsoft.Entertainment.Queries.VideoType.movie, hcrSecondaryText: convertNoDeflate("releaseDate", MSE.Data.Factory.localizedYear, String.empty), hcrInCollectionText: convertNoDeflate("inCollection", MSE.Data.Factory.Marketplace.inMyVideosText, 0), voicePhrase: convert("Name", MSE.Data.Factory.normalizeStringForVoice, String.empty), voiceLongPhrase: convert("Name", MSE.Data.Factory.normalizeStringForVoiceLong, String.empty), voiceConfidence: value(defaultVoiceConfidence)
                    })
            }), VideoEDS: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EDSVideoBase, null, {
                        edsId: convert("ID", MSE.Data.Factory.guid, String.empty), contentType: alias("type", String.empty), name: hydrated(alias("Name", String.empty)), sortTitle: alias("Name", String.empty), duration: hydrated(convert("Duration", MSE.Data.Factory.timeSpan, String.empty), MSE.Data.Comparer.inverseDateComparer), genre: hydrated(augment("Genres.Genre", MSE.Data.Factory.Marketplace.GenreEDS, null)), releaseDate: hydrated(convert("ReleaseDate", MSE.Data.Factory.date, String.empty)), rating: hydrated(convert("ParentalRating", MSE.Data.Factory.Marketplace.sanitizeVideoRating, String.empty)), parentalRating: hydrated(alias("ParentalRatings[0].RatingId", String.empty)), imageUri: hydrated(alias("Image.Url", String.empty)), episodeNumber: hydrated(convert("EpisodeNumber", MSE.Data.Factory.intNumber, -1)), formattedEpisodeNumber: convert("EpisodeNumber", MSE.Data.Factory.formattedIntNumber, -1), seasonNumber: hydrated(convert("SeasonNumber", MSE.Data.Factory.intNumber, -1)), formattedSeasonNumber: convert("SeasonNumber", MSE.Data.Factory.formattedIntNumber, -1), providers: hydrated(augment("Providers.Provider", MSE.Data.Factory.Marketplace.ProviderEDS, null)), description: hydrated(alias("Details.Description", String.empty)), videoPreviewUrl: hydrated(value(String.empty)), voicePhrase: convert("Name", MSE.Data.Factory.normalizeStringForVoice, String.empty), voiceLongPhrase: convert("Name", MSE.Data.Factory.normalizeStringForVoiceLong, String.empty), voiceConfidence: value(defaultVoiceConfidence)
                    })
            }), TVEpisodeEDS: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EDSVideoBase, null, {
                        edsId: convert("ID", MSE.Data.Factory.guid, String.empty), name: hydrated(alias("Name", String.empty)), releaseDate: hydrated(convert("ReleaseDate", MSE.Data.Factory.date, String.empty)), duration: hydrated(convert("Duration", MSE.Data.Factory.timeSpan, String.empty), MSE.Data.Comparer.inverseDateComparer), rating: hydrated(convert("ParentalRating", MSE.Data.Factory.Marketplace.sanitizeVideoRating, String.empty)), parentalRating: hydrated(alias("ParentalRatings[0].RatingId", String.empty)), imageUri: hydrated(alias("Image.Url", String.empty)), episodeNumber: convert("EpisodeNumber", MSE.Data.Factory.intNumber, -1), formattedEpisodeNumber: convert("EpisodeNumber", MSE.Data.Factory.formattedIntNumber, -1), seasonNumber: convert("SeasonNumber", MSE.Data.Factory.intNumber, -1), formattedSeasonNumber: convert("SeasonNumber", MSE.Data.Factory.formattedIntNumber, -1), providers: hydrated(augment("Providers.Provider", MSE.Data.Factory.Marketplace.ProviderEDS, null)), description: hydrated(alias("Details.Description", String.empty)), videoType: Microsoft.Entertainment.Queries.VideoType.tvEpisode, voicePhrase: convert("Name", MSE.Data.Factory.normalizeStringForVoice, String.empty), voiceLongPhrase: convert("Name", MSE.Data.Factory.normalizeStringForVoiceLong, String.empty), voiceConfidence: value(defaultVoiceConfidence)
                    })
            }), TVSeasonEDS: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EDSVideoBase, null, {
                        mediaType: Microsoft.Entertainment.Queries.ObjectType.tvSeason, edsId: convert("ID", MSE.Data.Factory.guid, String.empty), name: hydrated(alias("Name", String.empty)), releaseDate: hydrated(convert("ReleaseDate", MSE.Data.Factory.date, String.empty)), genre: hydrated(augment("Genres.Genre", MSE.Data.Factory.Marketplace.GenreEDS, null)), rating: hydrated(convert("ParentalRating", MSE.Data.Factory.Marketplace.sanitizeVideoRating, String.empty)), parentalRating: hydrated(alias("ParentalRatings[0].RatingId", String.empty)), imageUri: hydrated(alias("Image.Url", String.empty)), seasonNumber: convert("SeasonNumber", MSE.Data.Factory.intNumber, -1), formattedSeasonNumber: convert("SeasonNumber", MSE.Data.Factory.formattedIntNumber, -1), episodeCount: hydrated(convert("NumberOfEpisodes", MSE.Data.Factory.intNumber, -1)), voicePhrase: convert("Name", MSE.Data.Factory.normalizeStringForVoice, String.empty), voiceLongPhrase: convert("Name", MSE.Data.Factory.normalizeStringForVoiceLong, String.empty), voiceConfidence: value(defaultVoiceConfidence)
                    })
            }), TVSeriesEDS: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EDSVideoBase, null, {
                        mediaType: Microsoft.Entertainment.Queries.ObjectType.tvSeries, edsId: convert("ID", MSE.Data.Factory.guid, String.empty), name: hydrated(alias("Name", String.empty)), releaseDate: hydrated(convert("ReleaseDate", MSE.Data.Factory.date, String.empty)), network: hydrated(alias("Network", String.empty)), studioName: alias("Network", String.empty), seasonCount: convert("NumberOfSeasons", MSE.Data.Factory.intNumber, -1), providers: hydrated(augment("Providers.Provider", MSE.Data.Factory.Marketplace.ProviderEDS, null)), genre: hydrated(augment("Genres.Genre", MSE.Data.Factory.Marketplace.GenreEDS, null)), description: hydrated(alias("Details.Description", String.empty)), rating: hydrated(convert("ParentalRating", MSE.Data.Factory.Marketplace.sanitizeVideoRating, String.empty)), parentalRating: hydrated(alias("ParentalRatings[0].RatingId", String.empty)), imageUri: hydrated(alias("Image.Url", String.empty)), videoPreviewUrl: hydrated(value(String.empty)), hcrSecondaryText: convertNoDeflate("seasonCount", MS.Entertainment.Formatters.seasonCountText, 0), hcrInCollectionText: convertNoDeflate("inCollection", MSE.Data.Factory.Marketplace.inMyVideosText, 0), voicePhrase: convert("Name", MSE.Data.Factory.normalizeStringForVoice, String.empty), voiceLongPhrase: convert("Name", MSE.Data.Factory.normalizeStringForVoiceLong, String.empty), voiceConfidence: value(defaultVoiceConfidence)
                    })
            })
    });
    WinJS.Namespace.defineWithParent(MSE, "Data.Augmenter.Marketplace", {TVSeason: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.VideoBase, null, {
                    seasonNumber: convert("id", MSE.Data.Factory.intNumber, -1), seasonServiceId: hydrated(convertNoDeflate(String.empty, MSE.Data.Factory.Common.tvSeasonServiceId, null)), seriesId: hydrated(convert("seriesId", MSE.Data.Factory.guid, null)), seriesLibraryId: alias("seriesLibraryId", -1), seriesImageUri: alias("TVSeriesImageUrl", String.empty), seriesTitle: convertOriginal("title.$value", MSE.Data.Factory.normalizeTextDirection, null), releaseDate: hydrated(convert("releaseDate", MSE.Data.Factory.date, String.empty)), description: hydrated(convertOriginal("content.$value", MSE.Data.Factory.normalizeTextDirection, String.empty)), episodeCount: hydrated(convert("episodeCount", MSE.Data.Factory.intNumber, -1)), episodes: hydrated(augment("entry", MSE.Data.Augmenter.Marketplace.TVEpisode, null)), episodesQueryFailed: hydratedRequired(value(false)), rights: hydrated(augment("rights.right", MSE.Data.Augmenter.Marketplace.Right, MSE.Data.Factory.array)), rating: hydrated(convert("rating", MSE.Data.Factory.Marketplace.sanitizeVideoRating, String.empty)), parentalRating: hydrated(alias("ParentalRatings[0].RatingId", String.empty)), mediaType: Microsoft.Entertainment.Queries.ObjectType.tvSeason, isComplete: hydrated(convert("isComplete", MSE.Data.Factory.boolFromString, false)), knownChildServiceIds: null, hasSeriesId: {get: function() {
                                return (this.seriesId && this.seriesId !== MS.Entertainment.Utilities.EMPTY_GUID)
                            }}, isChildOf: function MediaItem_TVSeasonComparerIsChild(mediaItem2) {
                            var isChild = false;
                            if (mediaItem2 && ((mediaItem2.zuneId && this.seriesId === mediaItem2.zuneId) || (mediaItem2.canonicalId && this.seriesId === mediaItem2.canonicalId)))
                                isChild = true;
                            return isChild
                        }, onHydrated: MS.Entertainment.Hydrator.tvSeason
                })
        })});
    WinJS.Namespace.defineWithParent(MSE, "Data.Augmenter.Marketplace", {TVSeries: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.VideoBase, null, {
                    serviceId: convert("id", MSE.Data.Factory.guid, String.empty), libraryId: alias("libraryId", -1), name: hydrated(convertOriginal("title.$value", MSE.Data.Factory.normalizeTextDirection, String.empty)), sortTitle: alias("sortTitle", String.empty), duration: hydrated(convert("duration", MSE.Data.Factory.timeSpan, -1), MSE.Data.Comparer.inverseDateComparer), releaseDate: hydrated(convert("releaseDate", MSE.Data.Factory.date, String.empty)), network: hydrated(value(String.empty)), seasonCount: hydrated(convert("seasonCount", MSE.Data.Factory.intNumber, -1)), episodeCount: hydrated(convert("episodeCount", MSE.Data.Factory.intNumber, -1)), studioName: convertOriginal("network.title", MSE.Data.Factory.normalizeTextDirection, String.empty), genre: hydrated(augment("categories.category", MSE.Data.Augmenter.Marketplace.Genre, null)), description: hydrated(convertOriginal("content.$value", MSE.Data.Factory.normalizeTextDirection, String.empty)), rights: hydrated(augment("rights.right", MSE.Data.Augmenter.Marketplace.Right, MSE.Data.Factory.array)), seasons: hydrated(list("entry", MSE.Data.Augmenter.Marketplace.TVSeason, null)), rating: hydrated(convert("rating", MSE.Data.Factory.Marketplace.sanitizeVideoRating, String.empty)), parentalRating: hydrated(alias("ParentalRatings[0].RatingId", String.empty)), mediaType: Microsoft.Entertainment.Queries.ObjectType.tvSeries, videoPreviewUrl: hydrated(value(String.empty)), _hcrSecondaryText: convertNoDeflate("seasonCount", MS.Entertainment.Formatters.seasonCountText, 0), hcrSecondaryText: convertOriginalNoDeflate("_hcrSecondaryText", MSE.Data.Factory.normalizeTextDirection, 0), hcrInCollectionText: convertNoDeflate("inCollection", MSE.Data.Factory.Marketplace.inMyVideosText, 0), edsMediaGroup: hydratedRequired(value(null), MSE.Data.Comparer.notFalsy), edsMediaItemType: hydratedRequired(value(null), MSE.Data.Comparer.notFalsy), edsMediaItemTypeString: hydratedRequired(value(null), MSE.Data.Comparer.notFalsy), librarySeasons: hydratedRequired(value(null)), liveQuery: hydratedRequired(value(null)), hasActivities: hydratedRequired(value(false)), voicePhrase: convert("title.$value", MSE.Data.Factory.normalizeStringForVoice, String.empty), voiceLongPhrase: convert("title.$value", MSE.Data.Factory.normalizeStringForVoiceLong, String.empty), voiceConfidence: value(defaultVoiceConfidence), onHydrated: MS.Entertainment.Hydrator.tvSeries
                })
        })});
    WinJS.Namespace.defineWithParent(MSE, "Data.Augmenter.Marketplace", {
        EditorialMovie: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.Movie, null, {
                    serviceType: null, serviceId: hydrated(convert("link.target", MSE.Data.Factory.guid, String.empty)), name: hydrated(convertOriginal("title", MSE.Data.Factory.normalizeTextDirection, String.empty)), zuneId: hydrated(convert("link.target", MSE.Data.Factory.guid, String.empty)), canonicalId: hydrated(convert("link.target", MSE.Data.Factory.guid, String.empty)), type: alias("link.type", String.empty), target: alias("link.target", String.empty), voicePhrase: convert("title", MSE.Data.Factory.normalizeStringForVoice, String.empty), voiceLongPhrase: convert("title", MSE.Data.Factory.normalizeStringForVoiceLong, String.empty), voiceConfidence: value(defaultVoiceConfidence)
                })
        }), SearchMovie: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.Movie, null, {
                        serviceId: hydrated(alias("serviceId", String.empty)), name: hydrated(convertOriginal("name", MSE.Data.Factory.normalizeTextDirection, String.empty)), hcrSecondaryText: convertNoDeflate("releaseDate", MSE.Data.Factory.localizedYear, 0), hcrInCollectionText: convertNoDeflate("inCollection", MSE.Data.Factory.Marketplace.inMyVideosText, 0), voicePhrase: convert("name", MSE.Data.Factory.normalizeStringForVoice, String.empty), voiceLongPhrase: convert("name", MSE.Data.Factory.normalizeStringForVoiceLong, String.empty), voiceConfidence: value(defaultVoiceConfidence)
                    })
            }), ChartMovie: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.Movie, null, {
                        name: hydrated(convertOriginal("movie.title", MSE.Data.Factory.normalizeTextDirection, String.empty)), releaseDate: hydrated(convert("movie.releaseDate", MSE.Data.Factory.date, String.empty)), voicePhrase: convert("movie.title", MSE.Data.Factory.normalizeStringForVoice, String.empty), voiceLongPhrase: convert("movie.title", MSE.Data.Factory.normalizeStringForVoiceLong, String.empty), voiceConfidence: value(defaultVoiceConfidence)
                    })
            }), EditorialTVSeries: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.TVSeries, null, {
                        serviceType: null, serviceId: hydrated(convert("link.target", MSE.Data.Factory.guid, String.empty)), name: hydrated(convertOriginal("title", MSE.Data.Factory.normalizeTextDirection, String.empty)), zuneId: hydrated(convert("link.target", MSE.Data.Factory.guid, String.empty)), canonicalId: hydrated(convert("link.target", MSE.Data.Factory.guid, String.empty)), type: alias("link.type", String.empty), target: alias("link.target", String.empty), voicePhrase: convert("title", MSE.Data.Factory.normalizeStringForVoice, String.empty), voiceLongPhrase: convert("title", MSE.Data.Factory.normalizeStringForVoiceLong, String.empty), voiceConfidence: value(defaultVoiceConfidence)
                    })
            }), SearchTVSeries: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.TVSeries, null, {
                        serviceId: hydrated(alias("serviceId", String.empty)), name: hydrated(convertOriginal("name", MSE.Data.Factory.normalizeTextDirection, String.empty)), voicePhrase: convert("name", MSE.Data.Factory.normalizeStringForVoice, String.empty), voiceLongPhrase: convert("name", MSE.Data.Factory.normalizeStringForVoiceLong, String.empty), voiceConfidence: value(defaultVoiceConfidence)
                    })
            }), EpisodeTVSeries: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.TVSeries, null, {
                        serviceId: hydrated(convert("seriesId", MSE.Data.Factory.guid, null)), libraryId: hydrated(alias("seriesLibraryId", -1)), name: hydrated(convertOriginal("seriesTitle", MSE.Data.Factory.normalizeTextDirection, null)), voicePhrase: convert("seriesTitle", MSE.Data.Factory.normalizeStringForVoice, String.empty), voiceLongPhrase: convert("seriesTitle", MSE.Data.Factory.normalizeStringForVoiceLong, String.empty), voiceConfidence: value(defaultVoiceConfidence)
                    })
            }), EditorialTVSeason: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.TVSeason, null, {
                        serviceType: null, serviceId: hydrated(convert("link.target", MSE.Data.Factory.Marketplace.editorialTvSeasonGetSeriesId)), seriesId: hydrated(convert("link.target", MSE.Data.Factory.Marketplace.editorialTvSeasonGetSeriesId)), seasonNumber: hydrated(convert("link.target", MSE.Data.Factory.Marketplace.editorialTvSeasonGetSeasonNumber)), name: hydrated(convertOriginal("title", MSE.Data.Factory.normalizeTextDirection, String.empty)), seriesTitle: hydrated(convertOriginal("title", MSE.Data.Factory.normalizeTextDirection, null)), zuneId: hydrated(convert("link.target", MSE.Data.Factory.Marketplace.editorialTvSeasonGetSeriesId, String.empty)), canonicalId: hydrated(convert("link.target", MSE.Data.Factory.guid, String.empty)), type: alias("link.type", String.empty), target: alias("link.target", String.empty), voicePhrase: convert("title", MSE.Data.Factory.normalizeStringForVoice, String.empty), voiceLongPhrase: convert("title", MSE.Data.Factory.normalizeStringForVoiceLong, String.empty), voiceConfidence: value(defaultVoiceConfidence)
                    })
            }), EditorialEpisode: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.TVEpisode, null, {
                        serviceType: null, serviceId: hydrated(convert("link.target", MSE.Data.Factory.guid, null)), name: hydrated(convertOriginal("title", MSE.Data.Factory.normalizeTextDirection, String.empty)), seriesTitle: hydrated(convertOriginal("title", MSE.Data.Factory.normalizeTextDirection, null)), zuneId: hydrated(convert("link.target", MSE.Data.Factory.guid, String.empty)), canonicalId: hydrated(convert("link.target", MSE.Data.Factory.guid, String.empty)), type: alias("link.type", String.empty), target: alias("link.target", String.empty), voicePhrase: convert("title", MSE.Data.Factory.normalizeStringForVoice, String.empty), voiceLongPhrase: convert("title", MSE.Data.Factory.normalizeStringForVoiceLong, String.empty), voiceConfidence: value(defaultVoiceConfidence)
                    })
            })
    });
    WinJS.Namespace.defineWithParent(MSE, "Data.Augmenter.Marketplace", {
        EdsClosedCaptionFile: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.Data.define(null, {
                    mediaInstanceId: convert("serviceMediaInstanceId", MSE.Data.Factory.guid, String.empty), lcid: convert("lcid", MSE.Data.Factory.string, String.empty), name: alias("name", String.empty), fileUri: alias("fileUrl", String.empty)
                })
        }), EdsQueryRefiner: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {name: alias("Name", String.empty)})
            }), EdsMetadataBase: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {
                        name: alias("Name", String.empty), serviceId: alias("Name", String.empty), mediaType: Microsoft.Entertainment.Queries.ObjectType.genre, images: sortArray("Images", MSE.Data.Comparer.Marketplace.edsCompareImagePurposeOnly, MSE.Data.Augmenter.Marketplace.EDSImage, null), primaryImage: searchNoDeflate("images", MSE.Data.Filter.Marketplace.edsFilterNonLogos, null), imageUri: convertNoDeflate("primaryImage.url", MSE.Data.Factory.self, null), imageResizeUri: convertNoDeflate("primaryImage.resizeUrl", MSE.Data.Factory.self, null)
                    })
            }), EdsPartnerApplicationLaunchInfo: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {
                        deepLinkInfo: alias("DeepLinkInfo", String.empty), consoleTitleId: alias("TitleId", String.empty), clientType: alias("ClientType", String.empty)
                    })
            }), EdsProviderContent: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {
                        device: alias("Device", String.empty), imageUri: alias("Image.Url", String.empty)
                    })
            }), EdsClosedCaption: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {
                        mediaInstanceId: convert("MediaInstanceID", MSE.Data.Factory.guid, String.empty), lcid: convert("Lcid", MSE.Data.Factory.string, String.empty), name: alias("Name", String.empty), fileUri: alias("Url", String.empty)
                    })
            })
    });
    WinJS.Namespace.defineWithParent(MSE, "Data.Augmenter.Marketplace", {
        EDSGenrePivotValue: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.Data.define(null, {
                    queryOptions: convertNoDeflate(String.empty, MSE.Data.Factory.Marketplace.edsCreateMovieGenreQueryOptions, null), itemQueryOptions: convertNoDeflate(String.empty, MSE.Data.Factory.Marketplace.edsCreateMovieGenreQueryOptions, null), isRoot: alias("isRoot", false), serviceId: alias("serviceId", null)
                })
        }), EDSPivotValueBase: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {
                        isRoot: alias("isRoot", false), serviceId: alias("serviceId", null), parent: alias("parent", null)
                    })
            }), EDSStudioPivotValue: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EDSPivotValueBase, null, {queryOptions: convertNoDeflate(String.empty, MSE.Data.Factory.Marketplace.edsCreateMovieGenreQueryOptions, null)})
            }), EDSNetworkPivotValue: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EDSPivotValueBase, null, {queryOptions: convertNoDeflate(String.empty, MSE.Data.Factory.Marketplace.edsCreateTvGenreQueryOptions, null)})
            }), EdsGenre: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EdsMetadataBase, null, {
                        genre: alias("Name", String.empty), isRoot: true, label: alias("Name", String.empty), value: augmentNoDeflate(String.empty, MSE.Data.Augmenter.Marketplace.EDSGenrePivotValue), items: null, selected: false, expanded: false, tabPanelId: null, childIds: null, ariaLevel: 1
                    })
            }), EdsMovieStudio: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EdsMetadataBase, null, {
                        studio: alias("Name", String.empty), isRoot: false, label: alias("Name", String.empty), value: augmentNoDeflate(String.empty, MSE.Data.Augmenter.Marketplace.EDSStudioPivotValue), items: undefined, expanded: undefined, ariaLevel: 2
                    })
            }), EdsTvNetwork: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EdsMetadataBase, null, {
                        network: alias("Name", String.empty), isRoot: false, label: alias("Name", String.empty), value: augmentNoDeflate(String.empty, MSE.Data.Augmenter.Marketplace.EDSNetworkPivotValue), items: undefined, expanded: undefined, ariaLevel: 2
                    })
            }), EdsSearchItem: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EDSMediaItem, null, {
                        mediaType: convert("MediaItemType", MSE.Data.Factory.Marketplace.edsMediaTypeToDatabaseMediaType, null), personType: convert("MediaItemType", MSE.Data.Factory.Marketplace.edsMediaTypeToPersonType, null), videoType: convert("MediaItemType", MSE.Data.Factory.Marketplace.edsMediaTypeToVideoType, null), type: convert("MediaItemType", MSE.Data.Factory.Marketplace.edsMediaTypeToHcrType, null)
                    })
            }), EdsProvider: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {
                        Id: alias("ID", null), name: alias("Name", String.empty), images: sortArray("Images", MSE.Data.Comparer.Marketplace.edsCompareImage, MSE.Data.Augmenter.Marketplace.EDSImage, null), primaryImage: searchNoDeflate("images", MSE.Data.Filter.Marketplace.edsFilterNonCoversNonThumbnails, null), imageUri: convertNoDeflate("primaryImage.url", MSE.Data.Factory.self, null), partnerApplicationLaunchInfoList: augment("PartnerApplicationLaunchInfos", MSE.Data.Augmenter.Marketplace.EdsPartnerApplicationLaunchInfo, null), providerContents: augment("ProviderContents", MSE.Data.Augmenter.Marketplace.EdsProviderContent, null)
                    })
            })
    });
    WinJS.Namespace.defineWithParent(MSE, "Data.Augmenter.Marketplace", {EdsVideo: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EDSVideoBase, null, {
                    edsId: convert("ID", MSE.Data.Factory.guid, String.empty), contributors: hydrated(augment("Contributors", MSE.Data.Augmenter.Library.contributor, [])), contentType: alias("type", String.empty), name: hydrated(alias("Name", String.empty)), sortTitle: alias("Name", String.empty), duration: hydrated(convert("Duration", MSE.Data.Factory.timeSpan, -1), MSE.Data.Comparer.inverseDateComparer), genre: hydrated(augment("Genres", MSE.Data.Augmenter.Marketplace.EdsGenre, null)), releaseDate: hydrated(convert("ReleaseDate", MSE.Data.Factory.date, String.empty)), rating: hydrated(convert("ParentalRating", MSE.Data.Factory.Marketplace.sanitizeVideoRating, String.empty)), parentalRating: hydrated(alias("ParentalRatings[0].RatingId", String.empty)), primaryText: hydrated(alias("Name", String.empty)), providers: hydrated(convert("Providers", MSE.Data.Factory.Marketplace.edsProviders)), providerNameList: convertNoDeflate("providers", MSE.Data.Factory.Marketplace.edsCompanionProviderNames, String.empty), description: hydrated(alias("Description", String.empty)), videoPreviewUrl: hydrated(alias("PreviewUrl", String.empty)), edsMediaItemType: hydrated(alias("MediaItemType", String.empty), MSE.Data.Comparer.notFalsy), videoType: hydrated(convert("MediaItemType", MSE.Data.Factory.Marketplace.edsMediaTypeToVideoType, Microsoft.Entertainment.Queries.VideoType.other)), voicePhrase: convert("VuiDisplayName", MSE.Data.Factory.normalizeStringForVoice, String.empty), voiceLongPhrase: convert("VuiDisplayName", MSE.Data.Factory.normalizeStringForVoiceLong, String.empty), voiceShortPhrase: convert("VuiDisplayName", MSE.Data.Factory.normalizeStringForVoiceShort, String.empty), voiceConfidence: value(defaultVoiceConfidence)
                })
        })});
    WinJS.Namespace.defineWithParent(MSE, "Data.Augmenter.Marketplace", {
        EdsExplanation: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.Data.define(null, {
                    text: hydrated(convertOriginal("Text", MSE.Data.Factory.normalizeTextDirection, String.empty)), longText: hydrated(convertOriginal("LongText", MSE.Data.Factory.normalizeTextDirection, String.empty)), explanationItems: augment("ExplanationItems", MSE.Data.Augmenter.Marketplace.EdsVideo, null)
                })
        }), EdsMovie: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EdsVideo, null, {
                        criticReview: hydrated(searchNoDeflate("reviewSources", MSE.Data.Factory.Marketplace.filterNonRottenTomatoesReviews, null)), videoType: convert("MediaItemType", MSE.Data.Factory.Marketplace.edsMediaTypeToVideoType, Microsoft.Entertainment.Queries.VideoType.movie), studioName: hydrated(alias("Studio", String.empty)), hcrSecondaryText: convertNoDeflate("releaseDate", MSE.Data.Factory.localizedYear, String.empty), hcrInCollectionText: convertNoDeflate("inCollection", MSE.Data.Factory.Marketplace.inMyVideosText, 0), closedCaptionFiles: hydrated(convert("Providers", MSE.Data.Factory.Marketplace.edsClosedCaptionFiles, null)), hasCaptions: hydrated(convertNoDeflate("closedCaptionFiles.length", MSE.Data.Factory.bool, false, convertFeatureOptionsClosedCaptions)), hasSubtitles: hydrated(convert("Providers", MSE.Data.Factory.Marketplace.edsHasSubtitles, false)), formattedSubtitles: hydrated(convert("Providers", MSE.Data.Factory.Marketplace.edsFormatSubtitles, String.empty)), studios: hydrated(sortArray("Studios", MSE.Data.Comparer.Marketplace.edsCompareStudio, MSE.Data.Factory.Marketplace.EDSStudio, MSE.Data.Factory.array)), studioBackgroundImage: searchNoDeflate("studios[0].images", MSE.Data.Filter.Marketplace.edsFilterNonStaticStudioBackgrounds, null), studioBackgroundImageUri: hydrated(convertNoDeflate("studioBackgroundImage.url", MSE.Data.Factory.self, null)), explanations: augment("Explanations", MSE.Data.Augmenter.Marketplace.EdsExplanation, null), secondsFromEndForPostroll: hydratedRequired(value(-1)), unfilteredRights: hydrated(convert("Providers", MSE.Data.Factory.Marketplace.edsUnfilteredRightsCurrentClientProviders, null)), isPresale: hydratedRequired(value(false)), presaleFulfillmentDate: hydratedRequired(value(null)), isBundle: hydratedRequired(value(false)), isPartOfBundle: hydratedRequired(value(false)), allBundledItemsInCollection: hydratedRequired(value(false)), bundledItems: hydratedRequired(value(null)), onHydrated: MS.Entertainment.Hydrator.movie
                    })
            }), EdsTVEpisode: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EdsVideo, null, {
                        videoType: convert("MediaItemType", MSE.Data.Factory.Marketplace.edsMediaTypeToVideoType, Microsoft.Entertainment.Queries.VideoType.tvEpisode), network: hydrated(alias("Network", String.empty)), studioName: hydrated(alias("Network", String.empty)), networks: hydrated(sortArray("Networks", MSE.Data.Comparer.Marketplace.edsCompareStudio, MSE.Data.Factory.Marketplace.EDSStudio, MSE.Data.Factory.array)), episodeNumber: hydrated(convert("EpisodeNumber", MSE.Data.Factory.intNumber, -1)), formattedEpisodeNumber: hydrated(convert("EpisodeNumber", MSE.Data.Factory.formattedIntNumber, -1)), seasonNumber: hydrated(convert("SeasonNumber", MSE.Data.Factory.intNumber, -1)), formattedSeasonNumber: hydrated(convert("SeasonNumber", MSE.Data.Factory.formattedIntNumber, -1)), closedCaptionFiles: hydrated(convert("Providers", MSE.Data.Factory.Marketplace.edsClosedCaptionFiles, null)), hasCaptions: hydrated(convertNoDeflate("closedCaptionFiles.length", MSE.Data.Factory.bool, false, convertFeatureOptionsClosedCaptions)), hasSubtitles: hydrated(convert("Providers", MSE.Data.Factory.Marketplace.edsHasSubtitles, false)), formattedSubtitles: hydrated(convert("Providers", MSE.Data.Factory.Marketplace.edsFormatSubtitles, String.empty)), canonicalSeriesId: hydrated(convert("ParentSeries.ID", MSE.Data.Factory.guid, String.empty)), canonicalSeriesTitle: hydrated(alias("ParentSeries.Name", String.empty)), canonicalSeasonId: hydrated(convert("ParentSeason.ID", MSE.Data.Factory.guid, String.empty)), seriesTitle: alias("ParentSeries.Name", String.empty), secondsFromEndForPostroll: hydratedRequired(value(-1)), unfilteredRights: hydrated(convert("Providers", MSE.Data.Factory.Marketplace.edsUnfilteredRightsCurrentClientProviders, null)), isChildOf: function MediaItem_TVSeasonComparerIsChild(mediaItem2) {
                                var isChild = false;
                                if (mediaItem2 && (!MS.Entertainment.Utilities.isEmptyGuid(mediaItem2.canonicalId) && this.canonicalSeriesId === mediaItem2.canonicalId))
                                    isChild = true;
                                return isChild
                            }, sharesParentWith: function sharesParentWith(mediaItem2) {
                                var sharesParent = false;
                                if (mediaItem2 && ((!MS.Entertainment.Utilities.isEmptyGuid(mediaItem2.canonicalSeriesId) && mediaItem2.canonicalSeriesId === this.canonicalSeriesId) || (!MS.Entertainment.Utilities.isEmptyGuid(mediaItem2.seriesId) && mediaItem2.seriesId === this.canonicalSeriesId)))
                                    sharesParent = true;
                                return sharesParent
                            }, onHydrated: MS.Entertainment.Hydrator.tvEpisode
                    })
            }), EdsTVSeason: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EdsVideo, null, {
                        criticReview: hydrated(searchNoDeflate("reviewSources", MSE.Data.Factory.Marketplace.filterNonMetaCriticReviews, null)), seasonServiceId: hydrated(convert("ID", MSE.Data.Factory.guid, MS.Entertainment.Utilities.EMPTY_GUID)), seriesZuneId: hydrated(value(MS.Entertainment.Utilities.EMPTY_GUID)), mediaType: Microsoft.Entertainment.Queries.ObjectType.tvSeason, network: hydrated(alias("Network", String.empty)), studioName: hydrated(alias("Network", String.empty)), networks: hydrated(sortArray("Networks", MSE.Data.Comparer.Marketplace.edsCompareStudio, MSE.Data.Factory.Marketplace.EDSStudio, MSE.Data.Factory.array)), seasonNumber: hydrated(convert("SeasonNumber", MSE.Data.Factory.intNumber, -1)), seriesTitle: hydrated(alias("ParentSeries.Name", String.empty)), seriesId: hydrated(convert("ParentSeries.ID", MSE.Data.Factory.guid, MS.Entertainment.Utilities.EMPTY_GUID)), seriesIdType: hydrated(value("Canonical")), description: hydrated(alias("Description", String.empty)), formattedSeasonNumber: hydrated(convert("SeasonNumber", MSE.Data.Factory.formattedIntNumber, -1)), episodeCount: hydrated(convert("EpisodeCount", MSE.Data.Factory.intNumber, -1)), isComplete: hydrated(convert("IsSeasonComplete", MSE.Data.Factory.boolFromString, true)), hasActivities: hydratedRequired(value(false)), episodes: hydratedRequired(value(null)), firstEpisode: hydratedRequired(value(null)), episodesQueryFailed: hydratedRequired(value(false)), latestEpisode: hydrated(convert("LatestEpisode.EpisodeNumber", MSE.Data.Factory.intNumber, -1)), unfilteredRights: hydrated(convert("Providers", MSE.Data.Factory.Marketplace.edsUnfilteredRightsCurrentClientProviders, null)), libraryEpisodes: hydratedRequired(value(null)), knownChildServiceIds: null, isChildOf: function MediaItem_TVSeasonComparerIsChild(mediaItem2) {
                                var isChild = false;
                                if (mediaItem2 && (!MS.Entertainment.Utilities.isEmptyGuid(mediaItem2.canonicalId) && this.seriesId === mediaItem2.canonicalId))
                                    isChild = true;
                                return isChild
                            }, sharesParentWith: function sharesParentWith(mediaItem2) {
                                var sharesParent = false;
                                if (mediaItem2 && ((!MS.Entertainment.Utilities.isEmptyGuid(mediaItem2.canonicalSeriesId) && mediaItem2.canonicalSeriesId === this.canonicalSeriesId) || (!MS.Entertainment.Utilities.isEmptyGuid(mediaItem2.seriesId) && mediaItem2.seriesId === this.canonicalSeriesId)))
                                    sharesParent = true;
                                return sharesParent
                            }, onHydrated: MS.Entertainment.Hydrator.tvSeason
                    })
            }), EdsTVSeries: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EdsVideo, null, {
                        mediaType: Microsoft.Entertainment.Queries.ObjectType.tvSeries, criticReview: hydrated(searchNoDeflate("reviewSources", MSE.Data.Factory.Marketplace.filterNonMetaCriticReviews, null)), network: hydrated(alias("Network", String.empty)), studioName: alias("Network", String.empty), _seasonCount: convert(String.empty, function select(item) {
                                return item.ZuneSeasonCount
                            }), seasons: hydratedRequired(value(null)), librarySeasons: hydratedRequired(value(null)), liveQuery: hydratedRequired(value(null)), episodeCount: hydratedRequired(value(-1)), seasonCount: convertNoDeflate("_seasonCount", MSE.Data.Factory.intNumber, -1), hcrSecondaryText: convertNoDeflate("seasonCount", MS.Entertainment.Formatters.seasonCountText, 0), hcrInCollectionText: convertNoDeflate("inCollection", MSE.Data.Factory.Marketplace.inMyVideosText, 0), networks: hydrated(sortArray("Networks", MSE.Data.Comparer.Marketplace.edsCompareStudio, MSE.Data.Factory.Marketplace.EDSStudio, MSE.Data.Factory.array)), networkBackgroundImage: searchNoDeflate("networks[0].images", MSE.Data.Filter.Marketplace.edsFilterNonStaticStudioBackgrounds, null), networkBackgroundImageUri: hydrated(convertNoDeflate("networkBackgroundImage.url", MSE.Data.Factory.self, null)), explanations: augment("Explanations", MSE.Data.Augmenter.Marketplace.EdsExplanation, null), onHydrated: MS.Entertainment.Hydrator.tvSeries
                    })
            })
    });
    WinJS.Namespace.defineWithParent(MSE, "Data.Augmenter.Marketplace", {
        EDSEditorialTVSeries: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EdsTVSeries, null, {
                    serviceType: null, serviceId: hydrated(convert("link.target", MSE.Data.Factory.guid, String.empty)), serviceIdType: hydrated(convert(String.empty, MSE.Data.Factory.Marketplace.edsServiceIdTypeLegacy, null)), serviceImageType: MS.Entertainment.Data.ImageIdType.editorialSeries, canonicalId: hydrated(convert("canonicalId", MSE.Data.Factory.guid, MS.Entertainment.Utilities.EMPTY_GUID)), name: hydrated(convertOriginal("title", MSE.Data.Factory.normalizeTextDirection, String.empty)), seriesTitle: hydrated(convertOriginal("title", MSE.Data.Factory.normalizeTextDirection, String.empty)), imageId: convert("image.id", MSE.Data.Factory.guid, String.empty), zuneId: hydrated(convert("link.target", MSE.Data.Factory.guid, String.empty)), type: alias("link.type", String.empty), target: alias("link.target", String.empty), id: alias("id", String.empty), editorialTitle: convertOriginal("title", MSE.Data.Factory.normalizeTextDirection, String.empty), primaryText: convertOriginal("title", MSE.Data.Factory.normalizeTextDirection, String.empty), secondaryText: convertOriginal("text", MSE.Data.Factory.normalizeTextDirection, String.empty), text: convertOriginal("text", MSE.Data.Factory.normalizeTextDirection, String.empty), backgroundImageId: alias("backgroundImage.id", String.empty), voicePhrase: convert("title", MSE.Data.Factory.normalizeStringForVoice, String.empty), voiceLongPhrase: convert("title", MSE.Data.Factory.normalizeStringForVoiceLong, String.empty), voiceConfidence: value(defaultVoiceConfidence), parentalRating: convert("Rating", MSE.Data.Factory.Marketplace.sanitizeTVRatingAndAddFilterMoniker, String.empty)
                })
        }), EDSEditorialTVEpisode: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EdsTVEpisode, null, {
                        serviceType: null, serviceId: hydrated(convert("link.target", MSE.Data.Factory.guid, String.empty)), serviceIdType: hydrated(convert(String.empty, MSE.Data.Factory.Marketplace.edsServiceIdTypeLegacy, null)), serviceImageType: MS.Entertainment.Data.ImageIdType.editorialSeries, canonicalId: hydrated(convert("canonicalId", MSE.Data.Factory.guid, MS.Entertainment.Utilities.EMPTY_GUID)), name: hydrated(convertOriginal("title", MSE.Data.Factory.normalizeTextDirection, String.empty)), imageId: convert("image.id", MSE.Data.Factory.guid, String.empty), zuneId: hydrated(convert("link.target", MSE.Data.Factory.guid, String.empty)), type: alias("link.type", String.empty), target: alias("link.target", String.empty), id: alias("id", String.empty), editorialTitle: convertOriginal("title", MSE.Data.Factory.normalizeTextDirection, String.empty), primaryText: convertOriginal("title", MSE.Data.Factory.normalizeTextDirection, String.empty), secondaryText: convertOriginal("text", MSE.Data.Factory.normalizeTextDirection, String.empty), text: convertOriginal("text", MSE.Data.Factory.normalizeTextDirection, String.empty), backgroundImageId: alias("backgroundImage.id", String.empty), voicePhrase: convert("title", MSE.Data.Factory.normalizeStringForVoice, String.empty), voiceLongPhrase: convert("title", MSE.Data.Factory.normalizeStringForVoiceLong, String.empty), voiceConfidence: value(defaultVoiceConfidence), parentalRating: convert("Rating", MSE.Data.Factory.Marketplace.sanitizeTVRatingAndAddFilterMoniker, String.empty)
                    })
            }), EDSEditorialTVSeason: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EdsTVSeason, null, {
                        isEditorialSeason: true, serviceType: null, canonicalId: hydrated(value(null)), serviceId: hydrated(value(null)), serviceIdType: hydrated(value(null)), serviceImageType: MS.Entertainment.Data.ImageIdType.editorialSeason, seriesId: hydrated(convert("link.target", MSE.Data.Factory.Marketplace.editorialTvSeasonGetSeriesId)), seriesIdType: hydrated(value("ZuneCatalog")), seasonNumber: hydrated(convert("link.target", MSE.Data.Factory.Marketplace.editorialTvSeasonGetSeasonNumber)), name: hydrated(convertOriginal("title", MSE.Data.Factory.normalizeTextDirection, String.empty)), seriesTitle: hydrated(convertOriginal("title", MSE.Data.Factory.normalizeTextDirection, null)), imageId: convert("image.id", MSE.Data.Factory.guid, String.empty), zuneId: hydrated(convert("link.target", MSE.Data.Factory.Marketplace.editorialTvSeasonGetSeriesId, String.empty)), type: alias("link.type", String.empty), target: alias("link.target", String.empty), id: alias("id", String.empty), editorialTitle: convertOriginal("title", MSE.Data.Factory.normalizeTextDirection, String.empty), primaryText: convertOriginal("title", MSE.Data.Factory.normalizeTextDirection, String.empty), secondaryText: convertOriginal("text", MSE.Data.Factory.normalizeTextDirection, String.empty), text: convertOriginal("text", MSE.Data.Factory.normalizeTextDirection, String.empty), backgroundImageId: alias("backgroundImage.id", String.empty), voicePhrase: convert("title", MSE.Data.Factory.normalizeStringForVoice, String.empty), voiceLongPhrase: convert("title", MSE.Data.Factory.normalizeStringForVoiceLong, String.empty), voiceConfidence: value(defaultVoiceConfidence), parentalRating: convert("Rating", MSE.Data.Factory.Marketplace.sanitizeTVRatingAndAddFilterMoniker, String.empty)
                    })
            }), EDSEditorialMovie: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EdsMovie, null, {
                        isEditorialMovie: true, serviceType: null, canonicalId: hydrated(convert("canonicalId", MSE.Data.Factory.guid, MS.Entertainment.Utilities.EMPTY_GUID)), serviceId: hydrated(convert("link.target", MSE.Data.Factory.guid)), serviceIdType: hydrated(convert(String.empty, MSE.Data.Factory.Marketplace.edsServiceIdTypeLegacy, null)), serviceImageType: MS.Entertainment.Data.ImageIdType.editorialMovie, name: hydrated(convertOriginal("title", MSE.Data.Factory.normalizeTextDirection, String.empty)), imageId: convert("image.id", MSE.Data.Factory.guid, String.empty), zuneId: hydrated(convert("link.target", MSE.Data.Factory.guid, String.empty)), type: alias("link.type", String.empty), target: alias("link.target", String.empty), primaryImageUri: hydrated(alias("imagePrimaryUrl", String.empty)), id: alias("id", String.empty), editorialTitle: convertOriginal("title", MSE.Data.Factory.normalizeTextDirection, String.empty), primaryText: convertOriginal("title", MSE.Data.Factory.normalizeTextDirection, String.empty), secondaryText: convertOriginal("text", MSE.Data.Factory.normalizeTextDirection, String.empty), text: convertOriginal("text", MSE.Data.Factory.normalizeTextDirection, String.empty), backgroundImageId: alias("backgroundImage.id", String.empty), voicePhrase: convert("title", MSE.Data.Factory.normalizeStringForVoice, String.empty), voiceLongPhrase: convert("title", MSE.Data.Factory.normalizeStringForVoiceLong, String.empty), voiceConfidence: value(defaultVoiceConfidence), parentalRating: convert("Rating", MSE.Data.Factory.Marketplace.sanitizeMovieRatingAndAddFilterMoniker, String.empty)
                    })
            }), EDSSpotlightMovie: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EdsMovie, null, {
                        isEditorialMovie: true, serviceId: hydrated(convert("Action.Target", MSE.Data.Factory.guid, String.empty)), serviceIdType: hydrated(convert(String.empty, MSE.Data.Factory.Marketplace.edsServiceIdTypeLegacy, null)), imageUri: hydratedRequired(alias("ImageUrl", null)), imageResizeUri: hydratedRequired(alias("ImageUrl", null)), canonicalId: hydrated(convert("canonicalId", MSE.Data.Factory.guid, MS.Entertainment.Utilities.EMPTY_GUID)), zuneId: hydrated(convert("Action.Target", MSE.Data.Factory.guid, String.empty)), _name: convert("Name", MSE.Data.Factory.stringOrEmpty, String.empty), name: hydrated(convertOriginalNoDeflate("_name", MSE.Data.Factory.normalizeTextDirection, String.empty)), _title: convert("Title", MSE.Data.Factory.stringOrEmpty, String.empty), title: convertOriginalNoDeflate("_title", MSE.Data.Factory.normalizeTextDirection, String.empty), primaryText: convertOriginalNoDeflate("_title", MSE.Data.Factory.normalizeTextDirection, String.empty), _description: convert("Description", MSE.Data.Factory.stringOrEmpty, String.empty), secondaryText: convertOriginalNoDeflate("_description", MSE.Data.Factory.normalizeTextDirection, String.empty), text: convertOriginalNoDeflate("_description", MSE.Data.Factory.normalizeTextDirection, String.empty), imagePrimaryUrl: alias("ImageUrl", String.empty), primaryImageUri: hydrated(alias("ImageUrl", String.empty)), actionTarget: alias("Action.Target", String.empty), actionType: convert("Action.type", MSE.Data.Augmenter.Spotlight.parseActionType), icon: convert("Action.type", MSE.Data.Augmenter.Spotlight.parseIcon, null), replaceable: convert("replaceable", MSE.Data.Factory.boolFromString, true), voicePhrase: convertNoDeflate("_title", MSE.Data.Factory.normalizeStringForVoice, String.empty), voiceLongPhrase: convertNoDeflate("_title", MSE.Data.Factory.normalizeStringForVoiceLong, String.empty), voiceConfidence: value(defaultVoiceConfidence), spotlightAction: augment("Action", MSE.Data.Augmenter.Spotlight.SpotlightAction, null), type: alias("type", null), parentalRating: convert("Rating", MSE.Data.Factory.Marketplace.sanitizeMovieRatingAndAddFilterMoniker, String.empty)
                    })
            }), EDSSpotlightTVSeries: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EdsTVSeries, null, {
                        serviceId: hydrated(convert("Action.Target", MSE.Data.Factory.guid, String.empty)), serviceIdType: hydrated(convert(String.empty, MSE.Data.Factory.Marketplace.edsServiceIdTypeLegacy, null)), imageUri: hydratedRequired(alias("ImageUrl", null)), imageResizeUri: hydratedRequired(alias("ImageUrl", null)), canonicalId: hydrated(convert("canonicalId", MSE.Data.Factory.guid, MS.Entertainment.Utilities.EMPTY_GUID)), zuneId: hydrated(convert("Action.Target", MSE.Data.Factory.guid, String.empty)), _name: convert("Name", MSE.Data.Factory.stringOrEmpty, String.empty), name: hydrated(convertOriginalNoDeflate("_name", MSE.Data.Factory.normalizeTextDirection, String.empty)), _title: convert("Title", MSE.Data.Factory.stringOrEmpty, String.empty), title: convertOriginalNoDeflate("_title", MSE.Data.Factory.normalizeTextDirection, String.empty), primaryText: convertOriginalNoDeflate("_title", MSE.Data.Factory.normalizeTextDirection, String.empty), _description: convert("Description", MSE.Data.Factory.stringOrEmpty, String.empty), secondaryText: convertOriginalNoDeflate("_description", MSE.Data.Factory.normalizeTextDirection, String.empty), text: convertOriginalNoDeflate("_description", MSE.Data.Factory.normalizeTextDirection, String.empty), imagePrimaryUrl: alias("ImageUrl", String.empty), primaryImageUri: hydrated(alias("ImageUrl", String.empty)), actionTarget: alias("Action.Target", String.empty), actionType: convert("Action.type", MSE.Data.Augmenter.Spotlight.parseActionType), icon: convert("Action.type", MSE.Data.Augmenter.Spotlight.parseIcon, null), replaceable: convert("replaceable", MSE.Data.Factory.boolFromString, true), voicePhrase: convertNoDeflate("_title", MSE.Data.Factory.normalizeStringForVoice, String.empty), voiceLongPhrase: convertNoDeflate("_title", MSE.Data.Factory.normalizeStringForVoiceLong, String.empty), voiceConfidence: value(defaultVoiceConfidence), spotlightAction: augment("Action", MSE.Data.Augmenter.Spotlight.SpotlightAction, null), type: alias("type", null), parentalRating: convert("Rating", MSE.Data.Factory.Marketplace.sanitizeTVRatingAndAddFilterMoniker, String.empty)
                    })
            }), EDSSpotlightTVSeason: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EdsTVSeason, null, {
                        isEditorialSeason: true, serviceId: hydrated(convert("Action.Target", MSE.Data.Factory.guid, String.empty)), serviceIdType: hydrated(convert(String.empty, MSE.Data.Factory.Marketplace.edsServiceIdTypeLegacy, null)), imageUri: hydratedRequired(alias("ImageUrl", null)), imageResizeUri: hydratedRequired(alias("ImageUrl", null)), canonicalId: hydrated(convert("canonicalId", MSE.Data.Factory.guid, MS.Entertainment.Utilities.EMPTY_GUID)), zuneId: hydrated(convert("Action.Target", MSE.Data.Factory.guid, String.empty)), seriesId: hydrated(convert("Action.ParentIdTarget", MSE.Data.Factory.guid, String.empty)), seriesIdType: hydrated(value("Canonical")), seriesTitle: convertOriginal("Name", MSE.Data.Factory.normalizeTextDirection, String.empty), _name: convert("Name", MSE.Data.Factory.stringOrEmpty, String.empty), name: hydrated(convertOriginalNoDeflate("_name", MSE.Data.Factory.normalizeTextDirection, String.empty)), _title: convert("Title", MSE.Data.Factory.stringOrEmpty, String.empty), title: convertOriginalNoDeflate("_title", MSE.Data.Factory.normalizeTextDirection, String.empty), primaryText: convertOriginalNoDeflate("_title", MSE.Data.Factory.normalizeTextDirection, String.empty), _description: convert("Description", MSE.Data.Factory.stringOrEmpty, String.empty), secondaryText: convertOriginalNoDeflate("_description", MSE.Data.Factory.normalizeTextDirection, String.empty), text: convertOriginalNoDeflate("_description", MSE.Data.Factory.normalizeTextDirection, String.empty), imagePrimaryUrl: alias("ImageUrl", String.empty), primaryImageUri: hydrated(alias("ImageUrl", String.empty)), actionTarget: alias("Action.Target", String.empty), actionType: convert("Action.type", MSE.Data.Augmenter.Spotlight.parseActionType), icon: convert("Action.type", MSE.Data.Augmenter.Spotlight.parseIcon, null), replaceable: convert("replaceable", MSE.Data.Factory.boolFromString, true), voicePhrase: convertNoDeflate("_title", MSE.Data.Factory.normalizeStringForVoice, String.empty), voiceLongPhrase: convertNoDeflate("_title", MSE.Data.Factory.normalizeStringForVoiceLong, String.empty), voiceConfidence: value(defaultVoiceConfidence), parentalRating: convert("Rating", MSE.Data.Factory.Marketplace.sanitizeTVRatingAndAddFilterMoniker, String.empty), type: alias("type", null)
                    })
            }), EDSSpotlightTVEpisode: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EdsTVEpisode, null, {
                        serviceId: hydrated(convert("Action.Target", MSE.Data.Factory.guid, String.empty)), serviceIdType: hydrated(convert(String.empty, MSE.Data.Factory.Marketplace.edsServiceIdTypeLegacy, null)), imageUri: hydratedRequired(alias("ImageUrl", null)), imageResizeUri: hydratedRequired(alias("ImageUrl", null)), canonicalId: hydrated(convert("canonicalId", MSE.Data.Factory.guid, MS.Entertainment.Utilities.EMPTY_GUID)), zuneId: hydrated(convert("Action.Target", MSE.Data.Factory.guid, String.empty)), _name: convert("Name", MSE.Data.Factory.stringOrEmpty, String.empty), name: hydrated(convertOriginalNoDeflate("_name", MSE.Data.Factory.normalizeTextDirection, String.empty)), _title: convert("Title", MSE.Data.Factory.stringOrEmpty, String.empty), title: convertOriginalNoDeflate("_title", MSE.Data.Factory.normalizeTextDirection, String.empty), primaryText: convertOriginalNoDeflate("_title", MSE.Data.Factory.normalizeTextDirection, String.empty), _description: convert("Description", MSE.Data.Factory.stringOrEmpty, String.empty), secondaryText: convertOriginalNoDeflate("_description", MSE.Data.Factory.normalizeTextDirection, String.empty), text: convertOriginalNoDeflate("_description", MSE.Data.Factory.normalizeTextDirection, String.empty), imagePrimaryUrl: alias("ImageUrl", String.empty), primaryImageUri: hydrated(alias("ImageUrl", String.empty)), actionTarget: alias("Action.Target", String.empty), actionType: convert("Action.type", MSE.Data.Augmenter.Spotlight.parseActionType), icon: convert("Action.type", MSE.Data.Augmenter.Spotlight.parseIcon, null), replaceable: convert("replaceable", MSE.Data.Factory.boolFromString, true), episodeNumber: hydrated(convert("EpisodeNumber", MSE.Data.Factory.intNumber, -1)), formattedEpisodeNumber: hydrated(convert("EpisodeNumber", MSE.Data.Factory.formattedIntNumber, -1)), seasonNumber: hydrated(convert("SeasonNumber", MSE.Data.Factory.intNumber, -1)), formattedSeasonNumber: hydrated(convert("SeasonNumber", MSE.Data.Factory.formattedIntNumber, -1)), voicePhrase: convertNoDeflate("_title", MSE.Data.Factory.normalizeStringForVoice, String.empty), voiceLongPhrase: convertNoDeflate("_title", MSE.Data.Factory.normalizeStringForVoiceLong, String.empty), voiceConfidence: value(defaultVoiceConfidence), spotlightAction: augment("Action", MSE.Data.Augmenter.Spotlight.SpotlightAction, null), type: alias("type", null), parentalRating: convert("Rating", MSE.Data.Factory.Marketplace.sanitizeTVRatingAndAddFilterMoniker, String.empty)
                    })
            })
    });
    WinJS.Namespace.defineWithParent(MSE, "Data.Factory.Marketplace", {
        createTvSeasonItem: function createTvSeasonItem(sourceItem) {
            var augmentation;
            if (sourceItem && sourceItem.ID)
                augmentation = MSE.Data.Augmenter.Marketplace.EdsTVSeason;
            else if (!(sourceItem instanceof MSE.Data.Augmenter.Library.TVSeason))
                augmentation = MSE.Data.Augmenter.Library.TVSeason;
            return MSE.Data.augment(sourceItem, augmentation)
        }, createTvEpisodeItem: function createTvEpisodeItem(sourceItem) {
                var augmentation;
                if (sourceItem && sourceItem.ID)
                    augmentation = MSE.Data.Augmenter.Marketplace.EdsTVEpisode;
                else if (!(sourceItem instanceof MSE.Data.Augmenter.Library.TVEpisode))
                    augmentation = MSE.Data.Augmenter.Library.TVEpisode;
                return MSE.Data.augment(sourceItem, augmentation)
            }
    });
    WinJS.Namespace.defineWithParent(MSE, "Data.Augmenter.Marketplace", {
        MoviesResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.Data.define(null, {items: list("feed.entry", MSE.Data.Augmenter.Marketplace.Movie, null)})
        }), ChartEntriesResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {items: list("feed.entry", MSE.Data.Augmenter.Marketplace.ChartMovie, null)})
            }), TVChartEntriesResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {items: list("feed.entry", MSE.Data.Augmenter.Marketplace.TVSeries, null)})
            }), MovieDetailsResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {item: augment("entry", MSE.Data.Augmenter.Marketplace.Movie, null)})
            }), MovieRightsResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {rights: list("entry.rights.right", MSE.Data.Augmenter.Marketplace.Right, MSE.Data.Factory.array)})
            }), StudioDetailsResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {item: augment("entry", MSE.Data.Augmenter.Marketplace.Studio, null)})
            }), TVSeriesResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {items: list("feed.entry", MSE.Data.Augmenter.Marketplace.TVSeries, null)})
            }), TVSeriesDetailsResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {item: augment("feed", MSE.Data.Augmenter.Marketplace.TVSeries, null)})
            }), TVEpisodeDetailsResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {item: augment("entry", MSE.Data.Augmenter.Marketplace.TVEpisode, null)})
            }), TVSeasonDetailsResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {items: list("feed.entry", MSE.Data.Augmenter.Marketplace.TVEpisode, null)})
            }), StudiosResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {items: list("feed.entry", MSE.Data.Augmenter.Marketplace.Studio, null)})
            }), EdsClosedCaptioningFiles: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {items: augment("results", MSE.Data.Augmenter.Marketplace.EdsClosedCaptionFile, MSE.Data.Factory.array)})
            }), EdsMovieDetails: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EDSDetailsResult, null, {item: augment("Items[0]", MSE.Data.Augmenter.Marketplace.EdsMovie, null)})
            }), EdsTVSeriesDetails: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EDSDetailsResult, null, {item: augment("Items[0]", MSE.Data.Augmenter.Marketplace.EdsTVSeries, null)})
            }), EdsTVSeasonDetails: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EDSDetailsResult, null, {item: augment("Items[0]", MSE.Data.Augmenter.Marketplace.EdsTVSeason, null)})
            }), EdsTVEpisodeDetails: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EDSDetailsResult, null, {item: augment("Items[0]", MSE.Data.Augmenter.Marketplace.EdsTVEpisode, null)})
            }), EdsMovieList: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EDSBrowseResult, null, {
                        items: list("Items", MSE.Data.Augmenter.Marketplace.EdsMovie, null), itemsArray: augment("Items", MSE.Data.Augmenter.Marketplace.EdsMovie, null)
                    })
            }), EdsVideoList: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EDSBrowseResult, null, {items: list("Items", MSE.Data.Augmenter.Marketplace.EdsVideo, null)})
            }), EdsCrossVideoList: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EDSBrowseResult, null, {items: list("Items", MSE.Data.Factory.Marketplace.edsCrossMediaToVideoFactory, null)})
            }), EdsTVSeriesList: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EDSBrowseResult, null, {
                        items: list("Items", MSE.Data.Augmenter.Marketplace.EdsTVSeries, null), itemsArray: augment("Items", MSE.Data.Augmenter.Marketplace.EdsTVSeries, null)
                    })
            }), EdsTVSeasonList: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EDSBrowseResult, null, {
                        items: MSE.Data.Property.sort("Items", MSE.Data.Comparer.Marketplace.edsCompareSeason, null, MSE.Data.Factory.Marketplace.createTvSeasonItem), itemsArray: augment("Items", MSE.Data.Augmenter.Marketplace.EdsTVSeason, null)
                    })
            }), EdsTVEpisodeList: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EDSBrowseResult, null, {
                        items: list("Items", MSE.Data.Factory.Marketplace.createTvEpisodeItem, null), itemsArray: augment("Items", MSE.Data.Augmenter.Marketplace.EdsTVEpisode, null)
                    })
            }), EdsVideoResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EDSDetailsResult, null, {item: augment(["Item", "Items[0]"], MSE.Data.Augmenter.Marketplace.EdsVideo, null)})
            }), EdsRecommendedVideoList: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EDSBrowseResult, null, {
                        itemsArray: augment("Items", MSE.Data.Factory.Marketplace.edsCrossMediaToVideoFactory, null), filteredItemsArray: filterArrayNoDeflate("itemsArray", MS.Entertainment.Data.Filter.Marketplace.filterUnsupportedRecommendationItems, MSE.Data.Factory.Marketplace.convertVideoRecommendationItem, null)
                    })
            }), EdsQueryRefinerList: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EDSBrowseResult, null, {
                        items: list("MediaQueryRefiners[0].Refiners", MSE.Data.Augmenter.Marketplace.EdsGenre, null), total: alias("MediaQueryRefiners[0].Refiners.length", 0)
                    })
            }), EdsGenreRefinerList: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EDSBrowseResult, null, {
                        items: list("MediaQueryRefiners[0].Refiners", MSE.Data.Augmenter.Marketplace.EdsGenre, null), total: alias("MediaQueryRefiners[0].Refiners.length", 0)
                    })
            }), EdsMovieStudioRefinerList: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EDSBrowseResult, null, {
                        items: list("MediaQueryRefiners[0].Refiners", MSE.Data.Augmenter.Marketplace.EdsMovieStudio, null), total: alias("MediaQueryRefiners[0].Refiners.length", 0)
                    })
            }), EdsTvNetworkRefinerList: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EDSBrowseResult, null, {
                        items: list("MediaQueryRefiners[0].Refiners", MSE.Data.Augmenter.Marketplace.EdsTvNetwork, null), total: alias("MediaQueryRefiners[0].Refiners.length", 0)
                    })
            }), EdsRelatedMovies: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EDSBrowseResult, null, {items: list("Items", MSE.Data.Augmenter.Marketplace.EdsMovie, null)})
            }), EdsRelatedTV: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EDSBrowseResult, null, {items: list("Items", MSE.Data.Augmenter.Marketplace.EdsTVSeries, null)})
            }), EdsTVSeriesDetailsResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.mixNoDeflate({item: MSE.Data.Augmenter.Marketplace.EdsTVSeries})
            }), EdsTVSeasonDetailsResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.mixNoDeflate({item: MSE.Data.Augmenter.Marketplace.EdsTVSeason})
            }), EdsTVSeriesResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.mix({"Items[0]": MSE.Data.Augmenter.Marketplace.EdsTVSeries})
            }), EdsTVSeasonResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.mix({"Items[0]": MSE.Data.Augmenter.Marketplace.EdsTVSeason})
            }), EdsTVSeriesSeasons: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EDSBrowseResult, null, {seasons: list("Items", MSE.Data.Augmenter.Marketplace.EdsTVSeason, null)})
            }), EdsTVSeasonsOnSeries: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {seasons: convertOriginalNoDeflate("items", MSE.Data.Factory.self, null)})
            }), EdsTVSeasonEpisodes: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EDSBrowseResult, null, {episodes: list("Items", MSE.Data.Augmenter.Marketplace.EdsTVEpisode, null)})
            }), EdsTVEpisodesOnSeason: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {episodes: convertOriginalNoDeflate("items", MSE.Data.Factory.self, null)})
            }), MoviesResultEDS: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {items: list("SearchResponse.Items.Item", MSE.Data.Augmenter.Marketplace.MovieEDS, null)})
            }), MovieDetailsResultEDS: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {item: augment("DetailsResponse.Item", MSE.Data.Augmenter.Marketplace.MovieEDS, null)})
            }), TVSeriesResultEDS: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {items: list("SearchResponse.Items.Item", MSE.Data.Augmenter.Marketplace.TVSeriesEDS, null)})
            }), TVSeasonsResultEDS: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {items: list("ListResponse.Items.Item", MSE.Data.Augmenter.Marketplace.TVSeasonEDS, null)})
            }), TVEpisodeDetailsResultEDS: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {item: augment("DetailsResponse.Item", MSE.Data.Augmenter.Marketplace.TVEpisodeEDS, null)})
            }), TVEpisodesResultEDS: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {items: list("ListResponse.Items.Item", MSE.Data.Augmenter.Marketplace.TVEpisodeEDS, null)})
            }), VideoResultEDS: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {item: augment("DetailsResponse.Item", MSE.Data.Augmenter.Marketplace.VideoEDS, null)})
            }), RelatedMovieResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {items: list("ListResponse.Items.Item", MSE.Data.Augmenter.Marketplace.MovieEDS, null)})
            }), PinnedMovie: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.Movie, null, {
                        canonicalId: hydrated(convert("ProviderId", MSE.Data.Factory.guid, String.empty)), provider: alias("Provider", null)
                    })
            }), PinnedTvSeries: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.TVSeries, null, {
                        canonicalId: hydrated(convert("ProviderId", MSE.Data.Factory.guid, String.empty)), provider: alias("Provider", null)
                    })
            })
    });
    WinJS.Namespace.defineWithParent(MSE, "Data.Augmenter.Marketplace", {
        EdsSeriesWithSeasons: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.Data.BrowseDetailQuery.mixAugmentation(MSE.Data.Augmenter.Marketplace.EdsTVSeasonsOnSeries, MSE.Data.Augmenter.Marketplace.EdsTVSeriesDetailsResult)
        }), EdsSeasonWithEpisodes: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.BrowseDetailQuery.mixAugmentation(MSE.Data.Augmenter.Marketplace.EdsTVEpisodesOnSeason, MSE.Data.Augmenter.Marketplace.EdsTVSeasonDetailsResult)
            })
    });
    WinJS.Namespace.defineWithParent(MSE, "Data.Augmenter.Marketplace", {
        EdsSeriesWithSeasonsResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EDSBrowseResult, null, {item: augment(String.empty, MSE.Data.Augmenter.Marketplace.EdsSeriesWithSeasons, null)})
        }), EdsSeasonWithEpisodesResult: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.EDSBrowseResult, null, {item: augment(String.empty, MSE.Data.Augmenter.Marketplace.EdsSeasonWithEpisodes, null)})
            })
    });
    WinJS.Namespace.defineWithParent(MSE, "Data.Augmenter.Spotlight", {
        SpotlightItem: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.Data.define(null, {
                    serviceId: convert("InitData", MSE.Data.Factory.guid, String.empty), zuneId: convert("InitData", MSE.Data.Factory.guid, String.empty), _name: convert("Name", MSE.Data.Factory.stringOrEmpty, String.empty), name: convertOriginalNoDeflate("_name", MSE.Data.Factory.normalizeTextDirection, String.empty), _title: convert("Title", MSE.Data.Factory.stringOrEmpty, String.empty), title: convertOriginalNoDeflate("_title", MSE.Data.Factory.normalizeTextDirection, String.empty), primaryText: convertOriginalNoDeflate("_title", MSE.Data.Factory.normalizeTextDirection, String.empty), _description: convert("Description", MSE.Data.Factory.stringOrEmpty, String.empty), _longDescription: convert("LongDescription", MSE.Data.Factory.stringOrEmpty, String.empty), secondaryText: convertOriginalNoDeflate("_description", MSE.Data.Factory.normalizeTextDirection, String.empty), longSecondaryText: convertOriginalNoDeflate("_longDescription", MSE.Data.Factory.normalizeTextDirection, String.empty), imageUri: alias("ImageUrl", String.empty), imageResizeUri: alias("ImageUrl", String.empty), imagePrimaryUrl: alias("ImageUrl", String.empty), spotlightAction: augment("Action", MSE.Data.Augmenter.Spotlight.SpotlightAction, null), actionTarget: alias("Action.Target", String.empty), actionType: convert("Action.type", MSE.Data.Augmenter.Spotlight.parseActionType), icon: convert("Action.type", MSE.Data.Augmenter.Spotlight.parseIcon, null), replaceable: convert("replaceable", MSE.Data.Factory.boolFromString, true), canonicalId: MS.Entertainment.Utilities.EMPTY_GUID, voicePhrase: convertNoDeflate("_title", MSE.Data.Factory.normalizeStringForVoice, String.empty), voiceLongPhrase: convertNoDeflate("_title", MSE.Data.Factory.normalizeStringForVoiceLong, String.empty), voiceConfidence: value(defaultVoiceConfidence), serviceType: value(MS.Entertainment.Data.Augmenter.ServiceTypes.editorialItem), type: convertNoDeflate("actionType.mediaType", MSE.Data.Factory.self, null), mediaType: Microsoft.Entertainment.Queries.ObjectType.editorial, isNotMedia: {get: function get_isNotMedia() {
                                var mediaType = this.actionType && this.actionType.mediaType;
                                return mediaType === MS.Entertainment.Data.Augmenter.Spotlight.MediaType.ZuneFlexHub || mediaType === MS.Entertainment.Data.Augmenter.Spotlight.MediaType.FlexHub || mediaType === MS.Entertainment.Data.Augmenter.Spotlight.MediaType.Web || mediaType === MS.Entertainment.Data.Augmenter.Spotlight.MediaType.WebBlend || mediaType === MS.Entertainment.Data.Augmenter.Spotlight.MediaType.None
                            }}
                })
        }), SpotlightMovie: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.Movie, null, {
                        serviceId: convert("actionTarget", MSE.Data.Factory.guid, String.empty), name: hydrated(convertOriginal("title", MSE.Data.Factory.normalizeTextDirection, String.empty)), voicePhrase: convert("title", MSE.Data.Factory.normalizeStringForVoice, String.empty), voiceLongPhrase: convert("title", MSE.Data.Factory.normalizeStringForVoiceLong, String.empty), voiceConfidence: value(defaultVoiceConfidence), type: alias("type", null)
                    })
            }), SpotlightTVSeries: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MSE.Data.Augmenter.Marketplace.TVSeries, null, {
                        serviceId: convert("actionTarget", MSE.Data.Factory.guid, String.empty), name: hydrated(convertOriginal("title", MSE.Data.Factory.normalizeTextDirection, String.empty)), voicePhrase: convert("title", MSE.Data.Factory.normalizeStringForVoice, String.empty), voiceLongPhrase: convert("title", MSE.Data.Factory.normalizeStringForVoiceLong, String.empty), voiceConfidence: value(defaultVoiceConfidence), type: alias("type", null)
                    })
            })
    });
    WinJS.Namespace.defineWithParent(MSE, "Data.Augmenter.Marketplace", {
        TVEpisodeSharePackage: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.Data.define(null, {
                    mediaId: alias("serviceId", String.empty), mediaType: alias("mediaType", 0), mediaTitle: collect(["seriesTitle", "name"]), title: collect(["seriesTitle", "name"]), description: alias("description", String.empty), text: collect(["seriesTitle", "name"]), uri: alias("webUri", String.empty), htmlUri: alias("webUri", String.empty), htmlImages: collect(["imageUri", "primaryImageUri"], null, String.empty), htmlLines: collect(["name", "seriesTitle", "seasonNumber", "description"], null, String.empty), emptyMessage: String.id.IDS_SHARE_EMPTY_MESSAGE_TV_EPISODE
                })
        }), TVSeasonSharePackage: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {
                        mediaId: alias("serviceId", String.empty), mediaType: alias("mediaType", 0), mediaTitle: collect(["seriesTitle", "name"]), title: collect(["seriesTitle", "name"]), description: alias("description", String.empty), text: collect(["seriesTitle", "name"]), uri: alias("webUri", String.empty), htmlUri: alias("webUri", String.empty), htmlImages: collect(["imageUri", "primaryImageUri"], null, String.empty), htmlLines: collect(["seriesTitle", "seasonNumber", "description"], null, String.empty), emptyMessage: String.id.IDS_SHARE_EMPTY_MESSAGE_TV_EPISODE
                    })
            }), MovieSharePackage: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MS.Entertainment.Data.Augmenter.Marketplace.MediaSharePackage, null, {emptyMessage: String.id.IDS_SHARE_EMPTY_MESSAGE_MOVIE})
            }), TVSeriesSharePackage: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MS.Entertainment.Data.Augmenter.Marketplace.MediaSharePackage, null, {emptyMessage: String.id.IDS_SHARE_EMPTY_MESSAGE_TV_SERIES})
            })
    });
    WinJS.Namespace.defineWithParent(MSE, "Data.Augmenter.Marketplace.Video", {
        EditorialTVSeason: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MS.Entertainment.Data.Augmenter.Marketplace.EDSEditorialTVSeason
        }), EditorialTVSeries: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MS.Entertainment.Data.Augmenter.Marketplace.EDSEditorialTVSeries
            }), EditorialEpisode: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MS.Entertainment.Data.Augmenter.Marketplace.EDSEditorialTVEpisode
            }), EditorialMovie: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MS.Entertainment.Data.Augmenter.Marketplace.EDSEditorialMovie
            }), EdsMovie: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MS.Entertainment.Data.Augmenter.Marketplace.EdsMovie
            }), EdsTVSeries: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MS.Entertainment.Data.Augmenter.Marketplace.EdsTVSeries
            }), SpotlightMovie: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MS.Entertainment.Data.Augmenter.Marketplace.EDSSpotlightMovie
            }), SpotlightTVSeries: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MS.Entertainment.Data.Augmenter.Marketplace.EDSSpotlightTVSeries
            }), SpotlightTVSeason: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MS.Entertainment.Data.Augmenter.Marketplace.EDSSpotlightTVSeason
            }), SpotlightTVEpisode: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MS.Entertainment.Data.Augmenter.Marketplace.EDSSpotlightTVEpisode
            })
    });
    WinJS.Namespace.defineWithParent(MSE, "Data.Augmenter.Video", {MediaDiscoveryFeed: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.Data.define(null, {
                    entries: list("SlotGroup", MSE.Data.Augmenter.MediaDiscovery.SlotGroupItem, null), editorialItems: augment("SlotGroup", MSE.Data.Augmenter.MediaDiscovery.SlotGroupItem, null)
                })
        })});
    WinJS.Namespace.defineWithParent(MSE, "Data.Augmenter.Video", {
        FlexHubContent: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.Data.define(null, {
                    entries: list("ContentManifest.Content.Channel", MSE.Data.Augmenter.Video.MediaDiscoveryFeed, null), entriesArray: augment("ContentManifest.Content.Channel", MSE.Data.Augmenter.Video.MediaDiscoveryFeed, null), featuredSetsArray: filterArrayNoDeflate("entriesArray[0].editorialItems", MS.Entertainment.Data.Filter.Marketplace.filterUnsupportedEditorialItems, MSE.Data.Factory.Marketplace.getEditorialItem, null), items: filterArrayNoDeflate("entriesArray[0].editorialItems", MS.Entertainment.Data.Filter.Marketplace.filterUnsupportedEditorialItems, MSE.Data.Factory.Marketplace.getEditorialItem, null), name: convertOriginal("ContentManifest.Title", MSE.Data.Factory.normalizeTextDirection, String.empty), description: convertOriginal("ContentManifest.Description", MSE.Data.Factory.normalizeTextDirection, String.empty), backgroundImageUrl: alias("ContentManifest.BackgroundImageUrl", String.empty), heroImageUrl: alias("ContentManifest.HeroImageUrl", String.empty)
                })
        }), MovieHubContent: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {
                        entries: list("ContentManifest.Content.Channel", MSE.Data.Augmenter.Video.MediaDiscoveryFeed, null), entriesArray: augment("ContentManifest.Content.Channel", MSE.Data.Augmenter.Video.MediaDiscoveryFeed, null), name: convertOriginal("ContentManifest.Name", MSE.Data.Factory.normalizeTextDirection, String.empty)
                    })
            }), MovieHubNewReleaseContent: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MS.Entertainment.Data.Augmenter.Video.MovieHubContent, null, {items: filterNoDeflate("entriesArray[0].editorialItems", MS.Entertainment.Data.Filter.Marketplace.filterUnsupportedEditorialItems, MSE.Data.Factory.Marketplace.convertVideoEditorialItem, null)})
            }), MovieHubFeaturedContent: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.derive(MS.Entertainment.Data.Augmenter.Video.MovieHubContent, null, {items: filterNoDeflate("entriesArray[1].editorialItems", MS.Entertainment.Data.Filter.Marketplace.filterUnsupportedEditorialItems, MSE.Data.Factory.Marketplace.convertVideoEditorialItem, null)})
            }), TvHubContent: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.Data.define(null, {
                        entries: list("ContentManifest.Content.Channel", MSE.Data.Augmenter.Video.MediaDiscoveryFeed, null), entriesArray: augment("ContentManifest.Content.Channel", MSE.Data.Augmenter.Video.MediaDiscoveryFeed, null), filteredEntries: filterNoDeflate("entriesArray[0].editorialItems", MS.Entertainment.Data.Filter.Marketplace.filterUnsupportedEditorialItems, MSE.Data.Factory.Marketplace.convertVideoEditorialItem, null), filteredEntriesArray: filterArrayNoDeflate("entriesArray[0].editorialItems", MS.Entertainment.Data.Filter.Marketplace.filterUnsupportedEditorialItems, MSE.Data.Factory.Marketplace.convertVideoEditorialItem, null), name: convertOriginal("ContentManifest.Name", MSE.Data.Factory.normalizeTextDirection, String.empty)
                    })
            })
    });
    WinJS.Namespace.defineWithParent(MSE, "Data.Augmenter.FileActivation", {Video: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.Data.derive(MSE.Data.Augmenter.Library.Video, null, {
                    artistId: -1, dateAdded: hydrated(value(null)), genreId: hydrated(value(-1)), mediaType: Microsoft.Entertainment.Queries.ObjectType.video, releaseDate: hydrated(value(null)), seasonNumber: hydrated(value(-1)), seriesTitle: hydrated(value(null)), seriesId: hydrated(value(null)), studio: hydrated(value(null)), subtitle: hydrated(value(null)), userStarRating: -1, providerNameList: String.empty, wmContentId: null, videoType: Microsoft.Entertainment.Queries.VideoType.other, duration: -1, imageUri: hydrated(convert("thumbnail", MSE.Data.Factory.oneTimeUseBlob, null)), _title: convert("fileItem.name", MSE.Data.Factory.string, String.empty), name: hydrated(convertOriginalNoDeflate("_title", MSE.Data.Factory.normalizeTextDirection, String.empty)), title: convertOriginalNoDeflate("_title", MSE.Data.Factory.normalizeTextDirection, String.empty), activationFilePath: convert("fileItem.path", MSE.Data.Factory.string, String.empty), userRating: null, fileItem: alias("fileItem", null), filePath: alias("FilePath", null), hasSeriesId: {get: function() {
                                return (this.seriesId && this.seriesId !== MS.Entertainment.Utilities.EMPTY_GUID)
                            }}, isMovie: {get: function() {
                                return (this.videoType === Microsoft.Entertainment.Queries.VideoType.movie)
                            }}
                })
        })})
})(MS.Entertainment)
