﻿/* Copyright (C) Microsoft Corporation. All rights reserved. */
scriptValidator();
MS.Entertainment.UI.Debug.defineAssert("MS.Entertainment.Data");
(function(MSE, undefined) {
    "use strict";
    WinJS.Namespace.defineWithParent(MSE, "Data", {
        listGrouperEvents: {batchChange: "batchChange"}, emptyGrouper: {
                isEmpty: true, noHeaderGroups: true, execute: function execute() {
                        return null
                    }
            }, emptyGroupKey: "noGroupHeader", ListGrouperBase: MS.Entertainment.UI.Framework.derive("MS.Entertainment.Utilities.EventInvoker", function listGrouper(grouper, dataSource) {
                if (grouper && !grouper.execute)
                    throw new Error("Invalid galleryGrouper passed to ListGrouper");
                if (dataSource && dataSource.setGrouper)
                    this._dataSource = dataSource;
                this._grouper = grouper;
                this._reset()
            }, {
                _dataSourceReadySignal: null, _dataSource: null, _grouper: null, _groups: null, _groupHints: null, _headerRanges: null, _pendingChanges: null, _stopInsertingGroupHintHeaders: false, _groupHintsDispatchCount: 100, _pendingInserts: 0, _tracingId: 0, dispose: function dispose() {
                        if (this._dataSourceReadySignal) {
                            this._dataSourceReadySignal.error(new Error("Grouper has been disposed"));
                            this._dataSourceReadySignal = null
                        }
                        if (this._dataSource) {
                            this._dataSource.setGrouper(null);
                            this._dataSource = null
                        }
                    }, dataSource: {get: function get_dataSource() {
                            return this._dataSource
                        }}, dataSourceReady: {get: function get_dataSourceReady() {
                            return WinJS.Promise.as(this._dataSourceReadySignal && this._dataSourceReadySignal.promise)
                        }}, groupHints: {
                        get: function() {
                            return this._groupHints
                        }, set: function(value) {
                                this.setGroupHints(value)
                            }
                    }, grouper: {get: function() {
                            return this._grouper
                        }}, isGrouperEmpty: {get: function() {
                            return !this._grouper || !!this._grouper.isEmpty
                        }}, isInlineGrouper: {get: function get_isInlineGrouper() {
                            MS.Entertainment.Data.fail("Derived classes must define isInlineGrouper.")
                        }}, headerRanges: {get: function() {
                            if (this._headerRanges)
                                return this._headerRanges.ranges;
                            else
                                return []
                        }}, headerIndices: {get: function() {
                            var result = [];
                            if (this._headerRanges)
                                this._headerRanges.ranges.forEach(function(item) {
                                    result.push(item.start)
                                });
                            return result
                        }}, headerCount: {get: function get_headerCount() {
                            var result = 0;
                            if (this._headerRanges)
                                result = this._headerRanges.total;
                            return result
                        }}, reset: function reset() {
                        this._reset();
                        this._onReset()
                    }, _getTracingId: function _getTracingId() {
                        this._tracingId++;
                        return this._tracingId
                    }, _reset: function _reset() {
                        this._headerRanges = new MS.Entertainment.Data.Ranges;
                        this._headerRanges.singleItems = true;
                        this._groups = {};
                        this._groupHints = null;
                        this._pendingChanges = null;
                        this._stopInsertingGroupHintHeaders = false;
                        if (this._dataSourceReadySignal) {
                            this._dataSourceReadySignal.error(new Error("ListGrouper has been reset"));
                            this._dataSourceReadySignal = null
                        }
                        if (this.dataSource) {
                            this._dataSourceReadySignal = new MS.Entertainment.UI.Framework.Signal;
                            this.dataSource.setGrouper(this).done(function setGrouperSucceeded() {
                                if (this._dataSourceReadySignal)
                                    this._dataSourceReadySignal.complete()
                            }.bind(this), function setGrouperFailed(error) {
                                if (this._dataSourceReadySignal)
                                    this._dataSourceReadySignal.error(error)
                            }.bind(this))
                        }
                    }, _onReset: function _onReset(){}, clear: function clear() {
                        var ranges;
                        if (this._headerRanges && this.isInlineGrouper)
                            ranges = this._headerRanges.ranges;
                        else {
                            this._headerRanges = new MS.Entertainment.Data.Ranges;
                            this._headerRanges.singleItems = true
                        }
                        if (ranges)
                            for (var i = ranges.length - 1; i >= 0; i--)
                                this._removeHeader(ranges[i].start);
                        this._dispatchChanges();
                        this._groups = {}
                    }, setGroupHints: function setGroupHints(value) {
                        var result;
                        var tracingId = this._getTracingId();
                        if (this._groupHints !== value) {
                            msWriteProfilerMark("ent:ListGrouperBase:setGroupHints: " + tracingId + ",StartTM");
                            var oldValue = this._groupHints;
                            this._groupHints = value;
                            result = this._onGroupHintsChanged(value, oldValue).then(function setGroupHints(promiseResult) {
                                this._groupHints = value;
                                msWriteProfilerMark("ent:ListGrouperBase:setGroupHints: " + tracingId + ",StopTM");
                                return promiseResult
                            }.bind(this))
                        }
                        return WinJS.Promise.as(result)
                    }, groupHintIndexFromIndex: function groupHintIndexFromIndex(index) {
                        var result = -1;
                        if (this._groupHints && this._groupHints.forEach) {
                            var async = true;
                            this._groupHints.forEach(function(args) {
                                if (args.item.firstItemIndexHint <= index && args.item.firstItemIndexHint + args.item.data.totalCount - 1 >= index) {
                                    result = args.item.itemIndex;
                                    args.stop = true
                                }
                            }).done(function() {
                                async = false
                            }, function ignoreErrors(error) {
                                MS.Entertainment.Data.fail("Unexcepted error searching for source index. error: " + (error && error.message))
                            });
                            MS.Entertainment.Data.assert(!async, "The groupHints data source should not be an async data source.")
                        }
                        return result
                    }, groupHintIndexFromGroupHintKey: function groupHintIndexFromGroupHintKey(key) {
                        var result = -1;
                        if (key && this._groupHints && this._groupHints.indexFromKey)
                            result = this._groupHints.indexFromKey(key);
                        return result
                    }, firstItemIndexFromGroupHintKey: function firstItemIndexFromGroupHintKey(groupHintKey) {
                        var index = -1;
                        var groupHintIndex = -1;
                        var groupHint;
                        if (this._groupHints && this._groupHints.indexFromKey)
                            groupHintIndex = this._groupHints.indexFromKey(groupHintKey);
                        if (groupHintIndex >= 0 && groupHintIndex < this._groupHints.count)
                            groupHint = this._groupHints.getItem(groupHintIndex);
                        if (groupHint)
                            index = groupHint.firstItemIndexHint;
                        return index
                    }, groupIndexFromSourceIndex: function groupIndexFromSourceIndex(sourceIndex) {
                        var result = -1;
                        if (this._headerRanges)
                            result = this._headerRanges.findLessThanOrEqual(sourceIndex);
                        return result
                    }, groupSizeFromGroupIndex: function groupSizeFromGroupIndex(groupIndex) {
                        var groupSize = 0;
                        var groupCache = null;
                        var groupCacheAfter = null;
                        var listSize = 0;
                        if (this.dataSource)
                            listSize = this.dataSource.count;
                        if (this._headerRanges) {
                            groupCache = this._headerRanges.get(groupIndex);
                            groupCacheAfter = this._headerRanges.get(groupIndex + 1)
                        }
                        if (groupCache)
                            if (groupCacheAfter)
                                groupSize = groupCacheAfter.start - groupCache.start;
                            else if (listSize > 0)
                                groupSize = listSize - groupCache.start;
                        if (groupSize > 0 && this.isInlineGrouper)
                            groupSize--;
                        return groupSize
                    }, _leftGroupFromSourceIndex: function _leftGroupFromSourceIndex(sourceIndex) {
                        var group = null;
                        var index = -1;
                        var range = null;
                        if (this._headerRanges)
                            index = this._headerRanges.findLessThanOrEqual(sourceIndex);
                        if (index >= 0)
                            range = this._headerRanges.get(index);
                        if (range && range.data)
                            group = range.data;
                        return group
                    }, _leftGroupHintFromSourceIndex: function _leftGroupHintFromSourceIndex(sourceIndex) {
                        return this.groupHintIndexFromGroup(this._leftGroupFromSourceIndex(sourceIndex))
                    }, groupIndexFromKey: function groupIndexFromKey(groupKey) {
                        var result = -1;
                        var currentIndex = -1;
                        if (this._headerRanges)
                            this._headerRanges.forEach(function(range) {
                                var exit = false;
                                currentIndex++;
                                if (range.data && range.data.key === key) {
                                    result = currentIndex;
                                    exit = true
                                }
                                return exit
                            });
                        return result
                    }, firstGroupItemIndexFromKey: function firstGroupItemIndexFromKey(groupKey) {
                        var result = -1;
                        if (this._groups && this._groups[groupKey])
                            result = this._groups[groupKey].start;
                        return result
                    }, groupHintIndexFromGroup: function groupHintIndexFromGroup(group) {
                        var groupHintIndex = -1;
                        if (group && group.parentKey && this.groupHints && this.groupHints.indexFromKey) {
                            groupHintIndex = this.groupHints.indexFromKey(group.parentKey);
                            if (typeof groupHintIndex !== "number")
                                groupHintIndex = -1
                        }
                        return groupHintIndex
                    }, countHeaders: function countHeaders(startIndex, endIndex) {
                        return 0
                    }, exclusionCountHeaders: function exclusionCountHeaders(startIndex, endIndex) {
                        return 0
                    }, calculate: function calculate(item) {
                        return (item && item.group) || (this._grouper ? this._grouper.execute(item) : null)
                    }, copy: function copy(item, oldItem) {
                        if (item && oldItem) {
                            item.group = oldItem.group;
                            item.isHeader = oldItem.isHeader
                        }
                        return item
                    }, isValidGroupOrParentGroup: function isValidGroupOrParentGroup(group) {
                        return !!(group && group.key) || !!(group && group.parentKey)
                    }, isValidGroup: function isValidGroup(group) {
                        return !!(group && group.key)
                    }, update: function update(index, item, existingItems) {
                        return this._insert(index, item, existingItems, true)
                    }, insert: function insert(index, item, existingItems) {
                        return this._insert(index, item, existingItems, false)
                    }, remove: function remove(index, item, existingItems) {
                        return this._remove(index, item, existingItems)
                    }, _sourceIndexFromIndex: function _sourceIndexFromIndex(index) {
                        var sourceIndex = index;
                        if (this._dataSource && this._dataSource.indexToSourceIndex)
                            sourceIndex = this._dataSource.indexToSourceIndex(index);
                        return sourceIndex
                    }, _sourceIndexToIndex: function _sourceIndexToIndex(sourceIndex) {
                        var index = sourceIndex;
                        if (this._dataSource && this._dataSource.indexFromSourceIndex)
                            index = this._dataSource.indexFromSourceIndex(index);
                        return index
                    }, _addGetHashCode: function _addGetHashCode(listItem, group) {
                        if (listItem && !listItem.getHashCode && group && group.parentKey) {
                            var parentKey = group.parentKey;
                            listItem.getHashCode = function getHashCode() {
                                return parentKey
                            }
                        }
                        listItem = null;
                        group = null
                    }, _createGroupHintListItem: function _createGroupHintListItem(firstItemIndex, group) {
                        var groupHint = {
                                Name: group.parentData && group.parentData.title, GroupId: group.parentKey
                            };
                        if (this._groupHints && this._groupHints.createItem) {
                            groupHint = this._groupHints.createItem(groupHint);
                            groupHint.preventAugmentation = true;
                            this._addGetHashCode(groupHint, group)
                        }
                        return groupHint
                    }, _insertGroupHintFromGroupIfNeeded: function _insertGroupHintFromGroupIfNeeded(firstItemIndex, group, itemBefore, itemAfter) {
                        if (!this._groupHints || !group)
                            return false;
                        var inserted = false;
                        var groupHintIndex = this.groupHintIndexFromGroup(group);
                        if (this._groupHints && groupHintIndex >= 0 && groupHintIndex < this._groupHints.count)
                            this._updateGroupHintSize(this._groupHints.getItem(groupHintIndex), 1);
                        else {
                            var itemBeforeGroupHintIndex = this.groupHintIndexFromGroup(itemBefore && itemBefore.group);
                            var itemAfterGroupHintIndex = this.groupHintIndexFromGroup(itemAfter && itemAfter.group);
                            var groupHint = this._createGroupHintListItem(firstItemIndex, group);
                            if (itemBeforeGroupHintIndex >= 0)
                                groupHintIndex = itemBeforeGroupHintIndex + 1;
                            else if (itemAfterGroupHintIndex >= 0)
                                groupHintIndex = itemAfterGroupHintIndex;
                            else if (this._groupHints.count === 0 || this._isStartOrEnd(itemBefore))
                                groupHintIndex = 0;
                            else if (this._isStartOrEnd(itemAfter))
                                groupHintIndex = this._groupHints.count;
                            else
                                groupHintIndex = this._leftGroupHintFromSourceIndex(firstItemIndex);
                            MS.Entertainment.Data.assert(groupHintIndex >= 0 || (this._isUnknown(itemBefore) && this._isUnknown(itemAfter)), "Couldn't find a spot for the missing group hint.");
                            if (groupHintIndex >= 0) {
                                var async = true;
                                inserted = true;
                                this._groupHints.insertAt(groupHintIndex, groupHint).done(function() {
                                    async = false
                                }, function ignoreError(error) {
                                    MS.Entertainment.Data.assert(WinJS.Promise.isCanceledError(error), "An unknown error occurred while adding a new group hint. error: " + (error && error.message))
                                });
                                MS.Entertainment.Data.assert(!async, "The groupHints data source should not be an async data source.");
                                this._initializeGroupHintAndSizes(this._groupHints.getItem(groupHintIndex), this._sourceIndexFromIndex(firstItemIndex))
                            }
                        }
                        return inserted
                    }, _insertHeaderIfNeeded: function _insertHeaderIfNeeded(index, group, itemBefore, itemAfter) {
                        var inserted = false;
                        if (group && this.isValidGroup(group)) {
                            var lastKnownIndex = -1;
                            if (this._groups[group.key])
                                lastKnownIndex = this._groups[group.key].start;
                            if (lastKnownIndex < 0) {
                                this._insertHeader(index, group, itemBefore, itemAfter);
                                lastKnownIndex = index;
                                inserted = true
                            }
                        }
                        return inserted
                    }, _updateHeaderIfNeeded: function _updateHeaderIfNeeded(newGroup) {
                        if (newGroup && !newGroup.fromGroupHint) {
                            var groupRange = this._groups[newGroup.key];
                            var firstItemIndex = -1;
                            var groupListItem = null;
                            if (groupRange && groupRange.data && groupRange.data.fromGroupHint) {
                                firstItemIndex = groupRange.start;
                                groupRange.data = null
                            }
                            if (firstItemIndex >= 0) {
                                groupListItem = new MS.Entertainment.Data.Factory.ListHeaderWrapper(newGroup, firstItemIndex);
                                this._pushPendingChange({
                                    change: "Update", absoluteIndex: firstItemIndex, value: groupListItem, groupIndex: this.groupIndexFromSourceIndex(firstItemIndex)
                                });
                                this._onHeaderUpdated(firstItemIndex, groupListItem)
                            }
                        }
                    }, _onHeaderUpdated: function _onHeaderUpdated(firstItemIndex, groupListItem){}, _createHeaderItem: function _createHeaderItem(firstItemIndex, group) {
                        return new MS.Entertainment.Data.Factory.ListHeaderWrapper(group, firstItemIndex)
                    }, _insertItem: function _insertItem(index, item, itemBefore, itemAfter) {
                        this._insertGroupHintFromGroupIfNeeded(index, item && item.group, itemBefore, itemAfter)
                    }, _updateItem: function _updateItem(index, item, itemBefore, itemAfter, oldGroup) {
                        var groupHintIndex = -1;
                        var newGroup = item && item.group;
                        if (oldGroup && newGroup && !this._areGroupsEqual(oldGroup, newGroup))
                            groupHintIndex = this.groupHintIndexFromGroupHintKey(oldGroup.parentKey);
                        if (groupHintIndex >= 0) {
                            this._removeItemFromGroupHint(groupHintIndex);
                            this._insertGroupHintFromGroupIfNeeded(index, item && item.group, itemBefore, itemAfter)
                        }
                    }, _updateHeader: function _updateHeader(firstItemIndex, group) {
                        var groupListItem = this._createHeaderItem(firstItemIndex, group);
                        MS.Entertainment.Data.assert(group, "The group header being inserted is null");
                        MS.Entertainment.Data.assert(this._groups[group.key], "Updating a header that doesn't exist, this should not happen");
                        var groupCache = this._groups[group.key];
                        if (groupCache)
                            groupCache.data = group;
                        this._pushPendingChange({
                            change: "Update", absoluteIndex: firstItemIndex, value: groupListItem, groupIndex: this.groupIndexFromSourceIndex(firstItemIndex)
                        })
                    }, _insertHeader: function _insertHeader(firstItemIndex, group, itemBefore, itemAfter) {
                        var groupListItem = this._createHeaderItem(firstItemIndex, group);
                        MS.Entertainment.Data.assert(group, "The group header being inserted is null");
                        MS.Entertainment.Data.assert(!group || group.key, "The group header key being inserted is null");
                        MS.Entertainment.Data.assert(!this._groups[group.key], "Inserting a header that already exists, this should not happen");
                        if (this.isInlineGrouper) {
                            this._insertItem(firstItemIndex, groupListItem, itemBefore, itemAfter);
                            this._headerRanges.shift(firstItemIndex, true)
                        }
                        this._groups[group.key] = this._headerRanges.insert(firstItemIndex);
                        this._groups[group.key].data = group;
                        this._pendingInserts++;
                        this._pushPendingChange({
                            change: "Add", absoluteIndex: firstItemIndex, value: groupListItem, groupIndex: this.groupIndexFromSourceIndex(firstItemIndex)
                        });
                        this._onHeaderInserted(firstItemIndex, groupListItem)
                    }, _onHeaderInserted: function _onHeaderInserted(firstItemIndex, groupListItem){}, _removeItem: function _removeItem(index) {
                        var groupHintIndex = this.groupHintIndexFromIndex(index);
                        this._removeItemFromGroupHint(groupHintIndex)
                    }, _removeItemFromGroupHint: function _removeItemFromGroupHint(groupHintIndex) {
                        var groupHint;
                        if (this._groupHints && groupHintIndex >= 0 && groupHintIndex < this._groupHints.count)
                            groupHint = this._groupHints.getItem(groupHintIndex);
                        if (groupHint) {
                            this._updateGroupHintSize(groupHint, -1);
                            if (groupHint.data && groupHint.data.totalCount <= 0)
                                this._groupHints.removeAt(groupHintIndex)
                        }
                    }, _removeHeader: function _removeHeader(firstItemIndex, group) {
                        MS.Entertainment.Data.assert(firstItemIndex >= 0, "Item index should be negative");
                        this._pushPendingChange({
                            change: "Remove", absoluteIndex: firstItemIndex, groupIndex: this.groupIndexFromSourceIndex(firstItemIndex)
                        });
                        this._onHeaderRemoved(firstItemIndex);
                        var removedRange = !!this._headerRanges.remove(firstItemIndex);
                        MS.Entertainment.Data.assert(removedRange, "No range was removed");
                        if (!group && removedRange)
                            group = removedRange.data;
                        MS.Entertainment.Data.assert(!removedRange || !removedRange.data || !group || group.key === removedRange.data.key, "We removed the wrong range from the header ranges.");
                        if (group && group.key && group.key in this._groups)
                            delete this._groups[group.key];
                        if (this.isInlineGrouper) {
                            this._removeItem(firstItemIndex);
                            this._headerRanges.shift(firstItemIndex + 1, false)
                        }
                    }, _onHeaderRemoved: function _onHeaderRemoved(firstItemIndex){}, _onDispatchingChanges: function _onDispatchingChanges(changes){}, _pushPendingChange: function _pushPendingChange(change) {
                        this._pendingChanges = this._pendingChanges || [];
                        this._pendingChanges.push(change)
                    }, _dispatchChanges: function _dispatchChanges() {
                        var tracingId = this._getTracingId();
                        var pendingChanges = this._pendingChanges;
                        this._pendingChanges = null;
                        this._pendingInserts = 0;
                        if (pendingChanges && pendingChanges.length) {
                            msWriteProfilerMark("ent:ListGrouperBase:_dispatchChanges: " + tracingId + ",StartTM");
                            this._onDispatchingChanges(pendingChanges);
                            this.dispatchEvent(MS.Entertainment.Data.listGrouperEvents.batchChange, {
                                sender: this, changes: pendingChanges
                            });
                            msWriteProfilerMark("ent:ListGrouperBase:_dispatchChanges: " + tracingId + ",StopTM")
                        }
                    }, _onGroupHintsChanged: function _onGroupHintsChanged(newValue, oldValue) {
                        var firstGroupHints = !!newValue && !oldValue;
                        var ranges = [];
                        var headersInserted = 0;
                        var tracingId = this._getTracingId();
                        if (!firstGroupHints)
                            this._stopInsertingGroupHintHeaders = true;
                        if (!newValue)
                            return WinJS.Promise.wrap();
                        var returnPromise = newValue.forEachAll(function addItem(args) {
                                var item = args.item;
                                this._initializeGroupHint(item)
                            }.bind(this)).then(null, function handleError(error) {
                                MS.Entertainment.Data.fail("forEachAll failed when expanding group hints. error: " + (error && error.message))
                            });
                        if (!this._stopInsertingGroupHintHeaders) {
                            msWriteProfilerMark("ent:ListGrouperBase:instertGroupHintAsHeader: " + tracingId + ",StartTM");
                            newValue.forEachAll(function addItem(args) {
                                if (this._stopInsertingGroupHintHeaders) {
                                    args.stop = true;
                                    return
                                }
                                var item = args.item;
                                this._insertGroupFromGroupHint(item);
                                if (this._groupHintsDispatchCount > 0 && this.headerCount % this._groupHintsDispatchCount === 0) {
                                    this._dispatchChanges();
                                    return WinJS.Promise.timeout()
                                }
                            }.bind(this)).then(null, function ingoreError(){}).done(function dispatchChanges() {
                                this._dispatchChanges();
                                msWriteProfilerMark("ent:ListGrouperBase:instertGroupHintAsHeader: " + tracingId + ",StopTM")
                            }.bind(this))
                        }
                        return returnPromise
                    }, _insertGroupFromGroupHint: function _insertGroupFromGroupHint(groupHint) {
                        var group;
                        if (!groupHint || !groupHint.data)
                            return;
                        var subGroupHint;
                        var subGroupHintsLength = groupHint.data.subGroupHints ? groupHint.data.subGroupHints.length : 0;
                        if (subGroupHintsLength && groupHint.data.firstItemIndexSourceHint >= 0)
                            for (var i = 0; i < subGroupHintsLength; i++) {
                                subGroupHint = groupHint.data.subGroupHints[i];
                                this._insertGroupFromGroupHint({data: subGroupHint})
                            }
                        else if (!subGroupHintsLength && groupHint.data.firstItemIndexSourceHint >= 0)
                            group = this.calculate(groupHint);
                        if (group) {
                            group.fromGroupHint = true;
                            this._insertGroupHeaderFromGroupHint(groupHint, group)
                        }
                    }, _groupFromKey: function _groupFromKey(key) {
                        return (this._groups && this._groups[key] && this._groups[key].data) || null
                    }, _groupFromGroupIndex: function _groupFromGroupIndex(index) {
                        var groupCache = null;
                        var group = null;
                        if (this._groups)
                            groupCache = this._headerRanges.get(index);
                        if (groupCache)
                            group = groupCache.data;
                        return group
                    }, _isKnownGroup: function _isKnownGroup(group) {
                        return !!(group && this._groupFromKey(group.key))
                    }, _isStartOrEnd: function _isStartOrEnd(item) {
                        return item === undefined
                    }, _isHeader: function _isHeader(item) {
                        return !!(item && item.isHeader)
                    }, _isUnknown: function _isUnknown(item) {
                        return item === null
                    }, _areGroupsEqual: function _areGroupsEqual(group1, group2) {
                        var equal = false;
                        if (!group1 && !group2)
                            equal = true;
                        else
                            equal = !!(group1 && group2 && group1.key === group2.key);
                        return equal
                    }, _isMatch: function _isMatch(item, group) {
                        return !!(item && this._areGroupsEqual(group, item.group))
                    }, _isNotMatch: function _isNotMatch(item, group) {
                        return !!((this._isStartOrEnd(item)) || (item && group && item.group && item.group.key !== group.key))
                    }, _calculateAndApplyGroup: function _calculateAndApplyGroup(item) {
                        var group = this.calculate(item);
                        if (this.isValidGroupOrParentGroup(group)) {
                            if (this._isKnownGroup(group) && this.isValidGroup(group)) {
                                group = this._groups[group.key].data;
                                MS.Entertainment.Data.assert(!!group, "A known group shouldn't have null data")
                            }
                            this._setGroup(item, group)
                        }
                        return group
                    }, _setGroup: function _setGroup(listItem, group) {
                        if (listItem)
                            listItem.group = group;
                        return listItem
                    }, _shiftHeaderRanges: function _shiftHeaderRanges(startIndex, increase) {
                        this._headerRanges.shift(startIndex, increase)
                    }, _insert: function _insert(index, item, existingItems, updating) {
                        MS.Entertainment.Data.fail("Derived classes must define _insert")
                    }, _insertGroupHeaderFromGroupHint: function _insertGroupHeaderFromGroupHint(groupHint, group) {
                        MS.Entertainment.Data.fail("Derived classes must define _insertGroupHeaderFromGroupHint")
                    }, _remove: function _remove(index, item, existingItems) {
                        MS.Entertainment.Data.fail("Derived classes must define _remove")
                    }, _initializeGroupHintAndSizes: function _initializeGroupHintAndSizes(groupHint, firstItemIndexSourceHint) {
                        if (groupHint && this._groupHints) {
                            groupHint.data.firstItemIndexSourceHint = firstItemIndexSourceHint;
                            groupHint.data.totalCount = 0;
                            this._updateGroupHintSize(groupHint, 1);
                            this._initializeGroupHint(groupHint)
                        }
                    }, _initializeGroupHint: function _initializeGroupHint(groupHint) {
                        if (groupHint && groupHint.data) {
                            var dataSource = this._dataSource;
                            if (dataSource)
                                MS.Entertainment.Data.Factory.ListItemWrapper.addFirstItemIndexHint(groupHint, function() {
                                    var index = groupHint.data.firstItemIndexSourceHint;
                                    if (dataSource.indexFromSourceIndex)
                                        index = dataSource.indexFromSourceIndex(index);
                                    return index
                                })
                        }
                    }, _updateGroupHintSize: function _updateGroupHintSize(groupHint, increase) {
                        if (groupHint && this._groupHints) {
                            var groupHintIndex = groupHint.itemIndex;
                            var currentItem = groupHint;
                            if (increase >= 0 || currentItem.data.totalCount >= 0) {
                                currentItem.data.totalCount += increase;
                                for (var i = groupHintIndex + 1; i < this._groupHints.count; i++) {
                                    currentItem = this._groupHints.getItem(i);
                                    currentItem.data.firstItemIndexSourceHint += increase
                                }
                            }
                        }
                    }
            }, {clearGroup: function clearGroup(item) {
                    if (item) {
                        item.group = null;
                        item.isHeader = false
                    }
                }})
    });
    WinJS.Namespace.defineWithParent(MSE, "Data", {ListGrouper: MS.Entertainment.UI.Framework.derive("MS.Entertainment.Data.ListGrouperBase", function listGrouper(grouper, dataSource) {
            MS.Entertainment.Data.ListGrouperBase.prototype.constructor.call(this, grouper, dataSource)
        }, {
            isInlineGrouper: {get: function get_isInlineGrouper() {
                    return true
                }}, countHeaders: function countHeaders(startIndex, endIndex) {
                    return this._headerRanges.count(startIndex, endIndex)
                }, exclusionCountHeaders: function exclusionCountHeaders(startIndex, endIndex) {
                    return this._headerRanges.exclusionCount(startIndex, endIndex)
                }, _insert: function _insert(index, item, existingItems, updating) {
                    if (!item || item.isHeader || (updating && item.group) || this.isGrouperEmpty)
                        return index;
                    var itemBefore = existingItems(index - 1);
                    var itemAfter = existingItems(updating ? index + 1 : index);
                    var group = this.calculate(item);
                    if (!this.isValidGroup(group)) {
                        if (!updating)
                            this._insertItem(index, item, itemBefore, itemAfter);
                        return index
                    }
                    var groupHeaderIndex = -1;
                    if (this._isNotMatchingHeader(itemBefore, group)) {
                        if (updating)
                            this._removeHeader(index - 1, itemBefore.group);
                        else
                            itemAfter = itemBefore;
                        index--;
                        itemBefore = existingItems(index - 1)
                    }
                    if (this._canInsertHeaderUsingGroup(item, group))
                        index = this._moveOrInsertHeaderIfNeeded(index, group, itemBefore, itemAfter).index;
                    this._updateHeaderIfNeeded(group);
                    item.group = group;
                    if (!updating) {
                        this._shiftHeaderRanges(index, true);
                        this._insertItem(index, item, itemBefore, itemAfter)
                    }
                    if (itemAfter) {
                        if (this._canInsertHeaderUsingGroup(itemAfter, itemAfter.group)) {
                            var moveResult = this._moveOrInsertHeaderIfNeeded(index + 1, itemAfter.group, item, null);
                            if (moveResult.oldHeaderIndex >= 0 && moveResult.oldHeaderIndex < index && moveResult.oldHeaderIndex !== moveResult.newHeaderIndex)
                                index--
                        }
                        this._updateHeaderIfNeeded(itemAfter.group)
                    }
                    this._dispatchChanges();
                    return index
                }, _isNotMatchingHeader: function isNotMatchingHeader(item, group) {
                    return !!(item && item.isHeader && this._isNotMatch(item, group))
                }, _canInsertHeaderUsingGroup: function _canInsertHeaderUsingGroup(item, group) {
                    return !!(item && group && !item.isAction && !item.isHeader && !item.noHeader)
                }, _canInsertHeader: function _canInsertHeader(item) {
                    return !!(item && this._canInsertHeaderUsingGroup(item, item.group))
                }, _remove: function _remove(index, item, existingItems) {
                    item = item || {};
                    if (!item.isHeader && !this.isGrouperEmpty) {
                        var itemBefore = existingItems(index - 1);
                        var itemAfter = existingItems(index + 1);
                        this._removeItem(index, item);
                        if (this.isValidGroup(item && item.group)) {
                            if ((this._isStartOrEnd(itemBefore) || this._isHeader(itemBefore)) && (this._isStartOrEnd(itemAfter) || this._isHeader(itemAfter))) {
                                index--;
                                this._removeHeader(index, itemBefore && itemBefore.group)
                            }
                            this._shiftHeaderRanges(index + 1, false)
                        }
                        item.group = null;
                        this._dispatchChanges()
                    }
                    return index
                }, _moveOrInsertHeaderIfNeeded: function _moveOrInsertHeaderIfNeeded(index, group, itemBefore, itemAfter) {
                    var result = {
                            index: index, oldHeaderIndex: -1, newHeaderIndex: -1
                        };
                    var atBoundary = this._isNotMatch(itemBefore, group);
                    if (this._groups[group.key])
                        result.oldHeaderIndex = result.newHeaderIndex = this._groups[group.key].start;
                    if (atBoundary)
                        if (result.oldHeaderIndex === index)
                            index++;
                        else if (result.oldHeaderIndex >= 0 && result.oldHeaderIndex !== index - 1) {
                            this._removeHeader(result.oldHeaderIndex, group);
                            if (result.oldHeaderIndex < index)
                                index--;
                            result.newHeaderIndex = index;
                            this._insertHeader(index, group, itemBefore, itemAfter);
                            index++
                        }
                        else if (this._insertHeaderIfNeeded(index, group, itemBefore, itemAfter)) {
                            result.newHeaderIndex = index;
                            index++
                        }
                    result.index = index;
                    return result
                }, _insertGroupHeaderFromGroupHint: function _insertGroupHeaderFromGroupHint(groupHint, group) {
                    var firstItemIndexHint = this._sourceIndexToIndex(groupHint.data.firstItemIndexSourceHint);
                    this._insertHeaderIfNeeded(firstItemIndexHint + this._pendingInserts, group, null, null)
                }
        })})
})(WinJS.Namespace.define("MS.Entertainment", null))
