﻿/* Copyright (C) Microsoft Corporation. All rights reserved. */
scriptValidator();
(function() {
    "use strict";
    var MSE = WinJS.Namespace.define("MS.Entertainment", null);
    var VER_CLIENTTYPE_STR_EDS = "PCWindows";
    var VER_SERVICEVERSION_STR_EDS = "1.4";
    var SEARCH_CHUNK_SIZE = 20;
    var BROWSE_CHUNK_SIZE = 25;
    WinJS.Namespace.define("MS.Entertainment.Data.Query", {
        edsMediaGroup: {
            appType: "AppType", enhancedContentType: "EnhancedContentType", gameType: "GameType", movieType: "MovieType", musicType: "MusicType", musicArtistType: "MusicArtistType", tvType: "TVType", unknown: "Unknown", webVideoType: "WebVideoType"
        }, edsSortOrder: {
                allTimeAverageRating: "AllTimeAverageRating", allTimePlayCount: "AllTimePlayCount", allTimePurchaseCount: "AllTimePurchaseCount", allTimeRatingCount: "AllTimeRatingCount", allTimeRentalCount: "AllTimeRentalCount", allTimeUserRating: "AllTimeUserRating", criticRating: "CriticRating", digitalReleaseDate: "DigitalReleaseDate", freeAndPaidCountDaily: "FreeAndPaidCountDaily", mostPopular: "MostPopular", paidCountAllTime: "PaidCountAllTime", paidCountDaily: "PaidCountDaily", releaseDate: "ReleaseDate", sevenDaysAverageRating: "SevenDaysAverageRating", sevenDaysPlayCount: "SevenDaysPlayCount", sevenDaysPurchaseCount: "SevenDaysPurchaseCount", sevenDaysRentalCount: "SevenDaysRentalCount", sevenDaysRatingCount: "SevenDaysRatingCount", userRating: "UserRating"
            }, edsQueryRefiner: {
                decade: "Decade", genre: "Genre", network: "Network", studio: "Studio"
            }, edsEndpointType: {
                browse: "browse", crossMediaGroupSearch: "crossMediaGroupSearch", details: "details", fields: "fields", mediaGuide: "mediaGuide", metadata: "metadata", metadataMovieGenres: "metadata/mediaItemTypes/Movie/queryRefiners/genre", metadataMovieStudios: "metadata/mediaItemTypes/Movie/queryRefiners/studio", metadataMusicGenres: "metadata/mediaItemTypes/Album/queryRefiners/genre", metadataMusicSubGenres: "metadata/mediaItemTypes/Album/queryRefiners/genre/subQueryRefinerValues", metadataTvGenres: "metadata/mediaItemTypes/TVSeries/queryRefiners/genre", metadataTvNetworks: "metadata/mediaItemTypes/TVSeries/queryRefiners/network", recommendations: "recommendations", related: "related", searchTerms: "searchTerms", singleMediaGroupSearch: "singleMediaGroupSearch"
            }, edsFields: {
                allTimeAverageRating: "AllTimeAverageRating", allTimePlayCount: "AllTimePlayCount", allTimeRatingCount: "AllTimeRatingCount", amgId: "AmgId", availabilities: "Availabilities", awards: "Awards", contributors: "Contributors", copyright: "Copyright", criticRating: "CriticRating", description: "Description", duration: "Duration", episodeCount: "EpisodeCount", episodeNumber: "EpisodeNumber", explanation: "Explanation", explanations: "Explanations", genres: "Genres", hasActivities: "HasActivities", hasSeasons: "HasSeasons", hasTrackMediaGuide: "HasTrackMediaGuide", id: "ID", images: "Images", isExplicit: "IsExplicit", isHero: "IsHero", isSeasonComplete: "IsSeasonComplete", label: "Label", labelOwner: "LabelOwner", latestEpisode: "LatestEpisode", latestSeason: "LatestSeason", legacyAmgId: "LegacyAmgId", legacyIds: "LegacyIds", mediaGroup: "MediaGroup", mediaItemType: "MediaItemType", mediaNetId: "MediaNetId", mergedMetadata: "MergedMetadata", musicAlbumType: "MusicAlbumType", musicVideoId: "MusicVideoId", name: "Name", network: "Network", networks: "Networks", parentAlbum: "ParentAlbum", parentalRating: "ParentalRating", parentalRatings: "ParentalRatings", parentalRatingReasons: "ParentalRatingReasons", parentalRatingSystem: "ParentalRatingSystem", parentItems: "ParentItems", parentSeason: "ParentSeason", parentSeries: "ParentSeries", previewDuration: "PreviewDuration", previewUrl: "PreviewUrl", primaryArtist: "PrimaryArtist", providers: "Providers", ratingId: "RatingId", relationType: "RelationType", relatedMedia: "RelatedMedia", releaseDate: "ReleaseDate", reviewSources: "ReviewSources", seasonCount: "SeasonCount", seasonNumber: "SeasonNumber", sevenDaysAverageRating: "SevenDaysAverageRating", sevenDaysPlayCount: "SevenDaysPlayCount", sevenDaysRatingCount: "SevenDaysRatingCount", sortName: "SortName", studio: "Studio", studios: "Studios", subGenres: "SubGenres", subTitle: "SubTitle", thirtyDaysAverageRating: "ThirtyDaysAverageRating", thirtyDaysPlayCount: "ThirtyDaysPlayCount", thirtyDaysRatingCount: "ThirtyDaysRatingCount", trackCount: "TrackCount", trackId: "TrackId", trackNumber: "TrackNumber", vuiDisplayName: "VuiDisplayName", zuneId: "ZuneId", zuneEpisodeCount: "ZuneEpisodeCount", zuneSeasonCount: "ZuneSeasonCount"
            }, bbxMediaType: {
                app: "bbxapps", album: "bbxalbum", allMovie: "bbxmovies", allTv: "bbxtv", allVideo: "bbxvideo", artist: "bbxartist", artistSmartDj: "bbxartisttrkmg", game: "bbxgames", firstParty: "bbxallfirstparty", movie: "bbxmoviesfirstparty", music: "bbxmusic", musicVideo: "bbxmusicvideo", track: "bbxtrack", tv: "bbxtvfirstparty", video: "bbxvideofirstparty", webVideo: "bbxwebvideo"
            }, edsArray: function edsArray(array) {
                var result;
                if (Array.isArray(array))
                    result = array.join(".");
                else if (array)
                    result = [array];
                return result
            }, edsString: function edsString(string) {
                if (string)
                    string = string.replace(/\s+/g, '+');
                return string
            }, edsSearchString: function edsSearchString(string) {
                if (string)
                    string = string.replace(/\+/g, '%2B');
                return string
            }
    });
    WinJS.Namespace.define("MS.Entertainment.Data.Query.edsMediaType", {
        appActivity: "AppActivity", avatarItem: "AvatarItem", gameActivity: "GameActivity", gameLayer: "GameLayer", metroGame: "MetroGame", metroGameConsumable: "MetroGameConsumable", metroGameContent: "MetroGameContent", mobileGame: "MobileGame", movie: "Movie", subscription: "Subscription", tvEpisode: "TVEpisode", tvSeason: "TVSeason", tvSeries: "TVSeries", tvShow: "TVShow", videoActivity: "VideoActivity", webGame: "WebGame", webVideo: "WebVideo", webVideoCollection: "WebVideoCollection", xbox360Game: "Xbox360Game", xbox360GameContent: "Xbox360GameContent", xbox360GameDemo: "Xbox360GameDemo", xboxApp: "XboxApp", xboxArcadeGame: "XboxArcadeGame", xboxBundle: "XboxBundle", xboxGameConsumable: "XboxGameConsumable", xboxGameTrailer: "XboxGameTrailer", xboxGameTrial: "XboxGameTrial", xboxGamerTile: "XboxGamerTile", xboxGameVideo: "XboxGameVideo", xboxMarketplace: "XboxMarketplace", xboxOriginalGame: "XboxOriginalGame", xboxTheme: "XboxTheme", xboxXnaCommunityGame: "XboxXnaCommunityGame", xboxMobilePDLC: "XboxMobilePDLC", xboxMobileConsumable: "XboxMobileConsumable"
    });
    WinJS.Namespace.define("MS.Entertainment.Data.Query", {
        edsMediaTypeToDatabaseMappings: (function() {
            var mapping = {};
            mapping[MS.Entertainment.Data.Query.edsMediaType.album] = Microsoft.Entertainment.Queries.ObjectType.album;
            mapping[MS.Entertainment.Data.Query.edsMediaType.avatarItem] = null;
            mapping[MS.Entertainment.Data.Query.edsMediaType.appActivity] = null;
            mapping[MS.Entertainment.Data.Query.edsMediaType.gameActivity] = null;
            mapping[MS.Entertainment.Data.Query.edsMediaType.videoActivity] = null;
            mapping[MS.Entertainment.Data.Query.edsMediaType.gameLayer] = Microsoft.Entertainment.Queries.ObjectType.game;
            mapping[MS.Entertainment.Data.Query.edsMediaType.metroGame] = Microsoft.Entertainment.Queries.ObjectType.game;
            mapping[MS.Entertainment.Data.Query.edsMediaType.metroGameConsumable] = null;
            mapping[MS.Entertainment.Data.Query.edsMediaType.metroGameContent] = null;
            mapping[MS.Entertainment.Data.Query.edsMediaType.mobileGame] = Microsoft.Entertainment.Queries.ObjectType.game;
            mapping[MS.Entertainment.Data.Query.edsMediaType.movie] = Microsoft.Entertainment.Queries.ObjectType.video;
            mapping[MS.Entertainment.Data.Query.edsMediaType.musicArtist] = Microsoft.Entertainment.Queries.ObjectType.person;
            mapping[MS.Entertainment.Data.Query.edsMediaType.musicVideo] = Microsoft.Entertainment.Queries.ObjectType.video;
            mapping[MS.Entertainment.Data.Query.edsMediaType.track] = Microsoft.Entertainment.Queries.ObjectType.track;
            mapping[MS.Entertainment.Data.Query.edsMediaType.tvEpisode] = Microsoft.Entertainment.Queries.ObjectType.video;
            mapping[MS.Entertainment.Data.Query.edsMediaType.tvSeason] = Microsoft.Entertainment.Queries.ObjectType.tvSeason;
            mapping[MS.Entertainment.Data.Query.edsMediaType.tvSeries] = Microsoft.Entertainment.Queries.ObjectType.tvSeries;
            mapping[MS.Entertainment.Data.Query.edsMediaType.tvShow] = Microsoft.Entertainment.Queries.ObjectType.video;
            mapping[MS.Entertainment.Data.Query.edsMediaType.webGame] = Microsoft.Entertainment.Queries.ObjectType.game;
            mapping[MS.Entertainment.Data.Query.edsMediaType.webVideo] = Microsoft.Entertainment.Queries.ObjectType.video;
            mapping[MS.Entertainment.Data.Query.edsMediaType.webVideoCollection] = null;
            mapping[MS.Entertainment.Data.Query.edsMediaType.xbox360Game] = Microsoft.Entertainment.Queries.ObjectType.game;
            mapping[MS.Entertainment.Data.Query.edsMediaType.xbox360GameContent] = null;
            mapping[MS.Entertainment.Data.Query.edsMediaType.xbox360GameDemo] = Microsoft.Entertainment.Queries.ObjectType.game;
            mapping[MS.Entertainment.Data.Query.edsMediaType.xboxApp] = Microsoft.Entertainment.Queries.ObjectType.game;
            mapping[MS.Entertainment.Data.Query.edsMediaType.xboxArcadeGame] = Microsoft.Entertainment.Queries.ObjectType.game;
            mapping[MS.Entertainment.Data.Query.edsMediaType.xboxBundle] = null;
            mapping[MS.Entertainment.Data.Query.edsMediaType.xboxGameConsumable] = null;
            mapping[MS.Entertainment.Data.Query.edsMediaType.xboxGameTrailer] = Microsoft.Entertainment.Queries.ObjectType.video;
            mapping[MS.Entertainment.Data.Query.edsMediaType.xboxGameTrial] = Microsoft.Entertainment.Queries.ObjectType.game;
            mapping[MS.Entertainment.Data.Query.edsMediaType.xboxGamerTile] = null;
            mapping[MS.Entertainment.Data.Query.edsMediaType.xboxGameVideo] = Microsoft.Entertainment.Queries.ObjectType.video;
            mapping[MS.Entertainment.Data.Query.edsMediaType.xboxMarketplace] = null;
            mapping[MS.Entertainment.Data.Query.edsMediaType.xboxOriginalGame] = Microsoft.Entertainment.Queries.ObjectType.game;
            mapping[MS.Entertainment.Data.Query.edsMediaType.xboxTheme] = null;
            mapping[MS.Entertainment.Data.Query.edsMediaType.xboxXnaCommunityGame] = Microsoft.Entertainment.Queries.ObjectType.game;
            mapping[MS.Entertainment.Data.Query.edsMediaType.xboxMobilePDLC] = null;
            mapping[MS.Entertainment.Data.Query.edsMediaType.xboxMobileConsumable] = null;
            return mapping
        })(), edsMediaTypeIntegerToStringMappings: {
                1: MS.Entertainment.Data.Query.edsMediaType.xbox360Game, 5: MS.Entertainment.Data.Query.edsMediaType.xboxGameTrial, 18: MS.Entertainment.Data.Query.edsMediaType.xbox360GameContent, 19: MS.Entertainment.Data.Query.edsMediaType.xbox360GameDemo, 20: MS.Entertainment.Data.Query.edsMediaType.xboxTheme, 21: MS.Entertainment.Data.Query.edsMediaType.xboxOriginalGame, 22: MS.Entertainment.Data.Query.edsMediaType.xboxGamerTile, 23: MS.Entertainment.Data.Query.edsMediaType.xboxArcadeGame, 30: MS.Entertainment.Data.Query.edsMediaType.xboxGameVideo, 37: MS.Entertainment.Data.Query.edsMediaType.xboxXnaCommunityGame, 47: MS.Entertainment.Data.Query.edsMediaType.avatarItem, 61: MS.Entertainment.Data.Query.edsMediaType.xboxApp, 62: MS.Entertainment.Data.Query.edsMediaType.metroGame, 63: MS.Entertainment.Data.Query.edsMediaType.metroGameContent, 64: MS.Entertainment.Data.Query.edsMediaType.metroGameConsumable, 66: MS.Entertainment.Data.Query.edsMediaType.gameActivity, 67: MS.Entertainment.Data.Query.edsMediaType.appActivity, 901: MS.Entertainment.Data.Query.edsMediaType.videoActivity, 1000: MS.Entertainment.Data.Query.edsMediaType.movie, 1002: MS.Entertainment.Data.Query.edsMediaType.tvShow, 1003: MS.Entertainment.Data.Query.edsMediaType.tvEpisode, 1004: MS.Entertainment.Data.Query.edsMediaType.tvSeries, 1005: MS.Entertainment.Data.Query.edsMediaType.tvSeason, 1006: MS.Entertainment.Data.Query.edsMediaType.album, 1007: MS.Entertainment.Data.Query.edsMediaType.track, 1008: MS.Entertainment.Data.Query.edsMediaType.musicVideo, 1009: MS.Entertainment.Data.Query.edsMediaType.musicArtist
            }, edsMediaTypeToVideoTypeMappings: (function() {
                var mapping = {};
                mapping[MS.Entertainment.Data.Query.edsMediaType.movie] = Microsoft.Entertainment.Queries.VideoType.movie;
                mapping[MS.Entertainment.Data.Query.edsMediaType.musicVideo] = Microsoft.Entertainment.Queries.VideoType.musicVideo;
                mapping[MS.Entertainment.Data.Query.edsMediaType.tvEpisode] = Microsoft.Entertainment.Queries.VideoType.tvEpisode;
                mapping[MS.Entertainment.Data.Query.edsMediaType.tvShow] = Microsoft.Entertainment.Queries.VideoType.other;
                mapping[MS.Entertainment.Data.Query.edsMediaType.tvSeries] = null;
                mapping[MS.Entertainment.Data.Query.edsMediaType.tvSeason] = null;
                mapping[MS.Entertainment.Data.Query.edsMediaType.webVideo] = Microsoft.Entertainment.Queries.VideoType.other;
                mapping[MS.Entertainment.Data.Query.edsMediaType.xboxGameTrailer] = Microsoft.Entertainment.Queries.VideoType.other;
                mapping[MS.Entertainment.Data.Query.edsMediaType.xboxGameVideo] = Microsoft.Entertainment.Queries.VideoType.other;
                return mapping
            })(), edsMediaTypeToGameTypeMappings: (function() {
                var mapping = {};
                mapping[MS.Entertainment.Data.Query.edsMediaType.avatarItem] = Microsoft.Entertainment.Queries.GameType.console;
                mapping[MS.Entertainment.Data.Query.edsMediaType.metroGame] = Microsoft.Entertainment.Queries.GameType.windows;
                mapping[MS.Entertainment.Data.Query.edsMediaType.metroGameConsumable] = Microsoft.Entertainment.Queries.GameType.windows;
                mapping[MS.Entertainment.Data.Query.edsMediaType.metroGameContent] = Microsoft.Entertainment.Queries.GameType.windows;
                mapping[MS.Entertainment.Data.Query.edsMediaType.mobileGame] = null;
                mapping[MS.Entertainment.Data.Query.edsMediaType.webGame] = null;
                mapping[MS.Entertainment.Data.Query.edsMediaType.xboxApp] = Microsoft.Entertainment.Queries.GameType.console;
                mapping[MS.Entertainment.Data.Query.edsMediaType.xboxArcadeGame] = Microsoft.Entertainment.Queries.GameType.console;
                mapping[MS.Entertainment.Data.Query.edsMediaType.xboxGamerTile] = Microsoft.Entertainment.Queries.GameType.console;
                mapping[MS.Entertainment.Data.Query.edsMediaType.xboxGameTrial] = Microsoft.Entertainment.Queries.GameType.console;
                mapping[MS.Entertainment.Data.Query.edsMediaType.xboxGameVideo] = Microsoft.Entertainment.Queries.GameType.console;
                mapping[MS.Entertainment.Data.Query.edsMediaType.xboxOriginalGame] = Microsoft.Entertainment.Queries.GameType.console;
                mapping[MS.Entertainment.Data.Query.edsMediaType.xbox360Game] = Microsoft.Entertainment.Queries.GameType.console;
                mapping[MS.Entertainment.Data.Query.edsMediaType.xbox360GameContent] = Microsoft.Entertainment.Queries.GameType.console;
                mapping[MS.Entertainment.Data.Query.edsMediaType.xbox360GameDemo] = Microsoft.Entertainment.Queries.GameType.console;
                mapping[MS.Entertainment.Data.Query.edsMediaType.xboxTheme] = Microsoft.Entertainment.Queries.GameType.console;
                mapping[MS.Entertainment.Data.Query.edsMediaType.xboxXnaCommunityGame] = Microsoft.Entertainment.Queries.GameType.console;
                return mapping
            })(), edsMediaTypeToGameTitleTypeMappings: (function() {
                var mapping = {};
                mapping[MS.Entertainment.Data.Query.edsMediaType.avatarItem] = null;
                mapping[MS.Entertainment.Data.Query.edsMediaType.metroGame] = Microsoft.Entertainment.Queries.GameTitleType.standard;
                mapping[MS.Entertainment.Data.Query.edsMediaType.metroGameConsumable] = null;
                mapping[MS.Entertainment.Data.Query.edsMediaType.metroGameContent] = null;
                mapping[MS.Entertainment.Data.Query.edsMediaType.mobileGame] = Microsoft.Entertainment.Queries.GameTitleType.standard;
                mapping[MS.Entertainment.Data.Query.edsMediaType.webGame] = Microsoft.Entertainment.Queries.GameTitleType.standard;
                mapping[MS.Entertainment.Data.Query.edsMediaType.xboxApp] = Microsoft.Entertainment.Queries.GameTitleType.application;
                mapping[MS.Entertainment.Data.Query.edsMediaType.xboxArcadeGame] = Microsoft.Entertainment.Queries.GameTitleType.arcade;
                mapping[MS.Entertainment.Data.Query.edsMediaType.xboxGamerTile] = null;
                mapping[MS.Entertainment.Data.Query.edsMediaType.xboxGameTrial] = Microsoft.Entertainment.Queries.GameTitleType.standard;
                mapping[MS.Entertainment.Data.Query.edsMediaType.xboxGameVideo] = null;
                mapping[MS.Entertainment.Data.Query.edsMediaType.xboxOriginalGame] = Microsoft.Entertainment.Queries.GameTitleType.standard;
                mapping[MS.Entertainment.Data.Query.edsMediaType.xbox360Game] = Microsoft.Entertainment.Queries.GameTitleType.standard;
                mapping[MS.Entertainment.Data.Query.edsMediaType.xbox360GameContent] = null;
                mapping[MS.Entertainment.Data.Query.edsMediaType.xbox360GameDemo] = Microsoft.Entertainment.Queries.GameTitleType.demo;
                mapping[MS.Entertainment.Data.Query.edsMediaType.xboxTheme] = null;
                mapping[MS.Entertainment.Data.Query.edsMediaType.xboxXnaCommunityGame] = null;
                return mapping
            })(), edsMediaTypeToPersonTypeMappings: (function() {
                var mapping = {};
                mapping[MS.Entertainment.Data.Query.edsMediaType.musicArtist] = Microsoft.Entertainment.Queries.PersonType.artist;
                return mapping
            })(), edsMediaTypeToZuneHcrTypeMappings: (function() {
                var mapping = {};
                mapping[MS.Entertainment.Data.Query.edsMediaType.album] = "Album";
                mapping[MS.Entertainment.Data.Query.edsMediaType.movie] = "Movie";
                mapping[MS.Entertainment.Data.Query.edsMediaType.musicArtist] = "Artist";
                mapping[MS.Entertainment.Data.Query.edsMediaType.track] = "Track";
                mapping[MS.Entertainment.Data.Query.edsMediaType.tvSeries] = "Series";
                return mapping
            })(), edsMediaTypeToContentTypeMappings: (function() {
                var mapping = {};
                mapping[MS.Entertainment.Data.Query.edsMediaType.album] = "Album";
                mapping[MS.Entertainment.Data.Query.edsMediaType.movie] = "Movie";
                mapping[MS.Entertainment.Data.Query.edsMediaType.musicArtist] = "Artist";
                mapping[MS.Entertainment.Data.Query.edsMediaType.musicVideo] = "MusicVideo";
                mapping[MS.Entertainment.Data.Query.edsMediaType.track] = "Track";
                mapping[MS.Entertainment.Data.Query.edsMediaType.tvEpisode] = "Episode";
                mapping[MS.Entertainment.Data.Query.edsMediaType.tvSeason] = "Season";
                mapping[MS.Entertainment.Data.Query.edsMediaType.tvSeries] = "Series";
                return mapping
            })(), edsMediaTypeToGamePlatformTypeMappings: (function() {
                var mapping = {};
                mapping[MS.Entertainment.Data.Query.edsMediaType.metroGame] = MSE.Data.Augmenter.GamePlatform.Modern;
                mapping[MS.Entertainment.Data.Query.edsMediaType.xbox360Game] = MSE.Data.Augmenter.GamePlatform.Xbox;
                mapping[MS.Entertainment.Data.Query.edsMediaType.xboxArcadeGame] = MSE.Data.Augmenter.GamePlatform.Xbox;
                mapping[MS.Entertainment.Data.Query.edsMediaType.xboxOriginalGame] = MSE.Data.Augmenter.GamePlatform.Xbox;
                mapping[MS.Entertainment.Data.Query.edsMediaType.xboxXnaCommunityGame] = MSE.Data.Augmenter.GamePlatform.Xbox;
                return mapping
            })(), edsMediaTypeToPurchaseHelperTypeMappings: (function() {
                var mapping = {};
                return mapping
            })(), edsSortOrderToLegacySortOrder: (function() {
                var mapping = {};
                var marketplaceOrderBy = WinJS.Utilities.getMember("MS.Entertainment.Data.Query.marketplaceOrderBy") || {};
                mapping[MS.Entertainment.Data.Query.edsSortOrder.allTimePurchaseCount] = marketplaceOrderBy.salesRank;
                mapping[MS.Entertainment.Data.Query.edsSortOrder.mostPopular] = marketplaceOrderBy.playRank;
                mapping[MS.Entertainment.Data.Query.edsSortOrder.releaseDate] = marketplaceOrderBy.releaseDate;
                mapping[MS.Entertainment.Data.Query.edsSortOrder.sevenDaysRentalCount] = marketplaceOrderBy.rentalRank;
                mapping[MS.Entertainment.Data.Query.edsSortOrder.sevenDaysPurchaseCount] = marketplaceOrderBy.downloadRank;
                return mapping
            })(), convertToLegacySortIfNeeded: function convertToLegacySortIfNeeded(edsSort) {
                return edsSort
            }
    });
    WinJS.Namespace.define("MS.Entertainment.Data.Query", {edsMediaTypeToGameTypeGameTitleTypeMappings: (function() {
            var mapping = {};
            var edsMediaTypeToGameTypeMappings = MS.Entertainment.Data.Query.edsMediaTypeToGameTypeMappings;
            var edsMediaTypeToGameTitleTypeMappings = MS.Entertainment.Data.Query.edsMediaTypeToGameTitleTypeMappings;
            mapping[MS.Entertainment.Data.Query.edsMediaType.metroGame] = [edsMediaTypeToGameTypeMappings[MS.Entertainment.Data.Query.edsMediaType.metroGame], edsMediaTypeToGameTitleTypeMappings[MS.Entertainment.Data.Query.edsMediaType.metroGame]];
            mapping[MS.Entertainment.Data.Query.edsMediaType.mobileGame] = [edsMediaTypeToGameTypeMappings[MS.Entertainment.Data.Query.edsMediaType.mobileGame], edsMediaTypeToGameTitleTypeMappings[MS.Entertainment.Data.Query.edsMediaType.mobileGame]];
            mapping[MS.Entertainment.Data.Query.edsMediaType.webGame] = [edsMediaTypeToGameTypeMappings[MS.Entertainment.Data.Query.edsMediaType.webGame], edsMediaTypeToGameTitleTypeMappings[MS.Entertainment.Data.Query.edsMediaType.webGame]];
            mapping[MS.Entertainment.Data.Query.edsMediaType.xboxApp] = [edsMediaTypeToGameTypeMappings[MS.Entertainment.Data.Query.edsMediaType.xboxApp], edsMediaTypeToGameTitleTypeMappings[MS.Entertainment.Data.Query.edsMediaType.xboxApp]];
            mapping[MS.Entertainment.Data.Query.edsMediaType.xboxArcadeGame] = [edsMediaTypeToGameTypeMappings[MS.Entertainment.Data.Query.edsMediaType.xboxArcadeGame], edsMediaTypeToGameTitleTypeMappings[MS.Entertainment.Data.Query.edsMediaType.xboxArcadeGame]];
            mapping[MS.Entertainment.Data.Query.edsMediaType.xbox360Game] = [edsMediaTypeToGameTypeMappings[MS.Entertainment.Data.Query.edsMediaType.xbox360Game], edsMediaTypeToGameTitleTypeMappings[MS.Entertainment.Data.Query.edsMediaType.xbox360Game]];
            mapping[MS.Entertainment.Data.Query.edsMediaType.xbox360GameDemo] = [edsMediaTypeToGameTypeMappings[MS.Entertainment.Data.Query.edsMediaType.xbox360GameDemo], edsMediaTypeToGameTitleTypeMappings[MS.Entertainment.Data.Query.edsMediaType.xbox360GameDemo]];
            mapping[MS.Entertainment.Data.Query.edsMediaType.xboxXnaCommunityGame] = [edsMediaTypeToGameTypeMappings[MS.Entertainment.Data.Query.edsMediaType.xboxXnaCommunityGame], edsMediaTypeToGameTitleTypeMappings[MS.Entertainment.Data.Query.edsMediaType.xboxXnaCommunityGame]];
            return mapping
        })()});
    WinJS.Namespace.define("MS.Entertainment.Data.Query", {databaseMediaTypeToSubTypeMappingMappings: (function() {
            var mapping = {};
            mapping[Microsoft.Entertainment.Queries.ObjectType.album] = null;
            mapping[Microsoft.Entertainment.Queries.ObjectType.game] = MS.Entertainment.Data.Query.edsMediaTypeToGameTypeGameTitleTypeMappings;
            mapping[Microsoft.Entertainment.Queries.ObjectType.person] = MS.Entertainment.Data.Query.edsMediaTypeToPersonTypeMappings;
            mapping[Microsoft.Entertainment.Queries.ObjectType.playlist] = null;
            mapping[Microsoft.Entertainment.Queries.ObjectType.smartDJ] = null;
            mapping[Microsoft.Entertainment.Queries.ObjectType.track] = null;
            mapping[Microsoft.Entertainment.Queries.ObjectType.tvSeason] = null;
            mapping[Microsoft.Entertainment.Queries.ObjectType.tvSeries] = null;
            mapping[Microsoft.Entertainment.Queries.ObjectType.video] = MS.Entertainment.Data.Query.edsMediaTypeToVideoTypeMappings;
            return mapping
        })()});
    WinJS.Namespace.define("MS.Entertainment.Data.Query", {edsRequestFields: {basic: [MS.Entertainment.Data.Query.edsFields.id, MS.Entertainment.Data.Query.edsFields.mediaGroup, MS.Entertainment.Data.Query.edsFields.mediaItemType, MS.Entertainment.Data.Query.edsFields.name, ]}});
    WinJS.Namespace.define("MS.Entertainment.Data.Query", {EDSDeviceQuery: MSE.derive(MSE.Data.EDSWrapperQuery, null, {createTargetDeviceType: function createTargetDeviceType() {
                return MS.Entertainment.Utilities.defaultEdsTargetDeviceTypeFromApp
            }})});
    WinJS.Namespace.defineWithParent(MSE.Data, "Query", {
        CrossMediaSearch: MS.Entertainment.deferredDerive(MS.Entertainment.Data.Query.EDSDeviceQuery, null, {
            search: null, keyword: null, groupTypes: null, chunkSize: 1, enabledImpressionGuid: true, resultAugmentation: MS.Entertainment.Data.Augmenter.Marketplace.EDSSearchResult, forceSecureEndpoint: true, includeContentRestrictionHeader: true, createResourceURI: function() {
                    return this.getResourceEndpoint(MS.Entertainment.Data.Query.edsEndpointType.crossMediaGroupSearch)
                }, createParameters: function createParameters() {
                    return {
                            q: MS.Entertainment.Data.Query.edsSearchString(this.search || this.keyword), desiredMediaItemTypes: MS.Entertainment.Data.Query.edsArray(this.groupTypes), firstPartyOnly: true
                        }
                }
        }), AutoSuggest: MS.Entertainment.deferredDerive(MS.Entertainment.Data.ServiceWrapperQuery, null, {
                search: null, keyword: null, mediaType: MS.Entertainment.Data.Query.bbxMediaType.firstParty, serviceType: MS.Entertainment.Data.ServiceWrapperQuery.ServiceTypes.json, resultAugmentation: MS.Entertainment.Data.Augmenter.Marketplace.BBXAutoSuggestResult, getResourceEndpointID: function getResourceEndpointID() {
                        return MS.Entertainment.Endpoint.id.seid_BingAutoSuggest
                    }, createResourceURI: function() {
                        return this.getResourceEndpoint()
                    }, createParameters: function createParameters() {
                        if (!MS.Entertainment.Data.Query.AutoSuggest.cachedMarket) {
                            var configurationManager = new Microsoft.Entertainment.Configuration.ConfigurationManager;
                            MS.Entertainment.Data.Query.AutoSuggest.cachedMarket = configurationManager.marketplace.marketplaceCulture
                        }
                        return {
                                FORM: "XBOXQ5", q: this.search || this.keyword, ds: this.mediaType
                            }
                    }
            }, {cachedMarket: null}), edsWrapperQuery: MSE.derive(MSE.Data.ServiceWrapperQuery, null, {getResourceEndpointID: function getResourceEndpointID() {
                    return MS.Entertainment.Endpoint.id.seid_EDSSearch
                }}, {
                itemsPluralizer: "Items/Item", genresPluralizer: "Genres/Genre", providersPluralizer: "Providers/Provider", partnerApplicationLaunchInfosPluralizer: "PartnerApplicationLaunchInfos/PartnerApplicationLaunchInfo", providerContentsPluralizer: "ProviderContents/ProviderContent", searchTermsPluralizer: "SearchTerms/SearchTerm"
            })
    });
    WinJS.Namespace.defineWithParent(MSE.Data, "Query", {videoDetailsFromTitleIdAssetId: MSE.derive(MSE.Data.Query.edsWrapperQuery, null, {
            assetId: "", titleId: "", createResourceURI: function() {
                    return this.getResourceEndpoint() + "/titles/" + this.titleId + "/content"
                }, createParameters: function createParameters() {
                    return {
                            version: VER_SERVICEVERSION_STR_EDS, clientType: VER_CLIENTTYPE_STR_EDS, clientContext: "video", contentId: this.assetId
                        }
                }, pluralizers: [MSE.Data.Query.edsWrapperQuery.genresPluralizer, MSE.Data.Query.edsWrapperQuery.providersPluralizer, MSE.Data.Query.edsWrapperQuery.partnerApplicationLaunchInfosPluralizer], resultAugmentation: MSE.Data.Augmenter.Marketplace.VideoResultEDS
        })});
    WinJS.Namespace.defineWithParent(MSE.Data, "Query", {ESListServiceWrapperQuery: WinJS.Class.derive(MSE.Data.EDSWrapperQuery, function ESListService() {
            MS.Entertainment.Data.EDSWrapperQuery.prototype.constructor.call(this);
            this.shouldAuthenticate = true
        }, {
            getAuthenticatedResourceEndpointID: function getAuthenticationResourceEndpointID() {
                return MS.Entertainment.Endpoint.id.seid_ESListService
            }, getResourceEndpointID: function getResourceEndpointID() {
                    return MS.Entertainment.Endpoint.id.seid_ESListService
                }
        })});
    WinJS.Namespace.defineWithParent(MSE.Data, "Query", {GenericDetails: MS.Entertainment.deferredDerive(MS.Entertainment.Data.EDSWrapperQuery, null, {
            id: null, idType: null, serviceId: null, chunkSize: 0, resultAugmentation: MS.Entertainment.Data.Augmenter.Marketplace.EDSGenericResult, requestFields: MS.Entertainment.Data.Query.edsRequestFields.basic, createResourceURI: function() {
                    return this.getResourceEndpoint(MS.Entertainment.Data.Query.edsEndpointType.details)
                }, createParameters: function createParameters() {
                    return {
                            ids: this.id || this.serviceId, idType: (this.idType !== MS.Entertainment.Data.Query.edsIdType.canonical) ? this.idType : null, mediaGroup: MS.Entertainment.Data.Query.edsMediaGroup.unknown, firstPartyOnly: true
                        }
                }
        })});
    WinJS.Namespace.define("MS.Entertainment.Data.Query.Shared", {
        PinnedList: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MS.Entertainment.derive(MS.Entertainment.Data.Query.ESListServiceWrapperQuery, function PinnedList() {
                    this.base()
                }, {
                    clearResultOnFailure: true, useCache: true, useIfMatchCache: true, chunkSize: BROWSE_CHUNK_SIZE, aggregateChunks: true, resultAugmentation: MS.Entertainment.Data.Augmenter.Marketplace.EDSPinnedListResults, requestFields: MS.Entertainment.Data.EDSWrapperQuery.requestFieldsNotNeeded, forceSecureEndpoint: true, hasTotalCount: true, xuid: String.empty, createResourceURI: function() {
                            var suffix = MS.Entertainment.Data.Query.Shared.PinnedList.defaultSuffix.format(this.xuid);
                            return MS.Entertainment.Utilities.UriFactory.create(this.getResourceEndpoint(), suffix)
                        }, createEDSHeaders: function createEDSHeaders() {
                            return {
                                    "Content-Type": "application/json", Accept: "application/json", "x-xbl-contract-version": "2", "x-xbl-client-type": MS.Entertainment.Data.EDSWrapperQuery.clientType, "x-xbl-device-type": this.getHeaderDeviceType(), "x-xbl-client-version": MS.Entertainment.Data.EDSWrapperQuery.currentVersion
                                }
                        }, getResponseVersion: function getResponseVersion(result) {
                            return result.listVersion
                        }
                }, {defaultSuffix: "users/xuid({0})/lists/PINS/XBLPins"})
        }), PinnedListAdd: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MS.Entertainment.derive(MS.Entertainment.Data.Query.ESListServiceWrapperQuery, function pinnedListAdd(mediaItem, listVersion) {
                        this.base();
                        var provider = MS.Entertainment.Utilities.titleId;
                        if (mediaItem) {
                            var edsMediaItem;
                            var signedInUser = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signedInUser);
                            var locale = signedInUser.locale;
                            switch (mediaItem.mediaType) {
                                case Microsoft.Entertainment.Queries.ObjectType.playlist:
                                    edsMediaItem = {
                                        ContentType: MS.Entertainment.Data.Query.edsMediaType.musicPlaylist, ItemId: null, ProviderId: mediaItem.cloudSyncItemId, Provider: provider, ImageUrl: mediaItem.imageResizeUri, Title: mediaItem.name, Locale: locale
                                    };
                                    if (mediaItem.tracks)
                                        this.getImagePromise = function getImagePromise() {
                                            return mediaItem.tracks.getCount().then(function getFirstTrack(count) {
                                                    if (count > 0)
                                                        return mediaItem.tracks.itemsFromIndex(0)
                                                }).then(function getTrackImage(args) {
                                                    if (args && args.items && args.items[0] && args.items[0].data) {
                                                        var url = MS.Entertainment.UI.Shell.ImageLoader.getNewImageServiceUri(args.items[0].data, MS.Entertainment.Utilities.playlistPinImageSize.width, MS.Entertainment.Utilities.playlistPinImageSize.height);
                                                        if (url) {
                                                            edsMediaItem.ImageUrl = url;
                                                            this._updatePostData(edsMediaItem)
                                                        }
                                                    }
                                                }.bind(this), function onError(error) {
                                                    return WinJS.Promise.wrapError("pinnedListAdd getImageUri failed: " + error && error.message)
                                                })
                                        }.bind(this);
                                    break;
                                case Microsoft.Entertainment.Queries.ObjectType.album:
                                    edsMediaItem = {
                                        ContentType: MS.Entertainment.Data.Query.edsMediaType.album, ItemId: null, ProviderId: mediaItem.canonicalId, Provider: provider, ImageUrl: mediaItem.imageResizeUri, Title: mediaItem.name, Locale: locale
                                    };
                                    break;
                                case Microsoft.Entertainment.Queries.ObjectType.person:
                                    edsMediaItem = {
                                        ContentType: MS.Entertainment.Data.Query.edsMediaType.musicArtist, ItemId: null, ProviderId: mediaItem.canonicalId, Provider: provider, ImageUrl: mediaItem.imageResizeUri, Title: mediaItem.name, Locale: locale
                                    };
                                    break;
                                case Microsoft.Entertainment.Queries.ObjectType.video:
                                    edsMediaItem = {
                                        ContentType: MS.Entertainment.Data.Query.edsMediaType.movie, ItemId: null, ProviderId: mediaItem.canonicalId, Provider: provider, ImageUrl: mediaItem.imageResizeUri, Title: mediaItem.name, Locale: locale
                                    };
                                    break;
                                case Microsoft.Entertainment.Queries.ObjectType.tvSeries:
                                    edsMediaItem = {
                                        ContentType: MS.Entertainment.Data.Query.edsMediaType.tvSeries, ItemId: null, ProviderId: mediaItem.canonicalId, Provider: provider, ImageUrl: mediaItem.imageResizeUri, Title: mediaItem.name, Locale: locale
                                    };
                                    break;
                                default:
                                    MS.Entertainment.ViewModels.fail("Object type " + mediaItem.mediaType + " is not pinnable");
                                    break
                            }
                            this._listVersion = listVersion;
                            this.requestType = MS.Entertainment.Data.ServiceWrapperQuery.RequestTypes.post;
                            this._updatePostData(edsMediaItem)
                        }
                    }, {
                        chunkSize: 0, useCache: false, forceSecureEndpoint: true, requestFields: MS.Entertainment.Data.EDSWrapperQuery.requestFieldsNotNeeded, getImagePromise: null, createResourceURI: function() {
                                var suffix;
                                var signedInUser = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signedInUser);
                                var suffix = MS.Entertainment.Data.Query.Shared.PinnedList.defaultSuffix.format(signedInUser.xuid);
                                return MS.Entertainment.Utilities.UriFactory.create(this.getResourceEndpoint(), suffix)
                            }, createEDSHeaders: function createEDSHeaders() {
                                return {
                                        Accept: "application/json", "x-xbl-contract-version": "2", "x-xbl-client-type": MS.Entertainment.Data.EDSWrapperQuery.clientType, "x-xbl-device-type": this.getHeaderDeviceType(), "x-xbl-client-version": MS.Entertainment.Data.EDSWrapperQuery.currentVersion, "if-match": this._listVersion
                                    }
                            }, execute: function execute() {
                                if (this.getImagePromise)
                                    return this.getImagePromise().then(function onImageAquired() {
                                            return MS.Entertainment.Data.Query.ESListServiceWrapperQuery.prototype.execute.apply(this, arguments)
                                        }.bind(this), function onImageError() {
                                            return MS.Entertainment.Data.Query.ESListServiceWrapperQuery.prototype.execute.apply(this, arguments)
                                        }.bind(this));
                                else
                                    return MS.Entertainment.Data.Query.ESListServiceWrapperQuery.prototype.execute.apply(this, arguments)
                            }, _updatePostData: function _updatePostData(edsMediaItem) {
                                var data = {Items: [edsMediaItem]};
                                this.postData = {
                                    contentType: "application/json", data: JSON.stringify(data)
                                }
                            }
                    }, {contentType: "application/json"})
            }), PinnedListDelete: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MS.Entertainment.derive(MS.Entertainment.Data.Query.ESListServiceWrapperQuery, function pinnedListDelete(listIndex, listVersion) {
                        this.base();
                        this._indices = listIndex;
                        this._listVersion = listVersion;
                        this.requestType = MS.Entertainment.Data.ServiceWrapperQuery.RequestTypes.deleteRequest
                    }, {
                        chunkSize: 0, useCache: false, _indices: String.empty, _listVersion: 0, forceSecureEndpoint: true, requestFields: MS.Entertainment.Data.EDSWrapperQuery.requestFieldsNotNeeded, createResourceURI: function() {
                                var suffix;
                                var signedInUser = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signedInUser);
                                var suffix = MS.Entertainment.Data.Query.Shared.PinnedList.defaultSuffix.format(signedInUser.xuid);
                                return MS.Entertainment.Utilities.UriFactory.create(this.getResourceEndpoint(), suffix)
                            }, createEDSHeaders: function createEDSHeaders() {
                                return {
                                        Accept: "application/json", "x-xbl-contract-version": "2", "x-xbl-client-type": MS.Entertainment.Data.EDSWrapperQuery.clientType, "x-xbl-device-type": this.getHeaderDeviceType(), "x-xbl-client-version": MS.Entertainment.Data.EDSWrapperQuery.currentVersion, "if-match": this._listVersion
                                    }
                            }, createParameters: function createParameters() {
                                return {indexes: this._indices}
                            }
                    })
            })
    })
})()
