﻿/* Copyright (C) Microsoft Corporation. All rights reserved. */
scriptValidator();
(function() {
    "use strict";
    var MSE = WinJS.Namespace.define("MS.Entertainment", null);
    WinJS.Namespace.defineWithParent(MSE.Data, "Query", {LibraryQueryBase: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.derive(MSE.Data.LibraryWrapperQuery, null, {
                    groupsAugmentation: MSE.Data.Augmenter.Library.GroupsAugmentation, getItemIndexAsync: function getItemIndexAsync(libraryId) {
                            var getItemIndexPromise;
                            if (this._innerQuery && this._innerQuery.getItemIndexAsync)
                                getItemIndexPromise = this._innerQuery.getItemIndexAsync(libraryId);
                            return WinJS.Promise.as(getItemIndexPromise)
                        }, executeCount: function executeCount() {
                            var innerQuery = this.createInnerQuery();
                            return innerQuery.getCountAsync()
                        }
                }, {isLibraryQuery: function LibraryQuery_isLibraryQuery(object) {
                        return MS.Entertainment.Data.Query.LibraryQueryBase.prototype.isPrototypeOf(object)
                    }})
        })});
    WinJS.Namespace.defineWithParent(MSE.Data, "Query", {libraryGenres: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.derive(MSE.Data.Query.LibraryQueryBase, null, {
                    mediaType: Microsoft.Entertainment.Queries.GenresQueryMediaType.undefined, videoType: -1, sort: Microsoft.Entertainment.Queries.GenresSortBy.none, createInnerQuery: function createInnerQuery() {
                            var query = new Microsoft.Entertainment.Queries.GenresQuery;
                            query.mediaType = this.mediaType;
                            if (this.videoType !== -1)
                                query.videoType = this.videoType;
                            query.primarySortBy = this.sort;
                            return query
                        }, resultAugmentation: MSE.Data.Augmenter.Library.GenresResult, aggregateChunks: true
                })
        })});
    WinJS.Namespace.defineWithParent(MSE.Data, "Query", {libraryVideos: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.derive(MSE.Data.Query.LibraryQueryBase, null, {
                    category: -1, genreId: -1, seasonId: -1, seriesId: -1, folderId: null, sort: Microsoft.Entertainment.Queries.VideosSortBy.none, studio: null, keyword: null, objectIds: null, videoUrl: null, mediaAvailability: null, createInnerQuery: function createInnerQuery() {
                            var query = new Microsoft.Entertainment.Queries.VideosQuery;
                            if (this.category !== -1)
                                query.category = this.category;
                            if (this.genreId !== -1)
                                query.genreId = this.genreId;
                            if (this.seasonId !== -1)
                                query.seasonId = this.seasonId;
                            if (this.seriesId !== -1)
                                query.seriesId = this.seriesId;
                            if (this.folderId !== null)
                                query.folderId = this.folderId;
                            if (this.studio !== null)
                                query.studio = this.studio;
                            if (this.keyword)
                                query.keyword = this.keyword;
                            if (this.objectIds)
                                query.objectIds = this.objectIds;
                            if (this.videoUrl !== null)
                                query.videoUrl = this.videoUrl;
                            if (this.mediaAvailability !== null)
                                query.mediaAvailability = this.mediaAvailability;
                            query.primarySortBy = this.sort;
                            return query
                        }, resultAugmentation: MSE.Data.Augmenter.Library.VideosResult, aggregateChunks: true
                })
        })});
    WinJS.Namespace.defineWithParent(MSE.Data, "Query", {
        libraryVideoMovies: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.derive(MSE.Data.Query.libraryVideos, null, {
                    category: Microsoft.Entertainment.Queries.VideoType.movie, resultAugmentation: MSE.Data.Augmenter.Library.MoviesResult
                })
        }), libraryVideoTV: MS.Entertainment.UI.Framework.lazyDefine(function() {
                return MSE.derive(MSE.Data.Query.libraryVideos, null, {
                        category: Microsoft.Entertainment.Queries.VideoType.tvEpisode, resultAugmentation: MSE.Data.Augmenter.Library.TVEpisodesResult
                    })
            })
    });
    WinJS.Namespace.defineWithParent(MSE.Data, "Query", {libraryTVSeries: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.derive(MSE.Data.Query.LibraryQueryBase, null, {
                    keyword: null, sort: Microsoft.Entertainment.Queries.TVSeriesSortBy.none, mediaAvailability: null, createInnerQuery: function createInnerQuery() {
                            var query = new Microsoft.Entertainment.Queries.TVSeriesQuery;
                            if (this.keyword)
                                query.keyword = this.keyword;
                            if (this.mediaAvailability !== null)
                                query.mediaAvailability = this.mediaAvailability;
                            query.primarySortBy = this.sort;
                            return query
                        }, resultAugmentation: MSE.Data.Augmenter.Library.TVSeriesResult, aggregateChunks: true
                })
        })});
    WinJS.Namespace.defineWithParent(MSE.Data, "Query", {libraryVideoOther: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.derive(MSE.Data.Query.libraryVideos, null, {category: Microsoft.Entertainment.Queries.VideoType.other})
        })})
})()
