﻿/* Copyright (C) Microsoft Corporation. All rights reserved. */
scriptValidator();
(function() {
    "use strict";
    var MSE = WinJS.Namespace.define("MS.Entertainment", null);
    var edsArray = MS.Entertainment.Data.Query.edsArray;
    var edsEndpointType = MS.Entertainment.Data.Query.edsEndpointType;
    var edsFields = MS.Entertainment.Data.Query.edsFields;
    var edsIdType = MS.Entertainment.Data.Query.edsIdType;
    var edsMediaGroup = MS.Entertainment.Data.Query.edsMediaGroup;
    var edsMediaType = MS.Entertainment.Data.Query.edsMediaType;
    var edsQueryRefiner = MS.Entertainment.Data.Query.edsQueryRefiner;
    var edsSortOrder = MS.Entertainment.Data.Query.edsSortOrder;
    var edsString = MS.Entertainment.Data.Query.edsString;
    var edsSearchString = MS.Entertainment.Data.Query.edsSearchString;
    var SEARCH_CHUNK_SIZE = 40;
    var VIDEO_SEARCH_CHUNK_SIZE = 25;
    var BROWSE_CHUNK_SIZE = 25;
    var RELATED_CHUNK_SIZE = 0;
    WinJS.Namespace.define("MS.Entertainment.Data.Query.Video", {requestFields: {
            videoDetails: [edsFields.allTimeAverageRating, edsFields.allTimeRatingCount, edsFields.contributors, edsFields.description, edsFields.duration, edsFields.genres, edsFields.hasActivities, edsFields.id, edsFields.images, edsFields.mediaGroup, edsFields.mediaItemType, edsFields.parentalRating, edsFields.parentalRatings, edsFields.previewUrl, edsFields.providers, edsFields.releaseDate, edsFields.reviewSources, edsFields.seasonCount, edsFields.studio, edsFields.studios, edsFields.vuiDisplayName, edsFields.zuneId, edsFields.zuneSeasonCount], videoSearch: [edsFields.allTimeAverageRating, edsFields.id, edsFields.images, edsFields.mediaItemType, edsFields.releaseDate, edsFields.seasonCount, edsFields.vuiDisplayName, edsFields.zuneId, edsFields.zuneSeasonCount], tvSeriesBrowse: [edsFields.allTimeAverageRating, edsFields.allTimeRatingCount, edsFields.genres, edsFields.hasActivities, edsFields.id, edsFields.images, edsFields.latestEpisode, edsFields.latestSeason, edsFields.mediaGroup, edsFields.mediaItemType, edsFields.name, edsFields.network, edsFields.networks, edsFields.parentalRating, edsFields.parentalRatings, edsFields.releaseDate, edsFields.seasonCount, edsFields.vuiDisplayName, edsFields.zuneId, edsFields.zuneSeasonCount], tvSeriesDetails: [edsFields.allTimeAverageRating, edsFields.allTimeRatingCount, edsFields.description, edsFields.genres, edsFields.hasActivities, edsFields.id, edsFields.images, edsFields.latestEpisode, edsFields.latestSeason, edsFields.mediaGroup, edsFields.mediaItemType, edsFields.name, edsFields.network, edsFields.networks, edsFields.parentalRating, edsFields.parentalRatings, edsFields.releaseDate, edsFields.reviewSources, edsFields.seasonCount, edsFields.vuiDisplayName, edsFields.zuneId, edsFields.zuneSeasonCount], tvSeasonBrowse: [edsFields.allTimeAverageRating, edsFields.allTimeRatingCount, edsFields.episodeCount, edsFields.genres, edsFields.hasActivities, edsFields.id, edsFields.images, edsFields.isSeasonComplete, edsFields.latestEpisode, edsFields.latestSeason, edsFields.mediaGroup, edsFields.mediaItemType, edsFields.name, edsFields.network, edsFields.networks, edsFields.parentalRating, edsFields.parentalRatings, edsFields.parentSeries, edsFields.providers, edsFields.releaseDate, edsFields.reviewSources, edsFields.seasonNumber, edsFields.vuiDisplayName, edsFields.zuneId, ], tvSeasonDetails: [edsFields.allTimeAverageRating, edsFields.allTimeRatingCount, edsFields.description, edsFields.episodeCount, edsFields.genres, edsFields.hasActivities, edsFields.id, edsFields.images, edsFields.isSeasonComplete, edsFields.latestEpisode, edsFields.latestSeason, edsFields.mediaGroup, edsFields.mediaItemType, edsFields.name, edsFields.network, edsFields.networks, edsFields.parentalRating, edsFields.parentalRatings, edsFields.parentSeries, edsFields.providers, edsFields.releaseDate, edsFields.reviewSources, edsFields.seasonNumber, edsFields.vuiDisplayName, edsFields.zuneId, ], tvEpisodeBrowse: [edsFields.allTimeAverageRating, edsFields.allTimeRatingCount, edsFields.description, edsFields.duration, edsFields.episodeNumber, edsFields.genres, edsFields.hasActivities, edsFields.id, edsFields.images, edsFields.mediaGroup, edsFields.mediaItemType, edsFields.name, edsFields.network, edsFields.networks, edsFields.parentalRating, edsFields.parentalRatings, edsFields.parentSeason, edsFields.parentSeries, edsFields.releaseDate, edsFields.seasonNumber, edsFields.vuiDisplayName, edsFields.zuneId, ], tvEpisodeDetails: [edsFields.allTimeAverageRating, edsFields.allTimeRatingCount, edsFields.contributors, edsFields.description, edsFields.duration, edsFields.episodeNumber, edsFields.genres, edsFields.hasActivities, edsFields.id, edsFields.images, edsFields.mediaGroup, edsFields.mediaItemType, edsFields.name, edsFields.network, edsFields.networks, edsFields.parentalRating, edsFields.parentalRatings, edsFields.parentalRatingReasons, edsFields.parentSeason, edsFields.parentSeries, edsFields.providers, edsFields.releaseDate, edsFields.seasonNumber, edsFields.vuiDisplayName, edsFields.zuneId, ], movieDetails: [edsFields.allTimeAverageRating, edsFields.allTimeRatingCount, edsFields.contributors, edsFields.description, edsFields.duration, edsFields.genres, edsFields.hasActivities, edsFields.id, edsFields.images, edsFields.mediaGroup, edsFields.mediaItemType, edsFields.name, edsFields.parentalRating, edsFields.parentalRatings, edsFields.previewUrl, edsFields.providers, edsFields.releaseDate, edsFields.reviewSources, edsFields.studio, edsFields.studios, edsFields.vuiDisplayName, edsFields.zuneId, ], moviesBrowse: [edsFields.allTimeAverageRating, edsFields.allTimeRatingCount, edsFields.duration, edsFields.genres, edsFields.hasActivities, edsFields.id, edsFields.images, edsFields.mediaGroup, edsFields.mediaItemType, edsFields.name, edsFields.parentalRating, edsFields.parentalRatings, edsFields.previewUrl, edsFields.providers, edsFields.releaseDate, edsFields.reviewSources, edsFields.studio, edsFields.studios, edsFields.vuiDisplayName, edsFields.zuneId, ], moviesSimpleBrowse: [edsFields.id, edsFields.images, edsFields.name, edsFields.zuneId, edsFields.vuiDisplayName, ], tvSeriesSimpleBrowse: [edsFields.id, edsFields.images, edsFields.name, edsFields.vuiDisplayName, edsFields.zuneId, edsFields.zuneSeasonCount, ], cacheRequestFields: function cacheRequsetFields() {
                    MS.Entertainment.Data.EDSWrapperQuery.fetchRequestFields(MS.Entertainment.Data.Query.Video.requestFields.videoDetails.join("."));
                    MS.Entertainment.Data.EDSWrapperQuery.fetchRequestFields(MS.Entertainment.Data.Query.Video.requestFields.videoSearch.join("."));
                    MS.Entertainment.Data.EDSWrapperQuery.fetchRequestFields(MS.Entertainment.Data.Query.Video.requestFields.tvSeriesBrowse.join("."));
                    MS.Entertainment.Data.EDSWrapperQuery.fetchRequestFields(MS.Entertainment.Data.Query.Video.requestFields.tvSeriesDetails.join("."));
                    MS.Entertainment.Data.EDSWrapperQuery.fetchRequestFields(MS.Entertainment.Data.Query.Video.requestFields.tvSeasonBrowse.join("."));
                    MS.Entertainment.Data.EDSWrapperQuery.fetchRequestFields(MS.Entertainment.Data.Query.Video.requestFields.tvSeasonDetails.join("."));
                    MS.Entertainment.Data.EDSWrapperQuery.fetchRequestFields(MS.Entertainment.Data.Query.Video.requestFields.tvEpisodeBrowse.join("."));
                    MS.Entertainment.Data.EDSWrapperQuery.fetchRequestFields(MS.Entertainment.Data.Query.Video.requestFields.tvEpisodeDetails.join("."));
                    MS.Entertainment.Data.EDSWrapperQuery.fetchRequestFields(MS.Entertainment.Data.Query.Video.requestFields.movieDetails.join("."));
                    MS.Entertainment.Data.EDSWrapperQuery.fetchRequestFields(MS.Entertainment.Data.Query.Video.requestFields.moviesBrowse.join("."));
                    MS.Entertainment.Data.EDSWrapperQuery.fetchRequestFields(MS.Entertainment.Data.Query.Video.requestFields.moviesSimpleBrowse.join("."));
                    MS.Entertainment.Data.EDSWrapperQuery.fetchRequestFields(MS.Entertainment.Data.Query.Video.requestFields.tvSeriesSimpleBrowse.join("."))
                }
        }});
    WinJS.Namespace.defineWithParent(MSE.Data, "Query", {libraryMovieTVSeries: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return WinJS.Class.derive(MS.Entertainment.Data.AggregateQuery, function libraryMovieTVSeries() {
                    MS.Entertainment.Data.AggregateQuery.prototype.constructor.apply(this, arguments);
                    this.resultAugmentationFactory = {create: this._createResultAugmentation.bind(this)};
                    this.queries.length = 2;
                    this.queries[0] = new MS.Entertainment.Data.Query.libraryVideoMovies;
                    this.queries[1] = new MS.Entertainment.Data.Query.libraryTVSeries;
                    this._selectMovie = false
                }, {
                    _selectMovie: false, baseResultAugmentation: MS.Entertainment.Data.Augmenter.Library.MergedVideoTVSeasonResult, keyword: {
                            get: function() {
                                return this.queries[0]
                            }, set: function(value) {
                                    this.queries[0].keyword = value;
                                    this.queries[1].keyword = value
                                }
                        }, _preInnerExecute: function _preInnerExecute() {
                            if (this.isLoadingFromStart)
                                this.selectMovie = false
                        }, _comparer: function _comparer(movieItem, tvItem) {
                            if (movieItem && tvItem) {
                                this.selectMovie = !this.selectMovie;
                                return this.selectMovie ? -1 : 1
                            }
                            else if (movieItem)
                                return -1;
                            else if (tvItem)
                                return 1
                        }, _merger: function _merger(movieItem, tvItem) {
                            if (movieItem)
                                return movieItem;
                            else
                                return tvItem
                        }, _createResultAugmentation: function _createResultAugmentation() {
                            var augment = MS.Entertainment.Data.Property.augment;
                            var unionNoDeflate = MS.Entertainment.Data.Property.unionNoDeflate;
                            return MS.Entertainment.Data.derive(this.baseResultAugmentation, null, {items: unionNoDeflate("movieItems", "tvSeriesItems", this._comparer.bind(this), this._merger.bind(this), null)})
                        }
                })
        })});
    WinJS.Namespace.defineWithParent(MSE.Data, "Query", {libraryMovieGenres: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.derive(MSE.Data.Query.libraryGenres, null, {
                    mediaType: Microsoft.Entertainment.Queries.GenresQueryMediaType.video, videoType: Microsoft.Entertainment.Queries.VideoType.movie
                })
        })});
    WinJS.Namespace.defineWithParent(MSE.Data, "Query", {libraryVideoStudios: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.derive(MSE.Data.Query.LibraryQueryBase, null, {
                    createInnerQuery: function createInnerQuery() {
                        return new Microsoft.Entertainment.Queries.VideoStudiosQuery
                    }, resultAugmentation: MSE.Data.Augmenter.Library.StudiosResult, aggregateChunks: true
                })
        })});
    WinJS.Namespace.defineWithParent(MSE.Data, "Query", {libraryTVSeasons: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.derive(MSE.Data.Query.LibraryQueryBase, null, {
                    tvSeriesId: -1, tvSeasonId: -1, sort: Microsoft.Entertainment.Queries.TVSeasonsSortBy.none, createInnerQuery: function createInnerQuery() {
                            var query = new Microsoft.Entertainment.Queries.TVSeasonsQuery;
                            var seriesId = parseInt(this.tvSeriesId);
                            var seasonId = parseInt(this.tvSeasonId);
                            if (seriesId !== -1)
                                query.tvSeriesId = seriesId;
                            if (seasonId !== -1)
                                query.tvSeasonId = seasonId;
                            query.primarySortBy = this.sort;
                            return query
                        }, resultAugmentation: MSE.Data.Augmenter.Library.TVSeasonsResult, aggregateChunks: true
                })
        })});
    WinJS.Namespace.defineWithParent(MSE.Data, "Query", {browseTVFromLastNight: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return MSE.derive(MSE.Data.Query.marketplaceWrapperQuery, null, {
                    createHeaders: function createHeaders() {
                        return MS.Entertainment.Data.Query.createEditorialHeaders()
                    }, _getHubQueryNameForLastNight: function _getHubQueryNameForLastNight() {
                            var config = new Microsoft.Entertainment.Configuration.ConfigurationManager;
                            var dayOfWeek = [];
                            dayOfWeek.push(config.video.lastNightOnTVSunday);
                            dayOfWeek.push(config.video.lastNightOnTVMonday);
                            dayOfWeek.push(config.video.lastNightOnTVTuesday);
                            dayOfWeek.push(config.video.lastNightOnTVWednesday);
                            dayOfWeek.push(config.video.lastNightOnTVThursday);
                            dayOfWeek.push(config.video.lastNightOnTVFriday);
                            dayOfWeek.push(config.video.lastNightOnTVSaturday);
                            var yesterday = new Date;
                            yesterday.setDate(yesterday.getDate() - 1);
                            return dayOfWeek[yesterday.getDay()]
                        }, getResourceEndpointID: function getResourceEndpointID() {
                            return MS.Entertainment.Endpoint.id.seid_MediaDiscovery
                        }, createResourceURI: function createResourceURI() {
                            var hubUrl = this._getHubQueryNameForLastNight();
                            var serviceConfig = (new Microsoft.Entertainment.Configuration.ConfigurationManager).service;
                            var uri = MS.Entertainment.Utilities.UriFactory.create(this.getResourceEndpoint(), serviceConfig.videoAppTvOnLastNightHubSuffix.format(hubUrl));
                            return uri
                        }, pluralizers: [MSE.Data.Query.marketplaceWrapperQuery.channelPluralizer, MSE.Data.Query.marketplaceWrapperQuery.slotGroupPluralizer, MSE.Data.Query.marketplaceWrapperQuery.slotPluralizer], resultAugmentation: MSE.Data.Augmenter.Video.TvHubContent, aggregateChunks: false
                })
        })});
    WinJS.Namespace.defineWithParent(MSE.Data, "Query", {
        LibraryFolders: MSE.deferredDerive(MS.Entertainment.Data.Query.LibraryQueryBase, null, {
            parentFolderId: -1, folderId: -1, sort: Microsoft.Entertainment.Queries.FoldersSortBy.none, videoType: Microsoft.Entertainment.Queries.VideoType.other, createInnerQuery: function createInnerQuery() {
                    var query = new Microsoft.Entertainment.Queries.FoldersQuery;
                    if (this.parentFolderId !== -1)
                        query.parentFolderId = this.parentFolderId;
                    if (this.folderId !== -1)
                        query.folderId = this.folderId;
                    query.videoType = this.videoType;
                    query.primarySortBy = this.sort;
                    return query
                }, resultAugmentation: MSE.Data.Augmenter.Library.FoldersResult
        }), LibraryVideoFolder: MSE.deferredDerive(MS.Entertainment.Data.Query.libraryVideos, null, {
                category: Microsoft.Entertainment.Queries.VideoType.other, resultAugmentation: MSE.Data.Augmenter.Library.FolderVideosResult
            })
    });
    WinJS.Namespace.define("MS.Entertainment.Data.Query.Video", {FilterSpotlightRestrictedContentWrapperQuery: MS.Entertainment.UI.Framework.derive("MS.Entertainment.Data.AugmentationWrapperQuery", function FilterSpotlightRestrictedContentWrapperQuery(query) {
            MSE.Data.AugmentationWrapperQuery.prototype.constructor.call(this, query)
        }, {
            execute: function execute(cookie) {
                var executePromise;
                if (this.query)
                    executePromise = this.query.execute(cookie);
                else
                    executePromise = WinJS.Promise.wrapError(new Error("Invalid state for executing. The query property was not set to a valid value."));
                return executePromise.then(function filterRestrictedContent(query) {
                        var resultPromise = WinJS.Promise.as(query);
                        var contentRestrictionService = null;
                        if (MS.Entertainment.ServiceLocator.isServiceRegistered(MS.Entertainment.Services.contentRestrictionService))
                            contentRestrictionService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.contentRestrictionService);
                        if (contentRestrictionService) {
                            var items = query.result.itemsArray || [];
                            var mediaItemsToFilter = [];
                            for (var i = 0; i < items.length; i++) {
                                var currentItem = items[i];
                                currentItem = currentItem && currentItem.items && currentItem.items[0];
                                if (currentItem)
                                    mediaItemsToFilter.push(currentItem)
                            }
                            resultPromise = contentRestrictionService.getBrowsePolicyUpdatePromise().then(function gotBrowsePolicy() {
                                return contentRestrictionService.filterRestrictedMediaItems(mediaItemsToFilter)
                            })
                        }
                        return resultPromise.then(function filteringComplete(filteredResults) {
                                if (filteredResults.result && filteredResults.result.entriesArray)
                                    return filteredResults.result;
                                else {
                                    var returnItems = filteredResults || [];
                                    return {
                                            entries: new MS.Entertainment.Data.VirtualList(returnItems), entriesArray: returnItems
                                        }
                                }
                            })
                    })
            }, getItemsArray: function getItemsArray() {
                    return this.execute().then(function executeCompleted(result) {
                            return result.entriesArray
                        })
                }
        })});
    WinJS.Namespace.define("MS.Entertainment.Data.Query.Video", {EDSNoIdTypeVideoQuery: MSE.deferredDerive(MS.Entertainment.Data.Query.EDSDeviceQuery, null, {idType: {set: function(value) {
                    assert(value === edsIdType.canonical, "Setting a NoIdType query to anything other than canonical")
                }}})});
    WinJS.Namespace.define("MS.Entertainment.Data.Query.Video", {EdsBatchDetailsBase: MSE.deferredDerive(MS.Entertainment.Data.Query.EDSDeviceQuery, null, {
            ids: String.empty, idType: edsIdType.zuneCatalog, chunkSize: 5, requestFields: String.empty, desiredMediaItemTypes: String.empty, createResourceURI: function() {
                    return this.getResourceEndpoint(edsEndpointType.details)
                }, createParameters: function createParameters() {
                    var seperator = ".";
                    var idsString = this.ids;
                    if (typeof idsString !== "string")
                        idsString = idsString.join(seperator);
                    var numIds = idsString.split(seperator).length;
                    MS.Entertainment.Framework.assert(numIds <= this.chunkSize, "Too many id values supplied. Batch details requests must contain no more than {0} id values. Actual number of supplied id values was {1}".format(this.chunkSize, numIds));
                    MS.Entertainment.Framework.assert(numIds > 0, "Too few id values supplied. Batch details requests must contain at least 1 id value.");
                    return {
                            ids: idsString, idType: this.idType, desiredMediaItemTypes: this.desiredMediaItemTypes, firstPartyOnly: true
                        }
                }
        })});
    WinJS.Namespace.define("MS.Entertainment.Data.Query.Video", {
        EdsBatchDetailsMovie: MSE.deferredDerive(MS.Entertainment.Data.Query.Video.EdsBatchDetailsBase, null, {
            requestFields: MS.Entertainment.Data.Query.Video.requestFields.movieDetails, desiredMediaItemTypes: edsMediaType.movie, resultAugmentation: MSE.Data.Augmenter.Marketplace.EdsMovieList
        }), EdsBatchDetailsTVEpisode: MSE.deferredDerive(MS.Entertainment.Data.Query.Video.EdsBatchDetailsBase, null, {
                requestFields: MS.Entertainment.Data.Query.Video.requestFields.tvEpisodeDetails, desiredMediaItemTypes: edsMediaType.tvEpisode, resultAugmentation: MSE.Data.Augmenter.Marketplace.EdsTVEpisodeList
            }), EdsBatchDetailsTVSeason: MSE.deferredDerive(MS.Entertainment.Data.Query.Video.EdsBatchDetailsBase, null, {
                requestFields: MS.Entertainment.Data.Query.Video.requestFields.tvSeasonDetails, desiredMediaItemTypes: edsMediaType.tvSeason, resultAugmentation: MSE.Data.Augmenter.Marketplace.EdsTVSeasonList
            }), EdsDetailTVSeries: MSE.deferredDerive(MS.Entertainment.Data.Query.EDSDeviceQuery, null, {
                id: String.empty, idType: edsIdType.canonical, chunkSize: 0, requestFields: MS.Entertainment.Data.Query.Video.requestFields.tvSeriesDetails, createResourceURI: function() {
                        return this.getResourceEndpoint(edsEndpointType.details)
                    }, createParameters: function createParameters() {
                        return {
                                ids: this.id, idType: this.idType, mediaGroup: edsMediaGroup.tvType, firstPartyOnly: true
                            }
                    }, resultAugmentation: MSE.Data.Augmenter.Marketplace.EdsTVSeriesDetails
            }), EdsDetailTVSeason: MSE.deferredDerive(MS.Entertainment.Data.Query.EDSDeviceQuery, null, {
                id: String.empty, idType: edsIdType.canonical, chunkSize: 0, requestFields: MS.Entertainment.Data.Query.Video.requestFields.tvSeasonDetails, createResourceURI: function() {
                        return this.getResourceEndpoint(edsEndpointType.details)
                    }, createParameters: function createParameters() {
                        return {
                                ids: this.id, idType: this.idType, mediaGroup: edsMediaGroup.tvType, firstPartyOnly: true
                            }
                    }, resultAugmentation: MSE.Data.Augmenter.Marketplace.EdsTVSeasonDetails
            }), EdsDetailTVEpisode: MSE.deferredDerive(MS.Entertainment.Data.Query.EDSDeviceQuery, null, {
                id: String.empty, idType: edsIdType.canonical, chunkSize: 0, requestFields: MS.Entertainment.Data.Query.Video.requestFields.tvEpisodeDetails, createResourceURI: function() {
                        return this.getResourceEndpoint(edsEndpointType.details)
                    }, createParameters: function createParameters() {
                        return {
                                ids: this.id, idType: this.idType, mediaGroup: edsMediaGroup.tvType, firstPartyOnly: true
                            }
                    }, resultAugmentation: MSE.Data.Augmenter.Marketplace.EdsTVEpisodeDetails
            }), EdsTvSeasonsForSeries: MSE.deferredDerive(MS.Entertainment.Data.Query.Video.EDSNoIdTypeVideoQuery, null, {
                id: String.empty, chunkSize: BROWSE_CHUNK_SIZE, aggregateChunks: true, requestFields: MS.Entertainment.Data.Query.Video.requestFields.tvSeasonBrowse, createResourceURI: function() {
                        return this.getResourceEndpoint(edsEndpointType.browse)
                    }, createParameters: function createParameters() {
                        return {
                                id: this.id, desiredMediaItemTypes: edsMediaType.tvSeason, mediaItemType: edsMediaType.tvSeries, firstPartyOnly: true
                            }
                    }, resultAugmentation: MSE.Data.Augmenter.Marketplace.EdsTVSeasonList
            }), EdsTvEpisodesForSeason: MSE.deferredDerive(MS.Entertainment.Data.Query.Video.EDSNoIdTypeVideoQuery, null, {
                id: String.empty, chunkSize: BROWSE_CHUNK_SIZE, aggregateChunks: true, requestFields: MS.Entertainment.Data.Query.Video.requestFields.tvEpisodeBrowse, createResourceURI: function() {
                        return this.getResourceEndpoint(edsEndpointType.browse)
                    }, createParameters: function createParameters() {
                        return {
                                id: this.id, desiredMediaItemTypes: edsMediaType.tvEpisode, mediaItemType: edsMediaType.tvSeason, firstPartyOnly: true
                            }
                    }, resultAugmentation: MSE.Data.Augmenter.Marketplace.EdsTVEpisodeList
            }), EdsBrowseMoviesByActor: MSE.deferredDerive(MS.Entertainment.Data.Query.Video.EDSNoIdTypeVideoQuery, null, {
                actor: String.empty, chunkSize: BROWSE_CHUNK_SIZE, requestFields: MS.Entertainment.Data.Query.Video.requestFields.moviesBrowse, includeContentRestrictionHeader: true, enabledImpressionGuid: true, createResourceURI: function() {
                        return this.getResourceEndpoint(edsEndpointType.browse)
                    }, createParameters: function createParameters() {
                        return {
                                actors: this.actor, desiredMediaItemTypes: edsMediaType.movie, orderBy: edsSortOrder.sevenDaysPlayCount, firstPartyOnly: true
                            }
                    }, resultAugmentation: MSE.Data.Augmenter.Marketplace.EdsMovieList
            }), EdsBrowseTVByActor: MSE.deferredDerive(MS.Entertainment.Data.Query.Video.EDSNoIdTypeVideoQuery, null, {
                actor: String.empty, chunkSize: BROWSE_CHUNK_SIZE, requestFields: MS.Entertainment.Data.Query.Video.requestFields.tvSeriesBrowse, includeContentRestrictionHeader: true, enabledImpressionGuid: true, createResourceURI: function() {
                        return this.getResourceEndpoint(edsEndpointType.browse)
                    }, createParameters: function createParameters() {
                        return {
                                actors: this.actor, desiredMediaItemTypes: edsMediaType.tvSeries, orderBy: edsSortOrder.sevenDaysPlayCount, firstPartyOnly: true
                            }
                    }, resultAugmentation: MSE.Data.Augmenter.Marketplace.EdsTVSeriesList
            }), EdsSearchMovies: MSE.deferredDerive(MS.Entertainment.Data.Query.Video.EDSNoIdTypeVideoQuery, null, {
                search: String.empty, chunkSize: SEARCH_CHUNK_SIZE, autoSuggestSeed: false, forceSecureEndpoint: true, requestFields: MS.Entertainment.Data.Query.Video.requestFields.moviesBrowse, includeContentRestrictionHeader: true, enabledImpressionGuid: true, createResourceURI: function() {
                        return this.getResourceEndpoint(edsEndpointType.singleMediaGroupSearch)
                    }, createParameters: function createParameters() {
                        return {
                                q: edsSearchString(this.search), desiredMediaItemTypes: edsMediaType.movie, firstPartyOnly: true
                            }
                    }, createHeaders: function createHeaders() {
                        return {"x-xbl-autoSuggest-seed-text": this.autoSuggestSeed && this.search ? window.encodeURIComponent(this.search) : null}
                    }, resultAugmentation: MSE.Data.Augmenter.Marketplace.EdsMovieList
            }), EdsSearchTVSeries: MSE.deferredDerive(MS.Entertainment.Data.Query.Video.EDSNoIdTypeVideoQuery, null, {
                search: String.empty, chunkSize: SEARCH_CHUNK_SIZE, autoSuggestSeed: false, forceSecureEndpoint: true, requestFields: MS.Entertainment.Data.Query.Video.requestFields.tvSeriesBrowse, includeContentRestrictionHeader: true, enabledImpressionGuid: true, createResourceURI: function() {
                        return this.getResourceEndpoint(edsEndpointType.singleMediaGroupSearch)
                    }, createParameters: function createParameters() {
                        return {
                                q: edsSearchString(this.search), desiredMediaItemTypes: edsMediaType.tvSeries, firstPartyOnly: true
                            }
                    }, createHeaders: function createHeaders() {
                        return {"x-xbl-autoSuggest-seed-text": this.autoSuggestSeed && this.search ? window.encodeURIComponent(this.search) : null}
                    }, resultAugmentation: MSE.Data.Augmenter.Marketplace.EdsTVSeriesList
            }), EdsCrossVideoSearch: MSE.deferredDerive(MS.Entertainment.Data.Query.CrossMediaSearch, null, {
                chunkSize: VIDEO_SEARCH_CHUNK_SIZE, groupTypes: [edsMediaType.movie, edsMediaType.tvSeries], firstPartyOnly: true, requestFields: MS.Entertainment.Data.Query.Video.requestFields.videoSearch, enabledImpressionGuid: true, resultAugmentation: MSE.Data.Augmenter.Marketplace.EdsCrossVideoList
            }), EdsDetailMovie: MSE.deferredDerive(MS.Entertainment.Data.Query.EDSDeviceQuery, null, {
                id: String.empty, idType: edsIdType.canonical, chunkSize: 0, requestFields: MS.Entertainment.Data.Query.Video.requestFields.movieDetails, createResourceURI: function() {
                        return this.getResourceEndpoint(edsEndpointType.details)
                    }, createParameters: function createParameters() {
                        return {
                                mediaGroup: edsMediaGroup.movieType, ids: this.id, idType: this.idType, firstPartyOnly: MS.Entertainment.Utilities.isVideoApp2 || !this.useAuthenticatedEndpoint
                            }
                    }, resultAugmentation: MSE.Data.Augmenter.Marketplace.EdsMovieDetails
            }), EdsVideoDetailsFromTitleIdAssetId: MSE.deferredDerive(MS.Entertainment.Data.Query.EDSDeviceQuery, null, {
                assetId: String.empty, requestFields: MS.Entertainment.Data.Query.Video.requestFields.videoDetails, createResourceURI: function() {
                        return this.getResourceEndpoint(edsEndpointType.details)
                    }, createParameters: function createParameters() {
                        return {
                                ids: edsArray(this.assetId), idType: edsIdType.providerContentId, firstPartyOnly: true
                            }
                    }, resultAugmentation: MSE.Data.Augmenter.Marketplace.EdsVideoResult
            }), EdsVideoDetailsFromAssetId: MSE.deferredDerive(MS.Entertainment.Data.Query.EDSDeviceQuery, null, {
                assetId: String.empty, mediaGroup: null, requestFields: MS.Entertainment.Data.Query.Video.requestFields.videoDetails, createResourceURI: function() {
                        return this.getResourceEndpoint(edsEndpointType.details)
                    }, createParameters: function createParameters() {
                        return {
                                mediaGroup: this.mediaGroup, ids: edsArray(this.assetId), firstPartyOnly: true
                            }
                    }, resultAugmentation: MSE.Data.Augmenter.Marketplace.EdsVideoResult
            }), EdsMovieRelatedItems: MSE.deferredDerive(MS.Entertainment.Data.Query.Video.EDSNoIdTypeVideoQuery, null, {
                id: String.empty, serviceId: String.empty, chunkSize: RELATED_CHUNK_SIZE, requestFields: MS.Entertainment.Data.Query.Video.requestFields.moviesSimpleBrowse, forceSecureEndpoint: true, includeContentRestrictionHeader: true, enabledImpressionGuid: true, createResourceURI: function() {
                        return this.getResourceEndpoint(edsEndpointType.related)
                    }, createParameters: function createParameters() {
                        return {
                                id: this.id || this.serviceId, mediaItemType: edsMediaType.movie, desiredMediaItemTypes: edsMediaType.movie, firstPartyOnly: true, maxItems: 10
                            }
                    }, resultAugmentation: MSE.Data.Augmenter.Marketplace.EdsRelatedMovies
            }), EdsTVRelatedItems: MSE.deferredDerive(MS.Entertainment.Data.Query.Video.EDSNoIdTypeVideoQuery, null, {
                id: String.empty, serviceId: String.empty, chunkSize: RELATED_CHUNK_SIZE, forceSecureEndpoint: true, requestFields: MS.Entertainment.Data.Query.Video.requestFields.tvSeriesBrowse, includeContentRestrictionHeader: true, enabledImpressionGuid: true, createResourceURI: function() {
                        return this.getResourceEndpoint(edsEndpointType.related)
                    }, createParameters: function createParameters() {
                        return {
                                id: this.id || this.serviceId, mediaItemType: edsMediaType.tvSeries, desiredMediaItemTypes: edsMediaType.tvSeries, firstPartyOnly: true, maxItems: 10
                            }
                    }, resultAugmentation: MSE.Data.Augmenter.Marketplace.EdsRelatedTV
            }), EdsBrowseTopMovies: MSE.deferredDerive(MS.Entertainment.Data.Query.Video.EDSNoIdTypeVideoQuery, null, {
                chunkSize: BROWSE_CHUNK_SIZE, aggregateChunks: true, requestFields: MS.Entertainment.Data.Query.Video.requestFields.moviesSimpleBrowse, includeContentRestrictionHeader: true, enabledImpressionGuid: true, orderBy: null, genre: null, studio: null, createResourceURI: function() {
                        return this.getResourceEndpoint(edsEndpointType.browse)
                    }, createParameters: function createParameters() {
                        return {
                                genre: edsString(this.genre), studio: edsString(this.studio), orderBy: this.orderBy, desiredMediaItemTypes: edsMediaType.movie, firstPartyOnly: true
                            }
                    }, resultAugmentation: MSE.Data.Augmenter.Marketplace.EdsMovieList
            }), EdsBrowseTopMoviesDetailed: MSE.deferredDerive("MS.Entertainment.Data.Query.Video.EdsBrowseTopMovies", null, {requestFields: MS.Entertainment.Data.Query.Video.requestFields.moviesBrowse}), EdsBrowseTopSellingMovies: MSE.deferredDerive("MS.Entertainment.Data.Query.Video.EdsBrowseTopMovies", null, {orderBy: edsSortOrder.sevenDaysPurchaseCount}), EdsBrowseTopRentalMovies: MSE.deferredDerive("MS.Entertainment.Data.Query.Video.EdsBrowseTopMovies", null, {orderBy: edsSortOrder.sevenDaysRentalCount}), EdsBrowseNewReleaseMovies: MSE.deferredDerive(MS.Entertainment.Data.Query.Video.EDSNoIdTypeVideoQuery, null, {
                chunkSize: BROWSE_CHUNK_SIZE, aggregateChunks: true, id: String.empty, serviceId: String.empty, requestFields: MS.Entertainment.Data.Query.Video.requestFields.moviesSimpleBrowse, includeContentRestrictionHeader: true, enabledImpressionGuid: true, createResourceURI: function() {
                        return this.getResourceEndpoint(edsEndpointType.browse)
                    }, createParameters: function createParameters() {
                        return {
                                genre: edsString(this.id || this.serviceId), orderBy: edsSortOrder.releaseDate, desiredMediaItemTypes: edsMediaType.movie, firstPartyOnly: true
                            }
                    }, resultAugmentation: MSE.Data.Augmenter.Marketplace.EdsMovieList
            }), EdsBrowseNewReleaseTvSeries: MSE.deferredDerive(MS.Entertainment.Data.Query.Video.EDSNoIdTypeVideoQuery, null, {
                chunkSize: BROWSE_CHUNK_SIZE, aggregateChunks: true, id: String.empty, serviceId: String.empty, requestFields: MS.Entertainment.Data.Query.Video.requestFields.tvSeriesSimpleBrowse, includeContentRestrictionHeader: true, enabledImpressionGuid: true, createResourceURI: function() {
                        return this.getResourceEndpoint(edsEndpointType.browse)
                    }, createParameters: function createParameters() {
                        return {
                                genre: edsString(this.id || this.serviceId), orderBy: edsSortOrder.releaseDate, desiredMediaItemTypes: edsMediaType.tvSeries, firstPartyOnly: true
                            }
                    }, resultAugmentation: MSE.Data.Augmenter.Marketplace.EdsTVSeriesList
            }), EdsBrowseTvSeries: MSE.deferredDerive(MS.Entertainment.Data.Query.Video.EDSNoIdTypeVideoQuery, null, {
                chunkSize: BROWSE_CHUNK_SIZE, aggregateChunks: true, requestFields: MS.Entertainment.Data.Query.Video.requestFields.tvSeriesSimpleBrowse, includeContentRestrictionHeader: true, enabledImpressionGuid: true, genre: null, network: null, orderBy: edsSortOrder.sevenDaysPurchaseCount, createResourceURI: function() {
                        return this.getResourceEndpoint(edsEndpointType.browse)
                    }, createParameters: function createParameters() {
                        return {
                                genre: edsString(this.genre), network: edsString(this.network), orderBy: this.orderBy, desiredMediaItemTypes: edsMediaType.tvSeries, firstPartyOnly: true
                            }
                    }, resultAugmentation: MSE.Data.Augmenter.Marketplace.EdsTVSeriesList
            }), EdsBrowseTvSeriesDetailed: MSE.deferredDerive("MS.Entertainment.Data.Query.Video.EdsBrowseTvSeries", null, {requestFields: MS.Entertainment.Data.Query.Video.requestFields.tvSeriesBrowse}), EdsBrowseMoviesByGenre: MSE.deferredDerive(MS.Entertainment.Data.Query.Video.EDSNoIdTypeVideoQuery, null, {
                chunkSize: BROWSE_CHUNK_SIZE, aggregateChunks: true, orderBy: edsSortOrder.sevenDaysRentalCount, id: String.empty, serviceId: String.empty, requestFields: MS.Entertainment.Data.Query.Video.requestFields.moviesSimpleBrowse, includeContentRestrictionHeader: true, enabledImpressionGuid: true, createResourceURI: function() {
                        return this.getResourceEndpoint(edsEndpointType.browse)
                    }, createParameters: function createParameters() {
                        return {
                                genre: edsString(this.id || this.serviceId), orderBy: this.orderBy, desiredMediaItemTypes: edsMediaType.movie, firstPartyOnly: true
                            }
                    }, resultAugmentation: MSE.Data.Augmenter.Marketplace.EdsMovieList
            }), EdsBrowseTVByGenre: MSE.deferredDerive(MS.Entertainment.Data.Query.Video.EDSNoIdTypeVideoQuery, null, {
                chunkSize: BROWSE_CHUNK_SIZE, aggregateChunks: true, orderBy: edsSortOrder.sevenDaysPurchaseCount, id: String.empty, serviceId: String.empty, requestFields: MS.Entertainment.Data.Query.Video.requestFields.tvSeriesSimpleBrowse, includeContentRestrictionHeader: true, enabledImpressionGuid: true, createResourceURI: function() {
                        return this.getResourceEndpoint(edsEndpointType.browse)
                    }, createParameters: function createParameters() {
                        return {
                                genre: edsString(this.id || this.serviceId), orderBy: this.orderBy, desiredMediaItemTypes: edsMediaType.tvSeries, firstPartyOnly: true
                            }
                    }, resultAugmentation: MSE.Data.Augmenter.Marketplace.EdsTVSeriesList
            }), EdsBrowseTVByGenreNetwork: MSE.deferredDerive(MS.Entertainment.Data.Query.Video.EDSNoIdTypeVideoQuery, null, {
                chunkSize: BROWSE_CHUNK_SIZE, aggregateChunks: true, orderBy: edsSortOrder.sevenDaysPurchaseCount, id: String.empty, serviceId: String.empty, genre: String.empty, network: String.empty, requestFields: MS.Entertainment.Data.Query.Video.requestFields.tvSeriesSimpleBrowse, includeContentRestrictionHeader: true, enabledImpressionGuid: true, createResourceURI: function() {
                        return this.getResourceEndpoint(edsEndpointType.browse)
                    }, createParameters: function createParameters() {
                        return {
                                genre: edsString(this.genre), network: edsString(this.network), orderBy: this.orderBy, desiredMediaItemTypes: edsMediaType.tvSeries, firstPartyOnly: true
                            }
                    }, resultAugmentation: MSE.Data.Augmenter.Marketplace.EdsTVSeriesList, queryType: "EdsBrowseTVByGenreNetwork"
            }), EdsBrowseMovieStudios: MSE.deferredDerive(MS.Entertainment.Data.Query.Video.EDSNoIdTypeVideoQuery, null, {
                requestFields: MS.Entertainment.Data.EDSWrapperQuery.requestFieldsNotNeeded, enabledImpressionGuid: true, createResourceURI: function() {
                        return this.getResourceEndpoint(edsEndpointType.metadataMovieStudios)
                    }, resultAugmentation: MSE.Data.Augmenter.Marketplace.EdsQueryRefinerList
            }), EdsBrowseTvNetworks: MSE.deferredDerive(MS.Entertainment.Data.Query.Video.EDSNoIdTypeVideoQuery, null, {
                requestFields: MS.Entertainment.Data.EDSWrapperQuery.requestFieldsNotNeeded, enabledImpressionGuid: true, createResourceURI: function() {
                        return this.getResourceEndpoint(edsEndpointType.metadataTvNetworks)
                    }, resultAugmentation: MSE.Data.Augmenter.Marketplace.EdsQueryRefinerList
            }), EdsBrowseMoviesByStudio: MSE.deferredDerive(MS.Entertainment.Data.Query.Video.EDSNoIdTypeVideoQuery, null, {
                chunkSize: BROWSE_CHUNK_SIZE, aggregateChunks: true, orderBy: edsSortOrder.sevenDaysPurchaseCount, id: String.empty, serviceId: String.empty, requestFields: MS.Entertainment.Data.Query.Video.requestFields.moviesSimpleBrowse, includeContentRestrictionHeader: true, enabledImpressionGuid: true, createResourceURI: function() {
                        return this.getResourceEndpoint(edsEndpointType.browse)
                    }, createParameters: function createParameters() {
                        return {
                                studio: edsString(this.id || this.serviceId), orderBy: this.orderBy, desiredMediaItemTypes: edsMediaType.movie, firstPartyOnly: true
                            }
                    }, resultAugmentation: MSE.Data.Augmenter.Marketplace.EdsMovieList
            }), EdsBrowseMoviesByGenreStudio: MSE.deferredDerive(MS.Entertainment.Data.Query.Video.EDSNoIdTypeVideoQuery, null, {
                chunkSize: BROWSE_CHUNK_SIZE, aggregateChunks: true, orderBy: edsSortOrder.sevenDaysPurchaseCount, id: String.empty, serviceId: String.empty, genre: String.empty, studio: String.empty, requestFields: MS.Entertainment.Data.Query.Video.requestFields.moviesSimpleBrowse, includeContentRestrictionHeader: true, enabledImpressionGuid: true, createResourceURI: function() {
                        return this.getResourceEndpoint(edsEndpointType.browse)
                    }, createParameters: function createParameters() {
                        return {
                                genre: edsString(this.genre), studio: edsString(this.studio), orderBy: this.orderBy, desiredMediaItemTypes: edsMediaType.movie, firstPartyOnly: true
                            }
                    }, resultAugmentation: MSE.Data.Augmenter.Marketplace.EdsMovieList, queryType: "EdsBrowseMoviesByGenreStudio"
            }), EdsBrowseTVByNetwork: MSE.deferredDerive(MS.Entertainment.Data.Query.Video.EDSNoIdTypeVideoQuery, null, {
                chunkSize: BROWSE_CHUNK_SIZE, aggregateChunks: true, orderBy: edsSortOrder.sevenDaysPurchaseCount, id: String.empty, serviceId: String.empty, requestFields: MS.Entertainment.Data.Query.Video.requestFields.tvSeriesSimpleBrowse, includeContentRestrictionHeader: true, enabledImpressionGuid: true, createResourceURI: function() {
                        return this.getResourceEndpoint(edsEndpointType.browse)
                    }, createParameters: function createParameters() {
                        return {
                                network: edsString(this.id || this.serviceId), orderBy: this.orderBy, desiredMediaItemTypes: edsMediaType.tvSeries, firstPartyOnly: true
                            }
                    }, resultAugmentation: MSE.Data.Augmenter.Marketplace.EdsTVSeriesList
            }), EdsBrowseFreeTV: MSE.deferredDerive(MS.Entertainment.Data.Query.Video.EDSNoIdTypeVideoQuery, null, {
                chunkSize: BROWSE_CHUNK_SIZE, aggregateChunks: true, orderBy: edsSortOrder.sevenDaysPurchaseCount, requestFields: MS.Entertainment.Data.Query.Video.requestFields.tvSeriesSimpleBrowse, includeContentRestrictionHeader: true, enabledImpressionGuid: true, createResourceURI: function() {
                        return this.getResourceEndpoint(edsEndpointType.browse)
                    }, createParameters: function createParameters() {
                        return {
                                orderBy: this.orderBy, desiredMediaItemTypes: edsMediaType.tvSeries, firstPartyOnly: true, freeOnly: true
                            }
                    }, resultAugmentation: MSE.Data.Augmenter.Marketplace.EdsTVSeriesList
            }), AutoSuggest: MS.Entertainment.deferredDerive(MS.Entertainment.Data.Query.AutoSuggest, null, {mediaType: MS.Entertainment.Data.Query.bbxMediaType.video}), AutoSuggestTV: MS.Entertainment.deferredDerive(MS.Entertainment.Data.Query.AutoSuggest, null, {mediaType: MS.Entertainment.Data.Query.bbxMediaType.tv}), AutoSuggestMovies: MS.Entertainment.deferredDerive(MS.Entertainment.Data.Query.AutoSuggest, null, {mediaType: MS.Entertainment.Data.Query.bbxMediaType.movie})
    });
    WinJS.Namespace.define("MS.Entertainment.Data.Query.Video", {
        EdsTvSeriesWithSeasons: MS.Entertainment.UI.Framework.derive("MS.Entertainment.Data.BrowseDetailQuery", function EdsTvSeriesWithSeasons() {
            MS.Entertainment.Data.BrowseDetailQuery.prototype.constructor.call(this)
        }, {
            browseConstructor: MS.Entertainment.Data.Query.Video.EdsTvSeasonsForSeries, detailConstructor: MS.Entertainment.Data.Query.Video.EdsDetailTVSeries, resultAugmentation: MS.Entertainment.Data.Augmenter.Marketplace.EdsSeriesWithSeasonsResult, id: {
                    get: function() {
                        if (this.browse)
                            return this.browse.id;
                        else
                            return null
                    }, set: function(value) {
                            if (this.browse)
                                this.browse.id = value;
                            if (this.detail)
                                this.detail.id = value
                        }
                }, idType: {
                    get: function() {
                        if (this.browse)
                            return this.browse.idType;
                        else
                            return null
                    }, set: function(value) {
                            if (this.browse)
                                this.browse.idType = value;
                            if (this.detail)
                                this.detail.idType = value
                        }
                }
        }), EdsTvSeasonWithEpisodes: MS.Entertainment.UI.Framework.derive("MS.Entertainment.Data.BrowseDetailQuery", function EdsTvSeasonWithEpisodes() {
                MS.Entertainment.Data.BrowseDetailQuery.prototype.constructor.call(this)
            }, {
                browseConstructor: MS.Entertainment.Data.Query.Video.EdsTvEpisodesForSeason, detailConstructor: MS.Entertainment.Data.Query.Video.EdsDetailTVSeason, resultAugmentation: MS.Entertainment.Data.Augmenter.Marketplace.EdsSeasonWithEpisodesResult, id: {
                        get: function() {
                            if (this.browse)
                                return this.browse.id;
                            else
                                return null
                        }, set: function(value) {
                                if (this.browse)
                                    this.browse.id = value;
                                if (this.detail)
                                    this.detail.id = value
                            }
                    }, seasonId: {
                        get: function() {
                            return this.id
                        }, set: function(value) {
                                this.id = value
                            }
                    }, idType: {
                        get: function() {
                            if (this.browse)
                                return this.browse.idType;
                            else
                                return null
                        }, set: function(value) {
                                if (this.browse)
                                    this.browse.idType = value;
                                if (this.detail)
                                    this.detail.idType = value
                            }
                    }
            }), EdsMetadataMovieGenres: MSE.deferredDerive(MS.Entertainment.Data.Query.Video.EDSNoIdTypeVideoQuery, null, {
                createResourceURI: function() {
                    return this.getResourceEndpoint(edsEndpointType.metadataMovieGenres)
                }, resultAugmentation: MSE.Data.Augmenter.Marketplace.EdsGenreRefinerList, requestFields: MS.Entertainment.Data.EDSWrapperQuery.requestFieldsNotNeeded
            }), EdsMetadataMovieStudios: MSE.deferredDerive(MS.Entertainment.Data.Query.Video.EDSNoIdTypeVideoQuery, null, {
                createResourceURI: function() {
                    return this.getResourceEndpoint(edsEndpointType.metadataMovieStudios)
                }, resultAugmentation: MSE.Data.Augmenter.Marketplace.EdsMovieStudioRefinerList, requestFields: MS.Entertainment.Data.EDSWrapperQuery.requestFieldsNotNeeded
            }), EdsMetadataTvGenres: MSE.deferredDerive(MS.Entertainment.Data.Query.Video.EDSNoIdTypeVideoQuery, null, {
                createResourceURI: function() {
                    return this.getResourceEndpoint(edsEndpointType.metadataTvGenres)
                }, resultAugmentation: MSE.Data.Augmenter.Marketplace.EdsGenreRefinerList, requestFields: MS.Entertainment.Data.EDSWrapperQuery.requestFieldsNotNeeded
            }), EdsMetadataTvNetworks: MSE.deferredDerive(MS.Entertainment.Data.Query.Video.EDSNoIdTypeVideoQuery, null, {
                createResourceURI: function() {
                    return this.getResourceEndpoint(edsEndpointType.metadataTvNetworks)
                }, resultAugmentation: MSE.Data.Augmenter.Marketplace.EdsTvNetworkRefinerList, requestFields: MS.Entertainment.Data.EDSWrapperQuery.requestFieldsNotNeeded
            }), MovieNewReleasesQuery: MS.Entertainment.UI.Framework.derive("MS.Entertainment.Data.AugmentationWrapperQuery", null, {
                genre: null, studio: null, execute: function execute() {
                        if (this.genre || this.studio) {
                            this.query = new MS.Entertainment.Data.Query.Video.EdsBrowseMoviesByGenreStudio;
                            this.query.genre = this.genre;
                            this.query.studio = this.studio
                        }
                        else
                            this.query = new MS.Entertainment.Data.Query.MovieHubNewReleasesQuery;
                        return MS.Entertainment.Data.AugmentationWrapperQuery.prototype.execute.call(this)
                    }
            })
    })
})()
