﻿/* Copyright (C) Microsoft Corporation. All rights reserved. */
scriptValidator();
MS.Entertainment.UI.Debug.defineAssert("MS.Entertainment.Data");
(function(MSE, undefined) {
    "use strict";
    WinJS.Namespace.defineWithParent(MSE, "Data", {Ranges: MS.Entertainment.UI.Framework.define(function ranges(initialRanges) {
            this._ranges = [];
            if (Array.isArray(initialRanges))
                initialRanges.forEach(function addRange(range) {
                    this._ranges.push(this._createRange(range.start, range.end))
                }, this);
            else if (initialRanges)
                this._ranges.push(this._createRange(initialRanges.start, initialRanges.end))
        }, {
            singleItems: false, _ranges: null, _cachedTotal: -1, _createRange: function _createRange(index, endIndex) {
                    return {
                            start: index, end: isNaN(endIndex) ? index : endIndex
                        }
                }, total: {get: function get_total() {
                        this._initializeTotal();
                        return this._cachedTotal
                    }}, ranges: {get: function() {
                        return this._ranges.map(function(item) {
                                return this._createRange(item.start, item.end)
                            }, this)
                    }}, printRanges: function printRanges() {
                    Debug.console.log(0, "[START PRINT RANGES]");
                    this._ranges.forEach(function(item) {
                        Debug.console.log(0, "[RANGE] [start = " + item.start + "] [end = " + item.end + "]")
                    }, this);
                    Debug.console.log(0, "[END PRINT RANGES]")
                }, shift: function shift(startIndex, forward) {
                    var i;
                    var increase = (forward) ? 1 : -1;
                    var foundRangeIndex = -1;
                    var foundRange;
                    for (i = 0; i < this._ranges.length; i++)
                        if ((this._ranges[i].start > startIndex) || (this._ranges[i].end >= startIndex)) {
                            foundRangeIndex = i;
                            break
                        }
                    if (foundRangeIndex >= 0) {
                        foundRange = this._ranges[foundRangeIndex];
                        if (foundRange.start < startIndex && foundRange.end >= startIndex) {
                            if (increase > 0) {
                                this._ranges.splice(foundRangeIndex, 0, this._createRange(foundRange.start, startIndex - 1));
                                foundRange.start = startIndex
                            }
                            else
                                foundRange.end += increase;
                            if (foundRange.end < foundRange.start)
                                this._ranges.splice(foundRangeIndex, 1);
                            else
                                foundRangeIndex++
                        }
                        for (i = foundRangeIndex; i < this._ranges.length; i++) {
                            this._ranges[i].start += increase;
                            this._ranges[i].end += increase
                        }
                        if (!this.singleItems) {
                            var right = this._ranges[foundRangeIndex + 1];
                            if (right && right.start <= foundRange.end + 1) {
                                foundRange.end = right.end;
                                this._ranges.splice(foundRangeIndex + 1, 1)
                            }
                            var left = this._ranges[foundRangeIndex - 1];
                            if (left && left.end >= foundRange.start - 1) {
                                foundRange.start = left.start;
                                this._ranges.splice(foundRangeIndex - 1, 1)
                            }
                        }
                    }
                }, get: function get(index) {
                    return this._ranges ? this._ranges[index] : null
                }, forEach: function forEach(callback, that) {
                    if (this._ranges)
                        for (var i = 0; i < this._ranges.length; i++)
                            if (callback.call(that || window, this._ranges[i]))
                                break
                }, findLessThanOrEqual: function findLessThanOrEqual(index) {
                    var i;
                    var foundRangeIndex = -1;
                    for (i = 0; i < this._ranges.length; i++) {
                        if (this._ranges[i].end > index)
                            break;
                        foundRangeIndex = i
                    }
                    return foundRangeIndex
                }, findIndex: function findIndex(index) {
                    var i;
                    var foundRangeIndex = -1;
                    for (i = 0; i < this._ranges.length; i++)
                        if (this._ranges[i].start <= index && this._ranges[i].end >= index) {
                            foundRangeIndex = i;
                            break
                        }
                    return foundRangeIndex
                }, find: function find(index) {
                    var foundRange = null;
                    var foundRangeIndex = this.findIndex(index);
                    if (foundRangeIndex >= 0)
                        foundRange = this._ranges[foundRangeIndex];
                    return foundRange
                }, insert: function insert(index) {
                    var i;
                    var foundRangeIndex = -1;
                    var foundRange;
                    var inserted = true;
                    for (i = 0; i < this._ranges.length; i++)
                        if (this._ranges[i].end + 1 >= index && this._ranges[i].start - 1 <= index && !this.singleItems) {
                            foundRangeIndex = i;
                            foundRange = this._ranges[foundRangeIndex];
                            break
                        }
                        else if (this._ranges[i].start > index) {
                            foundRangeIndex = i;
                            break
                        }
                    if (foundRangeIndex < 0)
                        foundRangeIndex = this._ranges.length;
                    if (!foundRange) {
                        foundRange = this._createRange(index);
                        this._ranges.splice(foundRangeIndex, 0, foundRange)
                    }
                    else if (foundRange.end + 1 === index)
                        foundRange.end = index;
                    else if (foundRange.start - 1 === index)
                        foundRange.start = index;
                    else
                        inserted = false;
                    if (!this.singleItems) {
                        var right = this._ranges[foundRangeIndex + 1];
                        if (right && right.start - 1 <= foundRange.end) {
                            foundRange.end = right.end;
                            this._ranges.splice(foundRangeIndex + 1, 1)
                        }
                        var left = this._ranges[foundRangeIndex - 1];
                        if (left && left.end + 1 >= foundRange.start) {
                            foundRange.start = left.start;
                            this._ranges.splice(foundRangeIndex - 1, 1)
                        }
                    }
                    if (inserted)
                        this._updateCachedTotal(1);
                    return foundRange
                }, remove: function remove(index) {
                    var i;
                    var foundRangeIndex = -1;
                    var foundRange;
                    var rangeRemovedFrom;
                    var split = false;
                    var removed = false;
                    for (i = 0; i < this._ranges.length; i++)
                        if (this._ranges[i].end >= index && this._ranges[i].start <= index) {
                            foundRangeIndex = i;
                            break
                        }
                    rangeRemovedFrom = foundRange = this._ranges[foundRangeIndex];
                    if (foundRange && foundRange.start <= index) {
                        split = true;
                        removed = true;
                        if (foundRange.start === index) {
                            split = false;
                            foundRange.start = index + 1
                        }
                        if (foundRange.end === index) {
                            split = false;
                            foundRange.end = index - 1
                        }
                        if (foundRange.start > foundRange.end) {
                            split = false;
                            foundRange = null;
                            this._ranges.splice(foundRangeIndex, 1)
                        }
                    }
                    if (split) {
                        this._ranges.splice(foundRangeIndex + 1, 0, this._createRange(index + 1, foundRange.end));
                        foundRange.end = Math.max(0, index - 1)
                    }
                    if (foundRange && !this.singleItems) {
                        var right = this._ranges[foundRangeIndex + 1];
                        if (right && right.start - 1 <= foundRange.end) {
                            foundRange.end = right.end;
                            this._ranges.splice(foundRangeIndex + 1, 1)
                        }
                        var left = this._ranges[foundRangeIndex - 1];
                        if (left && left.end + 1 >= foundRange.start) {
                            foundRange.start = left.start;
                            this._ranges.splice(foundRangeIndex - 1, 1)
                        }
                    }
                    if (removed)
                        this._updateCachedTotal(-1);
                    return rangeRemovedFrom
                }, exclusionCount: function exclusionCount(startIndex, endIndex, consecutive) {
                    return this._count(startIndex, endIndex, consecutive, true)
                }, count: function count(startIndex, endIndex, consecutive) {
                    return this._count(startIndex, endIndex, consecutive, false)
                }, _count: function _count(startIndex, endIndex, consecutive, exclusion) {
                    var i,
                        range,
                        start,
                        end,
                        delta;
                    var count = 0;
                    if (startIndex > endIndex && !isNaN(endIndex))
                        return count;
                    for (i = 0; i < this._ranges.length; i++) {
                        range = this._ranges[i];
                        start = range.start;
                        end = range.end;
                        if (exclusion && start === startIndex) {
                            delta = end - start + 1;
                            startIndex += delta;
                            endIndex += delta;
                            count += delta
                        }
                        if (end < startIndex)
                            continue;
                        else if (start > endIndex)
                            break;
                        if (start < startIndex)
                            start = startIndex;
                        if (end > endIndex)
                            end = endIndex;
                        delta = end - start + 1;
                        if (exclusion && startIndex !== endIndex)
                            endIndex += delta;
                        count += delta;
                        if (consecutive) {
                            if (start > startIndex)
                                count = 0;
                            break
                        }
                    }
                    return count
                }, countFromEnd: function countFromEnd(startIndex, endIndex, inclusive) {
                    var i,
                        range,
                        start,
                        end;
                    var count = 0;
                    if (startIndex > endIndex)
                        return count;
                    for (i = this._ranges.length - 1; i >= 0; i--) {
                        range = this._ranges[i];
                        start = range.start;
                        end = range.end;
                        if (end < startIndex || start > endIndex)
                            continue;
                        if (start < startIndex)
                            start = startIndex;
                        if (end > endIndex)
                            end = endIndex;
                        count += end - start + 1;
                        if (inclusive) {
                            if (end < endIndex)
                                count = 0;
                            break
                        }
                    }
                    return count
                }, _initializeTotal: function _initializeTotal() {
                    if (this._cachedTotal < 0)
                        this._cachedTotal = this.count(0);
                    return this._cachedTotal
                }, _updateCachedTotal: function _updateCachedTotal(change) {
                    if (this._cachedTotal >= 0) {
                        this._cachedTotal += change;
                        MS.Entertainment.Data.assert(this._cachedTotal >= 0, "Cache total has gotten out of wack. cached total = " + this._cachedTotal)
                    }
                    return this._cachedTotal
                }
        })})
})(WinJS.Namespace.define("MS.Entertainment", null))
