﻿/* Copyright (C) Microsoft Corporation. All rights reserved. */
scriptValidator();
(function() {
    "use strict";
    var e = WinJS.Promise.wrapError();
    var d = Object.getPrototypeOf(e).done;
    Object.getPrototypeOf(e).done = function(c, e, p) {
        e = e || function(v) {
            if (!(v instanceof Error)) {
                var description;
                try {
                    if (v && Object.keys(v).length === 0)
                        description = "Empty object: " + JSON.stringify(v);
                    else
                        description = JSON.stringify(v)
                }
                catch(e) {
                    description = "[unknown]"
                }
                v = {
                    number: 0, stack: "", description: description
                }
            }
            else if (v.name === "Canceled")
                return;
            debugger;
            MSApp.terminateApp(v)
        };
        d.call(this, c, e, p)
    };
    var c = WinJS.Promise.wrap();
    Object.getPrototypeOf(c).done = function(c) {
        this.then(c).then(null, function(v) {
            if (!(v instanceof Error)) {
                var description;
                try {
                    description = JSON.stringify(v)
                }
                catch(e) {
                    description = "[unknown]"
                }
                v = {
                    number: 0, stack: "", description: description
                }
            }
            else if (v.name === "Canceled")
                return;
            debugger;
            MSApp.terminateApp(v)
        })
    };
    var isInUnitTest = (window.location.pathname === "/bootstrap.html");
    var alertsToShow = [];
    var dialogVisible = false;
    var showPendingAlerts = function showPendingAlerts() {
            if (dialogVisible || !alertsToShow.length)
                return;
            dialogVisible = true;
            if (!MS.Entertainment.Utilities.isApp2)
                new Windows.UI.Popups.MessageDialog(alertsToShow.shift()).showAsync().done(function() {
                    dialogVisible = false;
                    showPendingAlerts()
                })
        };
    window.alert = function(message) {
        if (window.console && window.console.log)
            window.console.log(message);
        if (!isInUnitTest) {
            alertsToShow.push(message);
            showPendingAlerts()
        }
    }
})();
(function() {
    "use strict";
    WinJS.Namespace.define("MS.Entertainment.UI.Debug", {
        write: (function() {
            var debugUtility = null;
            var console = window.console;
            return function write(text) {
                    text = (new Date).toLocaleTimeString() + ": " + text;
                    if (console && console.log)
                        console.log(text);
                    if (!debugUtility)
                        debugUtility = new Microsoft.Entertainment.Util.Debug;
                    debugUtility.outputDebugString(text)
                }
        })(), writeLine: function writeLine(text) {
                MS.Entertainment.UI.Debug.write(text + "\n")
            }, defineAssert: function defineAssert(ns) {
                var resolvedNamespace = WinJS.Utilities.getMember(ns);
                if (resolvedNamespace && resolvedNamespace.assert)
                    return;
                WinJS.Namespace.define(ns, {
                    assert: function assert(condition, message, optional_parameter, optional_errorLevel) {
                        optional_errorLevel = optional_errorLevel || MS.Entertainment.UI.Debug.errorLevel.high;
                        return MS.Entertainment.UI.Debug._doAssert(condition, ns, message, optional_parameter, optional_errorLevel)
                    }, fail: function fail(message, optional_parameter, optional_errorLevel) {
                            WinJS.Utilities.getMember(ns).assert(false, message, optional_parameter, optional_errorLevel)
                        }
                })
            }, errorLevel: {
                high: 0, low: 10
            }, getStackTrace: function getStackTrace() {
                var stackTrace = "";
                try {
                    throw new Error;
                }
                catch(e) {
                    stackTrace = e.stack
                }
                return stackTrace
            }, unhandledPromiseErrorHandler: function unhandledPromiseErrorHandler(error) {
                try {
                    MS.Entertainment.Instrumentation.PerfTrack.disableAllStartupScenarios()
                }
                catch(e) {}
                if (MS.Entertainment.handleError && MS.Entertainment.handleError(error))
                    return true;
                else if (error.detail && error.detail.promise) {
                    var errorString = String.empty;
                    try {
                        errorString = JSON.stringify(error.detail)
                    }
                    catch(e) {}
                    if (error.detail.exception && error.detail.exception.stack)
                        MS.Entertainment.fail("Unhandled error in a promise. Error exception was:" + error.detail.exception + ".\n " + "Stack: " + error.detail.exception.stack + ".\n " + "Detailed Error Info was: " + errorString);
                    else {
                        var detailedErrorInfo;
                        if (error.detail.error) {
                            detailedErrorInfo = {
                                errorCode: error.detail.error.errorCode, description: error.detail.error.description
                            };
                            if (error.detail.error.asyncOpSource)
                                detailedErrorInfo.asyncOpSourceStack = error.detail.error.asyncOpSource.stack
                        }
                        var detailedErrorInfoString = String.empty;
                        try {
                            detailedErrorInfoString = JSON.stringify(detailedErrorInfo)
                        }
                        catch(e) {}
                        MS.Entertainment.fail("Unhandled error in a promise. Error exception was:" + error.detail.exception + ".\n " + "Error was:" + error.detail.error + ".\n " + "Detailed Error Info was: " + detailedErrorInfoString + ".\n " + "Additional Error Data: " + errorString)
                    }
                    return true
                }
                return false
            }, handleAssert: function handleAssert(condition, area, message, parameter, errorLevel) {
                if (MS.Entertainment.UI.Debug._configurationManager === null)
                    MS.Entertainment.UI.Debug._configurationManager = new Microsoft.Entertainment.Configuration.ConfigurationManager;
                var ignoreLowPriorityAsserts;
                if (MS.Entertainment.UI.Debug._configurationManager && MS.Entertainment.UI.Debug._configurationManager.shell)
                    ignoreLowPriorityAsserts = MS.Entertainment.UI.Debug._configurationManager.shell.ignoreLowPriorityAsserts;
                else
                    ignoreLowPriorityAsserts = false;
                if (errorLevel !== MS.Entertainment.UI.Debug.errorLevel.low || !ignoreLowPriorityAsserts)
                    return false;
                else
                    return true
            }, _doAssert: (function() {
                var shipAssertProvider;
                return function _doAssert(condition, area, message, parameter, errorLevel) {
                        if (!(condition) && (!MS.Entertainment.UI.Debug.handleAssert || !MS.Entertainment.UI.Debug.handleAssert(condition, area, message, parameter, errorLevel))) {
                            var stack = MS.Entertainment.UI.Debug.getStackTrace();
                            var signature = MS.Entertainment.UI.Debug._getFunctionSignature(stack);
                            try {
                                if (!shipAssertProvider)
                                    shipAssertProvider = new Microsoft.Entertainment.Infrastructure.ShipAssertProvider;
                                shipAssertProvider.shipAssert(area, signature, stack, message, parameter)
                            }
                            catch(e) {}
                        }
                    }
            })(), _getFunctionSignature: function _getFunctionSignature(stackTrace) {
                var fnString = stackTrace.split("\n")[4];
                var signature = fnString.substring(fnString.indexOf("at ") + 3, fnString.indexOf("(") - 1).trim();
                return signature
            }, _configurationManager: null
    })
})();
(function() {
    "use strict";
    if (console && console.msIsIndependentlyComposed) {
        WinJS.Namespace.define("MS.Entertainment.UI.Application.Helpers", {
            animationsRunning: 0, failedAnimations: 0
        });
        var dumpElementInformation = function dumpElementInformation(message, element) {
                console.log(message + element.id + ", classes: " + element.className + ", independent: " + console.msIsIndependentlyComposed(element) + ", control: " + element.getAttribute("data-win-control"))
            };
        var dumpHiddenInfo = function dumpHiddenInfo(element) {
                var computedStyle;
                var workingElement = element;
                while (workingElement) {
                    computedStyle = window.getComputedStyle(workingElement);
                    if (workingElement.className.indexOf && workingElement.className.indexOf("hideFromDisplay") >= 0)
                        dumpElementInformation("Element has the 'hideFromDisplay' class applied. ID:", workingElement);
                    else if (workingElement.currentStyle && workingElement.currentStyle.visibility && workingElement.currentStyle.visibility === "hidden")
                        dumpElementInformation("Element has visibility set directly. visibility: " + workingElement.currentStyle.visibility + " ID:", workingElement);
                    else if (computedStyle["visibility"] && computedStyle["visibility"] === "hidden")
                        dumpElementInformation("Element, or parent is hidden. visibility: " + workingElement.style.visibility + " ID:", workingElement);
                    else if (computedStyle["display"] === "none")
                        dumpElementInformation("Element, or parent is display: none. ID:", workingElement);
                    if (computedStyle["opacity"] === 0)
                        dumpElementInformation("Element, or parent has an opacity of 0. ID:", workingElement);
                    if (computedStyle["z-index"] < 0)
                        dumpElementInformation("Element, or parent has a negative z-index. ID:", workingElement);
                    workingElement = workingElement.parentElement
                }
            };
        window.addEventListener("animationstart", function animationsStartedTracing(e) {
            if (!console.msIsIndependentlyComposed(e.srcElement)) {
                dumpElementInformation("****animation not independently composed:" + e.animationName + ", ", e.srcElement);
                dumpHiddenInfo(e.srcElement);
                MS.Entertainment.UI.Application.Helpers.failedAnimations++
            }
            {};
            MS.Entertainment.UI.Application.Helpers.animationsRunning++
        });
        window.addEventListener("animationend", function animationsStartedTracing(e) {
            MS.Entertainment.UI.Application.Helpers.animationsRunning--
        });
        window.addEventListener("transitionstart", function transitionsStartedTracing(e) {
            if (!console.msIsIndependentlyComposed(e.srcElement)) {
                dumpElementInformation("****transition not independently composed:" + e.propertyName + ", ", e.srcElement);
                dumpHiddenInfo(e.srcElement);
                MS.Entertainment.UI.Application.Helpers.failedAnimations++
            }
            {}
        })
    }
    MS.Entertainment.UI.Debug.defineAssert("Trace")
})()
