﻿/* Copyright (C) Microsoft Corporation. All rights reserved. */
(function() {
    "use strict";
    var skipValidation = true;
    if (!skipValidation) {
        var baseLength = (window.location.protocol + "//" + window.location.host).length;
        var isInUnitTest = (window.location.pathname === "/bootstrap.html");
        var existingScripts = [];
        var scriptsAfterMainChecked = false
    }
    function getCurrentScripts(currentScripts, headScripts) {
        if (skipValidation)
            return [];
        var scripts = currentScripts || [];
        var documentScripts = headScripts || document.head.querySelectorAll("script[src]");
        var scriptsLength = scripts.length;
        var documentScriptsLength = documentScripts.length;
        for (var i = scriptsLength; i < documentScriptsLength; i++)
            scripts.push(documentScripts[i].src.substr(baseLength).toLowerCase());
        return scripts
    }
    function scriptValidator(files) {
        if (isInUnitTest || skipValidation || window.loadingMergedJsFile)
            return;
        if (!existingScripts.length)
            existingScripts = getCurrentScripts(existingScripts, headScripts);
        var scriptsToCheck = Array.prototype.map.call(arguments, function(item) {
                return item.toLowerCase()
            });
        scriptsToCheck.forEach(function(path) {
            if (MS && MS.Entertainment && MS.Entertainment.UI && MS.Entertainment.UI.Framework && MS.Entertainment.UI.Framework.scriptMappings && MS.Entertainment.UI.Framework.scriptMappings[path])
                path = MS.Entertainment.UI.Framework.scriptMappings[path];
            var isAbsolute = (path.charAt(0) === "/");
            if (!isAbsolute)
                fail("File: " + path + " was not an absolute path");
            validateScriptIncluded(path, existingScripts);
            if (existingScripts.indexOf(path) < 0)
                existingScripts.push(path)
        });
        var headScripts = document.head.querySelectorAll("script[src]");
        if (headScripts.length !== existingScripts.length)
            existingScripts = getCurrentScripts(existingScripts, headScripts)
    }
    {};
    Object.defineProperty(window, "scriptValidator", {
        value: scriptValidator, writable: false, enumerable: true, configurable: false
    });
    window.scriptValidator.getUnreferencedScripts = function getUnreferencedScripts() {
        var unreferencedScripts = [];
        getCurrentScripts().forEach(function(item) {
            if (existingScripts.indexOf(item) < 0)
                unreferencedScripts.push(item)
        });
        return unreferencedScripts
    };
    function validateScriptIncluded(script, currentScripts) {
        var foundAt = currentScripts.indexOf(script);
        if (foundAt < 0) {
            fail("Script: " + script + " was not found in the script tags");
            return
        }
    }
    function fail(message) {
        if (MS && MS.Entertainment && MS.Entertainment.assert)
            MS.Entertainment.assert(false, message);
        else {
            alert(message);
            debugger
        }
    }
})()
