﻿/* Copyright (C) Microsoft Corporation. All rights reserved. */
(function() {
    "use strict";
    scriptValidator();
    var ServiceEntry = WinJS.Class.define(function(factory, isCritical) {
            this._factory = factory;
            this.isCritical = isCritical
        }, {
            isCritical: false, _factory: null, _cache: null, service: function service() {
                    if (!this._cache)
                        this._cache = this._factory();
                    return this._cache
                }, reset: function reset() {
                    if (this._cache && this._cache.dispose)
                        this._cache.dispose();
                    this._cache = null
                }
        });
    WinJS.Namespace.define("MS.Entertainment", {ServiceLocator: MS.Entertainment.UI.Framework.define(function() {
            throw"ServiceLocator contains only static methods.";
        }, {}, {
            _serviceTable: {}, _validateIdentifierOrThrow: function _validateIdentifierOrThrow(candidateIdentifier) {
                    if (!MS.Entertainment.Services.hasOwnProperty(candidateIdentifier))
                        throw"Unknown service identifier passed into Service Locator: " + candidateIdentifier;
                }, getService: function getService(identifier) {
                    var serviceTable = this._serviceTable;
                    var serviceEntry = null;
                    this._validateIdentifierOrThrow(identifier);
                    if (!serviceTable.hasOwnProperty(identifier))
                        throw new Error("Attempt to retrieve a service that has not been registered: " + identifier);
                    serviceEntry = serviceTable[identifier];
                    return serviceEntry.service()
                }, isServiceRegistered: function isServiceRegistered(identifier) {
                    return !!this._serviceTable.hasOwnProperty(identifier)
                }, register: function register(identifier, factory, isCritical) {
                    var serviceTable = this._serviceTable;
                    this._validateIdentifierOrThrow(identifier);
                    if (serviceTable.hasOwnProperty(identifier))
                        throw"Attempt to register a second service for an already registered service identifier: " + identifier;
                    if (typeof factory !== "function")
                        throw"Attempt to register something besides a function as a service factory: " + identifier;
                    serviceTable[identifier] = new ServiceEntry(factory, isCritical)
                }, unregister: function unregister(identifier) {
                    var serviceEntry;
                    var serviceTable = this._serviceTable;
                    this._validateIdentifierOrThrow(identifier);
                    serviceEntry = serviceTable[identifier];
                    if (serviceEntry)
                        serviceEntry.reset();
                    delete serviceTable[identifier]
                }, cleanupNonCriticalServices: function cleanupNonCriticalServices() {
                    var serviceTable = this._serviceTable;
                    for (var id in serviceTable) {
                        if (serviceTable[id].isCritical)
                            continue;
                        serviceTable[id].reset()
                    }
                }, getTestHooks: function getTestHooks() {
                    var that = this;
                    var testHooks = null;
                    testHooks = {getServiceTable: function getServiceTable() {
                            return that._serviceTable
                        }};
                    return testHooks
                }
        })});
    WinJS.Namespace.define("MS.Entertainment.Services", {
        actions: "actions", adService: "adService", anonymousFreePlay: "anonymousFreePlay", appNotification: "appNotification", appToolbar: "appToolbar", applicationStateManager: "applicationStateManager", assetDetails: "assetDetails", backButton: "backButton", bookmarkOperationsWatcher: "bookmarkOperationsWatcher", contentRestrictionService: "contentRestrictionService", contentRestrictionStateHandler: "contentRestrictionStateHandler", cloudCollection: "cloudCollection", collectionChangeNotifier: "collectionChangeNotifier", dashboardRefresher: "dashboardRefresher", dateTimeFormatters: "dateTimeFormatters", dragData: "dragData", featureEnablement: "featureEnablement", findFriends: "findFriends", fileTransfer: "fileTransfer", fileTransferNotifications: "fileTransferNotifications", freePlayLimits: "freePlayLimits", gamesPurchaseHistory: "gamesPurchaseHistory", graceNoteService: "graceNoteService", idleApplicationService: "idleApplicationService", informationArchitecture: "informationArchitecture", interactionNotifier: "interactionNotifier", listNotification: "listNotification", marketplace: "marketplace", mediaStore: "mediaStore", musicStateHandler: "musicStateHandler", navigation: "navigation", networkStatus: "networkStatus", nowPlayingControlManager: "nowPlayingControlManager", mediaDeleted: "mediaDeleted", pinnedList: "pinnedList", pinToStartScreen: "pinToStartScreen", pinToStartScreenInterop: "pinToStartScreenInterop", playbackErrorDisplayService: "playbackErrorDisplayService", playbackEventNotifications: "playbackEventNotifications", playlists: "playlists", playToReceiverNativeService: "playToReceiverNativeService", progressNotification: "progressNotification", purchaseFlowProvider: "purchaseFlowProvider", purchaseHistory: "purchaseHistory", richPresence: "richPresence", sessionManager: "sessionManager", searchResultCounts: "searchResultCounts", shareDecoder: "shareDecoder", shareEncoder: "shareEncoder", shareHost: "shareHost", shareSender: "shareSender", shareTarget: "shareTarget", shortcutManager: "shortcutManager", signedInUser: "signedInUser", signIn: "signIn", smartDJList: "smartDJList", syncManager: "syncManager", systemMTCMetadataUpdater: "systemMTCMetadataUpdater", tileManager: "tileManager", trackRestrictionCollection: "trackRestrictionCollection", typeToSearch: "typeToSearch", uiState: "uiState", upgradeReminderDisplayer: "upgradeReminderDisplayer", userEngagementService: "userEngagementService", userLibraryManager: "userLibraryManager", userTimeTelemetryManager: "userTimeTelemetryManager", userUsageData: "userUsageData", videoCloudCollection: "videoCloudCollection", videoDetailsUiState: "videoDetailsUiState", volumeService: "volumeService", welcomeDialogService: "welcomeDialogService", winJSNavigation: "winJSNavigation", xboxLive: "xboxLive", xhr: "xhr"
    })
})()
