﻿/* Copyright (C) Microsoft Corporation. All rights reserved. */
(function initMicrosoft_Zune_Common(global) {
    var providerTemplates = null;
    var ns = global;
    if (ns.Diagnostics === undefined)
        ns.Diagnostics = {};
    var ns = ns.Diagnostics;
    if (ns.Tracing === undefined)
        ns.Tracing = {};
    var ns = ns.Tracing;
    if (ns.Microsoft === undefined)
        ns.Microsoft = {};
    var ns = ns.Microsoft;
    if (ns.Entertainment === undefined)
        ns.Entertainment = {};
    var ns = ns.Entertainment;
    if (ns.Instrumentation === undefined)
        ns.Instrumentation = {};
    var ns = ns.Instrumentation;
    if (ns.Providers === undefined)
        ns.Providers = {};
    var ns = ns.Providers;
    ns.Common = function() {
        if (providerTemplates === null)
            providerTemplates = new global.Microsoft.Entertainment.Instrumentation.Providers.CommonTemplate
    };
    var proto = ns.Common.prototype;
    proto.is_ShipAssertEnabled = function() {
        return !!providerTemplates.eventEnabled(0)
    };
    proto.trace_ShipAssert = function(id, param, message, hResult, functionName, file, line) {
        providerTemplates.traceTemplate_qqzdzzq(0, id, param, message, hResult, functionName, file, line)
    };
    proto.isBusinessIntelligenceScalarDataPointEnabled = function() {
        return !!providerTemplates.eventEnabled(1)
    };
    proto.traceBusinessIntelligenceScalarDataPoint = function(id, userId, timestamp, classId, typeId, allowedByPrivacySettings, parameterName, parameterValue) {
        providerTemplates.traceTemplate_qjiqqtzq(1, id, userId, timestamp, classId, typeId, allowedByPrivacySettings, parameterName, parameterValue)
    };
    proto.isBusinessIntelligenceStreamDataPointEnabled = function() {
        return !!providerTemplates.eventEnabled(2)
    };
    proto.traceBusinessIntelligenceStreamDataPoint = function(id, userId, timestamp, classId, typeId, allowedByPrivacySettings, parameterCount) {
        providerTemplates.traceTemplate_qjiqqtq(2, id, userId, timestamp, classId, typeId, allowedByPrivacySettings, parameterCount)
    };
    proto.isBusinessIntelligenceStreamIntParameterEnabled = function() {
        return !!providerTemplates.eventEnabled(3)
    };
    proto.traceBusinessIntelligenceStreamIntParameter = function(id, parameterName, parameterValue) {
        providerTemplates.traceTemplate_qzq(3, id, parameterName, parameterValue)
    };
    proto.isBusinessIntelligenceStreamBooleanParameterEnabled = function() {
        return !!providerTemplates.eventEnabled(4)
    };
    proto.traceBusinessIntelligenceStreamBooleanParameter = function(id, parameterName, parameterValue) {
        providerTemplates.traceTemplate_qzt(4, id, parameterName, parameterValue)
    };
    proto.isBusinessIntelligenceStreamStringParameterEnabled = function() {
        return !!providerTemplates.eventEnabled(5)
    };
    proto.traceBusinessIntelligenceStreamStringParameter = function(id, parameterName, parameterValue) {
        providerTemplates.traceTemplate_qzz(5, id, parameterName, parameterValue)
    };
    proto.isClientLaunchEnabled = function() {
        return !!providerTemplates.eventEnabled(6)
    };
    proto.traceClientLaunch = function() {
        providerTemplates.traceTemplateEventDescriptor(6)
    };
    proto.isClientShutdownEnabled = function() {
        return !!providerTemplates.eventEnabled(7)
    };
    proto.traceClientShutdown = function(code) {
        providerTemplates.traceTemplate_d(7, code)
    };
    proto.isEventSystemErrorEnabled = function() {
        return !!providerTemplates.eventEnabled(8)
    };
    proto.traceEventSystemError = function(errorCode, provider, eventChannel, eventId, eventKeywords, eventLevel, eventOpcode, eventTask, eventVersion) {
        providerTemplates.traceTemplate_qjqqxqqqq(8, errorCode, provider, eventChannel, eventId, eventKeywords, eventLevel, eventOpcode, eventTask, eventVersion)
    };
    proto.isZuneHostLaunchEnabled = function() {
        return !!providerTemplates.eventEnabled(9)
    };
    proto.traceZuneHostLaunch = function(isElevated, parameter) {
        providerTemplates.traceTemplate_tz(9, isElevated, parameter)
    };
    proto.isZuneHostShutdownEnabled = function() {
        return !!providerTemplates.eventEnabled(10)
    };
    proto.traceZuneHostShutdown = function(code) {
        providerTemplates.traceTemplate_d(10, code)
    };
    proto.isLogFileUploadedToWatsonEnabled = function() {
        return !!providerTemplates.eventEnabled(11)
    };
    proto.traceLogFileUploadedToWatson = function(filePath) {
        providerTemplates.traceTemplate_z(11, filePath)
    };
    proto.isProcessInitializeEventStartEnabled = function() {
        return !!providerTemplates.eventEnabled(12)
    };
    proto.traceProcessInitializeEventStart = function() {
        providerTemplates.traceTemplateEventDescriptor(12)
    };
    proto.isProcessInitializeEventStopEnabled = function() {
        return !!providerTemplates.eventEnabled(13)
    };
    proto.traceProcessInitializeEventStop = function(durationMsec) {
        providerTemplates.traceTemplate_q(13, durationMsec)
    };
    proto.isProcessSuspendEventStartEnabled = function() {
        return !!providerTemplates.eventEnabled(14)
    };
    proto.traceProcessSuspendEventStart = function() {
        providerTemplates.traceTemplateEventDescriptor(14)
    };
    proto.isProcessSuspendEventStopEnabled = function() {
        return !!providerTemplates.eventEnabled(15)
    };
    proto.traceProcessSuspendEventStop = function(durationMsec) {
        providerTemplates.traceTemplate_q(15, durationMsec)
    };
    proto.isProcessResumeEventStartEnabled = function() {
        return !!providerTemplates.eventEnabled(16)
    };
    proto.traceProcessResumeEventStart = function() {
        providerTemplates.traceTemplateEventDescriptor(16)
    };
    proto.isProcessResumeEventStopEnabled = function() {
        return !!providerTemplates.eventEnabled(17)
    };
    proto.traceProcessResumeEventStop = function(durationMsec) {
        providerTemplates.traceTemplate_q(17, durationMsec)
    };
    proto.isProcessSuspendEventSingletonStartEnabled = function() {
        return !!providerTemplates.eventEnabled(18)
    };
    proto.traceProcessSuspendEventSingletonStart = function(singletonEnumValue) {
        providerTemplates.traceTemplate_q(18, singletonEnumValue)
    };
    proto.isProcessSuspendEventSingletonStopEnabled = function() {
        return !!providerTemplates.eventEnabled(19)
    };
    proto.traceProcessSuspendEventSingletonStop = function(singletonEnumValue) {
        providerTemplates.traceTemplate_q(19, singletonEnumValue)
    };
    proto.isProcessResumeEventSingletonStartEnabled = function() {
        return !!providerTemplates.eventEnabled(20)
    };
    proto.traceProcessResumeEventSingletonStart = function(singletonEnumValue) {
        providerTemplates.traceTemplate_q(20, singletonEnumValue)
    };
    proto.isProcessResumeEventSingletonStopEnabled = function() {
        return !!providerTemplates.eventEnabled(21)
    };
    proto.traceProcessResumeEventSingletonStop = function(singletonEnumValue) {
        providerTemplates.traceTemplate_q(21, singletonEnumValue)
    };
    proto.isProcessSuspendTelemetryStartEnabled = function() {
        return !!providerTemplates.eventEnabled(22)
    };
    proto.traceProcessSuspendTelemetryStart = function() {
        providerTemplates.traceTemplateEventDescriptor(22)
    };
    proto.isProcessSuspendTelemetryStopEnabled = function() {
        return !!providerTemplates.eventEnabled(23)
    };
    proto.traceProcessSuspendTelemetryStop = function() {
        providerTemplates.traceTemplateEventDescriptor(23)
    };
    proto.isProcessResumeTelemetryStartEnabled = function() {
        return !!providerTemplates.eventEnabled(24)
    };
    proto.traceProcessResumeTelemetryStart = function() {
        providerTemplates.traceTemplateEventDescriptor(24)
    };
    proto.isProcessResumeTelemetryStopEnabled = function() {
        return !!providerTemplates.eventEnabled(25)
    };
    proto.traceProcessResumeTelemetryStop = function() {
        providerTemplates.traceTemplateEventDescriptor(25)
    };
    proto.isSingletonInitializationStartedEnabled = function() {
        return !!providerTemplates.eventEnabled(26)
    };
    proto.traceSingletonInitializationStarted = function(singletonEnumValue) {
        providerTemplates.traceTemplate_q(26, singletonEnumValue)
    };
    proto.isSingletonInitializationCompletedEnabled = function() {
        return !!providerTemplates.eventEnabled(27)
    };
    proto.traceSingletonInitializationCompleted = function(singletonEnumValue) {
        providerTemplates.traceTemplate_q(27, singletonEnumValue)
    };
    proto.isFileTransferManagerInitializationStartEnabled = function() {
        return !!providerTemplates.eventEnabled(28)
    };
    proto.traceFileTransferManagerInitializationStart = function() {
        providerTemplates.traceTemplateEventDescriptor(28)
    };
    proto.isFileTransferManagerInitializationStopEnabled = function() {
        return !!providerTemplates.eventEnabled(29)
    };
    proto.traceFileTransferManagerInitializationStop = function() {
        providerTemplates.traceTemplateEventDescriptor(29)
    };
    proto.isFileTransferBackgroundTransferStartFailedEnabled = function() {
        return !!providerTemplates.eventEnabled(30)
    };
    proto.traceFileTransferBackgroundTransferStartFailed = function(hResult, taskId, backgroundTransferId, bytes, totalBytes, fileId, libraryId, libraryTypeId, mediaId, isolatedStoragePath, targetPath, status) {
        providerTemplates.traceTemplate_ddjxxdddjzzd(30, hResult, taskId, backgroundTransferId, bytes, totalBytes, fileId, libraryId, libraryTypeId, mediaId, isolatedStoragePath, targetPath, status)
    };
    proto.isFileTransferBackgroundTransferAttachFailedEnabled = function() {
        return !!providerTemplates.eventEnabled(31)
    };
    proto.traceFileTransferBackgroundTransferAttachFailed = function(hResult, taskId, backgroundTransferId, bytes, totalBytes, fileId, libraryId, libraryTypeId, mediaId, isolatedStoragePath, targetPath, status) {
        providerTemplates.traceTemplate_ddjxxdddjzzd(31, hResult, taskId, backgroundTransferId, bytes, totalBytes, fileId, libraryId, libraryTypeId, mediaId, isolatedStoragePath, targetPath, status)
    };
    proto.isFileTransferBackgroundTransferCompletedEnabled = function() {
        return !!providerTemplates.eventEnabled(32)
    };
    proto.traceFileTransferBackgroundTransferCompleted = function(hResult, taskId, backgroundTransferId, bytes, totalBytes, fileId, libraryId, libraryTypeId, mediaId, isolatedStoragePath, targetPath, status) {
        providerTemplates.traceTemplate_ddjxxdddjzzd(32, hResult, taskId, backgroundTransferId, bytes, totalBytes, fileId, libraryId, libraryTypeId, mediaId, isolatedStoragePath, targetPath, status)
    };
    proto.isFileTransferBackgroundTransferErrorEnabled = function() {
        return !!providerTemplates.eventEnabled(33)
    };
    proto.traceFileTransferBackgroundTransferError = function(hResult, taskId, backgroundTransferId, bytes, totalBytes, fileId, libraryId, libraryTypeId, mediaId, isolatedStoragePath, targetPath, status) {
        providerTemplates.traceTemplate_ddjxxdddjzzd(33, hResult, taskId, backgroundTransferId, bytes, totalBytes, fileId, libraryId, libraryTypeId, mediaId, isolatedStoragePath, targetPath, status)
    };
    proto.isFileTransferBackgroundTransferCanceledEnabled = function() {
        return !!providerTemplates.eventEnabled(34)
    };
    proto.traceFileTransferBackgroundTransferCanceled = function(hResult, taskId, backgroundTransferId, bytes, totalBytes, fileId, libraryId, libraryTypeId, mediaId, isolatedStoragePath, targetPath, status) {
        providerTemplates.traceTemplate_ddjxxdddjzzd(34, hResult, taskId, backgroundTransferId, bytes, totalBytes, fileId, libraryId, libraryTypeId, mediaId, isolatedStoragePath, targetPath, status)
    };
    proto.isFileTransferMoveToLibraryFailedEnabled = function() {
        return !!providerTemplates.eventEnabled(35)
    };
    proto.traceFileTransferMoveToLibraryFailed = function(hResult, taskId, backgroundTransferId, bytes, totalBytes, fileId, libraryId, libraryTypeId, mediaId, isolatedStoragePath, targetPath, status) {
        providerTemplates.traceTemplate_ddjxxdddjzzd(35, hResult, taskId, backgroundTransferId, bytes, totalBytes, fileId, libraryId, libraryTypeId, mediaId, isolatedStoragePath, targetPath, status)
    };
    proto.isFileTransferDownloadInfoFailedEnabled = function() {
        return !!providerTemplates.eventEnabled(36)
    };
    proto.traceFileTransferDownloadInfoFailed = function(hResult, taskId, backgroundTransferId, bytes, totalBytes, fileId, libraryId, libraryTypeId, mediaId, isolatedStoragePath, targetPath, status) {
        providerTemplates.traceTemplate_ddjxxdddjzzd(36, hResult, taskId, backgroundTransferId, bytes, totalBytes, fileId, libraryId, libraryTypeId, mediaId, isolatedStoragePath, targetPath, status)
    };
    proto.isFileTransferQueuedEnabled = function() {
        return !!providerTemplates.eventEnabled(37)
    };
    proto.traceFileTransferQueued = function(hResult, taskId, backgroundTransferId, bytes, totalBytes, fileId, libraryId, libraryTypeId, mediaId, isolatedStoragePath, targetPath, status) {
        providerTemplates.traceTemplate_ddjxxdddjzzd(37, hResult, taskId, backgroundTransferId, bytes, totalBytes, fileId, libraryId, libraryTypeId, mediaId, isolatedStoragePath, targetPath, status)
    };
    proto.isFileTransferFailedEnabled = function() {
        return !!providerTemplates.eventEnabled(38)
    };
    proto.traceFileTransferFailed = function(hResult, taskId, backgroundTransferId, bytes, totalBytes, fileId, libraryId, libraryTypeId, mediaId, isolatedStoragePath, targetPath, status) {
        providerTemplates.traceTemplate_ddjxxdddjzzd(38, hResult, taskId, backgroundTransferId, bytes, totalBytes, fileId, libraryId, libraryTypeId, mediaId, isolatedStoragePath, targetPath, status)
    };
    proto.isFileTransferStart_SuccessedEnabled = function() {
        return !!providerTemplates.eventEnabled(39)
    };
    proto.traceFileTransferStart_Successed = function(hResult, taskId, backgroundTransferId, bytes, totalBytes, fileId, libraryId, libraryTypeId, mediaId, isolatedStoragePath, targetPath, status) {
        providerTemplates.traceTemplate_ddjxxdddjzzd(39, hResult, taskId, backgroundTransferId, bytes, totalBytes, fileId, libraryId, libraryTypeId, mediaId, isolatedStoragePath, targetPath, status)
    };
    proto.isFileTransferStart_FailedEnabled = function() {
        return !!providerTemplates.eventEnabled(40)
    };
    proto.traceFileTransferStart_Failed = function(hResult, taskId, backgroundTransferId, bytes, totalBytes, fileId, libraryId, libraryTypeId, mediaId, isolatedStoragePath, targetPath, status) {
        providerTemplates.traceTemplate_ddjxxdddjzzd(40, hResult, taskId, backgroundTransferId, bytes, totalBytes, fileId, libraryId, libraryTypeId, mediaId, isolatedStoragePath, targetPath, status)
    };
    proto.isFileTransferCompletedEnabled = function() {
        return !!providerTemplates.eventEnabled(41)
    };
    proto.traceFileTransferCompleted = function(hResult, taskId, backgroundTransferId, bytes, totalBytes, fileId, libraryId, libraryTypeId, mediaId, isolatedStoragePath, targetPath, status) {
        providerTemplates.traceTemplate_ddjxxdddjzzd(41, hResult, taskId, backgroundTransferId, bytes, totalBytes, fileId, libraryId, libraryTypeId, mediaId, isolatedStoragePath, targetPath, status)
    };
    proto.isFileTransferClosedEnabled = function() {
        return !!providerTemplates.eventEnabled(42)
    };
    proto.traceFileTransferClosed = function(hResult, taskId, backgroundTransferId, bytes, totalBytes, fileId, libraryId, libraryTypeId, mediaId, isolatedStoragePath, targetPath, status) {
        providerTemplates.traceTemplate_ddjxxdddjzzd(42, hResult, taskId, backgroundTransferId, bytes, totalBytes, fileId, libraryId, libraryTypeId, mediaId, isolatedStoragePath, targetPath, status)
    };
    proto.isClosedCaptionDownloadStartedEnabled = function() {
        return !!providerTemplates.eventEnabled(43)
    };
    proto.traceClosedCaptionDownloadStarted = function(hResult, path, url, isXHR) {
        providerTemplates.traceTemplate_dzzt(43, hResult, path, url, isXHR)
    };
    proto.isClosedCaptionDownloadFailedEnabled = function() {
        return !!providerTemplates.eventEnabled(44)
    };
    proto.traceClosedCaptionDownloadFailed = function(hResult, path, url, isXHR) {
        providerTemplates.traceTemplate_dzzt(44, hResult, path, url, isXHR)
    };
    proto.isClosedCaptionDownloadCompletedEnabled = function() {
        return !!providerTemplates.eventEnabled(45)
    };
    proto.traceClosedCaptionDownloadCompleted = function(hResult, path, url, isXHR) {
        providerTemplates.traceTemplate_dzzt(45, hResult, path, url, isXHR)
    };
    proto.isAppVisibilityChangedEnabled = function() {
        return !!providerTemplates.eventEnabled(46)
    };
    proto.traceAppVisibilityChanged = function(appVisible) {
        providerTemplates.traceTemplate_t(46, appVisible)
    }
})(this);
(function initMicrosoft_Zune_Library(global) {
    var providerTemplates = null;
    var ns = global;
    if (ns.Diagnostics === undefined)
        ns.Diagnostics = {};
    var ns = ns.Diagnostics;
    if (ns.Tracing === undefined)
        ns.Tracing = {};
    var ns = ns.Tracing;
    if (ns.Microsoft === undefined)
        ns.Microsoft = {};
    var ns = ns.Microsoft;
    if (ns.Entertainment === undefined)
        ns.Entertainment = {};
    var ns = ns.Entertainment;
    if (ns.Instrumentation === undefined)
        ns.Instrumentation = {};
    var ns = ns.Instrumentation;
    if (ns.Providers === undefined)
        ns.Providers = {};
    var ns = ns.Providers;
    ns.Library = function() {
        if (providerTemplates === null)
            providerTemplates = new global.Microsoft.Entertainment.Instrumentation.Providers.LibraryTemplate
    };
    var proto = ns.Library.prototype;
    proto.isEasyTransferIterationStartedEnabled = function() {
        return !!providerTemplates.eventEnabled(0)
    };
    proto.traceEasyTransferIterationStarted = function() {
        providerTemplates.traceTemplateEventDescriptor(0)
    };
    proto.isEasyTransferFoundConfigEnabled = function() {
        return !!providerTemplates.eventEnabled(1)
    };
    proto.traceEasyTransferFoundConfig = function() {
        providerTemplates.traceTemplateEventDescriptor(1)
    };
    proto.isEasyTransferNoConfigEnabled = function() {
        return !!providerTemplates.eventEnabled(2)
    };
    proto.traceEasyTransferNoConfig = function() {
        providerTemplates.traceTemplateEventDescriptor(2)
    };
    proto.isEasyTransferParsingConfigEnabled = function() {
        return !!providerTemplates.eventEnabled(3)
    };
    proto.traceEasyTransferParsingConfig = function() {
        providerTemplates.traceTemplateEventDescriptor(3)
    };
    proto.isEasyTransferConfigParseFailedEnabled = function() {
        return !!providerTemplates.eventEnabled(4)
    };
    proto.traceEasyTransferConfigParseFailed = function() {
        providerTemplates.traceTemplateEventDescriptor(4)
    };
    proto.isEasyTransferConfigParseSucceededEnabled = function() {
        return !!providerTemplates.eventEnabled(5)
    };
    proto.traceEasyTransferConfigParseSucceeded = function() {
        providerTemplates.traceTemplateEventDescriptor(5)
    };
    proto.isEasyTransferAddingPathsEnabled = function() {
        return !!providerTemplates.eventEnabled(6)
    };
    proto.traceEasyTransferAddingPaths = function() {
        providerTemplates.traceTemplateEventDescriptor(6)
    };
    proto.isEasyTransferNoPathsToAddEnabled = function() {
        return !!providerTemplates.eventEnabled(7)
    };
    proto.traceEasyTransferNoPathsToAdd = function() {
        providerTemplates.traceTemplateEventDescriptor(7)
    };
    proto.isEasyTransferBeginImportingMetadataEnabled = function() {
        return !!providerTemplates.eventEnabled(8)
    };
    proto.traceEasyTransferBeginImportingMetadata = function() {
        providerTemplates.traceTemplateEventDescriptor(8)
    };
    proto.isEasyTransferCompletedImportingMetadataEnabled = function() {
        return !!providerTemplates.eventEnabled(9)
    };
    proto.traceEasyTransferCompletedImportingMetadata = function() {
        providerTemplates.traceTemplateEventDescriptor(9)
    };
    proto.isEasyTransferBeginImportingPlaylistsEnabled = function() {
        return !!providerTemplates.eventEnabled(10)
    };
    proto.traceEasyTransferBeginImportingPlaylists = function() {
        providerTemplates.traceTemplateEventDescriptor(10)
    };
    proto.isEasyTransferCompletedImportingPlaylistsEnabled = function() {
        return !!providerTemplates.eventEnabled(11)
    };
    proto.traceEasyTransferCompletedImportingPlaylists = function() {
        providerTemplates.traceTemplateEventDescriptor(11)
    };
    proto.isEasyTransferIterationCompleteEnabled = function() {
        return !!providerTemplates.eventEnabled(12)
    };
    proto.traceEasyTransferIterationComplete = function() {
        providerTemplates.traceTemplateEventDescriptor(12)
    };
    proto.isEasyTransferCompleteEnabled = function() {
        return !!providerTemplates.eventEnabled(13)
    };
    proto.traceEasyTransferComplete = function() {
        providerTemplates.traceTemplateEventDescriptor(13)
    };
    proto.isEasyTransferIterationFailedEnabled = function() {
        return !!providerTemplates.eventEnabled(14)
    };
    proto.traceEasyTransferIterationFailed = function() {
        providerTemplates.traceTemplateEventDescriptor(14)
    };
    proto.isEasyTransferParseErrorEnabled = function() {
        return !!providerTemplates.eventEnabled(15)
    };
    proto.traceEasyTransferParseError = function(line, column, message) {
        providerTemplates.traceTemplate_qqz(15, line, column, message)
    };
    proto.isEasyTransferImportedMetadataEnabled = function() {
        return !!providerTemplates.eventEnabled(16)
    };
    proto.traceEasyTransferImportedMetadata = function(mediaId, rating, playCount) {
        providerTemplates.traceTemplate_qqq(16, mediaId, rating, playCount)
    };
    proto.isEasyTransferImportedPlaylistEnabled = function() {
        return !!providerTemplates.eventEnabled(17)
    };
    proto.traceEasyTransferImportedPlaylist = function(name, trackCount, imported) {
        providerTemplates.traceTemplate_zqt(17, name, trackCount, imported)
    };
    proto.isEasyTransferLocatingMediaItemEnabled = function() {
        return !!providerTemplates.eventEnabled(18)
    };
    proto.traceEasyTransferLocatingMediaItem = function(location) {
        providerTemplates.traceTemplate_z(18, location)
    };
    proto.isEasyTransferLocatedMediaItemEnabled = function() {
        return !!providerTemplates.eventEnabled(19)
    };
    proto.traceEasyTransferLocatedMediaItem = function(mediaId, created) {
        providerTemplates.traceTemplate_qt(19, mediaId, created)
    };
    proto.isEasyTransferStateChangeEnabled = function() {
        return !!providerTemplates.eventEnabled(20)
    };
    proto.traceEasyTransferStateChange = function(oldState, newState) {
        providerTemplates.traceTemplate_qq(20, oldState, newState)
    };
    proto.isEasyTransferFailedToLocateMediaItemEnabled = function() {
        return !!providerTemplates.eventEnabled(21)
    };
    proto.traceEasyTransferFailedToLocateMediaItem = function(hResult) {
        providerTemplates.traceTemplate_d(21, hResult)
    };
    proto.isEasyTransferMatchedByFileUrlEnabled = function() {
        return !!providerTemplates.eventEnabled(22)
    };
    proto.traceEasyTransferMatchedByFileUrl = function() {
        providerTemplates.traceTemplateEventDescriptor(22)
    };
    proto.isGrovelerScanStartedEnabled = function() {
        return !!providerTemplates.eventEnabled(23)
    };
    proto.traceGrovelerScanStarted = function() {
        providerTemplates.traceTemplateEventDescriptor(23)
    };
    proto.isGrovelerScanCompletedEnabled = function() {
        return !!providerTemplates.eventEnabled(24)
    };
    proto.traceGrovelerScanCompleted = function(fileCount) {
        providerTemplates.traceTemplate_q(24, fileCount)
    };
    proto.isGrovelerQuickScanStartedEnabled = function() {
        return !!providerTemplates.eventEnabled(25)
    };
    proto.traceGrovelerQuickScanStarted = function() {
        providerTemplates.traceTemplateEventDescriptor(25)
    };
    proto.isGrovelerQuickScanCompletedEnabled = function() {
        return !!providerTemplates.eventEnabled(26)
    };
    proto.traceGrovelerQuickScanCompleted = function(receivedFileCount, modifiedFileCount) {
        providerTemplates.traceTemplate_qq(26, receivedFileCount, modifiedFileCount)
    };
    proto.isGrovelerDeleteScanStartedEnabled = function() {
        return !!providerTemplates.eventEnabled(27)
    };
    proto.traceGrovelerDeleteScanStarted = function() {
        providerTemplates.traceTemplateEventDescriptor(27)
    };
    proto.isGrovelerDeleteScanCompletedEnabled = function() {
        return !!providerTemplates.eventEnabled(28)
    };
    proto.traceGrovelerDeleteScanCompleted = function(fileCount) {
        providerTemplates.traceTemplate_q(28, fileCount)
    };
    proto.isGrovelerPlaylistScanStartedEnabled = function() {
        return !!providerTemplates.eventEnabled(29)
    };
    proto.traceGrovelerPlaylistScanStarted = function() {
        providerTemplates.traceTemplateEventDescriptor(29)
    };
    proto.isGrovelerPlaylistScanCompletedEnabled = function() {
        return !!providerTemplates.eventEnabled(30)
    };
    proto.traceGrovelerPlaylistScanCompleted = function(fileCount) {
        providerTemplates.traceTemplate_q(30, fileCount)
    };
    proto.isGrovelerAdditionScanStartedEnabled = function() {
        return !!providerTemplates.eventEnabled(31)
    };
    proto.traceGrovelerAdditionScanStarted = function() {
        providerTemplates.traceTemplateEventDescriptor(31)
    };
    proto.isGrovelerAdditionScanCompletedEnabled = function() {
        return !!providerTemplates.eventEnabled(32)
    };
    proto.traceGrovelerAdditionScanCompleted = function(fileCount) {
        providerTemplates.traceTemplate_q(32, fileCount)
    };
    proto.isGrovelerFullScanSkippedEnabled = function() {
        return !!providerTemplates.eventEnabled(33)
    };
    proto.traceGrovelerFullScanSkipped = function() {
        providerTemplates.traceTemplateEventDescriptor(33)
    };
    proto.isGrovelerTopLevelFolderAddedEnabled = function() {
        return !!providerTemplates.eventEnabled(34)
    };
    proto.traceGrovelerTopLevelFolderAdded = function() {
        providerTemplates.traceTemplateEventDescriptor(34)
    };
    proto.isGrovelerNotificationReceivedEnabled = function() {
        return !!providerTemplates.eventEnabled(35)
    };
    proto.traceGrovelerNotificationReceived = function() {
        providerTemplates.traceTemplateEventDescriptor(35)
    };
    proto.isGrovelerNetworkConnectedEnabled = function() {
        return !!providerTemplates.eventEnabled(36)
    };
    proto.traceGrovelerNetworkConnected = function() {
        providerTemplates.traceTemplateEventDescriptor(36)
    };
    proto.isGrovelerNetworkShareAccessedEnabled = function() {
        return !!providerTemplates.eventEnabled(37)
    };
    proto.traceGrovelerNetworkShareAccessed = function() {
        providerTemplates.traceTemplateEventDescriptor(37)
    };
    proto.isGrovelerMasterRatingFileDirtySetEnabled = function() {
        return !!providerTemplates.eventEnabled(38)
    };
    proto.traceGrovelerMasterRatingFileDirtySet = function() {
        providerTemplates.traceTemplateEventDescriptor(38)
    };
    proto.isGrovelerWriteMasterRatingFileTriggeredEnabled = function() {
        return !!providerTemplates.eventEnabled(39)
    };
    proto.traceGrovelerWriteMasterRatingFileTriggered = function() {
        providerTemplates.traceTemplateEventDescriptor(39)
    };
    proto.isGrovelerWriteMasterRatingFileStartedEnabled = function() {
        return !!providerTemplates.eventEnabled(40)
    };
    proto.traceGrovelerWriteMasterRatingFileStarted = function() {
        providerTemplates.traceTemplateEventDescriptor(40)
    };
    proto.isGrovelerWriteMasterRatingFileCompletedEnabled = function() {
        return !!providerTemplates.eventEnabled(41)
    };
    proto.traceGrovelerWriteMasterRatingFileCompleted = function(hResult, ratingCount) {
        providerTemplates.traceTemplate_dq(41, hResult, ratingCount)
    };
    proto.isGrovelerReadMasterRatingFileTriggeredEnabled = function() {
        return !!providerTemplates.eventEnabled(42)
    };
    proto.traceGrovelerReadMasterRatingFileTriggered = function() {
        providerTemplates.traceTemplateEventDescriptor(42)
    };
    proto.isGrovelerReadMasterRatingFileStartedEnabled = function() {
        return !!providerTemplates.eventEnabled(43)
    };
    proto.traceGrovelerReadMasterRatingFileStarted = function() {
        providerTemplates.traceTemplateEventDescriptor(43)
    };
    proto.isGrovelerReadMasterRatingFileCompletedEnabled = function() {
        return !!providerTemplates.eventEnabled(44)
    };
    proto.traceGrovelerReadMasterRatingFileCompleted = function(hResult, ratingCount) {
        providerTemplates.traceTemplate_dq(44, hResult, ratingCount)
    };
    proto.isGrovelerQueryIndexerDiffEnabled = function() {
        return !!providerTemplates.eventEnabled(45)
    };
    proto.traceGrovelerQueryIndexerDiff = function(timestamp) {
        providerTemplates.traceTemplate_z(45, timestamp)
    };
    proto.isGrovelerIsQuickGrovelNeededEnabled = function() {
        return !!providerTemplates.eventEnabled(46)
    };
    proto.traceGrovelerIsQuickGrovelNeeded = function(currentCount, changedCount, quickScanNeeded) {
        providerTemplates.traceTemplate_qqt(46, currentCount, changedCount, quickScanNeeded)
    };
    proto.isGrovelerGetFilesAsyncRetryEnabled = function() {
        return !!providerTemplates.eventEnabled(47)
    };
    proto.traceGrovelerGetFilesAsyncRetry = function(hResult, retryCount) {
        providerTemplates.traceTemplate_dq(47, hResult, retryCount)
    };
    proto.isGrovelerWaitForCompletionRetryEnabled = function() {
        return !!providerTemplates.eventEnabled(48)
    };
    proto.traceGrovelerWaitForCompletionRetry = function(hResult, retryCount) {
        providerTemplates.traceTemplate_dq(48, hResult, retryCount)
    };
    proto.isGrovelerGetResultsErrorEnabled = function() {
        return !!providerTemplates.eventEnabled(49)
    };
    proto.traceGrovelerGetResultsError = function(hResult) {
        providerTemplates.traceTemplate_d(49, hResult)
    };
    proto.isGrovelerGetEmptyItemListEnabled = function() {
        return !!providerTemplates.eventEnabled(50)
    };
    proto.traceGrovelerGetEmptyItemList = function(hResult) {
        providerTemplates.traceTemplate_d(50, hResult)
    };
    proto.isGrovelerRefreshLicenseStartedEnabled = function() {
        return !!providerTemplates.eventEnabled(51)
    };
    proto.traceGrovelerRefreshLicenseStarted = function() {
        providerTemplates.traceTemplateEventDescriptor(51)
    };
    proto.isGrovelerRefreshLicenseCompletedEnabled = function() {
        return !!providerTemplates.eventEnabled(52)
    };
    proto.traceGrovelerRefreshLicenseCompleted = function(hResult) {
        providerTemplates.traceTemplate_d(52, hResult)
    };
    proto.isGrovelerDefinitionChangedNotificationReceivedEnabled = function() {
        return !!providerTemplates.eventEnabled(53)
    };
    proto.traceGrovelerDefinitionChangedNotificationReceived = function() {
        providerTemplates.traceTemplateEventDescriptor(53)
    };
    proto.isGrovelerRetriesExhaustedEnabled = function() {
        return !!providerTemplates.eventEnabled(54)
    };
    proto.traceGrovelerRetriesExhausted = function(hResult, fileCount) {
        providerTemplates.traceTemplate_dq(54, hResult, fileCount)
    };
    proto.isGrovelerAddFileEnabled = function() {
        return !!providerTemplates.eventEnabled(55)
    };
    proto.traceGrovelerAddFile = function(hResult, fileUrl) {
        providerTemplates.traceTemplate_dz(55, hResult, fileUrl)
    };
    proto.isGrovelerSetFileAvailableEnabled = function() {
        return !!providerTemplates.eventEnabled(56)
    };
    proto.traceGrovelerSetFileAvailable = function(fileUrl) {
        providerTemplates.traceTemplate_z(56, fileUrl)
    };
    proto.isGrovelerSetFileUnavailableEnabled = function() {
        return !!providerTemplates.eventEnabled(57)
    };
    proto.traceGrovelerSetFileUnavailable = function(fileUrl) {
        providerTemplates.traceTemplate_z(57, fileUrl)
    };
    proto.isGrovelerSecondScanStartedEnabled = function() {
        return !!providerTemplates.eventEnabled(58)
    };
    proto.traceGrovelerSecondScanStarted = function() {
        providerTemplates.traceTemplateEventDescriptor(58)
    };
    proto.isGrovelerSecondScanCompletedEnabled = function() {
        return !!providerTemplates.eventEnabled(59)
    };
    proto.traceGrovelerSecondScanCompleted = function(fileCount, unindexedFileCount, unknownFileCount) {
        providerTemplates.traceTemplate_qqq(59, fileCount, unindexedFileCount, unknownFileCount)
    };
    proto.isMDLCStartedEnabled = function() {
        return !!providerTemplates.eventEnabled(60)
    };
    proto.traceMDLCStarted = function() {
        providerTemplates.traceTemplateEventDescriptor(60)
    };
    proto.isMDLCCompletedEnabled = function() {
        return !!providerTemplates.eventEnabled(61)
    };
    proto.traceMDLCCompleted = function() {
        providerTemplates.traceTemplateEventDescriptor(61)
    };
    proto.isDatabaseOpenStartedEnabled = function() {
        return !!providerTemplates.eventEnabled(62)
    };
    proto.traceDatabaseOpenStarted = function() {
        providerTemplates.traceTemplateEventDescriptor(62)
    };
    proto.isDatabaseOpenCompletedEnabled = function() {
        return !!providerTemplates.eventEnabled(63)
    };
    proto.traceDatabaseOpenCompleted = function() {
        providerTemplates.traceTemplateEventDescriptor(63)
    };
    proto.isDatabaseCloseStartedEnabled = function() {
        return !!providerTemplates.eventEnabled(64)
    };
    proto.traceDatabaseCloseStarted = function() {
        providerTemplates.traceTemplateEventDescriptor(64)
    };
    proto.isDatabaseCloseCompletedEnabled = function() {
        return !!providerTemplates.eventEnabled(65)
    };
    proto.traceDatabaseCloseCompleted = function() {
        providerTemplates.traceTemplateEventDescriptor(65)
    };
    proto.isDbCleanupOnUserSignedOutStartedEnabled = function() {
        return !!providerTemplates.eventEnabled(66)
    };
    proto.traceDbCleanupOnUserSignedOutStarted = function() {
        providerTemplates.traceTemplateEventDescriptor(66)
    };
    proto.isDbCleanupOnUserSignedOutCompletedEnabled = function() {
        return !!providerTemplates.eventEnabled(67)
    };
    proto.traceDbCleanupOnUserSignedOutCompleted = function() {
        providerTemplates.traceTemplateEventDescriptor(67)
    };
    proto.isQueryStartedEnabled = function() {
        return !!providerTemplates.eventEnabled(68)
    };
    proto.traceQueryStarted = function(queryObjectInstanceId, queryType, actionName) {
        providerTemplates.traceTemplate_dzz(68, queryObjectInstanceId, queryType, actionName)
    };
    proto.isQueryCompletedEnabled = function() {
        return !!providerTemplates.eventEnabled(69)
    };
    proto.traceQueryCompleted = function(queryObjectInstanceId, queryType, actionName) {
        providerTemplates.traceTemplate_dzz(69, queryObjectInstanceId, queryType, actionName)
    };
    proto.isPlaylistIOStartedEnabled = function() {
        return !!providerTemplates.eventEnabled(70)
    };
    proto.tracePlaylistIOStarted = function() {
        providerTemplates.traceTemplateEventDescriptor(70)
    };
    proto.isPlaylistIOCompletedEnabled = function() {
        return !!providerTemplates.eventEnabled(71)
    };
    proto.tracePlaylistIOCompleted = function(readFileCount) {
        providerTemplates.traceTemplate_q(71, readFileCount)
    };
    proto.isBackgroundWorkLock_RequestedEnabled = function() {
        return !!providerTemplates.eventEnabled(72)
    };
    proto.traceBackgroundWorkLock_Requested = function(requestor) {
        providerTemplates.traceTemplate_z(72, requestor)
    };
    proto.isBackgroundWorkLock_AcquiredEnabled = function() {
        return !!providerTemplates.eventEnabled(73)
    };
    proto.traceBackgroundWorkLock_Acquired = function(requestor) {
        providerTemplates.traceTemplate_z(73, requestor)
    };
    proto.isBackgroundWorkLock_ReleasedEnabled = function() {
        return !!providerTemplates.eventEnabled(74)
    };
    proto.traceBackgroundWorkLock_Released = function(requestor) {
        providerTemplates.traceTemplate_z(74, requestor)
    };
    proto.isCollectionBuildingBeginEnabled = function() {
        return !!providerTemplates.eventEnabled(75)
    };
    proto.traceCollectionBuildingBegin = function(eventSource) {
        providerTemplates.traceTemplate_q(75, eventSource)
    };
    proto.isCollectionBuildingEndEnabled = function() {
        return !!providerTemplates.eventEnabled(76)
    };
    proto.traceCollectionBuildingEnd = function(eventSource, itemsAdded, itemsTotal, errorState) {
        providerTemplates.traceTemplate_qqqq(76, eventSource, itemsAdded, itemsTotal, errorState)
    };
    proto.isCollectionBuildingProgressEnabled = function() {
        return !!providerTemplates.eventEnabled(77)
    };
    proto.traceCollectionBuildingProgress = function(itemsProcessed) {
        providerTemplates.traceTemplate_q(77, itemsProcessed)
    };
    proto.isCollectionBuildingMediaSyncedEnabled = function() {
        return !!providerTemplates.eventEnabled(78)
    };
    proto.traceCollectionBuildingMediaSynced = function() {
        providerTemplates.traceTemplateEventDescriptor(78)
    };
    proto.isCollectionBuildingMissingMetadataEnabled = function() {
        return !!providerTemplates.eventEnabled(79)
    };
    proto.traceCollectionBuildingMissingMetadata = function() {
        providerTemplates.traceTemplateEventDescriptor(79)
    };
    proto.isCollectionBuildingMDLCProgressEnabled = function() {
        return !!providerTemplates.eventEnabled(80)
    };
    proto.traceCollectionBuildingMDLCProgress = function(itemsProcessed) {
        providerTemplates.traceTemplate_q(80, itemsProcessed)
    };
    proto.isFingerprintingStartedEnabled = function() {
        return !!providerTemplates.eventEnabled(81)
    };
    proto.traceFingerprintingStarted = function() {
        providerTemplates.traceTemplateEventDescriptor(81)
    };
    proto.isFingerprintingCompleteEnabled = function() {
        return !!providerTemplates.eventEnabled(82)
    };
    proto.traceFingerprintingComplete = function(hResult, canceled, processedFileCount, remainingFileCount, failedFileCount) {
        providerTemplates.traceTemplate_dtqqq(82, hResult, canceled, processedFileCount, remainingFileCount, failedFileCount)
    };
    proto.isProcessRemainingFilesStartedEnabled = function() {
        return !!providerTemplates.eventEnabled(83)
    };
    proto.traceProcessRemainingFilesStarted = function() {
        providerTemplates.traceTemplateEventDescriptor(83)
    };
    proto.isProcessRemainingFilesCompleteEnabled = function() {
        return !!providerTemplates.eventEnabled(84)
    };
    proto.traceProcessRemainingFilesComplete = function(hResult) {
        providerTemplates.traceTemplate_d(84, hResult)
    };
    proto.isFileProcessedEnabled = function() {
        return !!providerTemplates.eventEnabled(85)
    };
    proto.traceFileProcessed = function(fileId, foreground, allowGracenoteId, hResult) {
        providerTemplates.traceTemplate_qttd(85, fileId, foreground, allowGracenoteId, hResult)
    };
    proto.isFingerprintIdFoundEnabled = function() {
        return !!providerTemplates.eventEnabled(86)
    };
    proto.traceFingerprintIdFound = function(fileId, fileUrl) {
        providerTemplates.traceTemplate_qz(86, fileId, fileUrl)
    };
    proto.isFingerprintComputedEnabled = function() {
        return !!providerTemplates.eventEnabled(87)
    };
    proto.traceFingerprintComputed = function(fileId, fileUrl) {
        providerTemplates.traceTemplate_qz(87, fileId, fileUrl)
    };
    proto.isFingerprintGeneration_InternalErrorEnabled = function() {
        return !!providerTemplates.eventEnabled(88)
    };
    proto.traceFingerprintGeneration_InternalError = function(fileUrl, error) {
        providerTemplates.traceTemplate_zd(88, fileUrl, error)
    };
    proto.isFingerprintGeneration_EndOfStreamReachedEnabled = function() {
        return !!providerTemplates.eventEnabled(89)
    };
    proto.traceFingerprintGeneration_EndOfStreamReached = function(fileUrl) {
        providerTemplates.traceTemplate_z(89, fileUrl)
    };
    proto.isFingerprintGeneration_SourceReaderErrorEnabled = function() {
        return !!providerTemplates.eventEnabled(90)
    };
    proto.traceFingerprintGeneration_SourceReaderError = function(fileUrl, flags) {
        providerTemplates.traceTemplate_zq(90, fileUrl, flags)
    };
    proto.isFingerprintGeneration_FingerprintRetrievedEnabled = function() {
        return !!providerTemplates.eventEnabled(91)
    };
    proto.traceFingerprintGeneration_FingerprintRetrieved = function(fileUrl, qualities) {
        providerTemplates.traceTemplate_zq(91, fileUrl, qualities)
    };
    proto.isGetImmediateFingerprintsStartEnabled = function() {
        return !!providerTemplates.eventEnabled(92)
    };
    proto.traceGetImmediateFingerprintsStart = function() {
        providerTemplates.traceTemplateEventDescriptor(92)
    };
    proto.isGetImmediateFingerprintsCompleteEnabled = function() {
        return !!providerTemplates.eventEnabled(93)
    };
    proto.traceGetImmediateFingerprintsComplete = function(processedFileCount) {
        providerTemplates.traceTemplate_q(93, processedFileCount)
    };
    proto.isImmediateFingerprintRetrievedEnabled = function() {
        return !!providerTemplates.eventEnabled(94)
    };
    proto.traceImmediateFingerprintRetrieved = function(fileId, hResult, resultType) {
        providerTemplates.traceTemplate_qdd(94, fileId, hResult, resultType)
    }
})(this);
(function initMicrosoft_Zune_Pipeline(global) {
    var providerTemplates = null;
    var ns = global;
    if (ns.Diagnostics === undefined)
        ns.Diagnostics = {};
    var ns = ns.Diagnostics;
    if (ns.Tracing === undefined)
        ns.Tracing = {};
    var ns = ns.Tracing;
    if (ns.Microsoft === undefined)
        ns.Microsoft = {};
    var ns = ns.Microsoft;
    if (ns.Entertainment === undefined)
        ns.Entertainment = {};
    var ns = ns.Entertainment;
    if (ns.Instrumentation === undefined)
        ns.Instrumentation = {};
    var ns = ns.Instrumentation;
    if (ns.Providers === undefined)
        ns.Providers = {};
    var ns = ns.Providers;
    ns.Pipeline = function() {
        if (providerTemplates === null)
            providerTemplates = new global.Microsoft.Entertainment.Instrumentation.Providers.PipelineTemplate
    };
    var proto = ns.Pipeline.prototype;
    proto.isMBR_Pause_EnterEnabled = function() {
        return !!providerTemplates.eventEnabled(0)
    };
    proto.traceMBR_Pause_Enter = function(currentStreamTimeHns) {
        providerTemplates.traceTemplate_x(0, currentStreamTimeHns)
    };
    proto.isMBR_Pause_ExitEnabled = function() {
        return !!providerTemplates.eventEnabled(1)
    };
    proto.traceMBR_Pause_Exit = function(currentStreamTimeHns, hResult) {
        providerTemplates.traceTemplate_xd(1, currentStreamTimeHns, hResult)
    };
    proto.isMBR_Run_EnterEnabled = function() {
        return !!providerTemplates.eventEnabled(2)
    };
    proto.traceMBR_Run_Enter = function(startTimeHns, currentStreamTimeHns) {
        providerTemplates.traceTemplate_xx(2, startTimeHns, currentStreamTimeHns)
    };
    proto.isMBR_Run_LockEnabled = function() {
        return !!providerTemplates.eventEnabled(3)
    };
    proto.traceMBR_Run_Lock = function(currentStreamTimeHns) {
        providerTemplates.traceTemplate_x(3, currentStreamTimeHns)
    };
    proto.isMBR_Run_ExitEnabled = function() {
        return !!providerTemplates.eventEnabled(4)
    };
    proto.traceMBR_Run_Exit = function(currentStreamTimeHns, hResult) {
        providerTemplates.traceTemplate_xd(4, currentStreamTimeHns, hResult)
    };
    proto.isMBR_Seek_EnterEnabled = function() {
        return !!providerTemplates.eventEnabled(5)
    };
    proto.traceMBR_Seek_Enter = function(possitionHns, currentStreamTimeHns) {
        providerTemplates.traceTemplate_ix(5, possitionHns, currentStreamTimeHns)
    };
    proto.isMBR_Seek_ExitEnabled = function() {
        return !!providerTemplates.eventEnabled(6)
    };
    proto.traceMBR_Seek_Exit = function(currentStreamTimeHns, hResult) {
        providerTemplates.traceTemplate_xd(6, currentStreamTimeHns, hResult)
    };
    proto.isMBR_Stop_EnterEnabled = function() {
        return !!providerTemplates.eventEnabled(7)
    };
    proto.traceMBR_Stop_Enter = function(currentStreamTimeHns) {
        providerTemplates.traceTemplate_x(7, currentStreamTimeHns)
    };
    proto.isMBR_Stop_ExitEnabled = function() {
        return !!providerTemplates.eventEnabled(8)
    };
    proto.traceMBR_Stop_Exit = function(currentStreamTimeHns, hResult) {
        providerTemplates.traceTemplate_xd(8, currentStreamTimeHns, hResult)
    };
    proto.isMBR_SourceState_ChangedEnabled = function() {
        return !!providerTemplates.eventEnabled(9)
    };
    proto.traceMBR_SourceState_Changed = function(filterState, oldState, newState) {
        providerTemplates.traceTemplate_ddd(9, filterState, oldState, newState)
    };
    proto.isMBR_PinPumpState_ChangedEnabled = function() {
        return !!providerTemplates.eventEnabled(10)
    };
    proto.traceMBR_PinPumpState_Changed = function(streamType, oldState, newState) {
        providerTemplates.traceTemplate_qdd(10, streamType, oldState, newState)
    };
    proto.isMBR_EOSEnabled = function() {
        return !!providerTemplates.eventEnabled(11)
    };
    proto.traceMBR_EOS = function(streamType, currentStreamTimeHns) {
        providerTemplates.traceTemplate_qx(11, streamType, currentStreamTimeHns)
    };
    proto.isMBR_Preroll_ExitEnabled = function() {
        return !!providerTemplates.eventEnabled(12)
    };
    proto.traceMBR_Preroll_Exit = function(streamType, initialAudioTimeHns, initialVideoTimeHns, newStartBaseTimeHns) {
        providerTemplates.traceTemplate_dxxx(12, streamType, initialAudioTimeHns, initialVideoTimeHns, newStartBaseTimeHns)
    };
    proto.isMBR_Preroll_Forced_ExitEnabled = function() {
        return !!providerTemplates.eventEnabled(13)
    };
    proto.traceMBR_Preroll_Forced_Exit = function(streamType, initialAudioTimeHns, initialVideoTimeHns, newStartBaseTimeHns) {
        providerTemplates.traceTemplate_dxxx(13, streamType, initialAudioTimeHns, initialVideoTimeHns, newStartBaseTimeHns)
    };
    proto.isMBR_PinBeginFlush_EnterEnabled = function() {
        return !!providerTemplates.eventEnabled(14)
    };
    proto.traceMBR_PinBeginFlush_Enter = function(streamType, currentStreamTimeHns) {
        providerTemplates.traceTemplate_qx(14, streamType, currentStreamTimeHns)
    };
    proto.isMBR_PinBeginFlush_ExitEnabled = function() {
        return !!providerTemplates.eventEnabled(15)
    };
    proto.traceMBR_PinBeginFlush_Exit = function(streamType, currentStreamTimeHns, hResult) {
        providerTemplates.traceTemplate_qxd(15, streamType, currentStreamTimeHns, hResult)
    };
    proto.isMBR_PinEndFlush_EnterEnabled = function() {
        return !!providerTemplates.eventEnabled(16)
    };
    proto.traceMBR_PinEndFlush_Enter = function(streamType, currentStreamTimeHns) {
        providerTemplates.traceTemplate_qx(16, streamType, currentStreamTimeHns)
    };
    proto.isMBR_PinEndFlush_ExitEnabled = function() {
        return !!providerTemplates.eventEnabled(17)
    };
    proto.traceMBR_PinEndFlush_Exit = function(streamType, currentStreamTimeHns, hResult) {
        providerTemplates.traceTemplate_qxd(17, streamType, currentStreamTimeHns, hResult)
    };
    proto.isMBR_GotNewSampleEnabled = function() {
        return !!providerTemplates.eventEnabled(18)
    };
    proto.traceMBR_GotNewSample = function(streamType, sampleTimeHns, currentStreamTimeHns) {
        providerTemplates.traceTemplate_qxx(18, streamType, sampleTimeHns, currentStreamTimeHns)
    };
    proto.isMBR_SamplePushedToPinPumpEnabled = function() {
        return !!providerTemplates.eventEnabled(19)
    };
    proto.traceMBR_SamplePushedToPinPump = function(streamType, sampleTimeHns, currentStreamTimeHns) {
        providerTemplates.traceTemplate_qxx(19, streamType, sampleTimeHns, currentStreamTimeHns)
    };
    proto.isMBR_SamplePushedDownStream_BeginEnabled = function() {
        return !!providerTemplates.eventEnabled(20)
    };
    proto.traceMBR_SamplePushedDownStream_Begin = function(streamType, sampleTimeHns, currentStreamTimeHns) {
        providerTemplates.traceTemplate_qxx(20, streamType, sampleTimeHns, currentStreamTimeHns)
    };
    proto.isMBR_SamplePushedDownStream_EndEnabled = function() {
        return !!providerTemplates.eventEnabled(21)
    };
    proto.traceMBR_SamplePushedDownStream_End = function(streamType, sampleTimeHns, currentStreamTimeHns) {
        providerTemplates.traceTemplate_qxx(21, streamType, sampleTimeHns, currentStreamTimeHns)
    };
    proto.isMBR_BufferStatusEnabled = function() {
        return !!providerTemplates.eventEnabled(22)
    };
    proto.traceMBR_BufferStatus = function(currentStreamTimeHns, bufferSizeMs) {
        providerTemplates.traceTemplate_xx(22, currentStreamTimeHns, bufferSizeMs)
    };
    proto.isMBR_DropFrameEnabled = function() {
        return !!providerTemplates.eventEnabled(23)
    };
    proto.traceMBR_DropFrame = function(totalFramesDropped, sampleTimeHns, currentStreamTimeHns) {
        providerTemplates.traceTemplate_qxx(23, totalFramesDropped, sampleTimeHns, currentStreamTimeHns)
    };
    proto.isMBR_PinDecompress_BeginEnabled = function() {
        return !!providerTemplates.eventEnabled(24)
    };
    proto.traceMBR_PinDecompress_Begin = function(streamType, sampleTimeHns, currentStreamTimeHns) {
        providerTemplates.traceTemplate_qxx(24, streamType, sampleTimeHns, currentStreamTimeHns)
    };
    proto.isMBR_PinDecompress_EndEnabled = function() {
        return !!providerTemplates.eventEnabled(25)
    };
    proto.traceMBR_PinDecompress_End = function(streamType, frameSizeInBytes, durationHns) {
        providerTemplates.traceTemplate_qqx(25, streamType, frameSizeInBytes, durationHns)
    };
    proto.isMBR_PinDecompress_CallEnabled = function() {
        return !!providerTemplates.eventEnabled(26)
    };
    proto.traceMBR_PinDecompress_Call = function(streamType) {
        providerTemplates.traceTemplate_q(26, streamType)
    };
    proto.isMBR_PinDecompress_ReturnEnabled = function() {
        return !!providerTemplates.eventEnabled(27)
    };
    proto.traceMBR_PinDecompress_Return = function(streamType) {
        providerTemplates.traceTemplate_q(27, streamType)
    };
    proto.isMBR_Transcrypt_BeginEnabled = function() {
        return !!providerTemplates.eventEnabled(28)
    };
    proto.traceMBR_Transcrypt_Begin = function(streamType) {
        providerTemplates.traceTemplate_q(28, streamType)
    };
    proto.isMBR_Transcrypt_EndEnabled = function() {
        return !!providerTemplates.eventEnabled(29)
    };
    proto.traceMBR_Transcrypt_End = function(streamType) {
        providerTemplates.traceTemplate_q(29, streamType)
    };
    proto.isMBR_DMO_ProcessInput_ReturnEnabled = function() {
        return !!providerTemplates.eventEnabled(30)
    };
    proto.traceMBR_DMO_ProcessInput_Return = function(streamType, sampleTimeHns, hResult) {
        providerTemplates.traceTemplate_qxd(30, streamType, sampleTimeHns, hResult)
    };
    proto.isMBR_DMO_ProcessOutput_ReturnEnabled = function() {
        return !!providerTemplates.eventEnabled(31)
    };
    proto.traceMBR_DMO_ProcessOutput_Return = function(streamType, hResult, durationHns) {
        providerTemplates.traceTemplate_qdx(31, streamType, hResult, durationHns)
    };
    proto.isMBR_NextChunkEnabled = function() {
        return !!providerTemplates.eventEnabled(32)
    };
    proto.traceMBR_NextChunk = function(streamType, chunkIndex, bitrateBps, sampleTimeHns, durationHns, sizeInBytes, quality, targetQuality, totalBandwidthBps, targetBandwidthBps, bufferSizeMs) {
        providerTemplates.traceTemplate_qdqxxqqqqqq(32, streamType, chunkIndex, bitrateBps, sampleTimeHns, durationHns, sizeInBytes, quality, targetQuality, totalBandwidthBps, targetBandwidthBps, bufferSizeMs)
    };
    proto.isMBR_ManifestStreamEnabled = function() {
        return !!providerTemplates.eventEnabled(33)
    };
    proto.traceMBR_ManifestStream = function(streamType, iD, bitrate, width, height, channels) {
        providerTemplates.traceTemplate_qqqqqq(33, streamType, iD, bitrate, width, height, channels)
    };
    proto.isTranscoding_JobTypeEnabled = function() {
        return !!providerTemplates.eventEnabled(34)
    };
    proto.traceTranscoding_JobType = function(jobType) {
        providerTemplates.traceTemplate_d(34, jobType)
    };
    proto.isTranscoding_StartEnabled = function() {
        return !!providerTemplates.eventEnabled(35)
    };
    proto.traceTranscoding_Start = function() {
        providerTemplates.traceTemplateEventDescriptor(35)
    };
    proto.isTranscoding_CompleteEnabled = function() {
        return !!providerTemplates.eventEnabled(36)
    };
    proto.traceTranscoding_Complete = function(hResult) {
        providerTemplates.traceTemplate_d(36, hResult)
    };
    proto.isTranscoding_MF_DShow_FallbackEnabled = function() {
        return !!providerTemplates.eventEnabled(37)
    };
    proto.traceTranscoding_MF_DShow_Fallback = function() {
        providerTemplates.traceTemplateEventDescriptor(37)
    };
    proto.isTranscoding_MF_HW_SW_FallbackEnabled = function() {
        return !!providerTemplates.eventEnabled(38)
    };
    proto.traceTranscoding_MF_HW_SW_Fallback = function() {
        providerTemplates.traceTemplateEventDescriptor(38)
    };
    proto.isTranscoding_MF_HW_StatusEnabled = function() {
        return !!providerTemplates.eventEnabled(39)
    };
    proto.traceTranscoding_MF_HW_Status = function(hW_Status) {
        providerTemplates.traceTemplate_t(39, hW_Status)
    };
    proto.isTranscoding_Crash_StatusEnabled = function() {
        return !!providerTemplates.eventEnabled(40)
    };
    proto.traceTranscoding_Crash_Status = function(crashCount, maxCrashCount, hW_Status, isConfirmed, hResult) {
        providerTemplates.traceTemplate_qqttd(40, crashCount, maxCrashCount, hW_Status, isConfirmed, hResult)
    };
    proto.isTranscoding_Disable_HW_AccelerationEnabled = function() {
        return !!providerTemplates.eventEnabled(41)
    };
    proto.traceTranscoding_Disable_HW_Acceleration = function() {
        providerTemplates.traceTemplateEventDescriptor(41)
    };
    proto.isTranscoding_Reenable_HW_AccelerationEnabled = function() {
        return !!providerTemplates.eventEnabled(42)
    };
    proto.traceTranscoding_Reenable_HW_Acceleration = function() {
        providerTemplates.traceTemplateEventDescriptor(42)
    };
    proto.isTranscoding_SW_Retranscode_After_CrashEnabled = function() {
        return !!providerTemplates.eventEnabled(43)
    };
    proto.traceTranscoding_SW_Retranscode_After_Crash = function() {
        providerTemplates.traceTemplateEventDescriptor(43)
    };
    proto.isPresenter_DownresEnabled = function() {
        return !!providerTemplates.eventEnabled(44)
    };
    proto.tracePresenter_Downres = function(width, height) {
        providerTemplates.traceTemplate_qq(44, width, height)
    };
    proto.isPresenter_Native_Video_SizeEnabled = function() {
        return !!providerTemplates.eventEnabled(45)
    };
    proto.tracePresenter_Native_Video_Size = function(width, height) {
        providerTemplates.traceTemplate_qq(45, width, height)
    };
    proto.isPresenter_Target_Video_SizeEnabled = function() {
        return !!providerTemplates.eventEnabled(46)
    };
    proto.tracePresenter_Target_Video_Size = function(width, height) {
        providerTemplates.traceTemplate_qq(46, width, height)
    };
    proto.isPresenter_Display_Video_SizeEnabled = function() {
        return !!providerTemplates.eventEnabled(47)
    };
    proto.tracePresenter_Display_Video_Size = function(width, height) {
        providerTemplates.traceTemplate_qq(47, width, height)
    };
    proto.isPresenter_FrameTimesEnabled = function() {
        return !!providerTemplates.eventEnabled(48)
    };
    proto.tracePresenter_FrameTimes = function(frameNumber, timestampStream, timestampQPC, systime100ns, streamtime100ns, freqQPC) {
        providerTemplates.traceTemplate_xxxxxx(48, frameNumber, timestampStream, timestampQPC, systime100ns, streamtime100ns, freqQPC)
    };
    proto.isPresenter_FrameDroppedEnabled = function() {
        return !!providerTemplates.eventEnabled(49)
    };
    proto.tracePresenter_FrameDropped = function(framesDropped) {
        providerTemplates.traceTemplate_q(49, framesDropped)
    };
    proto.isPresenter_OperationEnabled = function() {
        return !!providerTemplates.eventEnabled(50)
    };
    proto.tracePresenter_Operation = function(op, lastPTS, splashOwnedFrameCount, stepCount, state, connectedState) {
        providerTemplates.traceTemplate_zxqqdd(50, op, lastPTS, splashOwnedFrameCount, stepCount, state, connectedState)
    };
    proto.isLEQ_EnabledEnabled = function() {
        return !!providerTemplates.eventEnabled(51)
    };
    proto.traceLEQ_Enabled = function(enabled) {
        providerTemplates.traceTemplate_t(51, enabled)
    };
    proto.isLEQ_SetFormatEnabled = function() {
        return !!providerTemplates.eventEnabled(52)
    };
    proto.traceLEQ_SetFormat = function(format, channels, samplesPerChannel, action, hResult) {
        providerTemplates.traceTemplate_qqqqd(52, format, channels, samplesPerChannel, action, hResult)
    };
    proto.isLEQ_Process_StartEnabled = function() {
        return !!providerTemplates.eventEnabled(53)
    };
    proto.traceLEQ_Process_Start = function() {
        providerTemplates.traceTemplateEventDescriptor(53)
    };
    proto.isLEQ_Process_CompleteEnabled = function() {
        return !!providerTemplates.eventEnabled(54)
    };
    proto.traceLEQ_Process_Complete = function(passthrough, hResult) {
        providerTemplates.traceTemplate_td(54, passthrough, hResult)
    };
    proto.isPlaybackInterop_PlayerStateChangedEnabled = function() {
        return !!providerTemplates.eventEnabled(55)
    };
    proto.tracePlaybackInterop_PlayerStateChanged = function(state) {
        providerTemplates.traceTemplate_q(55, state)
    };
    proto.isPlaybackInterop_PositionChangedEnabled = function() {
        return !!providerTemplates.eventEnabled(56)
    };
    proto.tracePlaybackInterop_PositionChanged = function(position, minSeekPosition, maxSeekPosition, endOfMedia, canSeek) {
        providerTemplates.traceTemplate_xxxtt(56, position, minSeekPosition, maxSeekPosition, endOfMedia, canSeek)
    };
    proto.isPlaybackInterop_TransportStateChangedEnabled = function() {
        return !!providerTemplates.eventEnabled(57)
    };
    proto.tracePlaybackInterop_TransportStateChanged = function(state) {
        providerTemplates.traceTemplate_q(57, state)
    };
    proto.isPlaybackInterop_TrickPlayStateChangedEnabled = function() {
        return !!providerTemplates.eventEnabled(58)
    };
    proto.tracePlaybackInterop_TrickPlayStateChanged = function(state) {
        providerTemplates.traceTemplate_q(58, state)
    };
    proto.isPlayback_MCPlayerAdapter_CreateInstanceEnabled = function() {
        return !!providerTemplates.eventEnabled(59)
    };
    proto.tracePlayback_MCPlayerAdapter_CreateInstance = function(hResult) {
        providerTemplates.traceTemplate_d(59, hResult)
    };
    proto.isPlayback_MFPlayer_CreateInstanceEnabled = function() {
        return !!providerTemplates.eventEnabled(60)
    };
    proto.tracePlayback_MFPlayer_CreateInstance = function(hResult) {
        providerTemplates.traceTemplate_d(60, hResult)
    };
    proto.isPlayback_ControlInitializedEnabled = function() {
        return !!providerTemplates.eventEnabled(61)
    };
    proto.tracePlayback_ControlInitialized = function() {
        providerTemplates.traceTemplateEventDescriptor(61)
    };
    proto.isPlayback_SessionInitializedEnabled = function() {
        return !!providerTemplates.eventEnabled(62)
    };
    proto.tracePlayback_SessionInitialized = function() {
        providerTemplates.traceTemplateEventDescriptor(62)
    };
    proto.isPlayback_PlayerStateChangedEnabled = function() {
        return !!providerTemplates.eventEnabled(63)
    };
    proto.tracePlayback_PlayerStateChanged = function(newState, oldState) {
        providerTemplates.traceTemplate_zz(63, newState, oldState)
    };
    proto.isPlayback_TransportStateChangedEnabled = function() {
        return !!providerTemplates.eventEnabled(64)
    };
    proto.tracePlayback_TransportStateChanged = function(newState, oldState) {
        providerTemplates.traceTemplate_zz(64, newState, oldState)
    };
    proto.isPlayback_SetMediaEnabled = function() {
        return !!providerTemplates.eventEnabled(65)
    };
    proto.tracePlayback_SetMedia = function(source, mediaType, protectionState, startPosition, cookie, durationMsec) {
        providerTemplates.traceTemplate_zzzqqq(65, source, mediaType, protectionState, startPosition, cookie, durationMsec)
    };
    proto.isPlayback_SetNextMediaEnabled = function() {
        return !!providerTemplates.eventEnabled(66)
    };
    proto.tracePlayback_SetNextMedia = function(readyForNext, source, mediaType, protectionState, startPosition, cookie) {
        providerTemplates.traceTemplate_tzzzqq(66, readyForNext, source, mediaType, protectionState, startPosition, cookie)
    };
    proto.isPlayback_CurrentMediaLoadedEnabled = function() {
        return !!providerTemplates.eventEnabled(67)
    };
    proto.tracePlayback_CurrentMediaLoaded = function(source, mediaType, protectionState, startPosition, cookie, durationMsec) {
        providerTemplates.traceTemplate_zzzqqq(67, source, mediaType, protectionState, startPosition, cookie, durationMsec)
    };
    proto.isPlayback_NextMediaLoadedEnabled = function() {
        return !!providerTemplates.eventEnabled(68)
    };
    proto.tracePlayback_NextMediaLoaded = function(source, mediaType, protectionState, startPosition, cookie, durationMsec) {
        providerTemplates.traceTemplate_zzzqqq(68, source, mediaType, protectionState, startPosition, cookie, durationMsec)
    };
    proto.isPlayback_SwitchingToNextMediaEnabled = function() {
        return !!providerTemplates.eventEnabled(69)
    };
    proto.tracePlayback_SwitchingToNextMedia = function(source) {
        providerTemplates.traceTemplate_z(69, source)
    };
    proto.isPlayback_NextMediaStartedEnabled = function() {
        return !!providerTemplates.eventEnabled(70)
    };
    proto.tracePlayback_NextMediaStarted = function(source) {
        providerTemplates.traceTemplate_z(70, source)
    };
    proto.isPlayback_ErrorOccurredEnabled = function() {
        return !!providerTemplates.eventEnabled(71)
    };
    proto.tracePlayback_ErrorOccurred = function(errorCode, extendedCode, context) {
        providerTemplates.traceTemplate_qqz(71, errorCode, extendedCode, context)
    };
    proto.isPlayback_EnableTimeUpdateEnabled = function() {
        return !!providerTemplates.eventEnabled(72)
    };
    proto.tracePlayback_EnableTimeUpdate = function(currentPositionMsec) {
        providerTemplates.traceTemplate_q(72, currentPositionMsec)
    };
    proto.isPlayback_DisableTimeUpdateEnabled = function() {
        return !!providerTemplates.eventEnabled(73)
    };
    proto.tracePlayback_DisableTimeUpdate = function(currentPositionMsec) {
        providerTemplates.traceTemplate_q(73, currentPositionMsec)
    };
    proto.isPlayback_ForceTimeUpdateEnabled = function() {
        return !!providerTemplates.eventEnabled(74)
    };
    proto.tracePlayback_ForceTimeUpdate = function(currentPositionMsec) {
        providerTemplates.traceTemplate_q(74, currentPositionMsec)
    };
    proto.isPlayback_PBMSoundLevelChangedEnabled = function() {
        return !!providerTemplates.eventEnabled(75)
    };
    proto.tracePlayback_PBMSoundLevelChanged = function(soundLevel, currentTransportState) {
        providerTemplates.traceTemplate_zz(75, soundLevel, currentTransportState)
    };
    proto.isPlayback_TargetTransportStateSetEnabled = function() {
        return !!providerTemplates.eventEnabled(76)
    };
    proto.tracePlayback_TargetTransportStateSet = function(wannaBe, current) {
        providerTemplates.traceTemplate_zz(76, wannaBe, current)
    };
    proto.isPlaylist_SetDataSourceBeginEnabled = function() {
        return !!providerTemplates.eventEnabled(77)
    };
    proto.tracePlaylist_SetDataSourceBegin = function() {
        providerTemplates.traceTemplateEventDescriptor(77)
    };
    proto.isPlaylist_SetDataSourceEndEnabled = function() {
        return !!providerTemplates.eventEnabled(78)
    };
    proto.tracePlaylist_SetDataSourceEnd = function() {
        providerTemplates.traceTemplateEventDescriptor(78)
    };
    proto.isPlaylist_InterpretingDataEnabled = function() {
        return !!providerTemplates.eventEnabled(79)
    };
    proto.tracePlaylist_InterpretingData = function() {
        providerTemplates.traceTemplateEventDescriptor(79)
    };
    proto.isPlaylist_ActivateEnabled = function() {
        return !!providerTemplates.eventEnabled(80)
    };
    proto.tracePlaylist_Activate = function(index, startPosition, shuffle, repeat) {
        providerTemplates.traceTemplate_qqtt(80, index, startPosition, shuffle, repeat)
    };
    proto.isPlaylist_SetMediaEnabled = function() {
        return !!providerTemplates.eventEnabled(81)
    };
    proto.tracePlaylist_SetMedia = function(source, mediaType, protectionState, startPosition, cookie) {
        providerTemplates.traceTemplate_zzzqq(81, source, mediaType, protectionState, startPosition, cookie)
    };
    proto.isPlaylist_SetNextMediaEnabled = function() {
        return !!providerTemplates.eventEnabled(82)
    };
    proto.tracePlaylist_SetNextMedia = function(source, mediaType, protectionState, startPosition, cookie) {
        providerTemplates.traceTemplate_zzzqq(82, source, mediaType, protectionState, startPosition, cookie)
    };
    proto.isPlaylist_CreatedEnabled = function() {
        return !!providerTemplates.eventEnabled(83)
    };
    proto.tracePlaylist_Created = function() {
        providerTemplates.traceTemplateEventDescriptor(83)
    };
    proto.isPlaylog_BookmarkLoadEnabled = function() {
        return !!providerTemplates.eventEnabled(84)
    };
    proto.tracePlaylog_BookmarkLoad = function(positionMS, playFromBookmark) {
        providerTemplates.traceTemplate_qt(84, positionMS, playFromBookmark)
    };
    proto.isPlaylog_BookmarkSaveEnabled = function() {
        return !!providerTemplates.eventEnabled(85)
    };
    proto.tracePlaylog_BookmarkSave = function(positionMS) {
        providerTemplates.traceTemplate_q(85, positionMS)
    };
    proto.isPlaylog_PlayCountLoadEnabled = function() {
        return !!providerTemplates.eventEnabled(86)
    };
    proto.tracePlaylog_PlayCountLoad = function(playCount) {
        providerTemplates.traceTemplate_q(86, playCount)
    };
    proto.isPlaylog_PlayCountSaveEnabled = function() {
        return !!providerTemplates.eventEnabled(87)
    };
    proto.tracePlaylog_PlayCountSave = function(playCount) {
        providerTemplates.traceTemplate_q(87, playCount)
    };
    proto.isPlaylog_PlayedLoadEnabled = function() {
        return !!providerTemplates.eventEnabled(88)
    };
    proto.tracePlaylog_PlayedLoad = function(played) {
        providerTemplates.traceTemplate_t(88, played)
    };
    proto.isPlaylog_PlayedSaveEnabled = function() {
        return !!providerTemplates.eventEnabled(89)
    };
    proto.tracePlaylog_PlayedSave = function(played) {
        providerTemplates.traceTemplate_t(89, played)
    };
    proto.isDRM_RootLicenseRefresh_AccountEnabled = function() {
        return !!providerTemplates.eventEnabled(90)
    };
    proto.traceDRM_RootLicenseRefresh_Account = function(subscription, tunerActivated) {
        providerTemplates.traceTemplate_tt(90, subscription, tunerActivated)
    };
    proto.isDRM_RootLicenseRefresh_DetailsEnabled = function() {
        return !!providerTemplates.eventEnabled(91)
    };
    proto.traceDRM_RootLicenseRefresh_Details = function(now, lastRefresh, spanMs) {
        providerTemplates.traceTemplate_zzx(91, now, lastRefresh, spanMs)
    };
    proto.isDRM_RootLicenseRefresh_InvokedEnabled = function() {
        return !!providerTemplates.eventEnabled(92)
    };
    proto.traceDRM_RootLicenseRefresh_Invoked = function() {
        providerTemplates.traceTemplateEventDescriptor(92)
    };
    proto.isDRM_RootLicenseRefresh_CompletedEnabled = function() {
        return !!providerTemplates.eventEnabled(93)
    };
    proto.traceDRM_RootLicenseRefresh_Completed = function(status) {
        providerTemplates.traceTemplate_z(93, status)
    };
    proto.isDRM_ReportMetering_AccountEnabled = function() {
        return !!providerTemplates.eventEnabled(94)
    };
    proto.traceDRM_ReportMetering_Account = function(subscription, tunerActivated, meteringCertificate) {
        providerTemplates.traceTemplate_ttz(94, subscription, tunerActivated, meteringCertificate)
    };
    proto.isDRM_ReportMetering_InvokedEnabled = function() {
        return !!providerTemplates.eventEnabled(95)
    };
    proto.traceDRM_ReportMetering_Invoked = function() {
        providerTemplates.traceTemplateEventDescriptor(95)
    };
    proto.isDRM_ReportMetering_CompletedEnabled = function() {
        return !!providerTemplates.eventEnabled(96)
    };
    proto.traceDRM_ReportMetering_Completed = function(status) {
        providerTemplates.traceTemplate_z(96, status)
    };
    proto.isDRM_ReportMetering_NoDataToReportEnabled = function() {
        return !!providerTemplates.eventEnabled(97)
    };
    proto.traceDRM_ReportMetering_NoDataToReport = function() {
        providerTemplates.traceTemplateEventDescriptor(97)
    };
    proto.isDRM_DeleteLicense_InvokedEnabled = function() {
        return !!providerTemplates.eventEnabled(98)
    };
    proto.traceDRM_DeleteLicense_Invoked = function(kid) {
        providerTemplates.traceTemplate_z(98, kid)
    };
    proto.isDRM_DeleteLicense_CompletedEnabled = function() {
        return !!providerTemplates.eventEnabled(99)
    };
    proto.traceDRM_DeleteLicense_Completed = function(kid, hResult) {
        providerTemplates.traceTemplate_zd(99, kid, hResult)
    };
    proto.isClosedCaptions_RendererGetTTMLFilepathEnabled = function() {
        return !!providerTemplates.eventEnabled(100)
    };
    proto.traceClosedCaptions_RendererGetTTMLFilepath = function(state, smid, miid, lcid, filepath) {
        providerTemplates.traceTemplate_zzzqz(100, state, smid, miid, lcid, filepath)
    };
    proto.isClosedCaptions_RendererLoadTTMLFileEnabled = function() {
        return !!providerTemplates.eventEnabled(101)
    };
    proto.traceClosedCaptions_RendererLoadTTMLFile = function(state, filepath) {
        providerTemplates.traceTemplate_zz(101, state, filepath)
    };
    proto.isClosedCaptions_EnterRenderingLoopEnabled = function() {
        return !!providerTemplates.eventEnabled(102)
    };
    proto.traceClosedCaptions_EnterRenderingLoop = function(currentPosition, transportState) {
        providerTemplates.traceTemplate_qz(102, currentPosition, transportState)
    };
    proto.isClosedCaptions_ExitRenderingLoopEnabled = function() {
        return !!providerTemplates.eventEnabled(103)
    };
    proto.traceClosedCaptions_ExitRenderingLoop = function(currentPosition, transportState, closedCaptionsOn) {
        providerTemplates.traceTemplate_qzt(103, currentPosition, transportState, closedCaptionsOn)
    };
    proto.isClosedCaptions_OnEnabled = function() {
        return !!providerTemplates.eventEnabled(104)
    };
    proto.traceClosedCaptions_On = function(enabled) {
        providerTemplates.traceTemplate_t(104, enabled)
    };
    proto.isClosedCaptions_DroppedFrameEnabled = function() {
        return !!providerTemplates.eventEnabled(105)
    };
    proto.traceClosedCaptions_DroppedFrame = function(generatedAt, validUntil, currentPosition) {
        providerTemplates.traceTemplate_qqq(105, generatedAt, validUntil, currentPosition)
    };
    proto.isFastStartMediaSource_CreatedEnabled = function() {
        return !!providerTemplates.eventEnabled(106)
    };
    proto.traceFastStartMediaSource_Created = function() {
        providerTemplates.traceTemplateEventDescriptor(106)
    };
    proto.isFastStartMediaSource_ReceivedUrlEnabled = function() {
        return !!providerTemplates.eventEnabled(107)
    };
    proto.traceFastStartMediaSource_ReceivedUrl = function(info) {
        providerTemplates.traceTemplate_z(107, info)
    };
    proto.isFastStartMediaSource_PlaybackStartEnabled = function() {
        return !!providerTemplates.eventEnabled(108)
    };
    proto.traceFastStartMediaSource_PlaybackStart = function() {
        providerTemplates.traceTemplateEventDescriptor(108)
    };
    proto.isPlayback_WPPEnabled = function() {
        return !!providerTemplates.eventEnabled(109)
    };
    proto.tracePlayback_WPP = function(info) {
        providerTemplates.traceTemplate_z(109, info)
    }
})(this);
(function initMicrosoft_Zune_Service(global) {
    var providerTemplates = null;
    var ns = global;
    if (ns.Diagnostics === undefined)
        ns.Diagnostics = {};
    var ns = ns.Diagnostics;
    if (ns.Tracing === undefined)
        ns.Tracing = {};
    var ns = ns.Tracing;
    if (ns.Microsoft === undefined)
        ns.Microsoft = {};
    var ns = ns.Microsoft;
    if (ns.Entertainment === undefined)
        ns.Entertainment = {};
    var ns = ns.Entertainment;
    if (ns.Instrumentation === undefined)
        ns.Instrumentation = {};
    var ns = ns.Instrumentation;
    if (ns.Providers === undefined)
        ns.Providers = {};
    var ns = ns.Providers;
    ns.Service = function() {
        if (providerTemplates === null)
            providerTemplates = new global.Microsoft.Entertainment.Instrumentation.Providers.ServiceTemplate
    };
    var proto = ns.Service.prototype;
    proto.isServiceSignInStartedEnabled = function() {
        return !!providerTemplates.eventEnabled(0)
    };
    proto.traceServiceSignInStarted = function(message) {
        providerTemplates.traceTemplate_z(0, message)
    };
    proto.isServiceSignInCompletedEnabled = function() {
        return !!providerTemplates.eventEnabled(1)
    };
    proto.traceServiceSignInCompleted = function(message) {
        providerTemplates.traceTemplate_z(1, message)
    };
    proto.isServiceSignInErrorEnabled = function() {
        return !!providerTemplates.eventEnabled(2)
    };
    proto.traceServiceSignInError = function(hResult) {
        providerTemplates.traceTemplate_d(2, hResult)
    };
    proto.isServiceGetTicketStartedEnabled = function() {
        return !!providerTemplates.eventEnabled(3)
    };
    proto.traceServiceGetTicketStarted = function(message) {
        providerTemplates.traceTemplate_z(3, message)
    };
    proto.isServiceGetTicketCompletedEnabled = function() {
        return !!providerTemplates.eventEnabled(4)
    };
    proto.traceServiceGetTicketCompleted = function(message) {
        providerTemplates.traceTemplate_z(4, message)
    };
    proto.isServiceGetTicketErrorEnabled = function() {
        return !!providerTemplates.eventEnabled(5)
    };
    proto.traceServiceGetTicketError = function(hResult) {
        providerTemplates.traceTemplate_d(5, hResult)
    };
    proto.isServiceSignOutStartedEnabled = function() {
        return !!providerTemplates.eventEnabled(6)
    };
    proto.traceServiceSignOutStarted = function(message) {
        providerTemplates.traceTemplate_z(6, message)
    };
    proto.isServiceSignOutCompletedEnabled = function() {
        return !!providerTemplates.eventEnabled(7)
    };
    proto.traceServiceSignOutCompleted = function(message) {
        providerTemplates.traceTemplate_z(7, message)
    };
    proto.isServiceZestSignInStartedEnabled = function() {
        return !!providerTemplates.eventEnabled(8)
    };
    proto.traceServiceZestSignInStarted = function(message) {
        providerTemplates.traceTemplate_z(8, message)
    };
    proto.isServiceZestSignInCompletedEnabled = function() {
        return !!providerTemplates.eventEnabled(9)
    };
    proto.traceServiceZestSignInCompleted = function(message) {
        providerTemplates.traceTemplate_z(9, message)
    };
    proto.isServiceAgeAndGenderStartedEnabled = function() {
        return !!providerTemplates.eventEnabled(10)
    };
    proto.traceServiceAgeAndGenderStarted = function(message) {
        providerTemplates.traceTemplate_z(10, message)
    };
    proto.isServiceAgeAndGenderCompletedEnabled = function() {
        return !!providerTemplates.eventEnabled(11)
    };
    proto.traceServiceAgeAndGenderCompleted = function(message) {
        providerTemplates.traceTemplate_z(11, message)
    };
    proto.isServiceRefreshSignInStartedEnabled = function() {
        return !!providerTemplates.eventEnabled(12)
    };
    proto.traceServiceRefreshSignInStarted = function() {
        providerTemplates.traceTemplateEventDescriptor(12)
    };
    proto.isServiceRefreshSignInCompletedEnabled = function() {
        return !!providerTemplates.eventEnabled(13)
    };
    proto.traceServiceRefreshSignInCompleted = function() {
        providerTemplates.traceTemplateEventDescriptor(13)
    };
    proto.isServiceAuthHeaderEnabled = function() {
        return !!providerTemplates.eventEnabled(14)
    };
    proto.traceServiceAuthHeader = function(message) {
        providerTemplates.traceTemplate_z(14, message)
    };
    proto.isServiceUserProfilePropertyEnabled = function() {
        return !!providerTemplates.eventEnabled(15)
    };
    proto.traceServiceUserProfileProperty = function(name, value) {
        providerTemplates.traceTemplate_zz(15, name, value)
    };
    proto.isServiceUserProfileStartedEnabled = function() {
        return !!providerTemplates.eventEnabled(16)
    };
    proto.traceServiceUserProfileStarted = function(message) {
        providerTemplates.traceTemplate_z(16, message)
    };
    proto.isServiceUserProfileCompletedEnabled = function() {
        return !!providerTemplates.eventEnabled(17)
    };
    proto.traceServiceUserProfileCompleted = function(message) {
        providerTemplates.traceTemplate_z(17, message)
    };
    proto.isFamilyUserPropertyEnabled = function() {
        return !!providerTemplates.eventEnabled(18)
    };
    proto.traceFamilyUserProperty = function(name, value) {
        providerTemplates.traceTemplate_zz(18, name, value)
    };
    proto.isServiceFamilyUserStartedEnabled = function() {
        return !!providerTemplates.eventEnabled(19)
    };
    proto.traceServiceFamilyUserStarted = function(message) {
        providerTemplates.traceTemplate_z(19, message)
    };
    proto.isServiceFamilyUserCompletedEnabled = function() {
        return !!providerTemplates.eventEnabled(20)
    };
    proto.traceServiceFamilyUserCompleted = function(message) {
        providerTemplates.traceTemplate_z(20, message)
    };
    proto.isSubscriptionInfoPropertyEnabled = function() {
        return !!providerTemplates.eventEnabled(21)
    };
    proto.traceSubscriptionInfoProperty = function(name, value) {
        providerTemplates.traceTemplate_zz(21, name, value)
    };
    proto.isServiceSubscriptionInfoStartedEnabled = function() {
        return !!providerTemplates.eventEnabled(22)
    };
    proto.traceServiceSubscriptionInfoStarted = function(message) {
        providerTemplates.traceTemplate_z(22, message)
    };
    proto.isServiceSubscriptionInfoCompletedEnabled = function() {
        return !!providerTemplates.eventEnabled(23)
    };
    proto.traceServiceSubscriptionInfoCompleted = function(message) {
        providerTemplates.traceTemplate_z(23, message)
    };
    proto.isServiceUserChangedEnabled = function() {
        return !!providerTemplates.eventEnabled(24)
    };
    proto.traceServiceUserChanged = function(message) {
        providerTemplates.traceTemplate_z(24, message)
    };
    proto.isPurchaseHistoryGrovelStartedEnabled = function() {
        return !!providerTemplates.eventEnabled(25)
    };
    proto.tracePurchaseHistoryGrovelStarted = function() {
        providerTemplates.traceTemplateEventDescriptor(25)
    };
    proto.isPurchaseHistoryGrovelCompletedEnabled = function() {
        return !!providerTemplates.eventEnabled(26)
    };
    proto.tracePurchaseHistoryGrovelCompleted = function(hResult) {
        providerTemplates.traceTemplate_d(26, hResult)
    };
    proto.isPurchaseHistoryGrovelErrorEnabled = function() {
        return !!providerTemplates.eventEnabled(27)
    };
    proto.tracePurchaseHistoryGrovelError = function(hResult) {
        providerTemplates.traceTemplate_d(27, hResult)
    }
})(this);
(function initMicrosoft_Zune_Shell(global) {
    var providerTemplates = null;
    var ns = global;
    if (ns.Diagnostics === undefined)
        ns.Diagnostics = {};
    var ns = ns.Diagnostics;
    if (ns.Tracing === undefined)
        ns.Tracing = {};
    var ns = ns.Tracing;
    if (ns.Microsoft === undefined)
        ns.Microsoft = {};
    var ns = ns.Microsoft;
    if (ns.Entertainment === undefined)
        ns.Entertainment = {};
    var ns = ns.Entertainment;
    if (ns.Instrumentation === undefined)
        ns.Instrumentation = {};
    var ns = ns.Instrumentation;
    if (ns.Providers === undefined)
        ns.Providers = {};
    var ns = ns.Providers;
    ns.Shell = function() {
        if (providerTemplates === null)
            providerTemplates = new global.Microsoft.Entertainment.Instrumentation.Providers.ShellTemplate
    };
    var proto = ns.Shell.prototype;
    proto.isNavigable_Loading_DoneEnabled = function() {
        return !!providerTemplates.eventEnabled(0)
    };
    proto.traceNavigable_Loading_Done = function(moniker) {
        providerTemplates.traceTemplate_z(0, moniker)
    };
    proto.isQueries_BeginEnabled = function() {
        return !!providerTemplates.eventEnabled(1)
    };
    proto.traceQueries_Begin = function(moniker) {
        providerTemplates.traceTemplate_z(1, moniker)
    };
    proto.isQueries_CompleteEnabled = function() {
        return !!providerTemplates.eventEnabled(2)
    };
    proto.traceQueries_Complete = function(moniker) {
        providerTemplates.traceTemplate_z(2, moniker)
    };
    proto.isJavascript_Load_StartEnabled = function() {
        return !!providerTemplates.eventEnabled(3)
    };
    proto.traceJavascript_Load_Start = function() {
        providerTemplates.traceTemplateEventDescriptor(3)
    };
    proto.isSplashScreen_RemovedEnabled = function() {
        return !!providerTemplates.eventEnabled(4)
    };
    proto.traceSplashScreen_Removed = function() {
        providerTemplates.traceTemplateEventDescriptor(4)
    };
    proto.isJavascript_Load_EndEnabled = function() {
        return !!providerTemplates.eventEnabled(5)
    };
    proto.traceJavascript_Load_End = function() {
        providerTemplates.traceTemplateEventDescriptor(5)
    };
    proto.isDom_Content_LoadedEnabled = function() {
        return !!providerTemplates.eventEnabled(6)
    };
    proto.traceDom_Content_Loaded = function() {
        providerTemplates.traceTemplateEventDescriptor(6)
    };
    proto.isFinish_ProcessAllEnabled = function() {
        return !!providerTemplates.eventEnabled(7)
    };
    proto.traceFinish_ProcessAll = function() {
        providerTemplates.traceTemplateEventDescriptor(7)
    };
    proto.isNavigation_StartedEnabled = function() {
        return !!providerTemplates.eventEnabled(8)
    };
    proto.traceNavigation_Started = function(moniker) {
        providerTemplates.traceTemplate_z(8, moniker)
    };
    proto.isLocation_ChangedEnabled = function() {
        return !!providerTemplates.eventEnabled(9)
    };
    proto.traceLocation_Changed = function(pageMoniker, hubMoniker, panelMoniker) {
        providerTemplates.traceTemplate_zzz(9, pageMoniker, hubMoniker, panelMoniker)
    };
    proto.isOverlay_ShownEnabled = function() {
        return !!providerTemplates.eventEnabled(10)
    };
    proto.traceOverlay_Shown = function(templateId) {
        providerTemplates.traceTemplate_z(10, templateId)
    };
    proto.isOverlay_DismissedEnabled = function() {
        return !!providerTemplates.eventEnabled(11)
    };
    proto.traceOverlay_Dismissed = function(templateId) {
        providerTemplates.traceTemplate_z(11, templateId)
    };
    proto.isAction_InvokedEnabled = function() {
        return !!providerTemplates.eventEnabled(12)
    };
    proto.traceAction_Invoked = function(actionId) {
        providerTemplates.traceTemplate_z(12, actionId)
    };
    proto.isDeepLink_Protocol_InvokedEnabled = function() {
        return !!providerTemplates.eventEnabled(13)
    };
    proto.traceDeepLink_Protocol_Invoked = function(url) {
        providerTemplates.traceTemplate_z(13, url)
    };
    proto.isDeepLink_Protocol_FailedEnabled = function() {
        return !!providerTemplates.eventEnabled(14)
    };
    proto.traceDeepLink_Protocol_Failed = function(url) {
        providerTemplates.traceTemplate_z(14, url)
    };
    proto.isDeepLink_Tile_InvokedEnabled = function() {
        return !!providerTemplates.eventEnabled(15)
    };
    proto.traceDeepLink_Tile_Invoked = function(arguments) {
        providerTemplates.traceTemplate_z(15, arguments)
    };
    proto.isDeepLink_Tile_FailedEnabled = function() {
        return !!providerTemplates.eventEnabled(16)
    };
    proto.traceDeepLink_Tile_Failed = function(arguments) {
        providerTemplates.traceTemplate_z(16, arguments)
    };
    proto.isSearch_StartEnabled = function() {
        return !!providerTemplates.eventEnabled(17)
    };
    proto.traceSearch_Start = function() {
        providerTemplates.traceTemplateEventDescriptor(17)
    };
    proto.isSearch_CompletedEnabled = function() {
        return !!providerTemplates.eventEnabled(18)
    };
    proto.traceSearch_Completed = function() {
        providerTemplates.traceTemplateEventDescriptor(18)
    };
    proto.isWebExperience_StartEnabled = function() {
        return !!providerTemplates.eventEnabled(19)
    };
    proto.traceWebExperience_Start = function(templateId) {
        providerTemplates.traceTemplate_z(19, templateId)
    };
    proto.isWebExperience_FinishEnabled = function() {
        return !!providerTemplates.eventEnabled(20)
    };
    proto.traceWebExperience_Finish = function(templateId) {
        providerTemplates.traceTemplate_z(20, templateId)
    };
    proto.isWebExperience_CancelEnabled = function() {
        return !!providerTemplates.eventEnabled(21)
    };
    proto.traceWebExperience_Cancel = function(templateId) {
        providerTemplates.traceTemplate_z(21, templateId)
    };
    proto.isWebExperience_ErrorEnabled = function() {
        return !!providerTemplates.eventEnabled(22)
    };
    proto.traceWebExperience_Error = function(templateId) {
        providerTemplates.traceTemplate_z(22, templateId)
    };
    proto.isWebExperience_PageLoadEnabled = function() {
        return !!providerTemplates.eventEnabled(23)
    };
    proto.traceWebExperience_PageLoad = function(templateId) {
        providerTemplates.traceTemplate_z(23, templateId)
    };
    proto.isTest_Event_ResultEnabled = function() {
        return !!providerTemplates.eventEnabled(24)
    };
    proto.traceTest_Event_Result = function(result, message) {
        providerTemplates.traceTemplate_tz(24, result, message)
    };
    proto.isTest_Event_TraceEnabled = function() {
        return !!providerTemplates.eventEnabled(25)
    };
    proto.traceTest_Event_Trace = function(id, message) {
        providerTemplates.traceTemplate_dz(25, id, message)
    };
    proto.isTest_Event_ErrorEnabled = function() {
        return !!providerTemplates.eventEnabled(26)
    };
    proto.traceTest_Event_Error = function(id, message) {
        providerTemplates.traceTemplate_dz(26, id, message)
    };
    proto.isHubStrip_Load_StartEnabled = function() {
        return !!providerTemplates.eventEnabled(27)
    };
    proto.traceHubStrip_Load_Start = function(moniker) {
        providerTemplates.traceTemplate_z(27, moniker)
    };
    proto.isHubStrip_Load_EndEnabled = function() {
        return !!providerTemplates.eventEnabled(28)
    };
    proto.traceHubStrip_Load_End = function(moniker) {
        providerTemplates.traceTemplate_z(28, moniker)
    };
    proto.isHub_Load_StartEnabled = function() {
        return !!providerTemplates.eventEnabled(29)
    };
    proto.traceHub_Load_Start = function(moniker) {
        providerTemplates.traceTemplate_z(29, moniker)
    };
    proto.isHub_Load_EndEnabled = function() {
        return !!providerTemplates.eventEnabled(30)
    };
    proto.traceHub_Load_End = function(moniker) {
        providerTemplates.traceTemplate_z(30, moniker)
    };
    proto.isPanel_Load_StartEnabled = function() {
        return !!providerTemplates.eventEnabled(31)
    };
    proto.tracePanel_Load_Start = function(moniker) {
        providerTemplates.traceTemplate_z(31, moniker)
    };
    proto.isPanel_Load_EndEnabled = function() {
        return !!providerTemplates.eventEnabled(32)
    };
    proto.tracePanel_Load_End = function(moniker) {
        providerTemplates.traceTemplate_z(32, moniker)
    };
    proto.isHubStrip_ReadyEnabled = function() {
        return !!providerTemplates.eventEnabled(33)
    };
    proto.traceHubStrip_Ready = function(moniker) {
        providerTemplates.traceTemplate_z(33, moniker)
    };
    proto.isHub_ReadyEnabled = function() {
        return !!providerTemplates.eventEnabled(34)
    };
    proto.traceHub_Ready = function(moniker) {
        providerTemplates.traceTemplate_z(34, moniker)
    };
    proto.isPanel_ReadyEnabled = function() {
        return !!providerTemplates.eventEnabled(35)
    };
    proto.tracePanel_Ready = function(moniker) {
        providerTemplates.traceTemplate_z(35, moniker)
    };
    proto.isHubStrip_MoveToCompleteEnabled = function() {
        return !!providerTemplates.eventEnabled(36)
    };
    proto.traceHubStrip_MoveToComplete = function(moniker) {
        providerTemplates.traceTemplate_z(36, moniker)
    };
    proto.isCreateAccount_StartEnabled = function() {
        return !!providerTemplates.eventEnabled(37)
    };
    proto.traceCreateAccount_Start = function(templateId) {
        providerTemplates.traceTemplate_z(37, templateId)
    };
    proto.isCreateAccount_FinishEnabled = function() {
        return !!providerTemplates.eventEnabled(38)
    };
    proto.traceCreateAccount_Finish = function(templateId) {
        providerTemplates.traceTemplate_z(38, templateId)
    };
    proto.isCreateAccount_CancelEnabled = function() {
        return !!providerTemplates.eventEnabled(39)
    };
    proto.traceCreateAccount_Cancel = function(templateId) {
        providerTemplates.traceTemplate_z(39, templateId)
    };
    proto.isCreateAccount_ErrorEnabled = function() {
        return !!providerTemplates.eventEnabled(40)
    };
    proto.traceCreateAccount_Error = function(templateId) {
        providerTemplates.traceTemplate_z(40, templateId)
    };
    proto.isAcceptTermsOfService_StartEnabled = function() {
        return !!providerTemplates.eventEnabled(41)
    };
    proto.traceAcceptTermsOfService_Start = function(templateId) {
        providerTemplates.traceTemplate_z(41, templateId)
    };
    proto.isAcceptTermsOfService_FinishEnabled = function() {
        return !!providerTemplates.eventEnabled(42)
    };
    proto.traceAcceptTermsOfService_Finish = function(templateId) {
        providerTemplates.traceTemplate_z(42, templateId)
    };
    proto.isAcceptTermsOfService_CancelEnabled = function() {
        return !!providerTemplates.eventEnabled(43)
    };
    proto.traceAcceptTermsOfService_Cancel = function(templateId) {
        providerTemplates.traceTemplate_z(43, templateId)
    };
    proto.isSignInResultEnabled = function() {
        return !!providerTemplates.eventEnabled(44)
    };
    proto.traceSignInResult = function(templateId) {
        providerTemplates.traceTemplate_z(44, templateId)
    };
    proto.isSettingsHome_StartEnabled = function() {
        return !!providerTemplates.eventEnabled(45)
    };
    proto.traceSettingsHome_Start = function(templateId) {
        providerTemplates.traceTemplate_z(45, templateId)
    };
    proto.isSettingsHome_FinishEnabled = function() {
        return !!providerTemplates.eventEnabled(46)
    };
    proto.traceSettingsHome_Finish = function(templateId) {
        providerTemplates.traceTemplate_z(46, templateId)
    };
    proto.isSettingsAccount_LaunchEnabled = function() {
        return !!providerTemplates.eventEnabled(47)
    };
    proto.traceSettingsAccount_Launch = function(templateId) {
        providerTemplates.traceTemplate_z(47, templateId)
    };
    proto.isSettingsAccount_FinishEnabled = function() {
        return !!providerTemplates.eventEnabled(48)
    };
    proto.traceSettingsAccount_Finish = function(templateId) {
        providerTemplates.traceTemplate_z(48, templateId)
    };
    proto.isSettingsAccount_ErrorEnabled = function() {
        return !!providerTemplates.eventEnabled(49)
    };
    proto.traceSettingsAccount_Error = function(templateId) {
        providerTemplates.traceTemplate_z(49, templateId)
    };
    proto.isSettingsPreferences_LaunchEnabled = function() {
        return !!providerTemplates.eventEnabled(50)
    };
    proto.traceSettingsPreferences_Launch = function(templateId) {
        providerTemplates.traceTemplate_z(50, templateId)
    };
    proto.isSettingsAbout_LaunchEnabled = function() {
        return !!providerTemplates.eventEnabled(51)
    };
    proto.traceSettingsAbout_Launch = function(templateId) {
        providerTemplates.traceTemplate_z(51, templateId)
    };
    proto.isSettingsFeedback_LaunchEnabled = function() {
        return !!providerTemplates.eventEnabled(52)
    };
    proto.traceSettingsFeedback_Launch = function(templateId) {
        providerTemplates.traceTemplate_z(52, templateId)
    };
    proto.isSettingsCaptions_LaunchEnabled = function() {
        return !!providerTemplates.eventEnabled(53)
    };
    proto.traceSettingsCaptions_Launch = function(templateId) {
        providerTemplates.traceTemplate_z(53, templateId)
    };
    proto.isSettingsPopulate_StartEnabled = function() {
        return !!providerTemplates.eventEnabled(54)
    };
    proto.traceSettingsPopulate_Start = function(templateId) {
        providerTemplates.traceTemplate_z(54, templateId)
    };
    proto.isSettingsWinJSPopulate_StartEnabled = function() {
        return !!providerTemplates.eventEnabled(55)
    };
    proto.traceSettingsWinJSPopulate_Start = function(templateId) {
        providerTemplates.traceTemplate_z(55, templateId)
    };
    proto.isSettingsPopulate_EndEnabled = function() {
        return !!providerTemplates.eventEnabled(56)
    };
    proto.traceSettingsPopulate_End = function(templateId) {
        providerTemplates.traceTemplate_z(56, templateId)
    };
    proto.isPurchaseFlowGames_StartEnabled = function() {
        return !!providerTemplates.eventEnabled(57)
    };
    proto.tracePurchaseFlowGames_Start = function(templateId) {
        providerTemplates.traceTemplate_z(57, templateId)
    };
    proto.isPurchaseFlowGames_FinishEnabled = function() {
        return !!providerTemplates.eventEnabled(58)
    };
    proto.tracePurchaseFlowGames_Finish = function(templateId) {
        providerTemplates.traceTemplate_z(58, templateId)
    };
    proto.isPurchaseFlowGames_CancelEnabled = function() {
        return !!providerTemplates.eventEnabled(59)
    };
    proto.tracePurchaseFlowGames_Cancel = function(templateId) {
        providerTemplates.traceTemplate_z(59, templateId)
    };
    proto.isPurchaseFlowGames_ErrorEnabled = function() {
        return !!providerTemplates.eventEnabled(60)
    };
    proto.tracePurchaseFlowGames_Error = function(templateId) {
        providerTemplates.traceTemplate_z(60, templateId)
    };
    proto.isPurchaseFlowGames_RejectionEnabled = function() {
        return !!providerTemplates.eventEnabled(61)
    };
    proto.tracePurchaseFlowGames_Rejection = function(templateId) {
        providerTemplates.traceTemplate_z(61, templateId)
    };
    proto.isMarketplaceBrowse_PageLoadStartEnabled = function() {
        return !!providerTemplates.eventEnabled(62)
    };
    proto.traceMarketplaceBrowse_PageLoadStart = function(templateId) {
        providerTemplates.traceTemplate_z(62, templateId)
    };
    proto.isServiceQuery_QueryStartEnabled = function() {
        return !!providerTemplates.eventEnabled(63)
    };
    proto.traceServiceQuery_QueryStart = function(templateId) {
        providerTemplates.traceTemplate_z(63, templateId)
    };
    proto.isServiceQuery_QueryReturnEnabled = function() {
        return !!providerTemplates.eventEnabled(64)
    };
    proto.traceServiceQuery_QueryReturn = function(templateId) {
        providerTemplates.traceTemplate_z(64, templateId)
    };
    proto.isServiceQuery_ParseCompleteEnabled = function() {
        return !!providerTemplates.eventEnabled(65)
    };
    proto.traceServiceQuery_ParseComplete = function(templateId) {
        providerTemplates.traceTemplate_z(65, templateId)
    };
    proto.isSettingsAccount_LaunchCompleteEnabled = function() {
        return !!providerTemplates.eventEnabled(66)
    };
    proto.traceSettingsAccount_LaunchComplete = function(templateId) {
        providerTemplates.traceTemplate_z(66, templateId)
    };
    proto.isSettingsPreferences_LaunchCompleteEnabled = function() {
        return !!providerTemplates.eventEnabled(67)
    };
    proto.traceSettingsPreferences_LaunchComplete = function(templateId) {
        providerTemplates.traceTemplate_z(67, templateId)
    };
    proto.isSettingsAbout_LaunchCompleteEnabled = function() {
        return !!providerTemplates.eventEnabled(68)
    };
    proto.traceSettingsAbout_LaunchComplete = function(templateId) {
        providerTemplates.traceTemplate_z(68, templateId)
    };
    proto.isSettings_BackToHomeEnabled = function() {
        return !!providerTemplates.eventEnabled(69)
    };
    proto.traceSettings_BackToHome = function(templateId) {
        providerTemplates.traceTemplate_z(69, templateId)
    };
    proto.isSettingsFeedback_LaunchCompleteEnabled = function() {
        return !!providerTemplates.eventEnabled(70)
    };
    proto.traceSettingsFeedback_LaunchComplete = function(templateId) {
        providerTemplates.traceTemplate_z(70, templateId)
    };
    proto.isSettingsCaptions_LaunchCompleteEnabled = function() {
        return !!providerTemplates.eventEnabled(71)
    };
    proto.traceSettingsCaptions_LaunchComplete = function(templateId) {
        providerTemplates.traceTemplate_z(71, templateId)
    };
    proto.isHomeHub_Load_StartEnabled = function() {
        return !!providerTemplates.eventEnabled(72)
    };
    proto.traceHomeHub_Load_Start = function() {
        providerTemplates.traceTemplateEventDescriptor(72)
    };
    proto.isHomeHub_Load_EndEnabled = function() {
        return !!providerTemplates.eventEnabled(73)
    };
    proto.traceHomeHub_Load_End = function() {
        providerTemplates.traceTemplateEventDescriptor(73)
    };
    proto.isHomeHub_ReadyEnabled = function() {
        return !!providerTemplates.eventEnabled(74)
    };
    proto.traceHomeHub_Ready = function() {
        providerTemplates.traceTemplateEventDescriptor(74)
    };
    proto.isPurchaseFlowMusic_StartEnabled = function() {
        return !!providerTemplates.eventEnabled(75)
    };
    proto.tracePurchaseFlowMusic_Start = function(templateId) {
        providerTemplates.traceTemplate_z(75, templateId)
    };
    proto.isPurchaseFlowMusic_FinishEnabled = function() {
        return !!providerTemplates.eventEnabled(76)
    };
    proto.tracePurchaseFlowMusic_Finish = function(templateId) {
        providerTemplates.traceTemplate_z(76, templateId)
    };
    proto.isPurchaseFlowMusic_CancelEnabled = function() {
        return !!providerTemplates.eventEnabled(77)
    };
    proto.tracePurchaseFlowMusic_Cancel = function(templateId) {
        providerTemplates.traceTemplate_z(77, templateId)
    };
    proto.isPurchaseFlowMusic_ErrorEnabled = function() {
        return !!providerTemplates.eventEnabled(78)
    };
    proto.tracePurchaseFlowMusic_Error = function(templateId) {
        providerTemplates.traceTemplate_z(78, templateId)
    };
    proto.isPurchaseFlowMusic_RejectionEnabled = function() {
        return !!providerTemplates.eventEnabled(79)
    };
    proto.tracePurchaseFlowMusic_Rejection = function(templateId) {
        providerTemplates.traceTemplate_z(79, templateId)
    };
    proto.isPurchaseFlowVideo_StartEnabled = function() {
        return !!providerTemplates.eventEnabled(80)
    };
    proto.tracePurchaseFlowVideo_Start = function(templateId) {
        providerTemplates.traceTemplate_z(80, templateId)
    };
    proto.isPurchaseFlowVideo_FinishEnabled = function() {
        return !!providerTemplates.eventEnabled(81)
    };
    proto.tracePurchaseFlowVideo_Finish = function(templateId) {
        providerTemplates.traceTemplate_z(81, templateId)
    };
    proto.isPurchaseFlowVideo_CancelEnabled = function() {
        return !!providerTemplates.eventEnabled(82)
    };
    proto.tracePurchaseFlowVideo_Cancel = function(templateId) {
        providerTemplates.traceTemplate_z(82, templateId)
    };
    proto.isPurchaseFlowVideo_ErrorEnabled = function() {
        return !!providerTemplates.eventEnabled(83)
    };
    proto.tracePurchaseFlowVideo_Error = function(templateId) {
        providerTemplates.traceTemplate_z(83, templateId)
    };
    proto.isPurchaseFlowVideo_Start_Bandwidth_TestEnabled = function() {
        return !!providerTemplates.eventEnabled(84)
    };
    proto.tracePurchaseFlowVideo_Start_Bandwidth_Test = function(templateId) {
        providerTemplates.traceTemplate_z(84, templateId)
    };
    proto.isPurchaseFlowVideo_DownloadEnabled = function() {
        return !!providerTemplates.eventEnabled(85)
    };
    proto.tracePurchaseFlowVideo_Download = function(templateId) {
        providerTemplates.traceTemplate_z(85, templateId)
    };
    proto.isPurchaseFlowVideo_StreamEnabled = function() {
        return !!providerTemplates.eventEnabled(86)
    };
    proto.tracePurchaseFlowVideo_Stream = function(templateId) {
        providerTemplates.traceTemplate_z(86, templateId)
    };
    proto.isPurchaseFlowVideo_DoneEnabled = function() {
        return !!providerTemplates.eventEnabled(87)
    };
    proto.tracePurchaseFlowVideo_Done = function(templateId) {
        providerTemplates.traceTemplate_z(87, templateId)
    };
    proto.isPurchaseFlowVideo_RejectionEnabled = function() {
        return !!providerTemplates.eventEnabled(88)
    };
    proto.tracePurchaseFlowVideo_Rejection = function(templateId) {
        providerTemplates.traceTemplate_z(88, templateId)
    };
    proto.isGalleryControl_Load_StartEnabled = function() {
        return !!providerTemplates.eventEnabled(89)
    };
    proto.traceGalleryControl_Load_Start = function() {
        providerTemplates.traceTemplateEventDescriptor(89)
    };
    proto.isGalleryControl_Load_EndEnabled = function() {
        return !!providerTemplates.eventEnabled(90)
    };
    proto.traceGalleryControl_Load_End = function() {
        providerTemplates.traceTemplateEventDescriptor(90)
    };
    proto.isGalleryControl_InLine_Open_StartEnabled = function() {
        return !!providerTemplates.eventEnabled(91)
    };
    proto.traceGalleryControl_InLine_Open_Start = function() {
        providerTemplates.traceTemplateEventDescriptor(91)
    };
    proto.isGalleryControl_InLine_Open_EndEnabled = function() {
        return !!providerTemplates.eventEnabled(92)
    };
    proto.traceGalleryControl_InLine_Open_End = function() {
        providerTemplates.traceTemplateEventDescriptor(92)
    };
    proto.isGalleryControl_InLine_Open_ErrorEnabled = function() {
        return !!providerTemplates.eventEnabled(93)
    };
    proto.traceGalleryControl_InLine_Open_Error = function() {
        providerTemplates.traceTemplateEventDescriptor(93)
    };
    proto.isGalleryControl_InLine_CloseEnabled = function() {
        return !!providerTemplates.eventEnabled(94)
    };
    proto.traceGalleryControl_InLine_Close = function() {
        providerTemplates.traceTemplateEventDescriptor(94)
    };
    proto.isGalleryControl_LoadingState_ChangedEnabled = function() {
        return !!providerTemplates.eventEnabled(95)
    };
    proto.traceGalleryControl_LoadingState_Changed = function(newState) {
        providerTemplates.traceTemplate_z(95, newState)
    };
    proto.isModifierControl_SelectionChangedEnabled = function() {
        return !!providerTemplates.eventEnabled(96)
    };
    proto.traceModifierControl_SelectionChanged = function(value, source) {
        providerTemplates.traceTemplate_zz(96, value, source)
    };
    proto.isModifierControl_PopupOpenedEnabled = function() {
        return !!providerTemplates.eventEnabled(97)
    };
    proto.traceModifierControl_PopupOpened = function(templateId) {
        providerTemplates.traceTemplate_z(97, templateId)
    };
    proto.isModifierControl_PopupClosedEnabled = function() {
        return !!providerTemplates.eventEnabled(98)
    };
    proto.traceModifierControl_PopupClosed = function(templateId) {
        providerTemplates.traceTemplate_z(98, templateId)
    };
    proto.isActionListControl_ItemAddedEnabled = function() {
        return !!providerTemplates.eventEnabled(99)
    };
    proto.traceActionListControl_ItemAdded = function(templateId) {
        providerTemplates.traceTemplate_z(99, templateId)
    };
    proto.isActionListControl_ItemRemovedEnabled = function() {
        return !!providerTemplates.eventEnabled(100)
    };
    proto.traceActionListControl_ItemRemoved = function(templateId) {
        providerTemplates.traceTemplate_z(100, templateId)
    };
    proto.isActionListControl_ItemsChangedEnabled = function() {
        return !!providerTemplates.eventEnabled(101)
    };
    proto.traceActionListControl_ItemsChanged = function(templateId) {
        providerTemplates.traceTemplate_z(101, templateId)
    };
    proto.isControlFramework_ControlConstructedEnabled = function() {
        return !!providerTemplates.eventEnabled(102)
    };
    proto.traceControlFramework_ControlConstructed = function(templateId) {
        providerTemplates.traceTemplate_z(102, templateId)
    };
    proto.isControlFramework_ControlCompleteInitializationQueuedEnabled = function() {
        return !!providerTemplates.eventEnabled(103)
    };
    proto.traceControlFramework_ControlCompleteInitializationQueued = function(templateId) {
        providerTemplates.traceTemplate_z(103, templateId)
    };
    proto.isControlFramework_ControlCompleteInitializationRequeuedEnabled = function() {
        return !!providerTemplates.eventEnabled(104)
    };
    proto.traceControlFramework_ControlCompleteInitializationRequeued = function(templateId) {
        providerTemplates.traceTemplate_z(104, templateId)
    };
    proto.isControlFramework_ControlInitializationStartedEnabled = function() {
        return !!providerTemplates.eventEnabled(105)
    };
    proto.traceControlFramework_ControlInitializationStarted = function(templateId) {
        providerTemplates.traceTemplate_z(105, templateId)
    };
    proto.isControlFramework_UserInitializationStartedEnabled = function() {
        return !!providerTemplates.eventEnabled(106)
    };
    proto.traceControlFramework_UserInitializationStarted = function(templateId) {
        providerTemplates.traceTemplate_z(106, templateId)
    };
    proto.isControlFramework_ControlTemplateLoadStartedEnabled = function() {
        return !!providerTemplates.eventEnabled(107)
    };
    proto.traceControlFramework_ControlTemplateLoadStarted = function(templateId) {
        providerTemplates.traceTemplate_z(107, templateId)
    };
    proto.isControlFramework_ControlTemplateLoadCompletedEnabled = function() {
        return !!providerTemplates.eventEnabled(108)
    };
    proto.traceControlFramework_ControlTemplateLoadCompleted = function(templateId) {
        providerTemplates.traceTemplate_z(108, templateId)
    };
    proto.isControlFramework_TemplateLoadStartedEnabled = function() {
        return !!providerTemplates.eventEnabled(109)
    };
    proto.traceControlFramework_TemplateLoadStarted = function(templateId) {
        providerTemplates.traceTemplate_z(109, templateId)
    };
    proto.isControlFramework_TemplateLoadFragmentStartedEnabled = function() {
        return !!providerTemplates.eventEnabled(110)
    };
    proto.traceControlFramework_TemplateLoadFragmentStarted = function(templateId) {
        providerTemplates.traceTemplate_z(110, templateId)
    };
    proto.isControlFramework_TemplateLoadFragmentCompletedEnabled = function() {
        return !!providerTemplates.eventEnabled(111)
    };
    proto.traceControlFramework_TemplateLoadFragmentCompleted = function(templateId) {
        providerTemplates.traceTemplate_z(111, templateId)
    };
    proto.isControlFramework_TemplateLoadTemplateExtractedEnabled = function() {
        return !!providerTemplates.eventEnabled(112)
    };
    proto.traceControlFramework_TemplateLoadTemplateExtracted = function(templateId) {
        providerTemplates.traceTemplate_z(112, templateId)
    };
    proto.isControlFramework_TemplateLoadCompletedFromCacheEnabled = function() {
        return !!providerTemplates.eventEnabled(113)
    };
    proto.traceControlFramework_TemplateLoadCompletedFromCache = function(templateId) {
        providerTemplates.traceTemplate_z(113, templateId)
    };
    proto.isControlFramework_TemplateLoadCompletedEnabled = function() {
        return !!providerTemplates.eventEnabled(114)
    };
    proto.traceControlFramework_TemplateLoadCompleted = function(templateId) {
        providerTemplates.traceTemplate_z(114, templateId)
    };
    proto.isControlFramework_ControlInitializationCompletedEnabled = function() {
        return !!providerTemplates.eventEnabled(115)
    };
    proto.traceControlFramework_ControlInitializationCompleted = function(templateId) {
        providerTemplates.traceTemplate_z(115, templateId)
    };
    proto.isControlFramework_UserInitializationCompletedEnabled = function() {
        return !!providerTemplates.eventEnabled(116)
    };
    proto.traceControlFramework_UserInitializationCompleted = function(templateId) {
        providerTemplates.traceTemplate_z(116, templateId)
    };
    proto.isControlFramework_ControlCompleteInitializationQueuedForRootEnabled = function() {
        return !!providerTemplates.eventEnabled(117)
    };
    proto.traceControlFramework_ControlCompleteInitializationQueuedForRoot = function(templateId) {
        providerTemplates.traceTemplate_z(117, templateId)
    };
    proto.isControlFramework_ControlCompleteInitializationDequeuedForRootEnabled = function() {
        return !!providerTemplates.eventEnabled(118)
    };
    proto.traceControlFramework_ControlCompleteInitializationDequeuedForRoot = function(templateId) {
        providerTemplates.traceTemplate_z(118, templateId)
    };
    proto.isSubscriptionSignup_StartEnabled = function() {
        return !!providerTemplates.eventEnabled(119)
    };
    proto.traceSubscriptionSignup_Start = function(templateId) {
        providerTemplates.traceTemplate_z(119, templateId)
    };
    proto.isSubscriptionSignup_FinishEnabled = function() {
        return !!providerTemplates.eventEnabled(120)
    };
    proto.traceSubscriptionSignup_Finish = function(templateId) {
        providerTemplates.traceTemplate_z(120, templateId)
    };
    proto.isSubscriptionSignup_CancelEnabled = function() {
        return !!providerTemplates.eventEnabled(121)
    };
    proto.traceSubscriptionSignup_Cancel = function(templateId) {
        providerTemplates.traceTemplate_z(121, templateId)
    };
    proto.isSubscriptionSignup_ErrorEnabled = function() {
        return !!providerTemplates.eventEnabled(122)
    };
    proto.traceSubscriptionSignup_Error = function(templateId) {
        providerTemplates.traceTemplate_z(122, templateId)
    };
    proto.isNotification_NotificationArrivedEnabled = function() {
        return !!providerTemplates.eventEnabled(123)
    };
    proto.traceNotification_NotificationArrived = function(templateId) {
        providerTemplates.traceTemplate_z(123, templateId)
    };
    proto.isNotification_PageSelectedEnabled = function() {
        return !!providerTemplates.eventEnabled(124)
    };
    proto.traceNotification_PageSelected = function(templateId) {
        providerTemplates.traceTemplate_z(124, templateId)
    };
    proto.isNotification_NotificationClickedEnabled = function() {
        return !!providerTemplates.eventEnabled(125)
    };
    proto.traceNotification_NotificationClicked = function(templateId) {
        providerTemplates.traceTemplate_z(125, templateId)
    };
    proto.isAd_Companion_ShownEnabled = function() {
        return !!providerTemplates.eventEnabled(126)
    };
    proto.traceAd_Companion_Shown = function(linkUrl, imageUrl) {
        providerTemplates.traceTemplate_zz(126, linkUrl, imageUrl)
    };
    proto.isAd_Companion_HiddenEnabled = function() {
        return !!providerTemplates.eventEnabled(127)
    };
    proto.traceAd_Companion_Hidden = function(linkUrl, imageUrl) {
        providerTemplates.traceTemplate_zz(127, linkUrl, imageUrl)
    };
    proto.isVideo_Ad_StartedEnabled = function() {
        return !!providerTemplates.eventEnabled(128)
    };
    proto.traceVideo_Ad_Started = function(videoUrl, clickUrl) {
        providerTemplates.traceTemplate_zz(128, videoUrl, clickUrl)
    };
    proto.isVideo_Ad_CompletedEnabled = function() {
        return !!providerTemplates.eventEnabled(129)
    };
    proto.traceVideo_Ad_Completed = function(videoUrl, clickUrl) {
        providerTemplates.traceTemplate_zz(129, videoUrl, clickUrl)
    };
    proto.isVideo_Ad_SkippedEnabled = function() {
        return !!providerTemplates.eventEnabled(130)
    };
    proto.traceVideo_Ad_Skipped = function(videoUrl, clickUrl) {
        providerTemplates.traceTemplate_zz(130, videoUrl, clickUrl)
    };
    proto.isVideo_Ad_ErrorEnabled = function() {
        return !!providerTemplates.eventEnabled(131)
    };
    proto.traceVideo_Ad_Error = function(videoUrl, clickUrl) {
        providerTemplates.traceTemplate_zz(131, videoUrl, clickUrl)
    };
    proto.isVideo_Ad_UpSellEnabled = function() {
        return !!providerTemplates.eventEnabled(132)
    };
    proto.traceVideo_Ad_UpSell = function(videoUrl, clickUrl) {
        providerTemplates.traceTemplate_zz(132, videoUrl, clickUrl)
    };
    proto.isAdControl_RefreshedEnabled = function() {
        return !!providerTemplates.eventEnabled(133)
    };
    proto.traceAdControl_Refreshed = function(applicationId, unitId) {
        providerTemplates.traceTemplate_zz(133, applicationId, unitId)
    };
    proto.isAdService_InitializedEnabled = function() {
        return !!providerTemplates.eventEnabled(134)
    };
    proto.traceAdService_Initialized = function() {
        providerTemplates.traceTemplateEventDescriptor(134)
    };
    proto.isAdService_UnloadedEnabled = function() {
        return !!providerTemplates.eventEnabled(135)
    };
    proto.traceAdService_Unloaded = function() {
        providerTemplates.traceTemplateEventDescriptor(135)
    };
    proto.isAdService_AudioAdRefreshingEnabled = function() {
        return !!providerTemplates.eventEnabled(136)
    };
    proto.traceAdService_AudioAdRefreshing = function() {
        providerTemplates.traceTemplateEventDescriptor(136)
    };
    proto.isAdService_AudioAdRefreshedEnabled = function() {
        return !!providerTemplates.eventEnabled(137)
    };
    proto.traceAdService_AudioAdRefreshed = function() {
        providerTemplates.traceTemplateEventDescriptor(137)
    };
    proto.isAdService_VideoAdRefreshingEnabled = function() {
        return !!providerTemplates.eventEnabled(138)
    };
    proto.traceAdService_VideoAdRefreshing = function() {
        providerTemplates.traceTemplateEventDescriptor(138)
    };
    proto.isAdService_VideoAdRefreshedEnabled = function() {
        return !!providerTemplates.eventEnabled(139)
    };
    proto.traceAdService_VideoAdRefreshed = function() {
        providerTemplates.traceTemplateEventDescriptor(139)
    };
    proto.isAdService_AudioAdPlayingEnabled = function() {
        return !!providerTemplates.eventEnabled(140)
    };
    proto.traceAdService_AudioAdPlaying = function() {
        providerTemplates.traceTemplateEventDescriptor(140)
    };
    proto.isAdService_AudioAdPlayedEnabled = function() {
        return !!providerTemplates.eventEnabled(141)
    };
    proto.traceAdService_AudioAdPlayed = function() {
        providerTemplates.traceTemplateEventDescriptor(141)
    };
    proto.isAdService_StreamingTrackPlayingEnabled = function() {
        return !!providerTemplates.eventEnabled(142)
    };
    proto.traceAdService_StreamingTrackPlaying = function() {
        providerTemplates.traceTemplateEventDescriptor(142)
    };
    proto.isAdService_StreamingTrackPlayedEnabled = function() {
        return !!providerTemplates.eventEnabled(143)
    };
    proto.traceAdService_StreamingTrackPlayed = function() {
        providerTemplates.traceTemplateEventDescriptor(143)
    };
    proto.isAdService_TrackPlayingEnabled = function() {
        return !!providerTemplates.eventEnabled(144)
    };
    proto.traceAdService_TrackPlaying = function() {
        providerTemplates.traceTemplateEventDescriptor(144)
    };
    proto.isMediaStateEngine_InitializedEnabled = function() {
        return !!providerTemplates.eventEnabled(145)
    };
    proto.traceMediaStateEngine_Initialized = function(mediaType, serviceId, libraryId) {
        providerTemplates.traceTemplate_zzz(145, mediaType, serviceId, libraryId)
    };
    proto.isMediaStateEngine_UnloadedEnabled = function() {
        return !!providerTemplates.eventEnabled(146)
    };
    proto.traceMediaStateEngine_Unloaded = function(mediaType, serviceId, libraryId) {
        providerTemplates.traceTemplate_zzz(146, mediaType, serviceId, libraryId)
    };
    proto.isMediaStateEngine_UpdateStateEnabled = function() {
        return !!providerTemplates.eventEnabled(147)
    };
    proto.traceMediaStateEngine_UpdateState = function(mediaType, serviceId, libraryId) {
        providerTemplates.traceTemplate_zzz(147, mediaType, serviceId, libraryId)
    };
    proto.isMediaStateEngine_ButtonsChangedEnabled = function() {
        return !!providerTemplates.eventEnabled(148)
    };
    proto.traceMediaStateEngine_ButtonsChanged = function(mediaType, serviceId, libraryId) {
        providerTemplates.traceTemplate_zzz(148, mediaType, serviceId, libraryId)
    };
    proto.isMediaStateEngine_ActionsChangedEnabled = function() {
        return !!providerTemplates.eventEnabled(149)
    };
    proto.traceMediaStateEngine_ActionsChanged = function(mediaType, serviceId, libraryId) {
        providerTemplates.traceTemplate_zzz(149, mediaType, serviceId, libraryId)
    };
    proto.isWinJSNavigation_ContentCompleteEnabled = function() {
        return !!providerTemplates.eventEnabled(150)
    };
    proto.traceWinJSNavigation_ContentComplete = function(location) {
        providerTemplates.traceTemplate_z(150, location)
    };
    proto.isShrinkAndStayHeader_ShownEnabled = function() {
        return !!providerTemplates.eventEnabled(151)
    };
    proto.traceShrinkAndStayHeader_Shown = function() {
        providerTemplates.traceTemplateEventDescriptor(151)
    };
    proto.isShrinkAndStayHeader_DismissedEnabled = function() {
        return !!providerTemplates.eventEnabled(152)
    };
    proto.traceShrinkAndStayHeader_Dismissed = function() {
        providerTemplates.traceTemplateEventDescriptor(152)
    };
    proto.isPerfTrack_Trigger_AppLaunchCompletedEnabled = function() {
        return !!providerTemplates.eventEnabled(153)
    };
    proto.tracePerfTrack_Trigger_AppLaunchCompleted = function(durationMsec) {
        providerTemplates.traceTemplate_q(153, durationMsec)
    };
    proto.isPerfTrack_Trigger_AppLaunchToCollectionCompletedEnabled = function() {
        return !!providerTemplates.eventEnabled(154)
    };
    proto.tracePerfTrack_Trigger_AppLaunchToCollectionCompleted = function(durationMsec) {
        providerTemplates.traceTemplate_q(154, durationMsec)
    };
    proto.isPerfTrack_Trigger_AppLaunchPlayNonProtectedContentEnabled = function() {
        return !!providerTemplates.eventEnabled(155)
    };
    proto.tracePerfTrack_Trigger_AppLaunchPlayNonProtectedContent = function(durationMsec) {
        providerTemplates.traceTemplate_q(155, durationMsec)
    };
    proto.isPerfTrack_Trigger_AppLaunchPlayProtectedContentEnabled = function() {
        return !!providerTemplates.eventEnabled(156)
    };
    proto.tracePerfTrack_Trigger_AppLaunchPlayProtectedContent = function(durationMsec) {
        providerTemplates.traceTemplate_q(156, durationMsec)
    };
    proto.isPerfTrack_Trigger_PlayProtectedInAppPlaybackStartedEnabled = function() {
        return !!providerTemplates.eventEnabled(157)
    };
    proto.tracePerfTrack_Trigger_PlayProtectedInAppPlaybackStarted = function(durationMsec) {
        providerTemplates.traceTemplate_q(157, durationMsec)
    };
    proto.isPerfTrack_Trigger_PlayNonProtectedInAppPlaybackStartedEnabled = function() {
        return !!providerTemplates.eventEnabled(158)
    };
    proto.tracePerfTrack_Trigger_PlayNonProtectedInAppPlaybackStarted = function(durationMsec) {
        providerTemplates.traceTemplate_q(158, durationMsec)
    };
    proto.isPerfTrack_Trigger_CollectionGalleryRequestToLoadEnabled = function() {
        return !!providerTemplates.eventEnabled(159)
    };
    proto.tracePerfTrack_Trigger_CollectionGalleryRequestToLoad = function(durationMsec) {
        providerTemplates.traceTemplate_q(159, durationMsec)
    };
    proto.isPerfTrack_Trigger_SearchGalleryRequestToLoadEnabled = function() {
        return !!providerTemplates.eventEnabled(160)
    };
    proto.tracePerfTrack_Trigger_SearchGalleryRequestToLoad = function(durationMsec) {
        providerTemplates.traceTemplate_q(160, durationMsec)
    };
    proto.isPerfTrack_Trigger_PopoverRequestToLoadEnabled = function() {
        return !!providerTemplates.eventEnabled(161)
    };
    proto.tracePerfTrack_Trigger_PopoverRequestToLoad = function(name, durationMsec) {
        providerTemplates.traceTemplate_zq(161, name, durationMsec)
    };
    proto.isPerfTrack_Trigger_MarketplaceGalleryRequestToLoadEnabled = function() {
        return !!providerTemplates.eventEnabled(162)
    };
    proto.tracePerfTrack_Trigger_MarketplaceGalleryRequestToLoad = function(durationMsec) {
        providerTemplates.traceTemplate_q(162, durationMsec)
    };
    proto.isPerfTrack_Trigger_WebBlendRequestToLoadEnabled = function() {
        return !!providerTemplates.eventEnabled(163)
    };
    proto.tracePerfTrack_Trigger_WebBlendRequestToLoad = function(url, durationMsec) {
        providerTemplates.traceTemplate_zq(163, url, durationMsec)
    };
    proto.isPerfTrack_Trigger_ExplorePageRequestToLoadEnabled = function() {
        return !!providerTemplates.eventEnabled(164)
    };
    proto.tracePerfTrack_Trigger_ExplorePageRequestToLoad = function(durationMsec) {
        providerTemplates.traceTemplate_q(164, durationMsec)
    };
    proto.isPerfTrack_Trigger_RadioPageRequestToLoadEnabled = function() {
        return !!providerTemplates.eventEnabled(165)
    };
    proto.tracePerfTrack_Trigger_RadioPageRequestToLoad = function(durationMsec) {
        providerTemplates.traceTemplate_q(165, durationMsec)
    };
    proto.isPerfTrack_Trigger_AppLaunchToExploreCompleteEnabled = function() {
        return !!providerTemplates.eventEnabled(166)
    };
    proto.tracePerfTrack_Trigger_AppLaunchToExploreComplete = function(durationMsec) {
        providerTemplates.traceTemplate_q(166, durationMsec)
    };
    proto.isPerfTrack_Trigger_AppLaunchToRadioCompleteEnabled = function() {
        return !!providerTemplates.eventEnabled(167)
    };
    proto.tracePerfTrack_Trigger_AppLaunchToRadioComplete = function(durationMsec) {
        providerTemplates.traceTemplate_q(167, durationMsec)
    };
    proto.isPerfTrack_Trigger_TVDetailsRequestToLoadEnabled = function() {
        return !!providerTemplates.eventEnabled(168)
    };
    proto.tracePerfTrack_Trigger_TVDetailsRequestToLoad = function(durationMsec) {
        providerTemplates.traceTemplate_q(168, durationMsec)
    };
    proto.isPerfTrack_Trigger_MovieDetailsRequestToLoadEnabled = function() {
        return !!providerTemplates.eventEnabled(169)
    };
    proto.tracePerfTrack_Trigger_MovieDetailsRequestToLoad = function(durationMsec) {
        providerTemplates.traceTemplate_q(169, durationMsec)
    };
    proto.isPerfTrack_Trigger_AlbumDetailsRequestToLoadEnabled = function() {
        return !!providerTemplates.eventEnabled(170)
    };
    proto.tracePerfTrack_Trigger_AlbumDetailsRequestToLoad = function(durationMsec) {
        providerTemplates.traceTemplate_q(170, durationMsec)
    };
    proto.isPerfTrack_Trigger_ArtistDetailsRequestToLoadEnabled = function() {
        return !!providerTemplates.eventEnabled(171)
    };
    proto.tracePerfTrack_Trigger_ArtistDetailsRequestToLoad = function(durationMsec) {
        providerTemplates.traceTemplate_q(171, durationMsec)
    };
    proto.isPerfTrack_Trigger_PlaylistDetailsRequestToLoadEnabled = function() {
        return !!providerTemplates.eventEnabled(172)
    };
    proto.tracePerfTrack_Trigger_PlaylistDetailsRequestToLoad = function(durationMsec) {
        providerTemplates.traceTemplate_q(172, durationMsec)
    };
    proto.isPerfTrack_Trigger_DevicesPageRequestToLoadEnabled = function() {
        return !!providerTemplates.eventEnabled(173)
    };
    proto.tracePerfTrack_Trigger_DevicesPageRequestToLoad = function(durationMsec) {
        providerTemplates.traceTemplate_q(173, durationMsec)
    };
    proto.isPerfTrack_Trigger_NowPlayingPageRequestToLoadEnabled = function() {
        return !!providerTemplates.eventEnabled(174)
    };
    proto.tracePerfTrack_Trigger_NowPlayingPageRequestToLoad = function(durationMsec) {
        providerTemplates.traceTemplate_q(174, durationMsec)
    };
    proto.isPerfTrack_Trigger_MoviesStorePageRequestToLoadEnabled = function() {
        return !!providerTemplates.eventEnabled(175)
    };
    proto.tracePerfTrack_Trigger_MoviesStorePageRequestToLoad = function(durationMsec) {
        providerTemplates.traceTemplate_q(175, durationMsec)
    };
    proto.isPerfTrack_Trigger_TvStorePageRequestToLoadEnabled = function() {
        return !!providerTemplates.eventEnabled(176)
    };
    proto.tracePerfTrack_Trigger_TvStorePageRequestToLoad = function(durationMsec) {
        providerTemplates.traceTemplate_q(176, durationMsec)
    };
    proto.isPerfTrack_Trigger_VideoCollectionPageRequestToLoadEnabled = function() {
        return !!providerTemplates.eventEnabled(177)
    };
    proto.tracePerfTrack_Trigger_VideoCollectionPageRequestToLoad = function(durationMsec) {
        providerTemplates.traceTemplate_q(177, durationMsec)
    }
})(this);
(function initMicrosoft_Zune_Sync(global) {
    var providerTemplates = null;
    var ns = global;
    if (ns.Diagnostics === undefined)
        ns.Diagnostics = {};
    var ns = ns.Diagnostics;
    if (ns.Tracing === undefined)
        ns.Tracing = {};
    var ns = ns.Tracing;
    if (ns.Microsoft === undefined)
        ns.Microsoft = {};
    var ns = ns.Microsoft;
    if (ns.Entertainment === undefined)
        ns.Entertainment = {};
    var ns = ns.Entertainment;
    if (ns.Instrumentation === undefined)
        ns.Instrumentation = {};
    var ns = ns.Instrumentation;
    if (ns.Providers === undefined)
        ns.Providers = {};
    var ns = ns.Providers;
    ns.Sync = function() {
        if (providerTemplates === null)
            providerTemplates = new global.Microsoft.Entertainment.Instrumentation.Providers.SyncTemplate
    };
    var proto = ns.Sync.prototype;
    proto.isStoreSync_StartEnabled = function() {
        return !!providerTemplates.eventEnabled(0)
    };
    proto.traceStoreSync_Start = function() {
        providerTemplates.traceTemplateEventDescriptor(0)
    };
    proto.isStoreSync_ErrorEnabled = function() {
        return !!providerTemplates.eventEnabled(1)
    };
    proto.traceStoreSync_Error = function(hResult) {
        providerTemplates.traceTemplate_d(1, hResult)
    };
    proto.isStoreSync_StopEnabled = function() {
        return !!providerTemplates.eventEnabled(2)
    };
    proto.traceStoreSync_Stop = function() {
        providerTemplates.traceTemplateEventDescriptor(2)
    };
    proto.isStoreSync_Type_StartEnabled = function() {
        return !!providerTemplates.eventEnabled(3)
    };
    proto.traceStoreSync_Type_Start = function() {
        providerTemplates.traceTemplateEventDescriptor(3)
    };
    proto.isStoreSync_Type_ErrorEnabled = function() {
        return !!providerTemplates.eventEnabled(4)
    };
    proto.traceStoreSync_Type_Error = function(hResult) {
        providerTemplates.traceTemplate_d(4, hResult)
    };
    proto.isStoreSync_Type_StopEnabled = function() {
        return !!providerTemplates.eventEnabled(5)
    };
    proto.traceStoreSync_Type_Stop = function() {
        providerTemplates.traceTemplateEventDescriptor(5)
    };
    proto.isStoreSync_PutRequestEnabled = function() {
        return !!providerTemplates.eventEnabled(6)
    };
    proto.traceStoreSync_PutRequest = function(syncType) {
        providerTemplates.traceTemplate_d(6, syncType)
    };
    proto.isStoreSync_PutRequestCompleteEnabled = function() {
        return !!providerTemplates.eventEnabled(7)
    };
    proto.traceStoreSync_PutRequestComplete = function(syncType) {
        providerTemplates.traceTemplate_d(7, syncType)
    };
    proto.isStoreSync_PutRequestErrorEnabled = function() {
        return !!providerTemplates.eventEnabled(8)
    };
    proto.traceStoreSync_PutRequestError = function(hResult) {
        providerTemplates.traceTemplate_d(8, hResult)
    };
    proto.isStoreSync_PostRequestEnabled = function() {
        return !!providerTemplates.eventEnabled(9)
    };
    proto.traceStoreSync_PostRequest = function(syncType) {
        providerTemplates.traceTemplate_d(9, syncType)
    };
    proto.isStoreSync_PostRequestCompleteEnabled = function() {
        return !!providerTemplates.eventEnabled(10)
    };
    proto.traceStoreSync_PostRequestComplete = function(syncType) {
        providerTemplates.traceTemplate_d(10, syncType)
    };
    proto.isStoreSync_PostRequestErrorEnabled = function() {
        return !!providerTemplates.eventEnabled(11)
    };
    proto.traceStoreSync_PostRequestError = function(hResult) {
        providerTemplates.traceTemplate_d(11, hResult)
    };
    proto.isStoreSync_GetRequestEnabled = function() {
        return !!providerTemplates.eventEnabled(12)
    };
    proto.traceStoreSync_GetRequest = function(syncType) {
        providerTemplates.traceTemplate_d(12, syncType)
    };
    proto.isStoreSync_GetRequestCompleteEnabled = function() {
        return !!providerTemplates.eventEnabled(13)
    };
    proto.traceStoreSync_GetRequestComplete = function(syncType) {
        providerTemplates.traceTemplate_d(13, syncType)
    };
    proto.isStoreSync_GetRequestErrorEnabled = function() {
        return !!providerTemplates.eventEnabled(14)
    };
    proto.traceStoreSync_GetRequestError = function(hResult) {
        providerTemplates.traceTemplate_d(14, hResult)
    };
    proto.isStoreSync_Item_AddEnabled = function() {
        return !!providerTemplates.eventEnabled(15)
    };
    proto.traceStoreSync_Item_Add = function(syncType) {
        providerTemplates.traceTemplate_d(15, syncType)
    };
    proto.isStoreSync_Item_UpdateEnabled = function() {
        return !!providerTemplates.eventEnabled(16)
    };
    proto.traceStoreSync_Item_Update = function(syncType) {
        providerTemplates.traceTemplate_d(16, syncType)
    };
    proto.isStoreSync_Item_DeleteEnabled = function() {
        return !!providerTemplates.eventEnabled(17)
    };
    proto.traceStoreSync_Item_Delete = function(syncType) {
        providerTemplates.traceTemplate_d(17, syncType)
    };
    proto.isStoreSync_Ingestion_StartEnabled = function() {
        return !!providerTemplates.eventEnabled(18)
    };
    proto.traceStoreSync_Ingestion_Start = function() {
        providerTemplates.traceTemplateEventDescriptor(18)
    };
    proto.isStoreSync_Ingestion_ErrorEnabled = function() {
        return !!providerTemplates.eventEnabled(19)
    };
    proto.traceStoreSync_Ingestion_Error = function(hResult) {
        providerTemplates.traceTemplate_d(19, hResult)
    };
    proto.isStoreSync_Ingestion_StopEnabled = function() {
        return !!providerTemplates.eventEnabled(20)
    };
    proto.traceStoreSync_Ingestion_Stop = function() {
        providerTemplates.traceTemplateEventDescriptor(20)
    };
    proto.isStoreSync_NotificationEnabled = function() {
        return !!providerTemplates.eventEnabled(21)
    };
    proto.traceStoreSync_Notification = function() {
        providerTemplates.traceTemplateEventDescriptor(21)
    };
    proto.isStoreSync_Item_LoadEnabled = function() {
        return !!providerTemplates.eventEnabled(22)
    };
    proto.traceStoreSync_Item_Load = function(syncType) {
        providerTemplates.traceTemplate_d(22, syncType)
    }
})(this);
(function initMicrosoft_Zune_LegacyPerfTrace(global) {
    var providerTemplates = null;
    var ns = global;
    if (ns.Diagnostics === undefined)
        ns.Diagnostics = {};
    var ns = ns.Diagnostics;
    if (ns.Tracing === undefined)
        ns.Tracing = {};
    var ns = ns.Tracing;
    if (ns.Microsoft === undefined)
        ns.Microsoft = {};
    var ns = ns.Microsoft;
    if (ns.Entertainment === undefined)
        ns.Entertainment = {};
    var ns = ns.Entertainment;
    if (ns.Instrumentation === undefined)
        ns.Instrumentation = {};
    var ns = ns.Instrumentation;
    if (ns.Providers === undefined)
        ns.Providers = {};
    var ns = ns.Providers;
    ns.LegacyPerfTrace = function() {
        if (providerTemplates === null)
            providerTemplates = new global.Microsoft.Entertainment.Instrumentation.Providers.LegacyPerfTraceTemplate
    };
    var proto = ns.LegacyPerfTrace.prototype;
    proto.isLegacyPerfTraceHttpEventEnabled = function() {
        return !!providerTemplates.eventEnabled(0)
    };
    proto.traceLegacyPerfTraceHttpEvent = function(httpEvent, url) {
        providerTemplates.traceTemplate_qz(0, httpEvent, url)
    };
    proto.isLegacyPerfTraceClientEventEnabled = function() {
        return !!providerTemplates.eventEnabled(1)
    };
    proto.traceLegacyPerfTraceClientEvent = function(reporterTag, actionType, reason) {
        providerTemplates.traceTemplate_qqq(1, reporterTag, actionType, reason)
    };
    proto.isLegacyPerfTraceWMPPlaybackEventEnabled = function() {
        return !!providerTemplates.eventEnabled(2)
    };
    proto.traceLegacyPerfTraceWMPPlaybackEvent = function(type, fileName, graphType, lastHR) {
        providerTemplates.traceTemplate_qzqd(2, type, fileName, graphType, lastHR)
    };
    proto.isLegacyPerfTraceDBMutexEventEnabled = function() {
        return !!providerTemplates.eventEnabled(3)
    };
    proto.traceLegacyPerfTraceDBMutexEvent = function(dBMutexEvent, threadId, time) {
        providerTemplates.traceTemplate_qqq(3, dBMutexEvent, threadId, time)
    };
    proto.isLegacyPerfTraceLaunchEventEnabled = function() {
        return !!providerTemplates.eventEnabled(4)
    };
    proto.traceLegacyPerfTraceLaunchEvent = function(launchEvent, launchEventData) {
        providerTemplates.traceTemplate_qq(4, launchEvent, launchEventData)
    };
    proto.isLegacyPerfTraceSyncEventEnabled = function() {
        return !!providerTemplates.eventEnabled(5)
    };
    proto.traceLegacyPerfTraceSyncEvent = function(syncEvent, syncEventData) {
        providerTemplates.traceTemplate_qq(5, syncEvent, syncEventData)
    };
    proto.isLegacyPerfTraceQRSEventEnabled = function() {
        return !!providerTemplates.eventEnabled(6)
    };
    proto.traceLegacyPerfTraceQRSEvent = function(qRSEvent, qRSEventData) {
        providerTemplates.traceTemplate_qq(6, qRSEvent, qRSEventData)
    };
    proto.isLegacyPerfTraceGenericEventEnabled = function() {
        return !!providerTemplates.eventEnabled(7)
    };
    proto.traceLegacyPerfTraceGenericEvent = function(reporterTag, type, action) {
        providerTemplates.traceTemplate_qqq(7, reporterTag, type, action)
    };
    proto.isLegacyPerfTraceDriverEventEnabled = function() {
        return !!providerTemplates.eventEnabled(8)
    };
    proto.traceLegacyPerfTraceDriverEvent = function(driverEvent, driverEventData) {
        providerTemplates.traceTemplate_qq(8, driverEvent, driverEventData)
    };
    proto.isLegacyPerfTraceCollectionEventEnabled = function() {
        return !!providerTemplates.eventEnabled(9)
    };
    proto.traceLegacyPerfTraceCollectionEvent = function(collectionEvent, detail) {
        providerTemplates.traceTemplate_qz(9, collectionEvent, detail)
    };
    proto.isLegacyPerfTraceQuickMixEventEnabled = function() {
        return !!providerTemplates.eventEnabled(10)
    };
    proto.traceLegacyPerfTraceQuickMixEvent = function(quickMixEvent, quickMixEventData) {
        providerTemplates.traceTemplate_qq(10, quickMixEvent, quickMixEventData)
    };
    proto.isLegacyPerfTraceDownloadEventEnabled = function() {
        return !!providerTemplates.eventEnabled(11)
    };
    proto.traceLegacyPerfTraceDownloadEvent = function(downloadEvent, id) {
        providerTemplates.traceTemplate_qz(11, downloadEvent, id)
    }
})(this);
(function initMicrosoft_Zune_Social(global) {
    var providerTemplates = null;
    var ns = global;
    if (ns.Diagnostics === undefined)
        ns.Diagnostics = {};
    var ns = ns.Diagnostics;
    if (ns.Tracing === undefined)
        ns.Tracing = {};
    var ns = ns.Tracing;
    if (ns.Microsoft === undefined)
        ns.Microsoft = {};
    var ns = ns.Microsoft;
    if (ns.Entertainment === undefined)
        ns.Entertainment = {};
    var ns = ns.Entertainment;
    if (ns.Instrumentation === undefined)
        ns.Instrumentation = {};
    var ns = ns.Instrumentation;
    if (ns.Providers === undefined)
        ns.Providers = {};
    var ns = ns.Providers;
    ns.Social = function() {
        if (providerTemplates === null)
            providerTemplates = new global.Microsoft.Entertainment.Instrumentation.Providers.SocialTemplate
    };
    var proto = ns.Social.prototype;
    proto.isAvatarRendererFrameStartEnabled = function() {
        return !!providerTemplates.eventEnabled(0)
    };
    proto.traceAvatarRendererFrameStart = function(id) {
        providerTemplates.traceTemplate_z(0, id)
    };
    proto.isAvatarRendererFrameEndEnabled = function() {
        return !!providerTemplates.eventEnabled(1)
    };
    proto.traceAvatarRendererFrameEnd = function(id, duration) {
        providerTemplates.traceTemplate_zf(1, id, duration)
    };
    proto.isAvatarRendererShutdownEnabled = function() {
        return !!providerTemplates.eventEnabled(2)
    };
    proto.traceAvatarRendererShutdown = function(id) {
        providerTemplates.traceTemplate_z(2, id)
    }
})(this);
(function initMicrosoft_Zune_Xbox(global) {
    var providerTemplates = null;
    var ns = global;
    if (ns.Diagnostics === undefined)
        ns.Diagnostics = {};
    var ns = ns.Diagnostics;
    if (ns.Tracing === undefined)
        ns.Tracing = {};
    var ns = ns.Tracing;
    if (ns.Microsoft === undefined)
        ns.Microsoft = {};
    var ns = ns.Microsoft;
    if (ns.Entertainment === undefined)
        ns.Entertainment = {};
    var ns = ns.Entertainment;
    if (ns.Instrumentation === undefined)
        ns.Instrumentation = {};
    var ns = ns.Instrumentation;
    if (ns.Providers === undefined)
        ns.Providers = {};
    var ns = ns.Providers;
    ns.Xbox = function() {
        if (providerTemplates === null)
            providerTemplates = new global.Microsoft.Entertainment.Instrumentation.Providers.XboxTemplate
    };
    var proto = ns.Xbox.prototype;
    proto.isXboxSessionStateChangeEnabled = function() {
        return !!providerTemplates.eventEnabled(0)
    };
    proto.traceXboxSessionStateChange = function(newState, oldState) {
        providerTemplates.traceTemplate_zz(0, newState, oldState)
    };
    proto.isXboxTransportControlsLRCStateChangeEnabled = function() {
        return !!providerTemplates.eventEnabled(1)
    };
    proto.traceXboxTransportControlsLRCStateChange = function(newState, oldState) {
        providerTemplates.traceTemplate_zz(1, newState, oldState)
    };
    proto.isXboxSigninTMFServiceSigninEnabled = function() {
        return !!providerTemplates.eventEnabled(2)
    };
    proto.traceXboxSigninTMFServiceSignin = function(tag, hResult, errorText) {
        providerTemplates.traceTemplate_zdz(2, tag, hResult, errorText)
    };
    proto.isXboxSigninJoinSessionEnabled = function() {
        return !!providerTemplates.eventEnabled(3)
    };
    proto.traceXboxSigninJoinSession = function(tag, hResult, errorText) {
        providerTemplates.traceTemplate_zdz(3, tag, hResult, errorText)
    };
    proto.isXboxSigninX8AppSigninEnabled = function() {
        return !!providerTemplates.eventEnabled(4)
    };
    proto.traceXboxSigninX8AppSignin = function(tag, hResult, errorText) {
        providerTemplates.traceTemplate_zdz(4, tag, hResult, errorText)
    };
    proto.isXboxSigninNoUserSessionsEnabled = function() {
        return !!providerTemplates.eventEnabled(5)
    };
    proto.traceXboxSigninNoUserSessions = function(tag, hResult, errorText) {
        providerTemplates.traceTemplate_zdz(5, tag, hResult, errorText)
    };
    proto.isXboxControlCommandSentEnabled = function() {
        return !!providerTemplates.eventEnabled(6)
    };
    proto.traceXboxControlCommandSent = function(controlKey, executionTimeMilliseconds) {
        providerTemplates.traceTemplate_qf(6, controlKey, executionTimeMilliseconds)
    };
    proto.isXboxControlCommandErrorEnabled = function() {
        return !!providerTemplates.eventEnabled(7)
    };
    proto.traceXboxControlCommandError = function(controlKey, executionTimeMilliseconds, responseCode) {
        providerTemplates.traceTemplate_qfq(7, controlKey, executionTimeMilliseconds, responseCode)
    };
    proto.isXboxControlSeekCommandSentEnabled = function() {
        return !!providerTemplates.eventEnabled(8)
    };
    proto.traceXboxControlSeekCommandSent = function(seekPosition, executionTimeMilliseconds) {
        providerTemplates.traceTemplate_xf(8, seekPosition, executionTimeMilliseconds)
    };
    proto.isXboxControlSeekCommandErrorEnabled = function() {
        return !!providerTemplates.eventEnabled(9)
    };
    proto.traceXboxControlSeekCommandError = function(seekPosition, executionTimeMilliseconds, responseCode) {
        providerTemplates.traceTemplate_xfq(9, seekPosition, executionTimeMilliseconds, responseCode)
    };
    proto.isXboxBogusMediaStateMessageIgnoredEnabled = function() {
        return !!providerTemplates.eventEnabled(10)
    };
    proto.traceXboxBogusMediaStateMessageIgnored = function(position, transportState, positionBeforeLastSeek, lastSeekPosition) {
        providerTemplates.traceTemplate_xqxx(10, position, transportState, positionBeforeLastSeek, lastSeekPosition)
    };
    proto.isXboxGetMediaStateErrorEnabled = function() {
        return !!providerTemplates.eventEnabled(11)
    };
    proto.traceXboxGetMediaStateError = function(executionTimeMilliseconds, responseCode) {
        providerTemplates.traceTemplate_fq(11, executionTimeMilliseconds, responseCode)
    };
    proto.isXboxShowXboxControlsEnabled = function() {
        return !!providerTemplates.eventEnabled(12)
    };
    proto.traceXboxShowXboxControls = function() {
        providerTemplates.traceTemplateEventDescriptor(12)
    };
    proto.isXboxShowXboxControlsSetVisibleEnabled = function() {
        return !!providerTemplates.eventEnabled(13)
    };
    proto.traceXboxShowXboxControlsSetVisible = function() {
        providerTemplates.traceTemplateEventDescriptor(13)
    };
    proto.isXboxHideXboxControlsEnabled = function() {
        return !!providerTemplates.eventEnabled(14)
    };
    proto.traceXboxHideXboxControls = function() {
        providerTemplates.traceTemplateEventDescriptor(14)
    };
    proto.isXboxOnlinePresenceBeginEnabled = function() {
        return !!providerTemplates.eventEnabled(15)
    };
    proto.traceXboxOnlinePresenceBegin = function() {
        providerTemplates.traceTemplateEventDescriptor(15)
    };
    proto.isXboxOnlinePresenceReceivedEnabled = function() {
        return !!providerTemplates.eventEnabled(16)
    };
    proto.traceXboxOnlinePresenceReceived = function(titleId, mediaAssetId) {
        providerTemplates.traceTemplate_qz(16, titleId, mediaAssetId)
    };
    proto.isXboxOnlinePresenceErrorEnabled = function() {
        return !!providerTemplates.eventEnabled(17)
    };
    proto.traceXboxOnlinePresenceError = function(hResult, errorMessage) {
        providerTemplates.traceTemplate_dz(17, hResult, errorMessage)
    };
    proto.isXboxGetActiveTitleInformationBeginEnabled = function() {
        return !!providerTemplates.eventEnabled(18)
    };
    proto.traceXboxGetActiveTitleInformationBegin = function() {
        providerTemplates.traceTemplateEventDescriptor(18)
    };
    proto.isXboxGetActiveTitleInformationDoneEnabled = function() {
        return !!providerTemplates.eventEnabled(19)
    };
    proto.traceXboxGetActiveTitleInformationDone = function() {
        providerTemplates.traceTemplateEventDescriptor(19)
    };
    proto.isXboxGetActiveTitleInformationErrorEnabled = function() {
        return !!providerTemplates.eventEnabled(20)
    };
    proto.traceXboxGetActiveTitleInformationError = function(hResult, errorMessage) {
        providerTemplates.traceTemplate_dz(20, hResult, errorMessage)
    };
    proto.isXboxEstablishTitleChannelBeginEnabled = function() {
        return !!providerTemplates.eventEnabled(21)
    };
    proto.traceXboxEstablishTitleChannelBegin = function() {
        providerTemplates.traceTemplateEventDescriptor(21)
    };
    proto.isXboxEstablishTitleChannelDoneEnabled = function() {
        return !!providerTemplates.eventEnabled(22)
    };
    proto.traceXboxEstablishTitleChannelDone = function() {
        providerTemplates.traceTemplateEventDescriptor(22)
    };
    proto.isXboxEstablishTitleChannelErrorEnabled = function() {
        return !!providerTemplates.eventEnabled(23)
    };
    proto.traceXboxEstablishTitleChannelError = function(hResult, errorMessage) {
        providerTemplates.traceTemplate_dz(23, hResult, errorMessage)
    };
    proto.isXboxSendTouchPointsBeginEnabled = function() {
        return !!providerTemplates.eventEnabled(24)
    };
    proto.traceXboxSendTouchPointsBegin = function() {
        providerTemplates.traceTemplateEventDescriptor(24)
    };
    proto.isXboxSendTouchPointsDoneEnabled = function() {
        return !!providerTemplates.eventEnabled(25)
    };
    proto.traceXboxSendTouchPointsDone = function() {
        providerTemplates.traceTemplateEventDescriptor(25)
    };
    proto.isXboxSendTouchPointsErrorEnabled = function() {
        return !!providerTemplates.eventEnabled(26)
    };
    proto.traceXboxSendTouchPointsError = function(hResult, errorMessage) {
        providerTemplates.traceTemplate_dz(26, hResult, errorMessage)
    };
    proto.isXboxGetKeyboardBeginEnabled = function() {
        return !!providerTemplates.eventEnabled(27)
    };
    proto.traceXboxGetKeyboardBegin = function() {
        providerTemplates.traceTemplateEventDescriptor(27)
    };
    proto.isXboxGetKeyboardDoneEnabled = function() {
        return !!providerTemplates.eventEnabled(28)
    };
    proto.traceXboxGetKeyboardDone = function() {
        providerTemplates.traceTemplateEventDescriptor(28)
    };
    proto.isXboxGetKeyboardErrorEnabled = function() {
        return !!providerTemplates.eventEnabled(29)
    };
    proto.traceXboxGetKeyboardError = function(hResult, errorMessage) {
        providerTemplates.traceTemplate_dz(29, hResult, errorMessage)
    };
    proto.isXboxGetKeyboardStateBeginEnabled = function() {
        return !!providerTemplates.eventEnabled(30)
    };
    proto.traceXboxGetKeyboardStateBegin = function() {
        providerTemplates.traceTemplateEventDescriptor(30)
    };
    proto.isXboxGetKeyboardStateDoneEnabled = function() {
        return !!providerTemplates.eventEnabled(31)
    };
    proto.traceXboxGetKeyboardStateDone = function() {
        providerTemplates.traceTemplateEventDescriptor(31)
    };
    proto.isXboxGetKeyboardStateErrorEnabled = function() {
        return !!providerTemplates.eventEnabled(32)
    };
    proto.traceXboxGetKeyboardStateError = function(hResult, errorMessage) {
        providerTemplates.traceTemplate_dz(32, hResult, errorMessage)
    };
    proto.isXboxGetKeyboardTextBeginEnabled = function() {
        return !!providerTemplates.eventEnabled(33)
    };
    proto.traceXboxGetKeyboardTextBegin = function() {
        providerTemplates.traceTemplateEventDescriptor(33)
    };
    proto.isXboxGetKeyboardTextDoneEnabled = function() {
        return !!providerTemplates.eventEnabled(34)
    };
    proto.traceXboxGetKeyboardTextDone = function() {
        providerTemplates.traceTemplateEventDescriptor(34)
    };
    proto.isXboxGetKeyboardTextErrorEnabled = function() {
        return !!providerTemplates.eventEnabled(35)
    };
    proto.traceXboxGetKeyboardTextError = function(hResult, errorMessage) {
        providerTemplates.traceTemplate_dz(35, hResult, errorMessage)
    };
    proto.isXboxSetKeyboardTextBeginEnabled = function() {
        return !!providerTemplates.eventEnabled(36)
    };
    proto.traceXboxSetKeyboardTextBegin = function(text) {
        providerTemplates.traceTemplate_z(36, text)
    };
    proto.isXboxSetKeyboardTextDoneEnabled = function() {
        return !!providerTemplates.eventEnabled(37)
    };
    proto.traceXboxSetKeyboardTextDone = function() {
        providerTemplates.traceTemplateEventDescriptor(37)
    };
    proto.isXboxSetKeyboardTextErrorEnabled = function() {
        return !!providerTemplates.eventEnabled(38)
    };
    proto.traceXboxSetKeyboardTextError = function(hResult, errorMessage) {
        providerTemplates.traceTemplate_dz(38, hResult, errorMessage)
    };
    proto.isXboxSetKeyboardTextAndSelectionBeginEnabled = function() {
        return !!providerTemplates.eventEnabled(39)
    };
    proto.traceXboxSetKeyboardTextAndSelectionBegin = function(text, selectionStart, selectionLength) {
        providerTemplates.traceTemplate_zqq(39, text, selectionStart, selectionLength)
    };
    proto.isXboxSetKeyboardTextAndSelectionDoneEnabled = function() {
        return !!providerTemplates.eventEnabled(40)
    };
    proto.traceXboxSetKeyboardTextAndSelectionDone = function() {
        providerTemplates.traceTemplateEventDescriptor(40)
    };
    proto.isXboxSetKeyboardTextAndSelectionErrorEnabled = function() {
        return !!providerTemplates.eventEnabled(41)
    };
    proto.traceXboxSetKeyboardTextAndSelectionError = function(hResult, errorMessage) {
        providerTemplates.traceTemplate_dz(41, hResult, errorMessage)
    };
    proto.isXboxSendTitleMessageBeginEnabled = function() {
        return !!providerTemplates.eventEnabled(42)
    };
    proto.traceXboxSendTitleMessageBegin = function() {
        providerTemplates.traceTemplateEventDescriptor(42)
    };
    proto.isXboxSendTitleMessageDoneEnabled = function() {
        return !!providerTemplates.eventEnabled(43)
    };
    proto.traceXboxSendTitleMessageDone = function() {
        providerTemplates.traceTemplateEventDescriptor(43)
    };
    proto.isXboxSendTitleMessageErrorEnabled = function() {
        return !!providerTemplates.eventEnabled(44)
    };
    proto.traceXboxSendTitleMessageError = function(hResult, errorMessage) {
        providerTemplates.traceTemplate_dz(44, hResult, errorMessage)
    };
    proto.isXboxDisconnectSessionBeginEnabled = function() {
        return !!providerTemplates.eventEnabled(45)
    };
    proto.traceXboxDisconnectSessionBegin = function() {
        providerTemplates.traceTemplateEventDescriptor(45)
    };
    proto.isXboxDisconnectSessionDoneEnabled = function() {
        return !!providerTemplates.eventEnabled(46)
    };
    proto.traceXboxDisconnectSessionDone = function() {
        providerTemplates.traceTemplateEventDescriptor(46)
    };
    proto.isXboxDisconnectSessionErrorEnabled = function() {
        return !!providerTemplates.eventEnabled(47)
    };
    proto.traceXboxDisconnectSessionError = function(hResult, errorMessage) {
        providerTemplates.traceTemplate_dz(47, hResult, errorMessage)
    };
    proto.isXboxNewSessionObjectAssignedEnabled = function() {
        return !!providerTemplates.eventEnabled(48)
    };
    proto.traceXboxNewSessionObjectAssigned = function() {
        providerTemplates.traceTemplateEventDescriptor(48)
    };
    proto.isXboxSessionObjectReassignedEnabled = function() {
        return !!providerTemplates.eventEnabled(49)
    };
    proto.traceXboxSessionObjectReassigned = function() {
        providerTemplates.traceTemplateEventDescriptor(49)
    };
    proto.isXboxSessionObjectResetToNullEnabled = function() {
        return !!providerTemplates.eventEnabled(50)
    };
    proto.traceXboxSessionObjectResetToNull = function() {
        providerTemplates.traceTemplateEventDescriptor(50)
    };
    proto.isXboxTitleChangedEnabled = function() {
        return !!providerTemplates.eventEnabled(51)
    };
    proto.traceXboxTitleChanged = function(titleId) {
        providerTemplates.traceTemplate_q(51, titleId)
    };
    proto.isXboxTitleMessagingConfigChangedEnabled = function() {
        return !!providerTemplates.eventEnabled(52)
    };
    proto.traceXboxTitleMessagingConfigChanged = function(titleId, titlePort, enabled) {
        providerTemplates.traceTemplate_qqt(52, titleId, titlePort, enabled)
    };
    proto.isXboxTitleChannelStatusChangedEnabled = function() {
        return !!providerTemplates.eventEnabled(53)
    };
    proto.traceXboxTitleChannelStatusChanged = function(status, titleId, titlePort, hResult) {
        providerTemplates.traceTemplate_qqqd(53, status, titleId, titlePort, hResult)
    };
    proto.isXboxStreamingModeChangedEnabled = function() {
        return !!providerTemplates.eventEnabled(54)
    };
    proto.traceXboxStreamingModeChanged = function(clientExclusiveModeStatus, consoleExclusiveModeStatus) {
        providerTemplates.traceTemplate_qq(54, clientExclusiveModeStatus, consoleExclusiveModeStatus)
    };
    proto.isXboxLocalTransportStateChangedEnabled = function() {
        return !!providerTemplates.eventEnabled(55)
    };
    proto.traceXboxLocalTransportStateChanged = function(localTransportConnected) {
        providerTemplates.traceTemplate_t(55, localTransportConnected)
    };
    proto.isXboxSessionStatusChangedEnabled = function() {
        return !!providerTemplates.eventEnabled(56)
    };
    proto.traceXboxSessionStatusChanged = function(sessionState) {
        providerTemplates.traceTemplate_q(56, sessionState)
    };
    proto.isXboxAcquireExclusiveModeBeginEnabled = function() {
        return !!providerTemplates.eventEnabled(57)
    };
    proto.traceXboxAcquireExclusiveModeBegin = function() {
        providerTemplates.traceTemplateEventDescriptor(57)
    };
    proto.isXboxAcquireExclusiveModeDoneEnabled = function() {
        return !!providerTemplates.eventEnabled(58)
    };
    proto.traceXboxAcquireExclusiveModeDone = function() {
        providerTemplates.traceTemplateEventDescriptor(58)
    };
    proto.isXboxAcquireExclusiveModeErrorEnabled = function() {
        return !!providerTemplates.eventEnabled(59)
    };
    proto.traceXboxAcquireExclusiveModeError = function(hResult, errorMessage) {
        providerTemplates.traceTemplate_dz(59, hResult, errorMessage)
    };
    proto.isXboxHeartBeatPingErrorEnabled = function() {
        return !!providerTemplates.eventEnabled(60)
    };
    proto.traceXboxHeartBeatPingError = function(hResult, errorMessage, sessionState, isCurrentWinRTSessionReassigned, isCurrentWinRTSessionNull) {
        providerTemplates.traceTemplate_dzztt(60, hResult, errorMessage, sessionState, isCurrentWinRTSessionReassigned, isCurrentWinRTSessionNull)
    };
    proto.isXboxSessionConnectCallEnabled = function() {
        return !!providerTemplates.eventEnabled(61)
    };
    proto.traceXboxSessionConnectCall = function(sessionState, isRetry) {
        providerTemplates.traceTemplate_zt(61, sessionState, isRetry)
    };
    proto.isXboxLaunchTitleCallEnabled = function() {
        return !!providerTemplates.eventEnabled(62)
    };
    proto.traceXboxLaunchTitleCall = function(titleId, startTimeMilliseconds, firstAction) {
        providerTemplates.traceTemplate_qfz(62, titleId, startTimeMilliseconds, firstAction)
    };
    proto.isXboxReleaseExclusiveModeBeginEnabled = function() {
        return !!providerTemplates.eventEnabled(63)
    };
    proto.traceXboxReleaseExclusiveModeBegin = function() {
        providerTemplates.traceTemplateEventDescriptor(63)
    };
    proto.isXboxReleaseExclusiveModeDoneEnabled = function() {
        return !!providerTemplates.eventEnabled(64)
    };
    proto.traceXboxReleaseExclusiveModeDone = function() {
        providerTemplates.traceTemplateEventDescriptor(64)
    };
    proto.isXboxReleaseExclusiveModeErrorEnabled = function() {
        return !!providerTemplates.eventEnabled(65)
    };
    proto.traceXboxReleaseExclusiveModeError = function(hResult, errorMessage) {
        providerTemplates.traceTemplate_dz(65, hResult, errorMessage)
    }
})(this);
(function initMicrosoft_Zune_Providers(global) {
    var providerTemplates = null;
    var ns = global;
    if (ns.Diagnostics === undefined)
        ns.Diagnostics = {};
    var ns = ns.Diagnostics;
    if (ns.Tracing === undefined)
        ns.Tracing = {};
    var ns = ns.Tracing;
    if (ns.Microsoft === undefined)
        ns.Microsoft = {};
    var ns = ns.Microsoft;
    if (ns.Entertainment === undefined)
        ns.Entertainment = {};
    var ns = ns.Entertainment;
    if (ns.Instrumentation === undefined)
        ns.Instrumentation = {};
    var ns = ns.Instrumentation;
    if (ns.Providers === undefined)
        ns.Providers = {};
    var ns = ns.Providers;
    ns.Providers = function() {
        if (providerTemplates === null)
            providerTemplates = new global.Microsoft.Entertainment.Instrumentation.Providers.ProvidersTemplate
    };
    var proto = ns.Providers.prototype;
    proto.isAddMediaStartEnabled = function() {
        return !!providerTemplates.eventEnabled(0)
    };
    proto.traceAddMediaStart = function() {
        providerTemplates.traceTemplateEventDescriptor(0)
    };
    proto.isAddMediaEndEnabled = function() {
        return !!providerTemplates.eventEnabled(1)
    };
    proto.traceAddMediaEnd = function() {
        providerTemplates.traceTemplateEventDescriptor(1)
    };
    proto.isAddTrackStartEnabled = function() {
        return !!providerTemplates.eventEnabled(2)
    };
    proto.traceAddTrackStart = function() {
        providerTemplates.traceTemplateEventDescriptor(2)
    };
    proto.isAddTrackEndEnabled = function() {
        return !!providerTemplates.eventEnabled(3)
    };
    proto.traceAddTrackEnd = function() {
        providerTemplates.traceTemplateEventDescriptor(3)
    };
    proto.isAddAlbumAndFindTrackIdStartEnabled = function() {
        return !!providerTemplates.eventEnabled(4)
    };
    proto.traceAddAlbumAndFindTrackIdStart = function() {
        providerTemplates.traceTemplateEventDescriptor(4)
    };
    proto.isAddAlbumAndFindTrackIdEndEnabled = function() {
        return !!providerTemplates.eventEnabled(5)
    };
    proto.traceAddAlbumAndFindTrackIdEnd = function() {
        providerTemplates.traceTemplateEventDescriptor(5)
    };
    proto.isFindTrackIdAndAlbumBasedOnTrackSmidStartEnabled = function() {
        return !!providerTemplates.eventEnabled(6)
    };
    proto.traceFindTrackIdAndAlbumBasedOnTrackSmidStart = function() {
        providerTemplates.traceTemplateEventDescriptor(6)
    };
    proto.isFindTrackIdAndAlbumBasedOnTrackSmidEndEnabled = function() {
        return !!providerTemplates.eventEnabled(7)
    };
    proto.traceFindTrackIdAndAlbumBasedOnTrackSmidEnd = function() {
        providerTemplates.traceTemplateEventDescriptor(7)
    };
    proto.isAddAlbumAndFindTrackIdBasedOnMetadataStartEnabled = function() {
        return !!providerTemplates.eventEnabled(8)
    };
    proto.traceAddAlbumAndFindTrackIdBasedOnMetadataStart = function() {
        providerTemplates.traceTemplateEventDescriptor(8)
    };
    proto.isAddAlbumAndFindTrackIdBasedOnMetadataEndEnabled = function() {
        return !!providerTemplates.eventEnabled(9)
    };
    proto.traceAddAlbumAndFindTrackIdBasedOnMetadataEnd = function() {
        providerTemplates.traceTemplateEventDescriptor(9)
    };
    proto.isAddAudioAlbumStartEnabled = function() {
        return !!providerTemplates.eventEnabled(10)
    };
    proto.traceAddAudioAlbumStart = function() {
        providerTemplates.traceTemplateEventDescriptor(10)
    };
    proto.isAddAudioAlbumEndEnabled = function() {
        return !!providerTemplates.eventEnabled(11)
    };
    proto.traceAddAudioAlbumEnd = function() {
        providerTemplates.traceTemplateEventDescriptor(11)
    };
    proto.isFindArtistAndAlbumStartEnabled = function() {
        return !!providerTemplates.eventEnabled(12)
    };
    proto.traceFindArtistAndAlbumStart = function() {
        providerTemplates.traceTemplateEventDescriptor(12)
    };
    proto.isFindArtistAndAlbumEndEnabled = function() {
        return !!providerTemplates.eventEnabled(13)
    };
    proto.traceFindArtistAndAlbumEnd = function() {
        providerTemplates.traceTemplateEventDescriptor(13)
    };
    proto.isUpdateCurrentAudioAlbumStartEnabled = function() {
        return !!providerTemplates.eventEnabled(14)
    };
    proto.traceUpdateCurrentAudioAlbumStart = function() {
        providerTemplates.traceTemplateEventDescriptor(14)
    };
    proto.isUpdateCurrentAudioAlbumEndEnabled = function() {
        return !!providerTemplates.eventEnabled(15)
    };
    proto.traceUpdateCurrentAudioAlbumEnd = function() {
        providerTemplates.traceTemplateEventDescriptor(15)
    };
    proto.isAddPersonLinksStartEnabled = function() {
        return !!providerTemplates.eventEnabled(16)
    };
    proto.traceAddPersonLinksStart = function() {
        providerTemplates.traceTemplateEventDescriptor(16)
    };
    proto.isAddPersonLinksEndEnabled = function() {
        return !!providerTemplates.eventEnabled(17)
    };
    proto.traceAddPersonLinksEnd = function() {
        providerTemplates.traceTemplateEventDescriptor(17)
    };
    proto.isAddPersonStartEnabled = function() {
        return !!providerTemplates.eventEnabled(18)
    };
    proto.traceAddPersonStart = function() {
        providerTemplates.traceTemplateEventDescriptor(18)
    };
    proto.isAddPersonEndEnabled = function() {
        return !!providerTemplates.eventEnabled(19)
    };
    proto.traceAddPersonEnd = function() {
        providerTemplates.traceTemplateEventDescriptor(19)
    };
    proto.isAddPersonLinkStartEnabled = function() {
        return !!providerTemplates.eventEnabled(20)
    };
    proto.traceAddPersonLinkStart = function() {
        providerTemplates.traceTemplateEventDescriptor(20)
    };
    proto.isAddPersonLinkEndEnabled = function() {
        return !!providerTemplates.eventEnabled(21)
    };
    proto.traceAddPersonLinkEnd = function() {
        providerTemplates.traceTemplateEventDescriptor(21)
    };
    proto.isFindAndGetAudioTrackStartEnabled = function() {
        return !!providerTemplates.eventEnabled(22)
    };
    proto.traceFindAndGetAudioTrackStart = function() {
        providerTemplates.traceTemplateEventDescriptor(22)
    };
    proto.isFindAndGetAudioTrackEndEnabled = function() {
        return !!providerTemplates.eventEnabled(23)
    };
    proto.traceFindAndGetAudioTrackEnd = function() {
        providerTemplates.traceTemplateEventDescriptor(23)
    };
    proto.isUpdateCurrentTrackStartEnabled = function() {
        return !!providerTemplates.eventEnabled(24)
    };
    proto.traceUpdateCurrentTrackStart = function() {
        providerTemplates.traceTemplateEventDescriptor(24)
    };
    proto.isUpdateCurrentTrackEndEnabled = function() {
        return !!providerTemplates.eventEnabled(25)
    };
    proto.traceUpdateCurrentTrackEnd = function() {
        providerTemplates.traceTemplateEventDescriptor(25)
    };
    proto.isRecomputeAlbumReleaseYearStartEnabled = function() {
        return !!providerTemplates.eventEnabled(26)
    };
    proto.traceRecomputeAlbumReleaseYearStart = function() {
        providerTemplates.traceTemplateEventDescriptor(26)
    };
    proto.isRecomputeAlbumReleaseYearEndEnabled = function() {
        return !!providerTemplates.eventEnabled(27)
    };
    proto.traceRecomputeAlbumReleaseYearEnd = function() {
        providerTemplates.traceTemplateEventDescriptor(27)
    };
    proto.isAddTrackFileStartEnabled = function() {
        return !!providerTemplates.eventEnabled(28)
    };
    proto.traceAddTrackFileStart = function() {
        providerTemplates.traceTemplateEventDescriptor(28)
    };
    proto.isAddTrackFileEndEnabled = function() {
        return !!providerTemplates.eventEnabled(29)
    };
    proto.traceAddTrackFileEnd = function() {
        providerTemplates.traceTemplateEventDescriptor(29)
    };
    proto.isReflectTrackFilesStateStartEnabled = function() {
        return !!providerTemplates.eventEnabled(30)
    };
    proto.traceReflectTrackFilesStateStart = function() {
        providerTemplates.traceTemplateEventDescriptor(30)
    };
    proto.isReflectTrackFilesStateEndEnabled = function() {
        return !!providerTemplates.eventEnabled(31)
    };
    proto.traceReflectTrackFilesStateEnd = function() {
        providerTemplates.traceTemplateEventDescriptor(31)
    };
    proto.isAddFileStartEnabled = function() {
        return !!providerTemplates.eventEnabled(32)
    };
    proto.traceAddFileStart = function() {
        providerTemplates.traceTemplateEventDescriptor(32)
    };
    proto.isAddFileEndEnabled = function() {
        return !!providerTemplates.eventEnabled(33)
    };
    proto.traceAddFileEnd = function() {
        providerTemplates.traceTemplateEventDescriptor(33)
    };
    proto.isUpdateFileStartEnabled = function() {
        return !!providerTemplates.eventEnabled(34)
    };
    proto.traceUpdateFileStart = function() {
        providerTemplates.traceTemplateEventDescriptor(34)
    };
    proto.isUpdateFileEndEnabled = function() {
        return !!providerTemplates.eventEnabled(35)
    };
    proto.traceUpdateFileEnd = function() {
        providerTemplates.traceTemplateEventDescriptor(35)
    };
    proto.isAddFolderStartEnabled = function() {
        return !!providerTemplates.eventEnabled(36)
    };
    proto.traceAddFolderStart = function() {
        providerTemplates.traceTemplateEventDescriptor(36)
    };
    proto.isAddFolderEndEnabled = function() {
        return !!providerTemplates.eventEnabled(37)
    };
    proto.traceAddFolderEnd = function() {
        providerTemplates.traceTemplateEventDescriptor(37)
    };
    proto.isUpdatePlaylistContentsStartEnabled = function() {
        return !!providerTemplates.eventEnabled(38)
    };
    proto.traceUpdatePlaylistContentsStart = function() {
        providerTemplates.traceTemplateEventDescriptor(38)
    };
    proto.isUpdatePlaylistContentsEndEnabled = function() {
        return !!providerTemplates.eventEnabled(39)
    };
    proto.traceUpdatePlaylistContentsEnd = function() {
        providerTemplates.traceTemplateEventDescriptor(39)
    };
    proto.isFoundTrackBySmidEnabled = function() {
        return !!providerTemplates.eventEnabled(40)
    };
    proto.traceFoundTrackBySmid = function() {
        providerTemplates.traceTemplateEventDescriptor(40)
    };
    proto.isFoundTrackAndAlbumEnabled = function() {
        return !!providerTemplates.eventEnabled(41)
    };
    proto.traceFoundTrackAndAlbum = function(albumId, artistId, trackId) {
        providerTemplates.traceTemplate_qqq(41, albumId, artistId, trackId)
    };
    proto.isPromotingTrackArtistEnabled = function() {
        return !!providerTemplates.eventEnabled(42)
    };
    proto.tracePromotingTrackArtist = function(albumTitle) {
        providerTemplates.traceTemplate_z(42, albumTitle)
    };
    proto.isAlbumAsVariousArtistsEnabled = function() {
        return !!providerTemplates.eventEnabled(43)
    };
    proto.traceAlbumAsVariousArtists = function() {
        providerTemplates.traceTemplateEventDescriptor(43)
    };
    proto.isAddingAlbumEnabled = function() {
        return !!providerTemplates.eventEnabled(44)
    };
    proto.traceAddingAlbum = function(albumName) {
        providerTemplates.traceTemplate_z(44, albumName)
    };
    proto.isAddAlbumWithTitleArtistEnabled = function() {
        return !!providerTemplates.eventEnabled(45)
    };
    proto.traceAddAlbumWithTitleArtist = function(albumTitle, artistId) {
        providerTemplates.traceTemplate_zq(45, albumTitle, artistId)
    };
    proto.isUpdatingAlbumEnabled = function() {
        return !!providerTemplates.eventEnabled(46)
    };
    proto.traceUpdatingAlbum = function() {
        providerTemplates.traceTemplateEventDescriptor(46)
    };
    proto.isAddingPersonEnabled = function() {
        return !!providerTemplates.eventEnabled(47)
    };
    proto.traceAddingPerson = function(personName) {
        providerTemplates.traceTemplate_z(47, personName)
    };
    proto.isUpdatingPersonEnabled = function() {
        return !!providerTemplates.eventEnabled(48)
    };
    proto.traceUpdatingPerson = function(personName) {
        providerTemplates.traceTemplate_z(48, personName)
    };
    proto.isAddingPersonLinkEnabled = function() {
        return !!providerTemplates.eventEnabled(49)
    };
    proto.traceAddingPersonLink = function(personId, mediaId) {
        providerTemplates.traceTemplate_qq(49, personId, mediaId)
    };
    proto.isAddingTrackEntryEnabled = function() {
        return !!providerTemplates.eventEnabled(50)
    };
    proto.traceAddingTrackEntry = function(albumId, trackTitle, trackNumber) {
        providerTemplates.traceTemplate_qzq(50, albumId, trackTitle, trackNumber)
    };
    proto.isTrackIsAudioBookEnabled = function() {
        return !!providerTemplates.eventEnabled(51)
    };
    proto.traceTrackIsAudioBook = function() {
        providerTemplates.traceTemplateEventDescriptor(51)
    };
    proto.isFoundExistingTrackEnabled = function() {
        return !!providerTemplates.eventEnabled(52)
    };
    proto.traceFoundExistingTrack = function(trackId) {
        providerTemplates.traceTemplate_q(52, trackId)
    };
    proto.isAddingUnknownArtistEnabled = function() {
        return !!providerTemplates.eventEnabled(53)
    };
    proto.traceAddingUnknownArtist = function() {
        providerTemplates.traceTemplateEventDescriptor(53)
    };
    proto.isUpdateAlbumSetGenreEnabled = function() {
        return !!providerTemplates.eventEnabled(54)
    };
    proto.traceUpdateAlbumSetGenre = function(genreId) {
        providerTemplates.traceTemplate_q(54, genreId)
    };
    proto.isSetUnknownGenreEnabled = function() {
        return !!providerTemplates.eventEnabled(55)
    };
    proto.traceSetUnknownGenre = function() {
        providerTemplates.traceTemplateEventDescriptor(55)
    };
    proto.isAddingTrackEnabled = function() {
        return !!providerTemplates.eventEnabled(56)
    };
    proto.traceAddingTrack = function(trackName) {
        providerTemplates.traceTemplate_z(56, trackName)
    };
    proto.isUpdatingTrackEnabled = function() {
        return !!providerTemplates.eventEnabled(57)
    };
    proto.traceUpdatingTrack = function(trackName) {
        providerTemplates.traceTemplate_z(57, trackName)
    };
    proto.isSetTrackRatingFromFileEnabled = function() {
        return !!providerTemplates.eventEnabled(58)
    };
    proto.traceSetTrackRatingFromFile = function(trackTitle, rating) {
        providerTemplates.traceTemplate_zq(58, trackTitle, rating)
    };
    proto.isSplitExistingFileEnabled = function() {
        return !!providerTemplates.eventEnabled(59)
    };
    proto.traceSplitExistingFile = function(oldTrackId, newTrackId) {
        providerTemplates.traceTemplate_qq(59, oldTrackId, newTrackId)
    };
    proto.isAddingFolderEnabled = function() {
        return !!providerTemplates.eventEnabled(60)
    };
    proto.traceAddingFolder = function(folderPath) {
        providerTemplates.traceTemplate_z(60, folderPath)
    };
    proto.isAddingFileEnabled = function() {
        return !!providerTemplates.eventEnabled(61)
    };
    proto.traceAddingFile = function(filename) {
        providerTemplates.traceTemplate_z(61, filename)
    };
    proto.isUpdatingFileEnabled = function() {
        return !!providerTemplates.eventEnabled(62)
    };
    proto.traceUpdatingFile = function(filename) {
        providerTemplates.traceTemplate_z(62, filename)
    };
    proto.isUpdatingFileCountsEnabled = function() {
        return !!providerTemplates.eventEnabled(63)
    };
    proto.traceUpdatingFileCounts = function() {
        providerTemplates.traceTemplateEventDescriptor(63)
    };
    proto.isUpdateOldAlbumVisibilityEnabled = function() {
        return !!providerTemplates.eventEnabled(64)
    };
    proto.traceUpdateOldAlbumVisibility = function(albumId) {
        providerTemplates.traceTemplate_q(64, albumId)
    };
    proto.isUpdateAlbumVisibilityEnabled = function() {
        return !!providerTemplates.eventEnabled(65)
    };
    proto.traceUpdateAlbumVisibility = function(albumId) {
        providerTemplates.traceTemplate_q(65, albumId)
    };
    proto.isUpdatingTrackAcquisitionDateEnabled = function() {
        return !!providerTemplates.eventEnabled(66)
    };
    proto.traceUpdatingTrackAcquisitionDate = function(trackId) {
        providerTemplates.traceTemplate_q(66, trackId)
    };
    proto.isUpdatingAlbumAcquisitionDateEnabled = function() {
        return !!providerTemplates.eventEnabled(67)
    };
    proto.traceUpdatingAlbumAcquisitionDate = function(albumId) {
        providerTemplates.traceTemplate_q(67, albumId)
    };
    proto.isUpdatingPlaylistItemWithMediaIdEnabled = function() {
        return !!providerTemplates.eventEnabled(68)
    };
    proto.traceUpdatingPlaylistItemWithMediaId = function(playlistContentId, mediaId) {
        providerTemplates.traceTemplate_qq(68, playlistContentId, mediaId)
    }
})(this)
