﻿/* Copyright (C) Microsoft Corporation. All rights reserved. */
(function() {
    "use strict";
    scriptValidator("/Framework/corefx.js", "/Framework/debug.js", "/Framework/utilities.js");
    MS.Entertainment.UI.Debug.defineAssert("MS.Entertainment.UI.Controls");
    WinJS.Namespace.define("MS.Entertainment.UI.Controls", {ErrorDialog: MS.Entertainment.UI.Framework.defineUserControl("/Controls/ErrorDialog.html#errorDialogTemplate", function messageBoxConstructor(element, options) {
            this.webLinkText = String.load(String.id.IDS_DIALOG_ERROR_MORE_INFO);
            this.feedbackLinkText = String.load(String.id.IDS_DIALOG_ERROR_FEEDBACKLINK);
            if (WinJS.Utilities.getMember("MS.Entertainment.UI.App2.VoiceStatics"))
                this.webLinkVoiceConfidence = MS.Entertainment.UI.App2.VoiceStatics.defaultConfidence
        }, {
            webLinkPromise: null, _parentOverlay: null, initialize: function initialize() {
                    MS.Entertainment.UI.Controls.assert(this.errorDialogErrorCode, "Overlay: Element with data-ent-member='errorDialogErrorCode' not found");
                    if (!this.errorCode)
                        this.errorDialogErrorCode.style.visibility = "hidden";
                    if (!this.subTitle)
                        WinJS.Utilities.addClass(this.errorDialogDescription, "text-small")
                }, onFeedbackLinkClick: function onFeedbackLinkClick() {
                    MS.Entertainment.UI.Controls.UserFeedbackDialog.errorId = this.errorCode;
                    MS.Entertainment.UI.Controls.UserFeedbackDialog.timestamp = (new Date).toUTCString();
                    this._parentOverlay.hide();
                    MS.Entertainment.UI.Shell.showFeedbackDialog()
                }, onWebLinkClick: function onWebLinkClick(e) {
                    if (e && e.keyCode && !(e.keyCode === WinJS.Utilities.Key.enter || e.keyCode === WinJS.Utilities.Key.space))
                        return;
                    var webUrlPromise;
                    var onWeblinkPromiseClicked = function onWeblinkPromiseClicked(url) {
                            this._parentOverlay.hide();
                            window.open(url, "_blank");
                            MS.Entertainment.Utilities.Telemetry.logPageAction({domElement: this.webLinkContainer.parentElement}, {
                                uri: "errorDialogTemplate", pageTypeId: MS.Entertainment.Utilities.Telemetry.PageTypeId.Popup
                            }, {
                                uri: url, pageTypeId: MS.Entertainment.Utilities.Telemetry.PageTypeId.WebPage
                            })
                        }.bind(this);
                    MS.Entertainment.UI.Controls.assert(this.webLinkPromise, "webLinkPromise was null");
                    webUrlPromise = WinJS.Promise.as(this.webLinkPromise);
                    WinJS.Promise.timeout(500, webUrlPromise).done(onWeblinkPromiseClicked, onWeblinkPromiseClicked);
                    if (e.stopPropagation && e.preventDefault) {
                        e.stopPropagation();
                        e.preventDefault()
                    }
                }, setOverlay: function setOverlay(instance) {
                    this._parentOverlay = instance;
                    if (MS.Entertainment.Utilities.isApp2 && instance && instance.buttons) {
                        var newButtons = [];
                        newButtons.push({
                            title: String.load(String.id.IDS_DIALOG_ERROR_MORE_INFO_BUTTON_VUI_GUI), execute: this.onWebLinkClick.bind(this)
                        }, {
                            title: String.load(String.id.IDS_DIALOG_ERROR_FEEDBACKBUTTON_VUI_GUI), execute: this.onFeedbackLinkClick.bind(this)
                        });
                        instance.buttons = instance.buttons.concat(newButtons)
                    }
                }
        }, {
            subTitle: null, description: null, errorCode: null, webLinkText: null, feedbackLinkText: null, webLinkVoiceConfidence: 0.2, showLinks: true, showErrorCodeInContent: true
        })})
})()
