﻿/* Copyright (C) Microsoft Corporation. All rights reserved. */
scriptValidator();
(function() {
    "use strict";
    MS.Entertainment.UI.Debug.defineAssert("MS.Entertainment.UI.Controls");
    var _defaultGrouperItemThreshold = 80;
    WinJS.Namespace.define("MS.Entertainment.UI.Controls", {TemplateSelectorBase: MS.Entertainment.UI.Framework.define(function templateSelectorBase() {
            this._templates = {}
        }, {
            _templates: null, addTemplate: function addTemplate(type, template) {
                    if (!type)
                        throw new Error("Invalid template type given to addTemplate()");
                    var oldTemplate = this._templates[type];
                    if (oldTemplate && oldTemplate.promise && oldTemplate.innerTemplate !== template) {
                        oldTemplate.promise.cancel();
                        oldTemplate.promise = null;
                        oldTemplate.provider = null;
                        this._templates[type] = null
                    }
                    if (template && (!oldTemplate || oldTemplate.innerTemplate !== template))
                        this._templates[type] = {
                            innerTemplate: template, promise: null
                        }
                }, getTemplate: function getTemplate(type) {
                    if (!type)
                        throw new Error("Invalid template type given to getTemplate()");
                    var innerTemplate;
                    var template = this._templates[type];
                    if (template)
                        innerTemplate = template.innerTemplate;
                    return innerTemplate
                }, getTemplateProvider: function getTemplateProvider(type) {
                    if (!type)
                        throw new Error("Invalid template type given to getTemplateProvider()");
                    return this._getTemplateProvider(this._templates[type])
                }, _getTemplateProvider: function _getTemplateProvider(template) {
                    MS.Entertainment.UI.Controls.assert(template && template.innerTemplate, "Template for the given type appears to be invalid");
                    var promise;
                    if (template.provider)
                        promise = WinJS.Promise.as(template.provider);
                    else if (!template.promise)
                        if (String.isString(template.innerTemplate))
                            promise = template.promise = MS.Entertainment.UI.Framework.loadTemplate(template.innerTemplate, null, true).then(function(provider) {
                                template.provider = provider;
                                return provider
                            });
                        else
                            promise = WinJS.Promise.as(template.innerTemplate.winControl);
                    else if (template.promise)
                        promise = template.promise;
                    else
                        promise = WinJS.Promise.as();
                    return promise
                }, selectTemplate: function selectTemplate(item, templateTypeHint) {
                    return this.onSelectTemplate(item, templateTypeHint)
                }, onSelectTemplate: function onSelectTemplate(item, templateTypeHint) {
                    templateTypeHint = templateTypeHint || MS.Entertainment.UI.Controls.TemplateSelectorBase.templateType.item;
                    return this.getTemplateProvider(templateTypeHint)
                }, ensureTemplatesLoaded: function ensureTemplatesLoaded(templates) {
                    var promises = [];
                    var item;
                    if (templates)
                        templates.forEach(function(item) {
                            var template = this._templates[item];
                            var promise;
                            if (template)
                                promise = this._getTemplateProvider(template);
                            if (promise)
                                promises.push(promise)
                        }, this);
                    return WinJS.Promise.join(promises)
                }
        }, {templateType: {
                action: "action", emptyGallery: "emptyGallery", item: "item", header: "header", panel: "panel", snappedItem: "snappedItem", unsnappedItem: "unsnappedItem", userGatedGallery: "userGatedGallery", syncScreen: "syncScreen", zoomedOut: "zoomedOut"
            }})});
    WinJS.Namespace.define("MS.Entertainment.UI.Controls", {
        TemplateType: MS.Entertainment.UI.Framework.lazyDefine(function() {
            return {
                    action: MS.Entertainment.UI.Controls.TemplateSelectorBase.templateType.action, emptyGallery: MS.Entertainment.UI.Controls.TemplateSelectorBase.templateType.emptyGallery, item: MS.Entertainment.UI.Controls.TemplateSelectorBase.templateType.item, header: MS.Entertainment.UI.Controls.TemplateSelectorBase.templateType.header, panel: MS.Entertainment.UI.Controls.TemplateSelectorBase.templateType.panel, snappedItem: MS.Entertainment.UI.Controls.TemplateSelectorBase.templateType.snappedItem, unsnappedItem: MS.Entertainment.UI.Controls.TemplateSelectorBase.templateType.unsnappedItem, userGatedGallery: MS.Entertainment.UI.Controls.TemplateSelectorBase.templateType.userGatedGallery, syncScreen: MS.Entertainment.UI.Controls.TemplateSelectorBase.templateType.syncScreen, zoomedOut: MS.Entertainment.UI.Controls.TemplateSelectorBase.templateType.zoomedOut
                }
        }), GalleryTemplateSelector: MS.Entertainment.UI.Framework.derive("MS.Entertainment.UI.Controls.TemplateSelectorBase", function galleryTemplateSelector() {
                MS.Entertainment.UI.Controls.TemplateSelectorBase.prototype.constructor.call(this)
            }, {
                ensureItemTemplatesLoaded: function ensureItemTemplatesLoaded() {
                    return this.ensureTemplatesLoaded([MS.Entertainment.UI.Controls.TemplateSelectorBase.templateType.item, MS.Entertainment.UI.Controls.TemplateSelectorBase.templateType.header, ])
                }, onSelectTemplate: function onSelectTemplate(item) {
                        if (item.isHeader)
                            return this.getTemplateProvider(MS.Entertainment.UI.Controls.TemplateSelectorBase.templateType.header);
                        else if (item.isAction)
                            return this.getTemplateProvider(MS.Entertainment.UI.Controls.TemplateSelectorBase.templateType.action);
                        else
                            return MS.Entertainment.UI.Controls.TemplateSelectorBase.prototype.onSelectTemplate.apply(this, arguments)
                    }, getPanelTemplatePath: function getPanelTemplatePath(item) {
                        MS.Entertainment.UI.Controls.assert(this._templates[MS.Entertainment.UI.Controls.TemplateSelectorBase.templateType.panel], "template not defined");
                        var panelPath;
                        var panelTemplate = this._templates[MS.Entertainment.UI.Controls.TemplateSelectorBase.templateType.panel];
                        if (panelTemplate && typeof panelTemplate.innerTemplate === "string")
                            panelPath = panelTemplate.innerTemplate;
                        return panelPath
                    }
            }), GalleryListDataNotificationHandler: MS.Entertainment.UI.Framework.define(function galleryListDataNotificationHandler(updateCallback) {
                this._updateCallback = updateCallback
            }, {
                countThreshold: NaN, _updateCallback: null, _updating: false, _pendingChanges: null, _pendingCountChange: null, _panelSelected: false, _minimumListLength: 1, minimumListLength: {
                        get: function get_minimumListLength() {
                            return this._minimumListLength
                        }, set: function set_minimumListLength(value) {
                                if (this._minimumListLength !== value) {
                                    this._minimumListLength = value;
                                    this.countChanged()
                                }
                            }
                    }, _pushChange: function _pushChange(change) {
                        this._pendingChanges = this._pendingChanges || [];
                        if (this._pendingChanges.indexOf(change) < 0)
                            this._pendingChanges.push(change)
                    }, _updateGallery: function _updateGallery() {
                        if (!this._updating && this._pendingChanges && this._pendingChanges.length) {
                            var changes = this._pendingChanges;
                            this._pendingChanges = null;
                            this._pendingCountChange = null;
                            this._updateCallback(changes)
                        }
                    }, dispose: function dispose() {
                        this._updateCallback = null
                    }, beginNotifications: function beginNotifications() {
                        this._updating = true
                    }, inserted: function inserted(itemPromise, previousHandle, nextHandle){}, changed: function changed(newItem, oldItem){}, moved: function moved(itemPromise, previousHandle, nextHandle){}, removed: function removed(handle, mirage){}, countChanged: function countChanged(newCount, oldCount) {
                        if (oldCount === "unknown")
                            oldCount = 0;
                        if (this._pendingCountChange)
                            this._pendingCountChange.newValue = newCount;
                        else
                            this._pendingCountChange = {
                                type: MS.Entertainment.UI.Controls.GalleryListDataNotificationHandler.UpdateType.countChanged, newValue: newCount, oldValue: oldCount, passedThreshold: false
                            };
                        if (this._passedThreshold(newCount, oldCount, this.minimumListLength) || this._passedThreshold(newCount, oldCount, this.countThreshold))
                            this._pendingCountChange.passedThreshold = true;
                        this._pushChange(this._pendingCountChange);
                        this._updateGallery()
                    }, endNotifications: function endNotifications() {
                        this._updating = false;
                        this._updateGallery()
                    }, reload: function reload() {
                        this._pushChange({type: MS.Entertainment.UI.Controls.GalleryListDataNotificationHandler.UpdateType.reload});
                        this._updateGallery()
                    }, _passedThreshold: function(newCount, oldCount, threshold) {
                        return ((newCount >= threshold) && (oldCount < threshold)) || ((oldCount >= threshold) && (newCount < threshold))
                    }
            }, {UpdateType: {
                    countChanged: "countChanged", reload: "reload"
                }}), GalleryControlDoubleClickHelper: MS.Entertainment.UI.Framework.derive("MS.Entertainment.UI.Framework.ObservableBase", function galleryControlDoubleClickHelper(galleryControl) {
                this._galleryControl = galleryControl
            }, {
                _appBarServiceStorage: null, _item: null, _index: -1, _invokePromise: null, _mediaContext: null, _playButton: null, _smartBuyStateEngine: null, _appBarService: {get: function get_appBarService() {
                            if (!this._appBarServiceStorage)
                                this._appBarServiceStorage = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.appToolbar);
                            return this._appBarServiceStorage
                        }}, _getData: function _getData() {
                        var data = this._item;
                        var key;
                        if (!data)
                            return;
                        key = data.key;
                        data = data.data || data;
                        return MS.Entertainment.ViewModels.MediaItemModel.hydrateLibraryInfoAsync(data).then(function mediaItemHydrated(mediaItem) {
                                var containingMedia = this.getContainingMedia(key);
                                this.clear();
                                this._mediaContext = this._appBarService.pushMediaContext(mediaItem, [], [], {
                                    executeLocation: MS.Entertainment.UI.Actions.ExecutionLocation.invokeInline, galleryControl: this._galleryControl, containingMedia: containingMedia, invokedIndex: key
                                });
                                this._mediaContext.collectionFilter = (this._galleryControl.mediaContext && this._galleryControl.mediaContext.collectionFilter) || Microsoft.Entertainment.Platform.MediaAvailability.available;
                                this._smartBuyStateEngine = new MS.Entertainment.ViewModels.SmartBuyStateEngine;
                                var buttons = MS.Entertainment.ViewModels.SmartBuyButtons.getTrackInlineDetailsButtons(this._mediaContext);
                                var handler = MS.Entertainment.ViewModels.MusicStateHandlers.onTrackInlineDetailsStateChanged;
                                this._smartBuyStateEngine.initialize(mediaItem, buttons, handler);
                                this._playButton = buttons.doubleClick;
                                if (data.hydrate && !data.hydrated) {
                                    var options = {collectionFilter: this._mediaContext && this._mediaContext.collectionFilter};
                                    data.hydrate(options).done(null, function(){})
                                }
                                return mediaItem
                            }.bind(this))
                    }, getContainingMedia: function getContainingMedia(key) {
                        var containingMedia = null;
                        if (this._galleryControl.mediaContext && this._galleryControl.mediaContext.containingMedia && this._galleryControl.dataSource) {
                            if (this._galleryControl.mediaContext.containingMedia.copy)
                                containingMedia = this._galleryControl.mediaContext.containingMedia.copy();
                            else
                                containingMedia = {
                                    playbackItemSource: this._galleryControl.mediaContext.containingMedia.playbackItemSource, dontUseTrackListForPlayback: this._galleryControl.mediaContext.containingMedia.dontUseTrackListForPlayback
                                };
                            containingMedia.playbackKey = key;
                            containingMedia.playbackOffset = this._galleryControl.dataSource.indexToSourceIndex ? this._galleryControl.dataSource.indexToSourceIndex(this._index) : this._index
                        }
                        return containingMedia
                    }, clear: function clear() {
                        if (this._smartBuyStateEngine) {
                            this._smartBuyStateEngine.unload();
                            this._smartBuyStateEngine = null
                        }
                        if (this._mediaContext) {
                            this._mediaContext.clearContext();
                            this._mediaContext = null
                        }
                    }, execute: function execute() {
                        this._getData().done(function gotData(data) {
                            this._playButton.execute()
                        }.bind(this), function ignoreError(error) {
                            MS.Entertainment.UI.Controls.fail("Failed to get data for double-click. error: " + (error && error.message))
                        })
                    }, wrapItemInvoke: function wrapItemInvoke(event, data) {
                        this._item = data;
                        this._index = event.detail.itemIndex;
                        this._invokePromise = WinJS.Promise.timeout();
                        this._invokePromise.then(function onComplete(complete) {
                            if (this._invokePromise) {
                                var invocationHelper = this._galleryControl.invocationHelper;
                                if (invocationHelper)
                                    invocationHelper.invokeItem(event, data);
                                this._invokePromise = null
                            }
                        }.bind(this), function onError(error) {
                            this._invokePromise = null
                        }.bind(this))
                    }
            }, {create: WinJS.Utilities.markSupportedForProcessing(function create(galleryControl) {
                    return new MS.Entertainment.UI.Controls.GalleryControlDoubleClickHelper(galleryControl)
                })}), GalleryControlInvocationHelper: MS.Entertainment.UI.Framework.derive("MS.Entertainment.UI.Framework.ObservableBase", function galleryControlInvocationHelper(galleryControl) {
                this._galleryControl = galleryControl;
                this._smartButtonCallbacks = [];
                this._createActionExecuteCallbacks()
            }, {
                _smartButtonCallbacks: null, _createActionExecuteCallbacks: function _createActionExecuteCallbacks() {
                        var clearInvocation = this.clearInvocation.bind(this);
                        this.addInvocationHandlers({
                            deleteMedia: clearInvocation, removeFromList: clearInvocation, exploreAlbum: clearInvocation
                        })
                    }, _mediaContext: null, _appBarServiceStorage: null, _appBarService: {get: function get_appBarService() {
                            if (!this._appBarServiceStorage)
                                this._appBarServiceStorage = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.appToolbar);
                            return this._appBarServiceStorage
                        }}, _galleryControl: null, _invokedItem: null, _shareOperation: null, _smartBuyStateEngine: null, _smartStateEngineBindings: null, _delayedActions: null, _currentInvokePromise: null, _pendingInvokeEvent: null, addInvocationHandlers: function addInvocationHandlers(handlers) {
                        this._smartButtonCallbacks = this._smartButtonCallbacks || [];
                        this._smartButtonCallbacks.push(handlers)
                    }, dispose: function dispose() {
                        this.clearInvocation();
                        this._galleryControl = null
                    }, invokedItem: {get: function() {
                            return this._invokedItem
                        }}, invokedKey: {get: function() {
                            return this.invokedItem ? this.invokedItem.key : null
                        }}, invokedIndex: {get: function() {
                            var result;
                            if (this._galleryControl && this._galleryControl.dataSource && this._galleryControl.dataSource.indexFromKey)
                                result = this._galleryControl.dataSource.indexFromKey(this.invokedKey);
                            else if (this.invokedItem)
                                result = this.invokedItem.itemIndex;
                            if (isNaN(result))
                                result = -1;
                            return result
                        }}, _setInvokedItem: function _setInvokedItem(value) {
                        if (this._invokedItem !== value) {
                            var oldValue = this._invokedItem;
                            this._invokedItem = value;
                            this.dispatchChangeAndNotify("invokedItem", value, oldValue)
                        }
                    }, invokeItem: function invokeItem(invocationEvent, eventData) {
                        if (!invocationEvent || !invocationEvent.srcElement || !invocationEvent.detail)
                            return;
                        this._pendingInvokeEvent = invocationEvent;
                        var getDataObject;
                        var invokedItem = {
                                srcElement: invocationEvent.srcElement, itemIndex: invocationEvent.detail.itemIndex
                            };
                        if (!invocationEvent.detail.rerender && WinJS.Utilities.hasClass(invokedItem.srcElement, "invoked")) {
                            this._clearInvokedAttributes(invokedItem.srcElement);
                            this.clearInvocation()
                        }
                        else {
                            this._setInvokedAttributes(invokedItem.srcElement);
                            if (eventData)
                                getDataObject = WinJS.Promise.wrap(eventData);
                            else if (invocationEvent.detail.itemPromise)
                                getDataObject = invocationEvent.detail.itemPromise;
                            else
                                getDataObject = this._galleryControl.getItemAtIndex(invocationEvent.detail.itemIndex)
                        }
                        if (this._currentInvokePromise) {
                            this._currentInvokePromise.cancel();
                            this._currentInvokePromise = null
                        }
                        if (getDataObject)
                            this._currentInvokePromise = getDataObject.then(function getItemsLibraryId(data) {
                                if (this._pendingInvokeEvent !== invocationEvent)
                                    return;
                                var key = data.key;
                                var itemData = data.data || data;
                                var promise;
                                if (this._clearInvocationIfNeeded(itemData, key)) {
                                    MS.Entertainment.ViewModels.MediaItemModel.augment(itemData);
                                    promise = MS.Entertainment.ViewModels.MediaItemModel.hydrateLibraryInfoAsync(itemData).then(function() {
                                        return data
                                    })
                                }
                                else if (invokedItem.srcElement !== this.invokedItem.srcElement) {
                                    if (this.invokedItem && this.invokedItem.srcElement)
                                        this._clearInvokedAttributes(this.invokedItem.srcElement);
                                    this.invokedItem.srcElement = invokedItem.srcElement
                                }
                                return promise || WinJS.Promise.wrap(data)
                            }.bind(this)).then(function getItemData(data) {
                                if (this._pendingInvokeEvent !== invocationEvent)
                                    return;
                                var key;
                                if (data) {
                                    key = data.key;
                                    data = data.data || data
                                }
                                if (data) {
                                    this._smartBuyStateEngine = new MS.Entertainment.ViewModels.SmartBuyStateEngine;
                                    this._setupSmartButtons(data, invocationEvent.detail.itemIndex, key);
                                    MS.Entertainment.UI.Controls.assert(!data.smartBuyStateEngine, "We do not expect this property to be set already.");
                                    if (data.eventProxy)
                                        this._smartBuyStateEngine.eventProxy = data.eventProxy;
                                    else
                                        data.addProperty("smartBuyStateEngine", this._smartBuyStateEngine);
                                    MS.Entertainment.UI.Controls.UserFeedbackDialog.inlineDetailsItem = data;
                                    this._shareModel(data);
                                    invokedItem.data = data;
                                    invokedItem.key = key;
                                    this._setInvokedItem(invokedItem);
                                    return WinJS.Promise.timeout(MS.Entertainment.UI.Controls.GalleryControlInvocationHelper.actionDelayMs).then(function() {
                                            return data
                                        })
                                }
                            }.bind(this)).then(function delayedActions(data) {
                                if (this._pendingInvokeEvent !== invocationEvent)
                                    return;
                                if (data) {
                                    if (data.hydrate && !data.hydrated) {
                                        var options = {collectionFilter: this._mediaContext && this._mediaContext.collectionFilter};
                                        data.hydrate(options).done(null, function(){})
                                    }
                                    this._smartStateEngineBindings = WinJS.Binding.bind(this._smartBuyStateEngine, {currentAppbarActions: this._setAppbarActions.bind(this)})
                                }
                                this._pendingInvokeEvent = null
                            }.bind(this), function delayedActions_Error() {
                                if (this._pendingInvokeEvent !== invocationEvent)
                                    return;
                                this._pendingInvokeEvent = null
                            }.bind(this))
                    }, _setAppbarActions: function _setAppbarActions(newValue, oldValue) {
                        if ((this._smartStateEngineBindings || (oldValue === undefined && !this._smartStateEngineBindings)) && this._mediaContext)
                            this._mediaContext.setToolbarActions(this._smartBuyStateEngine.currentAppbarActions)
                    }, _toggleOffIfNeeded: function _toggleOffIfNeeded(newKey) {
                        var toggledOff = false;
                        if (this.invokedItem && this.invokedItem.key === newKey && newKey) {
                            this.clearInvocation();
                            toggledOff = true
                        }
                        return toggledOff
                    }, _setInvokedAttributes: function _setInvokedAttributes(element) {
                        WinJS.Utilities.addClass(element, "invoked");
                        WinJS.Promise.timeout(750).done(function updateFocus() {
                            var actionList = element.querySelector(".inPlaceDetailsItemActions");
                            if (actionList && document.activeElement === element) {
                                var firstButton = actionList.querySelector(".iconButton");
                                if (firstButton)
                                    MS.Entertainment.UI.Framework.focusElement(firstButton)
                            }
                        })
                    }, _clearInvokedAttributes: function _clearInvokedAttributes(element) {
                        WinJS.Utilities.removeClass(element, "invoked")
                    }, _clearInvocationIfNeeded: function _clearInvocationIfNeeded(newData, newKey) {
                        var cleared = true;
                        if (this.invokedItem)
                            if (newData && this.invokedItem.data === newData && newKey && this.invokedItem.key === newKey)
                                cleared = false;
                            else
                                this.clearInvocation();
                        return cleared
                    }, clearInvocation: function clearInvocation() {
                        if (this._currentInvokePromise) {
                            this._currentInvokePromise.cancel();
                            this._currentInvokePromise = null
                        }
                        if (this.invokedItem) {
                            this._clearInvokedAttributes(this.invokedItem.srcElement);
                            WinJS.Utilities.removeClass(this.invokedItem.srcElement, "win-pressed");
                            if (this.invokedItem.data) {
                                MS.Entertainment.UI.Controls.UserFeedbackDialog.inlineDetailsItem = null;
                                this.invokedItem.data.smartBuyStateEngine = null
                            }
                            this._setInvokedItem(null)
                        }
                        this._unshareModel();
                        if (this._delayedActions) {
                            this._delayedActions.cancel();
                            this._delayedActions = null
                        }
                        if (this._smartBuyStateEngine) {
                            this._smartBuyStateEngine.unload();
                            this._smartBuyStateEngine = null
                        }
                        if (this._smartStateEngineBindings) {
                            this._smartStateEngineBindings.cancel();
                            this._smartStateEngineBindings = null
                        }
                        if (this._mediaContext) {
                            this._mediaContext.clearContext();
                            this._mediaContext = null
                        }
                    }, _setupSmartButtons: function _setupSmartButtons(mediaItem, index, key) {
                        if (mediaItem && (mediaItem.mediaType === Microsoft.Entertainment.Queries.ObjectType.track || MS.Entertainment.Platform.PlaybackHelpers.isMusicVideo(mediaItem))) {
                            MS.Entertainment.UI.Controls.assert(MS.Entertainment.Utilities.isMusicApp, "This code should only get called in the music app");
                            var containingMedia = null;
                            if (this._galleryControl.mediaContext && this._galleryControl.mediaContext.containingMedia && this._galleryControl.dataSource) {
                                if (this._galleryControl.mediaContext.containingMedia.copy)
                                    containingMedia = this._galleryControl.mediaContext.containingMedia.copy();
                                else
                                    containingMedia = {
                                        playbackItemSource: this._galleryControl.mediaContext.containingMedia.playbackItemSource, dontUseTrackListForPlayback: this._galleryControl.mediaContext.containingMedia.dontUseTrackListForPlayback
                                    };
                                containingMedia.playbackKey = key;
                                containingMedia.playbackOffset = this._galleryControl.dataSource.indexToSourceIndex ? this._galleryControl.dataSource.indexToSourceIndex(index) : index
                            }
                            if (this._mediaContext) {
                                this._mediaContext.clearContext();
                                this._mediaContext = null
                            }
                            var hydratePromise = WinJS.Promise.as();
                            if (MS.Entertainment.Platform.PlaybackHelpers.isMusicVideo(mediaItem))
                                hydratePromise = mediaItem.hydrate({forceUpdate: mediaItem.fromCollection});
                            hydratePromise.done(function setMediaContext() {
                                this._mediaContext = this._appBarService.pushMediaContext(mediaItem, this._smartButtonCallbacks, [], {
                                    executeLocation: MS.Entertainment.UI.Actions.ExecutionLocation.invokeInline, galleryControl: this._galleryControl, containingMedia: containingMedia, invokedIndex: index
                                });
                                this._mediaContext.collectionFilter = (this._galleryControl.mediaContext && this._galleryControl.mediaContext.collectionFilter) || Microsoft.Entertainment.Platform.MediaAvailability.available;
                                if (MS.Entertainment.Platform.PlaybackHelpers.isMusicTrack(mediaItem))
                                    this._smartBuyStateEngine.initialize(mediaItem, MS.Entertainment.ViewModels.SmartBuyButtons.getTrackInlineDetailsButtons(this._mediaContext), MS.Entertainment.ViewModels.MusicStateHandlers.onTrackInlineDetailsStateChanged);
                                else if (MS.Entertainment.Platform.PlaybackHelpers.isMusicVideo(mediaItem))
                                    this._smartBuyStateEngine.initialize(mediaItem, MS.Entertainment.ViewModels.SmartBuyButtons.getMusicVideoInlineDetailsButtons(this._mediaContext), MS.Entertainment.ViewModels.MusicStateHandlers.onMusicVideoInlineDetailsStateChanged)
                            }.bind(this))
                        }
                        else if (mediaItem.mediaType === Microsoft.Entertainment.Queries.ObjectType.video);
                        else
                            MS.Entertainment.UI.Controls.assert(false, "unexpected mediaType in inline buttons.")
                    }, _shareModel: function _shareModel(media) {
                        var sender = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.shareSender);
                        if (media) {
                            this._unshareModel();
                            try {
                                this._shareOperation = sender.pendingShare(media)
                            }
                            catch(e) {
                                this._shareOperation = null
                            }
                        }
                    }, _unshareModel: function _unshareModel() {
                        if (this._shareOperation) {
                            this._shareOperation.cancel();
                            this._shareOperation = null
                        }
                    }
            }, {
                create: WinJS.Utilities.markSupportedForProcessing(function create(galleryControl) {
                    return new MS.Entertainment.UI.Controls.GalleryControlInvocationHelper(galleryControl)
                }), actionDelayMs: 300
            })
    });
    WinJS.Namespace.define("MS.Entertainment.UI.Controls", {
        TrackGalleryControlInvocationHelper: MS.Entertainment.UI.Framework.derive("MS.Entertainment.UI.Controls.GalleryControlInvocationHelper", function trackGalleryControlInvocationHelper(galleryControl) {
            MS.Entertainment.UI.Controls.GalleryControlInvocationHelper.prototype.constructor.apply(this, arguments)
        }, {
            album: null, _setupSmartButtons: function _setupSmartButtons(mediaItem, index, key) {
                    if (mediaItem && this.album && "album" in mediaItem)
                        mediaItem.album = this.album;
                    MS.Entertainment.UI.Controls.GalleryControlInvocationHelper.prototype._setupSmartButtons.apply(this, arguments)
                }
        }, {createTrackHelper: WinJS.Utilities.markSupportedForProcessing(function createTrackHelper(galleryControl) {
                return new MS.Entertainment.UI.Controls.TrackGalleryControlInvocationHelper(galleryControl)
            })}), SmartDJGalleryControlInvocationHelper: MS.Entertainment.UI.Framework.derive("MS.Entertainment.UI.Controls.GalleryControlInvocationHelper", function SmartDJGalleryControlInvocationHelper(galleryControl) {
                MS.Entertainment.UI.Controls.GalleryControlInvocationHelper.prototype.constructor.apply(this, arguments)
            }, {invokeItem: function invokeItem(invocationEvent, eventData) {
                    var getDataPromise;
                    var invokedItem = {
                            srcElement: invocationEvent.srcElement, itemIndex: invocationEvent.detail.itemIndex
                        };
                    if (eventData)
                        getDataPromise = WinJS.Promise.wrap(eventData);
                    else if (invocationEvent.detail.itemPromise)
                        getDataPromise = invocationEvent.detail.itemPromise;
                    else
                        getDataPromise = this._galleryControl.getItemAtIndex(invocationEvent.detail.itemIndex);
                    MS.Entertainment.UI.Controls.assert(getDataPromise, "cannot obtain invoked object");
                    getDataPromise.done(function getItemData(data) {
                        var key = data.key;
                        data = data.data || data;
                        if (invokedItem.srcElement === invocationEvent.srcElement) {
                            var _actionService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.actions);
                            var action = _actionService.getAction(MS.Entertainment.UI.Actions.ActionIdentifiers.playSmartDJ);
                            action.automationId = MS.Entertainment.UI.AutomationIds.galleryPlaySmartDJ;
                            action.parameter = {
                                mediaItem: data, showAppBar: true
                            };
                            if (invokedItem.srcElement)
                                MS.Entertainment.Utilities.Telemetry.logPageAction({
                                    itemPropertyBag: data, domElement: invokedItem.srcElement
                                }, {
                                    uri: MS.Entertainment.Utilities.getCurrentUserLocation(), pageTypeId: MS.Entertainment.Utilities.Telemetry.PageTypeId.SmartDJ
                                });
                            action.execute()
                        }
                    }.bind(this), function getItemDataFailed() {
                        MS.Entertainment.UI.Controls.assert(getDataPromise, "cannot find invoked data")
                    }.bind(this))
                }}, {createSmartDJHelper: WinJS.Utilities.markSupportedForProcessing(function createSmartDJHelper(galleryControl) {
                    return new MS.Entertainment.UI.Controls.SmartDJGalleryControlInvocationHelper(galleryControl)
                })}), SearchDetailsInvocationHelper: MS.Entertainment.UI.Framework.derive("MS.Entertainment.UI.Controls.GalleryControlInvocationHelper", function searchDetailsInvocationHelper(galleryControl) {
                MS.Entertainment.UI.Controls.GalleryControlInvocationHelper.prototype.constructor.apply(this, arguments)
            }, {invokeItem: function invokeItem(invocationEvent, eventData) {
                    var invokedItem = eventData.data;
                    if (invokedItem.mediaType === Microsoft.Entertainment.Queries.ObjectType.track)
                        MS.Entertainment.UI.Controls.GalleryControlInvocationHelper.prototype.invokeItem.apply(this, arguments);
                    else {
                        var popOverParameters = this._galleryControl.createPopOverParameters(eventData);
                        MS.Entertainment.Platform.PlaybackHelpers.showItemDetails(popOverParameters)
                    }
                }}, {create: WinJS.Utilities.markSupportedForProcessing(function create(galleryControl) {
                    return new MS.Entertainment.UI.Controls.SearchDetailsInvocationHelper(galleryControl)
                })}), SearchHorizontalDetailsInvocationHelper: MS.Entertainment.UI.Framework.derive("MS.Entertainment.UI.Controls.GalleryControlInvocationHelper", function searchHorizontalDetailsInvocationHelper(galleryControl) {
                MS.Entertainment.UI.Controls.GalleryControlInvocationHelper.prototype.constructor.apply(this, arguments)
            }, {invokeItem: function invokeItem(invocationEvent, eventData) {
                    var contentRestrictionService = null;
                    var contentRestrictionBrowsePolicyUpdatePromise = WinJS.Promise.as();
                    if (MS.Entertainment.ServiceLocator.isServiceRegistered(MS.Entertainment.Services.contentRestrictionService)) {
                        contentRestrictionService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.contentRestrictionService);
                        contentRestrictionBrowsePolicyUpdatePromise = contentRestrictionService.getBrowsePolicyUpdatePromise()
                    }
                    contentRestrictionBrowsePolicyUpdatePromise.done(function invokeItem() {
                        if (contentRestrictionService && contentRestrictionService.hasBrowseFilterRestriction() && eventData.data && eventData.data.mediaType === Microsoft.Entertainment.Queries.ObjectType.track) {
                            var trackInvocationHelper = new MS.Entertainment.UI.Controls.TrackGalleryControlInvocationHelper(this);
                            trackInvocationHelper.invokeItem(invocationEvent, eventData)
                        }
                        else {
                            var actionService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.actions);
                            if (actionService.isRegistered(MS.Entertainment.UI.Actions.ActionIdentifiers.mediaItemDetailsNavigate)) {
                                var mediaItemDetailsAction = actionService.getAction(MS.Entertainment.UI.Actions.ActionIdentifiers.mediaItemDetailsNavigate);
                                mediaItemDetailsAction.parameter = {
                                    shouldGetLocationFromMediaItem: true, forceMarketplace: false, data: eventData.data
                                };
                                if (mediaItemDetailsAction.canExecute(mediaItemDetailsAction.parameter))
                                    return mediaItemDetailsAction.execute()
                            }
                            var popOverParameters = this._galleryControl.createPopOverParameters(eventData);
                            MS.Entertainment.Platform.PlaybackHelpers.showItemDetails(popOverParameters)
                        }
                    }.bind(this), function error(){})
                }}, {create: WinJS.Utilities.markSupportedForProcessing(function create(galleryControl) {
                    return new MS.Entertainment.UI.Controls.SearchHorizontalDetailsInvocationHelper(galleryControl)
                })}), DoNothingSelectionHelper: MS.Entertainment.UI.Framework.define(null, {
                dispose: function dispose(){}, updateSelectedItems: function updateSelectedItems(newSelection, oldSelection){}
            }), GalleryControlSelectionHelper: MS.Entertainment.UI.Framework.define(function galleryControlSelectionHelper(galleryControl, options) {
                this._appBarService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.appToolbar);
                this._galleryControl = galleryControl;
                this._updateContainingMedia();
                this._mediaContext = this._appBarService.pushMediaContext(this._galleryControl.selectedItems, this._galleryControl.selectionHandlers, [], {
                    galleryControl: this._galleryControl, executeLocation: MS.Entertainment.UI.Actions.ExecutionLocation.selection, containingMedia: this._containingMedia
                });
                this._mediaContext.collectionFilter = galleryControl._mediaContext && galleryControl._mediaContext.collectionFilter;
                if (options)
                    WinJS.UI.setOptions(this, WinJS.Binding.unwrap(options))
            }, {
                actionCallbacks: null, allowShare: true, _mediaContext: null, _containingMedia: null, _appBarService: null, _galleryControl: null, _selectedItemStateEngine: null, _selectedItemBindings: null, _multiSelectItemActions: null, _selectedItemsNum: null, _disposed: false, _shareOperation: null, dispose: function dispose() {
                        MS.Entertainment.UI.Controls.assert(!this._dispose, "dispose already called on gallery selection helper.");
                        if (this._disposed)
                            return;
                        this._disposed = true;
                        if (this._selectedItemBindings) {
                            this._selectedItemBindings.cancel();
                            this._selectedItemBindings = null
                        }
                        if (this._selectedItemStateEngine) {
                            this._selectedItemStateEngine.unload();
                            this._selectedItemStateEngine = null
                        }
                        this._multiSelectItemActions = null;
                        this._galleryControl = null;
                        this._cancelShareMedia();
                        var appBarControl = MS.Entertainment.globalControls.getControl(MS.Entertainment.globalControls.GlobalControl.appBar);
                        if (appBarControl && appBarControl.hide)
                            appBarControl.hide(true);
                        if (this._mediaContext) {
                            this._mediaContext.clearContext();
                            this._mediaContext = null
                        }
                    }, updateSelectedItems: function updateSelectedItems(newSelection, oldSelection) {
                        var selectedIndex;
                        if (!newSelection || newSelection.length === 0) {
                            MS.Entertainment.UI.Controls.assert(newSelection.length, "Dispose was expected to be called instead of this function if there are no items selected.");
                            return
                        }
                        this._cancelShareMedia();
                        this._selectedItemsNum = newSelection.length;
                        if (newSelection.length === 1)
                            this._handleGallerySingleSelection(newSelection[0]);
                        else
                            this._handleGalleryMultiSelection(newSelection);
                        if (this._mediaContext && this._galleryControl)
                            this._mediaContext.mediaItem = this._galleryControl.selectedItems;
                        this._updateContainingMedia()
                    }, _updateContainingMedia: function _updateContainingMedia() {
                        var containingMedia = this._containingMedia;
                        var index = this._galleryControl.selectedIndex;
                        if (!containingMedia && this._galleryControl && this._galleryControl.mediaContext && this._galleryControl.mediaContext.containingMedia)
                            if (this._galleryControl.mediaContext.containingMedia.copy)
                                containingMedia = this._galleryControl.mediaContext.containingMedia.copy();
                            else
                                containingMedia = {
                                    playbackItemSource: this._galleryControl.mediaContext.containingMedia.playbackItemSource, playbackOffset: -1, playbackKey: null
                                };
                        if (!containingMedia)
                            containingMedia = {
                                playbackItemSource: null, playbackOffset: -1, playbackKey: null
                            };
                        if (this._galleryControl && this._galleryControl.dataSource) {
                            containingMedia.playbackSelectionRanges = this._galleryControl.selection && this._galleryControl.selection.getRanges();
                            containingMedia.playbackKey = this._galleryControl.selectedKey;
                            containingMedia.playbackOffset = this._galleryControl.dataSource.indexToSourceIndex ? this._galleryControl.dataSource.indexToSourceIndex(this._galleryControl.selectedIndex) : this._galleryControl.selectedIndex
                        }
                        else {
                            containingMedia.playbackSelectionRanges = null;
                            containingMedia.playbackKey = null;
                            containingMedia.playbackOffset = -1
                        }
                        this._containingMedia = containingMedia
                    }, _handleGallerySingleSelection: function _handleGallerySingleSelection(selectedIndex) {
                        if (this._disposed || !this._galleryControl)
                            return;
                        if (this._selectedItemBindings) {
                            this._selectedItemBindings.cancel();
                            this._selectedItemBindings = null
                        }
                        if (this._selectedItemStateEngine) {
                            this._selectedItemStateEngine.unload();
                            this._selectedItemStateEngine = null
                        }
                        this._multiSelectItemActions = null;
                        this._galleryControl.getDataObjectAtIndex(selectedIndex).then(function getDataObjectAtIndex_Success(item) {
                            if (this._disposed || this._selectedItemsNum !== 1)
                                return;
                            MS.Entertainment.ViewModels.MediaItemModel.augment(item);
                            MS.Entertainment.ViewModels.MediaItemModel.hydrateLibraryInfoAsync(item);
                            if (item.hydrate && !item.hydrated) {
                                var options = {collectionFilter: this._mediaContext && this._mediaContext.collectionFilter};
                                item.hydrate(options).done(function hydrate_Done() {
                                    this._shareMedia(item)
                                }.bind(this), function hydrate_Error() {
                                    this._shareMedia(item)
                                }.bind(this))
                            }
                            else
                                this._shareMedia(item);
                            this._createSelectionStateEngineForMediaItem(item)
                        }.bind(this), function getDataObjectAtIndex_Error(){})
                    }, _handleGalleryMultiSelection: function _handleGalleryMultiSelection(selectedIndex) {
                        var featureEnablement = new Microsoft.Entertainment.FeatureEnablement.FeatureEnablement;
                        if (featureEnablement.isEnabled(Microsoft.Entertainment.FeatureEnablement.FeatureItem.musicShareToPhone))
                            if (this._galleryControl.selectedItems && this._galleryControl.selectedItems.count)
                                this._shareMedia(this._galleryControl.selectedItems);
                        if (this._multiSelectItemActions) {
                            var appBarControl = MS.Entertainment.globalControls.getControl(MS.Entertainment.globalControls.GlobalControl.appBar);
                            if (appBarControl)
                                appBarControl.show();
                            return
                        }
                        if (this._selectedItemBindings) {
                            this._selectedItemBindings.cancel();
                            this._selectedItemBindings = null
                        }
                        if (this._selectedItemStateEngine) {
                            this._selectedItemStateEngine.unload();
                            this._selectedItemStateEngine = null
                        }
                        this._multiSelectItemActions = [];
                        this._galleryControl.getDataObjectAtIndex(selectedIndex[0]).then(function getDataObjectAtIndex_Success(mediaItem) {
                            if (this._disposed || this._selectedItemsNum <= 1)
                                return;
                            switch (mediaItem && mediaItem.mediaType) {
                                case Microsoft.Entertainment.Queries.ObjectType.playlist:
                                    this._multiSelectItemActions = MS.Entertainment.ViewModels.SmartAppbarActions.getMusicPlaylistMultiSelectActions(mediaItem);
                                    break;
                                case Microsoft.Entertainment.Queries.ObjectType.album:
                                case Microsoft.Entertainment.Queries.ObjectType.track:
                                case Microsoft.Entertainment.Queries.ObjectType.person:
                                    this._multiSelectItemActions = MS.Entertainment.ViewModels.SmartAppbarActions.getMusicMultiSelectActions(mediaItem);
                                    break;
                                default:
                                    if (mediaItem.smartDJ)
                                        this._multiSelectItemActions = MS.Entertainment.ViewModels.SmartAppbarActions.getSmartDJMultiSelectActions();
                                    else
                                        this._multiSelectItemActions = [];
                                    break
                            }
                            this._updateAppBarActions(this._multiSelectItemActions)
                        }.bind(this), function getDataObjectAtIndex_Error(){})
                    }, _shareMedia: function _shareMedia(media) {
                        var sender = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.shareSender);
                        if (!this._shareOperation && media && this.allowShare)
                            this._shareOperation = sender.pendingShare(media)
                    }, _cancelShareMedia: function _cancelShareMedia() {
                        if (this._shareOperation) {
                            this._shareOperation.cancel();
                            this._shareOperation = null
                        }
                    }, _createSelectionStateEngineForMediaItem: function _createSelectionStateEngineForMediaItem(mediaItem) {
                        var handler;
                        if (this._disposed || this._selectedItemsNum !== 1)
                            return;
                        this._selectedItemStateEngine = MS.Entertainment.ViewModels.SmartBuyStateEngine.getSelectionStateFromMediaItem(mediaItem);
                        if (this._selectedItemStateEngine)
                            this._selectedItemBindings = WinJS.Binding.bind(this._selectedItemStateEngine, {currentAppbarActions: this._setSelectedItemAppbarActions.bind(this)})
                    }, _setSelectedItemAppbarActions: function _setSelectedItemAppbarActions(newValue, oldValue) {
                        if (oldValue !== undefined && this._selectedItemsNum === 1)
                            this._updateAppBarActions(newValue)
                    }, _updateAppBarActions: function _updateAppBarActions(newActions) {
                        if (this._mediaContext)
                            this._mediaContext.setToolbarActions(newActions);
                        if (newActions.length > 0) {
                            var appBarControl = MS.Entertainment.globalControls.getControl(MS.Entertainment.globalControls.GlobalControl.appBar);
                            if (appBarControl)
                                appBarControl.show()
                        }
                    }
            }), GalleryControl: MS.Entertainment.UI.Framework.defineUserControl(null, function galleryControlConstructor(element, options) {
                window.msWriteProfilerMark("ent:GalleryControl.Constructed");
                this._eventProvider = new Diagnostics.Tracing.Microsoft.Entertainment.Instrumentation.Providers.Shell;
                this._eventProvider.traceGalleryControl_Load_Start();
                this.readyState = MS.Entertainment.UI.Controls.GalleryControl.ReadyState.itemsLoading;
                this._selectionHandlers = [];
                this.selectionHelperFactory = function selectionHelperFactory(galleryControl) {
                    return new MS.Entertainment.UI.Controls.GalleryControlSelectionHelper(galleryControl, this.selectionHelperOptions)
                };
                var uiStateService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.uiState);
                this._uiStateHandlers = MS.Entertainment.Utilities.addEventHandlers(uiStateService, {
                    isSnappedChanged: this._onSnappedChanged.bind(this), windowresize: this._handleWindowResize.bind(this)
                });
                if (MS.Entertainment.Utilities.isApp2 && this.pagesToLoad === WinJS.UI._DEFAULT_PAGES_TO_LOAD)
                    this.pagesToLoad = 1
            }, {
                controlName: "GalleryControl", debugId: null, ignoreChildrenInitialization: true, horizontal: false, headerPosition: "top", _selectionMode: "none", _tap: "none", _swipeBehavior: "none", _selectionStyleFilled: false, _dragStarted: false, maxRows: -1, layout: "grid", loadingBehavior: "randomAccess", headerType: "auto", backdropColor: null, panelOptions: null, queryToPause: null, slotSize: null, itemMargin: null, itemSize: null, largeItemSize: null, itemClass: null, headerClass: null, autoSize: false, preventResizeJitter: false, suppressInvokeBubble: false, forceInteractive: false, handleFocus: false, pagesToLoad: WinJS.UI._DEFAULT_PAGES_TO_LOAD, inlineExtraData: null, raisePanelReadyEvents: true, raisePanelResetEvents: false, delayHydrateLibraryId: false, emptyGalleryModel: null, userGatedGalleryModel: null, userGatedGallery: false, syncScreenModel: null, syncScreen: false, initialSelected: -1, initialInvoked: -1, initialVisible: -1, invocationHelper: null, doubleClickHelper: null, _selectionHandlers: null, focusFirstItemOnPageLoad: false, restoreFocusOnDataChanges: false, multiSize: false, startNewColumnOnHeaders: false, largeItemIndex: -1, selectionHelperFactory: null, selectionHelperOptions: null, allowSelectAll: true, allowHeaders: true, actionOptions: null, doubleClickActionOptions: null, listViewClassName: null, orientation: null, ensureNextItemVisibleCount: 0, shrinkAndStayHeader: false, _userSelectedEverything: false, _uiStateHandlers: null, _invokeBehavior: "popOver", _invokeHelperFactory: null, _itemsDraggable: false, _itemsReorderable: false, _dragBetweenElement: -1, _eventProvider: null, _dataSourceHandlers: null, _dataSourceItemChangeHandlers: null, _doubleClickBehavior: "play", _listView: null, _zoomView: null, _zoomedOutView: null, _readyStateCallback: null, _selectedIndexChangedCallback: null, _itemInvoked: null, _initialItemCount: -1, _notificationHandler: null, _listBinding: null, _navigationBindings: null, _raisedPanelReady: false, _raisedPanelEmpty: false, _isEmpty: false, _isSyncing: false, _internalDataSource: null, _focusEventHandler: null, _listViewEventHandler: null, _zoomViewEventHandler: null, _previousCanZoom: false, _listViewEventCaptureHandler: null, _templateSelector: null, _grouperItemThreshold: _defaultGrouperItemThreshold, _minimumListLength: 1, _selectionHelper: null, _mediaContext: null, _mediaContextOwned: true, _dataSource: null, _invocationHelperEvents: null, _updateCount: 0, _templateSelectorConstructor: MS.Entertainment.UI.Controls.GalleryTemplateSelector, _pendingSelectionFromInvoke: -1, _maxSelectionCount: -1, _semanticZoomInitType: null, _firstPageRendered: false, _ignoreNextInteractiveCheck: false, _restoreFocusIndex: -1, _listViewHadFocus: false, _firstPagedRenderedEventDispatched: false, _firstPagedDelayInitializedHandled: false, _inplaceGrouper: null, _delayInitializeSignal: null, _mediaControlEventHandler: null, _mediaControlCommandEnabled: true, _savedScrollPosition: null, _listViewViewport: null, _delayInitializedChildren: false, _moreThanFirstPageRendered: false, _collectionFilter: Microsoft.Entertainment.Platform.MediaAvailability.available, blockDelayInitializeOfChildren: true, allowZoom: false, initialZoomedOut: false, zoomedOutLayout: "auto", maxSelectionCount: {
                        get: function() {
                            return this._maxSelectionCount
                        }, set: function(value) {
                                if (this._maxSelectionCount !== value)
                                    this._maxSelectionCount = typeof value !== "number" ? -1 : value
                            }
                    }, isFirstPageRendered: {get: function() {
                            return this._firstPageRendered
                        }}, templateSelectorConstructor: {
                        get: function() {
                            return this._templateSelectorConstructor
                        }, set: function(value) {
                                if (value !== this._templateSelectorConstructor) {
                                    this._templateSelectorConstructor = value || MS.Entertainment.UI.Controls.GalleryTemplateSelector;
                                    this._templateSelector = null
                                }
                            }
                    }, dataSource: {
                        get: function() {
                            return this._dataSource
                        }, set: function(value) {
                                if (value !== this._dataSource && !this._unloaded) {
                                    var oldValue = this._dataSource;
                                    this._dataSource = value;
                                    this._dataSourceUpdated(this._dataSource, oldValue);
                                    window.msWriteProfilerMark("ent:GalleryControl.GotData");
                                    this.notify("dataSource", this._dataSource, oldValue)
                                }
                            }
                    }, grouperItemThreshold: {
                        get: function() {
                            return this._grouperItemThreshold
                        }, set: function(value) {
                                if (isNaN(value))
                                    value = _defaultGrouperItemThreshold;
                                this._grouperItemThreshold = value
                            }
                    }, minimumListLength: {
                        get: function() {
                            return this._minimumListLength
                        }, set: function(value) {
                                if (isNaN(value))
                                    value = 1;
                                this._minimumListLength = value;
                                if (this._notificationHandler)
                                    this._notificationHandler.minimumListLength = value
                            }
                    }, templateSelector: {get: function() {
                            if (!this._templateSelector)
                                this._templateSelector = new this.templateSelectorConstructor(this);
                            return this._templateSelector
                        }}, itemTemplate: {
                        get: function() {
                            return this.templateSelector.getTemplate(MS.Entertainment.UI.Controls.TemplateSelectorBase.templateType.item)
                        }, set: function(value) {
                                this.templateSelector.addTemplate(MS.Entertainment.UI.Controls.TemplateSelectorBase.templateType.item, value)
                            }
                    }, headerTemplate: {
                        get: function() {
                            return this.templateSelector.getTemplate(MS.Entertainment.UI.Controls.TemplateSelectorBase.templateType.header)
                        }, set: function(value) {
                                this.templateSelector.addTemplate(MS.Entertainment.UI.Controls.TemplateSelectorBase.templateType.header, value)
                            }
                    }, actionTemplate: {
                        get: function() {
                            return this.templateSelector.getTemplate(MS.Entertainment.UI.Controls.TemplateSelectorBase.templateType.action)
                        }, set: function(value) {
                                this.templateSelector.addTemplate(MS.Entertainment.UI.Controls.TemplateSelectorBase.templateType.action, value)
                            }
                    }, zoomedOutTemplate: {
                        get: function() {
                            return this.templateSelector.getTemplate(MS.Entertainment.UI.Controls.TemplateSelectorBase.templateType.zoomedOut)
                        }, set: function(value) {
                                this.templateSelector.addTemplate(MS.Entertainment.UI.Controls.TemplateSelectorBase.templateType.zoomedOut, value)
                            }
                    }, emptyGalleryTemplate: {
                        get: function() {
                            return this.templateSelector.getTemplate(MS.Entertainment.UI.Controls.TemplateSelectorBase.templateType.emptyGallery)
                        }, set: function(value) {
                                this.templateSelector.addTemplate(MS.Entertainment.UI.Controls.TemplateSelectorBase.templateType.emptyGallery, value)
                            }
                    }, userGatedGalleryTemplate: {
                        get: function() {
                            return this.templateSelector.getTemplate(MS.Entertainment.UI.Controls.TemplateSelectorBase.templateType.userGatedGallery)
                        }, set: function(value) {
                                this.templateSelector.addTemplate(MS.Entertainment.UI.Controls.TemplateSelectorBase.templateType.userGatedGallery, value)
                            }
                    }, syncScreenTemplate: {
                        get: function getSyncScreenTemplate() {
                            return this.templateSelector.getTemplate(MS.Entertainment.UI.Controls.TemplateSelectorBase.templateType.syncScreen)
                        }, set: function setSyncScreenTemplate(value) {
                                this.templateSelector.addTemplate(MS.Entertainment.UI.Controls.TemplateSelectorBase.templateType.syncScreen, value)
                            }
                    }, panelTemplate: {
                        get: function() {
                            return this.templateSelector.getTemplate(MS.Entertainment.UI.Controls.TemplateSelectorBase.templateType.panel)
                        }, set: function(value) {
                                this.templateSelector.addTemplate(MS.Entertainment.UI.Controls.TemplateSelectorBase.templateType.panel, value)
                            }
                    }, _panelTemplateTypeMappings: null, panelTemplateTypeMappings: {
                        get: function() {
                            return this._panelTemplateTypeMappings
                        }, set: function(value) {
                                if (value !== this._panelTemplateTypeMappings || !this._panelTemplateTypeMappings)
                                    this._panelTemplateTypeMappings = value
                            }
                    }, _grouper: null, grouper: {
                        get: function() {
                            if (!this._grouper && this._grouperType)
                                this._grouper = new this._grouperType;
                            else if (!this._grouperType && this._grouper)
                                this._grouper = null;
                            return this._grouper
                        }, set: function(value) {
                                if (value !== this._grouper) {
                                    this._grouper = value;
                                    if (this._grouper) {
                                        this._grouperType = Object.getPrototypeOf(this._grouper);
                                        this._grouperType = this._grouperType && this._grouperType.constructor
                                    }
                                    this._updateRefreshThreshold()
                                }
                            }
                    }, _grouperType: null, grouperType: {
                        get: function() {
                            return this._grouperType
                        }, set: function(value) {
                                if (value !== this._grouperType) {
                                    this._grouper = null;
                                    this._grouperType = value;
                                    this._updateRefreshThreshold()
                                }
                            }
                    }, selectionMode: {
                        get: function() {
                            return this._selectionMode
                        }, set: function(value) {
                                if (value !== this._selectionMode) {
                                    this._selectionMode = value;
                                    if (this._listView)
                                        this._listView.selectionMode = value
                                }
                            }
                    }, selectionStyleFilled: {
                        get: function() {
                            return this._selectionStyleFilled
                        }, set: function(value) {
                                if (value !== this._selectionStyleFilled) {
                                    this._selectionStyleFilled = value;
                                    if (this._listView && this._listView._element)
                                        if (value)
                                            WinJS.Utilities.addClass(this._listView._element, MS.Entertainment.UI.Controls.GalleryControl.selectionFilledClass);
                                        else
                                            WinJS.Utilities.removeClass(this._listView._element, MS.Entertainment.UI.Controls.GalleryControl.selectionFilledClass)
                                }
                            }
                    }, tap: {
                        get: function() {
                            return this._tap
                        }, set: function(value) {
                                if (value !== this._tap) {
                                    this._tap = value;
                                    if (this._listView)
                                        this._listView.tap = value
                                }
                            }
                    }, swipeBehavior: {
                        get: function() {
                            return this._swipeBehavior
                        }, set: function(value) {
                                if (value !== this._swipeBehavior) {
                                    this._swipeBehavior = value;
                                    if (this._listView)
                                        this._listView.swipeBehavior = value
                                }
                            }
                    }, doubleClickBehavior: {
                        get: function() {
                            return this._doubleClickBehavior
                        }, set: function(value) {
                                if (value !== this._doubleClickBehavior)
                                    this._doubleClickBehavior = value
                            }
                    }, invokeBehavior: {
                        get: function() {
                            return this._invokeBehavior
                        }, set: function(value) {
                                if (value !== this._invokeBehavior) {
                                    this._invokeBehavior = value;
                                    this._updateInvokeHelper()
                                }
                            }
                    }, invokeHelperFactory: {
                        get: function() {
                            return this._invokeHelperFactory
                        }, set: function(value) {
                                if (value !== this._invokeHelperFactory) {
                                    this._invokeHelperFactory = value;
                                    this._updateInvokeHelper()
                                }
                            }
                    }, _isDragAndDropEnabled: function _isDragAndDropEnabled() {
                        var configurationManager = new Microsoft.Entertainment.Configuration.ConfigurationManager;
                        return configurationManager.shell.dragAndDropEnabled
                    }, itemsDraggable: {
                        get: function() {
                            return this._isDragAndDropEnabled() && this._itemsDraggable
                        }, set: function(value) {
                                value = this._isDragAndDropEnabled() && value;
                                if (value !== this._itemsDraggable) {
                                    this._itemsDraggable = value;
                                    if (this._listView)
                                        this._listView.itemsDraggable = value
                                }
                            }
                    }, itemsReorderable: {
                        get: function() {
                            return this._isDragAndDropEnabled() && this._itemsReorderable
                        }, set: function(value) {
                                value = this._isDragAndDropEnabled() && value;
                                if (value !== this._itemsReorderable) {
                                    this._itemsReorderable = value;
                                    if (this._listView)
                                        this._listView.itemsReorderable = value
                                }
                            }
                    }, selectionHandlers: {get: function get_selectionHandlers() {
                            return this._selectionHandlers
                        }}, setSelectionHandlers: function setSelectionHandlers(handlers) {
                        this.clearSelectionHandlers();
                        this.addSelectionHandlers(handlers)
                    }, addSelectionHandlers: function addSelectionHandlers(handlers) {
                        this._selectionHandlers = this._selectionHandlers || [];
                        if (Array.isArray(handlers))
                            this._selectionHandlers = this._selectionHandlers.concat(handlers);
                        else
                            this._selectionHandlers.push(handlers)
                    }, clearSelectionHandlers: function clearSelectionHandlers() {
                        this._selectionHandlers = []
                    }, mediaContext: {
                        get: function() {
                            return this._mediaContext
                        }, set: function(value) {
                                if (value !== this._mediaContext) {
                                    this._releaseMediaContext();
                                    this._mediaContext = value;
                                    this._mediaContextOwned = false
                                }
                            }
                    }, updateCollectionFilter: function(filter) {
                        this._collectionFilter = filter;
                        if (this.mediaContext)
                            this.mediaContext.collectionFilter = filter
                    }, processItemData: function processItemData(itemData) {
                        return itemData
                    }, internalDataSource: {get: function() {
                            return this._internalDataSource
                        }}, selection: {get: function() {
                            return this._listView ? this._listView.selection : null
                        }}, finalZoomedOutLayout: {get: function() {
                            return this.zoomedOutLayout === MS.Entertainment.UI.Controls.GalleryControl.ZoomedOutLayout.auto ? this.layout : this.zoomedOutLayout
                        }}, finalZoomedOutTemplateType: {get: function() {
                            return this.zoomedOutTemplate ? MS.Entertainment.UI.Controls.TemplateSelectorBase.templateType.zoomedOut : MS.Entertainment.UI.Controls.TemplateSelectorBase.templateType.header
                        }}, useInPlaceHeaders: {get: function() {
                            return this.headerType === MS.Entertainment.UI.Controls.GalleryControl.HeaderType.inPlace
                        }}, canGroup: {get: function get_canGroup() {
                            var canGroup;
                            canGroup = !!(this.dataSource && this.dataSource.groups && !this.dataSource.grouper.noHeaderGroups);
                            canGroup = canGroup || (this.useInPlaceHeaders && !!this.grouper);
                            canGroup = canGroup || !!this.grouper;
                            canGroup = canGroup && this.allowHeaders;
                            if (canGroup) {
                                var thresholdMet = this.useInPlaceHeaders || this._initialItemCount >= this.grouperItemThreshold || (!!this.grouperType && this.grouperType !== MS.Entertainment.UI.Controls.GalleryAlphaCharGrouper);
                                canGroup = thresholdMet
                            }
                            return canGroup
                        }}, canZoom: {get: function() {
                            return this.allowZoom && !!this.dataSource && !!this.dataSource.hasGroupHints
                        }}, isZoomReady: {get: function() {
                            return this.allowZoom && !!this.dataSource && !!this.dataSource.isGroupHintsReady
                        }}, isZoomedOut: {
                        get: function() {
                            return this._zoomView ? this._zoomView.zoomedOut : false
                        }, set: function(newValue) {
                                var oldValue = this.isZoomedOut;
                                if (this._zoomView && oldValue !== newValue && !this._unloaded) {
                                    msWriteProfilerMark("ent:GalleryControl:isZoomedChanging");
                                    this._zoomView.zoomedOut = newValue
                                }
                                this.updateAndNotify("isZoomedOut", newValue)
                            }
                    }, initialItemCount: {get: function getItemCount() {
                            return this._initialItemCount
                        }}, _activeListView: {get: function() {
                            return this.isZoomedOut ? this._zoomedOutView : this._listView
                        }}, hasSelectionOrInvocation: {get: function get_hasSelectionOrInvocation() {
                            var selection;
                            var index = -1;
                            if (this._listView && this._listView.selection)
                                selection = this._listView.selection.getIndices();
                            if (selection && selection.length > 0)
                                index = selection[0];
                            if (this.invocationHelper && this.invocationHelper.invokedIndex >= 0)
                                index = this.invocationHelper.invokedIndex;
                            return index >= 0
                        }}, hasMultiSelection: {get: function get_hasMultiSelection() {
                            if (this._listView && this._listView.selection) {
                                var selection = this._listView.selection.getIndices();
                                return selection && selection.length > 1
                            }
                            return false
                        }}, _waitForGalleryReady: function _waitForGalleryReady() {
                        var readyPromise;
                        if (this.readyState !== MS.Entertainment.UI.Controls.GalleryControl.ReadyState.complete) {
                            var readySignal = new MS.Entertainment.UI.Framework.Signal;
                            var readyStateEventHandler = MS.Entertainment.Utilities.addEventHandlers(this._listView, {loadingstatechanged: function readyStateChanged() {
                                        var readyState = this._listView && this._listView.loadingState;
                                        if (readyState === MS.Entertainment.UI.Controls.GalleryControl.ReadyState.complete)
                                            readySignal.complete()
                                    }.bind(this)});
                            WinJS.Promise.timeout(1000, readySignal.promise);
                            readyPromise = readySignal.promise.then(null, function assertGalleryReady() {
                                MS.Entertainment.UI.Controls.fail("_waitForGalleryReady timed out before gallery was ready. The timeout might need to be extended if this occurs regularly.")
                            }.bind(this)).then(function clearEventHandler() {
                                if (readyStateEventHandler) {
                                    readyStateEventHandler.cancel();
                                    readyStateEventHandler = null
                                }
                            })
                        }
                        return WinJS.Promise.as(readyPromise)
                    }, safeFocusAndEnsureVisible: function safeFocusAndEnsureVisible(index) {
                        if (!this.hasSelectionOrInvocation && index >= 0)
                            this._waitForGalleryReady().done(function galleryReady() {
                                this.setIndexFocus(index);
                                this.ensureVisible(index)
                            }.bind(this), function galleryReadyFailed(){})
                    }, setIndexFocus: function setIndexFocus(index) {
                        if (this._listView)
                            this._listView.currentItem = {index: index}
                    }, setVisibleIndexFocus: function setVisibleIndexFocus(index) {
                        if (MS.Entertainment.Utilities.isApp2 && MS.Entertainment.UI.Framework.canMoveFocus(document.activeElement))
                            return;
                        if (this._listView && MS.Entertainment.UI.Framework.canMoveFocus(this._listView._element))
                            this._listView.currentItem = {
                                index: index, hasFocus: true, showFocus: MS.Entertainment.Framework.KeyboardInteractionListener.showKeyboardFocus
                            }
                    }, ensureVisible: function ensureVisible(index) {
                        if (this._listView)
                            this._listView.ensureVisible(index)
                    }, _ensureSelectionInvokedVisible: function _ensureSelectionInvokedVisible(offset) {
                        var selection;
                        var index = -1;
                        offset = offset || 0;
                        if (this._listView && this._listView.selection)
                            selection = this._listView.selection.getIndices();
                        if (selection && selection.length > 0)
                            index = selection[0];
                        if (this.invocationHelper && this.invocationHelper.invokedIndex >= 0)
                            index = this.invocationHelper.invokedIndex;
                        if (index >= 0)
                            this.ensureVisible(index + offset)
                    }, getElementAtIndex: function getElementAtIndex(index) {
                        if (this._listView)
                            return this._listView.elementFromIndex(index);
                        return null
                    }, _releaseMediaContext: function _releaseMediaContext() {
                        if (this._mediaContext && this._mediaContextOwned) {
                            this._mediaContext.clearContext();
                            this._mediaContext = null
                        }
                    }, getItemAtIndex: function getItemAtIndex(index) {
                        var promise = null;
                        if (this._listView && index >= 0)
                            promise = this._listView.itemDataSource.itemFromIndex(index);
                        return WinJS.Promise.as(promise)
                    }, getDataObjectAtIndex: function getDataObjectAtIndex(index) {
                        var promise;
                        if (this._listView && index >= 0)
                            return this._listView.itemDataSource.itemFromIndex(index).then(function(item) {
                                    return item.data
                                });
                        else
                            promise = WinJS.Promise.wrap(null);
                        return promise
                    }, getGroupedDataSource: function getGroupedDataSource() {
                        var canGroup = this.canGroup;
                        var groupedDataSource = null;
                        if (canGroup && this.internalDataSource && this.dataSource && this.dataSource.groups) {
                            groupedDataSource = this.internalDataSource;
                            groupedDataSource.groups = new MS.Entertainment.Utilities.VirtualizedDataSource(this.dataSource.groups)
                        }
                        else if (canGroup && this.internalDataSource && !this.useInPlaceHeaders) {
                            var groupData = function groupData(item) {
                                    return !this.grouper ? {} : (this.grouper.useKeyAsData) ? {title: this.grouper.createKey(item)} : this.grouper.createData(item)
                                };
                            var groupKey = function groupKey(item) {
                                    if (this.grouper)
                                        return this.grouper.createKey(item)
                                };
                            groupedDataSource = WinJS.UI.computeDataSourceGroups(this.internalDataSource, groupKey.bind(this), groupData.bind(this));
                            MS.Entertainment.UI.Controls.assert(this.loadingBehavior === MS.Entertainment.UI.Controls.GalleryControl.LoadingBehavior.randomAccess, "ListView only supports randomAccess loading behavior for grouped views")
                        }
                        return groupedDataSource
                    }, _groupByGrouper: function groupByGrouper(item) {
                        return this.grouper.execute(item)
                    }, selectIndex: function selectIndex(index) {
                        if (index && this._listView && this._listView.selection) {
                            var currentSelection = this._listView.selection.getIndices();
                            if (currentSelection.length === 0 || index !== currentSelection[currentSelection.length - 1]) {
                                this._listView.selection.set(index);
                                this._listView.ensureVisible(index)
                            }
                        }
                    }, clearSelection: function clearSelection() {
                        if (this._listView && this._listView.selection)
                            this._listView.selection.clear();
                        this._setSelectedIndex(-1)
                    }, clearInvocation: function clearInvocation() {
                        if (this.invocationHelper)
                            this.invocationHelper.clearInvocation();
                        this._pendingSelectionFromInvoke = -1
                    }, scrollTo: function scrollTo(index) {
                        if (this._listView)
                            this._listView.indexOfFirstVisible = index
                    }, initialize: function initialize() {
                        this.bind("autoSizeMin", this.refreshGalleryWidth.bind(this));
                        this._itemInvoked = this.itemInvoked.bind(this);
                        this._notificationHandler = new MS.Entertainment.UI.Controls.GalleryListDataNotificationHandler(this._dataSourceContentsChanged.bind(this));
                        this._updateRefreshThreshold();
                        this.selectedIndices = [];
                        var navigation;
                        if (MS.Entertainment.ServiceLocator.isServiceRegistered(MS.Entertainment.Services.navigation))
                            navigation = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.navigation);
                        if (navigation)
                            this._navigationBindings = WinJS.Binding.bind(navigation, {currentPage: this._pageChanged.bind(this)});
                        if (!this._delayInitializeSignal)
                            this._delayInitializeSignal = new MS.Entertainment.UI.Framework.Signal
                    }, _delayInitialized: function _delayInitialized() {
                        if (MS.Entertainment.ServiceLocator.isServiceRegistered(MS.Entertainment.Services.appToolbar)) {
                            var appBarService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.appToolbar);
                            if (this._mediaContextOwned) {
                                this._mediaContext = appBarService.pushDefaultContext();
                                this._mediaContext.collectionFilter = this.collectionFilter
                            }
                            this._updateInvokeHelper();
                            this._updateSelection()
                        }
                        if (this.initialInvoked !== -1 && this.invocationHelper) {
                            var eventDetail = {
                                    itemPromise: this.getItemAtIndex(this.initialInvoked), itemIndex: this.initialInvoked, rerender: true
                                };
                            var domElement = this.getElementAtIndex(this.initialInvoked);
                            this.invocationHelper.invokeItem({
                                srcElement: domElement && domElement.parentElement, detail: eventDetail
                            });
                            this.scrollTo(this.initialInvoked)
                        }
                        MS.Entertainment.Utilities.schedulePromiseNormal(null, "ent:galleryControl:delayInitializeContainers").done(function delayInitializeContainersAndSemanticZoom() {
                            this._delayInitializedChildren = true;
                            if (this.domElement)
                                MS.Entertainment.UI.Framework.applyWithSelector(this.domElement, ".win-surface", function executeDelayInitializeOnList(element) {
                                    this._delayInitializeContainer(element)
                                }.bind(this));
                            this._commitZoomedOutDataSource()
                        }.bind(this), function ignoreCancelError(){});
                        if (this._delayInitializeSignal) {
                            this._delayInitializeSignal.complete();
                            this._delayInitializeSignal = null
                        }
                    }, _delayInitializeContainer: function _delayInitializeContainer(container) {
                        if (!container || !this.isDelayInitialized || !this._delayInitializedChildren || this._unloaded)
                            return;
                        MS.Entertainment.UI.Framework.delayInitializeChildren(container, true)
                    }, _delayHydrateLibraryInfoAsync: function _delayHydrateLibraryInfoAsync(mediaItem) {
                        if (!mediaItem || !this.delayHydrateLibraryId)
                            return WinJS.Promise.as();
                        var wrapperSignal = new MS.Entertainment.UI.Framework.Signal;
                        WinJS.Promise.as(this._delayInitializeSignal && this._delayInitializeSignal.promise).done(wrapperSignal.complete.bind(wrapperSignal), wrapperSignal.error.bind(wrapperSignal));
                        return wrapperSignal.promise.then(function _delayHydrateLibraryInfoAsyncWork() {
                                if (!this._unloaded)
                                    return MS.Entertainment.ViewModels.MediaItemModel.hydrateLibraryInfoAsync(mediaItem)
                            }.bind(this))
                    }, unload: function unload() {
                        if (this._uiStateHandlers) {
                            this._uiStateHandlers.cancel();
                            this._uiStateHandlers = null
                        }
                        if (this._listBinding) {
                            this._listBinding.release();
                            this._listBinding = null
                        }
                        if (this._notificationHandler) {
                            this._notificationHandler.dispose();
                            this._notificationHandler = null
                        }
                        if (this._focusEventHandler) {
                            this._focusEventHandler.cancel();
                            this._focusEventHandler = null
                        }
                        if (this._navigationBindings) {
                            this._navigationBindings.cancel();
                            this._navigationBindings = null
                        }
                        this._clearListViewEvents();
                        this._clearZoomViewEvents();
                        if (this._dragStarted)
                            this._itemDragEndedOrCanceled();
                        if (this._listView && this._listView.dispose)
                            this._listView.dispose();
                        this._listView = null;
                        this._dragBetweenElement = null;
                        this._internalDataSource = null;
                        this._internalZoomedOutDataSource = null;
                        this._clearDataSourceHandlers();
                        this._dataSource = null;
                        this.selectedItems = null;
                        this._clearInvocationHelper();
                        if (this._inplaceGrouper) {
                            this._inplaceGrouper.dispose();
                            this._inplaceGrouper = null
                        }
                        this._clearSelectionHelper();
                        this._selectionHandlers = null;
                        this._releaseMediaContext();
                        MS.Entertainment.UI.Framework.UserControl.prototype.unload.call(this)
                    }, freeze: function freeze() {
                        if (this.queryToPause)
                            this.queryToPause.pause();
                        if (MS.Entertainment.Utilities.isApp2) {
                            if (!this._listViewViewport)
                                this._listViewViewport = this.domElement.querySelector(".win-viewport");
                            if (this._listViewViewport)
                                this._savedScrollPosition = this._listViewViewport.scrollLeft
                        }
                        this._mediaControlCommandEnabled = false;
                        MS.Entertainment.UI.Framework.UserControl.prototype.freeze.call(this)
                    }, thaw: function thaw() {
                        MS.Entertainment.UI.Framework.UserControl.prototype.thaw.call(this);
                        if (this.queryToPause)
                            this.queryToPause.unpause();
                        if (MS.Entertainment.Utilities.isApp2 && this._savedScrollPosition && this._listViewViewport) {
                            this._listViewViewport.scrollLeft = this._savedScrollPosition;
                            this._savedScrollPosition = null
                        }
                        this._mediaControlCommandEnabled = true
                    }, _updateRefreshThreshold: function _updateRefreshThreshold() {
                        if (this._notificationHandler) {
                            if (this.grouper)
                                this._notificationHandler.countThreshold = this.grouperItemThreshold;
                            else
                                this._notificationHandler.countThreshold = NaN;
                            this._notificationHandler.minimumListLength = this.minimumListLength
                        }
                    }, _calculateIndexToFocus: function _calculateIndexToFocus() {
                        if (this.restoreFocusOnDataChanges && this._restoreFocusIndex === -1 && (document.activeElement === null || (!this._listView && this._listViewHadFocus))) {
                            this.focusFirstItemOnPageLoad = true;
                            this._listViewHadFocus = false
                        }
                        else if (this._listView && !MS.Entertainment.UI.Framework.focusedElementHasClass(["horizontalPivotButton", "verticalPivotButton"]))
                            this._listViewHadFocus = true;
                        else if (this._listView)
                            this._listViewHadFocus = false
                    }, _clearListViewEvents: function _clearListViewEvents() {
                        if (this._listViewEventHandler) {
                            this._listViewEventHandler.cancel();
                            this._listViewEventHandler = null
                        }
                        if (this._listViewEventCaptureHandler) {
                            this._listViewEventCaptureHandler.cancel();
                            this._listViewEventCaptureHandler = null
                        }
                        if (this._mediaControlEventHandler) {
                            this._mediaControlEventHandler.cancel();
                            this._mediaControlEventHandler = null
                        }
                    }, _clearZoomViewEvents: function _clearZoomViewEvents() {
                        if (this._zoomViewEventHandler) {
                            this._zoomViewEventHandler.cancel();
                            this._zoomViewEventHandler = null
                        }
                    }, _dataSourceUpdated: function _dataSourceUpdated(dataSource, oldDataSource) {
                        this._clearDataSourceHandlers();
                        this.clearSelection();
                        if (this._selectionHelper) {
                            this._selectionHelper.dispose();
                            this._selectionHelper = null
                        }
                        if ((!this._unloaded) && (dataSource || oldDataSource))
                            this._updateDataSourceGrouper(dataSource).then(function finalizeDataSource() {
                                if (this._unloaded || dataSource !== this.dataSource)
                                    return;
                                var returnValue = dataSource || [];
                                if (Array.isArray(returnValue))
                                    if (dataSource)
                                        returnValue = MS.Entertainment.Data.VirtualList.wrapArray(dataSource, {cacheSize: 200});
                                return returnValue
                            }.bind(this)).then(function afterNotArrayGuaranteed(notArray) {
                                if (this._unloaded || dataSource !== this.dataSource)
                                    return;
                                if ("createListBinding" in notArray)
                                    this._internalDataSource = notArray;
                                else
                                    this._internalDataSource = new MS.Entertainment.Utilities.VirtualizedDataSource(notArray);
                                return this._dataSourceContentsChanged()
                            }.bind(this)).then(function updateGroupHints() {
                                if (this._unloaded || dataSource !== this.dataSource)
                                    return;
                                if (dataSource)
                                    this._dataSourceHandlers = MS.Entertainment.Utilities.addEventHandlers(dataSource, {
                                        itemMoved: this._updateSelectionInvokedVisibleAfterMove.bind(this), groupHintsChanged: this._updateGroupHints.bind(this)
                                    });
                                this._updateGroupHints()
                            }.bind(this)).done(null, function ignoreError(error) {
                                MS.Entertainment.UI.Controls.fail("Failed to handle data changes in the gallery control. error: " + (error && error.message))
                            })
                    }, _updateGroupHints: function _updateGroupHints() {
                        if (this._unloaded)
                            return;
                        if (this.canZoom && this.dataSource.groupHints)
                            this._internalZoomedOutDataSource = new MS.Entertainment.Utilities.VirtualizedDataSource(this.dataSource.groupHints);
                        else {
                            this._internalZoomedOutDataSource = null;
                            this.isZoomedOut = false
                        }
                        if (this._zoomView)
                            this._zoomView.locked = !this.isZoomReady;
                        this._commitZoomedOutDataSource();
                        this.notify("canZoom", this.canZoom, false)
                    }, _commitZoomedOutDataSource: function _commitZoomedOutDataSource() {
                        if (!this._unloaded && this.isDelayInitialized && this._firstPageRendered && this._firstPagedDelayInitializedHandled && this._zoomedOutView && (!this.isZoomedOut || !this._zoomedOutView.itemDataSource))
                            this._zoomedOutView.itemDataSource = this._internalZoomedOutDataSource
                    }, _bindToDataSource: function _bindToDataSource(source) {
                        if (this._listBinding) {
                            this._listBinding.release();
                            this._listBinding = null
                        }
                        this._listBinding = source.createListBinding(this._notificationHandler)
                    }, _dataSourceContentsChanged: function _dataSourceContentsChanged(events) {
                        window.msWriteProfilerMark("ent.GalleryControl.DataSourceContentsChanged,StartTM");
                        var countChanged = false;
                        var updateGallery = false;
                        var returnPromise;
                        if (events)
                            events.forEach(function(event) {
                                if (!event)
                                    return;
                                if (event.type === MS.Entertainment.UI.Controls.GalleryListDataNotificationHandler.UpdateType.countChanged)
                                    countChanged = true;
                                if (this._initialItemCount <= 0 && event.type === MS.Entertainment.UI.Controls.GalleryListDataNotificationHandler.UpdateType.reload)
                                    updateGallery = true;
                                if (event.passedThreshold)
                                    updateGallery = true
                            }, this);
                        else
                            updateGallery = true;
                        if (updateGallery) {
                            this._updateCount++;
                            var updateCount = this._updateCount;
                            returnPromise = this.templateSelector.ensureItemTemplatesLoaded().then(function templatesLoaded() {
                                window.msWriteProfilerMark("ent.GalleryControl.TemplatesLoaded");
                                if (this._internalDataSource && this._updateCount === updateCount)
                                    return this._internalDataSource.getCount();
                                else
                                    return 0
                            }.bind(this)).then(function gotCount(count) {
                                if (this._updateCount === updateCount) {
                                    this._initialItemCount = count;
                                    if (this.invocationHelper)
                                        this.invocationHelper.clearInvocation();
                                    window.msWriteProfilerMark("ent.GalleryControl.DataSourceContentsChanged,StopTM");
                                    return this._updateLayoutAsync()
                                }
                            }.bind(this), function loadFailed() {
                                MS.Entertainment.UI.Controls.assert(false, "template load failed")
                            }.bind(this))
                        }
                        else if (countChanged)
                            this._validateSelection();
                        if (events && MS.Entertainment.Utilities.isApp2 && !document.activeElement)
                            WinJS.Promise.timeout(500).then(function delayUpdateFocus() {
                                return this.getFirstVisibleIndex()
                            }.bind(this)).done(function setFocus(index) {
                                this.setVisibleIndexFocus(index)
                            }.bind(this), function noItemToFocus(){});
                        return WinJS.Promise.as(returnPromise)
                    }, groupInfo: function getGroupInfo(userData) {
                        return {
                                enableCellSpanning: true, cellWidth: this.slotSize.width, cellHeight: this.slotSize.height
                            }
                    }, itemInfo: function getItemInfo(item) {
                        var size = {};
                        if (item === this.largeItemIndex) {
                            size.width = (this.largeItemSize && this.largeItemSize.width) ? this.largeItemSize.width : this.itemSize.width;
                            size.height = (this.largeItemSize && this.largeItemSize.height) ? this.largeItemSize.height : this._listView.layout.maxRows * this.itemSize.height + (this._listView.layout.maxRows - 1) * (this.itemMargin.top + this.itemMargin.bottom)
                        }
                        else
                            size.width = this.itemSize.width,
                            size.height = this.itemSize.height;
                        if (this.startNewColumnOnHeaders && this.dataSource && this.dataSource.isHeader && this.dataSource.isHeader(item))
                            size.newColumn = true;
                        return size
                    }, _onSnappedChanged: function _onSnappedChanged(args) {
                        if (args && args.detail && !args.detail.newValue && args.detail.oldValue && this._listView && this.dataSource && !this._firstPageRendered)
                            this._updateLayoutAsync()
                    }, _handleWindowResize: function _handleWindowResize() {
                        if (this.maxRows !== -1)
                            return;
                        var newRowCount = MS.Entertainment.Utilities.getRowCountForResolution();
                        this._updateMaxRows(this._listView, newRowCount);
                        this._updateMaxRows(this._zoomedOutView, newRowCount)
                    }, _updateMaxRows: function _updateMaxRows(listView, newRowCount) {
                        if (listView && listView.layout instanceof WinJS.UI.GridLayout && listView.layout.maxRows !== newRowCount)
                            listView.layout.maxRows = newRowCount
                    }, getFirstVisibleIndex: function getFirstVisibleIndex() {
                        return this._activeListView ? WinJS.Promise.as(this._activeListView.indexOfFirstVisible) : WinJS.Promise.wrapError(new Error("There is no first item, as there is no active list view"))
                    }, getLastVisibleIndex: function getLastVisibleIndex() {
                        return this._activeListView ? WinJS.Promise.as(this._activeListView.indexOfLastVisible) : WinJS.Promise.wrapError(new Error("There is no last item, as there is no active list view"))
                    }, getSelection: function getSelection() {
                        return this._listView ? this._listView.selection : null
                    }, setFirstVisibleIndex: function setFirstVisibleIndex(index) {
                        if (this._activeListView)
                            this._activeListView.indexOfFirstVisible = index
                    }, setReadyStateCallback: function setReadyStateCallback(callback) {
                        this._readyStateCallback = callback
                    }, setSelectedIndexChangedCallback: function setSelectedIndexChangedCallback(callback) {
                        this._selectedIndexChangedCallback = callback
                    }, getCurrentItem: function getCurrentItem() {
                        if (this._activeListView)
                            return this._activeListView.currentItem;
                        return null
                    }, setCurrentItem: function setCurrentItem(item) {
                        if (this._activeListView)
                            this._activeListView.currentItem = item
                    }, createItemRenderer: function createItemRenderer(templateType) {
                        templateType = templateType || MS.Entertainment.UI.Controls.TemplateSelectorBase.templateType.item;
                        var that = this;
                        var restoreSetImmediateModeTimer = null;
                        var placeholders = new MS.Entertainment.UI.Framework.ReferenceMap;
                        var visibleItemCount = 0;
                        var renderedItemCount = 0;
                        var delayedInitializedItemCount = 0;
                        var isItemRenderer = templateType === MS.Entertainment.UI.Controls.TemplateSelectorBase.templateType.item;
                        var usePlaceholder = (this.orientation === MS.Entertainment.UI.Controls.GalleryControl.Orientation.vertical) || MS.Entertainment.Utilities.isMusicApp2;
                        var isListLayout = isItemRenderer ? this.layout === MS.Entertainment.UI.Controls.GalleryControl.Layout.list : this.finalZoomedOutLayout === MS.Entertainment.UI.Controls.GalleryControl.Layout.list;
                        var traceId = 0;
                        this._moreThanFirstPageRendered = false;
                        var sendFirstPageRenderedIfNeeded = function sendFirstPageRenderedIfNeeded(container) {
                                var activeListView = that._activeListView;
                                if (activeListView) {
                                    if (!visibleItemCount && activeListView.indexOfLastVisible >= 0 && activeListView.indexOfFirstVisible >= 0)
                                        visibleItemCount = (activeListView.indexOfLastVisible - activeListView.indexOfFirstVisible) + 1;
                                    if (renderedItemCount === visibleItemCount && that._sendFirstPageRenderedEvent())
                                        WinJS.Promise.timeout(2500).done(function deferAria() {
                                            if (container && !container.hasAttribute("role") && activeListView && activeListView._view && activeListView._view.deferAriaSetup)
                                                activeListView._view.deferAriaSetup(visibleItemCount, 0, visibleItemCount - 1)
                                        });
                                    else if (renderedItemCount > visibleItemCount)
                                        that._moreThanFirstPageRendered = true
                                }
                            };
                        var handlePlaceholderRendered = function handlePlaceholderRendered(container) {
                                var activeListView = that._activeListView;
                                if (activeListView) {
                                    renderedItemCount++;
                                    sendFirstPageRenderedIfNeeded(container)
                                }
                            };
                        return function galleryViewItemRenderer(itemPromise, recycle) {
                                var container = document.createElement("div");
                                var placeholderRendered;
                                var data;
                                var item;
                                var template;
                                var containerReadySignal = new MS.Entertainment.UI.Framework.Signal;
                                traceId++;
                                var templateTraceId = templateType + ":" + traceId;
                                container.listViewItemContainer = true;
                                window.msWriteProfilerMark("ent:GalleryControl:DataAcquisition:" + templateTraceId + ",StartTM");
                                return {
                                        element: containerReadySignal.promise, renderComplete: itemPromise.then(function selectItemTemplate(itemPromise) {
                                                window.msWriteProfilerMark("ent:GalleryControl:DataAcquisition:" + templateTraceId + ",StopTM");
                                                window.msWriteProfilerMark("ent:GalleryControl:DataAcquired:" + itemPromise.index + ":" + templateTraceId);
                                                item = itemPromise;
                                                data = that.processItemData(item.data || item, item.index, item.key);
                                                window.msWriteProfilerMark("ent:GalleryControl:SelectTemplate:" + templateTraceId + ",StartTM");
                                                return that.templateSelector.selectTemplate(item, templateType).then(function(resultTemplate) {
                                                        template = resultTemplate;
                                                        window.msWriteProfilerMark("ent:GalleryControl:SelectTemplate:" + templateTraceId + ",StopTM")
                                                    })
                                            }).then(function renderUsablePlaceholder() {
                                                if (!template) {
                                                    MS.Entertainment.UI.Controls.fail("Template was not found for the given item");
                                                    return item.ready
                                                }
                                                if (usePlaceholder) {
                                                    var placeholder = placeholders.get(template);
                                                    if (placeholder) {
                                                        window.msWriteProfilerMark("ent:GalleryControl:RenderingListItemPlaceholder:" + templateTraceId + ",StartTM");
                                                        placeholderRendered = true;
                                                        placeholder.render(container, data);
                                                        window.msWriteProfilerMark("ent:GalleryControl:RenderingListItemPlaceholder:" + templateTraceId + ",StopTM")
                                                    }
                                                    containerReadySignal.complete(container)
                                                }
                                                if (container.parentElement && isItemRenderer)
                                                    WinJS.Utilities.removeClass(container.parentElement, "invoked");
                                                if (usePlaceholder && placeholderRendered) {
                                                    window.msWriteProfilerMark("ent:GalleryControl:ItemReadyPlaceholder:" + templateTraceId + ",StartTM");
                                                    handlePlaceholderRendered(container);
                                                    return item.ready
                                                }
                                            }).then(function renderActualTemplate() {
                                                if (usePlaceholder && placeholderRendered)
                                                    window.msWriteProfilerMark("ent:GalleryControl:ItemReadyPlaceholder:" + templateTraceId + ",StopTM");
                                                if (placeholderRendered)
                                                    container.innerHTML = String.empty;
                                                window.msWriteProfilerMark("ent:GalleryControl:RenderingListItemTemplate:" + templateTraceId + ",StartTM");
                                                return template.render(data, container).then(function() {
                                                        window.msWriteProfilerMark("ent:GalleryControl:RenderingListItemTemplate:" + templateTraceId + ",StopTM");
                                                        if (!usePlaceholder)
                                                            containerReadySignal.complete(container);
                                                        if (!usePlaceholder || !placeholderRendered) {
                                                            window.msWriteProfilerMark("ent:GalleryControl:ItemReadyNoPlaceholder:" + templateTraceId + ",StartTM");
                                                            handlePlaceholderRendered(container);
                                                            return item.ready
                                                        }
                                                    })
                                            }).then(function delayInitializeControls() {
                                                if (!usePlaceholder || !placeholderRendered)
                                                    window.msWriteProfilerMark("ent:GalleryControl:ItemReadyNoPlaceholder:" + templateTraceId + ",StopTM");
                                                sendFirstPageRenderedIfNeeded();
                                                that._raisePanelReadyOnce();
                                                if (usePlaceholder && that._firstPagedRenderedEventDispatched && container.parentElement && container.parentElement.parentElement) {
                                                    var placeholder = placeholders.get(template);
                                                    if (placeholder === undefined)
                                                        window.requestAnimationFrame(function galleryControl_generatePlaceholder() {
                                                            placeholders.set(template, MS.Entertainment.UI.Framework.getPlaceholderForElement(container))
                                                        })
                                                }
                                                if (that._firstPagedRenderedEventDispatched) {
                                                    if (restoreSetImmediateModeTimer) {
                                                        restoreSetImmediateModeTimer.cancel();
                                                        restoreSetImmediateModeTimer = null
                                                    }
                                                    MS.Entertainment.UI.Framework.setImmediateMode = MS.Entertainment.UI.Framework.setImmediateModes.panning;
                                                    restoreSetImmediateModeTimer = WinJS.Promise.timeout(MS.Entertainment.UI.Controls.GalleryControl._restoreSetImmediateModeTime).then(function() {
                                                        MS.Entertainment.UI.Framework.setImmediateMode = MS.Entertainment.UI.Framework.setImmediateModes.normal
                                                    })
                                                }
                                                that._delayInitializeContainer(container);
                                                if (container.parentElement)
                                                    container.parentElement.listViewItemContainer = true;
                                                return that._delayHydrateLibraryInfoAsync(item.data)
                                            }).then(function updateInvokedState() {
                                                var eventDetail;
                                                var itemIsInvoked = (that.invokeBehavior === MS.Entertainment.UI.Controls.GalleryControl.InvokeBehavior.inline && that.invocationHelper && that.invocationHelper.invokedKey === item.key) || that.initialInvoked === item.index;
                                                if (itemIsInvoked && isItemRenderer && that.invocationHelper) {
                                                    eventDetail = {
                                                        itemPromise: itemPromise, itemIndex: item.index, rerender: true
                                                    };
                                                    if (!container.parentElement || !container.parentElement.parentElement)
                                                        that.invocationHelper.invokeItem({
                                                            srcElement: container.parentElement || container, detail: eventDetail
                                                        });
                                                    else {
                                                        var domEvent = document.createEvent("Event");
                                                        domEvent.initEvent("iteminvoked", true, true);
                                                        domEvent.detail = eventDetail;
                                                        container.parentElement.dispatchEvent(domEvent)
                                                    }
                                                    if (that.initialInvoked !== -1)
                                                        that.scrollTo(that.initialInvoked);
                                                    else
                                                        that.initialInvoked = -1
                                                }
                                                delayedInitializedItemCount++;
                                                if (delayedInitializedItemCount === visibleItemCount)
                                                    that._handleFirstPageDelayedInitialized();
                                                return item
                                            })
                                    }
                            }
                    }, createHeaderRenderer: function createHeaderRenderer(templateType) {
                        var that = this;
                        return function galleryViewRenderGroup(groupPromise) {
                                var container = document.createElement("div");
                                var groupData;
                                if (that.headerClass)
                                    WinJS.Utilities.addClass(container, that.headerClass);
                                return {
                                        element: container, renderComplete: groupPromise.then(function selectGroupTemplate(group) {
                                                groupData = group.data;
                                                return that.templateSelector.getTemplateProvider(MS.Entertainment.UI.Controls.TemplateSelectorBase.templateType.header)
                                            }).then(function renderGroupTemplate(args) {
                                                if (!args)
                                                    return;
                                                return args.render(that.processItemData(groupData), container)
                                            })
                                    }
                            }
                    }, _updateLayoutAsync: function _updateLayoutAsync() {
                        if (this._unloaded)
                            return;
                        var cancelDragPromise;
                        if (this._dragStarted)
                            cancelDragPromise = this._cancelItemDrag().then(function itemDragCanceled() {
                                this._itemDragEndedOrCanceled();
                                this._updateLayout()
                            }.bind(this));
                        else
                            this._updateLayout();
                        return WinJS.Promise.as(cancelDragPromise)
                    }, _updateLayout: function _updateLayout() {
                        var that = this;
                        var dataSource = this._internalDataSource;
                        var loadingBehavior = this.loadingBehavior;
                        var zoomedInContainer = document.createElement("div");
                        var zoomedOutContainer;
                        var parentContainer;
                        var zoomViewContainer;
                        var emptyTemplateProvider;
                        var debugId = this.debugId || "gallery";
                        if (this._unloaded)
                            return;
                        this._calculateIndexToFocus();
                        this._clearListViewEvents();
                        this._clearZoomViewEvents();
                        this._firstPageRendered = false;
                        if (this._zoomedOutView && this._zoomedOutView.dispose)
                            this._zoomedOutView.dispose();
                        this._zoomedOutView = null;
                        if (this._listView && this._listView.dispose) {
                            if (MS.Entertainment.Utilities.isApp2)
                                window.removeEventListener("gesturedisengaged", this._listView._handleGestureDisengagedBind);
                            this._listView.dispose()
                        }
                        this._listView = null;
                        this._dragBetweenElement = null;
                        if (this._zoomView && this._zoomView.dispose)
                            this._zoomView.dispose();
                        this._zoomView = null;
                        window.msWriteProfilerMark("ent:GalleryControl.ListViewCreated,StartTM");
                        if (this.selectionStyleFilled)
                            WinJS.Utilities.addClass(zoomedInContainer, MS.Entertainment.UI.Controls.GalleryControl.selectionFilledClass);
                        if (this.canZoom) {
                            zoomViewContainer = document.createElement("div");
                            zoomedOutContainer = document.createElement("div");
                            zoomViewContainer.appendChild(zoomedInContainer);
                            zoomViewContainer.appendChild(zoomedOutContainer);
                            parentContainer = zoomViewContainer;
                            zoomViewContainer.id = debugId + "_zoomViewContainer";
                            zoomedOutContainer.id = debugId + "_zoomedOutContainer";
                            zoomedInContainer.id = debugId + "_zoomedInContainer";
                            WinJS.Utilities.addClass(zoomedInContainer, "ent-zoomedin");
                            WinJS.Utilities.addClass(zoomedOutContainer, "ent-zoomedout")
                        }
                        else {
                            parentContainer = zoomedInContainer;
                            zoomedInContainer.id = debugId
                        }
                        if (this.listViewClassName)
                            WinJS.Utilities.addClass(zoomedInContainer, this.listViewClassName);
                        if (this.blockDelayInitializeOfChildren)
                            WinJS.Utilities.addClass(parentContainer, "ent-delayInitializeBlock");
                        if (this.domElement) {
                            MS.Entertainment.Utilities.empty(this.domElement);
                            this.domElement.appendChild(parentContainer)
                        }
                        var visibleItemCount = 0;
                        var renderedItemCount = 0;
                        that._firstPagedRenderedEventDispatched = false;
                        this._firstPagedDelayInitializedHandled = false;
                        that._raisePanelResetOnce();
                        if (this.userGatedGallery) {
                            this.renderTemplate(this.userGatedGalleryTemplate, MS.Entertainment.UI.Controls.TemplateSelectorBase.templateType.userGatedGallery, this.userGatedGalleryModel, parentContainer);
                            return
                        }
                        else if (this.syncScreen) {
                            this.renderTemplate(this.syncScreenTemplate, MS.Entertainment.UI.Controls.TemplateSelectorBase.templateType.syncScreen, this.syncScreenModel, parentContainer);
                            this.syncScreenModel.action.execute();
                            return
                        }
                        else if (this.raisePanelResetEvents && this.dataSource === null)
                            return;
                        else if (this.syncScreenTemplate && MS.Entertainment.ServiceLocator.isServiceRegistered(MS.Entertainment.Services.userUsageData))
                            this._raisePanelSyncing(MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.userUsageData).isSyncing);
                        if ((this.dataSource === null) || (this._initialItemCount < this.minimumListLength)) {
                            this.renderTemplate(this.emptyGalleryTemplate, MS.Entertainment.UI.Controls.TemplateSelectorBase.templateType.emptyGallery, this.emptyGalleryModel, parentContainer);
                            if (that.dataSource !== null) {
                                that._bindToDataSource(dataSource);
                                dataSource.invalidateAll()
                            }
                            if (!this._unloaded && !!this.dataSource) {
                                that._sendFirstPageRenderedEvent();
                                that._handleFirstPageDelayedInitialized()
                            }
                            return
                        }
                        else
                            that._raisePanelEmpty(false);
                        var groupedDataSource = this.getGroupedDataSource();
                        this._bindToDataSource(groupedDataSource || dataSource);
                        var layoutOptions = this.layoutOptions || {};
                        layoutOptions.horizontal = this.horizontal;
                        layoutOptions.groupHeaderPosition = this.headerPosition === "inline" ? "left" : this.headerPosition;
                        if (this.maxRows >= 0)
                            layoutOptions.maxRows = this.maxRows;
                        else if (this.maxRows < 0)
                            layoutOptions.maxRows = MS.Entertainment.Utilities.getRowCountForResolution();
                        if (this.multiSize) {
                            layoutOptions.groupInfo = this.groupInfo.bind(this);
                            layoutOptions.itemInfo = this.itemInfo.bind(this)
                        }
                        var isListLayout = this.layout === MS.Entertainment.UI.Controls.GalleryControl.Layout.list;
                        var layout;
                        if (this.shrinkAndStayHeader)
                            layout = isListLayout ? new MS.Entertainment.UI.Controls.ShrinkAndStayListLayout(layoutOptions) : new MS.Entertainment.UI.Controls.ShrinkAndStayGridLayout(layoutOptions);
                        else
                            layout = isListLayout ? new WinJS.UI.ListLayout(layoutOptions) : new WinJS.UI.GridLayout(layoutOptions);
                        if (this.backdropColor && typeof layout.dragOver !== "function") {
                            layout.backdropColor = this.backdropColor;
                            layout.disableBackdrop = (this.backdropColor === "transparent")
                        }
                        if (this.itemsReorderable && layout.dragOver && layout.dragLeave) {
                            layout.dragOver = this._handleDragOver.bind(this);
                            layout.dragLeave = this._handleDragLeave.bind(this)
                        }
                        if (this.orientation)
                            layout.orientation = this.orientation;
                        this._listView = new WinJS.UI.ListView(zoomedInContainer, {
                            resetItem: MS.Entertainment.UI.Controls.GalleryControl.resetItem, layout: layout, itemDataSource: groupedDataSource || dataSource, groupDataSource: groupedDataSource && groupedDataSource.groups, selectionMode: MS.Entertainment.Utilities.isApp2 ? MS.Entertainment.UI.Controls.GalleryControl.SelectionMode.none : this.selectionMode, tapBehavior: this.tap, itemsDraggable: this.itemsDraggable, swipeBehavior: MS.Entertainment.Utilities.isApp2 ? MS.Entertainment.UI.Controls.GalleryControl.swipeBehavior.none : this.swipeBehavior, loadingBehavior: loadingBehavior, pagesToLoad: this.pagesToLoad, groupHeaderTemplate: this.createHeaderRenderer(), itemTemplate: this.createItemRenderer(), itemsReorderable: this.itemsReorderable
                        });
                        WinJS.Utilities.addClass(zoomedInContainer, "win-disposable");
                        zoomedInContainer.setAttribute("data-win-control", "WinJS.UI.ListView");
                        if (zoomedOutContainer) {
                            var isZoomedOutListLayout = this.finalZoomedOutLayout === MS.Entertainment.UI.Controls.GalleryControl.Layout.list;
                            var zoomedOutLayout;
                            var zoomedOutOptions;
                            if (this.backdropColor && typeof layout.dragOver !== "function")
                                zoomedOutOptions = {
                                    backdropColor: this.backdropColor, disableBackdrop: (this.backdropColor === "transparent")
                                };
                            zoomedOutLayout = isZoomedOutListLayout ? new WinJS.UI.ListLayout(zoomedOutOptions) : new WinJS.UI.GridLayout(zoomedOutOptions);
                            this._zoomedOutView = new WinJS.UI.ListView(zoomedOutContainer, {
                                resetItem: MS.Entertainment.UI.Controls.GalleryControl.resetItem, zoomedOut: this.initialZoomedOut, layout: zoomedOutLayout, itemsDraggable: false, selectionMode: MS.Entertainment.UI.Controls.GalleryControl.SelectionMode.none, swipeBehavior: MS.Entertainment.UI.Controls.GalleryControl.swipeBehavior.none, itemTemplate: this.createItemRenderer(this.finalZoomedOutTemplateType)
                            });
                            WinJS.Utilities.addClass(zoomedOutContainer, "win-disposable");
                            zoomedOutContainer.setAttribute("data-win-control", "WinJS.UI.ListView")
                        }
                        if (zoomViewContainer) {
                            this._zoomView = new WinJS.UI.SemanticZoom(zoomViewContainer);
                            this._zoomView.locked = !this.isZoomReady;
                            WinJS.Utilities.addClass(zoomViewContainer, "win-disposable");
                            zoomViewContainer.setAttribute("data-win-control", "WinJS.UI.SemanticZoom")
                        }
                        window.msWriteProfilerMark("ent:GalleryControl.ListViewCreated,StopTM");
                        if (this.initialSelected !== -1) {
                            this._listView.selection.set(this.initialSelected);
                            this._setSelectedIndex(this.initialSelected);
                            this.initialSelected = -1
                        }
                        if (this.initialInvoked >= 0) {
                            this.ensureVisible(this.initialInvoked);
                            this.setIndexFocus(this.initialInvoked)
                        }
                        else if (this.initialVisible >= 0) {
                            this.ensureVisible(this.initialVisible);
                            this.setIndexFocus(this.initialVisible)
                        }
                        this.refreshGalleryWidth();
                        if (this.forceInteractive) {
                            var currentMode = this._listView._mode;
                            currentMode.isInteractive = this._isElementInteractive.bind(this)
                        }
                        if (this.handleFocus) {
                            if (!this._focusEventHandler)
                                this._focusEventHandler = MS.Entertainment.Utilities.addEventHandlers(this.domElement, {focusin: this._onFocusin.bind(this)})
                        }
                        else if (this._focusEventHandler) {
                            this._focusEventHandler.cancel();
                            this._focusEventHandler = null
                        }
                        var _cachedSelectedItemsCount = 0;
                        var handleSelectionChanging = function(event) {
                                if (!event || !event.detail || !event.detail.newSelection) {
                                    MS.Entertainment.UI.Controls.fail("Invalid event passed to handlerSelectionChanging");
                                    return
                                }
                                var nonSourceIndices;
                                var oldIndices;
                                var newIndices;
                                var equal;
                                if (event.detail.newSelection.count()) {
                                    if (that.dataSource)
                                        nonSourceIndices = that.dataSource.nonSourceIndices;
                                    that._userSelectedEverything = that.selectionMode === MS.Entertainment.UI.Controls.GalleryControl.SelectionMode.multi && (event.detail.newSelection.isEverything() || (that._userSelectedEverything && event.detail.newSelection.count() >= _cachedSelectedItemsCount));
                                    _cachedSelectedItemsCount = event.detail.newSelection.count();
                                    if (nonSourceIndices && nonSourceIndices.length) {
                                        event.detail.newSelection.remove(nonSourceIndices);
                                        oldIndices = that._listView.selection.getIndices();
                                        newIndices = event.detail.newSelection.getIndices()
                                    }
                                    if (that.maxSelectionCount >= 0 && that.maxSelectionCount < _cachedSelectedItemsCount) {
                                        oldIndices = oldIndices || that._listView.selection.getIndices();
                                        newIndices = newIndices || event.detail.newSelection.getIndices();
                                        if (newIndices && newIndices.length > that.maxSelectionCount) {
                                            newIndices = newIndices.slice(0, that.maxSelectionCount);
                                            event.detail.newSelection.set(newIndices)
                                        }
                                    }
                                    if (newIndices && oldIndices && newIndices.length === oldIndices.length) {
                                        equal = true;
                                        for (var index in newIndices)
                                            if (newIndices[index] !== oldIndices[index]) {
                                                equal = false;
                                                break
                                            }
                                    }
                                }
                                else
                                    that._userSelectedEverything = false;
                                if (equal)
                                    event.preventDefault()
                            };
                        var handleSelectionChanged = function(event) {
                                that._updateSelection();
                                that._sendFirstPageRenderedEventOnInteraction()
                            };
                        var initializeSelection = true;
                        var handleReadyStateChanged = function(eventObject) {
                                var readyState = that._listView ? that._listView.loadingState : MS.Entertainment.UI.Controls.GalleryControl.ReadyState.itemsLoading;
                                if (readyState === MS.Entertainment.UI.Controls.GalleryControl.ReadyState.complete) {
                                    this._eventProvider.traceGalleryControl_Load_End();
                                    this._sendFirstPageRenderedEvent();
                                    if (initializeSelection) {
                                        initializeSelection = false;
                                        this._raisePanelReadyOnce()
                                    }
                                    var lastNavigationWasPage = true;
                                    if (MS.Entertainment.ServiceLocator.isServiceRegistered(MS.Entertainment.Services.navigation))
                                        lastNavigationWasPage = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.navigation).lastNavigationWasPage;
                                    if ((this.focusFirstItemOnPageLoad && lastNavigationWasPage) || (this.restoreFocusOnDataChanges && this._restoreFocusIndex !== -1)) {
                                        this.focusFirstItemOnPageLoad = false;
                                        MS.Entertainment.Utilities.schedulePromiseBelowNormal().then(function focusFirstElement() {
                                            if (this._listView) {
                                                if (document.activeElement && this._listView.element.contains(document.activeElement))
                                                    return;
                                                var index = 0;
                                                if (this._restoreFocusIndex !== -1) {
                                                    index = this._restoreFocusIndex;
                                                    this._restoreFocusIndex = -1
                                                }
                                                else if (this.dataSource && this.dataSource.indexFromSourceIndex)
                                                    index = this.dataSource.indexFromSourceIndex(0);
                                                this.setVisibleIndexFocus(index)
                                            }
                                        }.bind(this))
                                    }
                                    that.refreshGalleryWidth()
                                }
                                else {
                                    if (this.preventResizeJitter && readyState === MS.Entertainment.UI.Controls.GalleryControl.ReadyState.viewPortLoaded && this._listView) {
                                        var surfaceHeight = this.calculateHeightToShowAllItems();
                                        if (surfaceHeight && this._listView._element && this._listView._element.style)
                                            this._listView._element.style.height = surfaceHeight + "px"
                                    }
                                    this._eventProvider.traceGalleryControl_LoadingState_Changed(readyState)
                                }
                                this._raiseGalleryReadyState(readyState, eventObject)
                            }.bind(this);
                        var handleContentAnimating = function(eventObject) {
                                eventObject.preventDefault();
                                WinJS.UI.Animation.enterContent(eventObject.currentTarget)
                            }.bind(this);
                        var handleClick = function handleClick(event) {
                                if (this.isZoomReady && event.srcElement && WinJS.Utilities.hasClass(event.srcElement, MS.Entertainment.UI.Controls.GalleryControl.zoomedOutClass)) {
                                    this.isZoomedOut = true;
                                    this._semanticZoomInitType = MS.Entertainment.UI.Controls.GalleryControl.SemanticZoomSelected.headerClick
                                }
                            }.bind(this);
                        var handleDoubleClick = function handleDoubleClick(event) {
                                if (this.doubleClickBehavior === MS.Entertainment.UI.Controls.GalleryControl.DoubleClickBehavior.play && this.doubleClickHelper)
                                    this.doubleClickHelper.execute();
                                else if (this.doubleClickBehavior === MS.Entertainment.UI.Controls.GalleryControl.DoubleClickBehavior.action)
                                    if (this.doubleClickActionOptions) {
                                        event.preventDefault();
                                        event.stopPropagation();
                                        var actionOptions = this.doubleClickActionOptions || {};
                                        var actionParameter = this.doubleClickActionOptions.parameter || {};
                                        actionParameter.data = data.data;
                                        actionParameter.filter = actionOptions.filter;
                                        var action = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.actions).getAction(actionOptions.id);
                                        action.parameter = actionParameter;
                                        action.automationId = action.automationId || this.doubleClickActionOptions.automationId;
                                        action.execute()
                                    }
                            }.bind(this);
                        var handleMouseDown = function handleMouseDown(event) {
                                this._pendingSelectionFromInvoke = -1;
                                var isInteractive = this._listView._mode ? this._listView._mode.isInteractive : null;
                                var downIndex = this._listView.indexOfElement(event.srcElement);
                                var downItemKey;
                                var validIndex = false;
                                if (this.dataSource)
                                    if (this.dataSource.keyFromIndex) {
                                        downItemKey = this.dataSource.keyFromIndex(downIndex);
                                        validIndex = !!downItemKey
                                    }
                                    else
                                        validIndex = true;
                                if (validIndex)
                                    if (!this.isZoomReady && this.dataSource && this.dataSource.isHeader && this.dataSource.isHeader(downIndex))
                                        event.stopPropagation();
                                    else if (downIndex >= 0 && this.invocationHelper && this.invocationHelper.invokedIndex >= 0 && downIndex !== this.invocationHelper.invokedIndex && downItemKey !== this.invocationHelper.invokedKey && (!isInteractive || !isInteractive(event.srcElement))) {
                                        if (this.selectionMode === MS.Entertainment.UI.Controls.GalleryControl.SelectionMode.multi)
                                            this._pendingSelectionFromInvoke = this.invocationHelper.invokedIndex;
                                        this.invocationHelper.clearInvocation()
                                    }
                            }.bind(this);
                        var handleKeyDown = function handleKeyDown(event) {
                                if (!event)
                                    return;
                                if (this.isZoomReady && event.keyCode === WinJS.Utilities.Key.invokeSemanticZoom) {
                                    this.isZoomedOut = !this.isZoomedOut;
                                    if (MS.Entertainment.Utilities.isApp2)
                                        this._semanticZoomInitType = MS.Entertainment.UI.Controls.GalleryControl.SemanticZoomSelected.keyUp;
                                    else
                                        this._semanticZoomInitType = MS.Entertainment.UI.Controls.GalleryControl.SemanticZoomSelected.keyDown
                                }
                                else if (event.ctrlKey && !event.altKey && !event.shiftKey && event.keyCode === WinJS.Utilities.Key.a && !this.allowSelectAll)
                                    event.stopPropagation();
                                else if (this._isElementInteractive(event.target) && this.invocationHelper && this._listView.currentItem && this._listView.currentItem.index === this.invocationHelper.invokedIndex && this.layout === MS.Entertainment.UI.Controls.GalleryControl.Layout.list && (event.keyCode === WinJS.Utilities.Key.downArrow || event.keyCode === WinJS.Utilities.Key.upArrow))
                                    this._ignoreNextInteractiveCheck = true;
                                else if (this.invocationHelper && this._listView.currentItem && this._listView.currentItem.index === this.invocationHelper.invokedIndex && event.keyCode === WinJS.Utilities.Key.enter && WinJS.Utilities.hasClass(event.srcElement, "win-item"))
                                    handleDoubleClick(event)
                            }.bind(this);
                        if (this.layout === MS.Entertainment.UI.Controls.GalleryControl.Layout.list) {
                            var originalListViewResize = this._listView._onResize;
                            this._listView._onResize = function onListViewResize() {
                                if (this._listView && this.visibility)
                                    originalListViewResize.apply(this._listView, arguments)
                            }.bind(this)
                        }
                        var handleScrolledFocusChange = function handleScrolledFocusChange(event) {
                                if (this.ensureNextItemVisibleCount) {
                                    this.setVisibleIndexFocus(event.detail.newFocus);
                                    this.ensureVisible(event.detail.newFocus + this.ensureNextItemVisibleCount)
                                }
                                this.dispatchEvent("scrolledFocusChanged", {
                                    newValue: event.detail.newFocus, oldValue: event.detail.oldFocus
                                });
                                this._updateScrollStyles()
                            }.bind(this);
                        var listViewEventHandlers = {
                                loadingstatechanged: handleReadyStateChanged, selectionchanged: handleSelectionChanged, selectionchanging: handleSelectionChanging, iteminvoked: this._itemInvoked, keyboardnavigating: handleScrolledFocusChange
                            };
                        if (this._isDragAndDropEnabled()) {
                            listViewEventHandlers.itemdragstart = this._itemDragStarted.bind(this);
                            listViewEventHandlers.itemdragend = this._itemDragEndedOrCanceled.bind(this)
                        }
                        if (this.itemsReorderable)
                            listViewEventHandlers.itemdragbetween = this._handleItemDragBetween.bind(this);
                        this._listViewEventHandler = MS.Entertainment.Utilities.addEventHandlers(this._listView, listViewEventHandlers);
                        var keyEvent = MS.Entertainment.Utilities.isApp1 ? "keydown" : "keyup";
                        if (this._zoomView) {
                            var handleZoomPointerDown = this._zoomingIn.bind(this);
                            var zoomEventHandlers = {
                                    MSPointerDown: handleZoomPointerDown, pointerDown: handleZoomPointerDown, zoomchanged: this._zoomChanged.bind(this)
                                };
                            zoomEventHandlers[keyEvent] = this._zoomingIn.bind(this);
                            this._zoomViewEventHandler = MS.Entertainment.Utilities.addEventHandlers(this._zoomView, zoomEventHandlers)
                        }
                        if (layout && (!layout.dragOver || (typeof layout.dragOver !== "function")))
                            this._listView.oncontentanimating = handleContentAnimating;
                        var listViewCaptureEventHandlers = {
                                MSPointerDown: handleMouseDown, pointerdown: handleMouseDown, click: handleClick, dblclick: handleDoubleClick
                            };
                        listViewCaptureEventHandlers[keyEvent] = handleKeyDown;
                        if (this._isDragAndDropEnabled())
                            listViewCaptureEventHandlers.dragstart = this._onDragStartCapture.bind(this);
                        this._listViewEventCaptureHandler = MS.Entertainment.Utilities.addEventHandlers(this._listView, listViewCaptureEventHandlers, true);
                        var systemMediaTransportControls = WinJS.Utilities.getMember("Windows.Media.SystemMediaTransportControls");
                        if (MS.Entertainment.Utilities.isApp2 && systemMediaTransportControls && this.allowZoom) {
                            var systemMediaTransportControlsView = systemMediaTransportControls.getForCurrentView();
                            var systemMediaButtons = Windows.Media.SystemMediaTransportControlsButton;
                            systemMediaTransportControlsView.isViewEnabled = true;
                            systemMediaTransportControlsView.displayUpdater.update();
                            this._mediaControlEventHandler = MS.Entertainment.Utilities.addEventHandlers(systemMediaTransportControlsView, {buttonpressed: function buttonpressed(evt) {
                                    if (!this._mediaControlCommandEnabled)
                                        return;
                                    if (evt && evt.detail)
                                        evt.detail.forEach(function eventIterator(event) {
                                            var actionService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.actions);
                                            switch (event.button) {
                                                case systemMediaButtons.view:
                                                    if (this.isZoomReady) {
                                                        this.isZoomedOut = !this.isZoomedOut;
                                                        this._semanticZoomInitType = MS.Entertainment.UI.Controls.GalleryControl.SemanticZoomSelected.mediaTransportControl
                                                    }
                                                    break
                                            }
                                        }.bind(this))
                                }.bind(this)})
                        }
                    }, renderTemplate: function renderTemplate(template, templateType, galleryModel, parentContainer) {
                        if (template)
                            this.templateSelector.getTemplateProvider(templateType).then(function renderTemplate(templateProvider) {
                                if (templateProvider)
                                    templateProvider.render(galleryModel, parentContainer).done(function focusFirstItem() {
                                        MS.Entertainment.UI.Framework.tryAndFocusElementInSubTreeWithTimer(parentContainer, 250).done(function focusFirstItemTryTwo() {
                                            MS.Entertainment.UI.Framework.tryAndFocusElementInSubTreeWithTimer(parentContainer, 250).done(function focusFirstItemTryThree() {
                                                MS.Entertainment.UI.Framework.tryAndFocusElementInSubTreeWithTimer(parentContainer, 250)
                                            })
                                        })
                                    });
                                this._raisePanelReadyOnce();
                                this._raiseGalleryReadyState(MS.Entertainment.UI.Controls.GalleryControl.ReadyState.complete);
                                this._raisePanelEmpty(true)
                            }.bind(this));
                        else {
                            this._raisePanelReadyOnce();
                            this._raiseGalleryReadyState(MS.Entertainment.UI.Controls.GalleryControl.ReadyState.complete)
                        }
                    }, _isElementInteractive: function _isElementInteractive(element) {
                        var isInteractive = element && !this._ignoreNextInteractiveCheck && this.forceInteractive && ((element.type === "button") || (element.winControl && element.winControl.isInteractive));
                        this._ignoreNextInteractiveCheck = false;
                        return isInteractive
                    }, _zoomingInIndexPromise: null, _zoomingIn: function _zoomingIn(event) {
                        if (this._disposed)
                            return;
                        var downIndex;
                        if (MS.Entertainment.Utilities.isApp2 && this.isZoomedOut && this._zoomView && this._zoomView._zoom)
                            switch (event.keyCode) {
                                case WinJS.Utilities.Key.dismissButton:
                                case WinJS.Utilities.Key.backspace:
                                    this._zoomView._zoom(false);
                                    event.stopPropagation();
                                    event.stopImmediatePropagation();
                                    return
                            }
                        if (this._zoomedOutView && this._zoomedOutView.itemDataSource && this.isZoomedOut && event && event.srcElement)
                            downIndex = this._zoomedOutView.indexOfElement(event.srcElement);
                        if (downIndex >= 0)
                            this._zoomingInIndexPromise = this._zoomedOutView.itemDataSource.itemFromIndex(downIndex);
                        else
                            this._zoomingInIndexPromise = null;
                        if (WinJS.Utilities.hasClass(event.target, "win-semanticzoom-button"))
                            this._semanticZoomInitType = MS.Entertainment.UI.Controls.GalleryControl.SemanticZoomSelected.minusClick
                    }, _semanticZoomInit: function _semanticZoomInit() {
                        if (!this._semanticZoomInitType)
                            this._semanticZoomInitType = MS.Entertainment.UI.Controls.GalleryControl.SemanticZoomSelected.pinch;
                        MS.Entertainment.Utilities.Telemetry.logSemanticZoom(this._semanticZoomInitType);
                        this._semanticZoomInitType = null
                    }, _zoomChanged: function _zoomChanged(event) {
                        if (this._disposed)
                            return;
                        msWriteProfilerMark("ent:GalleryControl:zoomedChanged:" + event.detail);
                        this.isZoomedOut = event.detail;
                        if (this.isZoomedOut)
                            this._semanticZoomInit();
                        this.clearInvocation();
                        this.clearSelection();
                        if (this.queryToPause)
                            if (this.isZoomedOut)
                                this.queryToPause.pause();
                            else
                                WinJS.Promise.timeout(5000).done(function() {
                                    if (this.queryToPause)
                                        this.queryToPause.unpause()
                                }.bind(this));
                        this._commitZoomedOutDataSource();
                        if (this._zoomingInIndexPromise) {
                            this._zoomingInIndexPromise.then(function wait(item) {
                                return MS.Entertainment.Utilities.redirectPromise(WinJS.Promise.timeout(), item)
                            }).done(function zoomedOutItem(item) {
                                if (item && item.firstItemIndexHint >= 0)
                                    this.ensureVisible(item.firstItemIndexHint)
                            }.bind(this), function ignoreError(error) {
                                MS.Entertainment.UI.Controls.fail("Ensure visible failed during a zoom-in. Error message: " + (error && error.message))
                            });
                            this._zoomingInIndexPromise = null
                        }
                    }, _pageChanged: function _pageChanged(newValue, oldValue) {
                        if (this.invocationHelper)
                            this.invocationHelper.clearInvocation();
                        this.clearSelection();
                        if (this._selectionHelper) {
                            this._selectionHelper.dispose();
                            this._selectionHelper = null
                        }
                    }, _sendFirstPageRenderedEventOnInteraction: function _sendFirstPageRenderedEventOnInteraction() {
                        if (this._moreThanFirstPageRendered)
                            this._sendFirstPageRenderedEvent()
                    }, _sendFirstPageRenderedEvent: function _sendFirstPageRenderedEvent() {
                        var eventSent = false;
                        if (!this._firstPagedRenderedEventDispatched) {
                            window.msWriteProfilerMark("ent:galleryFirstPageRendered,StartTM");
                            eventSent = true;
                            this._firstPagedRenderedEventDispatched = true;
                            this._firstPageRendered = true;
                            WinJS.Promise.timeout(1).done(function sendFirstPageRenderedEvent() {
                                window.msWriteProfilerMark("ent:galleryFirstPageRendered,StopTM");
                                var domEvent = document.createEvent("Event");
                                domEvent.initEvent("galleryFirstPageRendered", true, true);
                                this.domElement.dispatchEvent(domEvent)
                            }.bind(this), function handleError(error) {
                                window.msWriteProfilerMark("ent:galleryFirstPageRendered,StopTM");
                                MS.Entertainment.UI.Controls.fail("Failed to handle first page rendered. error: " + (error && error.message))
                            });
                            this._updateScrollStyles()
                        }
                        return eventSent
                    }, _handleFirstPageDelayedInitialized: function _handleFirstPageDelayedInitialized() {
                        if (!this._firstPagedDelayInitializedHandled) {
                            window.msWriteProfilerMark("ent:galleryFirstPageDelayedInitialized,StartTM");
                            this._firstPagedDelayInitializedHandled = true;
                            MS.Entertainment.Utilities.schedulePromiseBelowNormal().done(function _handleFirstPageDelayedInitializedWork() {
                                window.msWriteProfilerMark("ent:galleryFirstPageDelayedInitialized,StopTM");
                                this._commitZoomedOutDataSource()
                            }.bind(this), function handleError(error) {
                                window.msWriteProfilerMark("ent:galleryFirstPageRendered,StopTM");
                                MS.Entertainment.UI.Controls.fail("Failed to handle first page delay initialized. error: " + (error && error.message))
                            })
                        }
                    }, _handleItemDragBetween: function _handleItemDragBetween(args) {
                        var dragOverInsertAfterIndex = -1;
                        var dragOverInsertBeforeIndex = -1;
                        if (args && args.detail && !isNaN(args.detail.index) && typeof args.detail.index === "number" && !isNaN(args.detail.insertAfterIndex) && typeof args.detail.insertAfterIndex === "number") {
                            dragOverInsertBeforeIndex = args.detail.index;
                            dragOverInsertAfterIndex = args.detail.insertAfterIndex
                        }
                        this._handleDragLeave();
                        if (dragOverInsertAfterIndex >= 0) {
                            this._dragBetweenElement = this.getElementAtIndex(dragOverInsertAfterIndex);
                            MS.Entertainment.Utilities.safeAddClass(this._dragBetweenElement, MS.Entertainment.UI.Controls.GalleryControl.dragInsertAfterClass)
                        }
                        else if (dragOverInsertBeforeIndex === 0) {
                            this._dragBetweenElement = this.getElementAtIndex(dragOverInsertBeforeIndex);
                            MS.Entertainment.Utilities.safeAddClass(this._dragBetweenElement, MS.Entertainment.UI.Controls.GalleryControl.dragInsertBeforeClass)
                        }
                        else
                            this._dragBetweenElement = null
                    }, _handleDragOver: function _handleDragOver(x, y, dragInfo){}, _handleDragLeave: function _handleDragLeave() {
                        MS.Entertainment.Utilities.safeRemoveClass(this._dragBetweenElement, MS.Entertainment.UI.Controls.GalleryControl.dragInsertAfterClass);
                        MS.Entertainment.Utilities.safeRemoveClass(this._dragBetweenElement, MS.Entertainment.UI.Controls.GalleryControl.dragInsertBeforeClass);
                        this._dragBetweenElement = null
                    }, _updateScrollStyles: function updateScrollStyles() {
                        if (MS.Entertainment.Utilities.isApp1 || this.layout === MS.Entertainment.UI.Controls.GalleryControl.Layout.grid)
                            return;
                        if (this._activeListView && this._activeListView.indexOfLastVisible < this._initialItemCount - 1)
                            WinJS.Utilities.addClass(this.domElement, "ent-scrollable-down");
                        else
                            WinJS.Utilities.removeClass(this.domElement, "ent-scrollable-down");
                        if (this._activeListView && this._activeListView.indexOfFirstVisible > 0)
                            WinJS.Utilities.addClass(this.domElement, "ent-scrollable-up");
                        else
                            WinJS.Utilities.removeClass(this.domElement, "ent-scrollable-up")
                    }, refreshGalleryWidth: function refreshGalleryWidth() {
                        if (this.autoSize && this._listView) {
                            var calculatedWidth = this.calculateWidthToShowAllItems();
                            this.domElement.style.width = Math.max(calculatedWidth, this.autoSizeMin, 1) + "px"
                        }
                        else
                            this.domElement.style.width = ""
                    }, calculateWidthToShowAllItems: function calculateWidthToShowAllItems() {
                        return this._listView._canvas.scrollWidth
                    }, calculateHeightToShowAllItems: function calculateHeightToShowAllItems() {
                        return this._listView._canvas.scrollHeight
                    }, _updateInvokeHelper: function _updateInvokeHelper() {
                        this._clearInvocationHelper();
                        this._initializeInvocationHelper()
                    }, _initializeInvocationHelper: function _initializeInvocationHelper() {
                        if (!this.invocationHelper && this.invokeHelperFactory && this.isDelayInitialized && this.invokeBehavior === MS.Entertainment.UI.Controls.GalleryControl.InvokeBehavior.inline) {
                            this.invocationHelper = this.invokeHelperFactory(this);
                            this._invocationHelperEvents = MS.Entertainment.Utilities.addEventHandlers(this.invocationHelper, {invokedItemChanged: this._invokeItemChanged.bind(this)})
                        }
                        return this.invocationHelper
                    }, _clearInvocationHelper: function _clearInvocationHelper() {
                        if (this._invocationHelperEvents) {
                            this._invocationHelperEvents.cancel();
                            this._invocationHelperEvents = null
                        }
                        if (this.invocationHelper) {
                            this.invocationHelper.dispose();
                            this._invokeItemChanged({detail: {
                                    newValue: null, oldValue: this.invocationHelper.invokedItem
                                }});
                            this.invocationHelper = null
                        }
                    }, _invokeItemChanged: function _invokedItemChanged(args) {
                        if (this.queryToPause && args && args.detail)
                            if (!args.detail.oldValue && args.detail.newValue)
                                this.queryToPause.pause();
                            else if (args.detail.oldValue && !args.detail.newValue)
                                this.queryToPause.unpause()
                    }, canInvokeForItem: function canInvokeForItem(item) {
                        return (!item || !item.isHeader || (this.isZoomReady && !this.isZoomedOut)) && this.canInvokeForItemOverride(item)
                    }, canInvokeForItemOverride: function canInvokeForItemOverride(item) {
                        return true
                    }, canToggleInvokeForItem: function canToggleInvokeForItem(item) {
                        return this._invokeBehavior === MS.Entertainment.UI.Controls.GalleryControl.InvokeBehavior.inline && this.canInvokeForItem(item) && !item.isAction
                    }, itemInvoked: function itemInvoked(event) {
                        if (this.tap === MS.Entertainment.UI.Controls.GalleryControl.Tap.toggleSelect) {
                            MS.Entertainment.UI.Controls.assert(this.invokeBehavior === MS.Entertainment.UI.Controls.GalleryControl.InvokeBehavior.none, "Cannot use tap=toggleSelect and specify an invokeBehavior other than none");
                            return
                        }
                        if (this.suppressInvokeBubble)
                            event.stopPropagation();
                        event.detail.itemPromise.then(function getItemData(data) {
                            if (!data || !data.data) {
                                MS.Entertainment.UI.Controls.fail("Invalid data returned from item promise during handling of an item invoked.");
                                return
                            }
                            if (!this.canInvokeForItem(data))
                                return;
                            if (this.selectedIndices && this.selectedIndices.length > 0)
                                this.clearSelection();
                            this._sendFirstPageRenderedEventOnInteraction();
                            MS.Entertainment.Utilities.playSelectButtonClick();
                            if (data && data.isHeader) {
                                this.isZoomedOut = true;
                                this._semanticZoomInitType = MS.Entertainment.UI.Controls.GalleryControl.SemanticZoomSelected.headerClick
                            }
                            else if (data && data.isAction && data.data && data.data.action) {
                                data.data.action.referenceContainer = {domElement: event.target.querySelector("button .win-commandicon") || event.target};
                                var actionPromise = data.data.action.execute();
                                data.data.action.referenceContainer = null;
                                if (actionPromise && data.data.isModifier) {
                                    var itemIndex = this._listView.currentItem.index;
                                    actionPromise.done(function changeIndexOnGalleryLoad(modifierChanged) {
                                        if (this.restoreFocusOnDataChanges && modifierChanged)
                                            this._restoreFocusIndex = itemIndex
                                    }.bind(this))
                                }
                            }
                            else if (this.invokeBehavior === MS.Entertainment.UI.Controls.GalleryControl.InvokeBehavior.popOver) {
                                var currentPage = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.navigation).currentPage;
                                if (currentPage) {
                                    data.hasFocus = true;
                                    WinJS.Binding.unwrap(currentPage).specialFocusedElement = {
                                        listView: this._listView, item: data
                                    }
                                }
                                if (data.data.mediaType === Microsoft.Entertainment.Queries.ObjectType.video && (data.data.videoType === Microsoft.Entertainment.Queries.VideoType.other || data.data.videoType === Microsoft.Entertainment.Queries.VideoType.musicVideo)) {
                                    MS.Entertainment.Instrumentation.PerfTrack.setStartTime(MS.Entertainment.Instrumentation.PerfTrack.StartPoints.PlayCommand);
                                    MS.Entertainment.Instrumentation.PerfTrack.enableScenarioPlayNonProtectedInApp();
                                    MS.Entertainment.Platform.PlaybackHelpers.showImmersiveDetails(data.data, false, true)
                                }
                                else {
                                    var popOverParameters = this.createPopOverParameters(data);
                                    MS.Entertainment.Platform.PlaybackHelpers.showItemDetails(popOverParameters)
                                }
                            }
                            else if (this.invokeBehavior === MS.Entertainment.UI.Controls.GalleryControl.InvokeBehavior.inline) {
                                MS.Entertainment.UI.Controls.assert(!this.isDelayInitialized || this.invocationHelper, "inline behavior requires an invocation helper");
                                if (!this.doubleClickHelper)
                                    this.doubleClickHelper = MS.Entertainment.UI.Controls.GalleryControlDoubleClickHelper.create(this);
                                this.doubleClickHelper.wrapItemInvoke(event, data)
                            }
                            else if (this.invokeBehavior === MS.Entertainment.UI.Controls.GalleryControl.InvokeBehavior.details) {
                                var popOverParameters = this.createPopOverParameters(data);
                                MS.Entertainment.Platform.PlaybackHelpers.showItemDetails(popOverParameters)
                            }
                            else if (this.invokeBehavior === MS.Entertainment.UI.Controls.GalleryControl.InvokeBehavior.action) {
                                var actionOptions = this.actionOptions || {};
                                var actionParameter = this.actionOptions.parameter || {};
                                actionParameter.data = data.data;
                                actionParameter.filter = actionOptions.filter;
                                var action = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.actions).getAction(actionOptions.id);
                                action.parameter = actionParameter;
                                action.automationId = action.automationId || this.actionOptions.automationId;
                                action.execute().done()
                            }
                        }.bind(this))
                    }, _cancelItemDrag: function _cancelItemDrag() {
                        var cancelDragSignal = new MS.Entertainment.UI.Framework.Signal;
                        var cancelDragHandler = MS.Entertainment.Utilities.addEventHandlers(this._listView, {drag: function cancelDrag(event) {
                                    if (!cancelDragHandler)
                                        return;
                                    cancelDragHandler.cancel();
                                    cancelDragHandler = null;
                                    event.preventDefault();
                                    cancelDragSignal.complete()
                                }.bind(this)});
                        return cancelDragSignal.promise
                    }, _onDragStartCapture: function _onDragStartCapture(event) {
                        if (this.selectionMode === MS.Entertainment.UI.Controls.GalleryControl.SelectionMode.single)
                            this.clearSelection();
                        else if (this.hasSelectionOrInvocation) {
                            var index = this._listView.indexOfElement(event.srcElement);
                            this._listView.selection.add(index)
                        }
                    }, _itemDragStarted: function _itemDragStarted(event) {
                        var dragDataPromise;
                        var indices = event.detail.dragInfo.getIndices();
                        if (indices && indices.length === 1) {
                            var index = indices[0];
                            dragDataPromise = this.getItemAtIndex(index).then(function saveDraggedMediaItem(mediaItem) {
                                return {data: mediaItem && mediaItem.data}
                            })
                        }
                        else {
                            MS.Entertainment.UI.Controls.assert(this.selectedItems && this.selectedItems.count, "GalleryControl::_itemDragStarted: Drag started for multiple items, but no selection was found in the list.");
                            if (this.selectedItems)
                                dragDataPromise = WinJS.Promise.wrap({
                                    data: this.selectedItems, onDragDataHandled: this._onDragDataHandled.bind(this)
                                })
                        }
                        if (dragDataPromise) {
                            this._dragStarted = true;
                            if (this.queryToPause && !this.itemsReorderable)
                                this.queryToPause.pause();
                            var dragDataService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.dragData);
                            dragDataService.startDrag(dragDataPromise)
                        }
                    }, _itemDragEndedOrCanceled: function _itemDragEndedOrCanceled(event) {
                        MS.Entertainment.UI.Controls.assert(this._dragStarted, "GalleryControl::_itemDragEndedOrCanceled: Received drag end, without corresponding drag start.");
                        var dragDataService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.dragData);
                        dragDataService.finishDrag();
                        if (this.queryToPause && !this.itemsReorderable)
                            this.queryToPause.unpause();
                        this._dragStarted = false
                    }, _onDragDataHandled: function _onDragDataHandled() {
                        this.clearInvocation();
                        this.clearSelection()
                    }, createPopOverParameters: function createPopOverParameters(data) {
                        var panelConstructor;
                        if (this.panelTemplateTypeMappings)
                            for (var x = 0; x < this.panelTemplateTypeMappings.length; x++) {
                                var templateMapping = this.panelTemplateTypeMappings[x];
                                if (data && data.data && data.data[templateMapping.key] === templateMapping.value) {
                                    panelConstructor = templateMapping.panelTemplate;
                                    break
                                }
                            }
                        if (!panelConstructor)
                            panelConstructor = this.templateSelector.getPanelTemplatePath(data);
                        MS.Entertainment.UI.Controls.assert(panelConstructor, "Pop-over behavior requires a panel constructor");
                        var size = this.panelOptions && this.panelOptions.size ? this.panelOptions.size : MS.Entertainment.Utilities.popOverDefaultSize;
                        data.hasFocus = true;
                        this._createItemChangeHandler(data);
                        var popOverParameters = {
                                itemConstructor: panelConstructor, size: size
                            };
                        popOverParameters.onclose = this._onPopOverClosed.bind(this);
                        popOverParameters.presetPreOverlayFocus = {
                            listView: this._listView, item: data
                        };
                        popOverParameters.dataContext = data;
                        popOverParameters.dataContext.inlineExtraData = this.inlineExtraData;
                        popOverParameters.dataContext.location = this.panelOptions && this.panelOptions.location;
                        popOverParameters.dataContext.collectionFilter = this._mediaContext && this._mediaContext.collectionFilter;
                        return popOverParameters
                    }, _onPopOverClosed: function _onPopOverClosed() {
                        this._clearDataSourceHandlers();
                        if (this.queryToPause && this.queryToPause.forceLiveRefresh)
                            this.queryToPause.forceLiveRefresh()
                    }, _createItemChangeHandler: function _createItemChangeHandler(data) {
                        var itemUpdated = function itemUpdated(args) {
                                if (args && args.detail && args.detail.newValue && args.detail.newValue.data && args.detail.newValue.data.libraryId === data.data.libraryId && args.detail.newValue.data.mediaType === data.data.mediaType)
                                    MS.Entertainment.Utilities.copyAugmentedProperties(args.detail.newValue.data, data.data)
                            }.bind(this);
                        this._clearDataItemChangeHandlers();
                        if (data && data.data)
                            this._dataSourceItemChangeHandlers = MS.Entertainment.Utilities.addEventHandlers(this.dataSource, {
                                itemInserted: itemUpdated, itemChanged: itemUpdated
                            })
                    }, _clearSelectionHelper: function _clearSelectionHelper() {
                        if (this._selectionHelper) {
                            this._selectionHelper.dispose();
                            this._selectionHelper = null
                        }
                    }, _canCreateSelectionHelper: {get: function get_canCreateSelectionHelper() {
                            return !!this.selectionHelperFactory && this.isDelayInitialized
                        }}, _initializeSelectionHelper: function _initializeSelectionHelper() {
                        if (!this._selectionHelper && this._canCreateSelectionHelper)
                            this._selectionHelper = this.selectionHelperFactory(this);
                        return this._selectionHelper
                    }, _clearDataItemChangeHandlers: function _clearDataItemChangeHandlers() {
                        if (this._dataSourceItemChangeHandlers) {
                            this._dataSourceItemChangeHandlers.cancel();
                            this._dataSourceItemChangeHandlers = null
                        }
                    }, _clearDataSourceHandlers: function _clearDataSourceHandlers() {
                        this._clearDataItemChangeHandlers();
                        if (this._dataSourceHandlers) {
                            this._dataSourceHandlers.cancel();
                            this._dataSourceHandlers = null
                        }
                    }, _onFocusin: function _onFocusin(event) {
                        var currElement = event && event.target;
                        if (currElement) {
                            this._lastFocusedElement = currElement;
                            WinJS.Promise.timeout().then(function() {
                                if (this._lastFocusedElement && !MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.uiState).appBarVisible)
                                    MS.Entertainment.UI.Framework.focusElement(this._lastFocusedElement);
                                this._lastFocusedElement = null
                            }.bind(this))
                        }
                    }, _raisePanelReadyOnce: function _raisePanelReadyOnce() {
                        if (!this._raisedPanelReady) {
                            this._raisedPanelReady = true;
                            if (!this._unloaded && this.raisePanelReadyEvents)
                                MS.Entertainment.Utilities.raisePanelReady(this.domElement);
                            if (MS.Entertainment.Utilities.isApp2 && this.focusFirstItemOnPageLoad)
                                this.setVisibleIndexFocus(0)
                        }
                    }, _raisePanelEmpty: function _raisePanelEmpty(isEmpty) {
                        if (!this._unloaded && (!this._raisedPanelEmpty || this._isEmpty !== isEmpty)) {
                            this._raisedPanelEmpty = true;
                            this._isEmpty = isEmpty;
                            var domEvent = document.createEvent("Event");
                            domEvent.initEvent("PanelEmpty", true, true);
                            domEvent.empty = isEmpty;
                            this.domElement.dispatchEvent(domEvent)
                        }
                    }, _raisePanelResetOnce: function _raisePanelResetOnce() {
                        if (this._raisedPanelReady) {
                            this._raisedPanelReady = false;
                            if (!this._unloaded && this.raisePanelResetEvents)
                                MS.Entertainment.Utilities.raisePanelReset(this.domElement)
                        }
                    }, _raiseGalleryReadyState: function _raiseGalleryReadyState(readyState, event) {
                        this.readyState = readyState;
                        if (this._readyStateCallback)
                            this._readyStateCallback({
                                readyState: this.readyState, scrolling: (event && event.detail) ? event.detail.scrolling : false
                            })
                    }, _raisePanelSyncing: function _raisePanelSyncing(isSyncing) {
                        if (!this._unloaded && this._isSyncing !== isSyncing) {
                            this._isSyncing = isSyncing;
                            var domEvent = document.createEvent("Event");
                            domEvent.initEvent("PanelSyncing", true, true);
                            domEvent.isSyncing = isSyncing;
                            this.domElement.dispatchEvent(domEvent)
                        }
                    }, _setSelectedIndex: function _setSelectedIndex(newIndex, oldIndex) {
                        oldIndex = oldIndex === undefined ? this.selectedIndex : oldIndex;
                        if (oldIndex !== newIndex) {
                            this.selectedIndex = newIndex;
                            if (this._selectedIndexChangedCallback)
                                this._selectedIndexChangedCallback(newIndex, oldIndex)
                        }
                        if (this.dataSource && this.dataSource.keyFromIndex)
                            this.selectedKey = this.dataSource.keyFromIndex(newIndex);
                        else
                            this.selectedKey = null
                    }, _validateSelection: function _validateSelection() {
                        var indices;
                        var selection = this._listView && this._listView.selection;
                        if (selection && this.maxSelectionCount >= 0) {
                            if (this.maxSelectionCount < selection.count()) {
                                indices = selection.getIndices();
                                if (indices.length > this.maxSelectionCount)
                                    indices = indices.slice(0, this.maxSelectionCount);
                                else
                                    indices = null
                            }
                            else if (selection.isEverything())
                                indices = [{
                                        firstIndex: 0, lastIndex: this.maxSelectionCount - 1
                                    }];
                            if (indices)
                                selection.set(indices)
                        }
                    }, _updateDataSourceGrouper: function _updateDataSourceGrouper(dataSource) {
                        var promise;
                        if (this._inplaceGrouper) {
                            this._inplaceGrouper.dispose();
                            this._inplaceGrouper = null
                        }
                        if (dataSource && dataSource.setGrouper && !dataSource.grouper && this.useInPlaceHeaders)
                            this._inplaceGrouper = new MS.Entertainment.Data.ListGrouper(this.grouper || MS.Entertainment.Data.emptyGrouper, dataSource);
                        return WinJS.Promise.as(this._inplaceGrouper && this._inplaceGrouper.dataSourceReady)
                    }, _updateSelectionInvokedVisibleAfterMove: function _updateSelectionInvokedVisibleAfterMove(args) {
                        var offset = 0;
                        if (args && args.detail)
                            offset = args.detail.newIndex < args.detail.oldIndex ? -1 : 1;
                        if (this.selectedIndices && this.selectedIndices.length)
                            this._updateSelection();
                        this._ensureSelectionInvokedVisible(offset)
                    }, _updateSelection: function _updateSelection() {
                        var newSelection;
                        var oldSelection = this.selectedIndices;
                        if (this._canCreateSelectionHelper) {
                            if (this._listView && this._listView.selection)
                                newSelection = this._listView.selection.getIndices();
                            if (this.invocationHelper && this.invocationHelper.invokedIndex >= 0) {
                                var lastInvokedIndex = this.invocationHelper.invokedIndex;
                                this.invocationHelper.clearInvocation();
                                if (this.selectionMode === MS.Entertainment.UI.Controls.GalleryControl.SelectionMode.multi)
                                    this._listView.selection.add(lastInvokedIndex)
                            }
                            if (this._pendingSelectionFromInvoke >= 0) {
                                this._listView.selection.add(this._pendingSelectionFromInvoke);
                                this._pendingSelectionFromInvoke = -1
                            }
                            if (newSelection && newSelection.length) {
                                if (!this.selectedItems)
                                    this.selectedItems = new MS.Entertainment.Data.SelectionList;
                                this.selectedItems.maxCount = this.maxSelectionCount;
                                this.selectedItems.setSource(this.dataSource, this._listView.selection, this._userSelectedEverything);
                                this._setSelectedIndices(newSelection);
                                this._setSelectedIndex(newSelection[newSelection.length - 1]);
                                this._selectionHelper = this._initializeSelectionHelper();
                                this._selectionHelper.updateSelectedItems(newSelection, oldSelection)
                            }
                            else {
                                this.selectedItems = null;
                                this._setSelectedIndices([]);
                                this._clearSelectionHelper()
                            }
                            if (this.queryToPause)
                                if (newSelection && newSelection.length) {
                                    if (!oldSelection || !oldSelection.length)
                                        this.queryToPause.pause()
                                }
                                else if (oldSelection && oldSelection.length)
                                    this.queryToPause.unpause()
                        }
                    }, _setSelectedIndices: function _setSelectedIndices(value) {
                        value = value || [];
                        var oldEmpty = !this.selectedIndices.length;
                        var newEmpty = !value.length;
                        if ((value !== this.selectedIndices) && !(oldEmpty && newEmpty)) {
                            var oldValue = this.selectedIndices;
                            this.selectedIndices = value;
                            this.dispatchEvent("selectedIndicesChanged", {
                                newValue: value, oldValue: oldValue
                            })
                        }
                    }
            }, {
                selectedIndex: -1, selectedKey: null, selectedIndices: null, selectedItems: null, readyState: null, autoSizeMin: 1
            }, {
                resetItem: function resetItem(item, element) {
                    element.listViewReset = true;
                    MS.Entertainment.UI.Framework.unloadControlTree(element)
                }, searchAndApply: function searchAndApply(subTree, operation) {
                        if (subTree && operation) {
                            var applyOnGalleryControl = function applyOnGalleryControl(listView) {
                                    var galleryControl;
                                    if (listView)
                                        galleryControl = listView.parentElement;
                                    if (galleryControl && galleryControl.winControl)
                                        operation(galleryControl.winControl)
                                };
                            MS.Entertainment.UI.Framework.applyWithSelector(subTree, ".win-listview", applyOnGalleryControl)
                        }
                    }, zoomedOutClass: "ent-zoomOutButton", selectionFilledClass: "win-selectionstylefilled", dragInsertBeforeClass: "state_dragInsertBefore", dragInsertAfterClass: "state_dragInsertAfter", defaultGrouperItemThreshold: _defaultGrouperItemThreshold, maxItemRenderTime: 40, _restoreSetImmediateModeTime: 1000, Layout: {
                        grid: "grid", list: "list"
                    }, Orientation: {
                        horizontal: "horizontal", vertical: "vertical"
                    }, DoubleClickBehavior: {
                        action: "action", play: "play", none: "none"
                    }, ZoomedOutLayout: {
                        auto: "auto", grid: "grid", list: "list"
                    }, HeaderPosition: {
                        inline: "inline", left: "left", top: "top"
                    }, HeaderType: {
                        none: "none", auto: "auto", inPlace: "inPlace"
                    }, SelectionMode: {
                        none: "none", single: "single", multi: "multi"
                    }, Tap: {
                        directSelect: "directSelect", toggleSelect: "toggleSelect", invokeOnly: "invokeOnly", none: "none"
                    }, swipeBehavior: {
                        select: "select", none: "none"
                    }, ReadyState: {
                        itemsLoading: "itemsLoading", viewPortLoaded: "viewPortLoaded", itemsLoaded: "itemsLoaded", complete: "complete"
                    }, LoadingBehavior: {
                        incremental: "incremental", randomAccess: "randomAccess"
                    }, InvokeBehavior: {
                        popOver: "popOver", inline: "inline", details: "details", action: "action", none: "none"
                    }, SemanticZoomSelected: {
                        headerClick: "headerClick", minusClick: "minusClick", keyDown: "keyDown", keyUp: "keyUp", pinch: "pinch", jumpTo: "jumpTo", mediaTransportControl: "mediaTransportControl"
                    }
            })
    });
    WinJS.Namespace.define("MS.Entertainment.UI.Controls", {ListViewModelGalleryControl: MS.Entertainment.UI.Framework.deriveUserControl("MS.Entertainment.UI.Controls.GalleryControl", null, function listViewModelGalleryControl(element, options){}, {
            listViewModel: null, processItemData: function processItemData(itemData, index, key) {
                    return new MS.Entertainment.UI.Controls.ListItemData(itemData, this.listViewModel, index, key)
                }
        })});
    WinJS.Namespace.define("MS.Entertainment.UI.Controls", {ListItemData: MS.Entertainment.UI.Framework.define(function listItemData(data, listViewModel, index, key) {
            this.data = data;
            this.index = index;
            this.key = key;
            this.listViewModel = listViewModel
        }, {
            listViewModel: null, data: null, index: -1, key: null, instance: {get: function() {
                        return this
                    }}
        })});
    function closeTooltip(element) {
        var tt = WinJS.Utilities.data(element).tooltip;
        if (tt) {
            tt.close();
            tt.dispose();
            WinJS.Utilities.data(element).tooltip = null
        }
    }
    if (WinJS.UI._ItemEventsHandler) {
        var ssrg = WinJS.UI._ItemEventsHandler.prototype._startSelfRevealGesture;
        WinJS.UI._ItemEventsHandler.prototype._startSelfRevealGesture = function() {
            ssrg.apply(this, arguments);
            if (this._selfRevealGesture) {
                var element = this._site.pressedItemBox;
                var down = String.load(String.id.IDS_SWIPE_VERTICALLY_TO_SELECT);
                var left = String.load(String.id.IDS_SWIPE_HORIZONTALLY_TO_SELECT);
                var directionText = this._site.horizontal ? down : left;
                var directionGlyph = this._site.horizontal ? "&#xE1FD;" : "&#xE112;";
                var tt = new WinJS.UI.Tooltip(element, {innerHTML: directionGlyph + " " + directionText});
                tt.open();
                setTimeout(closeTooltip.bind(null, element), 5000)
            }
        };
        var esrg = WinJS.UI._ItemEventsHandler.prototype._endSelfRevealGesture;
        WinJS.UI._ItemEventsHandler.prototype._endSelfRevealGesture = function() {
            var element = this._site.pressedItemBox;
            if (element)
                closeTooltip(element);
            esrg.apply(this, arguments)
        }
    }
})()
