﻿/* Copyright (C) Microsoft Corporation. All rights reserved. */
var __extends = this.__extends || function(d, b) {
        for (var p in b)
            if (b.hasOwnProperty(p))
                d[p] = b[p];
        function __() {
            this.constructor = d
        }
        __.prototype = b.prototype;
        d.prototype = new __
    };
var MS;
(function(MS) {
    (function(Entertainment) {
        (function(UI) {
            (function(Controls) {
                var FolderItem = (function(_super) {
                        __extends(FolderItem, _super);
                        function FolderItem(folder) {
                            _super.call(this);
                            if (folder) {
                                this._isAddFolderButton = false;
                                this._name = folder.name;
                                this._path = folder.path;
                                this._folder = folder
                            }
                            else
                                this._isAddFolderButton = true
                        }
                        Object.defineProperty(FolderItem.prototype, "name", {
                            get: function() {
                                return this._name
                            }, enumerable: true, configurable: true
                        });
                        Object.defineProperty(FolderItem.prototype, "path", {
                            get: function() {
                                return this._path
                            }, enumerable: true, configurable: true
                        });
                        Object.defineProperty(FolderItem.prototype, "isAddFolderButton", {
                            get: function() {
                                return this._isAddFolderButton
                            }, enumerable: true, configurable: true
                        });
                        Object.defineProperty(FolderItem.prototype, "folder", {
                            get: function() {
                                return this._folder
                            }, enumerable: true, configurable: true
                        });
                        return FolderItem
                    })(MS.Entertainment.UI.Framework.ObservableBase);
                var ManageFoldersDialog = (function(_super) {
                        __extends(ManageFoldersDialog, _super);
                        function ManageFoldersDialog(element, options) {
                            this.templateStorage = "/Controls/ManageFoldersPage.html";
                            this.templateName = "dialogTemplate";
                            _super.call(this, element, options)
                        }
                        ManageFoldersDialog.show = function() {
                            if (ManageFoldersDialog._dialog && ManageFoldersDialog._dialog.visible)
                                return;
                            var options = {
                                    width: "60%", height: "100%", buttons: [WinJS.Binding.as({
                                                title: String.load(String.id.IDS_MANAGE_FOLDERS_DONE_BUTTON), execute: function execute_done(dialog) {
                                                        dialog.hide();
                                                        ManageFoldersDialog._dialog = null
                                                    }
                                            })], defaultButtonIndex: 0, title: MS.Entertainment.Utilities.isVideoApp1 ? String.load(String.id.IDS_VIDEO1_MANAGE_FOLDERS_TITLE) : String.load(String.id.IDS_MUSIC_MANAGE_FOLDERS_TITLE), userControl: "MS.Entertainment.UI.Controls.ManageFolders", userControlOptions: {}, persistOnNavigate: false
                                };
                            if (!ManageFoldersDialog._dialog)
                                ManageFoldersDialog._dialog = new MS.Entertainment.UI.Controls.ManageFoldersDialog(document.createElement("div"), options);
                            if (!ManageFoldersDialog._dialog.visible)
                                ManageFoldersDialog._dialog.show()
                        };
                        ManageFoldersDialog.hide = function() {
                            var returnValue = ManageFoldersDialog._dialog.hide();
                            ManageFoldersDialog._dialog = null;
                            return returnValue
                        };
                        return ManageFoldersDialog
                    })(MS.Entertainment.UI.Controls.Dialog);
                Controls.ManageFoldersDialog = ManageFoldersDialog;
                var ManageFolders = (function(_super) {
                        __extends(ManageFolders, _super);
                        function ManageFolders(element, options) {
                            this.templateStorage = "/Controls/ManageFoldersPage.html";
                            this.templateName = "manageFoldersTemplate";
                            _super.call(this, element, options)
                        }
                        Object.defineProperty(ManageFolders.prototype, "items", {
                            get: function() {
                                return this._items
                            }, set: function(value) {
                                    this.updateAndNotify("items", value)
                                }, enumerable: true, configurable: true
                        });
                        Object.defineProperty(ManageFolders.prototype, "itemCounts", {
                            get: function() {
                                return this._itemCounts
                            }, enumerable: true, configurable: true
                        });
                        ManageFolders.prototype._load = function() {
                            var _this = this;
                            var addFolderItem = new Array;
                            var itemsInLibrary = new Array;
                            var libraryId;
                            libraryId = MS.Entertainment.Utilities.isVideoApp1 ? Windows.Storage.KnownLibraryId.videos : Windows.Storage.KnownLibraryId.music;
                            addFolderItem.push(new FolderItem(null));
                            Windows.Storage.StorageLibrary.getLibraryAsync(libraryId).then(function(library) {
                                if (library)
                                    library.folders.forEach(function(folder) {
                                        itemsInLibrary.push(new FolderItem(folder))
                                    })
                            }).done(function() {
                                _this._itemCounts = itemsInLibrary.length;
                                if (_this._itemCounts > 0)
                                    itemsInLibrary.reverse();
                                _this.items = new MS.Entertainment.ObservableArray(addFolderItem.concat(itemsInLibrary))
                            }, function(error) {
                                MS.Entertainment.Utilities.assertError("ManageFolders::_load() failed to get library items.", error)
                            })
                        };
                        ManageFolders.prototype.initialize = function() {
                            this._load()
                        };
                        ManageFolders.showLastFolderDialog = function() {
                            return MS.Entertainment.UI.Shell.showMessageBox(String.load(String.id.IDS_MANAGE_FOLDERS_LAST_FOLDER_ERROR_TITLE), String.load(String.id.IDS_MANAGE_FOLDERS_LAST_FOLDER_ERROR_TEXT), {
                                    width: "60%", height: "100%", buttons: [WinJS.Binding.as({
                                                title: String.load(String.id.IDS_CLOSE_BUTTON), execute: function execute_done(dialog) {
                                                        dialog.hide()
                                                    }
                                            })], defaultButtonIndex: 0
                                })
                        };
                        ManageFolders.folderTemplateSelector = function(item) {
                            function loadItemTemplate(itemTemplate) {
                                return MS.Entertainment.UI.Framework.loadTemplate(itemTemplate, null, true).then(function(templateControl) {
                                        return templateControl
                                    })
                            }
                            if (item.isAddFolderButton)
                                return loadItemTemplate("/Controls/ManageFoldersPage.html#addFolderItemTemplate");
                            else
                                return loadItemTemplate("/Controls/ManageFoldersPage.html#removeFolderItemTemplate")
                        };
                        ManageFolders.prototype.onModuleItemClicked = function(event) {
                            var element = event.srcElement;
                            while (element && element !== this.domElement) {
                                if (element.clickDataContext) {
                                    this._invokeModuleItem(element.clickDataContext);
                                    event.stopPropagation();
                                    break
                                }
                                element = element.parentElement
                            }
                        };
                        ManageFolders.prototype._invokeModuleItem = function(item) {
                            var _this = this;
                            if (!item)
                                return;
                            var libraryId;
                            libraryId = MS.Entertainment.Utilities.isVideoApp1 ? Windows.Storage.KnownLibraryId.videos : Windows.Storage.KnownLibraryId.music;
                            if (item.isAddFolderButton)
                                Windows.Storage.StorageLibrary.getLibraryAsync(libraryId).then(function(library) {
                                    return library.requestAddFolderAsync()
                                }).done(function() {
                                    _this._load()
                                }, function(error) {
                                    MS.Entertainment.fail("AddFolder Failed: " + (error && error.message))
                                });
                            else
                                Windows.Storage.StorageLibrary.getLibraryAsync(libraryId).then(function(library) {
                                    MS.Entertainment.UI.Controls.ManageFoldersDialog.hide();
                                    if (_this.itemCounts === 1)
                                        return MS.Entertainment.UI.Controls.ManageFolders.showLastFolderDialog();
                                    else
                                        return library.requestRemoveFolderAsync(item.folder)
                                }).done(function() {
                                    MS.Entertainment.UI.Controls.ManageFoldersDialog.show()
                                }, function(error) {
                                    MS.Entertainment.fail("RemoveFolder Failed: " + (error && error.message))
                                })
                        };
                        return ManageFolders
                    })(MS.Entertainment.UI.Framework.UserControl);
                Controls.ManageFolders = ManageFolders;
                WinJS.Utilities.markSupportedForProcessing(MS.Entertainment.UI.Controls.ManageFolders.folderTemplateSelector)
            })(UI.Controls || (UI.Controls = {}));
            var Controls = UI.Controls
        })(Entertainment.UI || (Entertainment.UI = {}));
        var UI = Entertainment.UI
    })(MS.Entertainment || (MS.Entertainment = {}));
    var Entertainment = MS.Entertainment
})(MS || (MS = {}))
