﻿/* Copyright (C) Microsoft Corporation. All rights reserved. */
(function() {
    "use strict";
    scriptValidator();
    MS.Entertainment.UI.Debug.defineAssert("MS.Entertainment.UI.Controls.Music");
    WinJS.Namespace.define("MS.Entertainment.UI.Controls", {MediaStatusIcon: MS.Entertainment.UI.Framework.defineUserControl(null, function mediaStatusIconConstructor(element){}, {
            controlName: "MediaStatusIcon", allowAnimations: false, preventHideDuringInitialize: true, hasError: false, index: -1, key: null, inNowPlaying: false, delayHydrateLibraryId: false, showExplicit: false, showMusicVideo: false, showMediaRights: false, _playbackErrorCode: 0, _transferErrorCode: 0, _notLocalErrorCode: false, _isNowPlaying: false, _setIsNowPlayingState: false, _isDownloading: false, _freeTrackLimitExceeded: false, _monthlyFreeLimitExceeded: false, _inCollection: false, _hasMusicVideo: false, _canPlayLocally: true, _isExplicit: false, _hasUsageRightRestrictions: false, _isUnavailable: false, _icon: String.empty, _iconClass: String.empty, _iconContainerDomElement: null, _ariaText: null, _ariaLabelContainerDomElement: null, _visible: false, _setClassFreeStreamLimitExceeded: false, _setCanPlayLocally: true, _setExplicit: false, _notificationText: null, _setUnavailable: false, _bindings: null, _containerElementClickHandler: null, _attachedLibraryId: -1, _attachedServiceId: MS.Entertainment.Utilities.EMPTY_GUID, _attachedActivationFilePath: String.empty, _freePlayLimits: null, _fileTransferNotificationsService: null, _delayInitializePromise: null, _mediaStore: null, _parentWinItemElement: null, iconClass: {
                    get: function() {
                        return this._iconClass
                    }, set: function(value) {
                            if (value !== this._iconClass) {
                                if (this._iconClass && this._iconContainerDomElement)
                                    WinJS.Utilities.removeClass(this._iconContainerDomElement, this._iconClass);
                                this._iconClass = value;
                                if (this._iconClass && this._iconContainerDomElement)
                                    WinJS.Utilities.addClass(this._iconContainerDomElement, this._iconClass)
                            }
                        }
                }, parentWinItemElement: {get: function() {
                        if (!this._parentWinItemElement)
                            this._parentWinItemElement = this._getParentWinItemElement();
                        return this._parentWinItemElement
                    }}, notificationText: {
                    get: function() {
                        return this._notificationText
                    }, set: function(value) {
                            if (value !== this._notificationText)
                                this._notificationText = value
                        }
                }, isUnavailable: {
                    get: function() {
                        return this._isUnavailable
                    }, set: function(value) {
                            if (value !== this._isUnavailable)
                                this._isUnavailable = value
                        }
                }, _delayInitialized: function _delayInitialized() {
                    this._iconContainerDomElement = this.domElement.querySelector(".mediaStatusIconContainer");
                    MS.Entertainment.UI.Controls.Music.assert(this._iconContainerDomElement, "MediaStatusIcon control is missing required child element of class 'mediaStatusIconContainer'.");
                    this._ariaLabelContainerDomElement = this.domElement.querySelector(".mediaStatusAriaLabelContainer");
                    MS.Entertainment.UI.Controls.Music.assert(this._ariaLabelContainerDomElement, "MediaStatusIcon control is missing required child element of class 'mediaStatusAriaLabelContainer'.");
                    this.domElement.setAttribute("role", "presentation");
                    if (MS.Entertainment.ServiceLocator.isServiceRegistered(MS.Entertainment.Services.freePlayLimits))
                        this._freePlayLimits = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.freePlayLimits);
                    if (MS.Entertainment.ServiceLocator.isServiceRegistered(MS.Entertainment.Services.fileTransferNotifications))
                        this._fileTransferNotificationsService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.fileTransferNotifications);
                    if (this.delayHydrateLibraryId)
                        MS.Entertainment.ViewModels.MediaItemModel.getLibraryIdAsync(this.mediaInstance);
                    this._handleTransferEvent = this._handleTransferEvent.bind(this);
                    this._handlePlaybackEvent = this._handlePlaybackEvent.bind(this);
                    this._handleFreePlayLimitsEvent = this._handleFreePlayLimitsEvent.bind(this);
                    this._handleMediaChange = this._handleMediaChange.bind(this);
                    this._updateFreePlayLimits = this._updateFreePlayLimits.bind(this);
                    this._updateCanPlayLocally = this._updateCanPlayLocally.bind(this);
                    this._delayInitializePromise = MS.Entertainment.Utilities.schedulePromiseBelowNormal(null, "MediaStatusIcon:initializeBindings").then(function initializeBindings() {
                        this._delayInitializePromise = null;
                        if (this._unloaded)
                            return;
                        this._bindings = WinJS.Binding.bind(this, {mediaInstance: {
                                serviceId: this._handleMediaChange, libraryId: this._handleMediaChange, inCollection: this._handleMediaChange, activationFilePath: this._handleMediaChange, musicVideoId: this._handleMediaChange, hasPurchased: this._updateFreePlayLimits, canPlayLocally: this._updateCanPlayLocally, isFreeStreamRestrictedByMonthlyLimit: this._updateFreePlayLimits, isFreeStreamRestrictedByIndividualLimit: this._updateFreePlayLimits
                            }});
                        if (this.domElement) {
                            if (this._containerElementClickHandler)
                                this._containerElementClickHandler.cancel();
                            this._containerElementClickHandler = MS.Entertainment.Utilities.addEventHandlers(this.domElement, {
                                click: this.mediaStatusIconClicked.bind(this), keydown: this.mediaStatusIconClicked.bind(this)
                            })
                        }
                        this._initializeMediaId(this.mediaInstance);
                        this._updateCanPlayLocally();
                        this._updateFreePlayLimits()
                    }.bind(this), function(error) {
                        this._delayInitializePromise = null;
                        MS.Entertainment.UI.Controls.Music.assert(WinJS.Promise.isCanceledError(error), "Failed to initialize bindings. error: " + (error && error.message))
                    }.bind(this))
                }, unload: function unload() {
                    if (this._bindings) {
                        this._bindings.cancel();
                        this._bindings = null
                    }
                    if (this._delayInitializePromise)
                        this._delayInitializePromise.cancel();
                    var playbackEventNotifications = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.playbackEventNotifications);
                    if (this._isValidMediaId(this._attachedLibraryId)) {
                        playbackEventNotifications.detachListener(this._attachedLibraryId, this._handlePlaybackEvent);
                        if (this._fileTransferNotificationsService)
                            this._fileTransferNotificationsService.detachListener(this._attachedLibraryId, this._handleTransferEvent);
                        this._detachedMediaId(this._attachedLibraryId)
                    }
                    if (this._isValidMediaId(this._attachedServiceId)) {
                        playbackEventNotifications.detachListener(this._attachedServiceId, this._handlePlaybackEvent);
                        if (this._fileTransferNotificationsService)
                            this._fileTransferNotificationsService.detachListener(this._attachedServiceId, this._handleTransferEvent);
                        if (this._freePlayLimits && MS.Entertainment.Music.FreePlayLimits.isFreeStreamingTrack(this.mediaInstance))
                            this._freePlayLimits.detachListener(this._attachedServiceId, this._handleFreePlayLimitsEvent);
                        this._detachedMediaId(this._attachedServiceId)
                    }
                    if (this._isValidMediaId(this._attachedActivationFilePath)) {
                        playbackEventNotifications.detachListener(this._attachedActivationFilePath, this._handlePlaybackEvent);
                        if (this._fileTransferNotificationsService)
                            this._fileTransferNotificationsService.detachListener(this._attachedActivationFilePath, this._handleTransferEvent);
                        this._detachedMediaId(this._attachedActivationFilePath)
                    }
                    if (this._containerElementClickHandler) {
                        this._containerElementClickHandler.cancel();
                        this._containerElementClickHandler = null
                    }
                    MS.Entertainment.UI.Framework.UserControl.prototype.unload.call(this)
                }, mediaStatusIconClicked: function mediaStatusIconClicked(event) {
                    if (event && event.keyCode && !(event.keyCode === WinJS.Utilities.Key.enter || event.keyCode === WinJS.Utilities.Key.space))
                        return;
                    if (this.hasError) {
                        var handled = this.showError();
                        if (handled)
                            event.cancelBubble = true
                    }
                    else if (this.notificationText) {
                        var notificationFlyout = new MS.Entertainment.UI.Controls.MediaStatusFlyout;
                        notificationFlyout.text = this.notificationText;
                        notificationFlyout.referenceDomElement = this.domElement;
                        notificationFlyout.showFlyout()
                    }
                }, showError: function showError() {
                    var uiStateService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.uiState);
                    if (!uiStateService.servicesEnabled) {
                        MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.upgradeReminderDisplayer).showUpgradeDialog();
                        return true
                    }
                    else {
                        var appView = Windows.UI.ViewManagement.ApplicationView;
                        var handled = false;
                        if (!uiStateService.isSnapped || appView.tryUnsnap())
                            if (this._freeTrackLimitExceeded && this._freePlayLimits) {
                                this._freePlayLimits.showFreeTrackLimitExceededDialog(this.mediaInstance);
                                handled = true
                            }
                            else if (this._monthlyFreeLimitExceeded && this._freePlayLimits) {
                                this._freePlayLimits.showMonthlyFreeLimitExceededDialog(this.mediaInstance);
                                handled = true
                            }
                            else if (this._playbackErrorCode) {
                                MS.Entertainment.UI.Shell.showError(String.load(String.id.IDS_PLAYBACK_ERROR_MESSAGE_TITLE), this._playbackErrorCode);
                                handled = true
                            }
                            else if (this._transferErrorCode) {
                                MS.Entertainment.UI.Shell.showError(String.load(String.id.IDS_DOWNLOAD_ERROR_CAPTION), this._transferErrorCode);
                                handled = true
                            }
                            else if (this._notLocalErrorCode) {
                                MS.Entertainment.UI.Shell.showError(String.load(String.id.IDS_PLAYBACK_ERROR_MESSAGE_TITLE), this._notLocalErrorCode);
                                handled = true
                            }
                        return handled
                    }
                }, _initializeMediaId: function _initializeMediaId(mediaItem) {
                    var mediaId;
                    mediaId = MS.Entertainment.Platform.Playback.PlaybackEventNotifications.getEventingMediaId(mediaItem);
                    this._handleMediaChange(mediaId)
                }, _handleMediaChange: function _handleMediaChange(newMediaId, oldMediaId) {
                    if (!this._bindings)
                        return;
                    var playbackEventNotifications = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.playbackEventNotifications);
                    if (this._isValidMediaId(oldMediaId) && (this._attachedServiceId === oldMediaId || this._attachedLibraryId === oldMediaId)) {
                        playbackEventNotifications.detachListener(oldMediaId, this._handlePlaybackEvent);
                        if (this._fileTransferNotificationsService)
                            this._fileTransferNotificationsService.detachListener(oldMediaId, this._handleTransferEvent);
                        if (this._freePlayLimits && MS.Entertainment.Music.FreePlayLimits.isFreeStreamingTrack(this.mediaInstance) && this._attachedServiceId === newMediaId)
                            this._freePlayLimits.detachListener(oldMediaId, this._handleFreePlayLimitsEvent);
                        this._detachedMediaId(oldMediaId)
                    }
                    if ((!this._unloaded) && this._isValidMediaId(newMediaId)) {
                        this._attachedMediaId(newMediaId);
                        playbackEventNotifications.attachListener(newMediaId, this._handlePlaybackEvent);
                        if (this._fileTransferNotificationsService)
                            this._fileTransferNotificationsService.attachListener(newMediaId, this._handleTransferEvent);
                        if (this._freePlayLimits && MS.Entertainment.Music.FreePlayLimits.isFreeStreamingTrack(this.mediaInstance) && this._attachedServiceId === newMediaId) {
                            this._freePlayLimits.attachListener(newMediaId, this._handleFreePlayLimitsEvent);
                            this._updateFreePlayLimits()
                        }
                    }
                    var updateState = false;
                    if (this.showInCollectionState && this.mediaInstance && this.mediaInstance.inCollection !== this._inCollection) {
                        this._inCollection = this.mediaInstance.inCollection;
                        updateState = true
                    }
                    if (this.showMusicVideo && this.mediaInstance && this.mediaInstance.hasMusicVideoId !== this._hasMusicVideo) {
                        this._hasMusicVideo = this.mediaInstance.hasMusicVideoId;
                        updateState = true
                    }
                    if (this.showExplicit) {
                        var signInService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signIn);
                        var signedInUser = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signedInUser);
                        if (this.mediaInstance && signInService && signInService.isSignedIn && signedInUser && !signedInUser.hasExplicitPrivilege && this.mediaInstance.isExplicit !== this._isExplicit) {
                            this._isExplicit = this.mediaInstance.isExplicit;
                            updateState = true
                        }
                    }
                    if (this.showMediaRights)
                        updateState = true;
                    if (updateState)
                        this._updateState()
                }, _updateFreePlayLimits: function _updateFreePlayLimits() {
                    var isFreePlayLimitsExceeded = this._checkIfFreePlayLimitsExceeded();
                    if (isFreePlayLimitsExceeded)
                        this._updateState()
                }, _checkIfFreePlayLimitsExceeded: function _checkIfFreePlayLimitsExceeded() {
                    if (!this._freePlayLimits || !this._bindings)
                        return false;
                    var updateState = false;
                    var isFreeStreamingTrack = MS.Entertainment.Music.FreePlayLimits.isFreeStreamingTrack(this.mediaInstance);
                    var freeTrackLimitExceeded = isFreeStreamingTrack && this.mediaInstance.isFreeStreamRestrictedByIndividualLimit;
                    if (this._freeTrackLimitExceeded !== freeTrackLimitExceeded) {
                        this._freeTrackLimitExceeded = freeTrackLimitExceeded;
                        updateState = true
                    }
                    var monthlyFreeLimitExceeded = isFreeStreamingTrack && (this._freePlayLimits.isMonthlyFreeLimitExceeded || this.mediaInstance.isFreeStreamRestrictedByMonthlyLimit);
                    if (this._monthlyFreeLimitExceeded !== monthlyFreeLimitExceeded) {
                        this._monthlyFreeLimitExceeded = monthlyFreeLimitExceeded;
                        updateState = true
                    }
                    return updateState
                }, _updateCanPlayLocally: function _updateCanPlayLocally() {
                    if (!this.mediaInstance || !this._bindings)
                        return;
                    var updateState = false;
                    if (this._canPlayLocally !== this.mediaInstance.canPlayLocally) {
                        this._canPlayLocally = this.mediaInstance.canPlayLocally;
                        updateState = true
                    }
                    var isFreePlayLimitsExceeded = this._checkIfFreePlayLimitsExceeded();
                    if (updateState || isFreePlayLimitsExceeded)
                        this._updateState()
                }, _isCurrentNowPlayingIndex: {get: function get_isCurrentNowPlayingIndex() {
                        var sessionManager = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.sessionManager);
                        return sessionManager.nowPlayingSession && sessionManager.nowPlayingSession.currentOrdinal === this.index
                    }}, _isCurrentNowPlayingKey: {get: function get_isCurrentNowPlayingKey() {
                        var sessionManager = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.sessionManager);
                        return sessionManager.nowPlayingSession && this.key && sessionManager.nowPlayingSession.currentMediaKey === this.key
                    }}, _isCurrentNowPlayingItem: {get: function get_isCurrentNowPlayingItem() {
                        return this._isCurrentNowPlayingKey || this._isCurrentNowPlayingIndex
                    }}, _hasNowPlayingIndex: {get: function get_hasNowPlayingIndex() {
                        return this.index >= 0 && this.inNowPlaying
                    }}, _hasNowPlayingKey: {get: function get_hasNowPlayingKey() {
                        return this.key && this.inNowPlaying
                    }}, _hasNowPlayingInformation: {get: function get_hasNowPlayingInformation() {
                        return this._hasNowPlayingKey || this._hasNowPlayingIndex
                    }}, _handlePlaybackEvent: function _handlePlaybackEvent(mediaId, event, value) {
                    switch (event) {
                        case MS.Entertainment.Platform.Playback.PlaybackEventNotifications.Event.error:
                            if (value === MS.Entertainment.Platform.Playback.Error.E_MDS_INDIVIDUAL_TRACK_LIMIT.code) {
                                this.mediaInstance.isFreeStreamRestrictedByIndividualLimit = true;
                                this.mediaInstance.canFreeStream = false;
                                this._freeTrackLimitExceeded = true
                            }
                            else if (value === MS.Entertainment.Platform.Playback.Error.E_MDS_AUTHENTICATED_TRACK_LIMIT.code) {
                                this.mediaInstance.isFreeStreamRestrictedByMonthlyLimit = true;
                                this.mediaInstance.canFreeStream = false;
                                this._monthlyFreeLimitExceeded = true
                            }
                            else if (value === MS.Entertainment.Platform.Playback.Error.X8_E_PLAYBACK_MEDIA_ERR_NOT_LOCAL.code && MS.Entertainment.Utilities.isMusicApp2)
                                this._notLocalErrorCode = value;
                            else
                                this._playbackErrorCode = value;
                            this._updateState();
                            break;
                        case MS.Entertainment.Platform.Playback.PlaybackEventNotifications.Event.nowPlaying:
                            this._isNowPlaying = value && (!this._hasNowPlayingInformation || this._isCurrentNowPlayingItem);
                            this._updateState();
                            break;
                        default:
                            MS.Entertainment.UI.Controls.Music.fail("Unknown event type");
                            break
                    }
                }, _handleTransferEvent: function _handleTransferEvent(mediaId, event, value) {
                    switch (event) {
                        case MS.Entertainment.UI.FileTransferNotificationService.Event.transferError:
                            this._transferErrorCode = value;
                            this._updateState();
                            break;
                        case MS.Entertainment.UI.FileTransferNotificationService.Event.download:
                            this._isDownloading = value;
                            this._updateState();
                            break;
                        default:
                            MS.Entertainment.UI.Controls.Music.fail("Unknown event type");
                            break
                    }
                }, _handleFreePlayLimitsEvent: function _handleFreePlayLimitsEvent(event) {
                    switch (event) {
                        case MS.Entertainment.Music.Freeplay.Events.monthlyFreeLimitExceeded:
                            this.mediaInstance.isFreeStreamRestrictedByMonthlyLimit = true;
                            this.mediaInstance.canFreeStream = false;
                            this._monthlyFreeLimitExceeded = true;
                            this._updateState();
                            break;
                        case MS.Entertainment.Music.Freeplay.Events.monthlyFreeLimitReset:
                            this.mediaInstance.isFreeStreamRestrictedByMonthlyLimit = false;
                            this.mediaInstance.canFreeStream = !this.mediaInstance.isFreeStreamRestrictedByIndividualLimit;
                            this._monthlyFreeLimitExceeded = false;
                            this._updateState();
                            break;
                        case MS.Entertainment.Music.Freeplay.Events.freeTrackLimitExceeded:
                            this.mediaInstance.isFreeStreamRestrictedByIndividualLimit = true;
                            this.mediaInstance.canFreeStream = false;
                            this._freeTrackLimitExceeded = true;
                            this._updateState();
                            break;
                        case MS.Entertainment.Music.Freeplay.Events.freeTrackLimitReset:
                            this.mediaInstance.isFreeStreamRestrictedByIndividualLimit = false;
                            this.mediaInstance.canFreeStream = !this.mediaInstance.isFreeStreamRestrictedByMonthlyLimit;
                            this._freeTrackLimitExceeded = false;
                            this._updateState();
                            break;
                        case MS.Entertainment.Music.Freeplay.Events.freeTrialStarted:
                        case MS.Entertainment.Music.Freeplay.Events.freeTrialCompleted:
                            this.mediaInstance.isFreeStreamRestrictedByMonthlyLimit = false;
                            this.mediaInstance.isFreeStreamRestrictedByIndividualLimit = false;
                            this.mediaInstance.canFreeStream = true;
                            this._monthlyFreeLimitExceeded = false;
                            this._freeTrackLimitExceeded = false;
                            this._updateState();
                            break;
                        default:
                            MS.Entertainment.UI.Controls.Music.fail("Unknown event type");
                            break
                    }
                }, _setIconAndAriaString: function _setIconAndAriaString() {
                    var icon = String.empty;
                    var iconClass = String.empty;
                    var ariaId = null;
                    var ariaText = null;
                    this._hasUsageRightRestrictions = false;
                    if (this._unloaded)
                        return;
                    if (this._playbackErrorCode) {
                        icon = MS.Entertainment.UI.Icon.inlineError;
                        iconClass = "mediaStatusIconContainer_inlineError";
                        ariaId = String.id.IDS_MEDIA_STATUS_PLAYBACK_ERROR_ICON
                    }
                    else if (this._freeTrackLimitExceeded) {
                        icon = MS.Entertainment.UI.Icon.inlineNotification;
                        iconClass = "mediaStatusIconContainer_inlineNotification";
                        ariaId = String.id.IDS_MEDIA_STATUS_STREAMING_TRACK_LIMIT_HIT_ICON
                    }
                    else if (this._monthlyFreeLimitExceeded) {
                        icon = MS.Entertainment.UI.Icon.inlineNotification;
                        iconClass = "mediaStatusIconContainer_inlineNotification";
                        ariaId = String.id.IDS_MEDIA_STATUS_STREAMING_MONTHLY_LIMIT_HIT_ICON
                    }
                    else if (this._transferErrorCode) {
                        icon = MS.Entertainment.UI.Icon.inlineError;
                        iconClass = "mediaStatusIconContainer_inlineError";
                        ariaId = String.id.IDS_MEDIA_STATUS_DOWNLOAD_ERROR_ICON
                    }
                    else if (this._notLocalErrorCode) {
                        icon = MS.Entertainment.UI.Icon.inlineNotification;
                        iconClass = "mediaStatusIconContainer_inlineNotification"
                    }
                    else if (this._isNowPlaying) {
                        icon = MS.Entertainment.UI.Icon.nowPlaying;
                        iconClass = "mediaStatusIconContainer_nowPlaying";
                        ariaId = String.id.IDS_MEDIA_STATUS_NOW_PLAYING_ICON
                    }
                    else if (this._isDownloading) {
                        icon = WinJS.UI.AppBarIcon.download;
                        iconClass = "mediaStatusIconContainer_download";
                        ariaId = String.id.IDS_MEDIA_STATUS_DOWNLOADING_ICON
                    }
                    else if (this._hasMusicVideo) {
                        icon = MS.Entertainment.UI.Icon.video11;
                        iconClass = "mediaStatusIconContainer_video11";
                        ariaId = String.id.IDS_MUSIC2_MUSIC_VIDEO_NOTE
                    }
                    else if (this._inCollection) {
                        icon = MS.Entertainment.UI.Icon.musicInCollection;
                        iconClass = "mediaStatusIconContainer_musicInCollection";
                        ariaId = String.id.IDS_MARKETPLACE_TOOLTIP_IN_COLLECTION
                    }
                    else if (this.notificationText) {
                        icon = MS.Entertainment.UI.Icon.inlineNotification;
                        iconClass = "mediaStatusIconContainer_inlineNotification";
                        ariaText = this.notificationText;
                        this._hasUsageRightRestrictions = true
                    }
                    if (this._icon !== icon) {
                        this._icon = icon;
                        this._iconContainerDomElement.textContent = icon
                    }
                    if (this.iconClass !== iconClass)
                        this.iconClass = iconClass;
                    if (ariaId)
                        ariaText = String.load(ariaId);
                    if (this._ariaText !== ariaText) {
                        this._ariaText = ariaText;
                        if (ariaText)
                            this._ariaLabelContainerDomElement.textContent = ariaText;
                        else
                            this._ariaLabelContainerDomElement.textContent = String.empty;
                        this.domElement.title = this._ariaLabelContainerDomElement.textContent
                    }
                }, _setVisible: function _setVisible(hasError) {
                    var visible = hasError || this._isNowPlaying || this._isDownloading || this._inCollection || this._hasMusicVideo || this._hasUsageRightRestrictions;
                    if (this._visible !== visible) {
                        this._visible = visible;
                        this.visibility = visible
                    }
                }, _updateFlyoutState: function _updateFlyoutState() {
                    if (this._unloaded || !this.domElement || this.hasError)
                        return;
                    if (this.notificationText) {
                        this.domElement.disabled = MS.Entertainment.Utilities.isMusicApp2;
                        this.domElement.setAttribute("role", "")
                    }
                    else {
                        this._notificationText = null;
                        this.domElement.disabled = true;
                        this.domElement.setAttribute("role", "presentation")
                    }
                }, _updateState: function _updateState() {
                    this._updateFlyoutState();
                    this._setIconAndAriaString();
                    var setClassFreeStreamLimitExceeded = this._freeTrackLimitExceeded || (this.mediaInstance && this.mediaInstance.inCollection && this._monthlyFreeLimitExceeded);
                    if (this._setClassFreeStreamLimitExceeded !== setClassFreeStreamLimitExceeded) {
                        this._setClassFreeStreamLimitExceeded = setClassFreeStreamLimitExceeded;
                        var freeStreamLimitExceededClassName = "state_freeStreamLimitExceeded";
                        if (setClassFreeStreamLimitExceeded)
                            MS.Entertainment.Utilities.safeAddClass(this.parentWinItemElement, freeStreamLimitExceededClassName);
                        else
                            MS.Entertainment.Utilities.safeRemoveClass(this.parentWinItemElement, freeStreamLimitExceededClassName)
                    }
                    if (this._setIsNowPlayingState !== this._isNowPlaying) {
                        this._setIsNowPlayingState = this._isNowPlaying;
                        var stateNowplayingClassName = "state_nowPlaying";
                        if (this._setIsNowPlayingState)
                            MS.Entertainment.Utilities.safeAddClass(this.parentWinItemElement, stateNowplayingClassName);
                        else
                            MS.Entertainment.Utilities.safeRemoveClass(this.parentWinItemElement, stateNowplayingClassName)
                    }
                    if (this._setCanPlayLocally !== this._canPlayLocally) {
                        this._setCanPlayLocally = this._canPlayLocally;
                        var streamOnlyClassName = "state_streamingOnly";
                        if (this._setCanPlayLocally)
                            MS.Entertainment.Utilities.safeRemoveClass(this.parentWinItemElement, streamOnlyClassName);
                        else
                            MS.Entertainment.Utilities.safeAddClass(this.parentWinItemElement, streamOnlyClassName)
                    }
                    if (this._setExplicit !== this._isExplicit) {
                        this._setExplicit = this._isExplicit;
                        var explicitClassName = "state_explicit";
                        if (this._setExplicit)
                            MS.Entertainment.Utilities.safeAddClass(this.parentWinItemElement, explicitClassName);
                        else
                            MS.Entertainment.Utilities.safeRemoveClass(this.parentWinItemElement, explicitClassName)
                    }
                    if (this._setUnavailable !== this._isUnavailable) {
                        this._setUnavailable = this._isUnavailable;
                        var unavailableClassName = "state_unavailable";
                        if (this._setUnavailable)
                            MS.Entertainment.Utilities.safeAddClass(this.parentWinItemElement, unavailableClassName);
                        else
                            MS.Entertainment.Utilities.safeRemoveClass(this.parentWinItemElement, unavailableClassName)
                    }
                    var hasError = (this._playbackErrorCode || this._transferErrorCode || this._freeTrackLimitExceeded || this._notLocalErrorCode || this._monthlyFreeLimitExceeded) ? true : false;
                    if (this.hasError !== hasError) {
                        this.hasError = hasError;
                        if (this.domElement)
                            if (hasError) {
                                this.domElement.disabled = MS.Entertainment.Utilities.isMusicApp2;
                                this.domElement.setAttribute("role", "")
                            }
                            else {
                                this.domElement.disabled = true;
                                this.domElement.setAttribute("role", "presentation")
                            }
                        if (this._iconContainerDomElement)
                            MS.Entertainment.Utilities.toggleClassOnElement(this._iconContainerDomElement, hasError, "state-mediaError")
                    }
                    var visible = this._setVisible(hasError)
                }, _getParentWinItemElement: function _getParentWinItemElement() {
                    var parentWinItemElement = this.domElement;
                    if (parentWinItemElement && !WinJS.Utilities.hasClass(parentWinItemElement, "win-item"))
                        parentWinItemElement = MS.Entertainment.Utilities.findParentElementByClassName(parentWinItemElement, "win-item");
                    if (!parentWinItemElement) {
                        parentWinItemElement = this.domElement;
                        do
                            parentWinItemElement = MS.Entertainment.Utilities.findParentElementByClassName(parentWinItemElement, "win-template");
                        while (parentWinItemElement && parentWinItemElement.parentElement)
                    }
                    if (!parentWinItemElement)
                        parentWinItemElement = this.domElement;
                    return parentWinItemElement
                }, _attachedMediaId: function _attachedMediaId(mediaId) {
                    if (typeof mediaId === "number")
                        this._attachedLibraryId = mediaId;
                    else if (typeof mediaId === "string")
                        if (this._isFilePath(mediaId))
                            this._attachedActivationFilePath = mediaId;
                        else
                            this._attachedServiceId = mediaId;
                    else
                        MS.Entertainment.UI.Controls.Music.fail("Attached unknown mediaId type")
                }, _detachedMediaId: function _detachedMediaId(mediaId) {
                    if (typeof mediaId === "number")
                        this._attachedLibraryId = -1;
                    else if (typeof mediaId === "string")
                        if (this._isFilePath(mediaId))
                            this._attachedActivationFilePath = String.empty;
                        else
                            this._attachedServiceId = MS.Entertainment.Utilities.EMPTY_GUID;
                    else
                        MS.Entertainment.UI.Controls.Music.fail("Detached unknown mediaId type")
                }, _isFilePath: function _isFilePath(text) {
                    return (text.indexOf("\\") >= 0 || text.indexOf("/") >= 0)
                }, _isValidMediaId: function _isValidMediaId(mediaId) {
                    return ((typeof mediaId === "number" && mediaId >= 0) || (typeof mediaId === "string" && !MS.Entertainment.Utilities.isEmptyGuid(mediaId)))
                }
        }, {
            mediaInstance: null, showInCollectionState: false
        })})
})()
