﻿/* Copyright (C) Microsoft Corporation. All rights reserved. */
(function() {
    "use strict";
    scriptValidator("/Framework/corefx.js", "/Framework/debug.js", "/Framework/utilities.js");
    WinJS.Namespace.define("MS.Entertainment.UI.Controls", {StarRatingControl: MS.Entertainment.UI.Framework.defineUserControl("/Controls/StarRatingControl.html#starRatingControlTemplate", function StarRatingControl(element){}, {
            controlName: "StarRatingControl", allowAnimations: false, preventKeyboardFocus: false, refreshOnThaw: false, _mediaInstanceBinding: null, _mediaInstancePropertyBindings: null, _signedInBinding: null, _requestedCanonicalId: null, _ratingProvider: null, initialize: function initialize() {
                    this._ratingProvider = (new Microsoft.Entertainment.Platform.MediaStore).ratingProvider;
                    if (!this.disabled) {
                        var signInService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signIn);
                        this._signedInBinding = WinJS.Binding.bind(signInService, {isSignedIn: function() {
                                this.disabled = !signInService.isSignedIn
                            }.bind(this)})
                    }
                    if (this.disableTransitionAnimations) {
                        var starNodes = this.domElement.querySelectorAll('div[style^="transition"]');
                        for (var index = 0; index < starNodes.length; index++)
                            starNodes[index].style.animation = null
                    }
                    this._mediaInstanceBinding = WinJS.Binding.bind(this, {mediaInstance: this._setMediaInstancePropertyBindings.bind(this)});
                    if (MS.Entertainment.Utilities.isApp2) {
                        var emptyItem = this.domElement.querySelector(".emptyFocusableItem");
                        if (emptyItem)
                            WinJS.Utilities.removeClass(emptyItem, "win-focusable")
                    }
                    if (this.preventKeyboardFocus)
                        WinJS.Utilities.removeClass(this._ratingsControl.element, "win-focusable")
                }, _setMediaInstancePropertyBindings: function _setMediaInstancePropertyBindings() {
                    if (this.mediaInstance) {
                        if (this._mediaInstancePropertyBindings)
                            this._mediaInstancePropertyBindings.cancel();
                        this._mediaInstancePropertyBindings = WinJS.Binding.bind(this.mediaInstance, {
                            averageRating: this._handleMediaPropertiesChange.bind(this), averageRatingCount: this._handleMediaPropertiesChange.bind(this), userRating: this._handleMediaPropertiesChange.bind(this)
                        })
                    }
                }, unload: function unload() {
                    if (this._mediaInstanceBinding) {
                        this._mediaInstanceBinding.cancel();
                        this._mediaInstanceBinding = null
                    }
                    if (this._signedInBinding) {
                        this._signedInBinding.cancel();
                        this._signedInBinding = null
                    }
                    if (this._mediaInstancePropertyBindings) {
                        this._mediaInstancePropertyBindings.cancel();
                        this._mediaInstancePropertyBindings = null
                    }
                    MS.Entertainment.UI.Framework.UserControl.prototype.unload.call(this)
                }, thaw: function thaw() {
                    if (this.refreshOnThaw) {
                        this._requestedCanonicalId = null;
                        this._handleMediaPropertiesChange()
                    }
                    MS.Entertainment.UI.Framework.UserControl.prototype.thaw.call(this)
                }, _handleMediaPropertiesChange: function _handleMediaPropertiesChange() {
                    if (this.mediaInstance) {
                        if (this.mediaInstance.userRating !== null && this.mediaInstance.userRating !== this.userRating) {
                            this.userRating = this.mediaInstance.userRating;
                            this._ratingsControl.userRating = this.mediaInstance.userRating;
                            this._ratingChangedHandler()
                        }
                        this._updateRatingFromDatabase();
                        if (this.mediaInstance.averageRating !== undefined && this.averageRating !== this.mediaInstance.averageRating)
                            this.averageRating = this.mediaInstance.averageRating;
                        if (this.mediaInstance.averageRatingCount !== undefined && this.averageRatingCount !== this.mediaInstance.averageRatingCount)
                            this.averageRatingCount = this.mediaInstance.averageRatingCount
                    }
                }, _updateRatingFromDatabase: function _getRatingFromDatabase() {
                    if (!this.mediaInstance || !this.mediaInstance.mediaType || !this.mediaInstance.hasCanonicalId)
                        return;
                    var ratingType = MS.Entertainment.Data.Factory.Library.mediaTypeToRatingTypeMappings[this.mediaInstance.mediaType];
                    if (!ratingType) {
                        MS.Entertainment.Framework.fail("Unknown mediaType: " + this.mediaInstance.mediaType);
                        return
                    }
                    if (this._requestedCanonicalId !== this.mediaInstance.canonicalId) {
                        this._requestedCanonicalId = this.mediaInstance.canonicalId;
                        this._ratingProvider.getRatingForMarketplaceItemAsync(this._requestedCanonicalId, ratingType).then(function ratingReturned(ratingItem) {
                            this.userRating = ratingItem.rating
                        }.bind(this))
                    }
                }, _ratingChangedHandler: function _ratingChangedHandler(eventInfo) {
                    if (!this.mediaInstance || !this.mediaInstance.hasCanonicalId)
                        return;
                    var selectedRating = this._ratingsControl.userRating;
                    var ratingType = MS.Entertainment.Data.Factory.Library.mediaTypeToRatingTypeMappings[this.mediaInstance.mediaType];
                    if (!ratingType) {
                        MS.Entertainment.Framework.fail("Unknown mediaType: " + this.mediaInstance.mediaType);
                        return
                    }
                    this._ratingProvider.setMarketplaceItemsRatingAsync([this.mediaInstance.canonicalId], ratingType, selectedRating).then(function ratingSaved() {
                        this.userRating = selectedRating
                    }.bind(this))
                }
        }, {
            averageRating: null, averageRatingCount: null, userRating: null, disabled: false, ratingInfoVisible: true, mediaInstance: null
        })})
})()
