﻿/* Copyright (C) Microsoft Corporation. All rights reserved. */
(function() {
    "use strict";
    scriptValidator("/Framework/corefx.js", "/Framework/debug.js", "/Framework/utilities.js");
    MS.Entertainment.UI.Debug.defineAssert("MS.Entertainment.UI.Controls");
    WinJS.Namespace.define("MS.Entertainment.UI.Controls", {UserFeedbackDialog: MS.Entertainment.UI.Framework.defineUserControl("/Controls/UserFeedbackDialog.html#userFeedbackDialogTemplate", function UserFeedbackDialog() {
            this.privacyStatementLabel = String.load(String.id.IDS_SETTINGS_ABOUT_PRIVACY_STATEMENT);
            if (MS.Entertainment.Utilities.isApp2) {
                this.provideDetailsLabel = String.load(String.id.IDS_APP_MENU_FEEDBACK_PROVIDE_DETAILS_VUI_GUI);
                if (WinJS.Utilities.getMember("MS.Entertainment.UI.App2.VoiceStatics")) {
                    this.provideDetailsVoiceConfidence = MS.Entertainment.UI.App2.VoiceStatics.defaultConfidence;
                    this.privacyStatementVoiceConfidence = MS.Entertainment.UI.App2.VoiceStatics.defaultConfidence
                }
            }
        }, {
            optionalParameter: null, _overlay: null, _selectedRadioButton: null, _submitted: false, _issuesTypes: null, _suggestionIssueTypeIndex: 0, _errorIssueTypeIndex: 0, _shareIssueTypeIndex: 0, _inputEventHandlers: null, provideDetailsLabel: String.Empty, provideDetailsVoiceConfidence: null, privacyStatementLabel: String.empty, privacyStatementVoiceConvidence: null, initialize: function initialize() {
                    this._issuesTypes = [];
                    if (MS.Entertainment.Utilities.isMusicApp) {
                        if (MS.Entertainment.Utilities.isMusicApp1) {
                            this._issuesTypes.push({
                                name: String.load(String.id.IDS_SETTINGS_FEEDBACK_BUYINGMUSIC), comment: String.load(String.id.IDS_SETTINGS_FEEDBACK_BUYINGMUSIC_DETAILS), value: "BuyMusic"
                            });
                            this._issuesTypes.push({
                                name: String.load(String.id.IDS_SETTINGS_FEEDBACK_CANTSIGNIN), comment: String.load(String.id.IDS_SETTINGS_FEEDBACK_CANTSIGNIN_DETAILS), value: "CantSignIn"
                            });
                            this._issuesTypes.push({
                                name: String.load(String.id.IDS_SETTINGS_FEEDBACK_CONNECTED), comment: String.load(String.id.IDS_SETTINGS_FEEDBACK_CONNECTED_DETAILS), value: "ConnectedDevice"
                            });
                            this._issuesTypes.push({
                                name: String.load(String.id.IDS_SETTINGS_FEEDBACK_DOWNLOADINGMUSIC), comment: String.load(String.id.IDS_SETTINGS_FEEDBACK_BUYINGMUSIC_DETAILS), value: "DownloadMusic"
                            })
                        }
                        this._issuesTypes.push({
                            name: String.load(String.id.IDS_SETTINGS_FEEDBACK_STREAMINGMUSIC), comment: String.load(String.id.IDS_SETTINGS_FEEDBACK_STREAMINGMUSIC_DETAILS), value: "MusicStreaming"
                        });
                        if (MS.Entertainment.Utilities.isMusicApp2)
                            this._issuesTypes.push({
                                name: String.load(String.id.IDS_MUSIC2_SETTINGS_FEEDBACK_MUSICVIDEO), comment: String.load(String.id.IDS_MUSIC2_SETTINGS_FEEDBACK_MUSICVIDEO_DETAILS), value: "MusicVideo"
                            });
                        this._issuesTypes.push({
                            name: String.load(String.id.IDS_SETTINGS_FEEDBACK_GENERALERRORS), comment: String.load(String.id.IDS_SETTINGS_FEEDBACK_GENERALERROR_DETAILS), value: "GeneralError"
                        });
                        this._issuesTypes.push({
                            name: String.load(String.id.IDS_SETTINGS_FEEDBACK_MUSICFORMAT), comment: String.load(String.id.IDS_SETTINGS_FEEDBACK_MUSICFORMAT_DETAILS), value: "MusicFormat"
                        });
                        this._issuesTypes.push({
                            name: String.load(String.id.IDS_SETTINGS_FEEDBACK_PLAYINGMUSIC), comment: String.load(String.id.IDS_SETTINGS_FEEDBACK_PLAYINGMUSIC_DETAILS), value: "PlayMusic"
                        });
                        if (MS.Entertainment.Utilities.isApp2)
                            this._issuesTypes.push({
                                name: String.load(String.id.IDS_SETTINGS_FEEDBACK_SUGGESTION), comment: String.load(String.id.IDS_SETTINGS_FEEDBACK_SUGGESTION_DETAILS), value: "Suggestion"
                            });
                        this._issuesTypes.push({
                            name: String.load(String.id.IDS_SETTINGS_FEEDBACK_SYNC), comment: String.load(String.id.IDS_SETTINGS_FEEDBACK_CANTSIGNIN_DETAILS), value: "SyncCloud"
                        });
                        this._issuesTypes.push({
                            name: String.load(String.id.IDS_SETTINGS_FEEDBACK_WRONGMUSIC), comment: String.load(String.id.IDS_SETTINGS_FEEDBACK_WRONGMUSIC_DETAILS), value: "WrongMusicInfo"
                        });
                        this._issuesTypes.push({
                            name: String.load(String.id.IDS_SETTINGS_FEEDBACK_MUSICMETADATA), comment: String.load(String.id.IDS_SETTINGS_FEEDBACK_MUSICMETADATA_DETAILS), value: "MusicMetadata"
                        });
                        if (MS.Entertainment.Utilities.isMusicApp1)
                            this._issuesTypes.push({
                                name: String.load(String.id.IDS_MUSIC_SHARE_SAS_FEEDBACK_TYPE), comment: String.load(String.id.IDS_MUSIC_SHARE_SAS_FEEDBACK_COMMENTS), value: "SharePlaylist"
                            })
                    }
                    else if (MS.Entertainment.Utilities.isVideoApp) {
                        this._issuesTypes.push({
                            name: String.load(String.id.IDS_SETTINGS_FEEDBACK_BUYINGVIDEO), comment: String.load(String.id.IDS_SETTINGS_FEEDBACK_BUYINGVIDEO_DETAILS), value: "BuyOrRent"
                        });
                        if (MS.Entertainment.Utilities.isVideoApp1) {
                            this._issuesTypes.push({
                                name: String.load(String.id.IDS_SETTINGS_FEEDBACK_CANTSIGNIN), comment: String.load(String.id.IDS_SETTINGS_FEEDBACK_CANTSIGNIN_DETAILS), value: "CantSignIn"
                            });
                            this._issuesTypes.push({
                                name: String.load(String.id.IDS_SETTINGS_FEEDBACK_CONNECTED), comment: String.load(String.id.IDS_SETTINGS_FEEDBACK_CONNECTED_DETAILS), value: "ConnectedDevice"
                            });
                            this._issuesTypes.push({
                                name: String.load(String.id.IDS_SETTINGS_FEEDBACK_DOWNLOADINGVIDEO), comment: String.load(String.id.IDS_SETTINGS_FEEDBACK_BUYINGVIDEO_DETAILS), value: "DownloadingVideo"
                            })
                        }
                        this._issuesTypes.push({
                            name: String.load(String.id.IDS_SETTINGS_FEEDBACK_STREAMINGVIDEO), comment: String.load(String.id.IDS_SETTINGS_FEEDBACK_STREAMINGVIDEO_DETAILS), value: "StreamingVideo"
                        });
                        this._issuesTypes.push({
                            name: String.load(String.id.IDS_SETTINGS_FEEDBACK_GENERALERRORS), comment: String.load(String.id.IDS_SETTINGS_FEEDBACK_GENERALERROR_DETAILS), value: "GeneralError"
                        });
                        this._issuesTypes.push({
                            name: String.load(String.id.IDS_SETTINGS_FEEDBACK_PLAYINGVIDEO), comment: String.load(String.id.IDS_SETTINGS_FEEDBACK_PLAYINGVIDEO_DETAILS), value: "PlayVideo"
                        });
                        if (MS.Entertainment.Utilities.isApp2)
                            this._issuesTypes.push({
                                name: String.load(String.id.IDS_SETTINGS_FEEDBACK_SUGGESTION), comment: String.load(String.id.IDS_SETTINGS_FEEDBACK_SUGGESTION_DETAILS), value: "Suggestion"
                            });
                        this._issuesTypes.push({
                            name: String.load(String.id.IDS_SETTINGS_FEEDBACK_VIDEOFORMAT), comment: String.load(String.id.IDS_SETTINGS_FEEDBACK_VIDEOFORMAT_DETAILS), value: "VideoFormat"
                        });
                        this._issuesTypes.push({
                            name: String.load(String.id.IDS_SETTINGS_FEEDBACK_TRAILER), comment: String.load(String.id.IDS_SETTINGS_FEEDBACK_TRAILER_DETAILS), value: "Trailer"
                        });
                        this._issuesTypes.push({
                            name: String.load(String.id.IDS_SETTINGS_FEEDBACK_WRONGVIDEO), comment: String.load(String.id.IDS_SETTINGS_FEEDBACK_BUYINGVIDEO_DETAILS), value: "WrongVideoInfo"
                        })
                    }
                    else {
                        this._issuesTypes.push({
                            name: String.load(String.id.IDS_SETTINGS_FEEDBACK_GENERALERRORS), comment: String.load(String.id.IDS_SETTINGS_FEEDBACK_GENERALERROR_DETAILS), value: "GeneralError"
                        });
                        if (MS.Entertainment.Utilities.isApp2)
                            this._issuesTypes.push({
                                name: String.load(String.id.IDS_SETTINGS_FEEDBACK_SUGGESTION), comment: String.load(String.id.IDS_SETTINGS_FEEDBACK_SUGGESTION_DETAILS), value: "Suggestion"
                            })
                    }
                    this._issuesTypes.forEach(function(item, index) {
                        switch (item.value) {
                            case"Suggestion":
                                this._suggestionIssueTypeIndex = index;
                                break;
                            case"GeneralError":
                                this._errorIssueTypeIndex = index;
                                break;
                            case"SharePlaylist":
                                this._shareIssueTypeIndex = index
                        }
                    }.bind(this));
                    for (var i = 0; i < this._issuesTypes.length; i++) {
                        var opt = document.createElement("option");
                        opt.label = this._issuesTypes[i].name;
                        opt.value = i;
                        this._issueTypeSelector.options.add(opt)
                    }
                    var settingsFlyout = document.getElementById("SettingsFeedback");
                    if (settingsFlyout) {
                        this._setInitialState();
                        settingsFlyout.winControl.addEventListener("beforeshow", this._setInitialState.bind(this))
                    }
                    if (MS.Entertainment.Utilities.isApp2)
                        WinJS.Utilities.addClass(this._userVoiceContainer, "removeFromDisplay")
                }, setOverlay: function setOverlay(instance) {
                    this._overlay = instance;
                    var that = this;
                    this._overlay.buttons = [WinJS.Binding.as({
                            title: String.load(String.id.IDS_SETTINGS_FEEDBACK_SUBMIT), isEnabled: true, execute: function onSubmit() {
                                    that._onSubmit()
                                }
                        }), WinJS.Binding.as({
                            title: String.load(String.id.IDS_SETTINGS_FEEDBACK_CANCEL), isEnabled: true, execute: function onCancel() {
                                    that._onCancel()
                                }
                        })];
                    this._setInitialState();
                    WinJS.Utilities.addClass(this._contentContainer, "settingsFeedbackContentDialog");
                    WinJS.Utilities.addClass(this._userVoiceContainer, "settingsFeedbackOptionsDialog");
                    WinJS.Utilities.addClass(this._editControl.domElement, "settingsFeedbackCommentBoxDialog");
                    WinJS.Utilities.addClass(this._bottomContainer, "settingsFeedbackBottomDialog");
                    WinJS.Utilities.addClass(this._connectionError.domElement, "settingsFeedbackPanelContentDialog");
                    WinJS.Utilities.addClass(this._commentDescription.domElement, "settingsFeedbackPanelContentDialog");
                    WinJS.Utilities.addClass(this._descriptionLabel.domElement, "settingsFeedbackPanelContentDialog");
                    WinJS.Utilities.addClass(this._feedbackButtonContainers, "removeFromDisplay");
                    if (MS.Entertainment.Utilities.isApp2) {
                        WinJS.Utilities.removeClass(this._provideDetailsLabel, "removeFromDisplay");
                        WinJS.Utilities.addClass(this._userCommentContainer, "removeFromDisplay");
                        var currentView = Windows.UI.ViewManagement.InputPane.getForCurrentView();
                        this._inputEventHandlers = MS.Entertainment.Utilities.addEventHandlers(currentView, {
                            showing: this._softKeyboardShown.bind(this), hiding: this._softKeyboardHidden.bind(this)
                        })
                    }
                }, _softKeyboardShown: function _softKeyboardShown() {
                    WinJS.Utilities.addClass(this._userVoiceContainer, "removeFromDisplay");
                    WinJS.Utilities.addClass(this._issueTypeSelector, "removeFromDisplay");
                    WinJS.Utilities.addClass(this._descriptionLabel.domElement, "removeFromDisplay")
                }, _softKeyboardHidden: function _softKeyboardHidden() {
                    WinJS.Utilities.removeClass(this._userVoiceContainer, "removeFromDisplay");
                    WinJS.Utilities.removeClass(this._issueTypeSelector, "removeFromDisplay");
                    WinJS.Utilities.removeClass(this._descriptionLabel.domElement, "removeFromDisplay")
                }, _setInitialState: function _setInitialState() {
                    var signedInUser = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.signedInUser);
                    var gamerTag = signedInUser.gamerTag;
                    if (gamerTag)
                        this._descriptionLabel.text = String.load(String.id.IDS_SETTINGS_FEEDBACK_DESCRIPTION_GAMERTAG).format(gamerTag);
                    else
                        this._descriptionLabel.text = String.load(String.id.IDS_SETTINGS_FEEDBACK_DESCRIPTION);
                    WinJS.Utilities.addClass(this._connectionError.domElement, "hidden");
                    this._editControl.clearInput();
                    if (this._selectedRadioButton)
                        this._selectedRadioButton.checked = false;
                    var initialIssueIndexToSelect = this._suggestionIssueTypeIndex;
                    if (MS.Entertainment.UI.Controls.UserFeedbackDialog.errorId)
                        initialIssueIndexToSelect = this._errorIssueTypeIndex;
                    else if (MS.Entertainment.Utilities.isMusicApp && MS.Entertainment.UI.Controls.UserFeedbackDialog.shareUrl)
                        initialIssueIndexToSelect = this._shareIssueTypeIndex;
                    this._issueTypeSelector.options.selectedIndex = initialIssueIndexToSelect;
                    this._onIssueTypeChange(this._issuesTypes[initialIssueIndexToSelect])
                }, _showDetails: function _showDetails() {
                    if (MS.Entertainment.Utilities.isApp2) {
                        WinJS.Utilities.removeClass(this._userCommentContainer, "removeFromDisplay");
                        WinJS.Utilities.addClass(this._provideDetailsLabel, "removeFromDisplay");
                        WinJS.Promise.timeout(250).done(function setFocus() {
                            var textArea = this._editControl && this._editControl.domElement;
                            if (textArea)
                                MS.Entertainment.UI.Framework.focusElement(this._editControl.domElement.querySelector("textarea"))
                        }.bind(this))
                    }
                }, _showPrivacy: function _showPrivacy(e) {
                    if (e && e.keyCode && !(e.keyCode === WinJS.Utilities.Key.enter || e.keyCode === WinJS.Utilities.Key.space))
                        return;
                    e.preventDefault();
                    var actionService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.actions);
                    var externalNavigationAction = actionService.getAction(MS.Entertainment.UI.Actions.ActionIdentifiers.externalNavigate);
                    externalNavigationAction.parameter = "http://go.microsoft.com/fwlink/?LinkID=259655";
                    externalNavigationAction.automationId = MS.Entertainment.UI.AutomationIds.userFeedbackDialogPrivacyLink;
                    externalNavigationAction.execute()
                }, _showUserVoice: function _showUserVoice(e) {
                    if (e && e.keyCode && !(e.keyCode === WinJS.Utilities.Key.enter || e.keyCode === WinJS.Utilities.Key.space))
                        return;
                    e.preventDefault();
                    var userVoiceUrl;
                    if (MS.Entertainment.Utilities.isMusicApp)
                        userVoiceUrl = "http://go.microsoft.com/fwlink/?LinkID=391683";
                    else if (MS.Entertainment.Utilities.isVideoApp)
                        userVoiceUrl = "http://go.microsoft.com/fwlink/?LinkId=391686";
                    var actionService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.actions);
                    var externalNavigationAction = actionService.getAction(MS.Entertainment.UI.Actions.ActionIdentifiers.externalNavigate);
                    externalNavigationAction.parameter = userVoiceUrl;
                    externalNavigationAction.automationId = MS.Entertainment.UI.AutomationIds.userFeedbackDialogPrivacyLink;
                    externalNavigationAction.execute()
                }, userVoiceString: {get: function userVoiceStringId_get() {
                        var stringId;
                        var featureEnablement = new Microsoft.Entertainment.FeatureEnablement.FeatureEnablement;
                        if (MS.Entertainment.Utilities.isMusicApp)
                            if (featureEnablement.isEnabled(Microsoft.Entertainment.FeatureEnablement.FeatureItem.musicMarketplace))
                                stringId = String.id.IDS_SETTINGS_FEEDBACK_SUGGESTION_XBOXMUSIC;
                            else
                                stringId = String.id.IDS_SETTINGS_FEEDBACK_SUGGESTION_MUSIC;
                        else if (MS.Entertainment.Utilities.isVideoApp)
                            if (featureEnablement.isEnabled(Microsoft.Entertainment.FeatureEnablement.FeatureItem.moviesMarketplace) || featureEnablement.isEnabled(Microsoft.Entertainment.FeatureEnablement.FeatureItem.tvMarketplace))
                                stringId = String.id.IDS_SETTINGS_FEEDBACK_SUGGESTION_XBOXVIDEO;
                            else
                                stringId = String.id.IDS_SETTINGS_FEEDBACK_SUGGESTION_VIDEO;
                        return String.load(stringId)
                    }}, _onSubmit: function _onSubmit() {
                    var currentLocation = null;
                    var currentContentIssue = null;
                    var currentMedia = null;
                    var searchHCR = null;
                    var telemetryParameterArray = [];
                    var pageOptions = null;
                    var inlineDetailsItem = MS.Entertainment.UI.Controls.UserFeedbackDialog.inlineDetailsItem;
                    if (!window.navigator.onLine)
                        WinJS.Utilities.removeClass(this._connectionError.domElement, "hidden");
                    else {
                        telemetryParameterArray.push({
                            parameterName: MS.Entertainment.Utilities.Telemetry.TelemetryParameterNames.AppMode, parameterValue: MS.Entertainment.appMode
                        });
                        currentLocation = MS.Entertainment.Utilities.getCurrentUserLocation();
                        telemetryParameterArray.push({
                            parameterName: MS.Entertainment.Utilities.Telemetry.TelemetryParameterNames.UIPath, parameterValue: currentLocation
                        });
                        telemetryParameterArray.push({
                            parameterName: MS.Entertainment.Utilities.Telemetry.TelemetryParameterNames.ContentIssueType, parameterValue: String.empty
                        });
                        if (WinJS.Utilities.getMember("MS.Entertainment.UI.Monikers") && currentLocation === MS.Entertainment.UI.Monikers.immersiveDetails) {
                            pageOptions = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.navigation).currentPage.options;
                            if (pageOptions && pageOptions.mediaItem) {
                                telemetryParameterArray.push({
                                    parameterName: MS.Entertainment.Utilities.Telemetry.TelemetryParameterNames.MediaType, parameterValue: this._getMediaStringFromItem(pageOptions.mediaItem)
                                });
                                telemetryParameterArray.push({
                                    parameterName: MS.Entertainment.Utilities.Telemetry.TelemetryParameterNames.MediaItem, parameterValue: pageOptions.mediaItem.serviceId
                                });
                                telemetryParameterArray.push({
                                    parameterName: MS.Entertainment.Utilities.Telemetry.TelemetryParameterNames.MediaItemInstanceId, parameterValue: pageOptions.mediaItem.id || pageOptions.mediaItem.ID
                                })
                            }
                        }
                        else if (inlineDetailsItem) {
                            var mediaItem = inlineDetailsItem.mediaItem || inlineDetailsItem.media;
                            if (mediaItem) {
                                telemetryParameterArray.push({
                                    parameterName: MS.Entertainment.Utilities.Telemetry.TelemetryParameterNames.MediaType, parameterValue: this._getMediaStringFromItem(mediaItem)
                                });
                                telemetryParameterArray.push({
                                    parameterName: MS.Entertainment.Utilities.Telemetry.TelemetryParameterNames.MediaItem, parameterValue: mediaItem.serviceId
                                });
                                telemetryParameterArray.push({
                                    parameterName: MS.Entertainment.Utilities.Telemetry.TelemetryParameterNames.MediaItemInstanceId, parameterValue: mediaItem.id || mediaItem.ID
                                })
                            }
                        }
                        if (MS.Entertainment.UI.Controls.UserFeedbackDialog.errorId) {
                            telemetryParameterArray.push({
                                parameterName: MS.Entertainment.Utilities.Telemetry.TelemetryParameterNames.ErrorId, parameterValue: MS.Entertainment.UI.Controls.UserFeedbackDialog.errorId
                            });
                            telemetryParameterArray.push({
                                parameterName: MS.Entertainment.Utilities.Telemetry.TelemetryParameterNames.ErrorTimestamp, parameterValue: MS.Entertainment.UI.Controls.UserFeedbackDialog.timestamp
                            })
                        }
                        if (MS.Entertainment.UI.Controls.UserFeedbackDialog.shareUrl)
                            telemetryParameterArray.push({
                                parameterName: MS.Entertainment.Utilities.Telemetry.TelemetryParameterNames.ShareUrl, parameterValue: MS.Entertainment.UI.Controls.UserFeedbackDialog.shareUrl
                            });
                        var comment = this._editControl.getValue();
                        if (comment.length <= 1024) {
                            telemetryParameterArray.push({
                                parameterName: MS.Entertainment.Utilities.Telemetry.TelemetryParameterNames.CommentText, parameterValue: comment
                            });
                            telemetryParameterArray.push({
                                parameterName: MS.Entertainment.Utilities.Telemetry.TelemetryParameterNames.IssueType, parameterValue: this._issuesTypes[this._issueTypeSelector.options.selectedIndex].value
                            });
                            MS.Entertainment.Utilities.Telemetry.logTelemetryEventWithParameterArray(MS.Entertainment.Utilities.Telemetry.TelemetryEvents.SendASmile, telemetryParameterArray);
                            this._exitFeedback()
                        }
                    }
                }, _getMediaStringFromItem: function _getMediaStringFromItem(mediaItem) {
                    if (!mediaItem)
                        return "undefined";
                    var mediaString = null;
                    switch (mediaItem.mediaType) {
                        case Microsoft.Entertainment.Queries.ObjectType.video:
                            if (mediaItem.videoType === Microsoft.Entertainment.Queries.VideoType.musicVideo)
                                mediaString = "musicVideo";
                            else if (mediaItem.videoType === Microsoft.Entertainment.Queries.VideoType.tvEpisode)
                                mediaString = "episode";
                            else if (mediaItem.videoType === Microsoft.Entertainment.Queries.VideoType.movie)
                                mediaString = "movie";
                            break;
                        case Microsoft.Entertainment.Queries.ObjectType.tvSeries:
                            mediaString = "series";
                            break;
                        case Microsoft.Entertainment.Queries.ObjectType.tvSeason:
                            mediaString = "season";
                            break;
                        case Microsoft.Entertainment.Queries.ObjectType.person:
                            mediaString = "artist";
                            break;
                        case Microsoft.Entertainment.Queries.ObjectType.genre:
                            mediaString = "genre";
                            break;
                        case Microsoft.Entertainment.Queries.ObjectType.album:
                            mediaString = "album";
                            break;
                        case Microsoft.Entertainment.Queries.ObjectType.track:
                            mediaString = "track";
                            break;
                        case Microsoft.Entertainment.Queries.ObjectType.game:
                            mediaString = "game";
                            break;
                        default:
                            mediaString = "undefined";
                            break
                    }
                    return mediaString
                }, _onCancel: function _onCancel() {
                    this._exitFeedback()
                }, _setWatermarkText: function _setWatermarkText(watermarkText) {
                    this._editControl.watermarkText = watermarkText;
                    var currentTextValue = this._editControl.getValue();
                    if (!currentTextValue || currentTextValue.length < 1)
                        this._editControl.reinitialize()
                }, _onIssueTypeChange: function _onIssueTypeChange(args) {
                    this._setWatermarkText(this._issuesTypes[this._issueTypeSelector.options.selectedIndex].comment);
                    if (MS.Entertainment.Utilities.isMusicApp && this._issueTypeSelector.options.selectedIndex === this._shareIssueTypeIndex && MS.Entertainment.UI.Controls.UserFeedbackDialog.shareUrl && this._sharePlaylistURLNote)
                        WinJS.Utilities.removeClass(this._sharePlaylistURLNote.domElement, "removeFromDisplay");
                    else
                        WinJS.Utilities.addClass(this._sharePlaylistURLNote.domElement, "removeFromDisplay")
                }, _exitFeedback: function _exitFeedback() {
                    if (this._overlay)
                        this._overlay.hide();
                    else
                        document.getElementById("SettingsFeedback").winControl.hide();
                    MS.Entertainment.UI.Controls.UserFeedbackDialog.errorId = null;
                    MS.Entertainment.UI.Controls.UserFeedbackDialog.timestamp = null;
                    MS.Entertainment.UI.Controls.UserFeedbackDialog.shareUrl = null;
                    this.optionalParameter = null;
                    if (this._inputEventHandlers) {
                        this._inputEventHandlers.cancel();
                        this._inputEventHandlers = null
                    }
                }, unload: function unload() {
                    this._exitFeedback();
                    MS.Entertainment.UI.Framework.UserControl.prototype.unload.call(this)
                }
        }, null, {
            errorId: null, timestamp: null, shareUrl: null, inlineDetailsItem: null
        })})
})()
