﻿/* Copyright (C) Microsoft Corporation. All rights reserved. */
scriptValidator();
(function() {
    "use strict";
    MS.Entertainment.UI.Debug.defineAssert("MS.Entertainment.UI.Controls");
    WinJS.Namespace.define("MS.Entertainment.UI.Controls", {ChooseDownloadQualityOverlay: MS.Entertainment.UI.Framework.defineUserControl("/Controls/Video/ChooseDownloadQuality.html#chooseDownloadQualityTemplate", function chooseDownloadQualityOverlayConstructor(element, options) {
            if (options) {
                this._media = options._media;
                this._hdSizeInMBytes = options.hdSizeInMBytes;
                this._sdSizeInMBytes = options.sdSizeInMBytes
            }
        }, {
            _media: null, _hdSizeInMBytes: 0, _sdSizeInMBytes: 0, _dialog: null, _okEnabled: true, _cancelEnabled: true, hdSelected: true, downloadFile: false, initialize: function initialize() {
                    this._downloadHD.checked = this.hdSelected;
                    this._downloadSD.checked = !this.hdSelected;
                    if (this._media && (!this._hdSizeInMBytes || !this._sdSizeInMBytes))
                        MS.Entertainment.UI.Controls.ChooseDownloadQualityOverlay.getDialogSizes(this._media).then(function updateFileSizes(dataSource) {
                            this._hdSizeInMBytes = dataSource.hdSizeInMBytes;
                            this._sdSizeInMBytes = dataSource.hdSizeInMBytes;
                            this._updateFileSizeStrings()
                        });
                    this._updateFileSizeStrings()
                }, _updateFileSizeStrings: function _updateFileSizeStrings() {
                    if (this._hdSizeInMBytes < 1 || this._sdSizeInMBytes < 1) {
                        this._downloadHDString.textContent = String.load(String.id.IDS_VIDEO_DETAILS_DOWNLOAD_CHOOSE_HD_SIMPLE);
                        this._downloadSDString.textContent = String.load(String.id.IDS_VIDEO_DETAILS_DOWNLOAD_CHOOSE_SD_SIMPLE);
                        WinJS.Utilities.addClass(this._downloadDisclaimer, "removeFromDisplay");
                        return
                    }
                    this._downloadHDString.textContent = MS.Entertainment.UI.Controls.ChooseDownloadQualityOverlay.getDialogSizeString(this._hdSizeInMBytes, String.id.IDS_VIDEO_DETAILS_DOWNLOAD_CHOOSE_HD);
                    this._downloadSDString.textContent = MS.Entertainment.UI.Controls.ChooseDownloadQualityOverlay.getDialogSizeString(this._sdSizeInMBytes, String.id.IDS_VIDEO_DETAILS_DOWNLOAD_CHOOSE_SD);
                    WinJS.Utilities.removeClass(this._downloadDisclaimer, "removeFromDisplay")
                }, setOverlay: function setOverlay(overlay) {
                    this._dialog = overlay;
                    this._setOKEnabled(this._okEnabled);
                    this._setCanceledEnabled(this._cancelEnabled)
                }, submit: function submit() {
                    this._setOKEnabled(false);
                    this._setCanceledEnabled(false);
                    this.downloadFile = true;
                    if (this._neverPrompt.checked)
                        MS.Entertainment.UI.Controls.ChooseDownloadQualityOverlay.storedDownloadPreference = this.hdSelected ? MS.Entertainment.Data.Augmenter.Marketplace.videoDefinition.hd : MS.Entertainment.Data.Augmenter.Marketplace.videoDefinition.sd;
                    this._hide()
                }, hdClicked: function hdClicked() {
                    this.hdSelected = true
                }, sdClicked: function sdClicked() {
                    this.hdSelected = false
                }, neverPromptClicked: function neverPromptClicked(){}, _hide: function _hide() {
                    if (this._dialog)
                        this._dialog.hide()
                }, _setOKEnabled: function _setOKEnabled(enabled) {
                    if (this._dialog && this._dialog.buttons && (this._dialog.buttons.length > 0))
                        this._dialog.buttons[0].isEnabled = enabled;
                    this._okEnabled = enabled
                }, _setCanceledEnabled: function _setCanceledEnabled(enabled) {
                    if (this._dialog && this._dialog.buttons && (this._dialog.buttons.length > 1))
                        this._dialog.buttons[1].isEnabled = enabled;
                    this._cancelEnabled = enabled
                }
        }, {}, {
            _isChooseDownloadQualityOverlayOpen: false, storedDownloadPreference: {
                    get: function() {
                        try {
                            return Windows.Storage.ApplicationData.current.localSettings.values["preferredDownloadQuality"]
                        }
                        catch(e) {
                            MS.Entertainment.Platform.fail("Failure to read preferredDownloadQuality from localSettings: " + (e && e.message) ? e.message : String.empty)
                        }
                    }, set: function(value) {
                            try {
                                Windows.Storage.ApplicationData.current.localSettings.values["preferredDownloadQuality"] = value;
                                if (MS.Entertainment.ServiceLocator.isServiceRegistered(MS.Entertainment.Services.videoDetailsUiState)) {
                                    var videoDetailsUiStateService = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.videoDetailsUiState);
                                    videoDetailsUiStateService.fireDownloadQualityChangeSignal()
                                }
                            }
                            catch(e) {
                                MS.Entertainment.Platform.fail("Failure to set preferredDownloadQuality from localSettings: " + (e && e.message) ? e.message : String.empty)
                            }
                        }
                }, show: function show(dataSource) {
                    if (MS.Entertainment.UI.Controls.ChooseDownloadQualityOverlay._isChooseDownloadQualityOverlayOpen)
                        return WinJS.Promise.wrap();
                    MS.Entertainment.UI.Controls.ChooseDownloadQualityOverlay._isChooseDownloadQualityOverlayOpen = true;
                    return MS.Entertainment.UI.Shell.showDialog(String.load(String.id.IDS_VIDEO_DETAILS_DOWNLOAD_CHOOSE_TITLE), "MS.Entertainment.UI.Controls.ChooseDownloadQualityOverlay", {
                            userControlOptions: dataSource, width: "40%", height: "310px", buttons: [WinJS.Binding.as({
                                        isEnabled: true, title: String.load(String.id.IDS_DETAILS_DOWNLOAD_LABEL), execute: function execute_submit(dialog) {
                                                WinJS.Promise.as(dialog.userControlInstance.submit()).done(null, function(error) {
                                                    MS.Entertainment.UI.Controls.fail("Submit failed in the choose download quality dialog. Error message: " + error && error.message)
                                                })
                                            }
                                    }), WinJS.Binding.as({
                                        isEnabled: true, title: String.load(String.id.IDS_CANCEL_BUTTON_TC), execute: function execute_cancel(dialog) {
                                                dialog.hide()
                                            }
                                    })], defaultButtonIndex: 0, cancelButtonIndex: 1
                        }).then(function onDismiss(overlay) {
                            if (overlay)
                                MS.Entertainment.UI.Controls.ChooseDownloadQualityOverlay._isChooseDownloadQualityOverlayOpen = false;
                            return overlay
                        })
                }, sizeInMBFromDefinition: function sizeInMBFromDefinition(media, definition, rented) {
                    var offerType = rented ? MS.Entertainment.ViewModels.SmartBuyStateHandlers.MarketplaceRight.Rent : MS.Entertainment.ViewModels.SmartBuyStateHandlers.MarketplaceRight.Purchase;
                    var offer = MS.Entertainment.ViewModels.VideoSmartBuyStateEngine.getDefaultOffer(media, MS.Entertainment.Utilities.defaultClientTypeFromApp, [offerType], false, false, MS.Entertainment.Data.Augmenter.Marketplace.edsDeliveryFormat.download, definition);
                    return offer ? offer.videoFileSizeInBytes / (1024 * 1024) : 0
                }, getDialogSizes: function getDialogSizes(media) {
                    var sizesRet = {
                            hdSizeInMBytes: 0, sdSizeInMBytes: 0
                        };
                    var config = new Microsoft.Entertainment.Configuration.ConfigurationManager;
                    if (config.video.videoDownloadQualityDialogUsesSizes) {
                        var hdSizeInMBytes = 0;
                        var sdSizeInMBytes = 0;
                        return MS.Entertainment.ViewModels.MediaItemModel.hydrateLibraryInfoAsync(media).then(function onHydrateLibraryInfo() {
                                if (!MS.Entertainment.Platform.PlaybackHelpers.isTVSeason(media))
                                    return WinJS.Promise.wrap([media]);
                                else {
                                    if (media.libraryId === -1)
                                        return WinJS.Promise.wrap([]);
                                    var query = new MS.Entertainment.Data.Query.libraryVideoTV;
                                    query.seriesId = media.seriesLibraryId;
                                    query.seasonId = media.libraryId;
                                    query.sort = Microsoft.Entertainment.Queries.VideosSortBy.seriesTitleSeasonNumberEpisodeNumber;
                                    query.isLive = false;
                                    query.chunkSize = 1000;
                                    return query.execute().then(function queryComplete(q) {
                                            if (q && q.result && q.result.items)
                                                return WinJS.Promise.wrap(MS.Entertainment.Data.List.listToArray(q.result.items))
                                        }.bind(this), function queryFailed(q) {
                                            return WinJS.Promise.wrap([])
                                        })
                                }
                            }.bind(this)).then(function onVideoList(mediaItemsArray) {
                                if (!mediaItemsArray || !mediaItemsArray.length)
                                    return [];
                                return WinJS.Promise.join(mediaItemsArray.map(MS.Entertainment.UI.Controls.ChooseDownloadQualityOverlay.hydrateMedia))
                            }.bind(this)).then(function sumFilesSizes(results) {
                                if (results)
                                    for (var i = 0; i < results.length; i++) {
                                        var result = results[i];
                                        if (result && result.length > 1) {
                                            var video = result[0];
                                            var entitlements = result[1];
                                            if (entitlements && entitlements.length > 1) {
                                                var marketplaceInfo = entitlements[0];
                                                var playability = entitlements[1];
                                                var hasHD = false;
                                                if (playability.local || marketplaceInfo.canDownload === MS.Entertainment.ViewModels.SmartBuyStateEngine.FileContainerAccess.None || !marketplaceInfo.libraryDefinitions)
                                                    continue;
                                                if (marketplaceInfo.libraryDefinitions[MS.Entertainment.Data.Augmenter.Marketplace.edsResolutionFormat.hd] || marketplaceInfo.libraryDefinitions[MS.Entertainment.Data.Augmenter.Marketplace.edsResolutionFormat.hd1080p])
                                                    hasHD = true;
                                                var rented = (marketplaceInfo.exclusivelyRented === MS.Entertainment.ViewModels.SmartBuyStateEngine.FileContainerAccess.All);
                                                var videoSdSizeInMBytes = MS.Entertainment.UI.Controls.ChooseDownloadQualityOverlay.sizeInMBFromDefinition(video, MS.Entertainment.Data.Augmenter.Marketplace.videoDefinition.sd, rented);
                                                var videoHdSizeInMBytes = hasHD ? MS.Entertainment.UI.Controls.ChooseDownloadQualityOverlay.sizeInMBFromDefinition(video, MS.Entertainment.Data.Augmenter.Marketplace.videoDefinition.hd, rented) : videoSdSizeInMBytes;
                                                hdSizeInMBytes += videoHdSizeInMBytes;
                                                sdSizeInMBytes += videoSdSizeInMBytes
                                            }
                                        }
                                    }
                                sizesRet.hdSizeInMBytes = hdSizeInMBytes;
                                sizesRet.sdSizeInMBytes = sdSizeInMBytes;
                                return sizesRet
                            })
                    }
                    return WinJS.Promise.wrap(sizesRet)
                }, getDialogSizeString: function getDialogSizeString(sizeInMBytes, stringId) {
                    var sizeString = sizeInMBytes >= 1024 ? String.load(String.id.IDS_VIDEO_DETAILS_DOWNLOAD_CHOOSE_SIZE_GB).format((sizeInMBytes / 1024).toFixed(1)) : String.load(String.id.IDS_VIDEO_DETAILS_DOWNLOAD_CHOOSE_SIZE_MB).format(sizeInMBytes.toFixed(0));
                    var durationHours = (sizeInMBytes * 8 / 1.5) / 3600;
                    var durationString = String.load(String.id.IDS_VIDEO_DETAILS_DOWNLOAD_CHOOSE_SIZE_HOURS).format(durationHours.toFixed(1));
                    return String.load(stringId).format(sizeString, durationString)
                }, hydrateMedia: function hydrateMedia(media) {
                    var hydratePromise = media.hydrate();
                    var fetchMediaStatesPromise = MS.Entertainment.UI.Controls.ChooseDownloadQualityOverlay.fetchMediaStates(media);
                    return WinJS.Promise.join([hydratePromise, fetchMediaStatesPromise])
                }, mediaHasHDandSD: function mediaHasHDandSD(media) {
                    if (!media)
                        return WinJS.Promise.wrap({
                                hasHD: false, hasSD: false
                            });
                    return MS.Entertainment.ViewModels.MediaItemModel.hydrateLibraryInfoAsync(media).then(function onHydrateLibraryInfo() {
                            if (!MS.Entertainment.Platform.PlaybackHelpers.isTVSeason(media))
                                return WinJS.Promise.wrap([media]);
                            else {
                                if (media.libraryId === -1)
                                    return WinJS.Promise.wrap([]);
                                var query = new MS.Entertainment.Data.Query.libraryVideoTV;
                                query.seriesId = media.seriesLibraryId;
                                query.seasonId = media.libraryId;
                                query.sort = Microsoft.Entertainment.Queries.VideosSortBy.seriesTitleSeasonNumberEpisodeNumber;
                                query.isLive = false;
                                query.chunkSize = 1000;
                                return query.execute().then(function queryComplete(q) {
                                        if (q && q.result && q.result.items)
                                            return WinJS.Promise.wrap(MS.Entertainment.Data.List.listToArray(q.result.items))
                                    }.bind(this), function queryFailed(q) {
                                        return WinJS.Promise.wrap([])
                                    })
                            }
                        }.bind(this)).then(function onVideoList(mediaItemsArray) {
                            if (!mediaItemsArray || !mediaItemsArray.length)
                                return [];
                            return WinJS.Promise.join(mediaItemsArray.map(MS.Entertainment.UI.Controls.ChooseDownloadQualityOverlay.fetchMediaStates))
                        }.bind(this)).then(function checkForHD(stateInfos) {
                            if (stateInfos)
                                for (var i = 0; i < stateInfos.length; i++) {
                                    var stateInfo = stateInfos[i];
                                    var hasHD = false;
                                    if (stateInfo.length === 2) {
                                        var marketplaceInfo = stateInfo[0];
                                        var playability = stateInfo[1];
                                        if (playability.local || marketplaceInfo.canDownload === MS.Entertainment.ViewModels.SmartBuyStateEngine.FileContainerAccess.None || !marketplaceInfo.libraryDefinitions)
                                            continue;
                                        if (marketplaceInfo.libraryDefinitions[MS.Entertainment.Data.Augmenter.Marketplace.edsResolutionFormat.hd] || marketplaceInfo.libraryDefinitions[MS.Entertainment.Data.Augmenter.Marketplace.edsResolutionFormat.hd1080p])
                                            hasHD = true;
                                        if (marketplaceInfo.exclusivelyRented === MS.Entertainment.ViewModels.SmartBuyStateEngine.FileContainerAccess.All)
                                            return {
                                                    hasHD: hasHD, hasSD: !hasHD
                                                };
                                        if (hasHD || (MS.Entertainment.Platform.PlaybackHelpers.isTVSeason(media) && marketplaceInfo.hasPurchasedSeason))
                                            return {
                                                    hasHD: hasHD, hasSD: hasHD
                                                }
                                    }
                                }
                            return {
                                    hasHD: false, hasSD: true
                                }
                        }.bind(this))
                }, fetchMediaStates: function fetchMediaStates(media) {
                    var marketplacePromise = MS.Entertainment.ViewModels.SmartBuyStateEngine.getMarketplaceFileAccessAsync(media).then(function queryMediaStateAsync_complete(stateInfo) {
                            return stateInfo
                        });
                    var playabilityPromise = MS.Entertainment.ViewModels.SmartBuyStateEngine.getPlayabilityAsync(media).then(function queryMediaStateAsync_complete(playability) {
                            return playability
                        });
                    return WinJS.Promise.join([marketplacePromise, playabilityPromise])
                }
        })})
})()
