﻿/* Copyright (C) Microsoft Corporation. All rights reserved. */
(function(undefined) {
    "use strict";
    scriptValidator("/Framework/utilities.js");
    WinJS.Namespace.define("MS.Entertainment.UI.Controls", {GalleryGrouper: MS.Entertainment.UI.Framework.define(function galleryGrouperConstructor(){}, {
            getKeySource: function getKeySource(item) {
                var key;
                if (item.data && item.data.groupKey)
                    key = item.data.groupKey;
                else if (item.data && item.data.inlinePanel)
                    key = MS.Entertainment.Utilities.valueFromPropertyPathFragments(item.data.dataItem.data, this.keyPropertyFragments);
                else if (item.data && item.data.isAction)
                    if (typeof item.data.groupHeader === "string")
                        if (String.id[item.data.groupHeader])
                            key = String.load(item.data.groupHeader);
                        else
                            key = item.data.groupHeader;
                    else
                        MS.Entertainment.UI.Controls.fail("an action in a grouped view must specify a groupHeader");
                else if (item.data)
                    key = MS.Entertainment.Utilities.valueFromPropertyPathFragments(item.data, this.keyPropertyFragments);
                else
                    key = String.empty;
                return key
            }, createKey: function createKey(item) {
                    var key = this.getKeySource(item);
                    if (key)
                        key += String.empty;
                    key = MS.Entertainment.Utilities.trimCharacterDirection(key);
                    return key + String.empty
                }, createParentKey: function createParentKey(item, groupData) {
                    return MS.Entertainment.Utilities.trimCharacterDirection(groupData && groupData.key)
                }, createData: function createData(item) {
                    var title = null;
                    var sortTitle = null;
                    var result = item && item.data;
                    var titlePropertyFragments = this.titlePropertyFragments;
                    var sortTitlePropertyFragments = this.sortTitlePropertyFragments;
                    if (titlePropertyFragments && titlePropertyFragments.length) {
                        title = MS.Entertainment.Utilities.valueFromPropertyPathFragments(item && item.data, this.titlePropertyFragments);
                        if (sortTitlePropertyFragments && sortTitlePropertyFragments.length)
                            sortTitle = MS.Entertainment.Utilities.valueFromPropertyPathFragments(item && item.data, this.sortTitlePropertyFragments);
                        result = {
                            title: title, sortTitle: sortTitle || title
                        }
                    }
                    return result
                }, _keyPropertyName: null, _keyPropertyFragments: null, _titlePropertyName: null, _titlePropertyFragments: null, _sortTitlePropertyName: null, _sortTitlePropertyFragments: null, useKeyAsData: true, keyPropertyName: {
                    get: function() {
                        return this._keyPropertyName
                    }, set: function(value) {
                            if (value !== this._keyPropertyName) {
                                this._keyPropertyFragments = null;
                                this._keyPropertyName = value
                            }
                        }
                }, keyPropertyFragments: {get: function() {
                        this._keyPropertyFragments = this._keyPropertyFragments || MS.Entertainment.Utilities.getPropertyPathFragments(this._keyPropertyName);
                        return this._keyPropertyFragments
                    }}, titlePropertyName: {
                    get: function() {
                        return this._titlePropertyName
                    }, set: function(value) {
                            if (value !== this._titlePropertyName) {
                                this._titlePropertyFragments = null;
                                this._titlePropertyName = value
                            }
                        }
                }, sortTitlePropertyName: {
                    get: function() {
                        return this._sortTitlePropertyName
                    }, set: function(value) {
                            if (value !== this._sortTitlePropertyName) {
                                this._sortTitlePropertyFragments = null;
                                this._sortTitlePropertyName = value
                            }
                        }
                }, titlePropertyFragments: {get: function() {
                        this._titlePropertyFragments = this._titlePropertyFragments || MS.Entertainment.Utilities.getPropertyPathFragments(this._titlePropertyName);
                        return this._titlePropertyFragments
                    }}, sortTitlePropertyFragments: {get: function() {
                        this._sortTitlePropertyFragments = this._sortTitlePropertyFragments || MS.Entertainment.Utilities.getPropertyPathFragments(this._sortTitlePropertyName);
                        return this._sortTitlePropertyFragments
                    }}, execute: function execute(item) {
                    var key = this.createKey(item);
                    var data = (this.useKeyAsData) ? {title: key} : this.createData(item);
                    key = MS.Entertainment.Utilities.trimCharacterDirection(key);
                    var groupData = {
                            key: key, data: data, parentData: data
                        };
                    groupData.parentKey = this.createParentKey(item, groupData);
                    if (groupData.parentKey !== groupData.key)
                        groupData.parentData = {title: groupData.parentKey};
                    return groupData
                }
        })});
    WinJS.Namespace.define("MS.Entertainment.UI.Controls", {
        GalleryAlphaWordGrouper: MS.Entertainment.UI.Framework.derive("MS.Entertainment.UI.Controls.GalleryGrouper", function galleryAlphaWordGrouperConstructor(){}, {
            isSubGroup: false, _parentGrouper: null, createKey: function createKey(item) {
                    var key = MS.Entertainment.UI.Controls.GalleryGrouper.prototype.createKey.call(this, item) + String.empty;
                    if (!key || key === "null")
                        key = String.load(String.id.IDS_UNKNOWN_VALUE);
                    return key
                }, createParentKey: function createParentKey(item, groupData) {
                    var key = null;
                    if (this.isSubGroup) {
                        if (!this._parentGrouper) {
                            this._parentGrouper = new MS.Entertainment.UI.Controls.GalleryAlphaCharGrouper;
                            this._parentGrouper.keyPropertyName = this.keyPropertyName
                        }
                        key = this._parentGrouper.createKey(item)
                    }
                    else
                        key = MS.Entertainment.UI.Controls.GalleryGrouper.prototype.createParentKey(item, groupData);
                    return key + String.empty
                }
        }), GalleryMediaItemGrouper: MS.Entertainment.UI.Framework.derive("MS.Entertainment.UI.Controls.GalleryGrouper", function galleryAlphaWordGrouperConstructor(){}, {
                isSubGroup: false, parentKeyPropertyName: "sortTitle", _parentGrouper: null, createKey: function createKey(item) {
                        var key = MS.Entertainment.UI.Controls.GalleryGrouper.prototype.createKey.call(this, item) + String.empty;
                        if (!key || key === "null")
                            key = String.load(String.id.IDS_UNKNOWN_VALUE);
                        return key
                    }, createParentKey: function createParentKey(item, groupData) {
                        var key = null;
                        if (this.isSubGroup) {
                            if (!this._parentGrouper)
                                this._parentGrouper = new MS.Entertainment.UI.Controls.GalleryAlphaCharGrouper;
                            this._parentGrouper.keyPropertyName = this.parentKeyPropertyName;
                            key = this._parentGrouper.createKey(groupData)
                        }
                        else
                            key = MS.Entertainment.UI.Controls.GalleryGrouper.prototype.createParentKey(item, groupData);
                        return key + String.empty
                    }
            }), GalleryAlphaCharGrouper: MS.Entertainment.UI.Framework.derive("MS.Entertainment.UI.Controls.GalleryGrouper", function galleryAlphaCharGrouperConstructor() {
                try {
                    this._characterGroupings = new Windows.Globalization.Collation.CharacterGroupings
                }
                catch(error) {}
            }, {
                _characterGroupings: null, createKey: function createKey(item) {
                        var index = 0;
                        var key = String.empty;
                        var originalKey = MS.Entertainment.UI.Controls.GalleryGrouper.prototype.createKey.call(this, item) + String.empty;
                        if (item.isAction)
                            return originalKey;
                        if (this._characterGroupings)
                            key = this._characterGroupings.lookup(originalKey || String.empty) + String.empty;
                        if (key === "Numbers")
                            key = String.load(String.id.IDS_NUMBER_SYMBOL);
                        else if (key === "Symbols")
                            key = String.load(String.id.IDS_WILD_CARD_SYMBOL);
                        return key
                    }
            }), GalleryNumericGrouper: MS.Entertainment.UI.Framework.derive("MS.Entertainment.UI.Controls.GalleryGrouper", function galleryNumericGrouperConstructor(){}, {}), GalleryTitleParentGrouper: MS.Entertainment.UI.Framework.derive("MS.Entertainment.UI.Controls.GalleryGrouper", function galleryYearGrouperConstructor(){}, {
                useKeyAsData: false, noHeaderGroups: true, createKey: function createKey(item) {
                        return null
                    }, createParentKey: function createParentKey(item, groupData) {
                        var title = groupData && groupData.data && groupData.data.title;
                        if (title !== null && title !== undefined)
                            title += String.empty;
                        title = MS.Entertainment.Utilities.trimCharacterDirection(title);
                        return title
                    }
            }), GalleryYearGrouper: MS.Entertainment.UI.Framework.derive("MS.Entertainment.UI.Controls.GalleryGrouper", function galleryYearGrouperConstructor(){}, {createKey: function createKey(item) {
                    var key = this.getKeySource(item);
                    if (!key || key === "null")
                        return String.load(String.id.IDS_UNKNOWN_VALUE);
                    if (item.isAction)
                        return key;
                    var date = MS.Entertainment.Data.Factory.localizedYear(key);
                    return (date || key) + String.empty
                }}), GalleryMonthGrouper: MS.Entertainment.UI.Framework.derive("MS.Entertainment.UI.Controls.GalleryGrouper", function galleryMonthGrouperConstructor(){}, {createKey: function createKey(item) {
                    var key = MS.Entertainment.UI.Controls.GalleryGrouper.prototype.createKey.call(this, item) + String.empty;
                    if (!key || key === "null")
                        return String.load(String.id.IDS_UNKNOWN_VALUE);
                    if (item.isAction)
                        return key;
                    var date = new Date(key);
                    var formattedMonth = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.dateTimeFormatters).abbreviatedMonthYear;
                    if (!MS.Entertainment.UI.Controls.GalleryMonthGrouper.minCalendar) {
                        MS.Entertainment.UI.Controls.GalleryMonthGrouper.minCalendar = new Windows.Globalization.Calendar(formattedMonth.languages);
                        MS.Entertainment.UI.Controls.GalleryMonthGrouper.minCalendar.setToMin()
                    }
                    if (!MS.Entertainment.UI.Controls.GalleryMonthGrouper.enCalendar)
                        MS.Entertainment.UI.Controls.GalleryMonthGrouper.enCalendar = new Windows.Globalization.Calendar(["en-US"]);
                    MS.Entertainment.UI.Controls.GalleryMonthGrouper.enCalendar.setDateTime(date);
                    if (MS.Entertainment.UI.Controls.GalleryMonthGrouper.enCalendar.compare(MS.Entertainment.UI.Controls.GalleryMonthGrouper.minCalendar) < 0)
                        date = MS.Entertainment.UI.Controls.GalleryMonthGrouper.minCalendar.getDateTime();
                    var month = formattedMonth.format(date);
                    return month + String.empty
                }}, {enCalendar: null}), GalleryDayGrouper: MS.Entertainment.UI.Framework.derive("MS.Entertainment.UI.Controls.GalleryGrouper", function galleryDayGrouperConstructor(){}, {createKey: function createKey(item) {
                    var key = MS.Entertainment.UI.Controls.GalleryGrouper.prototype.createKey.call(this, item) + String.empty;
                    if (!key)
                        return String.load(String.id.IDS_UNKNOWN_VALUE);
                    if (item.isAction)
                        return key;
                    var date = new Date(key).toDateString();
                    return date + String.empty
                }}), GalleryRecentGrouper: MS.Entertainment.UI.Framework.derive("MS.Entertainment.UI.Controls.GalleryGrouper", function galleryRecentGrouperConstructor(){}, {createKey: function createKey(item) {
                    var key = MS.Entertainment.UI.Controls.GalleryGrouper.prototype.createKey.call(this, item);
                    if (!key)
                        return String.load(String.id.IDS_UNKNOWN_VALUE);
                    if (item.isAction)
                        return key + String.empty;
                    var date = new Date(key);
                    var today = new Date;
                    var diff = Date.subtract(today, date);
                    var group;
                    if (diff.days <= 7)
                        group = String.load(String.id.IDS_RECENT_THIS_WEEK);
                    else if (diff.days <= 14)
                        group = String.load(String.id.IDS_RECENT_LAST_WEEK);
                    else if (date.getYear() === today.getYear() && date.getMonth() === today.getMonth())
                        group = String.load(String.id.IDS_RECENT_THIS_MONTH);
                    else {
                        var superShortMonthPattern = MS.Entertainment.ServiceLocator.getService(MS.Entertainment.Services.dateTimeFormatters).abbreviatedMonth;
                        var shortMonth = superShortMonthPattern.format(date);
                        group = shortMonth + " " + date.getFullYear()
                    }
                    return group + String.empty
                }}), SearchResultsGrouper: MS.Entertainment.UI.Framework.derive(MS.Entertainment.UI.Controls.GalleryGrouper, function searchResultsGrouperConstructor(){}, {createKey: function createKey(item) {
                    if (item.data && item.data.isHCR)
                        return "-1";
                    else
                        return MS.Entertainment.UI.Controls.GalleryGrouper.prototype.createKey.call(this, item)
                }})
    });
    WinJS.Namespace.define("MS.Entertainment.UI.Controls", {
        GalleryAlphaWordSubGrouper: MS.Entertainment.UI.Framework.derive("MS.Entertainment.UI.Controls.GalleryAlphaWordGrouper", function GalleryAlphaWordSubGrouper(){}, {isSubGroup: true}), GalleryMediaItemSubGrouper: MS.Entertainment.UI.Framework.derive("MS.Entertainment.UI.Controls.GalleryMediaItemGrouper", function GalleryMediaItemSubGrouper(){}, {isSubGroup: true}), VideoSearchResultsGrouper: MS.Entertainment.UI.Framework.derive("MS.Entertainment.UI.Controls.SearchResultsGrouper", function videoSearchResultsGrouperConstructor(){}, {createKey: function createKey(item) {
                    if (item.data && item.data.isHCR)
                        return "-1";
                    if (item.data.inCollection)
                        if (item.data.mediaType === Microsoft.Entertainment.Queries.ObjectType.video) {
                            MS.Entertainment.UI.Controls.assert(item.data.videoType === Microsoft.Entertainment.Queries.VideoType.movie || item.data.videoType === Microsoft.Entertainment.Queries.VideoType.other || item.data.videoType === Microsoft.Entertainment.Queries.VideoType.musicVideo, "Invalid video type passed to VideoSearchResultsGrouper");
                            return (item.data.videoType === Microsoft.Entertainment.Queries.VideoType.movie) ? "collectionMovie" : "otherVideo"
                        }
                        else {
                            MS.Entertainment.UI.Controls.assert(item.data.mediaType === Microsoft.Entertainment.Queries.ObjectType.tvSeries, "Invalid media type passed to VideoSearchResultsGrouper");
                            return "collectionTVSeries"
                        }
                    else if (item.data.mediaType === Microsoft.Entertainment.Queries.ObjectType.video) {
                        MS.Entertainment.UI.Controls.assert(item.data.videoType === Microsoft.Entertainment.Queries.VideoType.movie, "Invalid video type passed to VideoSearchResultsGrouper");
                        return "marketplaceMovie"
                    }
                    else {
                        MS.Entertainment.UI.Controls.assert(item.data.mediaType === Microsoft.Entertainment.Queries.ObjectType.tvSeries, "Invalid media type passed to VideoSearchResultsGrouper");
                        return "marketplaceTVSeries"
                    }
                    return MS.Entertainment.UI.Controls.SearchResultsGrouper.prototype.createKey.call(this, item)
                }})
    })
}())
