﻿/* Copyright (C) Microsoft Corporation. All rights reserved. */
(function() {
    "use strict";
    WinJS.Namespace.define("MS.Entertainment.UI.Controls", {IconButtonMode: {
            Normal: "normal", Add: "add", Remove: "remove", Custom: "custom"
        }});
    WinJS.Namespace.define("MS.Entertainment.UI.Controls", {IconButton: MS.Entertainment.UI.Framework.deriveUserControl("MS.Entertainment.UI.Controls.ActionLink", "/Controls/IconButton.html#iconButtonTemplate", null, {
            tabIndex: 0, automationId: null, hasSubActions: false, useActionInfo: false, _flyoutControl: null, _flyoutMoved: false, _flyoutReattached: false, _flyoutShowEventHandlers: false, _flyoutEventHandler: null, _iconButtonBindings: null, _allowToolTips: true, initialize: function initialize() {
                    MS.Entertainment.UI.Controls.ActionLink.prototype.initialize.call(this);
                    this._allowToolTips = !MS.Entertainment.Utilities.isApp2;
                    this._iconButtonBindings = WinJS.Binding.bind(this, {
                        icon: this._updateIcon.bind(this), iconPressed: this._updateIcon.bind(this), text: this._updateNonVisualLabels.bind(this), stringId: this._stringIdChanged.bind(this), visibility: this._setVisibility.bind(this), isDisabled: this._setDisabled.bind(this), isChecked: this._setChecked.bind(this), hideDefaultRing: this._hideDefaultRingChanged.bind(this), action: {isEnabled: this._updateIconInfo.bind(this)}
                    });
                    this.iconButtonActionBindings = WinJS.Binding.bind(this.action, {
                        subActions: function updateSubItems(newItems) {
                            if (this._unloaded)
                                return;
                            this.subItems = newItems;
                            this._updateSubActions(newItems)
                        }.bind(this), hasSubActions: function updateHasSubActions(newValue) {
                                this.hasSubActions = newValue
                            }.bind(this)
                    });
                    if (this._button)
                        this._button.tabIndex = this.tabIndex;
                    if (this.automationId && this._button)
                        this._button.setAttribute("data-win-automationid", this.automationId);
                    if (this._shouldCreateFlyout) {
                        this.domElement.setAttribute("aria-haspopup", true);
                        this._flyoutElement.setAttribute("data-win-control", "MS.Entertainment.UI.Controls.Flyout");
                        this._flyoutControl = new MS.Entertainment.UI.Controls.Flyout(this._flyoutElement);
                        MS.Entertainment.UI.Framework.waitForControlToInitialize(this._flyoutElement).done(function flyoutInitialized() {
                            if (this._unloaded)
                                return;
                            var flyoutElement = this._flyoutControl.flyout.element;
                            flyoutElement.suppressUnload = true;
                            this._flyoutElement.removeChild(flyoutElement);
                            flyoutElement.suppressUnload = false;
                            this._flyoutMoved = true;
                            this._flyoutEventHandler = MS.Entertainment.Utilities.addEventHandlers(this._flyoutControl.flyout, {
                                aftershow: this._updateFlyoutPosition.bind(this), beforeshow: this._hideFlyout.bind(this)
                            });
                            if (this.action._flyoutClassName)
                                WinJS.Utilities.addClass(flyoutElement, this.action._flyoutClassName)
                        }.bind(this))
                    }
                    if (this.isToggleButton && this._button) {
                        WinJS.Utilities.addClass(this._button, "toggleButton");
                        if (this.isChecked)
                            this._button.setAttribute("aria-pressed", "true");
                        else
                            this._button.setAttribute("aria-pressed", "false")
                    }
                }, _updateIconInfo: function _updateIconInfo() {
                    if (this.action)
                        if (this.useActionInfo) {
                            this.text = this.action.title;
                            this.icon = this.action.icon;
                            this.isDisabled = !this.action.isEnabled;
                            this.automationId = this.action.automationId;
                            if (this.automationId && this._button)
                                this._button.setAttribute("data-win-automationid", this.automationId);
                            this.voicePhrase = this.action.voicePhrase;
                            this.voiceConfidence = this.action.voiceConfidence;
                            this.voicePhoneticPhrase = this.action.voicePhoneticPhrase;
                            this._hideDefaultRingChanged();
                            this._updateIcon()
                        }
                        else if (this.action.iconInfo && !this.overrideIconInfo) {
                            var iconInfo = this.action.iconInfo;
                            this.text = this.action.title;
                            this.icon = iconInfo.icon;
                            this.iconPressed = iconInfo.iconPressed;
                            this.adornerMode = iconInfo.adornerMode;
                            this.adornerRing = iconInfo.adornerRing;
                            this.isToggleButton = iconInfo.isToggleButton;
                            this.isDisabled = !this.action.isEnabled;
                            this.hideDefaultRing = iconInfo.hideDefaultRing;
                            this._hideDefaultRingChanged();
                            this._updateIcon()
                        }
                    this._setDomElement();
                    this._setFocusDirections()
                }, _setFocusDirections: function _setFocusDirections() {
                    if (this.focusDirections) {
                        var child = this.domElement.firstElementChild;
                        if (child)
                            try {
                                child.setAttribute("data-win-focus", JSON.stringify(this.focusDirections))
                            }
                            catch(e) {
                                MS.Entertainment.UI.Controls.fail("JSON.stringify failed: " + e && e.message)
                            }
                    }
                }, unload: function unload() {
                    if (this._iconButtonBindings) {
                        this._iconButtonBindings.cancel();
                        this._iconButtonBindings = null
                    }
                    if (this.iconButtonActionBindings) {
                        this.iconButtonActionBindings.cancel();
                        this.iconButtonActionBindings = null
                    }
                    if (this.action)
                        this.action.referenceContainer = null;
                    if (this._flyoutEventHandler) {
                        this._flyoutEventHandler.cancel();
                        this._flyoutEventHandler = null
                    }
                    if (this._flyoutShowEventHandlers) {
                        this._flyoutShowEventHandlers.cancel();
                        this._flyoutShowEventHandlers = null
                    }
                    if (this._flyoutControl && this._flyoutControl.flyout) {
                        if (this._flyoutMoved && this._flyoutReattached)
                            document.body.removeChild(this._flyoutControl.flyout.element);
                        this._flyoutControl = null
                    }
                    MS.Entertainment.UI.Controls.ActionLink.prototype.unload.call(this)
                }, onClickPreProcess: function onClickPreProcess() {
                    if (this._flyoutControl) {
                        if (!(this._flyoutControl.flyout && this._flyoutControl.flyout.element)) {
                            MS.Entertainment.UI.Controls.fail("Flyout iconbutton is missing flyout elements");
                            return
                        }
                        var executePromise = WinJS.Promise.wrap();
                        if (!this._flyoutShowEventHandlers)
                            this._flyoutShowEventHandlers = MS.Entertainment.Utilities.addEventHandlers(this._flyoutControl.flyout.element, {
                                aftershow: function flyoutAfterShow() {
                                    if (this._flyoutControl && this._flyoutControl.flyout && this._flyoutControl.flyout.element)
                                        MS.Entertainment.UI.Framework.addOverlayContainer(this._flyoutControl.flyout.element)
                                }.bind(this), afterhide: function flyoutAfterHide() {
                                        if (this._flyoutControl && this._flyoutControl.flyout && this._flyoutControl.flyout.element)
                                            MS.Entertainment.UI.Framework.removeOverlayContainer(this._flyoutControl.flyout.element)
                                    }.bind(this)
                            }, false);
                        if (!this._flyoutReattached && this._flyoutControl.flyout.element.style.visibility !== "visible") {
                            document.body.appendChild(this._flyoutControl.flyout.element);
                            this._flyoutReattached = true
                        }
                        if (this.action.canExecute())
                            executePromise = WinJS.Promise.as(this.action.execute(this._button));
                        executePromise.done(function executed() {
                            this._updateSubActions(this.subItems);
                            WinJS.Promise.timeout().done(function delay() {
                                this._showFlyout()
                            }.bind(this))
                        }.bind(this), function onError(error) {
                            var message = error && error.message;
                            MS.Entertainment.UI.fail("executePromise failed: " + message)
                        })
                    }
                    else
                        this.onClick()
                }, _shouldCreateFlyout: {get: function _shouldCreateFlyout() {
                        return this.action && this.action.hasSubActions && !MS.Entertainment.Utilities.isMusicApp2
                    }}, _updateSubActions: function _updateSubActions(newActions) {
                    if (this._flyoutControl && this._flyoutControl._subItemsList)
                        this._flyoutControl._subItemsList.dataSource = newActions
                }, _showFlyout: function _showFlyout() {
                    if (this._flyoutControl && this._flyoutControl.flyout) {
                        var placement = (MS.Entertainment.Utilities.getTextDirection() === MS.Entertainment.Utilities.TextDirections.LeftToRight) ? "right" : "left";
                        var iconElement = this.domElement.querySelector(".win-commandicon");
                        this._flyoutControl.flyout.show(iconElement, placement)
                    }
                }, _hideFlyout: function _hideFlyout() {
                    var flyoutElement = this._flyoutControl && this._flyoutControl.flyout && this._flyoutControl.flyout.element;
                    if (flyoutElement && flyoutElement.style)
                        WinJS.Utilities.addClass(flyoutElement, "hideFromDisplay")
                }, _updateFlyoutPosition: function _updateFlyoutPosition() {
                    var flyoutElement = this._flyoutControl && this._flyoutControl.flyout && this._flyoutControl.flyout.element;
                    if (flyoutElement && flyoutElement.style) {
                        flyoutElement.style.top = "auto";
                        var iconElement = this.domElement.querySelector(".win-commandicon");
                        var offset = WinJS.Utilities.getPosition(iconElement);
                        offset = Math.max(0, document.body.clientHeight - (flyoutElement.clientHeight + offset.top - 7));
                        flyoutElement.style.bottom = offset + "px";
                        WinJS.Utilities.removeClass(flyoutElement, "hideFromDisplay");
                        this._setFocusInFlyout(flyoutElement, false)
                    }
                }, _setFocusInFlyout: function _setFocusInFlyout(flyoutElement, itemsReversed) {
                    WinJS.Promise.timeout().done(function setFocus() {
                        var elementToFocus;
                        var flyoutElements = flyoutElement.getElementsByClassName("actionButtonFlyoutButton");
                        for (var i = 0; flyoutElements && i < flyoutElements.length; i++) {
                            elementToFocus = elementToFocus || flyoutElements[i];
                            if (!itemsReversed && elementToFocus.offsetTop > flyoutElements[i].offsetTop)
                                elementToFocus = flyoutElements[i];
                            else if (itemsReversed && elementToFocus.offsetTop < flyoutElements[i].offsetTop)
                                elementToFocus = flyoutElements[i]
                        }
                        if (elementToFocus)
                            elementToFocus.focus()
                    })
                }, _setDomElement: function _setDomElement() {
                    if (this._unloaded)
                        return;
                    if (this.action)
                        this.action.referenceContainer = {
                            flyout: this._flyoutElement, domElement: this.iconSpan
                        }
                }, _setVisibility: function _setVisibility() {
                    if (this.visibility)
                        WinJS.Utilities.removeClass(this._button, "removeFromDisplay");
                    else
                        WinJS.Utilities.addClass(this._button, "removeFromDisplay")
                }, _setDisabled: function _setDisabled() {
                    if (this._button)
                        if (this.isDisabled)
                            this._button.setAttribute("disabled", "disabled");
                        else
                            this._button.removeAttribute("disabled")
                }, _setChecked: function _setChecked() {
                    if (this.isChecked) {
                        WinJS.Utilities.addClass(this._button, "checked");
                        if (this.isToggleButton && this._button.getAttribute("aria-pressed") === "false")
                            this._button.setAttribute("aria-pressed", "true")
                    }
                    else {
                        WinJS.Utilities.removeClass(this._button, "checked");
                        if (this.isToggleButton && this._button.getAttribute("aria-pressed") === "true")
                            this._button.setAttribute("aria-pressed", "false")
                    }
                }, _updateIcon: function _updateIcon() {
                    var iconPressed = (this.iconPressed) ? this.iconPressed : this.icon;
                    if (this.iconSpan && this.icon)
                        if (this.icon.length === 1 || this.icon === MS.Entertainment.UI.Icon.xboxXenonLogo) {
                            this.iconSpan.textContent = this.icon;
                            this.iconSpan.style.backgroundImage = "";
                            this.iconSpan.style.msHighContrastAdjust = ""
                        }
                        else {
                            this.iconSpan.textContent = "";
                            this.iconSpan.style.backgroundImage = this.icon;
                            this.iconSpan.style.msHighContrastAdjust = "none"
                        }
                    if (this.iconSpanPressed && iconPressed)
                        if (iconPressed.length === 1 || this.icon === MS.Entertainment.UI.Icon.xboxXenonLogo) {
                            this.iconSpanPressed.textContent = iconPressed;
                            this.iconSpanPressed.style.backgroundImage = "";
                            this.iconSpanPressed.style.msHighContrastAdjust = ""
                        }
                        else {
                            this.iconSpanPressed.textContent = "";
                            this.iconSpanPressed.style.backgroundImage = iconPressed;
                            this.iconSpanPressed.style.msHighContrastAdjust = "none"
                        }
                    switch (this.adornerMode) {
                        case(MS.Entertainment.UI.Controls.IconButtonMode.Add):
                            this._setAdorners(MS.Entertainment.UI.Icon.modifierAddRing);
                            break;
                        case(MS.Entertainment.UI.Controls.IconButtonMode.Remove):
                            this._setAdorners(MS.Entertainment.UI.Icon.modifierRemoveRing);
                            break;
                        case(MS.Entertainment.UI.Controls.IconButtonMode.Custom):
                            this._setAdorners(this.adornerRing);
                            break;
                        case(MS.Entertainment.UI.Controls.IconButtonMode.Normal):
                        default:
                            break
                    }
                }, _setAdorners: function _setAdorners(adorner) {
                    this.hideDefaultRing = true;
                    this._hideDefaultRingChanged();
                    this.modifier.textContent = adorner
                }, _hideDefaultRingChanged: function _hideDefaultRingChanged() {
                    if (this.hideDefaultRing || (this.action && this.action.hideDefaultRing))
                        WinJS.Utilities.addClass(this._button, "hideAdorner");
                    else
                        WinJS.Utilities.removeClass(this._button, "hideAdorner")
                }, _stringIdChanged: function _stringIdChanged() {
                    if (this.stringId) {
                        var string = String.load(this.stringId);
                        this._button.setAttribute("aria-label", string);
                        this.linkLabel.innerText = string;
                        this._updateTooltipLabel(string)
                    }
                }, _updateNonVisualLabels: function _updateNonVisualLabels() {
                    var overrideString = null;
                    if (this.toolTipOverrideStringId)
                        overrideString = String.load(this.toolTipOverrideStringId);
                    var toolTipLabel = overrideString || this.text;
                    this._updateAriaLabel();
                    this._updateTooltipLabel(toolTipLabel)
                }, _updateTooltipLabel: function _updateTooltipLabel(text) {
                    if (this._allowToolTips && WinJS.Utilities.getMember("_button.winControl", this) && text && text !== "null" && text !== "undefined")
                        this._button.winControl.innerHTML = text
                }, _updateAriaLabel: function _updateAriaLabel() {
                    var overrideString = null;
                    if (this.toolTipOverrideStringId)
                        overrideString = String.load(this.toolTipOverrideStringId);
                    var stringToUseforAria = overrideString || this.text;
                    if (stringToUseforAria)
                        this._button.setAttribute("aria-label", stringToUseforAria);
                    if (this.text)
                        this.linkLabel.innerText = this.text
                }
        }, {
            icon: null, iconPressed: null, hideDefaultRing: false, adornerMode: MS.Entertainment.UI.Controls.IconButtonMode.Normal, adornerRing: null, isDisabled: false, isToggleButton: false, isChecked: false, visibility: true, subItems: null, action: null, focusable: true, overrideIconInfo: false, toolTipOverrideStringId: null
        })});
    WinJS.Namespace.define("MS.Entertainment.UI.Controls", {IconButtonTwoLine: MS.Entertainment.UI.Framework.deriveUserControl("MS.Entertainment.UI.Controls.IconButton", "/Controls/IconButton.html#iconButtonTwoLineTemplate", null, {
            initialize: function initialize() {
                MS.Entertainment.UI.Controls.IconButton.prototype.initialize.call(this);
                this._iconButtonBindings = WinJS.Binding.bind(this, {
                    icon: this._updateIcon.bind(this), iconPressed: this._updateIcon.bind(this), text: this._textChanged.bind(this), subText: this._subTextChanged.bind(this), subTextString: this._subTextStringChanged.bind(this), stringId: this._stringIdChanged.bind(this), visibility: this._setVisibility.bind(this), isDisabled: this._setDisabled.bind(this), isChecked: this._setChecked.bind(this), hideDefaultRing: this._hideDefaultRingChanged.bind(this), action: this._setDomElement.bind(this)
                })
            }, _textChanged: function _subTextChanged() {
                    if (this.text)
                        this.linkLabel.innerText = this.text;
                    this._updateAriaLabel()
                }, _subTextChanged: function _subTextChanged() {
                    if (this.subText)
                        this.linkSubLabel.textContent = String.load(this.subText);
                    this._updateSubTextVisibility()
                }, _subTextStringChanged: function _subTextStringChanged() {
                    if (this.subTextString)
                        this.linkSubLabel.textContent = this.subTextString;
                    this._updateSubTextVisibility();
                    this._updateAriaLabel()
                }, _updateIconInfo: function _updateIconInfo() {
                    if (this.action && this.useActionInfo)
                        this.subTextString = this.action.subTitle;
                    MS.Entertainment.UI.Controls.IconButton.prototype._updateIconInfo.call(this)
                }, _updateSubTextVisibility: function _updateSubTextVisibility() {
                    this.subTextVisibility = (this.subText || this.subTextString)
                }, _updateAriaLabel: function _updateAriaLabel() {
                    var ariaLabel = String.empty;
                    if (this.text && this.subTextString)
                        ariaLabel = String.load(String.id.IDS_COMMA_SEPARATOR).format(this.text, this.subTextString);
                    else if (this.text)
                        ariaLabel = this.text;
                    if (ariaLabel)
                        this._button.setAttribute("aria-label", ariaLabel)
                }
        }, {
            subText: null, subTextString: null, subTextVisibility: false
        })});
    WinJS.Namespace.define("MS.Entertainment.UI.Controls", {IconButtonNotification: MS.Entertainment.UI.Framework.deriveUserControl("MS.Entertainment.UI.Controls.IconButtonTwoLine", "/Controls/IconButton.html#iconButtonNotificationTemplate", null)});
    WinJS.Namespace.define("MS.Entertainment.UI.Controls", {IconButtonMessageAction: MS.Entertainment.UI.Framework.deriveUserControl("MS.Entertainment.UI.Controls.IconButtonTwoLine", "/Controls/IconButton.html#iconButtonMessageActionTemplate", null)});
    WinJS.Namespace.define("MS.Entertainment.UI.Controls", {IconButtonImage: MS.Entertainment.UI.Framework.deriveUserControl("MS.Entertainment.UI.Controls.IconButton", "/Controls/IconButton.html#iconButtonImageTemplate", null, {
            initialize: function initialize() {
                MS.Entertainment.UI.Controls.IconButton.prototype.initialize.call(this);
                this._iconButtonBindings = WinJS.Binding.bind(this, {
                    icon: this._updateIcon.bind(this), iconPressed: this._updateIcon.bind(this), text: this._updateAriaLabel.bind(this), stringId: this._stringIdChanged.bind(this), visibility: this._setVisibility.bind(this), isDisabled: this._setDisabled.bind(this), isChecked: this._setChecked.bind(this), hideDefaultRing: this._hideDefaultRingChanged.bind(this), action: this._updateIconInfo.bind(this), media: this._updateImageProperties.bind(this), defaultImageSize: this._updateImageProperties.bind(this)
                })
            }, _updateIconInfo: function _updateIconInfo() {
                    if (!this.action) {
                        this.isDisabled = true;
                        WinJS.Utilities.addClass(this.ringSpan, "removeFromDisplay");
                        return
                    }
                    WinJS.Utilities.removeClass(this.ringSpan, "removeFromDisplay");
                    var iconInfo = this.action.iconInfo;
                    this.text = this.action.title;
                    this.icon = iconInfo.icon;
                    this.iconPressed = iconInfo.iconPressed;
                    this.adornerMode = iconInfo.adornerMode;
                    this.adornerRing = iconInfo.adornerRing;
                    this.isToggleButton = iconInfo.isToggleButton;
                    this.isDisabled = !this.action.isEnabled;
                    this.hideDefaultRing = iconInfo.hideDefaultRing;
                    this._setDomElement()
                }, _updateImageProperties: function _updateImageProperties() {
                    if (!this._image || !this.desiredImageSize || !this.media)
                        return;
                    this._image.domElement.width = this.desiredImageSize.width;
                    this._image.domElement.height = this.desiredImageSize.height;
                    this._image.desiredImageSize = this.desiredImageSize;
                    this._image.defaultImagePath = this.defaultImagePath;
                    this._image.target = this.media
                }, _updateAriaLabel: function _updateAriaLabel() {
                    var ariaLabel = String.empty;
                    if (this.text && this.subTextString)
                        ariaLabel = String.load(String.id.IDS_COMMA_SEPARATOR).format(this.text, this.subTextString);
                    else if (this.text)
                        ariaLabel = this.text;
                    if (ariaLabel)
                        this._button.setAttribute("aria-label", ariaLabel)
                }
        }, {
            media: null, desiredImageSize: null, defaultImagePath: String.empty, imageWidth: 0, imageHeight: 0
        })});
    WinJS.Namespace.define("MS.Entertainment.UI.Controls", {IconButtonVertical: MS.Entertainment.UI.Framework.deriveUserControl("MS.Entertainment.UI.Controls.IconButton", "/Controls/IconButton.html#iconButtonVerticalTemplate", null, {initialize: function initialize() {
                MS.Entertainment.UI.Controls.IconButton.prototype.initialize.call(this)
            }})})
})()
